      SUBROUTINE BLOSFC2
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    BLOSFC2     SETS BELOW SURFACE VALUES
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-05-07       
C     
C ABSTRACT:  THIS ROUTINE SETS BELOW GROUND Q, U, V, 
C     AND OMEGA.  FOR U, V, AND OMEGA WE SIMPLY FILL 
C     BELOW GROUND ARRAY ELEMENTS WITH VALUES FROM 
C     THE FIRST ATMOSPHERIC ETA LAYER (FAL).  FOR Q 
C     WE FIRST COMPUTE THE FAL RELATIVE HUMIDITY.  USING
C     THE GIVEN TEMPERATURE AND PRESSURE WE USE THIS 
C     FAL RH FIELD TO COMPUTE BELOW SURFACE Q WHICH 
C     MAINTAINS THE FAL RH.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-01-27  RUSS TREADON
C   93-05-07  RUSS TREADON - ADDED DOCBLOC
C   96-03-07  MIKE BALDWIN - SPEED UP CODE 
C   98-06-08  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-17  MIKE BALDWIN - COMPUTE RH OVER ICE
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   00-01-03  JIM TUCCILLO - MPI VERSION         
C     
C USAGE:    CALL BLOSFC2
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MAPOT
C                  VRBLS
C                  LOOPS
C                  EXTRA
C                  OMGAOT
C                  MASKS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     INCLUDE PARAMETER STATEMENTS.  SET LOCAL PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
      PARAMETER (DPBND=60.E2,ISMTHP=2,ISMTHT=2,ISMTHQ=2,ISMTHR=2,
     &  CLIMIT=1.E-20)
C     
C     DECLARE VARIABLES.
      REAL PBND(IM,JM),QBND(IM,JM),RHBND(IM,JM),TBND(IM,JM)
      REAL PSUM(IM,JM),ICEB(IM,JM),IWM1(IM,JM)
C     
C     INCLUDE COMMON BLOCKS
      INCLUDE "MAPOT.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "CTLBLK.comm"
C     
C********************************************************************
C     START BLOSFC HERE.
C     
C     SET BELOW GROUND OMEGA.
      DO L = 1,LM
         DO J=JSTA,JEND
         DO I=1,IM
           LLMH = LMH(I,J)
           IF(L.GT.LLMH) OMGA(I,J,L) = OMGA(I,J,LLMH)
         ENDDO
         ENDDO
         CALL EXCH(OMGA(1,1,L))
      ENDDO
C     
C     SET BELOW GROUND U AND V WIND COMPONENTS.
      DO L = 1,LM
         DO J=JSTA,JEND
         DO I=1,IM
           LLMV = LMV(I,J)
           IF (L.GT.LLMV) THEN
             U(I,J,L) = U(I,J,LLMV)
             V(I,J,L) = V(I,J,LLMV)
           ENDIF
         ENDDO
         ENDDO
         CALL EXCH(U(1,1,L))
         CALL EXCH(V(1,1,L))
      ENDDO
C
C     LOOP OVER HORIZONTAL.  AT EACH MASS POINT COMPUTE 
C     LAYER MEAN P, T, AND Q IN A DPBND THICK BOUNDARY
C     LAYER FROM THE SURFACE UP.
C
      DO J=JSTA,JEND
      DO I=1,IM 
        PBND(I,J)= PD(I,J) + PT - 0.5*DPBND
        PSUM(I,J)= D00
        TBND(I,J)= D00
        QBND(I,J)= D00
        ICEB(I,J)= D00
        IWM1(I,J)= D00
      ENDDO
      ENDDO
      DO L = 1,LM
        DO J=JSTA,JEND
        DO I=1,IM
          PM = D50*(PINT(I,J,L)+PINT(I,J,L+1))
          PTOP = PBND(I,J)-DPBND*0.5
          PBOT = PBND(I,J)+DPBND*0.5
C   COMPUTE IW
          RIW=0.
          IF(CWM(I,J,L).GT.CLIMIT) THEN
             IF(T(I,J,L).LT.258.15)THEN
               RIW=1.
             ELSEIF(T(I,J,L).GE.273.15)THEN
               RIW=0.
             ELSE
               IF(IWM1(I,J).EQ.1.0)RIW=1.
             ENDIF
          ELSE
             RIW=0.
          ENDIF
          IWM1(I,J)=RIW
C   COMPUTE IW
          IF (PM.GT.PTOP.AND.PM.LE.PBOT) THEN
             DP = PINT(I,J,L+1)-PINT(I,J,L)
             PSUM(I,J) = PSUM(I,J) + DP
             TBND(I,J) = TBND(I,J) + T(I,J,L)*DP
             QBND(I,J) = QBND(I,J) + Q(I,J,L)*DP
             ICEB(I,J) = ICEB(I,J) + RIW*DP
          ENDIF
        ENDDO
        ENDDO
      ENDDO
C
      DO J=JSTA,JEND
      DO I=1,IM
         IF (PSUM(I,J).NE.0.) THEN
            RPSUM   = 1./PSUM(I,J)
            TBND(I,J) = TBND(I,J)*RPSUM
            QBND(I,J) = QBND(I,J)*RPSUM
            ICEB(I,J) = ICEB(I,J)*RPSUM
            IF (ICEB(I,J).LT.0.5) ICEB(I,J)=0.
         ELSE
            LLMH=LMH(I,J)
            TBND(I,J) = T(I,J,LLMH)
            QBND(I,J) = Q(I,J,LLMH)
            ICEB(I,J) = IWM1(I,J)
         ENDIF
      ENDDO
      ENDDO
C     USE BOUNDARY LAYER PRESSURE, TEMPERATURE, AND SPECIFIC
C     HUMIDITY ARRAYS TO COMPUTE BOUNDARY LAYER RELATIVE
C     HUMIDITY
      CALL P2FILT(ISMTHP,HBM2,PBND)
      CALL P2FILT(ISMTHT,HBM2,TBND)
      CALL P2FILT(ISMTHQ,HBM2,QBND)
      CALL BOUNDL(QBND,H1M12,H99999,IM,JM)
      CALL CALRH2(PBND,TBND,QBND,ICEB,RHBND,IM,JM)
      CALL P2FILT(ISMTHR,HBM2,RHBND)
C     
C     SET BELOW GROUND Q TO PRESERVE BOUNDARY LAYER
C     RELATIVE HUMIDITY.
C     
      DO L = 1,LM
        DO J=JSTA,JEND
        DO I=1,IM
          LLMH=LMH(I,J)
          IF(L.GT.LLMH)THEN
            PM=D50*(PINT(I,J,L)+PINT(I,J,L+1))
            TM=T(I,J,L)
C     
            TMT0=TM-273.16
            TMT15=AMIN1(TMT0,-15.)
            AI=0.008855
            BI=1.
            IF(TMT0.LT.-20.)THEN
              AI=0.007225
              BI=0.9674
            ENDIF
            QW=PQ0/PM*EXP(A2*(TM-A3)/(TM-A4))
            QI=QW*(BI+AI*AMIN1(TMT0,0.))
            QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
            IF(TMT0.LT.-15.)THEN
               QS=QI
            ELSEIF(TMT0.GE.0.)THEN
               QS=QINT
            ELSE
               IF(ICEB(I,J).GT.0.0) THEN
                 QS=QI
               ELSE
                 QS=QINT
               ENDIF
            ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
            QS=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C
C
            Q(I,J,L)=RHBND(I,J)*QS
            Q(I,J,L)=AMAX1(H1M12,Q(I,J,L))
          ENDIF
        ENDDO
        ENDDO
        CALL EXCH(Q(1,1,L))
      ENDDO
C     
C     END OF ROUTINE
C     
      RETURN
      END

      SUBROUTINE TRNSGD
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    TRNSGD      SET OUTPUT GRID PARAMETERS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE LOADS COMMON BLOCK OUTGRD WITH 
C     OUTPUT GRID SPECIFICATIONS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE TRNSCG IN ETAPACKC
C   92-12-23  RUSS TREADON  - MODIFIED ETAPACKC TRNSCG FOR
C                             USE IN ETA POST PROCESSOR.
C   93-06-13  RUSS TREADON  - ADDED LOGIC PROJECTION PARAMETER.
C     
C USAGE:    CALL TRNSGD
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     STDOUT     - RUN-TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - OUTGRD
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     
C     DECLARE VARIABLES, COMMONS, AND CONSTANTS.
C     
      LOGICAL NORTH
      CHARACTER*6 PROJ
      INTEGER IDIM, JDIM
      REAL ALONVT, GI2, POLEI, POLEJ, RE, XMESHL
C     
C     INCLUDE OUTPUT GRID COMMON BLOCK.
      INCLUDE "OUTGRD.comm"
      INCLUDE "IOUNIT.comm"
C     
C     SET EARTH RADIUS (KM).
      DATA EARTHR/6371.2/
C     
C******************************************************************
C     START TRNSGD HERE.
C     
C     SET COMMON BLOCK CONSTANTS.
C
      RE  = (EARTHR * 1.86603) / XMESHL
      GI2 = RE * RE
C     
      WRITE(STDOUT,*)'TRNSGD:  COMMON BLOCK OUTGRD BELOW'
      WRITE(STDOUT,*)'  PROJ         :  ',PROJ
      WRITE(STDOUT,*)'  NORTH        :  ',NORTH
      WRITE(STDOUT,*)'  ALATVT,ALONVT:  ',ALATVT,ALONVT
      WRITE(STDOUT,*)'  XMESHL       :  ',XMESHL
      WRITE(STDOUT,*)'  POLEI,POLEJ  :  ',POLEI,POLEJ
      WRITE(STDOUT,*)'  IGOUT,JGOUT  :  ',IGOUT,JGOUT
      WRITE(STDOUT,*)'  RE,GI2       :  ',RE,GI2
C     
      RETURN
      END

      SUBROUTINE MPI_FIRST
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    MPI_FIRST   SET UP MESSGAE PASSING INFO
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     SETS UP MESSAGE PASSING INFO
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C
C USAGE:    CALL MPI_FIRST
C   INPUT ARGUMENT LIST:
C
C   OUTPUT ARGUMENT LIST:
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_INIT
C       MPI_COMM_SIZE
C       MPI_COMM_RANK
C       PARA_RANGE
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - CTLBLK.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
c
      include "CTLBLK.comm"
      include "parmeta"
      include 'mpif.h'
c
      integer ierr
c
      call mpi_init(ierr)
      call mpi_comm_size(MPI_COMM_WORLD,NUM_PROCS, ierr )
      call mpi_comm_rank(MPI_COMM_WORLD,ME, ierr )
c
      if ( me .eq. 0 ) then
c        print *, ' NUM_PROCS = ',num_procs
      end if

      if ( num_procs .gt. 1024 ) then
         print *, ' too many MPI tasks, max is 1024, stopping'
         call mpi_last
         call exit(3)
      end if
c
c     error check
c
      if ( num_procs .gt. JM/2 ) then
         print *, ' too many MPI tasks, max is ',jm/2,' stopping'
         call mpi_last
         call exit(3)
      end if
c
c     global loop ranges
c
      call para_range(1,jm,num_procs,me,jsta,jend)
      jsta_m  = jsta
      jsta_m2 = jsta
      jend_m  = jend
      jend_m2 = jend
      if ( me .eq. 0 ) then
         jsta_m  = 2
         jsta_m2 = 3
      end if
      if ( me .eq. num_procs - 1 ) then
         jend_m  = jm - 1
         jend_m2 = jm - 2
      end if
c
c     neighbors
c
      iup = me + 1
      idn = me - 1
      if ( me .eq. 0 ) then
         idn = MPI_PROC_NULL
      end if
      if ( me .eq. num_procs - 1 ) then
         iup = MPI_PROC_NULL
      end if
C
      print *, ' ME, NUM_PROCS = ',me,num_procs
      print *, ' ME, JSTA, JSTA_M, JSTA_M2 = ',me,jsta,jsta_m,jsta_m2
      print *, ' ME, JEND, JEND_M, JEND_M2 = ',me,jend,jend_m,jend_m2
      print *, ' ME, IUP, IDN = ',me,iup,idn
c
c     counts, disps for gatherv and scatterv
c
      do i = 0, num_procs - 1
         call para_range(1,jm,num_procs,i,jsx,jex) 
         icnt(i) = (jex-jsx+1)*im
         idsp(i) = (jsx-1)*im
         if ( me .eq. 0 ) then
c           print *, ' i, icnt(i),idsp(i) = ',i,icnt(i),idsp(i)
         end if
      end do
c
c     extraction limits    
c
      jsta_2l = max(jsta - 1,  1 )
      jend_2u = min(jend + 1, jm )
c     print *, ' me, jsta_2l, jend_2u = ',me,jsta_2l, jend_2u
c
      end

      SUBROUTINE GD2EGK(IMOT,JMOT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GD2EGK      MAP OUTPUT GRID TO E-GRID
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23
C     
C ABSTRACT:
C     THIS ROUTINE LOCATES THE (I,J) INDICES ON A SPECIFIED
C     OUTPUT GRID NEAREST TO E-GRID MASS (H) POINTS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  ???
C   92-12-23  RUSS TREADON - GENERALIZED CODE.
C   93-06-09  RUSS TREADON - EXPANDED COMMENTS.
C   98-06-04  BLACK - CONVERSION TO 2-D
C     
C USAGE:    GD2EGK(IMOT,JMOT)
C   INPUT ARGUMENT LIST:
C     IMOT     - FIRST DIMENSION OF OUTPUT GRID.
C     JMOT     - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LLGRDS
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     INCLUDE E- AND OTUPUT GRID DIMENSIONS.
C     COMPUTE DEPENDENT PARAMETERS.
C------------------------------------------------------------------------     
      INCLUDE "parmeta"
      INCLUDE "parmout"
C------------------------------------------------------------------------     
      PARAMETER (IMT=2*IM-1, JMT=JM)
C------------------------------------------------------------------------     
      INCLUDE "LLGRDS.comm"
      INCLUDE "IOUNIT.comm"
C     
C************************************************************************
C     START GD2EGK.
C     
      WRITE(STDOUT,*)'GD2EGK:  COMPUTE E-GRID (I,J) FOR CETLIH'
C     
C     INITIALIZE TO MINUS ONE (A FLAG) THE ARRAYS WHICH WILL CONTAIN 
C     THE OUTPUT GRID (I,J) NEAREST TO EACH E-GRID MASS POINT.
C
CMIC$ DO ALL VECTOR AUTOSCOPE
      DO J=1,JM
      DO I=1,IM
        IEGRDK(I,J)=-1
        JEGRDK(I,J)=-1
      ENDDO
      ENDDO
C     
C     THE MAPPING EXCLUDES THE OUTERMOST TWO ROWS AND COLUMNS ON
C     THE OUTPUT GRID.  SET UPPER INDEX LIMITS ACCORDINGLY.
C
      JMOT2=JMOT-2
      IMOT2=IMOT-2
C     
C     LOOP OVER THE E-GRID.  THE LOOP ON J MOVES US SOUTH TO NORTH
C     ON THE E-GRID.  THE LOOP ON K MOVES US WEST TO EAST ACROSS 
C     THE J-TH ROW ON THE E-GRID.
C
      doout175: DO  J=3,JM-2
      IEND=IM-1-MOD(J+1,2)
C
      doin175: DO I=2,IEND
C     
C     SET THE MASS POINT TRANSFORMED LATITUDE AND LONGITUDE
C     FOR THE K-TH E-GRID MASS POINT ON ROW J.
C
      CLON=HTLON(I,J)
      CLAT=HTLAT(I,J)
      DLAT=0.
C     
C           LOOP OVER THE OUTPUT GRID.  FOR THE CURRENT 
C           (I.E., K-TH) E-GRID MASS POINT WE WANT TO 
C           LOCATE THE NEAREST OUTPUT GRID (I,J) POINT.
C           NOTE THAT THE (LAT,LON) OF THE OUTPUT GRID HAVE 
C           BEEN TRANSFORMED TO THE E-GRID REFERENCE FRAME.
C     
 110  DO 130 JJ=2,JMOT2
      DO 120 II=2,IMOT2
      
      IF(CLON.GE.GDTLON(II+1,JJ))  GOTO 120
      IF(CLON.LT.GDTLON(II  ,JJ))  GOTO 120
C
C     WE HAVE THE I INDEX (IP) OF THE OUTPUT GRID POINT
C     CLOSEST TO THE K-TH E-GRID MASS POINT.  SAVE THIS
C     VALUE AND EXIT LOOP 120.
C
      IP=II
      IEGRDK(I,J)=IP
      GOTO 125
 120  CONTINUE
C     
C     REACHING THIS LINE MEANS THAT IP HAS NOT BEEN IDENTIFIED
C     ON THIS ROW OF THE OUTPUT GRID SO MOVE TO THE NEXT ROW OF
C     THE OUTPUT GRID AND REPEAT THE PROCESS.
C   
      GOTO 130
C
C     REACHING THIS POINT MEANS THAT WE HAVE THE I INDEX.
C     CHECK TO SEE IF THE LATITUDE OF THE JJ-TH OUTPUT GRID
C     POINT IN THE IP-TH COLUMN IS WITHIN DLAT OF THE LATITUDE
C     OF THE K-TH E-GRID MASS POINT.  IF SO, SAVE THE J INDEX
C     (JP) AND MOVE ON THE THE NEXT E-GRID MASS POINT.
C     OTHERWISE, MOVE ON THE THE NEXT ROW OF THE OUTPUT GRID
C     AND REPEAT THE SEARCH PROCESS.
C
  125 CONTINUE
C
      IF(CLAT.GE.(GDTLAT(IP,JJ+1)+DLAT))  GOTO 130
      IF(CLAT.LT.(GDTLAT(IP,JJ  )-DLAT))  GOTO 130
      JP=JJ
      JEGRDK(I,J)=JP
      CYCLE doin175
  130 CONTINUE
C     
C     REACHING THIS BLOCK OF CODE MEANS THAT NO NEAREST NEIGHBOR
C     OUTPUT GRID POINT HAS BEEN IDENTIFIED.  THIS COULD HAVE 
C     HAPPENED BECAUSE OF
C     (A) OBLIQUENESS OF TRANSFORMED GRID LINES, OR
C     (B) ETA GRID POINT BEING OUTSIDE THE OUTPUT GRID AREA.
C     WE ALLOW FOR (A) BY INCREASING THE TOLERANCE DLAT (UP TO
C     A LIMIT OF 0.1) AND REPEATING THE SEARCH.
C     
      IF(DLAT.LT.0.1)THEN
        DLAT = DLAT + 0.005
        GOTO 110
      ENDIF
C     
C     REACHING THIS LAST BLOCK OF CODE MEANS THAT WE CAN'T FIND
C     A NEAREST NEIGHBOR OUTPUT GRID POINT FOR THE K-TH E-GRID
C     MASS POINT.  SET I- AND J-EGRDK ARRAY TO -1 FOR THIS K.
C     (GRANTED, THIS IS OVERKILL, SINCE WE INITIALIZED THESE 
C     ARRAYS TO -1.)
C     
      IEGRDK(I,J)=-1
      JEGRDK(I,J)=-1
C     
C     REPEAT SEARCH FOR NEXT E-GRID MASS POINT.
C
      END DO doin175
      END DO doout175
C
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE WETBULB(T,Q,PDSL,HTM,KARR,TWET)
C
C     FILE: WETBULB.f
C     WRITTEN: 10 SEPTEMBER 1993, MICHAEL BALDWIN
C     REVISIONS: 
C     CONVERSION TO 2-D: 12 JUNE 1998 (T BLACK)
C     MPI VERSION: 04 Jan 2000 ( JIM TUCCILLO )
C
C-----------------------------------------------------------------------
C     ROUTINE TO COMPUTE WET BULB TEMPERATURES USING THE LOOK UP TABLE
C     APPROACH THAT IS USED IN CUCNVC
C  
C     FOR A GIVEN POINT K AND LAYER L:
C      THETA E IS COMPUTED FROM THETA AND Q BY LIFTING THE PARCEL TO
C      ITS SATURATION POINT.
C      THEN THE WET BULB TEMPERATURE IS FOUND BY FOLLOWING THE THETA E
C      DOWN TO THE ORIGINAL PRESSURE LEVEL (USING SUBROUTINE TTBLEX).     
C
C   
C
      LOGICAL   UNIS,UNIL,OCT90
      INCLUDE "parmeta"
      INCLUDE "parm.tbl"
      PARAMETER(IMJM=IM*JM-JM/2,LP1=LM+1)
      INCLUDE "cuparm"
      INCLUDE "PHYS.comm"
      INCLUDE "CTLBLK.comm"
C-----------------------------------------------------------------------
C  LIST OF VARIABLES NEEDED
C    PARAMETERS:
C      INCLUDED IN "cuparm" AND "parm.tbl"
C    INPUT:
C      T,Q,HTM (3-D),PDSL,KARR (2-D),KNUM
C    OUTPUT: 
C      TWET (3-D)
C    INTERNAL:
C      THESP,KLRES,KHRES,QQ,PP,IPTB,ITHTB
C      PLUS SOME INCLUDED IN COMMON BLOCK "PHYS"
C    SUBROUTINES CALLED:
C      TTBLEX
C
      DIMENSION THESP(IM,JM),TWET(IM,JM,LM),T(IM,JM,LM),Q(IM,JM,LM)
      DIMENSION PDSL(IM,JM),HTM(IM,JM,LM),KARR(IM,JM)
                             D I M E N S I O N
     1 KLRES(IM,JM),KHRES(IM,JM)
     2,QQ(IM,JM),PP(IM,JM)
     3,IPTB(IM,JM),ITHTB(IM,JM)
C
C--------------COMPUTE WET BULB TEMPERATURES----------------------------
!$omp  parallel do
!$omp& private(apebtk,apespk,bqk,bqs00k,bqs10k,iq,iqtbk,it,ittb1,ittbk,
!$omp&         karr,khres,klres,knumh,knuml,p00k,p01k,p10k,p11k,ppk,
!$omp&         presk,qbtk,qqk,sqk,sqs00k,sqs10k,tbtk,thesp,tpspk,
!$omp&         tqk,tthbtk,tthk)
C-----------------------------------------------------------------------
                             DO 300 L=1,LM
      doout125: DO J=JSTA,JEND
      doin125: DO  I=1,IM
      IF(KARR(I,J).GT.0)THEN
        IF (HTM(I,J,L).LT.1.0) THEN
          THESP(I,J)=273.15
          CYCLE doin125
        ENDIF
        TBTK  =T(I,J,L)
        QBTK  =Q(I,J,L)
        PRESK=PDSL(I,J)*AETA(L)+PT
        APEBTK=(H10E5/PRESK)**CAPA
        IF(QBTK.LT.EPSQ) QBTK=HTM(I,J,L)*EPSQ
C--------------SCALING POTENTIAL TEMPERATURE & TABLE INDEX--------------
        TTHBTK  =TBTK*APEBTK
        TTHK    =(TTHBTK-THL)*RDTH
        QQK     =TTHK-AINT(TTHK)
        ITTB1   =INT(TTHK)+1
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
        IF(ITTB1.LT.1) THEN
          ITTB1  =1
          QQK    =D00
        ENDIF
C
        IF(ITTB1.GE.JTB) THEN
        ITTB1  =JTB-1
        QQK    =D00
        ENDIF
C--------------BASE AND SCALING FACTOR FOR SPEC. HUMIDITY---------------
        ITTBK=ITTB1
        BQS00K=QS0(ITTBK)
        SQS00K=SQS(ITTBK)
        BQS10K=QS0(ITTBK+1)
        SQS10K=SQS(ITTBK+1)
C--------------SCALING SPEC. HUMIDITY & TABLE INDEX---------------------
        BQK=(BQS10K-BQS00K)*QQK+BQS00K
        SQK=(SQS10K-SQS00K)*QQK+SQS00K
        TQK=(QBTK-BQK)/SQK*RDQ
        PPK=TQK-AINT(TQK)
        IQTBK=INT(TQK)+1
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
        IF(IQTBK.LT.1) THEN
          IQTBK =1
          PPK   =D00
        ENDIF
C
        IF(IQTBK.GE.ITB) THEN
          IQTBK=ITB-1
          PPK  =D00
        ENDIF
C--------------SATURATION PRESSURE AT FOUR SURROUNDING TABLE PTS.-------
        IQ=IQTBK
        IT=ITTB1
        P00K=PTBL(IQ  ,IT  )
        P10K=PTBL(IQ+1,IT  )
        P01K=PTBL(IQ  ,IT+1)
        P11K=PTBL(IQ+1,IT+1)
C--------------SATURATION POINT VARIABLES AT THE BOTTOM-----------------
        TPSPK=P00K+(P10K-P00K)*PPK+(P01K-P00K)*QQK
     1          +(P00K-P10K-P01K+P11K)*PPK*QQK
        APESPK=(H10E5/TPSPK)**CAPA
        THESP(I,J)=TTHBTK*EXP(ELOCP*QBTK*APESPK/TTHBTK)
      ENDIF
      END DO doin125
      END DO doout125
C--------------SCALING PRESSURE & TT TABLE INDEX------------------------
      KNUML=0
      KNUMH=0
C
      doout280: DO J=JSTA,JEND
      doin280: DO I=1,IM
      KLRES(I,J)=0
      KHRES(I,J)=0
C
      IF(KARR(I,J).GT.0)THEN
        PRESK=PDSL(I,J)*AETA(L)+PT
C
        IF(PRESK.LT.PLQ)THEN
          KNUML=KNUML+1
          KLRES(I,J)=1
        ELSE
          KNUMH=KNUMH+1
          KHRES(I,J)=1
        ENDIF
      ENDIF
      END DO doin280
      END DO doout280
C***
C***  COMPUTE PARCEL TEMPERATURE ALONG MOIST ADIABAT FOR PRESSURE<PL
C**
      IF(KNUML.GT.0)THEN
        CALL TTBLEX(TWET(1,1,L),TTBL,ITB,JTB,KLRES,PDSL,AETA(L)
     1,             HTM(1,1,L),PT,PL,QQ,PP,RDP,THE0,STHE,RDTHE,THESP
     2,             IPTB,ITHTB)
      ENDIF
C***
C***  COMPUTE PARCEL TEMPERATURE ALONG MOIST ADIABAT FOR PRESSURE>PL
C**
      IF(KNUMH.GT.0)THEN
        CALL TTBLEX(TWET(1,1,L),TTBLQ,ITBQ,JTBQ,KHRES,PDSL,AETA(L)
     1,             HTM(1,1,L),PT,PLQ,QQ,PP,RDPQ,THE0Q,STHEQ,RDTHEQ
     2,             THESP,IPTB,ITHTB)
      ENDIF
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
  300 CONTINUE
      RETURN
      END

      SUBROUTINE NOPACK(IFLD,ILVL,GRID,IMOUT,JMOUT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    NOPACK      POST FIELDS IN CRAY BINARY
C   PRGRMMR: TREADON         ORG: W/NP2 
C     
C ABSTRACT:
C     THIS ROUTINE POSTS THE DATA IN THE PASSED ARRAY GRID
C     TO THE OUTPUT FILE AS AN UNFORMATTED CRAY BINARY FILE.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C     
C USAGE:    CALL NOPACK(IFLD,ILVL,GRID,IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IFLD     - FIELD ID TAG.
C     ILVL     - INTEGER TAG FOR LEVEL OF FIELD.
C     GRID     - FIELD TO BE POSTED IN CRAY BINARY.
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     LUNOUT  - UNIT DATA IS POSTED TO.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       MINMAX   - DETERMINES MIN/MAX VALUES IN AN ARRAY.
C     LIBRARY:
C       COMMON   - CTLBLK
C                  MAPOT
C                  RQSTFLD
C                  IOUNIT
C                  OUTGRD
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C
C
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE PARAMETERS.
C
      INCLUDE "parmeta"
      INCLUDE "parmout"
      PARAMETER (LP1=LM+1,D50=0.5E0)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESRT,SIGMA,OLDRD,STDRD
      LOGICAL NORTH,HEADER
      CHARACTER*4  RESTHR
      CHARACTER*6  PROJ,BLANK
      CHARACTER*9  DESCR2
      CHARACTER*120 ENVAR
      CHARACTER*256 FNAME
      REAL GRID(IMOUT,JMOUT)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "OUTGRD.comm"
      INCLUDE "OUTFIL.comm"
      DATA BLANK/'      '/
C     
C
C****************************************************************************
C     START NOPACK HERE.
C
C     SET OUTPUT GRID TYPE.  WE ASSUME KGYTPE HOLDS THE ON84
C     ID FOR THE OUTPUT GRID.
C     UNIQUE ON84 LABELS FOR VARIOUS ETA DOMAINS BELOW:
C              90 = STAGGERED 80KM E-GRID 
C              91 = FILLED    80KM E-GRID
C              92 = STAGGERED 40KM E-GRID
C              93 = FILLED    40KM E-GRID
C              94 = STAGGERED 30KM E-GRID
C              95 = FILLED    30KM E-GRID
C              96 = STAGGERED "BIG" 40KM E-GRID (EDAS)
C     
      KGTYP = KGTYPE
C     IF NEED BE, OPEN A UNIT TO THE OUTPUT FILE.  IF REQUESTED,
C     WRITE DATE AND GRID INFO IF REQUESTED.
C     
      IF (RITEHD) THEN
C
C        APPEND FORECAST HOUR TO SUFFIX FOR SEQUENTIAL BINARY FILE.
C         IHR = NTSD/TSPH + 0.5
          IHR = ITAG
C     
C        GET FULL PATH FOR OUTPUT FILE FROM ENVIRONMENT VARIABLE
C        COMSP WHICH IS SET IN THE SCRIPT RUNNING THE MODEL.
C     
C        CONSTRUCT FULL PATH-FILENAME FOR OUTPUT FILE
         ENVAR = ' '
         CALL GETENV('COMSP',ENVAR)
         IF (ENVAR(1:6).EQ.BLANK) THEN
          WRITE(DESCR2,1000) IHR
 1000     FORMAT('.SbinF',I7.7)
          KDAT = INDEX(DATSET,' ') -1
          IF (KDAT.LE.0) KDAT = LEN(DATSET)
          FNAME = DATSET(1:KDAT) // DESCR2
         ELSE
          CALL GETENV('tmmark',RESTHR)
          IHR=ITAG
          WRITE(DESCR2,1011) IHR
 1011     FORMAT(I7.7)
          KENV = INDEX(ENVAR,' ') -1
          IF (KENV.LE.0) KENV = LEN(ENVAR)
          KDAT = INDEX(DATSET,' ') -1
          IF (KDAT.LE.0) KDAT = LEN(DATSET)
          FNAME = ENVAR(1:KENV) // DATSET(1:KDAT) // DESCR2(1:7)
     &              //'.'// RESTHR
         ENDIF
C
C        ASSIGN AND OPEN UNIT FOR DATA FILE.
         CLOSE(LUNOUT)
C        CALL ASNUNIT(LUNOUT,'-F cos -N ibm',ier)
C        IF (IER.NE.0) WRITE(STDOUT,*)
C    X        'NOPACK:  ASNUNIT ERROR IER=',IER
         OPEN(LUNOUT,FILE=FNAME,FORM='UNFORMATTED')
         REWIND(LUNOUT)
C
         RITEHD = .FALSE.
         WRITE(STDOUT,*)'NOPACK:  OPENED ',LUNOUT,' ',FNAME,
     X        ' ',DATSET
C      
C        IF REQUESTED, THE FIRST TWO "RECORDS" INCLUDE DATE 
C        AND OUTPUT GRID INFORMATION.  WE WRITE THEM ONLY 
C        ONCE TO EACH OUTPUT GRID.  
C     
         IF (INDEX(DATSET,'NOHEAD').EQ.0) THEN
C            IHH = NTSD/TSPH+D50
            IHH = ITAG
            IYY = IDAT(3)-1900
            IMM = IDAT(1)
            IDD = IDAT(2)
            WRITE(LUNOUT) IHRST,IMM,IDD,IYY,IHH
            WRITE(LUNOUT) KGTYP,PROJ,NORTH,IMOUT,JMOUT,
     X           POLEI,POLEJ,ALATVT,ALONVT,XMESHL
            WRITE(STDOUT,*)'NOPACK:  WROTE DATE AND GRID INFO'
            WRITE(STDOUT,1010) IHRST,IMM,IDD,IYY,IHH
            WRITE(STDOUT,1020) KGTYP,PROJ,NORTH,IMOUT,JMOUT
            WRITE(STDOUT,1030) POLEI,POLEJ,ALATVT,ALONVT
            WRITE(STDOUT,1030) XMESHL
 1010       FORMAT(5(I5,1X))
 1020       FORMAT(I5,1X,A6,1X,L1,1X,I5,1X,I5)
 1030       FORMAT(4(G12.6,1X))
         ENDIF
      ENDIF
C     
C     SET SURFACE VALUE FOR DATA.
C
      SFC = 0.
      IF (IS(IDENT(IFLD)).EQ.8) THEN
         SFC = SPL(ILVL)
      ELSEIF (IS(IDENT(IFLD)).EQ.149) THEN
C
C   TKE IS ON THE ETA INTERFACE AT THE BOTTOM OF THE LAYER ILVL
C
         SFC = AETA(ILVL)
         IF (IQ(IDENT(IFLD)).EQ.158) SFC = ETA(ILVL+1)
      ENDIF
C
C     IF DATSET CONTAINS "NOHEAD" WE SKIP THE HEADER STUFF 
C     THAT FOLLOWS AND GO DIRECTLY TO THE DATA.  A USER 
C     WOULD USED THIS OPTION IF (S)HE WANTS TO DIRECTLY
C     CONTOUR DATA USING NMCIDAS.
C     
      HEADER = .FALSE.
      IF (INDEX(DATSET,'NOHEAD').NE.0) GOTO 10
      WRITE(LUNOUT) FIELD(IFLD),SFC
      HEADER = .TRUE.
C     
C     WRITE DATA TO OUTPUT FILE.
C     
 10   CONTINUE
      WRITE(LUNOUT) GRID
      CALL MINMAX(GRID,IMOUT,JMOUT,FMIN,FMAX)
      WRITE(STDOUT,1040) IFLD,FIELD(IFLD),SFC,FMIN,FMAX,
     X     KGTYP,HEADER
 1040 FORMAT('NOPACK:',I3,1X,A20,1X,3(G12.6,1X),I5,1X,L1)
C     
C     END OF ROUTINE.
C     
      RETURN
      END

       SUBROUTINE CALWXT(T,Q,RES,PD,HTM,LMH,PREC,PT,AETA,ETA,IWX)
C 
C     FILE: CALWXT.f
C     WRITTEN: 11 NOVEMBER 1993, MICHAEL BALDWIN
C     REVISIONS:
C               30 SEPT 1994-SETUP NEW DECISION TREE (M BALDWIN)
C               12 JUNE 1998-CONVERSION TO 2-D (T BLACK)
C                              
C
C     ROUTINE TO COMPUTE PRECIPITATION TYPE USING A DECISION TREE
C     APPROACH THAT USES VARIABLES SUCH AS INTEGRATED WET BULB TEMP
C     BELOW FREEZING AND LOWEST LAYER TEMPERATURE
C
C     SEE BALDWIN AND CONTORNO PREPRINT FROM 13TH WEATHER ANALYSIS
C     AND FORECASTING CONFERENCE FOR MORE DETAILS
C     (OR BALDWIN ET AL, 10TH NWP CONFERENCE PREPRINT)
C 
      INCLUDE "parmeta"
C
      PARAMETER (LP1=LM+1)
      PARAMETER (H1M12=1.E-12)
      PARAMETER (PTHRESH=0.000004)
C
C  LIST OF VARIABLES NEEDED
C    PARAMETERS:
C      D608,ROG,H1,D00
       PARAMETER(D608=0.608,ROG=287.04/9.8,H1=1.0,D00=0.0)
C
C    INPUT:
C      T,Q,RES,PD,HTM,LMH,PREC,PT,AETA,ETA
      DIMENSION T(IM,JM,LM),Q(IM,JM,LM),RES(IM,JM),PD(IM,JM)
     &,         HTM(IM,JM,LM)
      DIMENSION LMH(IM,JM),PREC(IM,JM),ETA(LP1),AETA(LM)
C    OUTPUT:
C      IWX - INSTANTANEOUS WEATHER TYPE.
C        ACTS LIKE A 4 BIT BINARY
C          1111 = RAIN/FREEZING RAIN/ICE PELLETS/SNOW
C          WHERE THE ONE'S DIGIT IS FOR SNOW
C                THE TWO'S DIGIT IS FOR ICE PELLETS
C                THE FOUR'S DIGIT IS FOR FREEZING RAIN
C            AND THE EIGHT'S DIGIT IS FOR RAIN
      DIMENSION IWX(IM,JM)
C    INTERNAL:
C      PDSL
C
      DIMENSION TWET(IM,JM,LM),PDSL(IM,JM)
      DIMENSION KARR(IM,JM)
      DIMENSION LICEE(IM,JM),TCOLD(IM,JM),TWARM(IM,JM)
C    SUBROUTINES CALLED:
C     WETBULB
C     
C
C     INITIALIZE WEATHER TYPE ARRAY TO ZERO (IE, OFF).
C     WE DO THIS SINCE WE WANT IWX TO REPRESENT THE
C     INSTANTANEOUS WEATHER TYPE ON RETURN.
C     
      INCLUDE "CTLBLK.comm"
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        IWX(I,J) = 0
        PDSL(I,J)=RES(I,J)*PD(I,J)
      ENDDO
      ENDDO
C
!$omp  parallel do
!$omp& private(a,lmhk,pkl,psfck,qkl,tdchk,tdkl,tdpre,tkl)
      doout800: DO J=JSTA,JEND
      doin800: DO I=1,IM
      LMHK=LMH(I,J)
C
C   SKIP THIS POINT IF NO PRECIP THIS TIME STEP 
C
      IF (PREC(I,J).LE.PTHRESH) CYCLE doin800
C
C   FIND COLDEST AND WARMEST TEMPS IN SATURATED LAYER BETWEEN
C   70 MB ABOVE GROUND AND 500 MB
C   ALSO FIND HIGHEST SATURATED LAYER IN THAT RANGE
C
      PSFCK=PD(I,J)+PT
      TDCHK=2.0
  760 TCOLD(I,J)=T(I,J,LMHK)
      TWARM(I,J)=T(I,J,LMHK)
      LICEE(I,J)=LMHK
C
      do775: DO L=1,LMHK
      QKL=Q(I,J,L)
      QKL=AMAX1(H1M12,QKL)
      TKL=T(I,J,L)
      PKL=PDSL(I,J)*AETA(L)+PT
C
C   SKIP PAST THIS IF THE LAYER IS NOT BETWEEN 70 MB ABOVE GROUND
C       AND 500 MB
C
      IF (PKL.LT.50000.0.OR.PKL.GT.PSFCK-7000.0) CYCLE do775
      A=ALOG(QKL*PKL/(6.1078*(0.378*QKL+0.622)))
      TDKL=(237.3*A)/(17.269-A)+273.15
      TDPRE=TKL-TDKL
      IF (TDPRE.LT.TDCHK.AND.TKL.LT.TCOLD(I,J)) TCOLD(I,J)=TKL
      IF (TDPRE.LT.TDCHK.AND.TKL.GT.TWARM(I,J)) TWARM(I,J)=TKL
      IF (TDPRE.LT.TDCHK.AND.L.LT.LICEE(I,J)) LICEE(I,J)=L
      END DO do775
C
C    IF NO SAT LAYER AT DEW POINT DEP=TDCHK, INCREASE TDCHK
C     AND START AGAIN (BUT DON'T MAKE TDCHK > 6)
C
      IF (TCOLD(I,J).EQ.T(I,J,LMHK).AND.TDCHK.LT.6.0) THEN
        TDCHK=TDCHK+2.0
        GOTO 760
      ENDIF
      END DO doin800
      END DO doout800
C
C    LOWEST LAYER T
C
      doout850: DO J=JSTA,JEND
      doin850: DO I=1,IM
      KARR(I,J)=0
      IF (PREC(I,J).LE.PTHRESH) CYCLE doin850
      LMHK=LMH(I,J)
      TLMHK=T(I,J,LMHK)
C
C    DECISION TREE TIME
C
      IF (TCOLD(I,J).GT.269.15) THEN
          IF (TLMHK.LE.273.15) THEN
C             TURN ON THE FLAG FOR
C             FREEZING RAIN = 4
C             IF ITS NOT ON ALREADY
C             IZR=MOD(IWX(I,J),8)/4
C             IF (IZR.LT.1) IWX(I,J)=IWX(I,J)+4
              IWX(I,J)=IWX(I,J)+4
            CYCLE  doin850
          ELSE
C             TURN ON THE FLAG FOR
C             RAIN = 8
C             IF ITS NOT ON ALREADY
C             IRAIN=IWX(I,J)/8
C             IF (IRAIN.LT.1) IWX(I,J)=IWX(I,J)+8
              IWX(I,J)=IWX(I,J)+8
            CYCLE doin850
          ENDIF
      ENDIF
      KARR(I,J)=1
      END DO doin850
      END DO doout850
C
C   COMPUTE WET BULB ONLY AT POINTS THAT NEED IT
C
      CALL WETBULB(T,Q,PDSL,HTM,KARR,TWET)
C
!$omp  parallel do
!$omp& private(area1,areap4,areas8,dzkl,ifrzl,iwrml,lice,
!$omp&         lmhk,pintk1,pintk2,pm150,psfck,surfc,surfw,
!$omp&         tlmhk,twrmk)
      doout1900: DO J=JSTA_M,JEND_M
      doin1900: DO I=2,IM-1
      IF(KARR(I,J).GT.0)THEN
        LMHK=LMH(I,J)
        LICE=LICEE(I,J)
        PSFCK=PD(I,J)+PT
        TLMHK=T(I,J,LMHK)
        TWRMK=TWARM(I,J)
C
C    TWET AREA VARIABLES
C     CALCULATE ONLY WHAT IS NEEDED
C      FROM GROUND TO 150 MB ABOVE SURFACE
C      FROM GROUND TO TCOLD LAYER
C      AND FROM GROUND TO 1ST LAYER WHERE WET BULB T < 0.0
C
C     PINTK1 IS THE PRESSURE AT THE BOTTOM OF THE LAYER
C     PINTK2 IS THE PRESSURE AT THE TOP OF THE LAYER
C
C     AREAP4 IS THE AREA OF TWET ABOVE -4 C BELOW HIGHEST SAT LYR 
C
        AREAS8=D00
        AREAP4=D00
        SURFW =D00
        SURFC =D00
        PINTK1=PSFCK
C
        do1945: DO L=LMHK,LICE,-1
        PINTK2=PDSL(I,J)*ETA(L)+PT
        DZKL=T(I,J,L)*(Q(I,J,L)*D608+H1)*ROG*
     1        ALOG(PINTK1/PINTK2)
        AREA1=(TWET(I,J,L)-269.15)*DZKL
        IF (TWET(I,J,L).GE.269.15) AREAP4=AREAP4+AREA1
        PINTK1=PINTK2
        END DO do1945
C
        IF (AREAP4.LT.3000.0) THEN
C             TURN ON THE FLAG FOR
C             SNOW = 1
C             IF ITS NOT ON ALREADY
C             ISNO=MOD(IWX(I,J),2)
C             IF (ISNO.LT.1) IWX(I,J)=IWX(I,J)+1
          IWX(I,J)=IWX(I,J)+1
          CYCLE doin1900
        ENDIF
C
C     AREAS8 IS THE NET AREA OF TWET W.R.T. FREEZING IN LOWEST 150MB
C
        PINTK1=PSFCK
        PM150=PSFCK-15000.
C
        do1955: DO L=LMHK,1,-1
        PINTK2=PDSL(I,J)*ETA(L)+PT
        IF(PINTK1.LT.PM150)GO TO 1950
        DZKL=T(I,J,L)*(Q(I,J,L)*D608+H1)*ROG*
     1        ALOG(PINTK1/PINTK2)
C
C    SUM PARTIAL LAYER IF IN 150 MB AGL LAYER
C
        IF(PINTK2.LT.PM150) 
     &    DZKL=T(I,J,L)*(Q(I,J,L)*D608+H1)*ROG*
     1         ALOG(PINTK1/PM150)
        AREA1=(TWET(I,J,L)-273.15)*DZKL
        AREAS8=AREAS8+AREA1
 1950   PINTK1=PINTK2
        END DO do1955
C
C     SURFW IS THE AREA OF TWET ABOVE FREEZING BETWEEN THE GROUND
C       AND THE FIRST LAYER ABOVE GROUND BELOW FREEZING
C     SURFC IS THE AREA OF TWET BELOW FREEZING BETWEEN THE GROUND
C       AND THE WARMEST SAT LAYER
C
        PINTK1=PSFCK
        IFRZL=0
        IWRML=0
C
        do2850: DO L=LMHK,1,-1
        IF (IFRZL.EQ.0.AND.T(I,J,L).LT.273.15) IFRZL=1
        IF (IWRML.EQ.0.AND.T(I,J,L).GE.TWRMK) IWRML=1
C
        IF (IWRML.EQ.0.OR.IFRZL.EQ.0) THEN
          PINTK2=PDSL(I,J)*ETA(L)+PT
          DZKL=T(I,J,L)*(Q(I,J,L)*D608+H1)*ROG*
     1         ALOG(PINTK1/PINTK2)
          AREA1=(TWET(I,J,L)-273.15)*DZKL
          PINTK1=PINTK2
          IF(IFRZL.EQ.0.AND.TWET(I,J,L).GE.273.15)SURFW=SURFW+AREA1
          IF(IWRML.EQ.0.AND.TWET(I,J,L).LE.273.15)SURFC=SURFC+AREA1
        ENDIF
        END DO do2850
        IF(SURFC.LT.-3000.0.OR.
     &    (AREAS8.LT.-3000.0.AND.SURFW.LT.50.0)) THEN
C             TURN ON THE FLAG FOR
C             ICE PELLETS = 2
C             IF ITS NOT ON ALREADY
C             IIP=MOD(IWX(I,J),4)/2
C             IF (IIP.LT.1) IWX(I,J)=IWX(I,J)+2
          IWX(I,J)=IWX(I,J)+2
          CYCLE doin1900
        ENDIF
C
        IF(TLMHK.LT.273.15) THEN
C             TURN ON THE FLAG FOR
C             FREEZING RAIN = 4
C             IF ITS NOT ON ALREADY
C             IZR=MOD(IWX(K),8)/4
C             IF (IZR.LT.1) IWX(K)=IWX(K)+4
          IWX(I,J)=IWX(I,J)+4
        ELSE
C             TURN ON THE FLAG FOR
C             RAIN = 8
C             IF ITS NOT ON ALREADY
C             IRAIN=IWX(K)/8
C             IF (IRAIN.LT.1) IWX(K)=IWX(K)+8
          IWX(I,J)=IWX(I,J)+8
        ENDIF
      ENDIF
      END DO doin1900
      END DO doout1900
C---------------------------------------------------------
      RETURN
      END

      SUBROUTINE MINMAX(A,IDIM,JDIM,AMIN,AMAX)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    MINMAX      RETURNS (MIN,MAX) IN ARRAY
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-01-08
C     
C ABSTRACT:
C     THIS ROUTINE FINDS THE MINIMUM AND MAXIMUM VALUES 
C     IN THE PASSED ARRAY "A" WHICH CONTAINS NPTS ELEMENTS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE MINMAX IN ETAPACKC.
C   93-01-08  RUSS TREADON - ADDED COMMENTS.
C     
C USAGE:    CALL MINMAX(A,IDIM,JDIM,AMIN,AMAX)
C   INPUT ARGUMENT LIST:
C     A        - INPUT ARRAY TO SCAN.
C     IDIM,JDIM- DIMENSIONS OF ARRAY "A".
C
C   OUTPUT ARGUMENT LIST: 
C     AMIN     - MINIMUM VALUE IN ARRAY "A".
C     AMAX     - MAXIMUM VALUE IN ARRAY "A".
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     DECLARE VARIABLES.
      REAL AMIN, AMAX
      REAL A(IDIM,JDIM)
C     
C*******************************************************************
C     START MINMAX HERE.
C     
C     INITIALIZE VARIABLES.
      AMIN =  1.E30
      AMAX = -1.E30
C     
C     FIND MIN AND MAX VALUES IN ARRAY.
C
      DO J=1,JDIM
      DO I=1,IDIM
        AMIN = AMIN1(AMIN,A(I,J))
        AMAX = AMAX1(AMAX,A(I,J))
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
      RETURN      
      END        

      SUBROUTINE CALMXW(MXWP,MXWZ,MXWU,MXWV)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALMXW      COMPUTE MAX WIND LEVEL 
C   PRGRMMR: MANIKIN        ORG: W/NP2   DATE: 97-03-04       
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES MAX WIND LEVEL.  AT EACH POINT,
C   IT FINDS THE MAX WIND ABOVE 500 MB AND DETERMINES THE
C   PRESSURE AND HEIGHT AT THAT LEVEL.
C     
C     
C PROGRAM HISTORY LOG:
C   97-03-04 GEOFF MANIKIN
C   98-06-15 T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-02 JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL  CALMXW(MXWP,MXWZ,MXWU,MXWV)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     MXWP    - PRESSURE LEVEL OF THE MAX WIND
C     MXWZ    - HEIGHT OF THE MAX WIND
C     MXWU    - U COMPONENT OF THE ACTUAL MAX WIND 
C     MXWV    - V COMPONENT OF THE ACTUAL MAX WIND
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       H2V     
C
C     LIBRARY:
C       COMMON   - VRBLS
C                  LOOPS
C                  EXTRA
C                  OPTIONS
C                  MASKS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE PARAMETERS.
C
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C
      INCLUDE "MASKS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "EXTRA.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C     DECLARE VARIABLES.
C     
      REAL MXWP(IM,JM),MXWZ(IM,JM),MXWU(IM,JM),MXWV(IM,JM),MXWW 
C     
C     
C*****************************************************************************
C     START CALMXW HERE.
C     
C     LOOP OVER THE GRID.
C    
      CRITP=5.0E4
C
      DO J=JSTA,JEND
      DO I=1,IM
        MXWU(I,J) = SPVAL
        MXWV(I,J) = SPVAL
        MXWP(I,J) = SPVAL
        MXWZ(I,J) = SPVAL 
      ENDDO
      ENDDO
C
C     ASSUME THAT U AND V HAVE UPDATED HALOS
C
!$omp  parallel do
!$omp& private(ie,iw,mxww,u0,v0,wind)
      doout20: DO J=JSTA_M,JEND_M
      doin20: DO I=2,IM-1
      IE=I+IHE(J)
      IW=I+IHW(J)
      MXWW  = -1000.
      LLMH=LMH(I,J)
C
      do10: DO L= LLMH-1,1,-1
         U0 = D25*(U(I,J-1,L)+U(IW,J,L)+
     X             U(IE,J,L)+U(I,J+1,L))
         V0 = D25*(V(I,J-1,L)+V(IW,J,L)+
     X             V(IE,J,L)+V(I,J+1,L))
         WIND = SQRT(U0**2 + V0**2)

C  MAX WIND LEVEL MUST BE ABOVE THE 500 MB 
C    ***NOTE, HOWEVER, THAT THE CHECK FOR 500 IS WITH THE
C       INTERFACE PRESSURE.  THEREFORE, WHEN THE PRESSURE OF
C       THE ACTUAL LEVEL OF THE MAX WIND IT COMPUTED, IT MAY
C       END UP WITH A PRESSURE SLIGHTLY GREATER THAN 500

         IF (WIND .GT. MXWW .and. PINT(I,J,L) .LT. CRITP) THEN
           MXWU(I,J) = U0
           MXWV(I,J) = V0
           MXWW = WIND 
           MXWP(I,J) = (PINT(I,J,L) + PINT(I,J,L+1)) * 0.5
           MXWZ(I,J)=HTM(I,J,L+1)*T(I,J,L+1)*(Q(I,J,L+1)*D608+H1)*ROG*
     X               (LOG(PINT(I,J,L+1))-LOG(MXWP(I,J)))+ZINT(I,J,L+1)
         ENDIF
      END DO do10
      END DO doin20
      END DO doout20

C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE FILLH(ARR1,ARR2,IDIM,JDIM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    FILLH       FILL H POINTS ON E-GRID V FIELD
C   PRGRMMR: BLACK           ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE FILLS MASS (H) POINTS ON A VELOCITY (V)
C     POINT E-GRID.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  BLACK - ORIGINATOR
C   93-12-23  RUSS TREADON - ADDED COMMENTS AND VARIABLE
C                            GRID DIMENSIONS TO 
C                            SUBROUTINE CALL.
C   98-06-04  BLACK - CONVERSION TO 2-D
C     
C USAGE:    CALL FILLH(ARR1,ARR2,IDIM,JDIM)
C   INPUT ARGUMENT LIST:
C     ARR2     - VELOCITY POINT DATA ON STAGGERED E-GRID.
C     IDIM     - FIRST DIMENSION OF FILLED E-GRID.
C     JDIM     - SECOND DIMENSION OF FILLED E-GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     ARR1     - VELOCITY POINT DATA ON FILLED E-GRID.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       EFILL - FILL MISSING VALUES ON STAGGERED
C               E-GRID WITH FIELD MEAN.
C     LIBRARY:
C       COMMON
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C--------------------------------------------------------------------
                        D I M E N S I O N
     & ARR1((IDIM+1)/2,JDIM), ARR2(IDIM,JDIM)
C     
C********************************************************************
C     START FILLH HERE.
C     
C     REPLACE MISSING VALUES ON EGRID WITH FIELD MEAN
      IM=(IDIM+1)/2
      CALL EFILL(ARR1,IM,JDIM)
C
      DO J=1,JDIM
      DO I=1,IDIM
        ARR2(I,J)=0.
      ENDDO
      ENDDO
C***
C***  REASSIGN VALUES OF MODEL GRID TO V POINTS ON IDIM X JDIM GRID
C***  ON ODD ROWS.
C***
      DO J=1,JDIM,2
      DO I=2,IDIM-1,2
        II=I/2
        ARR2(I,J)=ARR1(II,J)
      ENDDO
      ENDDO
C***
C***  REASSIGN VALUES OF MODEL GRID TO V POINTS ON IDIM X JDIM GRID
C***  ON EVEN ROWS.
C***
      DO J=2,JDIM-1,2
      DO I=1,IDIM,2
        II=(I+1)/2
        ARR2(I,J)=ARR1(II,J)
      ENDDO
      ENDDO
C***
C***  INTERPOLATE VALUES TO THOSE CORRESPONDING TO H POINTS ON THE
C***  IDIM X JDIM GRID ON THE BOTTOM AND TOP ROWS.
C***
      DO I=3,IDIM-2,2
        II=I/2
        ARR2(I,1)=(ARR1(II,1)+ARR1(II+1,1))*0.5
        ARR2(I,JDIM)=(ARR1(II,JDIM)+ARR1(II+1,JDIM))*0.5
      ENDDO
C***
C***  INTERPOLATE VALUES TO THOSE CORRESPONDING TO H POINTS ON THE
C***  IDIM X JDIM GRID ON THE WEST AND EAST SIDES.
C***
      DO J=3,JDIM-2,2
        ARR2(1,J)=(ARR1(1,J+1)+ARR1(1,J-1))*0.5
        ARR2(IDIM,J)=(ARR1(IM,J+1)+ARR1(IM,J-1))*0.5
      ENDDO
C***
C***  INTERPOLATE TO CORRESPONDING H POINTS ON ODD ROWS
C***  EXCLUDING THE SIDES.
C***
      DO J=3,JDIM-2,2
      DO I=3,IDIM-2,2
        II=I/2
        ARR2(I,J)=0.25*(ARR1(II,J)+ARR1(II+1,J)+ARR1(II+1,J+1)+
     1                  ARR1(II+1,J-1))
      ENDDO
      ENDDO
C***
C***  INTERPOLATE TO CORRESPONDING H POINTS ON EVEN ROWS
C***  EXCLUDING THE SIDES.
C***
      DO J=2,JDIM-1,2
      DO I=2,IDIM-1,2
        II=I/2
        ARR2(I,J)=0.25*(ARR1(II,J)+ARR1(II+1,J)+ARR1(II,J+1)+
     1                  ARR1(II,J-1))
      ENDDO
      ENDDO
C***
C***  EXTRAPOLATE TO THE FOUR CORNER H POINTS.
C***
      ARR2(1,1)=0.5*(1.5*(ARR1(1,1)+ARR1(1,2))
     1              -0.5*(ARR1(2,1)+ARR1(1,4)))
      ARR2(IDIM,1)=0.5*(1.5*(ARR1(IM-1,1)+ARR1(IM,2))
     1              -0.5*(ARR1(IM-2,1)+ARR1(IM,4)))
      ARR2(1,JDIM)=0.5*(1.5*(ARR1(1,JDIM)+ARR1(1,JDIM-1))
     1              -0.5*(ARR1(2,JDIM)+ARR1(1,JDIM-3)))
      ARR2(IDIM,JDIM)=0.5*(1.5*(ARR1(IM-1,JDIM)+ARR1(IM,JDIM-1))
     1              -0.5*(ARR1(IM-2,JDIM)+ARR1(IM,JDIM-3)))
      RETURN
      END

      SUBROUTINE LL2EG (YLAT,WLON,XI,YJ)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    LL2EG       ETA (LAT,LON) TO (I,J)
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     GIVEN (LAT,LON) ON A FILLED E-GRID THIS ROUTINE 
C     RETURNS THE CORRESPONDING FLOATING POINT (I,J)
C     OF THIS LOCATION.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE LL2EG IN ETAPACKC.
C   93-02-26  RUSS TREADON - GENERALIZED LL2EG TO HANDLE
C                            VARIABLE SIZE E-GRIDS.
C     
C USAGE:    CALL LL2EG(YLAT,WLON,XI,YJ)
C   INPUT ARGUMENT LIST:
C     YLAT     - LATITUDE OF (I,J) POINT.
C     WLON     - WEST LONGITUDE OF (I,J) POINT.
C
C   OUTPUT ARGUMENT LIST: 
C     XI       - FLOATING POINT "I" OF (LAT,LON) ON FILLED E-GRID.
C     YJ       - FLOATING POINT "J" OF (LAT,LON) ON FILLED E-GRID.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EGRID
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     DECLARE VARIABLES, COMMON, EQUIVALENCES, AND CONSTANTS.
C
      LOGICAL NORTH
      REAL ALONVT, DLAM, DPHI, LAM, LAM0, PHI0, POLEI, POLEJ
      REAL SINPH0, TANPH0, WLONC, XMESHL, YLATC
C     
C     INCLUDE EGRID SPECIFICATIONS.
      INCLUDE "EGRID.comm"
C
      EQUIVALENCE (YLATC,ALONVT), (DPHI, POLEI)
      EQUIVALENCE (WLONC, POLEJ), (DLAM,XMESHL)
C
      DATA CONV2R/0.017453293/,CONV2D/57.2958/
      DATA EARTHR/6371.2/
C     
C     
C********************************************************************
C     START LL2EG HERE.
C     
C     CONVERT (LAT,LON) TO FLOATING POINT (I,J).
      PHI    = YLAT*CONV2R
      LAM    = WLON*CONV2R
      COSPHI = COS(PHI)
      SINPHI = SIN(PHI)

      X1     = COSPHI*COS(LAM-LAM0)
      X      = COSPH0*X1+SINPH0*SINPHI
      Y      = -COSPHI*SIN(LAM-LAM0)
      Z      = -SINPH0*X1+COSPH0*SINPHI
      BIGPHI = ATAN(Z/(SQRT(X*X+Y*Y)))*CONV2D
      BIGLAM = ATAN(Y/X)*CONV2D
      XI     = (BIGLAM/DLAM)+(IDIM+1)/2.0
      YJ     = (BIGPHI/DPHI)+(JDIM+1)/2.0
C     
C     END OF ROUTINE.
C
      RETURN
      END

      PROGRAM ETAPOST
C$$$  MAIN PROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C MAIN PROGRAM: ETA_ETAPOST
C   PRGMMR: MANIKIN          ORG: NP22        DATE: 2000-02-01
C     
C ABSTRACT:  
C     THIS PROGRAM DRIVES THE EXTERNAL ETA MODEL POST PROCESSOR.
C     
C PROGRAM HISTORY LOG:
C   92-12-24  RUSS TREADON - CODED ETAPOST AS STAND ALONE CODE
C   98-03-06  BALDWIN/BLACK/ROGERS - MODIFIED TO POST MULTIPLE
C             FORECAST HOURS IN ONE EXECUTION; NUMBER AND 
C             FREQUENCY DETERMINED BY UNIT 5 INPUT CARD
C   98-05-29  BLACK - CONVERSION OF POST CODE FROM 1-D TO 2-D
C   00-02-04  JIM TUCCILLO - PARALLEL VERSION VIA MPI
C     
C USAGE:    ETAPOST
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - IOUNIT
C                RQSTFLD
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : IBM RS/6000 SP
C$$$  
C
C
C============================================================================================================
C
C     This is an MPI code. All array indexing is with respect to the global indices. Loop indices 
C     look as follows for N MPI tasks.
C
C
C
C  Original                                            New
C  Index                                               Index
C
C   JM ----------------------------------------------- JEND
C JM-1 -                                             - JEND_M
C JM-2 -               MPI TASK N-1                  - JEND_M2
C      -                                             -
C      -                                             -
C      ----------------------------------------------- JSTA, JSTA_M, JSTA_M2
C      ----------------------------------------------- JEND, JEND_M, JEND_M2
C      -                                             -
C      -               MPI TASK N-2                  -
C      -                                             -
C      -                                             -
C      ----------------------------------------------- JSTA, JSTA_M, JSTA_M2
C
C                           .
C                           .
C                           .
C
C      ----------------------------------------------- JEND, JEND_M, JEND_M2
C      -                                             -
C      -               MPI TASK 1                    -
C      -                                             -
C      -                                             -
C      ----------------------------------------------- JSTA, JSTA_M, JSTA_M2
C      ----------------------------------------------- JEND, JEND_M, JEND_M2
C      -                                             - 
C      -               MPI TASK 0                    - 
C    3 -                                             - JSTA_M2
C    2 -                                             - JSTA_M
C    1 ----------------------------------------------- JSTA
C
C     1                                              IM               
C
C
C     Jim Tuccillo
C     Jan 2000
C
C============================================================================================================
C     
C     INCLUDE ARRAY DIMENSIONS.
      INCLUDE "parmout"
      INCLUDE "mpif.h"
C
C     DECLARE VARIABLES.
CJLG
      character*6 DATASET
CJLG      
C     
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "OUTFIL.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "CTLBLK.comm"
Cmp
        INCLUDE "GDS.com"
Cmp
C     
C     SET HEADER WRITER FLAGS TO TRUE.
c
      common/tim_info/ETAFLD2_tim,ETA2P_tim,SURFCE2_tim, CLDRAD_tim,
     *                MISCLN_tim,FIXED_tim
C
      common/jjt/time_output, time_e2out
      real(8) time_output, time_e2out, time_initpost, rtc, ist
      
      LOGICAL LME
      CHARACTER FINFIL*50,DONE*10,RESTHR*4
      INTEGER ITAG2
      
      time_output = 0.
      time_e2out = 0.
      time_initpost = 0.
C     INITIALIZE MPI
C
      CALL MPI_FIRST
C
      ETAFLD2_tim = 0.0
      ETA2P_tim = 0.0
      SURFCE2_tim = 0.0
      CLDRAD_tim = 0.0
      MISCLN_tim =0.0
      FIXED_tim =  0.0
      bbtim = timef()
c
C     
C
c     IF(ME.EQ.0)THEN
c       CALL W3TAGB('ETA_ETAPOST',2000,0032,0094,'NP22')
c     ENDIF
C
C
C**************************************************************************
C
C     START PROGRAM ETAPOST.
C
      IF ( ME.EQ.0) call cpu_time(startMainTime)
      IF(ME.EQ.0)THEN
        READ(5,*)ITAG,NRSTRT,NPINCR,DATASET
        write(6,*)ITAG,NRSTRT,NPINCR,DATASET
      ENDIF
C
      CALL MPI_BCAST(ITAG  ,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(NRSTRT,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(NPINCR,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(DATASET,6,MPI_CHARACTER,0,MPI_COMM_WORLD,IRTN)
C
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
C
C     LOOP OVER THE RESTRT FILES
C
      DO 1000 NR=1,NRSTRT
      LUNCO=19
      LUNLL=29
C
C     REWIND ALL INPUT FILE UNIT NUMBERS (FOR CONTROL FILE 
C     AND INTERPOLATION WEIGHTS)
C
      REWIND LCNTRL
      DO KER=19,39
        REWIND KER
      ENDDO
C
C     INITIALIZE POST COMMON BLOCKS 
C
C      ist = rtc()
      CALL INITPOST
      IF ( ME.EQ.0) THEN
        call cpu_time(stopTime)
        write(STDOUT,*)'INITPOST Elapsed time, s: ',(stopTime-startTime)
      ENDIF
C      time_initpost = time_initpost + rtc() - ist
      IF ( ME.EQ.0)
     & WRITE(STDOUT,*)'ETAPOST:  INITIALIZED POST COMMON BLOCKS'
C
C     LOOP OVER THE OUTPUT GRID(S).  FIELD(S) AND 
C     OUTPUT GRID(S) ARE SPECIFIED IN THE CONTROL 
C     FILE.  WE PROCESS ONE GRID AND ITS FIELDS 
C     AT A TIME.  THAT'S WHAT THIS LOOP DOES.
C     
Cmp
        IF ( ME.EQ.0) call cpu_time(startTime)
        if (NR .eq. 1) CALL GETGDEF
        IF ( ME.EQ.0) THEN
        call cpu_time(stopTime)
        write(STDOUT,*)
     X    'GETGDEF Elapsed time, s:',(stopTime-startTime)
      ENDIF
        IF ( ME.EQ.0)write(6,*) 'do we have GDS??? '
        IF ( ME.EQ.0)write(6,*) (IGDS(I),I=1,18)
Cmp

 10   CONTINUE
C     
C        READ CONTROL FILE DIRECTING WHICH FIELDS ON WHICH
C        LEVELS AND TO WHICH GRID TO INTERPOLATE DATA TO.
C        VARIABLE IEOF.NE.0 WHEN THERE ARE NO MORE GRIDS
C        TO PROCESS.
C     
CJLG         CALL READCNTRL2(IEOF)
         IF ( ME.EQ.0) call cpu_time(startTime)
         CALL READCNTRL2(IEOF,DATASET)
         IF ( ME.EQ.0) THEN
           call cpu_time(stopTime)
           write(STDOUT,*)
     X    'READCNTRL2 Elapsed time, s:',(stopTime-startTime)
      ENDIF
         IF ( ME .EQ. 0 ) THEN
	 WRITE(STDOUT,*)'ETAPOST:  RETURN FROM READCNTRL.  ',
     1        'IEOF=',IEOF
         ENDIF
         IF (IEOF.NE.0) GOTO 20
	 
C     
C        PROCESS SELECTED FIELDS.  FOR EACH SELECTED FIELD/LEVEL
C        WE GO THROUGH THE FOLLOWING STEPS:
C           (1) COMPUTE FIELD IF NEED BE
C           (2) INTERPOLATE FROM E-GRID TO OUTPUT GRID.
C           (3) WRITE FIELD TO OUTPUT FILE IN REQUESTED FORMAT.
C
         IF ( ME.EQ.0) call cpu_time(startTime)
         CALL PROCESS
         IF ( ME.EQ.0) THEN
           call cpu_time(stopTime)
           write(STDOUT,*)
     X    'PROCESS Elapsed time, s:',(stopTime-startTime)
         ENDIF
         IF ( ME .EQ. 0 ) THEN
	 WRITE(STDOUT,*)' '
         WRITE(STDOUT,*)'ETAPOST:  PREPARE TO PROCESS NEXT GRID'
	 ENDIF
C     
C     PROCESS NEXT GRID.
C     
      GO TO 10
C     
C     ALL GRIDS PROCESSED.
C     
 20   CONTINUE
      
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)' '
      WRITE(STDOUT,*)'ALL GRIDS PROCESSED.'
      WRITE(STDOUT,*)' '
      ENDIF
C
      ITAG2=ITAG
      ITAG=ITAG+NPINCR
 1000 CONTINUE
C
      IF ( ME .EQ. 0 ) THEN
      print*, 'ETAFLD2_tim = ',  ETAFLD2_tim*1.0e-3
      print*, 'ETA2P_tim =  ',ETA2P_tim *1.0e-3
      print*, 'SURFCE2_tim =  ',SURFCE2_tim*1.0e-3
      print*, 'CLDRAD_tim =  ',CLDRAD_tim *1.0e-3
      print*, 'MISCLN_tim = ',MISCLN_tim*1.0e-3
      print*, 'FIXED_tim = ',FIXED_tim*1.0e-3
      print*, 'Total time = ',(timef() - bbtim) * 1.0e-3
      print*, 'Time for OUTPUT = ',time_output
      print*, 'Time for E2OUT = ',time_e2out
      print*, 'Time for INITPOST = ',time_initpost
      ENDIF
C     
C     END OF PROGRAM.
C
C
c     IF(ME.EQ.0)THEN
c       CALL W3TAGE('ETA_ETAPOST')
c     ENDIF
C
      
      IF(ME.EQ.0)THEN
        LME=.TRUE.
      ELSE
        LME=.FALSE.
      ENDIF
      
      RESTHR='t00s'
      
      IF(LME)THEN
        DONE='DONE'
        WRITE(FINFIL,1190)ITAG2,RESTHR
 1190   FORMAT('LATLONDONE',I7.7,'.',A4)
        LFINFIL=91
        CLOSE(LFINFIL)
        OPEN(UNIT=LFINFIL,FILE=FINFIL,FORM='UNFORMATTED',IOSTAT=IER)
        WRITE(LFINFIL)DONE
        CLOSE(LFINFIL)

        IF(IER.NE.0)WRITE(LIST,*)' SIGNAL SENT TO FINFIL:  DONE'
      ENDIF     
      
      IF ( ME.EQ.0) THEN
        call cpu_time(stopMainTime)
        write(STDOUT,*)
     X       'Post Elapsed time, s: ',(stopMainTime-startMainTime)
      ENDIF
      
      CALL MPI_LAST
C
C      STOP 0
      END

       MODULE INDX_MOD
       implicit none
       SAVE
       INTEGER :: IHE(1441), IHW(1441), IVE(1441), IVW(1441) 
C Substitua 500 pelo valor real de JM ou use ALLOCATABLE
       END MODULE INDX_MOD

      SUBROUTINE CALCAPE(ITYPE,P1D,T1D,Q1D,L1D,CAPE,CINS)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALCAPE     COMPUTES CAPE AND CINS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-02-10      
C     
C ABSTRACT:  
C     
C     THIS ROUTINE COMPUTES CAPE AND CINS GIVEN TEMPERATURE,
C     PRESSURE, AND SPECIFIC HUMIDTY.  IN "STORM AND CLOUD 
C     DYNAMICS" (1989, ACADEMIC PRESS) COTTON AND ANTHES DEFINE
C     CAPE (EQUATION 9.16, P501) AS
C
C                  EL
C         CAPE =  SUM G * LN(THETAP/THETAA) DZ 
C                 LCL
C     
C     WHERE,
C      EL    = EQUILIBRIUM LEVEL,
C     LCL    = LIFTING CONDENSTATION LEVEL,
C       G    = GRAVITATIONAL ACCELERATION,
C     THETAP = LIFTED PARCEL POTENTIAL TEMPERATURE,
C     THETAA = AMBIENT POTENTIAL TEMPERATURE.
C     
C     NOTE THAT THE INTEGRAND LN(THETAP/THETAA) APPROXIMATELY
C     EQUALS (THETAP-THETAA)/THETAA.  THIS RATIO IS OFTEN USED
C     IN THE DEFINITION OF CAPE/CINS.
C     
C     TWO TYPES OF CAPE/CINS CAN BE COMPUTED BY THIS ROUTINE.  THE
C     SUMMATION PROCESS IS THE SAME FOR BOTH CASES.  WHAT DIFFERS
C     IS THE DEFINITION OF THE PARCEL TO LIFT.  FOR ITYPE=1 THE
C     PARCEL WITH THE WARMEST THETA-E IN A DPBND PASCAL LAYER ABOVE
C     THE MODEL SURFACE IS LIFTED.  THE ARRAYS P1D, T1D, Q1D, AND
C     L1D ARE NOT USED.  FOR ITYPE=2 THE ARRAYS P1D, T1D, Q1D, AND
C     L1D DEFINE THE PARCEL TO LIFT IN EACH COLUMN.  BOTH TYPES OF
C     CAPE/CINS MAY BE COMPUTED IN A SINGLE EXECUTION OF THE POST
C     PROCESSOR.
C     
C     THIS ALGORITHM PROCEEDS AS FOLLOWS.
C     FOR EACH COLUMN, 
C        (1)  INITIALIZE RUNNING CAPE AND CINS SUM TO 0.0
C        (2)  COMPUTE TEMPERATURE AND PRESSURE AT THE LCL USING
C             LOOK UP TABLE (PTBL).  USE EITHER PARCEL THAT GIVES
C             MAX THETAE IN LOWEST DPBND ABOVE GROUND (ITYPE=1)
C             OR GIVEN PARCEL FROM T1D,Q1D,...(ITYPE=2).
C        (3)  COMPUTE THE TEMP OF A PARCEL LIFTED FROM THE LCL.
C             WE KNOW THAT THE PARCEL'S
C             EQUIVALENT POTENTIAL TEMPERATURE (THESP) REMAINS
C             CONSTANT THROUGH THIS PROCESS.  WE CAN
C             COMPUTE TPAR USING THIS KNOWLEDGE USING LOOK
C             UP TABLE (SUBROUTINE TTBLEX).
C        (4)  FIND THE EQUILIBRIUM LEVEL.  THIS IS DEFINED AS THE
C             HIGHEST POSITIVELY BUOYANT LAYER.
C             (IF THERE IS NO POSITIVELY BUOYANT LAYER, CAPE/CINS
C              WILL BE ZERO)
C        (5)  COMPUTE CAPE/CINS.  
C             (A) COMPUTE THETAP.  WE KNOW TPAR AND P.
C             (B) COMPUTE THETAA.  WE KNOW T AND P.  
C        (6)  ADD G*(THETAP-THETAA)*DZ TO THE RUNNING CAPE OR CINS SUM.
C             (A) IF THETAP > THETAA, ADD TO THE CAPE SUM.
C             (B) IF THETAP < THETAA, ADD TO THE CINS SUM.
C        (7)  ARE WE AT EQUILIBRIUM LEVEL? 
C             (A) IF YES, STOP THE SUMMATION.
C             (B) IF NO, CONTIUNUE THE SUMMATION.
C        (8)  ENFORCE LIMITS ON CAPE AND CINS (I.E. NO NEGATIVE CAPE)
C     
C PROGRAM HISTORY LOG:
C   93-02-10  RUSS TREADON
C   93-06-19  RUSS TREADON - GENERALIZED ROUTINE TO ALLOW FOR 
C                            TYPE 2 CAPE/CINS CALCULATIONS.     
C   94-09-23  MIKE BALDWIN - MODIFIED TO USE LOOK UP TABLES
C                            INSTEAD OF COMPLICATED EQUATIONS.
C   94-10-13  MIKE BALDWIN - MODIFIED TO CONTINUE CAPE/CINS CALC
C                            UP TO AT HIGHEST BUOYANT LAYER.
C   98-06-12  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-18  T BLACK      - COMPUTE APE INTERNALLY
C   00-01-04  JIM TUCCILLO - MPI VERSION              
C     
C USAGE:    CALL CALCAPE(ITYPE,P1D,T1D,Q1D,L1D,CAPE,CINS)
C   INPUT ARGUMENT LIST:
C     ITYPE    - INTEGER FLAG SPECIFYING HOW PARCEL TO LIFT IS
C                IDENTIFIED.  SEE COMMENTS ABOVE.
C     P1D      - ARRAY OF PRESSURE OF PARCELS TO LIFT.
C     T1D      - ARRAY OF TEMPERATURE OF PARCELS TO LIFT.
C     Q1D      - ARRAY OF SPECIFIC HUMIDITY OF PARCELS TO LIFT.
C     L1D      - ARRAY OF MODEL LEVEL OF PARCELS TO LIFT.
C
C   OUTPUT ARGUMENT LIST: 
C     CAPE     - CONVECTIVE AVAILABLE POTENTIAL ENERGY (J/KG)
C     CINS     - CONVECTIVE INHIBITION (J/KG)
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       P2FILT   - SMOOTH DATA ON STAGGERED E-GRID.
C       BOUND    - BOUND (CLIP) DATA BETWEEN UPPER AND LOWER LIMTS.
C       TTBLEX   - LOOKUP TABLE ROUTINE TO GET T FROM THETAE AND P
C
C     LIBRARY:
C       COMMON   - VRBLS
C                  PHYS
C                  EXTRA
C                  IOUNIT
C                  LOOPS
C                  MASKS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     
C     INCLUDE/SET PARAMETERS.  CONSTANTS ARE FROM BOLTON (MWR, 1980).
      INCLUDE "parmeta"
      INCLUDE "parm.tbl"
      INCLUDE "params"
      PARAMETER (DPBND=70.E2,
     & ELIVW=2.72E6,ELOCP=ELIVW/CP)
      PARAMETER (ISMTHP=2,ISMTHT=2,ISMTHQ=2)
C     
C     DECLARE VARIABLES.
C     
      INTEGER L1D(IM,JM),IEQL(IM,JM),IPTB(IM,JM),ITHTB(IM,JM)
      INTEGER KLRES(IM,JM),KHRES(IM,JM),LCL(IM,JM)
C      INTEGER KNUML(LM),KNUMH(LM)
C     
      REAL P1D(IM,JM),T1D(IM,JM),Q1D(IM,JM)
      REAL CAPE(IM,JM),CINS(IM,JM)
      REAL THESP(IM,JM),TPAR(IM,JM,LM),PSP(IM,JM)
      REAL QQ(IM,JM),PP(IM,JM)
      INTEGER IDX(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "CTLBLK.comm"
C
C**************************************************************
C     START CALCAPE HERE.
C     
C
C     COMPUTE CAPE/CINS
C
C        WHICH IS: THE SUM FROM THE LCL TO THE EQ LEVEL OF
C             G * (LN(THETAP) - LN(THETAA)) * DZ
C
C             (POSITIVE AREA FOR CAPE, NEGATIVE FOR CINS)
C
C        WHERE:
C             THETAP IS THE PARCEL THETA
C             THETAA IS THE AMBIENT THETA
C             DZ IS THE THICKNESS OF THE LAYER
C
C         USING LCL AS LEVEL DIRECTLY BELOW SATURATION POINT
C         AND EQ LEVEL IS THE HIGHEST POSITIVELY BUOYANT LEVEL.
C  
C         IEQL = EQ LEVEL
C
C     INITIALIZE CAPE AND CINS ARRAYS
C 
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        CAPE(I,J) = D00
        CINS(I,J) = D00
        LCL(I,J)  = D00
        THESP(I,J)= D00
        IEQL(I,J) = LM+1
      ENDDO
      ENDDO
C
!$omp  parallel do
      DO L=1,LM
        DO J=JSTA,JEND
        DO I=1,IM
          TPAR(I,J,L)= D00
        ENDDO
        ENDDO
      ENDDO
C     
C     FOR TYPE 2 CAPE/CINS SMOOTH DATA PRIOR TO CALCULATION.
C     NOTE THAT FOR TYPE 1 CAPE/CINS ARRAYS P1D, T1D, Q1D 
C     ARE DUMMY ARRAYS.
C     
      IF (ITYPE.EQ.2) THEN
         CALL P2FILT(ISMTHP,HBM2,P1D)
         CALL P2FILT(ISMTHT,HBM2,T1D)
         CALL P2FILT(ISMTHQ,HBM2,Q1D)
         CALL BOUNDL(Q1D,H1M12,H99999,IM,JM)
      ENDIF
C-------FOR ITYPE=1-----------------------------------------------------
C---------FIND MAXIMUM THETA E LAYER IN LOWEST DPBND ABOVE GROUND-------
C-------FOR ITYPE=2-----------------------------------------------------
C---------FIND THETA E LAYER OF GIVEN T1D, Q1D, P1D---------------------
C--------------TRIAL MAXIMUM BUOYANCY LEVEL VARIABLES-------------------
      do20: DO KB=1,LM
       IF (ITYPE.EQ.2.AND.KB.GT.1) CYCLE do20
       doout10: DO J=JSTA_M,JEND_M
       doin10: DO I=2,IM-1
        LMHK   =LMH(I,J)
        PSFCK  =AETA(LMHK)*PDSL(I,J)+PT
          PKL = AETA(KB)*PDSL(I,J)+PT
          IF (ITYPE.EQ.1.AND.(PKL.LT.PSFCK-DPBND.OR.PKL.GT.PSFCK))
     &             CYCLE doin10
          IF (ITYPE.EQ.1) THEN
            TBTK   =T(I,J,KB)
            QBTK   =Q(I,J,KB)
            APEBTK =(H10E5/(PDSL(I,J)*AETA(KB)+PT))**CAPA
          ELSE
            PKL    =P1D(I,J)
            TBTK   =T1D(I,J)
            QBTK   =Q1D(I,J)
            APEBTK =(H10E5/PKL)**CAPA
          ENDIF
C--------------SCALING POTENTIAL TEMPERATURE & TABLE INDEX--------------
          TTHBTK =TBTK*APEBTK
          TTHK   =(TTHBTK-THL)*RDTH
          QQ(I,J)=TTHK-AINT(TTHK)
          ITTBK  =INT(TTHK)+1
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
          IF(ITTBK.LT.1)    THEN
            ITTBK  =1
            QQ(I,J)=D00
          ENDIF
          IF(ITTBK.GE.JTB)  THEN
            ITTBK  =JTB-1
            QQ(I,J)=D00
          ENDIF
C--------------BASE AND SCALING FACTOR FOR SPEC. HUMIDITY---------------
          BQS00K=QS0(ITTBK)
          SQS00K=SQS(ITTBK)
          BQS10K=QS0(ITTBK+1)
          SQS10K=SQS(ITTBK+1)
C--------------SCALING SPEC. HUMIDITY & TABLE INDEX---------------------
          BQK    =(BQS10K-BQS00K)*QQ(I,J)+BQS00K
          SQK    =(SQS10K-SQS00K)*QQ(I,J)+SQS00K
          TQK    =(QBTK-BQK)/SQK*RDQ
          PP(I,J)=TQK-AINT(TQK)
          IQ     =INT(TQK)+1
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
          IF(IQ.LT.1)    THEN
            IQ     =1
            PP(I,J)=D00
          ENDIF
          IF(IQ.GE.ITB)  THEN
            IQ     =ITB-1
            PP(I,J)=D00
          ENDIF
C--------------SATURATION PRESSURE AT FOUR SURROUNDING TABLE PTS.-------
          IT=ITTBK
          P00K=PTBL(IQ  ,IT  )
          P10K=PTBL(IQ+1,IT  )
          P01K=PTBL(IQ  ,IT+1)
          P11K=PTBL(IQ+1,IT+1)
C--------------SATURATION POINT VARIABLES AT THE BOTTOM-----------------
          TPSPK=P00K+(P10K-P00K)*PP(I,J)+(P01K-P00K)*QQ(I,J)
     2      +(P00K-P10K-P01K+P11K)*PP(I,J)*QQ(I,J)
          APESPK=(H10E5/TPSPK)**CAPA
          TTHESK=TTHBTK*EXP(ELOCP*QBTK*APESPK/TTHBTK)
C--------------CHECK FOR MAXIMUM THETA E--------------------------------
          IF(TTHESK.GT.THESP(I,J)) THEN
            PSP  (I,J)=TPSPK
            THESP(I,J)=TTHESK
          ENDIF
        END DO doin10
        END DO doout10
        END DO do20
C-----CHOOSE LAYER DIRECTLY BELOW PSP AS LCL AND------------------------
C-----ENSURE THAT THE LCL IS ABOVE GROUND.------------------------------
C-------(IN SOME RARE CASES FOR ITYPE=2, IT IS NOT)---------------------
      DO L=1,LM
!$omp  parallel do
!$omp& private(pkl)
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          PKL = AETA(L)*PDSL(I,J)+PT
          IF (PKL.LT.PSP(I,J)) LCL(I,J)=L+1
        ENDDO
        ENDDO
      ENDDO
!$omp  parallel do
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IF (LCL(I,J).GT.LMH(I,J)) LCL(I,J)=LMH(I,J)
        ENDDO
        ENDDO
C-----------------------------------------------------------------------
C---------FIND TEMP OF PARCEL LIFTED ALONG MOIST ADIABAT (TPAR)---------
C-----------------------------------------------------------------------
!!$omp  parallel do
      DO 30 L=LM,1,-1
C--------------SCALING PRESSURE & TT TABLE INDEX------------------------
      KNUML=0
      KNUMH=0
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        KLRES(I,J)=0
        KHRES(I,J)=0
        PKL=AETA(L)*PDSL(I,J)+PT
        IF(L.LE.LCL(I,J)) THEN
          IF(PKL.LT.PLQ)THEN
            KNUML=KNUML+1
            KLRES(I,J)=1
          ELSE
            KNUMH=KNUMH+1
            KHRES(I,J)=1
          ENDIF
        ENDIF
      ENDDO
      ENDDO
C***
C***  COMPUTE PARCEL TEMPERATURE ALONG MOIST ADIABAT FOR PRESSURE<PLQ
C**
      IF(KNUML.GT.0)THEN
        CALL TTBLEX(TPAR(1,1,L),TTBL,ITB,JTB,KLRES,PDSL,AETA(L)
     1,             HTM(1,1,L),PT,PL,QQ,PP,RDP,THE0,STHE,RDTHE,THESP
     2,             IPTB,ITHTB)
      ENDIF
C***
C***  COMPUTE PARCEL TEMPERATURE ALONG MOIST ADIABAT FOR PRESSURE>PLQ
C**
      IF(KNUMH.GT.0)THEN
        CALL TTBLEX(TPAR(1,1,L),TTBLQ,ITBQ,JTBQ,KHRES,PDSL,AETA(L)
     1,             HTM(1,1,L),PT,PLQ,QQ,PP,RDPQ,THE0Q,STHEQ,RDTHEQ
     2,             THESP,IPTB,ITHTB)
      ENDIF

C------------SEARCH FOR EQ LEVEL----------------------------------------
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        IF(KHRES(I,J).GT.0)THEN
          IF(TPAR(I,J,L).GT.T(I,J,L)) IEQL(I,J)=L
        ENDIF
      ENDDO
      ENDDO
C
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        IF(KLRES(I,J).GT.0)THEN
          IF(TPAR(I,J,L).GT.T(I,J,L)) IEQL(I,J)=L
        ENDIF
      ENDDO
      ENDDO
C-----------------------------------------------------------------------
 30   CONTINUE
C------------COMPUTE CAPE AND CINS--------------------------------------
c      DO K=KHL01,KHH01
c        LCLK=LCL(K)
c        IEQK=IEQL(K)
cCDIR$ SHORTLOOP
c        DO L=IEQK,LCLK
c          PRESK=AETA(L)*PDSL(K)+PT
c          DZKL=T(K,L)*(Q(K,L)*D608+H1)*ROG*PDSL(K)*DETA(L)/PRESK
c          THETAP=TPAR(K,L)*(H10E5/PRESK)**CAPA
c          THETAA=T(K,L)*(H10E5/PRESK)**CAPA
c          IF (THETAP.LT.THETAA)
c     &      CINS(K)=CINS(K)+G*(ALOG(THETAP)-ALOG(THETAA))*DZKL
c          IF (THETAP.GT.THETAA)
c     &      CAPE(K)=CAPE(K)+G*(ALOG(THETAP)-ALOG(THETAA))*DZKL
c        ENDDO
c      ENDDO
      LBEG=100
      LEND=0
C
!$omp  parallel do
!$omp& private(lbeg,lend)
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        LBEG=MIN(IEQL(I,J),LBEG)
        LEND=MAX(LCL(I,J),LEND)
      ENDDO
      ENDDO
C
      DO L=LBEG,LEND
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IDX(I,J)=0
          IF(L.GE.IEQL(I,J).AND.L.LE.LCL(I,J))THEN
            IDX(I,J)=1
          ENDIF
        ENDDO
C
        ENDDO
C
!$omp  parallel do
!$omp& private(dzkl,presk,thetaa,thetap)
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IF(IDX(I,J).GT.0)THEN
            PRESK=AETA(L)*PDSL(I,J)+PT
            DZKL=T(I,J,L)*(Q(I,J,L)*D608+H1)
     *           *ROG*PDSL(I,J)*DETA(L)/PRESK
            THETAP=TPAR(I,J,L)*(H10E5/PRESK)**CAPA
            THETAA=T(I,J,L)*(H10E5/PRESK)**CAPA
            IF(THETAP.LT.THETAA)THEN
              CINS(I,J)=CINS(I,J)
cjjt *                 +G*(ALOG(THETAP/THETAA))*DZKL
     *                 +G*(ALOG(THETAP)-ALOG(THETAA))*DZKL
            ELSEIF(THETAP.GT.THETAA)THEN
              CAPE(I,J)=CAPE(I,J)
cjjt *                 +G*(ALOG(THETAP/THETAA))*DZKL
     *                 +G*(ALOG(THETAP)-ALOG(THETAA))*DZKL
            ENDIF
          ENDIF
        ENDDO
        ENDDO
      ENDDO
         
C    
C     ENFORCE LOWER LIMIT OF 0.0 ON CAPE AND UPPER
C     LIMIT OF 0.0 ON CINS.
C
!$omp  parallel do
      doout40: DO J=JSTA,JEND
      doin40: DO I=1,IM
c         IF (CAPE(K).LT.D00) 
c     X        WRITE(STDOUT,*)
c     X        'CALCAPE:  NEGATIVE CAPE AT K=',K,CAPE(K)
c         IF (CINS(K).GT.D00)
c     X        WRITE(STDOUT,*)
c     X        'CALCAPE:  POSTIVE CINS AT K = ',K,CINS(K)
         CAPE(I,J) = AMAX1(D00,CAPE(I,J))
         CINS(I,J) = AMIN1(CINS(I,J),D00)
      END DO doin40
      END DO doout40
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE CALRCH(EL,RICHNO)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALRCH      COMPUTES GRD RCH NUMBER
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-10-11
C     
C ABSTRACT:  
C   THIS ROUTINE COMPUTES THE GRADIENT RICHARDSON NUMBER
C   AS CODED IN ETA MODEL SUBROUTINE PROFQ2.F.
C   FIX TO AVOID UNREASONABLY SMALL ANEMOMETER LEVEL WINDS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-10-11  RUSS TREADON
C   98-06-17  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL CALRCH(EL,RICHNO)
C   INPUT ARGUMENT LIST:
C     EL      - MIXING LENGTH SCALE.
C
C   OUTPUT ARGUMENT LIST: 
C     RICHNO  - GRADIENT RICHARDSON NUMBER.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EXTRA
C                  LOOPS
C                  MASKS
C                  PHYS
C                  VRBLS
C                  PVRBLS
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     INCLUDE,DERIVE,SET PARAMETERS.
C     
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
      INCLUDE "parm.tbl"
C     
C     DECLARE VARIABLES.
C     
      REAL EGRID1(IM,JM),EGRID2(IM,JM),HGT(IM,JM)
      REAL EL(IM,JM,LM),RICHNO(IM,JM,LM),THV(IM,JM,LM)
C     
C     INCLUDE COMMON BLOCKS.
C     
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C
C     
C*************************************************************************
C     START CALRCH HERE.
C     
C     INITIALIZE ARRAYS.
C     
!$omp  parallel do
      DO L = 1,LM
        DO J=JSTA,JEND
        DO I=1,IM
          RICHNO(I,J,L)=SPVAL
        ENDDO
        ENDDO
      ENDDO
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        HGT(I,J)=RG*FIS(I,J)
      ENDDO
      ENDDO
C     
C     COMPUTE AND SMOOTH VIRTUAL POTENTIAL TEMPERATURE.
C
!$omp  parallel do
!$omp& private(ape,egrid1,egrid2,ie,iw)
      DO L=LM,1,-1
        DO J=JSTA,JEND
        DO I=1,IM
          APE=(H10E5/(PDSL(I,J)*AETA(L)+PT))**CAPA
          THV(I,J,L)=(Q(I,J,L)*D608+H1)*T(I,J,L)*APE
        ENDDO
        ENDDO
C     
        CALL EXCH(THV(1,1,L))
C
C        SMOOTH VIRTUAL POTENTIAL TEMPERATURE.
C     
        DO J=JSTA,JEND_M
        DO I=1,IM-1
          IE=I+IHE(J)
          EGRID1(I,J)=(THV(IE,J+1,L)-THV(I,J,L))
     1                *HTM(I,J,L)*HTM(IE,J+1,L)
        ENDDO
        ENDDO
C
        DO J=JSTA_M,JEND
        DO I=1,IM-1
          IE=I+IHE(J)
          EGRID2(I,J)=(THV(IE,J-1,L)-THV(I,J,L))
     1                *HTM(IE,J-1,L)*HTM(I,J,L)
        ENDDO
        ENDDO
C
        CALL EXCH(EGRID1)
        CALL EXCH(EGRID2)
C
        DO J=JSTA_M2,JEND_M2
        DO I=2,IM-1
          IW=I+IHW(J)
          THV(I,J,L)=THV(I,J,L) + D125 * 
     1              (EGRID1(I,J)-EGRID1(IW,J-1)+
     2               EGRID2(I,J)-EGRID2(IW,J+1))*HBM2(I,J)
        ENDDO
        ENDDO
C
      ENDDO
C
C     COMPUTE GRADIENT RICHARDSON NUMBER AS CODED IN ETA MODEL
C     SUBROUTINE PROFQ2.F.  OUTER LOOP OVER THE VERTICAL. 
C     INTTER LOOP OVER THE HORIZONTAL.
C
!$omp  parallel do
!$omp& private(cs,ct,dthvkl,dukl,dvkl,dzkl,elkl,elklsq,
!$omp&         ie,iw,q2kl,qroot,rdzkl,ri,uhkl,ulkl,vhkl,vlkl,
!$omp&         wndsl,wndslp)
      DO L = 1,LM1
C
C     ASSUME THAT VTM, U, and V HAVE UPDATED HALOS
C
        DO J=JSTA_M2,JEND_M2
        DO I=2,IM-1
          IE=I+IHE(J)
          IW=I+IHW(J)
C     
C         WE NEED (U,V) WINDS AT A MASS POINT.  FOUR POINT
C         AVERAGE (U,V) WINDS TO MASS POINT.  NORMALIZE FOUR
C         POINT AVERAGE BY THE ACTUAL NUMBER OF (U,V) WINDS
C         USED IN THE AVERAGING.  VTM=1 IF WIND POINT IS 
C         ABOVE GROUND.  VTM=0 IF BELOW GROUND.
C
          WNDSL=VTM(I,J-1,L)+VTM(IW,J,L)+VTM(IE,J,L)+VTM(I,J+1,L)
          WNDSLP=VTM(I,J-1,L+1)+VTM(IW,J,L+1)+
     1           VTM(IE,J,L+1)+VTM(I,J+1,L+1)
          IF(WNDSL.EQ.0..OR.WNDSLP.EQ.0.)GO TO 10
          UHKL=(U(I,J-1,L)+U(IW,J,L)+U(IE,J,L)+U(I,J+1,L))/WNDSL
          ULKL=(U(I,J-1,L+1)+U(IW,J,L+1)+U(IE,J,L+1)+
     1          U(I,J+1,L+1))/WNDSLP
          VHKL=(V(I,J-1,L)+V(IW,J,L)+V(IE,J,L)+V(I,J+1,L))/WNDSL
          VLKL=(V(I,J-1,L+1)+V(IW,J,L+1)+V(IE,J,L+1)+
     1           V(I,J+1,L+1))/WNDSLP
          DZKL=D50*(ZINT(I,J,L)-ZINT(I,J,L+2))
          RDZKL=1./DZKL
          Q2KL=AMAX1(Q2(I,J,L),0.00001)
          QROOT=SQRT(Q2KL)
          ELKL=EL(I,J,L)
          ELKL=AMAX1(ELKL,EPSQ2)
          ELKLSQ=ELKL*ELKL
          DTHVKL=THV(I,J,L)-THV(I,J,L+1)
          DUKL=(UHKL-ULKL)
          DVKL=(VHKL-VLKL)
          CS=(DUKL*RDZKL)**2+(DVKL*RDZKL)**2
C     
C         COMPUTE GRADIENT RICHARDSON NUMBER.
C     
          IF(CS.LE.1.E-8)THEN
C
C         WIND SHEAR IS VANISHINGLY SO SET RICHARDSON
C         NUMBER TO POST PROCESSOR SPECIAL VALUE.
C
            RICHNO(I,J,L)=SPVAL
C
          ELSE
C
C         WIND SHEAR LARGE ENOUGH TO USE RICHARDSON NUMBER.
C
            CT=-1.*G*BETA*DTHVKL*RDZKL
            RI=-CT/CS
            RICHNO(I,J,L)=RI
          ENDIF
C
 10       CONTINUE
        ENDDO
        ENDDO
      ENDDO
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      BLOCK DATA POSTDATA

      INCLUDE "parmout"
      INCLUDE "OPTIONS.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "RQSTFLD.comm"
C
C
C     COMMON BLOCK OPTIONS CONTAINS USER OPTIONS
C        SPVAL :  FLAG FOR MISSING DATA ON OUTPUT GRID.  THIS
C	          CAN ARISE IF OUTPUT GRID EXTENDS BEYOND THE
C	          FILLED E-GRID.
C        IBESSL:  SWITCH FOR TYPE OF HORIZONTAL INTERPOLATION
C	          FROM FILLED E-GRID TO OUTPUT GRID.  
C	           -1 = 4-POINT LINEAR INTERPOLATION SCHEME
C 	                 WITH GRADIENT CORRECTION.  THIS OPTION
C	                 IS NOT AVAILABLE
C	            0 = 4-POINT LINEAR INTERPOLATION SCHEME
C	            1 = 16-POINT BESSEL INTERPOLATION SCHEME
C                       THIS OPTION IS NOT AVAILABLE.
C	 KSB   :  SQUARE ROOT OF THE NUMBER OF SUB-BOXES WHICH
C	          SUBROUTINE CETLIH USES.  SUBROUTINE CETLIH
C	          INTERPOLATES A H-POINT ETA GRID FIELD TO AN
C	          OUTPUT GRID CONSERVING THE AREA INTEGRAL OF
C	          THE E-GRID FIELD.  WHEN INTERPOLATING PRECIP
C                 AMOUNT TO A COARSER RESOLUTION GRID, KSB=3
C                 IS A GOOD CHOICE.  IF INTERPOLATING TO A
C                 FINER RESOLUTION GRID, KSB=8 IS A GOOD CHOICE.
C	 IOFFS :  PLUS/MINUS NUMBER OF POINTS ABOUT SOUTHWEST
C                 CORNER OUTPUT GRID POINT OVER WHICH CETLIH4.F
C	          SEARCHES THE CLOSEST OUTPUT GRID POINT TO
C	          EACH SUB-BOX.  WHEN INTERPOLATING TO A COARSER
C                 RESOLUTION GRID, IOFFS=2 OR 3 IS A GOOD CHOICE.
C                 IF INTERPOLATING TO A FINER RESOLUTION GRID,
C                 IOFFS=5 OR 6 IS A GOOD CHOICE.
C	 IFLAG :  CONTROLS OUTPUT FROM FILLV
C	            IFLAG=0 -> TAKE WHAT INTERPOLATION GIVES
C	            IFLAG=1 -> TRUNCATE OUTPUT AT ZERO
C	            IFLAG=2 -> TRUNCATE AT A VERY SMALL
C 	                       POSITIVE NUMBER (EPS)
C	 SATDEL:  FRACTIONAL VARIATION OF SATURATION.  SUBROUTINE
C                 NLYLI (N-LAYER LIFTED INDEX) LIFTS A MODIFIED 
C                 PARCEL.  PARCEL SPECIFIC HUMIDITY IS MODIFIED 
C	          ACCORDING TO THE FORMULA QMOD = (1+SATDEL)*QGIVEN.
C                 THE NGM USES SATDEL=0.05
C

      DATA SPVAL  / 999999./ 
      DATA IBESSL /   0    / 
      DATA KSB    /   3    /
      DATA IOFFS  /   2    /
      DATA IFLAG  /   0    / 
      DATA SATDEL / 0.05   /
C
      DATA RITEHD,RITE2 / .TRUE., .TRUE. /
C
      DATA STDOUT,LCNTRL /  6, 18 /
      DATA LUNCO, LUNLL  / 19, 29 /
      DATA LUNOUT        / 60     /
C
C
C     THIS FILE CONTAINS ALL THE UNIQUE FIELDS THE
C     ETA POST PROCESSOR CAN CURRENTLY GENERATE.  
C
C	IFILV IS SWITCH FOR FILLING MASS OR VELOCITY POINT E-GRID
C	   =0 DATA IS VELOCITY POINT AND MUST FILL MASS POINTS
C	   =1 DATA IS MASS POINT AND MUST FILL VELOCITY POINTS
C	AVBL IS CHARACTER STRING IDENTIFYING THE FIELD.
C	IQ  IS THE GRIB PDS OCTET 9 - PARAMETER (TABLE 2)
C	IS  IS THE GRIB PDS OCTET 10 - LEVEL TYPE (TABLE 3 & 3a)
C
C     WANT MORE/DIFFERENT FIELDS? 
C	(1) ADD CODE TO CALCULATE FIELD(S) IN APPROPRIATE ROUTINE(S),
C       (2) ADD FIELD(S) TO THIS LIST WITH A UNIQUE ITAG TAG,
C       (3) EDIT INPUT (CONTROL) FILE ACCORDINGLY,
C       (3) INCREASE PARAMETER MXFLD IN INCLUDE FILE "PARMOUT".
C
C     CURRENT NUMBER OF FIELDS LISTED:  180
C
C0       1         2         3         4         5         6         7
C234567890123456789012345678901234567890123456789012345678901234567890
      DATA IFILV(001),AVBL(001),IQ(001),IS(001)
     &                      /1,'PRESS ON ETA SFCS   ',001,119/
      DATA IFILV(077),AVBL(077),IQ(077),IS(077)
     &                      /1,'HEIGHT ON ETA SFCS  ',007,119/
      DATA IFILV(002),AVBL(002),IQ(002),IS(002)
     &                      /1,'TEMP ON ETA SFCS    ',011,119/
      DATA IFILV(003),AVBL(003),IQ(003),IS(003)
     &                      /1,'POT TEMP ON ETA SFCS',013,119/
      DATA IFILV(004),AVBL(004),IQ(004),IS(004)
     &                      /1,'DWPT TEMP ON ETA SFC',017,119/
      DATA IFILV(005),AVBL(005),IQ(005),IS(005)
     &                      /1,'SPEC HUM ON ETA SFCS',051,119/
      DATA IFILV(006),AVBL(006),IQ(006),IS(006)
     &                      /1,'REL HUM ON ETA SFCS ',052,119/
      DATA IFILV(083),AVBL(083),IQ(083),IS(083)
     &                      /1,'MST CNVG ON ETA SFCS',135,119/
      DATA IFILV(007),AVBL(007),IQ(007),IS(007)
     &                      /0,'U WIND ON ETA SFCS  ',033,119/
      DATA IFILV(008),AVBL(008),IQ(008),IS(008)
     &                      /0,'V WIND ON ETA SFCS  ',034,119/
      DATA IFILV(009),AVBL(009),IQ(009),IS(009)
     &                      /1,'OMEGA ON ETA SFCS   ',039,119/
      DATA IFILV(010),AVBL(010),IQ(010),IS(010)
     &                      /1,'ABS VORT ON ETA SFCS',041,119/
      DATA IFILV(084),AVBL(084),IQ(084),IS(084)
     &                      /1,'STRMFUNC ON ETA SFCS',035,119/
      DATA IFILV(011),AVBL(011),IQ(011),IS(011)
     &                      /1,'TRBLNT KE ON ETA SFC',158,119/
      DATA IFILV(111),AVBL(111),IQ(111),IS(111)
     &                      /1,'RCHDSN NO ON ETA SFC',254,119/
      DATA IFILV(146),AVBL(146),IQ(146),IS(146)
     &                      /1,'MASTER LENGTH SCALE ',226,119/
      DATA IFILV(147),AVBL(147),IQ(147),IS(147)
     &                      /1,'ASYMPT MSTR LEN SCL ',227,119/
      DATA IFILV(012),AVBL(012),IQ(012),IS(012)
     &                      /1,'HEIGHT OF PRESS SFCS',007,100/
      DATA IFILV(013),AVBL(013),IQ(013),IS(013)
     &                      /1,'TEMP ON PRESS SFCS  ',011,100/
      DATA IFILV(014),AVBL(014),IQ(014),IS(014)
     &                      /1,'POT TEMP ON P SFCS  ',013,100/
      DATA IFILV(015),AVBL(015),IQ(015),IS(015)
     &                      /1,'DWPT TEMP ON P SFCS ',017,100/
      DATA IFILV(016),AVBL(016),IQ(016),IS(016)
     &                      /1,'SPEC HUM ON P SFCS  ',051,100/
      DATA IFILV(017),AVBL(017),IQ(017),IS(017)
     &                      /1,'REL HUMID ON P SFCS ',052,100/
      DATA IFILV(085),AVBL(085),IQ(085),IS(085)
     &                      /1,'MST CNVG ON P SFCS  ',135,100/
      DATA IFILV(018),AVBL(018),IQ(018),IS(018)
     &                      /0,'U WIND ON PRESS SFCS',033,100/
      DATA IFILV(019),AVBL(019),IQ(019),IS(019)
     &                      /0,'V WIND ON PRESS SFCS',034,100/
      DATA IFILV(020),AVBL(020),IQ(020),IS(020)
     &                      /1,'OMEGA ON PRESS SFCS ',039,100/
      DATA IFILV(021),AVBL(021),IQ(021),IS(021)
     &                      /1,'ABS VORT ON P SFCS  ',041,100/
      DATA IFILV(086),AVBL(086),IQ(086),IS(086)
     &                      /1,'STRMFUNC ON P SFCS  ',035,100/
      DATA IFILV(022),AVBL(022),IQ(022),IS(022)
     &                      /1,'TRBLNT KE ON P SFCS ',158,100/
      DATA IFILV(153),AVBL(153),IQ(153),IS(153)
     &                      /1,'CLOUD WATR ON P SFCS',153,100/
      DATA IFILV(166),AVBL(166),IQ(166),IS(166)
     &                      /1,'CLOUD ICE ON P SFCS ',058,100/
      DATA IFILV(023),AVBL(023),IQ(023),IS(023)
     &                      /1,'MESINGER MEAN SLP   ',130,102/
      DATA IFILV(105),AVBL(105),IQ(105),IS(105)
     &                      /1,'SHUELL MEAN SLP     ',002,102/
      DATA IFILV(138),AVBL(138),IQ(138),IS(138)
     &                      /1,'SHELTER PRESSURE    ',001,105/
      DATA IFILV(106),AVBL(106),IQ(106),IS(106)
     &                      /1,'SHELTER TEMPERATURE ',011,105/
      DATA IFILV(112),AVBL(112),IQ(112),IS(112)
     &                      /1,'SHELTER SPEC HUMID  ',051,105/
      DATA IFILV(113),AVBL(113),IQ(113),IS(113)
     &                      /1,'SHELTER DEWPOINT    ',017,105/
      DATA IFILV(114),AVBL(114),IQ(114),IS(114)
     &                      /1,'SHELTER REL HUMID   ',052,105/
      DATA IFILV(064),AVBL(064),IQ(064),IS(064)
     &                      /0,'U WIND AT ANEMOM HT ',033,105/
      DATA IFILV(065),AVBL(065),IQ(065),IS(065)
     &                      /0,'V WIND AT ANEMOM HT ',034,105/
      DATA IFILV(158),AVBL(158),IQ(158),IS(158)
     &                      /1,'POT TEMP AT 10 M    ',013,105/
      DATA IFILV(159),AVBL(159),IQ(159),IS(159)
     &                      /1,'SPEC HUM AT 10 M    ',051,105/
      DATA IFILV(024),AVBL(024),IQ(024),IS(024)
     &                      /1,'SURFACE PRESSURE    ',001,001/
      DATA IFILV(025),AVBL(025),IQ(025),IS(025)
     &                      /1,'SURFACE HEIGHT      ',007,001/
      DATA IFILV(027),AVBL(027),IQ(027),IS(027)
     &                      /1,'SURFACE POT TEMP    ',013,001/
      DATA IFILV(028),AVBL(028),IQ(028),IS(028)
     &                      /1,'SURFACE SPEC HUMID  ',051,001/
      DATA IFILV(029),AVBL(029),IQ(029),IS(029)
     &                      /1,'SURFACE DEWPOINT    ',017,001/
      DATA IFILV(076),AVBL(076),IQ(076),IS(076)
     &                      /1,'SURFACE REL HUMID   ',052,001/
      DATA IFILV(026),AVBL(026),IQ(026),IS(026)
     &                      /1,'SFC (SKIN) TEMPRATUR',011,001/
      DATA IFILV(115),AVBL(115),IQ(115),IS(115)
     &                      /1,'BOTTOM SOIL TEMP    ',085,111/
      DATA IFILV(116),AVBL(116),IQ(116),IS(116)
     &                      /1,'SOIL TEMPERATURE    ',085,112/
      DATA IFILV(117),AVBL(117),IQ(117),IS(117)
     &                      /1,'SOIL MOISTURE       ',144,112/
      DATA IFILV(036),AVBL(036),IQ(036),IS(036)
     &                      /1,'TOTAL SOIL MOISTURE ',086,112/
      DATA IFILV(118),AVBL(118),IQ(118),IS(118)
     &                      /1,'PLANT CANOPY SFC WTR',223,001/
      DATA IFILV(119),AVBL(119),IQ(119),IS(119)
     &                      /1,'SNOW WATER EQUIVALNT',065,001/
      DATA IFILV(120),AVBL(120),IQ(120),IS(120)
     &                      /1,'PERCENT SNOW COVER  ',238,001/
CHOU 20221225  Snow depth included
      DATA IFILV(099),AVBL(099),IQ(099),IS(099)
     &                      /1,'SNOW DEPTH          ',065,001/
CHOU 20221225
      DATA IFILV(169),AVBL(169),IQ(169),IS(169)
     &                      /1,'SFC EXCHANGE COEF   ',208,001/
      DATA IFILV(170),AVBL(170),IQ(170),IS(170)
     &                      /1,'GREEN VEG COVER     ',087,001/
      DATA IFILV(171),AVBL(171),IQ(171),IS(171)
     &                      /1,'SOIL MOISTURE AVAIL ',207,112/
      DATA IFILV(152),AVBL(152),IQ(152),IS(152)
     &                      /1,'INST GROUND HEAT FLX',155,001/
      DATA IFILV(030),AVBL(030),IQ(030),IS(030)
     &                      /1,'LIFTED INDEX--SURFCE',131,101/
      DATA IFILV(031),AVBL(031),IQ(031),IS(031)
     &                      /1,'LIFTED INDEX--BEST  ',132,116/
      DATA IFILV(075),AVBL(075),IQ(075),IS(075)
     &                      /1,'LIFTED INDEX--BNDLYR',024,116/
      DATA IFILV(032),AVBL(032),IQ(032),IS(032)
     &                      /1,'CNVCT AVBL POT ENRGY',157,001/
      DATA IFILV(107),AVBL(107),IQ(107),IS(107)
     &                      /1,'CNVCT INHIBITION    ',156,001/
      DATA IFILV(080),AVBL(080),IQ(080),IS(080)
     &                      /1,'PRECIPITABLE WATER  ',054,200/
      DATA IFILV(162),AVBL(162),IQ(162),IS(162)
     &                      /0,'STORM REL HELICITY  ',190,106/
      DATA IFILV(163),AVBL(163),IQ(163),IS(163)
     &                      /0,'U COMP STORM MOTION ',196,101/
      DATA IFILV(164),AVBL(164),IQ(164),IS(164)
     &                      /0,'V COMP STORM MOTION ',197,101/
      DATA IFILV(087),AVBL(087),IQ(087),IS(087)
     &                      /1,'ACM TOTAL PRECIP    ',061,001/
      DATA IFILV(033),AVBL(033),IQ(033),IS(033)
     &                      /1,'ACM CONVCTIVE PRECIP',063,001/
      DATA IFILV(034),AVBL(034),IQ(034),IS(034)
     &                      /1,'ACM GRD SCALE PRECIP',062,001/
      DATA IFILV(035),AVBL(035),IQ(035),IS(035)
     &                      /1,'ACM SNOWFALL        ',065,001/
      DATA IFILV(121),AVBL(121),IQ(121),IS(121)
     &                      /1,'ACM SNOW TOTAL/MELT ',099,001/
      DATA IFILV(122),AVBL(122),IQ(122),IS(122)
     &                      /1,'ACM STORM SFC RNOFF ',235,001/
      DATA IFILV(123),AVBL(123),IQ(123),IS(123)
     &                      /1,'ACM BSFL-GDWR RNOFF ',234,001/
      DATA IFILV(160),AVBL(160),IQ(160),IS(160)
     &                      /1,'INSTANT PRECIP TYPE ',140,001/
      DATA IFILV(167),AVBL(167),IQ(167),IS(167)
     &                      /1,'INSTANT PRECIP RATE ',059,001/
      DATA IFILV(172),AVBL(172),IQ(172),IS(172)
     &                      /1,'FROZEN FRAC CLD SCHM',194,001/
      DATA IFILV(124),AVBL(124),IQ(124),IS(124)
     &                      /1,'CLD WTR ON ETA SFCS ',153,119/
      DATA IFILV(125),AVBL(125),IQ(125),IS(125)
     &                      /1,'CLD ICE ON ETA SFCS ',058,119/
      DATA IFILV(145),AVBL(145),IQ(145),IS(145)
     &                      /1,'CLD FRAC ON ETA SFCS',071,119/
      DATA IFILV(037),AVBL(037),IQ(037),IS(037)
     &                      /1,'LOW CLOUD FRACTION  ',073,214/
      DATA IFILV(038),AVBL(038),IQ(038),IS(038)
     &                      /1,'MID CLOUD FRACTION  ',074,224/
      DATA IFILV(039),AVBL(039),IQ(039),IS(039)
     &                      /1,'HIGH CLOUD FRACTION ',075,234/
      DATA IFILV(161),AVBL(161),IQ(161),IS(161)
     &                      /1,'TOTAL CLD FRACTION  ',071,200/
      DATA IFILV(144),AVBL(144),IQ(144),IS(144)
     &                      /1,'AVG TOTAL CLD FRAC  ',071,200/
      DATA IFILV(139),AVBL(139),IQ(139),IS(139)
     &                      /1,'AVG STRAT CLD FRAC  ',213,200/
      DATA IFILV(143),AVBL(143),IQ(143),IS(143)
     &                      /1,'AVG CNVCT CLD FRAC  ',072,200/
      DATA IFILV(148),AVBL(148),IQ(148),IS(148)
     &                      /1,'CLOUD BOT PRESSURE  ',001,002/
      DATA IFILV(149),AVBL(149),IQ(149),IS(149)
     &                      /1,'CLOUD TOP PRESSURE  ',001,003/
      DATA IFILV(109),AVBL(109),IQ(109),IS(109)
     &                      /1,'LCL AGL HEIGHT      ',007,005/
      DATA IFILV(110),AVBL(110),IQ(110),IS(110)
     &                      /1,'LCL PRESSURE        ',001,005/
      DATA IFILV(078),AVBL(078),IQ(078),IS(078)
     &                      /1,'AVE GRDSCL RN TMPTDY',241,119/
      DATA IFILV(079),AVBL(079),IQ(079),IS(079)
     &                      /1,'AVE CNVCT RN TMPTDY ',242,119/
      DATA IFILV(168),AVBL(168),IQ(168),IS(168)
     &                      /1,'CLOUD TOP TEMPS     ',011,003/
      DATA IFILV(140),AVBL(140),IQ(140),IS(140)
     &                      /1,'RADFLX CNVG TMP TNDY',216,119/
      DATA IFILV(040),AVBL(040),IQ(040),IS(040)
     &                      /1,'SW RAD TEMP TNDY    ',250,119/
      DATA IFILV(041),AVBL(041),IQ(041),IS(041)
     &                      /1,'LW RAD TEMP TNDY    ',251,119/
      DATA IFILV(141),AVBL(141),IQ(141),IS(141)
     &                      /1,'INSTN OUT SFC SW RAD',211,001/
      DATA IFILV(142),AVBL(142),IQ(142),IS(142)
     &                      /1,'INSTN OUT SFC LW RAD',212,001/
      DATA IFILV(126),AVBL(126),IQ(126),IS(126)
     &                      /1,'AVE INCMG SFC SW RAD',204,001/
      DATA IFILV(127),AVBL(127),IQ(127),IS(127)
     &                      /1,'AVE INCMG SFC LW RAD',205,001/
      DATA IFILV(128),AVBL(128),IQ(128),IS(128)
     &                      /1,'AVE OUTGO SFC SW RAD',211,001/
      DATA IFILV(129),AVBL(129),IQ(129),IS(129)
     &                      /1,'AVE OUTGO SFC LW RAD',212,001/
      DATA IFILV(130),AVBL(130),IQ(130),IS(130)
     &                      /1,'AVE OUTGO TOA SW RAD',211,008/
      DATA IFILV(131),AVBL(131),IQ(131),IS(131)
     &                      /1,'AVE OUTGO TOA LW RAD',212,008/
      DATA IFILV(156),AVBL(156),IQ(156),IS(156)
     &                      /1,'INSTN INC SFC SW RAD',204,001/
      DATA IFILV(157),AVBL(157),IQ(157),IS(157)
     &                      /1,'INSTN INC SFC LW RAD',205,001/
      DATA IFILV(044),AVBL(044),IQ(044),IS(044)
     &                      /1,'ROUGHNESS LENGTH    ',083,001/
      DATA IFILV(045),AVBL(045),IQ(045),IS(045)
     &                      /1,'FRICTION VELOCITY   ',253,001/
      DATA IFILV(132),AVBL(132),IQ(132),IS(132)
     &                      /1,'SFC DRAG COEFFICIENT',252,001/
      DATA IFILV(133),AVBL(133),IQ(133),IS(133)
     &                      /1,'SFC U WIND STRESS   ',124,001/
      DATA IFILV(134),AVBL(134),IQ(134),IS(134)
     &                      /1,'SFC V WIND STRESS   ',125,001/
      DATA IFILV(043),AVBL(043),IQ(043),IS(043)
     &                      /1,'AVE SFC SENHEAT FX  ',122,001/
      DATA IFILV(135),AVBL(135),IQ(135),IS(135)
     &                      /1,'AVE GROUND HEAT FX  ',155,001/
      DATA IFILV(136),AVBL(136),IQ(136),IS(136)
     &                      /1,'AVE SNO PHSCNG HT FX',229,001/
      DATA IFILV(042),AVBL(042),IQ(042),IS(042)
     &                      /1,'AVE SFC LATHEAT FX  ',121,001/
      DATA IFILV(046),AVBL(046),IQ(046),IS(046)
     &                      /1,'AVE SFC MOMENTUM FX ',172,001/
      DATA IFILV(047),AVBL(047),IQ(047),IS(047)
     &                      /1,'ACC SFC EVAPORATION ',057,001/
      DATA IFILV(137),AVBL(137),IQ(137),IS(137)
     &                      /1,'ACC POT EVAPORATION ',228,001/
      DATA IFILV(154),AVBL(154),IQ(154),IS(154)
     &                      /1,'INST SFC SENHEAT FX ',122,001/
      DATA IFILV(155),AVBL(155),IQ(155),IS(155)
     &                      /1,'INST SFC LATHEAT FX ',121,001/
      DATA IFILV(048),AVBL(048),IQ(048),IS(048)
     &                      /1,'LATITUDE            ',176,001/
      DATA IFILV(049),AVBL(049),IQ(049),IS(049)
     &                      /1,'LONGITUDE           ',177,001/
      DATA IFILV(050),AVBL(050),IQ(050),IS(050)
     &                      /1,'LAND/SEA MASK       ',081,001/
      DATA IFILV(051),AVBL(051),IQ(051),IS(051)
     &                      /1,'SEA ICE MASK        ',091,001/
      DATA IFILV(052),AVBL(052),IQ(052),IS(052)
     &                      /1,'MASS POINT ETA SFC  ',173,001/
      DATA IFILV(053),AVBL(053),IQ(053),IS(053)
     &                      /1,'VEL POINT ETA SFC   ',174,001/
      DATA IFILV(150),AVBL(150),IQ(150),IS(150)
     &                      /1,'SFC MIDDAY ALBEDO   ',084,001/
      DATA IFILV(151),AVBL(151),IQ(151),IS(151)
     &                      /1,'SEA SFC TEMPERATURE ',080,001/
      DATA IFILV(054),AVBL(054),IQ(054),IS(054)
     &                      /1,'PRESS AT TROPOPAUSE ',001,007/
      DATA IFILV(055),AVBL(055),IQ(055),IS(055)
     &                      /1,'TEMP AT TROPOPAUSE  ',011,007/
      DATA IFILV(108),AVBL(108),IQ(108),IS(108)
     &                      /1,'POTENTL TEMP AT TROP',013,007/
      DATA IFILV(056),AVBL(056),IQ(056),IS(056)
     &                      /0,'U WIND AT TROPOPAUSE',033,007/
      DATA IFILV(057),AVBL(057),IQ(057),IS(057)
     &                      /0,'V WIND AT TROPOPAUSE',034,007/
      DATA IFILV(058),AVBL(058),IQ(058),IS(058)
     &                      /1,'SHEAR AT TROPOPAUSE ',136,007/
      DATA IFILV(059),AVBL(059),IQ(059),IS(059)
     &                      /1,'TEMP AT FD HEIGHTS  ',011,103/
      DATA IFILV(060),AVBL(060),IQ(060),IS(060)
     &                      /0,'U WIND AT FD HEIGHTS',033,103/
      DATA IFILV(061),AVBL(061),IQ(061),IS(061)
     &                      /0,'V WIND AT FD HEIGHTS',034,103/
      DATA IFILV(062),AVBL(062),IQ(062),IS(062)
     &                      /1,'HEIGHT OF FRZ LVL   ',007,004/
      DATA IFILV(063),AVBL(063),IQ(063),IS(063)
     &                      /1,'REL HUMID AT FRZ LVL',052,004/
      DATA IFILV(165),AVBL(165),IQ(165),IS(165)
     &                      /1,'HIGHEST FREEZE LVL  ',007,204/
CHOU 20221226 HPBL
      DATA IFILV(066),AVBL(066),IQ(066),IS(066)
     &                      /1,'BNDRY LYR HEIGHT    ',007,116/
CHOU
      DATA IFILV(067),AVBL(067),IQ(067),IS(067)
     &                      /1,'PRESS IN BNDRY LYR  ',001,116/
      DATA IFILV(068),AVBL(068),IQ(068),IS(068)
     &                      /1,'TEMP IN BNDRY LYR   ',011,116/
      DATA IFILV(069),AVBL(069),IQ(069),IS(069)
     &                      /1,'POT TMP IN BNDRY LYR',013,116/
      DATA IFILV(070),AVBL(070),IQ(070),IS(070)
     &                      /1,'DWPT IN BNDRY LYR   ',017,116/
      DATA IFILV(071),AVBL(071),IQ(071),IS(071)
     &                      /1,'SPC HUM IN BNDRY LYR',051,116/
      DATA IFILV(072),AVBL(072),IQ(072),IS(072)
     &                      /1,'REL HUM IN BNDRY LYR',052,116/
      DATA IFILV(088),AVBL(088),IQ(088),IS(088)
     &                      /1,'MST CNV IN BNDRY LYR',135,116/
      DATA IFILV(089),AVBL(089),IQ(089),IS(089)
     &                      /1,'P WATER IN BNDRY LYR',054,116/
      DATA IFILV(073),AVBL(073),IQ(073),IS(073)
     &                      /0,'U WIND IN BNDRY LYR ',033,116/
      DATA IFILV(074),AVBL(074),IQ(074),IS(074)
     &                      /0,'V WIND IN BNDRY LYR ',034,116/
      DATA IFILV(090),AVBL(090),IQ(090),IS(090)
     &                      /1,'OMEGA IN BNDRY LYR  ',039,116/
      DATA IFILV(081),AVBL(081),IQ(081),IS(081)
     &                      /1,'LFM 0.66-1.00 RELHUM',052,108/
      DATA IFILV(082),AVBL(082),IQ(082),IS(082)
     &                      /1,'LFM 0.33-0.66 RELHUM',052,108/
      DATA IFILV(104),AVBL(104),IQ(104),IS(104)
     &                      /1,'LFM 0.33-1.00 PWAT  ',054,108/
      DATA IFILV(091),AVBL(091),IQ(091),IS(091)
     &                      /1,'MAX TEMPERATURE     ',001,107/
      DATA IFILV(092),AVBL(092),IQ(092),IS(092)
     &                      /1,'MIN TEMPERATURE     ',011,107/
CHOU 2022/10/30 quv
      DATA IFILV(093),AVBL(093),IQ(093),IS(093)
     &                      /0,'VERT INT MOISTxU    ',124,001/
      DATA IFILV(094),AVBL(094),IQ(094),IS(094)
     &                      /0,'VERT INT MOISTxV    ',125,001/
CHOU
CHOU      DATA IFILV(093),AVBL(093),IQ(093),IS(093)
CHOU     &                      /1,'NGM 0.98230 SPC HUM ',051,107/
CHOU      DATA IFILV(094),AVBL(094),IQ(094),IS(094)
CHOU     &                      /1,'NGM 0.98230 REL HUM ',052,107/
CGSM V100
      DATA IFILV(095),AVBL(095),IQ(095),IS(095)
     &                      /0,'U WIND 100M         ',033,107/
      DATA IFILV(096),AVBL(096),IQ(096),IS(096)
     &                      /0,'V WIND 100M         ',034,107/
CGSM V100
CHOU CLW, CLI
      DATA IFILV(097),AVBL(097),IQ(097),IS(097)
     &                      /1,'VERT INT CLOUD WATER',054,200/
      DATA IFILV(098),AVBL(098),IQ(098),IS(098)
     &                      /1,'VERT INT CLOUD ICE  ',054,200/
CHOU
      DATA IFILV(100),AVBL(100),IQ(100),IS(100)
     &                      /1,'NGM 0.47-0.96 RELHUM',052,108/
      DATA IFILV(101),AVBL(101),IQ(101),IS(101)
     &                      /1,'NGM 0.18-0.47 RELHUM',052,108/
      DATA IFILV(102),AVBL(102),IQ(102),IS(102)
     &                      /1,'NGM 0.84-0.98 RELHUM',052,108/
      DATA IFILV(103),AVBL(103),IQ(103),IS(103)
     &                      /1,'NGM 0.85-1.00 QCONVG',135,108/
      DATA IFILV(173),AVBL(173),IQ(173),IS(173)
     &                      /1,'MAX WIND PRESS LEVEL',001,006/
      DATA IFILV(174),AVBL(174),IQ(174),IS(174)
     &                      /1,'MAX WIND HGHT LEVEL ',007,006/
      DATA IFILV(175),AVBL(175),IQ(175),IS(175)
     &                      /0,'U COMP MAX WIND     ',033,006/
      DATA IFILV(176),AVBL(176),IQ(176),IS(176)
     &                      /0,'V COMP MAX WIND     ',034,006/
      DATA IFILV(177),AVBL(177),IQ(177),IS(177)
     &                      /1,'HEIGHT AT TROPOPAUSE',007,007/
      DATA IFILV(178),AVBL(178),IQ(178),IS(178)
     &                      /1,'CLOUD BOTTOM HEIGHT ',007,002/
      DATA IFILV(179),AVBL(179),IQ(179),IS(179)
     &                      /1,'CLOUD TOP HEIGHT    ',007,003/
      DATA IFILV(180),AVBL(180),IQ(180),IS(180)
     &                      /1,'VISIBILITY          ',020,001/
      DATA IFILV(181),AVBL(181),IQ(181),IS(181)
     &                      /1,'SOIL TYPE           ',224,001/
      DATA IFILV(182),AVBL(182),IQ(182),IS(182)
     &                      /1,'VEGETATION TYPE     ',225,001/
C
      END

      SUBROUTINE ETAFLD2(IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    ETAFLD2     SLP AND ETA LEVEL POSTING
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-21       
C     
C ABSTRACT:
C     THIS ROUTINE DOES SEVERAL THINGS.  IT IS THE FIRST 
C     ROUTINE CALLED BY POST PROCESSOR SUBROUTINE PROCESS 
C     WHICH SETS THE ORDER IN WHICH FIELDS ARE POSTED.  THE
C     INTERNAL POST VERSION OF ETAFLD2 FIRST LOADS FUNDAMENTAL
C     MODEL VARIABLES (T,Q,U,V) INTO POST-ONLY ARRAYS. 
C     NEGATIVE SPECIFIC HUMIDITY IS CLIPPED.  NEXT PRESSURE AND
C     LOG PRESSURE ARE COMPUTED AT ALL MASS GRID POINTS.  THE
C     MODEL ITSELF COMPUTES THE MESINGER SEA LEVEL PRESSURE 
C     PRIOR TO POSTING THE PROFILE DATA.  THIS ROUTINE WILL
C     COMPUTE THE STANDARD NMC SEA LEVEL PRESSURE IF THIS OPTION
C     IS ACTIVATED.  BY EITHER METHOD WE COMPUTE BELOW SURFACE
C     TEMPERATURES.  AFTER COMPUTING OMEGA ON THE ETA LEVELS,
C     WE SET BELOW SURFACE FIELDS ON ETA LEVELS.  USING THE 
C     HYDROSTATIC EQUATION WE COMPUTE THE HEIGHT AT ETA LAYER
C     INTERFACES.  FINALLY WE COMPUTE/POST REQUESTED FIELDS ON
C     ETA LAYERS.
C
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-21  RUSS TREADON
C   93-09-01  RUSS TREADON - ADDED ADDITIONAL OUTPUT FIELDS.
C   96-03-20  MIKE BALDWIN - ADDED CLOUD TOP TEMPS, CHANGE CLOUD WATER
C                            TO CONTAIN WATER ONLY
C   97-04-29  GEOFF MANIKIN - MOVED CLOUD TOP TEMPS TO CLDRAD
C   98-06-01  T BLACK - CONVERSION FROM 1-D TO 2-D
C   98-07-20  MIKE BALDWIN - REMOVED LABL84
C   98-08-18  T BLACK - REMOVED EXCESS SPACE IN EXTRA.com
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL ETAFLD2(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       BOUND    - BOUND ARRAY ELEMENTS BETWEEN LOWER AND UPPER LIMITS.
C       E2OUT    - INTERPOLATE/SMOOTH E-GRID TO OUTPUT GRID.
C       SCLFLD   - SCALE ARRAY ELEMENTS BY SCALAR CONSTANT.
C       OUTPUT   - POST DATA TO OUTPUT GRID IN SPECIFIED FORMAT.
C       NGMSLP2  - COMPUTE SLP USING STANDARD NMC REDUCTION METHOD.
C       BLOSFC2  - SET BELOW SURFACE ETA LEVEL DATA.
C       NETAL    - EXTRACT DATA ON CONSTANT ETA LAYER OR CONSTANT
C                     ATMOSPHERIC ETA LAYER.
C       CALPOT2  - COMPUTE POTENTIAL TEMPERATURE.
C       CALRH2   - COMPUTE RELATIVE HUMIDITY.
C       CALDWP2  - COMPUTE DEWPOINT TEMPERATURE.
C       CALMCVG  - COMPUTE MOISTURE CONVERGENCE.
C       CALVOR   - COMPUTE ABSOLUTE VORTICITY.
C       CALSTRM  - COMPUTE GEOSTROPHIC STREAMFUNCTION.
C     LIBRARY:
C       COMMON   - VRBLS
C                  PVRBLS
C                  EXTRA
C                  MASKS
C                  MAPOT
C                  DYNAMD
C                  OMGAOT
C                  RQSTFLD
C                  CTLBLK
C                  LOOPS
C                  ACMCLH
C                  ACMRDL
C                  ACMRDS
C                  CLDWTR
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE ETA MODEL DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
      INCLUDE "parm.tbl"
C
      PARAMETER (RAINCON=1.1787E4)
      PARAMETER (SNOCON=1.4594E5)
      PARAMETER (VCON1=1.66476,VCON2=0.55683)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STDRD
      LOGICAL NORTH,NEED(IM,JM)
      REAL EGRID1(IM,JM),EGRID2(IM,JM),EGRID3(IM,JM),EGRID4(IM,JM)
      REAL HGT(IM,JM),EL0(IM,JM),FI(IM,JM,2)
      REAL P1D(IM,JM),T1D(IM,JM),Q1D(IM,JM),EGRID5(IM,JM)
      REAL GRID1(IMOUT,JMOUT), GRID2(IMOUT,JMOUT)
      REAL PMID(IM,JM,LM),ZMID(IM,JM,LM),IW(IM,JM,LM)
      REAL EL(IM,JM,LM),RICHNO(IM,JM,LM)
      REAL QI(IM,JM),QINT(IM,JM)
      REAL TT(IM,JM),PPP(IM,JM),QV(IM,JM),QCD(IM,JM),QICE(IM,JM)
      REAL QRAIN(IM,JM),QSNO(IM,JM),VIS(IM,JM)
C     
C     INCLUDE REQUIRED COMMONS.
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "DYNAMD.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "ACMCLH.comm"
      INCLUDE "ACMRDL.comm"
      INCLUDE "ACMRDS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "OUTFIL.comm"
      INCLUDE "LOOPS.comm"
C
      REAL TTND(IM,JM),TRAIN(IM,JM),TCUCN(IM,JM)
C     
C     DECLARE EQUIVALENCES.
      EQUIVALENCE (EGRID1(1,1),P1D(1,1),EL0(1,1))
      EQUIVALENCE (EGRID2(1,1),T1D(1,1),HGT(1,1))
      EQUIVALENCE (PMID(1,1,1),EL(1,1,1))
      EQUIVALENCE (ZMID(1,1,1),RICHNO(1,1,1))
C     
C*****************************************************************************
C     START SUBROUTINE ETAFLD.
C     
C
C  SET UP UTIM FOR THIS TIME STEP
C
      CTIM1=0.
      CTIM2=24.*3600.
      CTIM =NTSD*DT
      IF(CTIM.LT.CTIM1)THEN
        UTIM=0.
      ELSE
        IF(CTIM.LE.CTIM2)THEN
          UTIM=(CTIM-CTIM1)/(CTIM2-CTIM1)
        ELSE
          UTIM=1.
        ENDIF
      ENDIF
C     SET TOTAL NUMBER OF OUTPUT GRID POINTS.
C
C     FROM THE ETA MODEL WE COMPUTE SEA LEVEL PRESSURE USING
C     MESINGER'S ALGORITHM.  THIS CREATES AN UNDERGROUND
C     TEMPERATURE FIELD.  SUBROUTINE ETA2P MAKES USE OF THIS
C     UNDERGROUND TEMPERATURE FIELD IN COMPUTING GEOPOTENTIAL
C     BELOW THE GROUND.  IF THE USER WANTS SEA LEVEL PRESSURE
C     VIA THE SHUELL SCHEME, MAKE IT SO.  THIS SCHEME CREATES
C     ITS OWN UNDERGROUND TEMPERATURES WHICH ETA2P WILL USE.
C     THE ROUTINE ALSO COMPUTES ITS OWN 1000MB GEOPOTENTIAL.
C     
C     OUTPUT SEA LEVEL PRESSURE IF REQUESTED.
C     FIRST, MESINGER'S/Zavisa's SEA LEVEL PRESSURE.
      IF (IGET(023).GT.0) THEN
         CALL E2OUT(023,000,PSLP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
C         print*,'printing output mesinger pslp'
CHOU 20221229         do i=1,im
CHOU 20221229         do j=jsta,jend
CHOU 20221229C         print*,i,j,grid1(i,j)
CHOU 20221229         end do
CHOU 20221229         end do
c         print*,'OUTPUT MESINGER SEA LEVEL PRESSURE'
CHOU
         CALL OUTPUT(IOUTYP,IGET(023),LVLS(1,IGET(023)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SECOND, STANDARD NGM SEA LEVEL PRESSURE.
      IF (IGET(105).GT.0) THEN
         CALL NGMSLP2
         CALL E2OUT(105,000,SLP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
C         print*,'printing output NGM pslp'
CHOU 20221229         do i=1,im
CHOU 20221229         do j=jsta,jend
CHOU 20221229C         print*,i,j,grid1(i,j)
CHOU 20221229         end do
CHOU 20221229         end do
CHOU
CHOU
         print*,'OUTPUT NGM SEA LEVEL PRESSURE'
         CALL OUTPUT(IOUTYP,IGET(105),LVLS(1,IGET(105)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SET BELOW GROUND Q, U, V, AND OMEGA
C     
      CALL BLOSFC2
C     
C     COMPUTE HEIGHT AT INTERFACES.
C     SET SURFACE VALUES.
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        ZINT(I,J,LP1)=FIS(I,J)*GI
        FI(I,J,1)=FIS(I,J)
      ENDDO
      ENDDO
C
C     COMPUTE VALUES FROM THE SURFACE UP.
C
      DO 80 L=LM,1,-1
!$omp  parallel do
        DO J=JSTA,JEND
        DO I=1,IM
          FI(I,J,2)=HTM(I,J,L)*T(I,J,L)*(Q(I,J,L)*D608+H1)*R*
     1             (ALPINT(I,J,L+1)-ALPINT(I,J,L))+FI(I,J,1)
          ZINT(I,J,L)=FI(I,J,2)*GI
          FI(I,J,1)=FI(I,J,2)
        ENDDO
        ENDDO
   80 CONTINUE
C
C     COMPUTE VALUES FROM THE SURFACE BELOW.
      KMM=KMNTM(LM)
!$omp  parallel do
!$omp& private(i,iadd,j,k,lftov1,lmap1,ndrow)
      DO 100 KM=1,KMM
      K=KMNT(KM,LM)
      NDROW=K/IMT
      LFTOV1=MOD(K,IMT)
      IF(LFTOV1-IM.GT.0)THEN
        I=K-NDROW*IMT-IM
        IADD=2
      ELSEIF(LFTOV1.GT.0)THEN
        I=K-NDROW*IMT
        IADD=1
      ELSEIF(LFTOV1.EQ.0)THEN
        I=IM-1
        IADD=0
      ENDIF
      J=2*NDROW+IADD
C     IF ( J .GE. JSTA .AND. J .LE. JEND ) THEN
C
         LMAP1=LMH(I,J)+1
         DO L=LMAP1,LM
            ZINT(I,J,L+1)=DFL(L+1)*GI
         END DO 
C     END IF
  100 CONTINUE
C     
C     COMPUTE MIDLAYER HEIGHTS AND PRESSURES.
!$omp  parallel do
      DO 110 L = 1,LM
      DO J=JSTA,JEND
      DO I=1,IM
        PMID(I,J,L)=D50*(PINT(I,J,L+1)+PINT(I,J,L))
        ZMID(I,J,L)=D50*(ZINT(I,J,L+1)+ZINT(I,J,L))
      ENDDO
      ENDDO
  110 CONTINUE
C     
C     OUTPUT/CALCULATE PRESSURE, OMEGA, POTENTIAL TEMPERATURE,
C     DEWPOINT TEMPERATURE, RELATIVE HUMIDITY, AND 
C     ABSOLUTE VORTICITY ON ETA SURFACES.
C     
      NREC0=1
C
      IF ( (IGET(001).GT.0).OR.(IGET(077).GT.0).OR.
     X     (IGET(002).GT.0).OR.(IGET(003).GT.0).OR.
     X     (IGET(004).GT.0).OR.(IGET(005).GT.0).OR.
     X     (IGET(006).GT.0).OR.(IGET(083).GT.0).OR.
     X     (IGET(007).GT.0).OR.(IGET(008).GT.0).OR.
     X     (IGET(009).GT.0).OR.(IGET(010).GT.0).OR.
     X     (IGET(084).GT.0).OR.(IGET(011).GT.0).OR.
     X     (IGET(041).GT.0).OR.(IGET(124).GT.0).OR.
     X     (IGET(125).GT.0).OR.(IGET(145).GT.0).OR.
     X     (IGET(078).GT.0).OR.(IGET(079).GT.0).OR.
     X     (IGET(140).GT.0).OR.(IGET(040).GT.0).OR.
     X     (IGET(180).GT.0) ) THEN
C

C   IF ANY OF THE CLOUD ARRAYS ARE REQUESTED, COMPUTE ICE/WATER
C   ALSO NEED THIS IF VISIBILITY OR RH IS REQUESTED

      IF(IGET(124).GT.0.OR.IGET(125).GT.0.OR.IGET(145).GT.0
     X            .OR.IGET(006).GT.0.OR.IGET(180).GT.0)THEN
        CLIMIT =1.0E-20

        DO J=JSTA,JEND
        DO I=1,IM
          IW(I,J,1)=0.
        ENDDO
        ENDDO
C
      DO 125 L=2,LM 
      DO J=JSTA,JEND
      DO I=1,IM
        LML=LM-LMH(I,J)
        HH=HTM(I,J,L)*HBM2(I,J)
        TKL=T(I,J,L)
        QKL=Q(I,J,L)
        CWMKL=CWM(I,J,L)
        TMT0=(TKL-273.15)*HH
        TMT15=AMIN1(TMT0,-15.)*HH
        PP=PDSL(I,J)*AETA(L)+PT
        QW=HH*PQ0/PP*EXP(HH*A2*(TKL-A3)/(TKL-A4))
        QI(I,J)=QW*(1.+0.01*AMIN1(TMT0,0.))
C
        U00KL=U00(I,J)+UL(L+LML)*(0.95-U00(I,J))*UTIM
        IF(TMT0.LT.-15.0)THEN
          FIQ=QKL-U00KL*QI(I,J)
          IF(FIQ.GT.D00.OR.CWMKL.GT.CLIMIT) THEN
            IW(I,J,L)=1.
          ELSE
            IW(I,J,L)=0.
          ENDIF
        ENDIF
        IF(TMT0.GE.0.0)IW(I,J,L)=0.
        IF(TMT0.LT.0.0.AND.TMT0.GE.-15.0)THEN
          IW(I,J,L)=0.
          IF(IW(I,J,L-1).EQ.1.0.AND.CWMKL.GT.CLIMIT)IW(I,J,L)=1.
        ENDIF
      ENDDO
      ENDDO
  125 CONTINUE
      ENDIF
C
      DO 190 L=1,LM
C     
C           PRESSURE ON ETA SURFACES.
            IF (IGET(001).GT.0) THEN
             IF (LVLS(L,IGET(001)).GT.0) THEN
               ITYPE = LVLS(L,IGET(001))
               CALL NETAL(PMID,ITYPE,L,LMH,EGRID1)
               CALL E2OUT(001,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               print*,'OUTPUT PRESSURE ON ETA SURFACE'
               CALL OUTPUT(IOUTYP,IGET(001),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           HEIGHTS ON ETA SURFACES.
            IF (IGET(077).GT.0) THEN
             IF (LVLS(L,IGET(077)).GT.0) THEN
               ITYPE = LVLS(L,IGET(077))
               CALL NETAL(ZMID,ITYPE,L,LMH,EGRID1)
               CALL E2OUT(077,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               print*,'OUTPUT HEIGHT on ETA SURFACE'
               CALL OUTPUT(IOUTYP,IGET(077),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           TEMPERATURE ON ETA SURFACES.
            IF (IGET(002).GT.0) THEN
             IF (LVLS(L,IGET(002)).GT.0) THEN
               ITYPE = LVLS(L,IGET(002))
               CALL NETAL(T,ITYPE,L,LMH,EGRID1)
               CALL E2OUT(002,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(002),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           POTENTIAL TEMPERATURE ON ETA SURFACES.
            IF (IGET(003).GT.0) THEN
             IF (LVLS(L,IGET(003)).GT.0) THEN
               ITYPE = LVLS(L,IGET(003))
               CALL NETAL(PMID,ITYPE,L,LMH,P1D)
               CALL NETAL(T,ITYPE,L,LMH,T1D)
               CALL CALPOT2(P1D,T1D,EGRID3,IM,JM)
               CALL E2OUT(003,000,EGRID3,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(003),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           RELATIVE HUMIDITY ON ETA SURFACES.
            IF (IGET(006).GT.0) THEN
             IF (LVLS(L,IGET(006)).GT.0) THEN
               ITYPE = LVLS(L,IGET(006))
               CALL NETAL(PMID,ITYPE,L,LMH,P1D)
               CALL NETAL(T,ITYPE,L,LMH,T1D)
               CALL NETAL(Q,ITYPE,L,LMH,Q1D)
               CALL NETAL(IW,ITYPE,L,LMH,EGRID3)
               CALL CALRH2(P1D,T1D,Q1D,EGRID3,EGRID4,IM,JM)
               CALL E2OUT(006,000,EGRID4,EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(006),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           DEWPOINT ON ETA SURFACES.
            IF (IGET(004).GT.0) THEN
             IF (LVLS(L,IGET(004)).GT.0) THEN
               ITYPE = LVLS(L,IGET(004))
               CALL NETAL(PMID,ITYPE,L,LMH,P1D)
               CALL NETAL(Q,ITYPE,L,LMH,Q1D)
               CALL NETAL(T,ITYPE,L,LMH,T1D)
               CALL CALDWP2(P1D,Q1D,EGRID3,T1D)
               CALL E2OUT(004,000,EGRID3,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(004),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           SPECIFIC HUMIDITY ON ETA SURFACES.
            IF (IGET(005).GT.0) THEN
             IF (LVLS(L,IGET(005)).GT.0) THEN
               ITYPE = LVLS(L,IGET(005))
               CALL NETAL(Q,ITYPE,L,LMH,EGRID1)
               CALL E2OUT(005,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(005),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           MOISTURE CONVERGENCE ON ETA SURFACES.
            IF (IGET(083).GT.0) THEN
             IF (LVLS(L,IGET(083)).GT.0) THEN
               ITYPE = LVLS(L,IGET(083))
               CALL NETAL(Q,ITYPE,L,LMH,Q1D)
               CALL NETAL(U,ITYPE,L,LMV,EGRID1)
               CALL NETAL(V,ITYPE,L,LMV,EGRID2)
               CALL CALMCVG(Q1D,EGRID1,EGRID2,-1,EGRID3)
               CALL E2OUT(083,000,EGRID3,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(083),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           U AND/OR V WIND ON ETA SURFACES.

            IF (IGET(007).GT.0.OR.IGET(008).GT.0) THEN
             IF (LVLS(L,IGET(007)).GT.0.OR.LVLS(L,IGET(008)).GT.0) THEN
               ITYPE = LVLS(L,IGET(007))
               CALL NETAL(U,ITYPE,L,LMV,EGRID1)
               ITYPE = LVLS(L,IGET(008))
               CALL NETAL(V,ITYPE,L,LMV,EGRID2)
               CALL E2OUT(007,008,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               IF (IGET(007).GT.0)
     X              CALL OUTPUT(IOUTYP,IGET(007),LYR,GRID1,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               IF (IGET(008).GT.0)
     X              CALL OUTPUT(IOUTYP,IGET(008),LYR,GRID2,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           OMEGA ON ETA SURFACES.
            IF (IGET(009).GT.0) THEN
             IF (LVLS(L,IGET(009)).GT.0) THEN
               ITYPE = LVLS(L,IGET(009))
               CALL NETAL(OMGA,ITYPE,L,LMH,EGRID1)
               CALL E2OUT(009,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(009),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           ABSOLUTE VORTICITY ON ETA SURFACES.
            IF (IGET(010).GT.0) THEN
             IF (LVLS(L,IGET(010)).GT.0) THEN
               ITYPE = LVLS(L,IGET(010))
               CALL NETAL(U,ITYPE,L,LMV,EGRID1)
               CALL NETAL(V,ITYPE,L,LMV,EGRID2)
               CALL CALVOR(EGRID1,EGRID2,EGRID3)
               CALL E2OUT(010,000,EGRID3,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(010),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           GEOSTROPHIC STREAMFUNCTION ON ETA SURFACES.
            IF (IGET(084).GT.0) THEN
             IF (LVLS(L,IGET(084)).GT.0) THEN
               ITYPE = LVLS(L,IGET(084))
               CALL NETAL(ZMID,ITYPE,L,LMH,EGRID1)
               CALL CALSTRM(EGRID1,EGRID2)
               CALL E2OUT(084,000,EGRID2,EGRID3,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(084),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           TURBULENT KINETIC ENERGY ON ETA SURFACES.
            IF (IGET(011).GT.0) THEN
             IF (LVLS(L,IGET(011)).GT.0) THEN
               ITYPE = LVLS(L,IGET(011))
               CALL NETAL(Q2,ITYPE,L,LMH,EGRID1)
               CALL E2OUT(011,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(011),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C    
C           CLOUD WATER CONTENT
            IF (IGET(124).GT.0) THEN
             IF (LVLS(L,IGET(124)).GT.0) THEN
              DO J=JSTA,JEND
              DO I=1,IM
                IF(CWM(I,J,L).LT.0..AND.CWM(I,J,L).GT.-1.E-10)
     1            CWM(I,J,L)=0.
              ENDDO
              ENDDO
C
              ITYPE = LVLS(L,IGET(124))
              CALL NETAL(CWM,ITYPE,L,LMH,EGRID1)
              CALL NETAL(IW,ITYPE,L,LMH,EGRID2)
C
              DO J=JSTA,JEND
              DO I=1,IM
                EGRID1(I,J)=EGRID1(I,J)*(1.-EGRID2(I,J))
              ENDDO
              ENDDO
C
              CALL E2OUT(124,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
              ID(1:25) = 0
              LYR = L
              IF (ITYPE.GT.1) ID(9) = 109
              CALL OUTPUT(IOUTYP,IGET(124),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           CLOUD ICE CONTENT.
            IF (IGET(125).GT.0) THEN
             IF (LVLS(L,IGET(125)).GT.0) THEN
               ITYPE = LVLS(L,IGET(125))
               CALL NETAL(CWM,ITYPE,L,LMH,EGRID1)
               CALL NETAL(IW,ITYPE,L,LMH,EGRID2)
C
               DO J=JSTA,JEND
               DO I=1,IM
                 EGRID1(I,J)=EGRID1(I,J)*EGRID2(I,J)
               ENDDO
               ENDDO
C
               CALL E2OUT(125,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL OUTPUT(IOUTYP,IGET(125),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           CLOUD FRACTION
C     
            IF (IGET(145).GT.0) THEN
             IF (LVLS(L,IGET(145)).GT.0) THEN
               ITYPE = LVLS(L,IGET(145))
               US=H1                                                           
               CCLIMIT=1.0E-3                                                  
               CLIMIT =1.0E-20                                              
C
               IF(L.EQ.1)THEN
!$omp  parallel do
                 DO J=JSTA,JEND
                 DO I=1,IM
                   EGRID1(I,J)=0.
                 ENDDO
                 ENDDO
                 GO TO 180
               ENDIF
C
!$omp  parallel do
!$omp& private(cwmkl,fiw,hh,lml,pp,qc,qkl,qw,rqkl,tkl,tmt0,
!$omp&         tmt15,u00kl)
               DO J=JSTA,JEND
               DO I=1,IM
                 LML=LM-LMH(I,J)
                 HH=HTM(I,J,L)*HBM2(I,J)
                 TKL=T(I,J,L)    
                 QKL=Q(I,J,L)            
                 CWMKL=CWM(I,J,L)       
                 TMT0=(TKL-273.15)*HH
                 TMT15=AMIN1(TMT0,-15.)*HH     
                 PP=PDSL(I,J)*AETA(L)+PT        
                 QW =HH*PQ0/PP*EXP(HH*A2*(TKL-A3)/(TKL-A4))
                 QI(I,J)=QW *(1.+0.01*AMIN1(TMT0,0.))      
                 QINT(I,J)=QW *(1.-0.0004*TMT15*(TMT15+15.))
                 IF(TMT0.LE.-40.)QINT(I,J)=QI(I,J)           
C
                 U00KL=U00(I,J)+UL(L+LML)*(0.95-U00(I,J))*UTIM
C     -----------THE SATUATION SPECIFIC HUMIDITY---------
                 FIW=IW(I,J,L)  
                 QC =(H1-FIW)*QINT(I,J)+FIW*QI(I,J)   
C     -----------THE RELATIVE HUMIDITY-------------------
                 IF(QC.LE.D00) THEN 
                   RQKL=D00
                 ELSE     
                   RQKL=QKL/QC 
                 ENDIF         
C     -----------CLOUD COVER RATIO (EGRID1)--------------
                 IF(RQKL.GE.0.9999) THEN  
                   EGRID1(I,J)=AMIN1(1.0,RQKL) 
                 ELSE                                                      
                   ARG=-1000.0*CWMKL/(1.-RQKL)
                   ARG=AMAX1(ARG,-12.)
                   EGRID1(I,J)=RQKL*(1.-EXP(ARG))
                 ENDIF      
C
               ENDDO
               ENDDO
  180          CONTINUE
C
               CALL E2OUT(145,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               LYR = L
               IF (ITYPE.GT.1) ID(9) = 109
               CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(145),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           TEMPERATURE TENDENCY DUE TO RADIATIVE FLUX CONVERGENCE
            IF (IGET(140).GT.0) THEN
             IF (LVLS(L,IGET(140)).GT.0) THEN
               NREC1=LM+11+9*(L-1)
               CALL RDRST2D(TTND,IM,JM,LRSTRT,NREC0,NREC1,1,.FALSE.)
               NREC0=NREC1+1
                  ITYPE = LVLS(L,IGET(140))
                  CALL E2OUT(140,000,TTND,EGRID2,
     X                 GRID1,GRID2,IMOUT,JMOUT)
                  ID(1:25) = 0
                  LYR = L
                  IF (ITYPE.GT.1) ID(9) = 109
                  CALL OUTPUT(IOUTYP,IGET(140),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           TEMPERATURE TENDENCY DUE TO SHORT WAVE RADIATION.
            IF (IGET(040).GT.0) THEN
             IF (LVLS(L,IGET(040)).GT.0) THEN
c              NREC1=LM+11+9*(L-1)
c              CALL RDRST2D(TTND,IM,JM,LRSTRT,NREC0,NREC1,1,.FALSE.)
c              NREC0=NREC1+1
                  ITYPE = LVLS(L,IGET(040))
c                 CALL NETAL(TTND,ITYPE,L,LMH,EGRID1)
C      FILLED WILL -H999 FOR NOW
!$omp  parallel do
                  DO J=JSTA,JEND
                  DO I=1,IM
                    EGRID1(I,J) = -H999
                  ENDDO
                  ENDDO
C
                  CALL E2OUT(040,000,EGRID1,EGRID2,
     X                 GRID1,GRID2,IMOUT,JMOUT)
                  ID(1:25) = 0
                  LYR = L
                  IF (ITYPE.GT.1) ID(9) = 109
                  CALL OUTPUT(IOUTYP,IGET(040),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C           TEMPERATURE TENDENCY DUE TO LONG WAVE RADIATION.
            IF (IGET(041).GT.0) THEN
             IF (LVLS(L,IGET(041)).GT.0) THEN
c              NREC1=LM+11+9*(L-1)
c              CALL RDRST2D(TTND,IM,JM,LRSTRT,NREC0,NREC1,1,.FALSE.)
c              NREC0=NREC1+1
                  ITYPE = LVLS(L,IGET(041))
c                 CALL NETAL(TTND,ITYPE,L,LMH,EGRID1)
C      FILLED WILL -H999 FOR NOW
!$omp  parallel do
                  DO J=JSTA,JEND
                  DO I=1,IM
                    EGRID1(I,J)=-H999
                  ENDDO
                  ENDDO
C
                  CALL E2OUT(041,000,EGRID1,EGRID2,
     1                 GRID1,GRID2,IMOUT,JMOUT)
                  ID(1:25) = 0
                  LYR = L
                  IF (ITYPE.GT.1) ID(9) = 109
                  CALL OUTPUT(IOUTYP,IGET(041),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C
C           LATENT HEATING FROM GRID SCALE RAIN/EVAP. (TIME AVE)
            IF (IGET(078).GT.0) THEN
             IF (LVLS(L,IGET(078)).GT.0) THEN
               NREC1=LM+13+9*(L-1)
               CALL RDRST2D(TRAIN,IM,JM,LRSTRT,NREC0,NREC1,1,.FALSE.)
               NREC0=NREC1+1
                ITYPE = LVLS(L,IGET(078))
                IF(AVRAIN.GT.0.)THEN 
                  RRNUM=1./AVRAIN
                ELSE
                  RRNUM=0.
                ENDIF
!$omp  parallel do
                DO J=JSTA,JEND
                DO I=1,IM
                  EGRID1(I,J)=TRAIN(I,J)*RRNUM
                ENDDO
                ENDDO
C
                CALL E2OUT(078,000,EGRID1,EGRID2,
     1               GRID1,GRID2,IMOUT,JMOUT)
                ID(1:25) = 0
C                IFHR       = NTSD/TSPH+0.5
                IFHR       = ITAG
		ITHEAT     = INT(THEAT)
                IFINCR     = MOD(IFHR,ITHEAT)
                ID(19) = IFHR
                ID(20) = 3
                IF (IFINCR.EQ.0) THEN
                   ID(18) = IFHR-ITHEAT
                ELSE
                   ID(18) = IFHR-IFINCR
                ENDIF
                IF (ID(18).LT.0) ID(18) = 0
                LYR = L
                IF (ITYPE.GT.1) ID(9) = 109
                CALL OUTPUT(IOUTYP,IGET(078),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C
C           LATENT HEATING FROM CONVECTION. (TIME AVE)
            IF (IGET(079).GT.0) THEN
             IF (LVLS(L,IGET(079)).GT.0) THEN
               NREC1=LM+14+9*(L-1)
               CALL RDRST2D(TCUCN,IM,JM,LRSTRT,NREC0,NREC1,1,.FALSE.)
               NREC0=NREC1+1
                ITYPE = LVLS(L,IGET(079))
                IF(AVCNVC.GT.0.)THEN
                  RRNUM=1./AVCNVC
                ELSE
                  RRNUM=0.
                ENDIF
!$omp  parallel do
                DO J=JSTA,JEND
                DO I=1,IM
                  EGRID1(I,J) = TCUCN(I,J)*RRNUM
                ENDDO
                ENDDO
C
                CALL E2OUT(079,000,EGRID1,EGRID2,
     1               GRID1,GRID2,IMOUT,JMOUT)
                ID(1:25) = 0
C                IFHR       = NTSD/TSPH+0.5
                IFHR       = ITAG
		ITHEAT     = INT(THEAT)
                IFINCR     = MOD(IFHR,ITHEAT)
                ID(19) = IFHR
                ID(20) = 3
                IF (IFINCR.EQ.0) THEN
                   ID(18) = IFHR-ITHEAT
                ELSE
                   ID(18) = IFHR-IFINCR
                ENDIF
                IF (ID(18).LT.0) ID(18) = 0
                LYR = L
                IF (ITYPE.GT.1) ID(9) = 109
                CALL OUTPUT(IOUTYP,IGET(079),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C        PROCESS NEXT ETA LEVEL.
C
 190     CONTINUE
C
C     END OF ETA SURFACE OUTPUT BLOCK.
C
      ENDIF
C   VISIBILITY
      IF (IGET(180).GT.0) THEN
       RDTPHS= 1./(NPHS*DT)

C            NEED TO CALCULATE RAIN WATER AND SNOW MIXING RATIOS
       DO J=JSTA,JEND
       DO I=1,IM
         IF (PREC(I,J).EQ.0) THEN
           QSNO(I,J)=0.
           QRAIN(I,J)=0.
         ELSE
           LLMH=LMH(I,J)
           SNORATE=SR(I,J)*PREC(I,J)*RDTPHS
           RAINRATE=(1-SR(I,J))*PREC(I,J)*RDTPHS
           TERM1=(T(I,J,LM)/PSLP(I,J))**0.4167
           TERM2=(T(I,J,LLMH)/(PDSL(I,J)*AETA(LMH(I,J))+PT))**0.5833
           TERM3=RAINRATE**0.8333
           QRAIN(I,J)=RAINCON*TERM1*TERM2*TERM3
           TERM4=(T(I,J,LM)/PSLP(I,J))**0.47
           TERM5=(T(I,J,LLMH)/(PDSL(I,J)*AETA(LMH(I,J))+PT))**0.53
           TERM6=SNORATE**0.94
           QSNO(I,J)=SNOCON*TERM4*TERM5*TERM6
         ENDIF
         LLMH=LMH(I,J)
         TT(I,J)=T(I,J,LLMH)
         QV(I,J)=Q(I,J,LLMH)
         QCD(I,J)=(1-IW(I,J,LLMH))*CWM(I,J,LLMH)
         QICE(I,J)=IW(I,J,LLMH)*CWM(I,J,LLMH)
         PPP(I,J)=PDSL(I,J)*AETA(LMH(I,J))+PT
       ENDDO
       ENDDO
c      CALL CALVIS(QV,QCD,QR,QICE,QS,TT,PPP,PRSNOW,METH,IICE,VIS)
       CALL CALVIS(QV,QCD,QRAIN,QICE,QSNO,TT,PPP,VIS)
       CALL E2OUT(180,000,VIS,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
       ID(1:25) = 0
       CALL OUTPUT(IOUTYP,IGET(180),LVLS(1,IGET(180)),
     X           GRID1,IMOUT,JMOUT)
       ENDIF
C
C     
C     ASYMPTOTIC AND FREE ATMOSPHERE MASTER LENGTH SCALE (EL), PLUS
C     GRADIENT RICHARDSON NUMBER.  THESE FIELDS ARE PLACED OUTSIDE
C     THE ABOVE ETA LAYER LOOP SO THAT WE CAN EQUIVALENCE THE 3-D
C     EL ARRAY WITH 3-D ARRAY PMID.  THIS IS DONE TO MAKE THE POST
C     A BIT SMALLER.
C
      IF ( (IGET(111).GT.0) .OR. (IGET(146).GT.0) .OR. 
     X     (IGET(147).GT.0) ) THEN
C     
C        COMPUTE ASYMPTOTIC MASTER LENGTH SCALE.
         CALL CLMAX(DETA,PDSL,HTM,Q2,ZINT,SM,ZINT(1,1,LP1),
     X        LMH,IM,JM,LM,LP1,
     X        EL0,EGRID2,EGRID3,EGRID4,EGRID5)
C     
C        IF REQUESTED, POST ASYMPTOTIC MASTER LENGTH SCALE.
         IF (IGET(147).GT.0) THEN
            CALL E2OUT(147,000,EL0,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(147),LM,GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        IF REQUESTED, POST FREE ATMOSPHERE MASTER LENGTH SCALE
C        AND/OR THE GRADIENT RICHARDSON NUMBER.    
C
         IF ( (IGET(111).GT.0) .OR. (IGET(146).GT.0) ) THEN
C     
C           COMPUTE FREE ATMOSPHERE MASTER LENGTH SCALE.
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              HGT(I,J)=ZINT(I,J,LP1)
            ENDDO
            ENDDO
!$omp  parallel do
            DO L=1,LM
               DO J=JSTA,JEND
               DO I=1,IM
                 EL(I,J,L)=D00
               ENDDO
               ENDDO
            ENDDO
            CALL MIXLEN(ZINT,T,PDSL,AETA,PT,Q2,HGT,HTM,EL0,
     X           LM,LM1,LP1,IM,JM,
     X           EL)
C     
C           COMPUTE GRADIENT RICHARDSON NUMBER IF REQUESTED.
C     
            IF ( (IGET(111).GT.0) ) CALL CALRCH(EL,RICHNO)
C
C           LOOP OVER ETA LAYERS.
            DO 200 L = 1,LM
C     
C              POST MIXING LENGTH.
C
            IF (IGET(146).GT.0) THEN
             IF (LVLS(L,IGET(146)).GT.0) THEN
                  ITYPE = LVLS(L,IGET(146))
                  CALL NETAL(EL,ITYPE,L,LMH,EGRID1)
                  CALL E2OUT(146,000,EGRID1,EGRID2,
     X                 GRID1,GRID2,IMOUT,JMOUT)
                  ID(1:25) = 0
                  LYR = L
                  IF (ITYPE.GT.1) ID(9) = 109
                  CALL OUTPUT(IOUTYP,IGET(146),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C              POST GRADIENT RICHARDSON NUMBER.
C
            IF (IGET(111).GT.0) THEN
             IF (LVLS(L,IGET(111)).GT.0) THEN
                  ITYPE = LVLS(L,IGET(111))
                  CALL NETAL(RICHNO,ITYPE,L,LMH,EGRID1)
                  CALL E2OUT(111,000,EGRID1,EGRID2,
     X                 GRID1,GRID2,IMOUT,JMOUT)
                  ID(1:25) = 0
                  LYR = L
                  IF (ITYPE.GT.1) ID(9) = 109
                  CALL OUTPUT(IOUTYP,IGET(111),LYR,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
 200        CONTINUE
C
         ENDIF
      ENDIF
C     
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE NGMFLD2(RH4710,RH4796,RH1847,RH8498,QM8510)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    NGMFLD2     COMPUTES LAYER MEAN NGM FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES A HANDFUL OF NGM LAYER MEAN 
C     FIELDS.  THIS IS DONE TO PROVIDE A FULLY COMPLETE 
C     ETA NGM LOOK-ALIKE OUTPUT FILE.  THE SIGMA (LAYER)
C     FIELDS COMPUTED BY THIS ROUTINE ARE TABULATED BELOW.
C     
C           SIGMA (LAYER)         FIELD(S)
C          ---------------     --------------
C          0.47191-1.00000          RH
C          0.47171-0.96470          RH
C          0.18019-0.47191          RH
C          0.84368-0.98230          RH
C          0.85000-1.00000         MCONV
C     WHERE 
C          RH    = RELATIVE HUMIDITY
C          MCONV = MOISTURE CONVERGENCE
C
C     LAYER MEANS ARE A SUMMATION OVER ETA LAYERS MAPPING INTO
C     THE PRESSURE RANGE CORRESPONDING TO THE SIGMA RANGE ABOVE.
C     THE CALCULATION OF THESE BOUNDING PRESSURES IS DONE AT 
C     EACH HORIZONTAL GRID POINT BASED ON THE SURFACE PRESSURE.
C     EACH TERM IN THE SUMMATION IS WEIGHTED BY THE THICKNESS OF
C     THE ETA LAYER.  THE FINAL LAYER MEAN IS THIS SUM NORMALIZED
C     BY THE TOTAL DEPTH OF THE LAYER.

C
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   93-07-27  RUSS TREADON - MODIFIED SUMMATION LIMITS FROM
C                            0.66*PSFC TO 0.75*PSFC AND 0.33*PSFC 
C                            TO 0.50*PSFC, WHERE PSFC IS THE
C                            SURFACES PRESSURE.  THE REASON FOR
C                            THIS CHANGE WAS RECOGNITION THAT IN 
C                            THE LFM 0.33 AND 0.66 WERE MEASURED
C                            FROM THE SURFACE TO THE TROPOPAUSE,
C                            NOT THE TOP OF THE MODEL.
C   93-09-13  RUSS TREADON - RH CALCULATIONS WERE MADE INTERNAL
C                            TO THE ROUTINE.
C   98-06-16  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-18  MIKE BALDWIN - COMPUTE RH OVER ICE
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C     
C USAGE:    CALL NGMFLD2(RH4710,RH4796,RH1847,RH8498,QM8510)
C   INPUT ARGUMENT LIST:
C     NONE
C
C   OUTPUT ARGUMENT LIST: 
C     RH4710   - SIGMA LAYER 0.47-1.00 MEAN RELATIVE HUMIDITY.
C     RH4796   - SIGMA LAYER 0.47-0.96 MEAN RELATIVE HUMIDITY.
C     RH1847   - SIGMA LAYER 0.18-0.47 MEAN RELATIVE HUMIDITY.
C     RH8498   - SIGMA LAYER 0.84-0.98 MEAN RELATIVE HUMIDITY.
C     QM8510   - SIGMA LAYER 0.85-1.00 MEAN MOISTURE CONVERGENCE.
C     
C   OUTPUT FILES:
C     NONE
C     
C   LIBRARY:
C     COMMON   - VRBLS
C                MASKS
C                EXTRA
C                OPTIONS
C                LOOPS
C                MAPOT
C                DYNAMD
C                INDX
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE PARAMETERS
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C
      PARAMETER (SIG100=1.00000, SIG98=0.98230, SIG96=0.96470)
      PARAMETER (SIG89 =0.89671, SIG85=0.85000, SIG84=0.84368)
      PARAMETER (SIG78 =0.78483, SIG47=0.47191, SIG18=0.18018)
      PARAMETER (SMALL = 1.E-6)
C     
C     DECLARE VARIABLES.
      LOGICAL GOT8510,GOT4710,GOT4796,GOT1847,GOT8498
      LOGICAL OLDRD, STDRD
      REAL QM8510(IM,JM),RH4710(IM,JM),RH8498(IM,JM)
      REAL RH4796(IM,JM),RH1847(IM,JM),IWL(IM,JM),IWM1
      REAL Z8510(IM,JM),Z4710(IM,JM),Z8498(IM,JM)
      REAL Z4796(IM,JM),Z1847(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "DYNAMD.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C
C********************************************************************
C     START NGMFLD HERE.
C     
      CLIMIT =1.0E-20
C
C     INITIALIZE ARRAYS.
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
         QM8510(I,J) = D00
         RH4710(I,J) = D00
         RH8498(I,J) = D00
         RH4796(I,J) = D00
         RH1847(I,J) = D00
         Z8510(I,J)  = D00
         Z8498(I,J)  = D00
         Z4710(I,J)  = D00
         Z4796(I,J)  = D00
         Z1847(I,J)  = D00
         IWL  (I,J)  = D00
      ENDDO
      ENDDO
C     
C     LOOP OVER HORIZONTAL GRID.
C     
!$omp  parallel do
!$omp& private(ai,bi,dz,ie,iw,iwl,iwm1,p100,p18,p47,p84,p85,
!$omp&         p96,p98,pm,qdiv,qi,qint,qk,qkhn,qkhs,qkm1,qm,qm8510,
!$omp&         qmcvg,qs,qudx,qvdy,qw,r2dx,r2dy,rh,rh1847,rh4710,
!$omp&         rh4796,rh8498,tm,tmt0,tmt15,z1847,z4710,z4796,
!$omp&         z8498,z8510)
      DO L=1,LM
      CALL EXCH2(Q(1,1,L))
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
C
C        SET TARGET PRESSURES.
         P100  = SIG100*(PD(I,J)+PT)
         P98   = SIG98*(PD(I,J)+PT)
         P96   = SIG96*(PD(I,J)+PT)
         P85   = SIG85*(PD(I,J)+PT)
         P84   = SIG84*(PD(I,J)+PT)
         P47   = SIG47*(PD(I,J)+PT)
         P18   = SIG18*(PD(I,J)+PT)
C     
C     
C        COMPUTE LAYER MEAN FIELDS AT THE GIVEN K.
C
C          COMPUTE P, Z, T, AND Q AT THE MIDPOINT OF THE CURRENT ETA LAYER.
           ALPM = D50*(ALPINT(I,J,L)+ALPINT(I,J,L+1))
           DZ   = ZINT(I,J,L)-ZINT(I,J,L+1)
           PM   = EXP(ALPM)
           TM   = T(I,J,L)
           QM   = Q(I,J,L)
           QM   = AMAX1(QM,H1M12)
C
           IWM1=IWL(I,J)
           IF(CWM(I,J,L).GT.CLIMIT) THEN
             IF(TM.LT.258.15)THEN
               IWL(I,J)=1.
             ELSEIF(TM.GE.273.15)THEN
               IWL(I,J)=0.
             ELSE
               IF(IWM1.EQ.1.0)IWL(I,J)=1.
             ENDIF
           ELSE
             IWL(I,J)=0.
           ENDIF
C
C     
C          COMPUTE RELATIVE HUMIDITY.
C
           TMT0=TM-273.16
           TMT15=AMIN1(TMT0,-15.)
           AI=0.008855
           BI=1.
           IF(TMT0.LT.-20.)THEN
             AI=0.007225
             BI=0.9674
           ENDIF
           QW=PQ0/PM
     1          *EXP(A2*(TM-A3)/(TM-A4))
           QI=QW*(BI+AI*AMIN1(TMT0,0.))
           QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
           IF(TMT0.LT.-15.)THEN
               QS=QI
           ELSEIF(TMT0.GE.0.)THEN
               QS=QINT
           ELSE
             IF(IWL(I,J).GT.0.0) THEN
               QS=QI
             ELSE
               QS=QINT
             ENDIF
           ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
            QS=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT

C
           RH   = QM/QS
           IF (RH.GT.H1) THEN
              RH = H1
              QM = RH*QS
           ENDIF
           IF (RH.LT.D01) THEN
              RH = D01
              QM = RH*QS
           ENDIF
C
C          COMPUTE MOISTURE CONVERGENCE.  WE NEED Q AT V POINTS.
           QMCVG = D00
           IE=I+IHE(J)
           IW=I+IHW(J)
           QK=D25*(Q(I+1,J,L)+Q(I,J,L)+Q(IE,J+1,L)+Q(IE,J-1,L))
           QKM1=D25*(Q(I,J,L)+Q(I-1,J,L)+Q(IW,J+1,L)+Q(IW,J-1,L))
           QKHN=D25*(Q(IW,J+1,L)+Q(IE,J+1,L)+Q(I,J+2,L)+Q(I,J,L))
           QKHS=D25*(Q(IW,J-1,L)+Q(IE,J-1,L)+Q(I,J,L)+Q(I,J-2,L))
           R2DX =1./(2.*DX(I,J))
           R2DY =1./(2.*DY)
           QUDX =(QK*U(IE,J,L)-QKM1*U(IW,J,L))*R2DX
           QVDY =(QKHN*V(I,J+1,L)-QKHS*V(I,J-1,L))*R2DY
           QDIV =QUDX+QVDY
           QMCVG=-1.*QDIV*HBM2(I,J)
C     
C          SIGMA 0.85-1.00 MOISTURE CONVERGENCE.
           IF ((PM.LE.P100).AND.(PM.GE.P85)) THEN
              Z8510(I,J)  = Z8510(I,J) + DZ
              QM8510(I,J) = QM8510(I,J) + QMCVG*DZ
           ENDIF
C    
C          SIGMA 0.47-1.00 RELATIVE HUMIDITY.
           IF ((PM.LE.P100).AND.(PM.GE.P47)) THEN
              Z4710(I,J)  = Z4710(I,J) + DZ
              RH4710(I,J) = RH4710(I,J) + RH*DZ
           ENDIF
C
C          SIGMA 0.84-0.98 RELATIVE HUMIDITY.
           IF ((PM.LE.P98).AND.(PM.GE.P84)) THEN
              Z8498(I,J)  = Z8498(I,J) + DZ
              RH8498(I,J) = RH8498(I,J) + RH*DZ
           ENDIF
C     
C          SIGMA 0.47-0.96 RELATIVE HUMIDITY.
           IF ((PM.LE.P96).AND.(PM.GE.P47)) THEN
              Z4796(I,J)  = Z4796(I,J) + DZ
              RH4796(I,J) = RH4796(I,J) + RH*DZ
           ENDIF
C     
C          SIGMA 0.18-0.47 RELATIVE HUMIDITY.
           IF ((PM.LE.P47).AND.(PM.GE.P18)) THEN
              Z1847(I,J)  = Z1847(I,J) + DZ
              RH1847(I,J) = RH1847(I,J) + RH*DZ
           ENDIF
C
      ENDDO
      ENDDO
      ENDDO
C     
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
C        NORMALIZE TO GET LAYER MEAN VALUES.
         IF (Z8510(I,J).GT.0) THEN
            QM8510(I,J) = QM8510(I,J)/Z8510(I,J)
         ELSE
            QM8510(I,J) = SPVAL
         ENDIF
         IF (ABS(QM8510(I,J)-SPVAL).LT.SMALL)QM8510(I,J)=H1M12
C
         IF (Z4710(I,J).GT.0) THEN
            RH4710(I,J) = RH4710(I,J)/Z4710(I,J)
         ELSE
            RH4710(I,J) = SPVAL
         ENDIF
C
         IF (Z8498(I,J).GT.0) THEN
            RH8498(I,J) = RH8498(I,J)/Z8498(I,J)
         ELSE
            RH8498(I,J) = SPVAL
         ENDIF
C
         IF (Z4796(I,J).GT.0) THEN
            RH4796(I,J) = RH4796(I,J)/Z4796(I,J)
         ELSE
            RH4796(I,J) = SPVAL
         ENDIF
C
         IF (Z1847(I,J).GT.0) THEN
            RH1847(I,J) = RH1847(I,J)/Z1847(I,J)
         ELSE
            RH1847(I,J) = SPVAL
         ENDIF
      ENDDO
      ENDDO
C
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE CALDRG(DRAGCO)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALDRG      COMPUTE DRAG COEFFICIENT
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-09-01
C     
C ABSTRACT:  THIS ROUTINE COMPUTES A SURFACE LAYER DRAG
C   COEFFICIENT USING EQUATION (7.4.1A) IN "AN INTRODUCTION
C   TO BOUNDARY LAYER METEOROLOGY" BY STULL (1988, KLUWER
C   ACADEMIC PUBLISHERS).
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-09-01  RUSS TREADON
C   98-06-15  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION           
C     
C USAGE:    CALL CALDRG(DRAGCO)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     DRAGCO   - SURFACE LAYER DRAG COEFFICIENT
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LOOPS
C                  VRBLS
C                  SRFDSP
C                  PVRBLS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     INCLUDE/SET PARAMETERS.
C     
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C     
C     DECLARE VARIABLES.
      REAL DRAGCO(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
C     
      INCLUDE "LOOPS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "SRFDSP.comm"
      INCLUDE "PVRBLS.comm"
C      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C********************************************************************
C     START CALDRG HERE.
C     
C     INITIALIZE DRAG COEFFICIENT ARRAY TO ZERO.
C     
      DO J=JSTA,JEND
      DO I=1,IM
        DRAGCO(I,J) = D00
      ENDDO
      ENDDO
C     
C     COMPUTE A SURFACE LAYER DRAG COEFFICIENT.
C
      CALL EXCH(UZ0)
      CALL EXCH(VZ0)
C
C     ASSUMET THAT U AND V HAVE HALOS
C   
      doout30: DO J=JSTA_M,JEND_M
      doin30: DO I=2,IM-1
C     
C        COMPUTE A MEAN MASS POINT WIND IN THE 
C        FIRST ATMOSPHERIC ETA LAYER.
C
      LMHK=LMH(I,J)
      IE=I+IHE(J)
      IW=I+IHW(J)
      SUMU=U(IE,J,LMV(IE,J))+U(IW,J,LMV(IW,J))+U(I,J-1,LMV(I,J-1)) 
     1    +U(I,J+1,LMV(I,J+1))
      SUMV=V(IE,J,LMV(IE,J))+V(IW,J,LMV(IW,J))+V(I,J-1,LMV(I,J-1)) 
     1    +V(I,J+1,LMV(I,J+1))
      ULMH=D25*SUMU
      VLMH=D25*SUMV
C     
C        COMPUTE A MEAN MASS POINT WIND AT HEIGHT Z0.
C
      UZ0H=D25*(UZ0(IE,J)+UZ0(IW,J)+UZ0(I,J-1)+UZ0(I,J+1))
      VZ0H=D25*(VZ0(IE,J)+VZ0(IW,J)+VZ0(I,J-1)+VZ0(I,J+1))
C     
C        COMPUTE A MEAN MASS POINT WIND SPEED BETWEEN THE
C        FIRST ATMOSPHERIC ETA LAYER AND Z0.
C
      UBAR=D50*(ULMH+UZ0H)
      VBAR=D50*(VLMH+VZ0H)
      WSPDSQ=UBAR*UBAR+VBAR*VBAR
C     
C        COMPUTE A DRAG COEFFICIENT.
C
      USTRSQ=USTAR(I,J)*USTAR(I,J)
      DRAGCO(I,J)=USTRSQ/WSPDSQ
C
      END DO doin30
      END DO doout30
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE EUVGUV(U,V,VTLON,IMT,JMT,EVLAT,EVLON,
     1     ALATVT,ALVTOT,NRTHOT,PROJ)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    EUVGUV      
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE CONVERTS (ROTATES) U-V WIND COMPONENTS
C     ON THE ETA E-GRID TO U-V WIND COMPONENTS ON THE
C     SPECIFIED OUTPUT GRID.  IT ONLY DOES THE ROTATION,
C     NOT THE INTERPOLATION.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  ???
C   92-12-23  RUSS TREADON - ADDED COMMENTS AND GENERALIZED
C                            CODE TO HANDLE VARIABLE OUTPUT GRIDS.
C   93-06-13  RUSS TREADON - GENERALIZED ROUTINE TO HANDLE BOTH
C                            POLAR STEREOGRAPHIC AND LAT-LON 
C                            PROJECTIONS.
C     
C USAGE:    CALL EUVGUV(U,V,VTLON,IMT,JMT,EVLAT,EVLON,
C              ALVTOT,NRTHOT,PROJ)
C   INPUT ARGUMENT LIST:
C     U        - U WIND ON FILLED E-GRID
C     V        - V WIND ON FILLED E-GRID
C     VTLON    - V POINT LONGITUDES ON FILLED E-GRID
C     IMT      - FIRST DIMENSION OF FILLED E-GRID
C     JMT      - SECOND DIMENSION OF FILLED E-GRID
C     EVLAT    - FILLED E-GRID TRANSFORMED LATITUDES
C     EVLON    - FILLED E-GRID TRANSFORMED LONGITUDES
C     ALVTOT   - ROTATION LONGITUDE OF OUTPUT GRID
C     NRTHOT   - N/S HEMISPHERE LOGICAL SWITCH FOR OUTPUT GRID
C     PROJ     - OUTPUT GRID PROJECTION.
C
C   OUTPUT ARGUMENT LIST: 
C     U        - U WIND ROTATED TO OUTPUT GRID.
C     V        - V WIND ROTATED TO OUTPUT GRID.
C     
C   OUTPUT FILES:
C       NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EGRID
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE ETA MODEL DIMENSIONS.
C---------------------------------------------------------------
      INCLUDE "parmeta"
C---------------------------------------------------------------
      PARAMETER (LP1=LM+1)
C---------------------------------------------------------------
C     
C     DECLARE VARIABLES.
      LOGICAL NORTH, NRTHOT
      CHARACTER*6 PROJ
      REAL ALONVT, DLAM, DPHI, LAM0, PHI0, POLEI
      REAL POLEJ, SINPH0, TANPH0, WLONC, XMESHL
      REAL YLATC
      REAL U(IMT,JMT),V(IMT,JMT),VTLON(IMT,JMT)
      REAL EVLAT(IMT,JMT), EVLON(IMT,JMT)
C---------------------------------------------------------------
      INCLUDE "EGRID.comm"
      INCLUDE "IOUNIT.comm"
C---------------------------------------------------------------
      EQUIVALENCE (YLATC,ALONVT), (DPHI, POLEI)
      EQUIVALENCE (WLONC, POLEJ), (DLAM,XMESHL)
C---------------------------------------------------------------
      DATA CONV2R/0.017453293/,CONV2D/57.2958/
      DATA EARTHR/6371.2/
C     
C**************************************************************
C     START EUVGUV HERE.
C     
C     CASE I:  ROTATE FROM E-GRID TO POLAR STEREOGRAPHIC GRID.
C     
      IF (INDEX(PROJ,'POLA').NE.0) THEN
         SPHI0 = SINPH0
!$omp  parallel do
!$omp& private(a,alpha,arg,cosa,elat,elon,sina,ue,ve)
         doout10: DO J = 1, JMT
         doin10: DO I = 1, IMT
            ELAT = EVLAT(I,J)
            ELON = EVLON(I,J)
            ARG = SPHI0*SIN(VTLON(I,J)*CONV2R) /
     1           COS(ELAT*CONV2R)
            IF(ABS(ARG).GT.1.0) ARG = SIGN(1.0,ARG)  
            ALPHA = ASIN(ARG)
            COSA = COS(ALPHA)
            SINA = SIN(ALPHA)
            UE   = U(I,J)*COSA+V(I,J)*SINA
            VE   = V(I,J)*COSA-U(I,J)*SINA
            A    = (ELON-ALVTOT)*CONV2R
            SINA = SIN(A)
            COSA = COS(A)
            IF (.NOT.NRTHOT) COSA = -COSA
            U(I,J) =  UE*COSA+VE*SINA
            V(I,J) = -UE*SINA+VE*COSA
         END DO doin10
         END DO doout10
C     
C     CASE II:  ROTATE FROM E-GRID TO LATITUDE-LONGITUDE GRID.
C        THE BELOW CODE IS FROM THE PROFILE OUTPUT CODE IN
C        SUBROUTINE OUTMAP OR EQUALLY SUBOMG.  NOTE THAT ELON
C        AND WLONC ARE BOTH IN DEGREES WEST.  WE WANT THE DIFFERENCE
C        IN DEGREES BETWEEN THE TWO.  WHAT MATTERS IS THAT ELON AND
C        WLONC ARE EITHER BOTH IN DEGREES EAST OR WEST.
C
      ELSEIF (INDEX(PROJ,'LOLA').NE.0) THEN
!$omp  parallel do
!$omp& private(alpha,arg,cosalp,dlm,elat,elon,sinalp,tlon,ue,ve,xx,yy)
         doout20: DO J = 1,JMT
         doin20: DO I = 1,IMT
            ELAT   =  EVLAT(I,J)
            ELON   =  EVLON(I,J)
            DLM    =  ELON-WLONC
            XX     =  COSPH0*COS(ELAT*CONV2R)*COS(DLM*CONV2R)+
     X                SINPH0*SIN(ELAT*CONV2R)
            YY     = -COS(ELAT*CONV2R)*SIN(DLM*CONV2R)
            TLON   = ATAN(YY/XX)
	    ARG = SINPH0*SIN(TLON)/COS(ELAT*CONV2R)
	    IF(ABS(ARG).GT.1.0) ARG = SIGN(1.0,ARG)  
            ALPHA  = ASIN(ARG)
            SINALP = SIN(ALPHA)
            COSALP = COS(ALPHA)
            UE     = U(I,J)
            VE     = V(I,J)
            U(I,J) = UE*COSALP+VE*SINALP
            V(I,J) = VE*COSALP-UE*SINALP
         END DO doin20
         END DO doout20
C
C     CASE III.  ROTATE FROM E-GRID TO LAMBERT CONFORMAL GRID.
C
      ELSEIF (INDEX(PROJ,'LMBC').NE.0) THEN
         SPHI0 = SINPH0
!$omp  parallel do
!$omp& private(a,alpha,arg,cone,cosa,elat,elon,sina,ue,ve)
         doout30: DO J = 1, JMT
         doin30: DO I = 1, IMT
            ELAT = EVLAT(I,J)
            ELON = EVLON(I,J)
	    ARG = SPHI0*SIN(VTLON(I,J)*CONV2R) /
     X           COS(ELAT*CONV2R)
	    IF(ABS(ARG).GT.1.0) ARG = SIGN(1.0,ARG)  
            ALPHA = ASIN(ARG)
            COSA = COS(ALPHA)
            SINA = SIN(ALPHA)
            UE   = U(I,J)*COSA+V(I,J)*SINA
            VE   = V(I,J)*COSA-U(I,J)*SINA
            CONE = SIN(ALATVT*CONV2R)
            A    = CONE*(ELON-ALVTOT)*CONV2R
            SINA = SIN(A)
            COSA = COS(A)
            IF (.NOT.NRTHOT) COSA = -COSA
            U(I,J) =  UE*COSA+VE*SINA
            V(I,J) = -UE*SINA+VE*COSA
         END DO doin30
         END DO doout30
C     
C     CASE IV.  OUTPUT WINDS ON ETA E_GRID.  DO NOTHING CASE.
      ELSE
         CONTINUE
C
      ENDIF
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE FDLVL(ITYPE,TFD,UFD,VFD)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    FDLVL       COMPUTES FD LEVEL T, U, V
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES TEMPERATURE, U WIND COMPONENT,
C     AND V WIND COMPONENT ON THE NFD=6 FD LEVELS.  THE
C     HEIGHT OF THESE LEVELS (IN METERS) IS GIVEN IN THE 
C     DATA STATEMENT BELOW.  THE ALGORITHM PROCEEDS AS 
C     FOLLOWS. (AGL IN PARENTHESES)
C     
C     AT EACH MASS POINT MOVE UP VERTICALLY FROM THE LM-TH (LOWEST
C     ATMOSPHERIC) ETA LAYER.  FIND THE ETA LAYERS WHOSE 
C     HEIGHT (ABOVE GROUND) BOUNDS THE TARGET FD LEVEL HEIGHT.
C     VERTICALLY INTERPOLATE TO GET TEMPERATURE AT THIS FD
C     LEVEL.  AVERAGE THE FOUR SURROUNDING WINDS
C     TO GET A MASS POINT WIND.  VERTICALLY INTERPOLATE THESE
C     MASS POINT WINDS TO THE TARGET FD LEVEL.  CONTINUE THIS
C     PROCESS UNTIL ALL NFD=6 FD LEVELS HAVE BEEN PROCESSED.
C     MOVE ON TO THE NEXT MASS POINT.  
C     
C     AVERAGING THE FOUR ABOVE GROUND WINDS TO THE MASS POINT
C     WAS FOUND TO SMOOTH THE FIELD AND REDUCE THE OCCURRENCE
C     OF POINT PEAK WINDS FAR IN EXCESS OF THE WINDS AT 
C     ADJACENT POINTS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   93-11-23  RUSS TREADON - CORRECTED ROUTINE TO COMPUTE
C             FD LEVELS WITH REPECT TO MEAN SEA LEVEL.
C   94-01-04  MICHAEL BALDWIN - INCLUDE OPTIONS FOR COMPUTING
C                               EITHER AGL OR MSL
C   98-06-15  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION            
C     
C USAGE:    CALL FDLVL(ITYPE,TFD,UFD,VFD)
C   INPUT ARGUMENT LIST:
C     ITYPE    - FLAG THAT DETERMINES WHETHER MSL (1) OR AGL (2)
C                   LEVELS ARE USED.
C
C   OUTPUT ARGUMENT LIST: 
C     TFD      - TEMPERATURE (K) ON FD LEVELS.
C     UFD      - U WIND (M/S) ON FD LEVELS.
C     VFD      - V WIND (M/S) ON FD LEVELS.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       H2V
C
C     LIBRARY:
C       COMMON   - VRBLS
C                  LOOPS
C                  EXTRA
C                  MASKS
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C
C     
C     SET NUMBER OF FD LEVELS.
      USE INDX_MOD
      PARAMETER (NFD=6)
C     
C     INCLUDE PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
C     
C     DECLARE VARIABLES
C     
      INTEGER LVL(NFD)
      REAL DZABV(NFD), HTFD(NFD)
      REAL TFD(IM,JM,NFD),UFD(IM,JM,NFD)
      REAL VFD(IM,JM,NFD),EGRIDU(IM,JM,NFD),EGRIDV(IM,JM,NFD)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C
C     SET FD LEVEL HEIGHTS IN METERS.
      DATA HTFD  / 914.E0,1524.E0,1829.E0,
     X     2134.E0,2743.E0,3658.E0/
C     
C****************************************************************
C     START FDLVL HERE
C     
C     INITIALIZE ARRAYS.
C     
!$omp  parallel do
      DO 10 IFD = 1,NFD
      DO J=JSTA,JEND
      DO I=1,IM
         TFD(I,J,IFD)    = SPVAL
         UFD(I,J,IFD)    = SPVAL
         VFD(I,J,IFD)    = SPVAL
         EGRIDU(I,J,IFD) = D00
         EGRIDV(I,J,IFD) = D00
      ENDDO
      ENDDO
 10   CONTINUE
C
C     MSL FD LEVELS
C
      IF (ITYPE.EQ.1) THEN
C     
C     LOOP OVER HORIZONTAL GRID.
C
C     ASSUME THAT U, V, T, AND LMV HAVE UPDATED HALOS
C     
      doout50: DO J=JSTA_M,JEND_M
      doin50: DO I=2,IM-1
         IFD = 1
C     
C        LOCATE VERTICAL INDICES OF T,U,V, LEVEL JUST 
C        ABOVE EACH FD LEVEL.
C
         DO 20 L = LM,1,-1
            HTTUV = D50*(ZINT(I,J,L)+ZINT(I,J,L+1))
            IF (HTTUV.GT.HTFD(IFD)) THEN
               LVL(IFD)   = L
               DZABV(IFD) = HTTUV-HTFD(IFD)
               IFD        = IFD + 1
               IF (IFD.GT.NFD) GOTO 30
            ENDIF
 20         CONTINUE
C     
C        COMPUTE T, U, AND V AT FD LEVELS.
C
 30      CONTINUE
C
         IE=I+IHE(J)         
         IW=I+IHW(J)         
         DO 40 IFD = 1,NFD
            L = LVL(IFD)
            IF (L.LT.LM) THEN
               DZ   = D50*(ZINT(I,J,L)-ZINT(I,J,L+2))
               RDZ  = 1./DZ
               DELT = T(I,J,L)-T(I,J,L+1)
               UH=0.25*(U(IE,J,L)+U(IW,J,L)
     1                 +U(I,J+1,L)+U(I,J-1,L))
               VH=0.25*(V(IE,J,L)+V(IW,J,L)
     1                 +V(I,J+1,L)+V(I,J-1,L))
               UL=0.25*(U(IE,J,L+1)+U(IW,J,L+1)
     1                 +U(I,J+1,L+1)+U(I,J-1,L+1))
               VL=0.25*(V(IE,J,L+1)+V(IW,J,L+1)
     1                 +V(I,J+1,L+1)+V(I,J-1,L+1))
C
               DELU = UH - UL
               DELV = VH - VL
               TFD(I,J,IFD) = T(I,J,L) - DELT*RDZ*DZABV(IFD)
               EGRIDU(I,J,IFD) = UH  - DELU*RDZ*DZABV(IFD)
               EGRIDV(I,J,IFD) = VH  - DELV*RDZ*DZABV(IFD)
            ELSE
               TFD(I,J,IFD) = T(I,J,L)
               EGRIDU(I,J,IFD)=0.25*(U(IE,J,L)+U(IW,J,L)
     1                              +U(I,J+1,L)+U(I,J-1,L))
               EGRIDV(I,J,IFD)=0.25*(V(IE,J,L)+V(IW,J,L)
     1                              +V(I,J+1,L)+V(I,J-1,L))
            ENDIF
 40      CONTINUE
C     
C     COMPUTE FD LEVEL T, U, AND V AT NEXT K.
C
      END DO doin50
      END DO doout50
C     END OF MSL FD LEVELS
      ELSE
C
C     AGL FD LEVELS 
C
C     
C     LOOP OVER HORIZONTAL GRID.
C     
      doout250: DO J=JSTA_M,JEND_M
      doin250: DO I=2,IM-1
         HTSFC = FIS(I,J)*GI
         LLMH  = LMH(I,J)
         IFD   = 1
C     
C        LOCATE VERTICAL INDICES OF T,U,V, LEVEL JUST 
C        ABOVE EACH FD LEVEL.
C
         DO 220 L = LLMH,1,-1
            HTTUV = D50*(ZINT(I,J,L)+ZINT(I,J,L+1))
            HTABV = HTTUV-HTSFC
            IF (HTABV.GT.HTFD(IFD)) THEN
               LVL(IFD)   = L
               DZABV(IFD) = HTABV-HTFD(IFD)
               IFD        = IFD + 1
               IF (IFD.GT.NFD) GOTO 230
            ENDIF
 220        CONTINUE
C     
C        COMPUTE T, U, AND V AT FD LEVELS.
C
 230     CONTINUE
C
         IE=I+IHE(J)       
         IW=I+IHW(J)       
         DO 240 IFD = 1,NFD
            L = LVL(IFD)
            IF (L.LT.LM) THEN
               DZ   = D50*(ZINT(I,J,L)-ZINT(I,J,L+2))
               RDZ  = 1./DZ
               DELT = T(I,J,L)-T(I,J,L+1)
C
               LOFF = L-LLMH
               UH=0.25*(U(IE,J,LMV(IE,J)+LOFF)+U(IW,J,LMV(IW,J)+LOFF)
     1             +U(I,J+1,LMV(I,J+1)+LOFF)+U(I,J-1,LMV(I,J-1)+LOFF))
               VH=0.25*(V(IE,J,LMV(IE,J)+LOFF)+V(IW,J,LMV(IW,J)+LOFF)
     1             +V(I,J+1,LMV(I,J+1)+LOFF)+V(I,J-1,LMV(I,J-1)+LOFF))
               
               LOFF   = L+1-LLMH
               UL=0.25*(U(IW,J,LMV(IW,J)+LOFF)+U(IE,J,LMV(IE,J)+LOFF)
     1             +U(I,J+1,LMV(I,J+1)+LOFF)+U(I,J-1,LMV(I,J-1)+LOFF))
               VL=0.25*(V(IW,J,LMV(IW,J)+LOFF)+V(IE,J,LMV(IE,J)+LOFF)
     1             +V(I,J+1,LMV(I,J+1)+LOFF)+V(I,J-1,LMV(I,J-1)+LOFF))
C
               DELU = UH - UL
               DELV = VH - VL
               TFD(I,J,IFD) = T(I,J,L) - DELT*RDZ*DZABV(IFD)
               EGRIDU(I,J,IFD) = UH  - DELU*RDZ*DZABV(IFD)
               EGRIDV(I,J,IFD) = VH  - DELV*RDZ*DZABV(IFD)
            ELSE
               TFD(I,J,IFD) = T(I,J,L)
               LOFF   = L-LLMH
               UH=0.25*(U(IE,J,LMV(IE,J)+LOFF)+U(IW,J,LMV(IW,J)+LOFF)
     1             +U(I,J+1,LMV(I,J+1)+LOFF)+U(I,J-1,LMV(I,J-1)+LOFF))
               VH=0.25*(V(IE,J,LMV(IE,J)+LOFF)+V(IW,J,LMV(IW,J)+LOFF)
     1             +V(I,J+1,LMV(I,J+1)+LOFF)+V(I,J-1,LMV(I,J-1)+LOFF))
               EGRIDU(I,J,IFD) = UH
               EGRIDV(I,J,IFD) = VH
            ENDIF
 240     CONTINUE
C     
C     COMPUTE FD LEVEL T, U, AND V AT NEXT K.
C
      END DO doin250
      END DO doout250
C     END OF AGL FD LEVELS
      ENDIF
C
C     LOOP TO COMPUTE U-V AT VELOCITY POINTS.
C
      DO IFD = 1,NFD
         CALL H2V(EGRIDU(1,1,IFD),EGRIDV(1,1,IFD),
     X        UFD(1,1,IFD),VFD(1,1,IFD))
      END DO
C
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE FILLV(ARR1,ARR2,IFLAG,IDIM,JDIM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    FILLV       FILL V POINTS ON E-GRID H FIELD
C   PRGRMMR: BLACK           ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE FILLS VELOCITY (V) POINTS ON A MASS
C     POINT E-GRID.  PASSED VARIABLE IFLAG TELLS THE ROUTINE
C     WHAT TO DO WITH NEGATIVE VALUES OBTAINED DURING THE
C     FILLING PROCESS
C        IFLAG=0, TAKE WHATEVER THE INTERPOLATION GIVES.
C        IFLAG=1, TRUNCATE AT ZERO.
C        IFLAG=2, TRUNCATE AT A VERY SMALL POSITIVE VALUE (EPS).
C     THE INTERPOLATION CAN USE A BILINEAR SCHEME OR CUBIC
C     INTERPOLATING POLYMONIALS.  PARAMETERS WGTCUB AND WGTLIN
C     CONTROL THIS OPTION.  SETTING WGTCUB TO 1.0 ACTIVATES
C     INTERPOLATION USING CUBIC INTERPOLATING POLYNOMIALS.
C     SETTING WGTCUB TO 0.0 ACTIVATES BILINEAR INTERPOLATION.
C
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  BLACK - ORIGINATOR
C   93-12-23  RUSS TREADON - ADDED COMMENTS AND VARIABLE
C                            GRID DIMENSIONS TO 
C                            SUBROUTINE CALL.
C   98-06-04  BLACK - CONVERSION TO 2-D
C     
C USAGE:    CALL FILLV(ARR1,ARR2,IFLAG,IDIM,JDIM)
C   INPUT ARGUMENT LIST:
C     ARR2     - VELOCITY POINT DATA ON STAGGERED E-GRID.
C     IFLAG    - 
C     IDIM     - FIRST DIMENSION OF FILLED E-GRID.
C     JDIM     - SECOND DIMENSION OF FILLED E-GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     ARR1     - VELOCITY POINT DATA ON FILLED E-GRID.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       EFILL - FILL MISSING VALUES ON STAGGERED
C               E-GRID WITH FIELD MEAN.
C       COEFI - COMPUTES ROW-WISE INTERPOLATION VALUES.
C       COEFJ - COMPUTES COLUMN-WISE INTERPOLATION VALUES.
C     LIBRARY:
C       COMMON
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C----------------------------------------------------------------------
      PARAMETER (WGTCUB=0.0,WGTLIN=1.-WGTCUB,EPS=1.E-5)
      PARAMETER (P5C=.125,P15C=3.375,P25C=15.625
     1,          P35C=42.875,P45C=91.125)
      PARAMETER (P5S=.25,P15S=2.25,P25S=6.25
     1     ,          P35S=12.25,P45S=20.25)
C----------------------------------------------------------------------
                     D I M E N S I O N
     1 ARR1((IDIM+1)/2,JDIM),ARR2(IDIM,JDIM)
C     
C**********************************************************************
C     START FILLV HERE.
C     
C     REPLACE MISSING VALUES ON EGRID WITH FIELD MEAN
      IM=(IDIM+1)/2
      CALL EFILL(ARR1,IM,JDIM)
C
      DO J=1,JDIM
      DO I=1,IDIM
        ARR2(I,J)=0.
      ENDDO
      ENDDO
C***
C***  REASSIGN VALUES OF MODEL GRID TO IDIM X JDIM GRID ON ODD ROWS
C***
      DO J=1,JDIM,2
      DO I=1,IDIM,2
        II=(I+1)/2
        ARR2(I,J)=ARR1(II,J)
      ENDDO
      ENDDO
C***
C***  REASSIGN VALUES OF MODEL GRID TO IDIM X JDIM GRID ON EVEN ROWS
C***
      DO J=2,JDIM-1,2
      DO I=2,IDIM-1,2
        II=I/2
        ARR2(I,J)=ARR1(II,J)
      ENDDO
      ENDDO
C
      IF(WGTCUB.GT.0.99)GO TO 100
C***
C***  INTERPOLATE VALUES TO THOSE CORRESPONDING TO V POINTS NOW ON THE
C***  IDIM X JDIM GRID FOR THE BOTTOM AND TOP ROWS.
C***
      DO I=2,IDIM-1,2
        II=I/2
        ARR2(I,1)=(ARR1(II,1)+ARR1(II+1,1))*0.5
        ARR2(I,JDIM)=(ARR1(II,JDIM)+ARR1(II+1,JDIM))*0.5
      ENDDO
C***
C***  INTERPOLATE VALUES TO THOSE CORRESPONDING TO V POINTS NOW ON THE
C***  IDIM X JDIM GRID FOR WEST AND EAST SIDES.
C***
      DO J=2,JDIM-1,2
        ARR2(1,J)=(ARR1(1,J+1)+ARR1(1,J-1))*0.5
        ARR2(IDIM,J)=(ARR1(IM,J+1)+ARR1(IM,J-1))*0.5
      ENDDO
C***
C***  INTERPOLATE TO CORRESPONDING V POINTS ON ALL INNER POINTS
C***  OF ODD ROWS.
C***
      DO J=3,JDIM-2,2
      DO I=2,IDIM-1,2
        II=I/2
        ARR2(I,J)=0.25*(ARR1(II,J)+ARR1(II+1,J)
     1                 +ARR1(II,J+1)+ARR1(II,J-1))
      ENDDO
      ENDDO
C***
C***  INTERPOLATE TO CORRESPONDING V POINTS ON ALL INNER POINTS
C***  OF EVEN ROWS.
C***
      DO J=2,JDIM-1,2
      DO I=3,IDIM-2,2
        II=I/2
        ARR2(I,J)=0.25*(ARR1(II,J)+ARR1(II+1,J)
     1                 +ARR1(II+1,J+1)+ARR1(II+1,J-1))
      ENDDO
      ENDDO
      IF(WGTCUB.LT.0.01)GO TO 825
C***
C***  FILL IN THE VELOCITY POINTS USING CUBIC INTERPOLATING POLYNOMIALS.
C***  FIRST DO THE ROWS.
C***
  100 WGT1=0.5*WGTCUB+WGTLIN
      DO 200 J=1,JDIM,2
      DO I=3,IDIM-8,2
        CALL COEFI(ARR2,IDIM,JDIM,I,J,C1,C2,C3,C4)
        ARR2(I+3,J)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1               WGTLIN*ARR2(I+3,J))/WGT1
      ENDDO
C
      CALL COEFI(ARR2,IDIM,JDIM,1,J,C1,C2,C3,C4)
      ARR2(2,J)=(0.5*WGTCUB*(C1*P15C+C2*P15S+C3*1.5+C4)+
     1           WGTLIN*ARR2(2,J))/WGT1
      ARR2(4,J)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1           WGTLIN*ARR2(4,J))/WGT1
      CALL COEFI(ARR2,IDIM,JDIM,IDIM-6,J,C1,C2,C3,C4)
      ARR2(IDIM-3,J)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1                WGTLIN*ARR2(IDIM-3,J))/WGT1
      ARR2(IDIM-1,J)=(0.5*WGTCUB*(C1*P35C+C2*P35S+C3*3.5+C4)+
     1                WGTLIN*ARR2(IDIM-1,J))/WGT1
  200 CONTINUE
C
      DO 400 J=2,JDIMM,2
      DO I=4,IDIM-9,2
        CALL COEFI(ARR2,IDIM,JDIM,I,J,C1,C2,C3,C4)
        ARR2(I+3,J)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1               WGTLIN*ARR2(I+3,J))/WGT1
      ENDDO
C
      CALL COEFI(ARR2,IDIM,JDIM,2,J,C1,C2,C3,C4)
      ARR2(1,J)=(0.5*WGTCUB*(C1*P5C+C2*P5S+C3*.5+C4)+
     1           WGTLIN*ARR2(1,J))/WGT1
      ARR2(3,J)=(0.5*WGTCUB*(C1*P15C+C2*P15S+C3*1.5+C4)+
     1           WGTLIN*ARR2(3,J))/WGT1
      ARR2(5,J)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1           WGTLIN*ARR2(5,J))/WGT1
      CALL COEFI(ARR2,IDIM,JDIM,IDIM-7,J,C1,C2,C3,C4)
      ARR2(IDIM-4,J)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1                WGTLIN*ARR2(IDIM-4,J))/WGT1
      ARR2(IDIM-2,J)=(0.5*WGTCUB*(C1*P35C+C2*P35S+C3*3.5+C4)+
     1                WGTLIN*ARR2(IDIM-2,J))/WGT1
      ARR2(IDIM,J)=(0.5*WGTCUB*(C1*P45C+C2*P45S+C3*4.5+C4)+
     1                WGTLIN*ARR2(IDIM,J))/WGT1
  400 CONTINUE
C***
C***  NOW DO THE COLUMNS.
C***
      WGT2=0.5*WGTCUB+WGT1
      DO 600 I=1,IDIM,2
      DO J=3,JDIM-8,2
        CALL COEFJ(ARR2,IDIM,JDIM,I,J,C1,C2,C3,C4)
        ARR2(I,J+3)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1               WGT1*ARR2(I,J+3))/WGT2
      ENDDO
C
      CALL COEFJ(ARR2,IDIM,JDIM,I,1,C1,C2,C3,C4)
      ARR2(I,2)=(0.5*WGTCUB*(C1*P15C+C2*P15S+C3*1.5+C4)+
     1           WGT1*ARR2(I,2))/WGT2
      ARR2(I,4)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1           WGT1*ARR2(I,4))/WGT2
      CALL COEFJ(ARR2,IDIM,JDIM,I,JDIM-6,C1,C2,C3,C4)
      ARR2(I,JDIM-3)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1                WGT1*ARR2(I,JDIM-3))/WGT2
      ARR2(I,JDIM-1)=(0.5*WGTCUB*(C1*P35C+C2*P35S+C3*3.5+C4)+
     1                WGT1*ARR2(I,JDIM-1))/WGT2
  600 CONTINUE
C
      DO 800 I=2,IDIM-1,2
      DO J=4,JDIM-9,2
        CALL COEFJ(ARR2,IDIM,JDIM,I,J,C1,C2,C3,C4)
        ARR2(I,J+3)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1               WGT1*ARR2(I,J+3))/WGT2
      ENDDO
C
      CALL COEFJ(ARR2,IDIM,JDIM,I,2,C1,C2,C3,C4)
      ARR2(I,1)=(0.5*WGTCUB*(C1*P5C+C2*P5S+C3*.5+C4)+
     1           WGT1*ARR2(I,1))/WGT2
      ARR2(I,3)=(0.5*WGTCUB*(C1*P15C+C2*P15S+C3*1.5+C4)+
     1           WGT1*ARR2(I,3))/WGT2
      ARR2(I,5)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1           WGT1*ARR2(I,5))/WGT2
      CALL COEFJ(ARR2,IDIM,JDIM,I,JDIM-7,C1,C2,C3,C4)
      ARR2(I,JDIM-4)=(0.5*WGTCUB*(C1*P25C+C2*P25S+C3*2.5+C4)+
     1                WGT1*ARR2(I,JDIM-4))/WGT2
      ARR2(I,JDIM-2)=(0.5*WGTCUB*(C1*P35C+C2*P35S+C3*3.5+C4)+
     1                WGT1*ARR2(I,JDIM-2))/WGT2
      ARR2(I,JDIM)=(0.5*WGTCUB*(C1*P35C+C2*P35S+C3*3.5+C4)+
     1                WGT1*ARR2(I,JDIM))/WGT2
  800 CONTINUE
C
  825 IF(IFLAG.EQ.1)THEN
        DO J=1,JDIM,2
        DO I=2,IDIM-1,2
          IF(ARR2(I,J).LT.0.)ARR2(I,J)=0.
        ENDDO
        ENDDO
C
        DO J=2,JDIM-1,2
        DO I=1,IDIM,2
          IF(ARR2(I,J).LT.0.)ARR2(I,J)=0.
        ENDDO
        ENDDO
      ELSEIF(IFLAG.EQ.2)THEN
        DO J=1,JDIM,2
        DO I=2,IDIM-1,2
          IF(ARR2(I,J).LT.0.)ARR2(I,J)=EPS
        ENDDO
        ENDDO
C
        DO J=2,JDIM-1,2
        DO I=1,IDIM,2
          IF(ARR2(I,J).LT.0.)ARR2(I,J)=EPS
        ENDDO
        ENDDO
      ENDIF
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE CALTAU(TAUX,TAUY)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALTAU      COMPUTE U AND V WIND STRESSES
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-09-01
C     
C ABSTRACT:  THIS ROUTINE COMPUTES SURFACE LAYER U AND V
C   WIND COMPONENT STRESSES USING K THEORY AS PRESENTED
C   IN SECTION 8.4 OF "NUMBERICAL PREDICTION AND DYNAMIC
C   METEOROLOGY" BY HALTINER AND WILLIAMS (1980, JOHN WILEY
C   & SONS).
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-09-01  RUSS TREADON
C   98-06-11  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL CALTAU(TAUX,TAUY)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     TAUX     - SUFACE LAYER U COMPONENT WIND STRESS.
C     TAUY     - SUFACE LAYER V COMPONENT WIND STRESS.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       CLMAX
C       MIXLEN
C       H2V
C
C     LIBRARY:
C       COMMON   - EXTRA
C                  LOOPS
C                  VRBLS
C                  PVRBLS
C                  MAPOT
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     INCLUDE/SET PARAMETERS.
C     
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
C     
C     DECLARE VARIABLES.
      INTEGER KK(4)
      REAL TAUX(IM,JM),TAUY(IM,JM)
      REAL EL0(IM,JM),EL(IM,JM,LM)
      REAL EGRIDU(IM,JM),EGRIDV(IM,JM),EGRID4(IM,JM),EGRID5(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
C     
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
C      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C********************************************************************
C     START CALTAU HERE.
C     
C     COMPUTE MASTER LENGTH SCALE.
C
      CALL CLMAX(DETA,PDSL,HTM,Q2,ZINT,SM,ZINT(1,1,LP1),
     1     LMH,IM,JM,LM,LP1,
     2     EL0,EGRIDU,EGRIDV,EGRID4,EGRID5)
      CALL MIXLEN(ZINT,T,PDSL,AETA,PT,Q2,ZINT(1,1,LP1),HTM
     1,    EL0,LM,LM1,LP1,IM,JM,EL)
C     
C     INITIALIZE OUTPUT AND WORK ARRAY TO ZERO.
C     
      DO J=JSTA,JEND
      DO I=1,IM
        EGRIDU(I,J) = D00
        EGRIDV(I,J) = D00
        TAUX(I,J)   = SPVAL
        TAUY(I,J)   = SPVAL
      ENDDO
      ENDDO
C
      CALL EXCH(UZ0)
      CALL EXCH(VZ0)
C     
C     COMPUTE SURFACE LAYER U AND V WIND STRESSES.
C
C     ASSUME THAT U AND V HAVE UPDATED HALOS
C
      doout30: DO J=JSTA_M,JEND_M
      doin30: DO I=2,IM-1
C
        LMHK = LMH(I,J)
C
C       COMPUTE THICKNESS OF LAYER AT MASS POINT.
C
        DZ  = D50*(ZINT(I,J,LMHK)-ZINT(I,J,LMHK+1))
        DZ  = DZ-Z0(I,J)
        RDZ = 1./DZ
C
C        COMPUTE REPRESENTATIVE AIR DENSITY.
C
        PSFC = PD(I,J)+PT
        TV   = (H1+D608*Q(I,J,LMHK))*T(I,J,LMHK)
        RHO  = PSFC/(RD*TV)
C     
C        COMPUTE A MEAN MASS POINT WIND IN THE 
C        FIRST ATMOSPHERIC ETA LAYER.
C
        LMHK  = LMH(I,J)
        IE=I+IHE(J)
        IW=I+IHW(J)
        SUMU=U(IE,J,LMV(IE,J))+U(IW,J,LMV(IW,J))+U(I,J-1,LMV(I,J-1)) 
     1        +U(I,J+1,LMV(I,J+1))
        SUMV=V(IE,J,LMV(IE,J))+V(IW,J,LMV(IW,J))+V(I,J-1,LMV(I,J-1)) 
     1        +V(I,J+1,LMV(I,J+1))
        ULMH = D25*SUMU
        VLMH = D25*SUMV
C     
C       COMPUTE A MEAN MASS POINT WIND AT HEIGHT Z0.
C
        UZ0H = D25*(UZ0(I,J-1)+UZ0(IW,J)+UZ0(IE,J)+UZ0(I,J+1))
        VZ0H = D25*(VZ0(I,J-1)+VZ0(IW,J)+VZ0(IE,J)+VZ0(I,J+1))
C
C       COMPUTE WIND SHEAR COMPONENTS ACROSS LAYER.
C
        DELUDZ = (ULMH-UZ0H)*RDZ
        DELVDZ = (VLMH-VZ0H)*RDZ
C     
C       COMPUTE U (EGRIDU) AND V (EGRIDV) WIND STRESSES.
C
        ELSQR       = EL(I,J,LMHK)*EL(I,J,LMHK)
        EGRIDU(I,J) = RHO*ELSQR*DELUDZ*DELUDZ
        EGRIDV(I,J) = RHO*ELSQR*DELVDZ*DELVDZ

CX         WRITE(80,1000) K,LMHK,DZ,RDZ,PSFC,TV
CX         WRITE(80,1000) K,LMHK,ULMH,VLMH,UZ0H,VZ0H
CX         WRITE(80,1000) K,LMHK,RHO,DELUDZ,DELVDZ,EL(I,J,LMHK)
CX         WRITE(80,*)' '
CX 1000    FORMAT(I5,1X,I2,4(G12.6,1X))

C
      END DO doin30
      END DO doout30
C     
C     INTERPOLATE U-V STRESS FROM MASS TO VELOCITY POINTS.
C     
      CALL H2V(EGRIDU,EGRIDV,TAUX,TAUY)
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE GD2EG(IMOUT,JMOUT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GD2EG       CNVRT OUT (I,J) TO E (I,J)
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-01-03       
C     
C ABSTRACT:
C     THIS ROUTINE CONVERTS OUTPUT GRID INTEGER (I,J) 
C     TO FILLED E-GRID FLOATING POINT (I,J).  SUBROUTINE
C     INTERP3 USES THIS INFORMATION TO BILINEARLY 
C     INTERPOLATE FROM A FILLED E-GRID TO THE OUTPUT GRID.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-01-03  RUSS TREADON
C     
C USAGE:    CALL GD2EG(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       LL2EG - CONVERT (LAT,LON) TO FLOATING POINT E-GRID (I,J)
C     LIBRARY:
C       COMMON - IOUNIT
C                LLGRDS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE MAXIMUM OUTPUT GRID DIMENSIONS.
      INCLUDE "parmeta"
      INCLUDE "parmout"
      PARAMETER (imjm=im*jm-jm/2,IMT=2*IM-1,JMT=JM)
      PARAMETER (FMAXI=IMT-1.,FMAXJ=JMT-1.)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "IOUNIT.comm"
      INCLUDE "LLGRDS.comm"
C     
C*********************************************************************
C     START GD2EG HERE.
C     
C     INITIALIZE ARRAYS.
C     
      EGRDI(1:IMX,1:JMX) = -1
      EGRDJ(1:IMX,1:JMX) = -1

C     LOOP OVER OUTPUT GRID (I,J).  FOR EACH OUTPUT GRID (I,J) FIND
C     THE CORRESPONDING E-GRID (I,J).
C     
      WRITE(STDOUT,*)'GD2EG:  FIND E-GRID (I,J) ON OUTPUT GRID'
      doout20: DO J = 1,JMOUT
      doin20: DO I = 1,IMOUT
         ALAT = GDLAT(I,J)
         ALON = GDLON(I,J)
         CALL LL2EG(ALAT,ALON,EI,EJ)
         EGRDI(I,J) = EI
         EGRDJ(I,J) = EJ
      END DO doin20
      END DO doout20
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE BOUNDL(FLD,FMIN,FMAX,IM,JM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    BOUNDL       CLIPS DATA IN PASSED ARRAY
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-01-18
C     
C ABSTRACT:  THIS ROUTINE BOUNDS DATA IN THE PASSED ARRAY 
C   FLD (IMxJM ELEMENTS LONG) AND CLIPS DATA VALUES SUCH 
C   THAT ON EXITING THE ROUTINE 
C                FMIN <= FLD(I,J) <= FMAX
C   FOR ALL POINTS.
C
C   EACH MPI TASK BOUNDS THE PORTION OF THE ARRAY THAT IT "OWNS".
C
C     
C PROGRAM HISTORY LOG:
C   93-01-18  RUSS TREADON
C   93-05-07  RUSS TREADON - ADDED DOCBLOC
C   98-05-29  BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION        
C     
C USAGE:    CALL BOUND(FLD,FMIN,FMAX,NPTS)
C   INPUT ARGUMENT LIST:
C     FMIN     - LOWER (INCLUSIVE) BOUND FOR DATA.
C     FMAX     - UPPER (INCLUSIVE) BOUND FOR DATA.
C     IM,JM    - DIMENSION OF DATA ARRAY FLD.
C
C   OUTPUT ARGUMENT LIST: 
C     FLD      - ARRAY WHOSE ELEMENTS ARE BOUNDED BY [FMIN,FMAX].
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C     
      INCLUDE "CTLBLK.comm"
C     
C     DECLARE VARIABLES.
      REAL FMAX, FMIN, FLD(IM,JM)
C     
C     
C**********************************************************************
C     START BOUND HERE.
C     
C     BOUND ARRAY.
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        FLD(I,J) = AMAX1(FMIN,FLD(I,J))
        FLD(I,J) = AMIN1(FLD(I,J),FMAX)
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE DIST ( A ) 
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    DIST        SCATTERS FROM TASK 0        
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     SCATTER FROM TASK 0 TO ALL OTHER TASKS    
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C
C USAGE:    CALL DIST(A)
C   INPUT ARGUMENT LIST:
C     A        - ARRAY BEING SCATTERED - VALID ONLY ON TASK 0
C
C   OUTPUT ARGUMENT LIST:
C     A        - SCATTERD ARRAY 
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_SCATTERV
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - CTLBLK.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$

      include "parmeta"
      include "CTLBLK.comm"
      include 'mpif.h'
      real a ( im, jm ) 
      real b ( im, jsta:jend ) 
      integer i, j
      integer ierr
c
      if ( num_procs .eq. 1 ) return
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
      call mpi_scatterv(a,icnt,idsp,MPI_REAL,
     &    b(1,jsta),icnt(me),MPI_REAL,0,MPI_COMM_WORLD, ierr )

       a (1:im,jsta:jend) = b (1:im,jsta:jend)
       
      end               

      SUBROUTINE CALVOR(UWND,VWND,ABSV)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALVOR      COMPUTES ABSOLUTE VORTICITY
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22       
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES THE ABSOLUTE VORTICITY USING
C     SECOND ORDER FINITE DIFFERENCES ON THE STAGGERED
C     E-GRID.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   98-06-08  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL CALVOR(UWND,VWND,ABSV)
C   INPUT ARGUMENT LIST:
C     UWND     - U WIND (M/S)
C     VWND     - V WIND (M/S)
C
C   OUTPUT ARGUMENT LIST: 
C     ABSV     - ABSOLUTE VORTICITY (1/S)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - CTLBLK
C                  DYNAMD
C                  MAPOT
C                  MASKS
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
      PARAMETER (OMEGA=7.292E-5,TWOMG=2.*OMEGA)
C
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STRD
      REAL ABSV(IM,JM), UWND(IM,JM), VWND(IM,JM)
C     
C     DECLARE COMMONS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "DYNAMD.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
C     
C***************************************************************************
C     START CALVOR HERE.
C     
C     LOOP TO COMPUTE ABSOLUTE VORTICITY FROM WINDS.
C     
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        ABSV(I,J) = D00
      ENDDO
      ENDDO
C
      CALL EXCH(UWND)
      CALL EXCH(F)
!$omp  parallel do
!$omp& private(favg,tphi,uavg)
      DO J=JSTA_M2,JEND_M2
        TPHI=(J-JMT)*DPHD*DTR
        DO I=2,IM-1
          UAVG=0.25*(UWND(I+IHE(J),J)+UWND(I+IHW(J),J)
     1              +UWND(I,J+1)+UWND(I,J-1))
          FAVG=0.25*(F(I+IHE(J),J)+F(I+IHW(J),J)
     1              +F(I,J+1)+F(I,J-1))
          ABSV(I,J)=((VWND(I+IHE(J),J)-VWND(I+IHW(J),J))/(2.*DX(I,J))
     1              -(UWND(I,J+1)-UWND(I,J-1))/(2.*DY)
     2              +UAVG*TAN(TPHI)/ERAD+2.*FAVG/DT)*HBM2(I,J)
        ENDDO
      ENDDO
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE FIXED(IMOUT,JMOUT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    FIXED       POSTS FIXED FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-08-30
C     
C ABSTRACT:  THIS ROUTINE POSTS FIXED (IE, TIME INDEPENDENT)
C  ETA MODEL FIELDS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-08-30  RUSS TREADON
C   96-04-05  MIKE BALDWIN - CHANGED ALBEDO CALC
C   98-06-16  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-07-17  MIKE BALDWIN - REMOVED LABL84
C   00-01-05  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL FIXED(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE 
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LOOPS
C                  MASKS
C                  LLGRDS
C                  RQSTFLD
C                  PHYS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     INCLUDE/DECLARE PARAMETERS.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "parm.tbl"
      INCLUDE "params"
      INCLUDE "parmsoil"
C
      PARAMETER (SNOALB=0.55)
C     
C     DECLARE VARIABLES
      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT)
C
C     INCLUDE COMMON BLOCKS.
C     
      INCLUDE "LOOPS.comm"
      INCLUDE "LLGRDS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "SOIL.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C********************************************************************
C
C     START FIXED HERE.
C
C     LATITUDE (OUTPUT GRID).
      IF (IGET(048).GT.0) THEN
         DO J = 1,JMOUT
            DO I = 1,IMOUT
               GRID1(I,J) = GDLAT(I,J)
            END DO
         END DO
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(048),LVLS(1,IGET(048)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     LONGITUDE (OUTPUT GRID). CONVERT TO EAST
      IF (IGET(049).GT.0) THEN
         DO J = 1,JMOUT
            DO I = 1,IMOUT
               GRID1(I,J) = 360. - GDLON(I,J)
            END DO
         END DO
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(049),LVLS(1,IGET(049)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     LAND/SEA MASK.
      IF (IGET(050).GT.0) THEN
         DO J = JSTA,JEND
         DO I = 1,IM
            EGRID1(I,J) = 1. - SM(I,J)
         ENDDO
         ENDDO

         CALL E2OUT(050,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(050),LVLS(1,IGET(050)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SEA ICE MASK.
      IF (IGET(051).GT.0) THEN
         CALL E2OUT(051,000,SICE,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(051),LVLS(1,IGET(051)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     MASS POINT ETA SURFACE MASK.
      IF (IGET(052).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J) = FLOAT(LMH(I,J))
         ENDDO
         ENDDO
         CALL E2OUT(052,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(052),LVLS(1,IGET(052)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     VELOCITY POINT ETA SURFACE MASK.
      IF (IGET(053).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J) = FLOAT(LMV(I,J))
         ENDDO
         ENDDO
         CALL E2OUT(053,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(053),LVLS(1,IGET(053)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     SURFACE ALBEDO.
C       NO LONGER A FIXED FIELD, THIS VARIES WITH SNOW COVER
C
      IF (IGET(150).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           SNOK = AMAX1(SNO(I,J),0.0)
           SNOFAC = AMIN1(SNOK*50.0,1.0)
           EGRID1(I,J)=ALB(I,J)+(1.-VEGFRC(I,J))*SNOFAC
     1                *(SNOALB-ALB(I,J))
         ENDDO
         ENDDO
         CALL E2OUT(150,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
CHOU 2022         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(150),LVLS(1,IGET(150)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SEA SURFACE TEMPERAURE.
      IF (IGET(151).GT.0) THEN
         CALL E2OUT(151,000,SST,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(151),LVLS(1,IGET(151)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE READCNTRL2(IEOF,DATASET)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    READCNTRL2  READS CONTROL FILE
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-20       
C     
C ABSTRACT:
C     THIS ROUTINE READS THE CONTROL FILE SPECIFYING OUTPUT
C     GRID(S), DATA FORMAT(S), AND FIELD(S) TO POST.  THE
C     ORDER OF OPERATIONS IS 
C        (1) READ HEADER BLOCK OF CONTROL FILE,
C        (2) SET FLAGS, CLOSE OPEN UNITS, SET E-GRID SPECS,
C        (3) READ OR COMPUTE INTERPOLATION WEIGHTS, AND
C        (4) READ BODY OF CONTROL FILE (FIELD SPECIFICATIONS)
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-20  RUSS TREADON
C   93-06-15  RUSS TREADON - ADD PROJECTION CONTROL CARD
C   98-06-01  BLACK - CONVERSION OF POST FROM 1-D TO 2-D
C   98-07-17  MIKE BALDWIN - REMOVED PACK84
C     
C USAGE:    CALL READCNTRL2(IEOF)
C   INPUT ARGUMENT LIST:
C     NONE
C
C   OUTPUT ARGUMENT LIST: 
C     IEOF     - INTEGER FLAG FOR EOF IN CONTROL FILE.
C                IEOF=0 WHEN AN EOF IS READ IN THE
C                CONTROL FILE.  IEOF=1 OTHERWISE.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       TRNSEG   - SET E-GRID SPECIFCATIONS.
C       TRNSGD   - SET OUTPUT GRID SPECIFICATIONS.
C       E2TLL    - COMPUTE TRANSFORMED (LAT,LON) ON E-GRID.
C       FILLH    - FILL "H" POINTS FOR "V" POINT ARRAY.
C       FILLV    - FILL "V" POINTS FOR "H" POINT ARRAY.
C       GENLL    - COMPUTE OUTPUT GRID GEODETIC (LAT,LON).
C       GD2TLL   - MAP GEODETIC (LAT,LON) TO TRANSFORM
C                     ETA GRID REFERENCE FRAME.
C       GD2EG    - MAP OUTPUT GRID (I,J) TO FILLED E-GRID (I,J).
C       GD2EGK   - MAP OUTPUT GRID (I,J) TO E-GRID (K) FOR CETLIH4.
C       GENBIL   - COMPUTE BILINEAR INTERPOLATION WEIGHTS.
C       GENEUV   - LOAD ROTATION ARRAYS FOR WINDS.
C
C     LIBRARY:
C       COMMON   - OUTGRD
C                  RQSTFLD
C                  LLGRDS
C                  IOUNIT
C                  PHYS2
C                  OPTIONS
C                  MAPOT
C                  CTLBLK
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE PARAMETERS.
C
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "parm.tbl"
      PARAMETER (IMJM=IM*JM-JM/2,IMT=2*IM-1,JMT=JM,LP1=LM+1)
      PARAMETER (DTR=1.745329E-2,RTD=1./DTR)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL NORTH
      CHARACTER*2  CHAR2
      CHARACTER*4  CHAR4
CJLG
      CHARACTER*6  DATASET
CJLG 
      CHARACTER*6  NUFILE,OUTYPE,PROJ,READCO,READLL
      CHARACTER*80 LINE
      REAL EGRID1(IM,JM), EGRID2(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "OUTGRD.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "LLGRDS.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "PHYS2.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "OUTFIL.comm"
Cmp
	include "GDS.com"
	include "mpif.h"
Cmp
C
C******************************************************************************
C     START READCNTRL HERE.
C     
C      IFHR = NTSD/TSPH + 0.5
      IFHR = ITAG
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)'READCNTRL2:  POSTING FCST HR ',IFHR,' FROM ',
     X     IHRST,'UTC ',IDAT(1),'-',IDAT(2),'-',IDAT(3),' RUN'
      ENDIF
C     
C     INITIALIZE VARIABLES.
C        IEOF IS THE END OF FILE FLAG FOR THE CONTROL FILE.
C        ARRAY IGET IS THE "GET FIELD" FLAG ARRAY.
C
      IEOF=0
      DO 100 IFLD=1,MXFLD
        IGET(IFLD)=-1
 100  CONTINUE
 
C     OPEN cntrl.parm file
 
      OPEN(LCNTRL,FILE='cntrl.parm_'//DATASET,status='old')
C
C     READ OUTPUT GRID SPECIFICATIONS.
C
      READ(LCNTRL,1000,ERR=990,END=999) KGTYPE
      READ(LCNTRL,1000,ERR=990,END=999) IMDLTY
      READ(LCNTRL,1030,ERR=990,END=999) DATSET
      READ(LCNTRL,1030,ERR=990,END=999) OUTYPE
      READ(LCNTRL,1030,ERR=990,END=999) NUFILE
      READ(LCNTRL,1030,ERR=990,END=999) PROJ
      READ(LCNTRL,1010,ERR=990,END=999) NORTH
Cmp
      IF ( KGTYPE.EQ.257 ) THEN
        READ(LCNTRL,1000,ERR=990,END=999) IGOUT
        READ(LCNTRL,1000,ERR=990,END=999) JGOUT
        READ(LCNTRL,1020,ERR=990,END=999) POLEI
        READ(LCNTRL,1020,ERR=990,END=999) POLEJ
        READ(LCNTRL,1020,ERR=990,END=999) ALATVT
        READ(LCNTRL,1020,ERR=990,END=999) ALONVT
        READ(LCNTRL,1020,ERR=990,END=999) XMESHL
      ELSE
	IGOUT=IGDS(4)
	JGOUT=IGDS(5)
	POLEI=IGDS(11)/1000.
	POLEJ= -.001*IGDS(10)
	ALATVT=0.
	ALONVT=IGDS(9)/1000.
	XMESHL=IGDS(12)/1000.
      ENDIF
Cmp
      READ(LCNTRL,1030,ERR=990,END=999) READLL
      READ(LCNTRL,1030,ERR=990,END=999) READCO
 1000 FORMAT(T28,I5)
 1010 FORMAT(T28,L1)
 1020 FORMAT(T28,F11.6)
 1030 FORMAT(T28,A6)
C     
C     IF THE GRID TYPE (KGTYPE) IS NEITHER 0 NOR 99999 THEN THE
C     ONLY ALLOWED PROJECTIONS FOR THE OUTPUT GRID ARE POLAR 
C     STEREOGRAPHIC (POLA), LATITUDE-LONGITUDE (LOLA), AND LAMBERT
C     (TANGENT) CONFORMAL (LMBC).  IF THE REQUESTED PROJECTION 
C     DOES NOT SATISFY THESE CONDITIONS, TELL THE USER AND ASSUME
C     OUTPUT ON THE STAGGERED E-GRID.
C     
      IF ( (KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1      .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
     1      .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196) ) THEN
      IF ( ME .EQ. 0 ) THEN
         IF (INDEX(PROJ,'POLA').NE.0) THEN
            WRITE(STDOUT,*)'READCNTRL2:  POLAR STEREOGRAPHIC ',
     X           'PROJECTION REQUESTED.  PROJ=',PROJ
         ELSEIF (INDEX(PROJ,'LOLA').NE.0) THEN
            WRITE(STDOUT,*)'READCNTRL2:  LATITUDE-LONGITUDE ',
     X           'PROJECTION REQUESTED.  PROJ=',PROJ
         ELSEIF (INDEX(PROJ,'LMBC').NE.0) THEN
            WRITE(STDOUT,*)'READCNTRL2:  LAMBERT (TANGENT) CONFORMAL ',
     X           'PROJECTION REQUESTED.  PROJ=',PROJ
      ENDIF
         ELSE
           IF ( ME .EQ. 0 ) THEN
            WRITE(STDOUT,*)
     X           'READCNTRL2:  PROJ=',PROJ,' IS NOT AVAILABLE.'
            WRITE(STDOUT,*)
     X           '             USING STAGGERED E-GRID AS DEFAULT'
           ENDIF
C
CMEB  NEED TO KNOW WHICH VERSION OF THE MODEL IS RUNNING AT THIS POINT
C
            KGTYPE = 90
            PROJ   = 'ETA'
         ENDIF
      ENDIF
C     
C     00HR LFM LOOK-ALIKE FIELDS GO ON GRIDS 026 AND 005.
C     THE WAY THE CODE IS STRUCTURED WE MUST PROCESS GRIDS
C     026 AND 005 SEPARATELY.  TO UNIQUELY IDENTIFY THAT
C     THE USER ONLY WANTS THE 00HR LFM FIELDS ON GRID 005
C     DATSET MUST BE SET TO "ETA_AN".  IF THE CURRENT POST
C     TIME IS NOT 00, SKIP OUTPUT ON GRID 005.
C     
      IF ((KGTYPE.EQ.005).AND.(INDEX(DATSET,'ETA_AN').NE.0)) THEN
C         IFHR = NTSD/TSPH+0.50
         IFHR = ITAG
	 IF (IFHR.NE.0) GOTO 999
      ENDIF
C     
C     SET FLAG FOR TYPE OF OUTPUT.
C     
      IOUTYP=0
      IF (INDEX(OUTYPE,'NO'    ).NE.0) IOUTYP=1
      IF (INDEX(OUTYPE,'GRIBIT').NE.0) IOUTYP=3
      IF (INDEX(OUTYPE,'GRIBRK').NE.0) IOUTYP=5
      IF (IOUTYP.EQ.0) THEN
         IF ( ME .EQ. 0 ) WRITE(STDOUT,*)'OUTPUT TYPE ',
     X        OUTYPE,'NOT SUPPORTED.'
         IOUTYP=1
         IF ( ME .EQ. 0 )
     X   WRITE(STDOUT,*)'USING MACHINE BINARY AS DEFAULT.  ',
     X        'IOUTYP=',IOUTYP
      ENDIF
C     
C     IF NEW OUTPUT FILE IS SPECIFIED
C       1.  CLOSE THE PREVIOUS OUTPUT FILE UNIT,
C       2.  SET FLAG TO OPEN NEW OUTPUT FILE
C
      RITEHD = .FALSE.
      RITE2  = .FALSE.
      IF (INDEX(NUFILE,'YES').NE.0) THEN
         CLOSE(LUNOUT)
         CLOSE(LUNOUT+1)
         CLOSE(LUNOUT+2)
         IF ( ME .EQ. 0 )
     X    WRITE(STDOUT,*)' READCNTRL2:  JUST CLOSED UNITS ',LUNOUT,
     X        LUNOUT+1,LUNOUT+2
         RITEHD = .TRUE.
         RITE2  = .TRUE.
         IF ( ME .EQ. 0 )
     X    WRITE(STDOUT,*)
     X        ' READCNTRL2:  NEXT UNIT(S) OPENED WILL BE ',LUNOUT,
     X        LUNOUT+1,LUNOUT+2
      ENDIF
C     
C     INCREMENT UNIT NUMBERS FOR WEIGHTS AND LATLON GRID.
C     SET FLAG TO WRITE HEADER TO LEAD OFF OUTPUT FILE.
      IF (INDEX(READCO,'NO').EQ.0) THEN
         LUNCO  = LUNCO + 1
         REWIND(LUNCO)
      ENDIF
      IF (INDEX(READLL,'NO').EQ.0) THEN
         LUNLL  = LUNLL + 1
         REWIND(LUNLL)
      ENDIF
C     
C     LOAD E-GRID AND OUTPUT GRID COMMON BLOCKS.
      CALL TRNSEG
      IF ( (KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1      .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
     1      .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196.and.KGTYPE.NE.255) ) 
     2		CALL TRNSGD
C     
C     IF THE USER WANTS TO READ IN PRECOMPUTED WEIGHTS, DO SO.
C     
      IF(INDEX(READCO,'NO').EQ.0)THEN
        IF ( ME .EQ. 0 )WRITE(STDOUT,*)'READ PRECOMPUTED WEIGHTS'
	OPEN(LUNCO,file='wgts1',form='unformatted',
     1       status='old')
        READ(LUNCO,ERR=992) ((GDLAT(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((GDLON(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((GDTLAT(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((GDTLON(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((HTLAT(I,J),I=1,IM),J=1,JM)
        READ(LUNCO,ERR=992) ((HTLON(I,J),I=1,IM),J=1,JM)
        READ(LUNCO,ERR=992) ((IEGRDK(I,J),I=1,IM),J=1,JM)
        READ(LUNCO,ERR=992) ((JEGRDK(I,J),I=1,IM),J=1,JM)
        READ(LUNCO,ERR=992) ((VTLAT(I,J),I=1,IM),J=1,JM)
        READ(LUNCO,ERR=992) ((VTLON(I,J),I=1,IM),J=1,JM)
        READ(LUNCO,ERR=992) ((FVTLON(I,J),I=1,IMT),J=1,JMT)
        READ(LUNCO,ERR=992) ((EVLAT(I,J),I=1,IMT),J=1,JMT)
        READ(LUNCO,ERR=992) ((EVLON(I,J),I=1,IMT),J=1,JMT)
        READ(LUNCO,ERR=992) ((EGRDI(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((EGRDJ(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((IEGRD(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((JEGRD(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((IWGT(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((WIJ(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((WIPJ(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((WIJP(I,J),I=1,IGOUT),J=1,JGOUT)
        READ(LUNCO,ERR=992) ((WIPJP(I,J),I=1,IGOUT),J=1,JGOUT)
        CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
C     
C     OTHERWISE, WE MUST COMPUTE THE WEIGHTS AS WE RUN THE
C     PROGRAM.  CHECK TO SEE IF A USER DEFINED (LAT,LON)
C     GRID EXITS.  IF SO, READ IT.  IF NOT, USE THE GRID
C     SPECIFICATIONS TO GENERATE (LAT,LON) FOR THE OUTPUT
C     GRID.  IN EITHER CASE, TRANSFORM GEODETIC (LAT,LON)
C     OF THE OUTPUT GRID TO THE ETA REFERENCE FRAME.
C     
      ELSE
C     
C        SET UP E-GRID (LAT,LON) ARRAYS.
         WRITE(STDOUT,*)'SET UP E-GRID (LAT,LON) ARRAYS'
         CALL E2TLL(HTLAT,HTLON,VTLAT,VTLON)
         CALL FILLH(VTLON,FVTLON,IMT,JMT)
C     
C        READ IN USER (LAT,LON) GRID IF ONE EXISTS.
         IF (INDEX(READLL,'NO').EQ.0) THEN
            WRITE(STDOUT,*)'READ USER OUTPUT GRID (LAT,LON)'
            READ(LUNLL,ERR=994) ((GDLAT(I,J),I=1,IGOUT),J=1,JGOUT)
            READ(LUNLL,ERR=994) ((GDLON(I,J),I=1,IGOUT),J=1,JGOUT)
C           READ(LUNLL,1050,ERR=994) (((GDLAT(I,J),GDLON(I,J)),
C    X           I=1,IGOUT),J=1,JGOUT)
C1050       FORMAT(3(2(F11.6,1X),1X))
C     
C        OTHERWISE GENERATE OUTPUT GRID (LAT,LON)
C        WE DON'T NEED THE WEIGHTS IF OUTPUT GRID
C        IS A FILLED E-GRID (KGTYPE=0).  HOWEVER,
C        THE USER MAY REQUEST FILLED E-GRID (LAT,
C        LON), SO COMPUTE THESE FIELDS.
C
         ELSE
            IF ( (KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1            .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
     1            .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196) ) THEN
               WRITE(STDOUT,*)'GENERATE OUTPUT GRID (LAT,LON)'
               CALL GENLL(GDLAT,GDLON)
            ELSE
               WRITE(STDOUT,*)'COMPUTE E-GRID GEO-(LAT,LON)'
               DO J=1,JM
               DO I=1,IM
                 EGRID1(I,J) = GLAT(I,J)*RTD
                 EGRID2(I,J) = GLON(I,J)*RTD
               ENDDO
               ENDDO
               IF (MOD(KGTYPE,2).EQ.1.AND.KGTYPE.NE.99) THEN
                  IGOUT = IMT
                  JGOUT = JMT
                  CALL FILLV(EGRID1,GDLAT,IFLAG,IMT,JMT)
                  CALL FILLV(EGRID2,GDLON,IFLAG,IMT,JMT)
               ELSE
                  DO J=1,JM
                  DO I=1,IM
                    GDLAT(I,J)=EGRID1(I,J)
                    GDLON(I,J)=EGRID2(I,J)
                  ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDIF
C     
C        COMPUTE INTERPOLATION WEIGHTS.  WE DON'T NEED TO  
C        DO THIS FOR KGTYPE=0.  HOWEVER, WE DO NEED GEODETIC
C        (LAT,LON) FOR FILLED E-EGRID IF KGTYPE=0
C
         IF ( (KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1         .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
Cmp
     1    .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196.and.KGTYPE.ne.255))THEN
Cmp
            CALL GD2TLL(GDLAT,GDLON,GDTLAT,GDTLON,IGOUT,JGOUT)
            CALL GD2EG(IGOUT,JGOUT)
            CALL GD2EGK(IGOUT,JGOUT)
            CALL GENBIL(FVTLON,IGOUT,JGOUT)
            CALL GENEUV(EVLAT,EVLON)
         ENDIF
      ENDIF
      IF((INDEX(READCO,'YES').EQ.0).AND.(OUTYPE.EQ."NOPACK"))THEN   
 	WRITE(STDOUT,*)'WRITE COMPUTED WEIGHTS'
	OPEN(92,file='wgts1_tmp',form='unformatted',
     1       status='unknown')
 	WRITE(92) ((GDLAT(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((GDLON(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((GDTLAT(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((GDTLON(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((HTLAT(I,J),I=1,IM),J=1,JM)
 	WRITE(92) ((HTLON(I,J),I=1,IM),J=1,JM)
 	WRITE(92) ((IEGRDK(I,J),I=1,IM),J=1,JM)
 	WRITE(92) ((JEGRDK(I,J),I=1,IM),J=1,JM)
 	WRITE(92) ((VTLAT(I,J),I=1,IM),J=1,JM)
 	WRITE(92) ((VTLON(I,J),I=1,IM),J=1,JM)
 	WRITE(92) ((FVTLON(I,J),I=1,IMT),J=1,JMT)
 	WRITE(92) ((EVLAT(I,J),I=1,IMT),J=1,JMT)
 	WRITE(92) ((EVLON(I,J),I=1,IMT),J=1,JMT)
 	WRITE(92) ((EGRDI(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((EGRDJ(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((IEGRD(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((JEGRD(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((IWGT(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((WIJ(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((WIPJ(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((WIJP(I,J),I=1,IGOUT),J=1,JGOUT)
 	WRITE(92) ((WIPJP(I,J),I=1,IGOUT),J=1,JGOUT)
	close(92)
	WRITE(STDOUT,*)'CLOSE FILE COMPUTED WEIGHTS'
      ENDIF
C     
C     ECHO GRID SPECIFICATIONS TO STDOUT.
C
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)'READCNTRL:  OUTPUT GRID SPECIFICATIONS AND SETUP'
      WRITE(STDOUT,*)' KGTYPE       :  ',KGTYPE
      WRITE(STDOUT,*)' IGOUT,JGOUT  :  ',IGOUT,JGOUT
      WRITE(STDOUT,*)' DATSET,OUTYPE:  ',DATSET,' ',OUTYPE
      WRITE(STDOUT,*)' NUFILE,RITEHD:  ',NUFILE,RITEHD,' ',RITE2
      WRITE(STDOUT,*)' READLL,READCO:  ',READLL,' ',READCO
      WRITE(STDOUT,*)' IOUTYP       :  ',IOUTYP
      WRITE(STDOUT,*)' LUNCO,LL,OUT :  ',LUNCO,LUNLL,LUNOUT
      ENDIF
C     
C     ALL THE GRID STUFF IS DONE.  NOW READ WHICH FIELDS ON 
C     WHICH LEVELS TO INTERPOLATE TO THE OUTPUT GRID.  THE
C     CHARACTER STRING "DONE" MARKS THE END OF THE OUTPUT
C     FIELD SPECIFICATIONS.
C
      IFLD = 0
 10   CONTINUE
         READ(LCNTRL,1060,ERR=996) LINE
         IF (INDEX(LINE,'DONE').NE.0) GOTO 40
         IF (INDEX(LINE,'SCAL=').EQ.0)   GOTO 10
         IFLD        = IFLD+1
         FIELD(IFLD) = LINE(3:22)
         CHAR2       = LINE(64:65)
         CALL CHR2INT(CHAR2,2,ISMSTG(IFLD))
         CHAR2       = LINE(67:68)
         CALL CHR2INT(CHAR2,2,ISMFUL(IFLD))
         CHAR2       = LINE(70:71)
         CALL CHR2INT(CHAR2,2,ISMOUT(IFLD))
         READ(LINE,1061) DEC(IFLD)
         READ(LCNTRL,1090,ERR=996) (LVLS(L,IFLD),L=1,MXLVL)
 1060    FORMAT(A80)
 1061    FORMAT(50X,F4.1)
 1070    FORMAT(A4)
 1080    FORMAT(A2)
 1090    FORMAT(T5,12(5I1,1X))
C     
C        SEE IF WE WANT THIS FIELD.  THE SUM OF THE LEVELS
C        INDICATORS MUST BE GREATER THAN ZERO IF WE WANT 
C        THIS FIELD.
C     
         ISUM = 0
         DO 15 L = 1,MXLVL
            ISUM = ISUM + LVLS(L,IFLD)
 15      CONTINUE
         IF (ISUM.LT.1) THEN
            IFLD = IFLD - 1
            GOTO 10
         ENDIF
C     
C        SEE IF REQUESTED FIELD IS AVAILABLE.  IF NOT, 
C        WRITE MESSAGE TO STDOUT AND DECREMENT FIELD 
C        COUNTER BY ONE.  THEN READ NEXT REQUESTED FIELD.
C     
         DO 20 IAVBL = 1,MXFLD
            IF (INDEX(FIELD(IFLD),AVBL(IAVBL)).NE.0) GOTO 30
 20      CONTINUE
         IF ( ME .EQ. 0 )
     X   WRITE(STDOUT,*)'FIELD ',FIELD(IFLD),' NOT AVAILABLE'
         IFLD = IFLD-1
         GOTO 10
C     
C        IF FIELD IS AVAILABLE, TURN THE GET SWITCH ON.
C     
 30      CONTINUE
         IGET(IAVBL) = IFLD
         IDENT(IFLD) = IAVBL
         GOTO 10
C     
C     ALL DONE READING REQUESTED FIELDS FOR CURRENT OUTPUT GRID.
C     SET NFLD TO TOTAL NUMBER OF REQUESTED OUTPUT FIELDS THAT 
C     ARE AVAILABLE.
C
 40   CONTINUE
      NFLD = IFLD
C     
C     ECHO OUTPUT FIELDS/LEVELS TO STDOUT.
C
         IF ( ME .EQ. 0 )
     X   WRITE(STDOUT,*)'BELOW ARE FIELD/LEVEL/SMOOTHING ',
     X     'SPECIFICATIONS.'
      DO 50 IFLD = 1,NFLD
         IF ( ME .EQ. 0 )
     X   WRITE(STDOUT,2060) FIELD(IFLD),IQ(IDENT(IFLD)),
     X        IS(IDENT(IFLD)),ISMSTG(IFLD),ISMFUL(IFLD),ISMOUT(IFLD)
         IF ( ME .EQ. 0 )
     X   WRITE(STDOUT,2070) (LVLS(L,IFLD),L=1,MXLVL)
 2060    FORMAT('(',A20,') Q=(',I4,'), S=(',I4,
     X        '), SMTH=(',I2,1X,I2,1X,I2,')')
 2070    FORMAT('L=(',12(5I1,1X),')')
 50   CONTINUE
C     
C     WE HAVE AN OUTPUT GRID AND THE FIELDS TO GENERATE ON IT.
C     SKIP OVER THE FOLLOWING EOF MESSAGE TO EXIT THIS ROUTINE.
C     
      GOTO 60
C     
C     WE REACH THIS BLOCK ONLY IF THERE IS AN ERROR WHILE READING
C     IN THE CONTROL FILE.  PRINT AN ERROR MESSAGE TO STANDARD
C     OUT AND CARRY ON.
C     
 990  CONTINUE
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)' READCNTRL2:  ERROR READING CNTRL GRID INFO'
      WRITE(STDOUT,*)' BELOW IS CNTRL GRID INFO'
      WRITE(STDOUT,*)'  KGTYPE,DATSET:  ',KGTYPE,' ',DATSET
      WRITE(STDOUT,*)'  OUTYPE,NUFILE:  ',OUTYPE,' ',NUFILE
      WRITE(STDOUT,*)'  PROJ         :  ',PROJ
      WRITE(STDOUT,*)'  NORTH        :  ',NORTH
      WRITE(STDOUT,*)'  IGOUT,JGOUT  :  ',IGOUT,JGOUT
      WRITE(STDOUT,*)'  POLEI,POLEJ  :  ',POLEI,POLEJ
      WRITE(STDOUT,*)'  ALATVT,ALONVT:  ',ALATVT,ALONVT
      WRITE(STDOUT,*)'  XMESHL       :  ',XMESHL
      WRITE(STDOUT,*)'  READLL,READCO:  ',READLL,READCO
      ENDIF
      GOTO 999
 992  CONTINUE
      IF ( ME .EQ. 0 )
     X WRITE(STDOUT,*)' READCNTRL2:  ERROR READING INTERP WEIGHTS'
      GOTO 999
 994  CONTINUE
      IF ( ME .EQ. 0 ) 
     X WRITE(STDOUT,*)' READCNTRL2:  ERROR READING LATLON GRID'
      GOTO 999
 996  CONTINUE
      IF ( ME .EQ. 0 )
     X WRITE(STDOUT,*)' READCNTRL2:  ERROR READING CNTRL FLD/LVL INFO'
C     
C     WE REACH THIS BLOCK ONLY WHEN AN EOF HAS BEEN READ FROM 
C     THE CONTROL FILE.  THAT MEANS WE'VE PROCESSED ALL GRIDS
C     AND ALL FIELDS.  WE'RE DONE.  SET THE EOF FLAG TO ANY
C     NONZERO INTEGER, SAY ONE.  CLOSE THE UNIT CONNECTED TO
C     THE LAST OUTPUT FILE AND EXIT THE ROUTINE.
C     
 999  CONTINUE
      IEOF=1
      CLOSE(LUNOUT)
      CLOSE(LUNOUT+1)
      CLOSE(LUNOUT+2)
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)' READCNTRL2:  ALL GRIDS PROCESSED.  ',
     X     'CLOSED ',LUNOUT
      ENDIF
C     
C     END OF ROUTINE.
C     
 60   CONTINUE
      RETURN
      END

      SUBROUTINE H2V(UMASS,VMASS,UWIND,VWIND)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    H2V         INTERPOLATE MASS TO WIND POINTS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-10-05
C     
C ABSTRACT:  
C   THIS ROUTINE INTERPOLATES MASS POINT WINDS TO VELOCITY POINTS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-10-05  RUSS TREADON
C   98-06-11  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL H2V(UMASS,VMASS,UWIND,VWIND)
C   INPUT ARGUMENT LIST:
C     UMASS    - U WIND AT MASS POINTS
C     VMASS    - V WIND AT MASS POINTS
C
C   OUTPUT ARGUMENT LIST: 
C     UWIND    - U WIND AT VELOCITY POINTS
C     VWIND    - V WIND AT VELOCITY POINTS
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - OPTIONS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE PARAMETERS.
              USEINDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C     
C     DECLARE VARIABLES.
      REAL UMASS(IM,JM),VMASS(IM,JM),UWIND(IM,JM),VWIND(IM,JM)
C     
C     INCLUDE COMMON BLOCK.
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C***************************************************************************
C     START H2V HERE.
C     
C     INITIALIZE V POINT ARRAYS TO THE SPECIAL VALUE.
C     
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        UWIND(I,J) = SPVAL
        VWIND(I,J) = SPVAL
      ENDDO
      ENDDO
C     
C     FOUR POINT AVERAGE MASS POINT WINDS TO VELOCITY POINTS.
C
      CALL EXCH(UMASS)
      CALL EXCH(VMASS)
!$omp  parallel do
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        UWIND(I,J)=D25*(UMASS(I,J-1)+UMASS(I+IVW(J),J)+
     1                  UMASS(I+IVE(J),J)+UMASS(I,J+1))
        VWIND(I,J)=D25*(VMASS(I,J-1)+VMASS(I+IVW(J),J)+
     1                  VMASS(I+IVE(J),J)+VMASS(I,J+1))
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE OUT_MASKS(EGFUL,GDOUT,IMOT,JMOT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    OUT_MASKS   
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23
C     
C ABSTRACT: 
C    
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE INTERP
C   92-12-23  RUSS TREADON - BROKE INTERP INTO SEVERAL PIECES
C                            ONE OF WHICH BECAME THIS
C                            INTERPOLATION ROUTINE.
C   95-05-03  MIKE BALDWIN - ADDED BIT MAP ARRAY
C     
C USAGE:    CALL INTERP3(EGFUL,GDOUT,IMOT,JMOT)
C   INPUT ARGUMENT LIST:
C     EGFUL    - DATA ON FILLED E-GRID.
C     IMOT     - FIRST DIMENSION OF OUTPUT GRID.
C     JMOT     - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     GDOUT    - DATA INTERPOLATED TO OUTPUT GRID.
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       EXTEND   - FILLS MISSING VALUES ON OUTPUT GRID WITH 
C                  EITHER AN EXTENSION OF BORDER VALUES OR
C                  THE FIELD MEAN.
C     LIBRARY:
C       COMMON   - OPTIONS
C                  LLGRDS
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY Y-MP
C$$$  
C     
C     
C     INCLUDE DECLARED GRID DIMENSIONS.
C-----------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "parmout"
C-----------------------------------------------------------------
      PARAMETER (IMT=2*IM-1,JMT=JM)
C     
C     DECLARE VARIABLES.
C-----------------------------------------------------------------
      INTEGER IMOT,JMOT
      REAL EGFUL(IMT,JMT),GDOUT(IMOT,JMOT)
      DOUBLE PRECISION SUM
C-----------------------------------------------------------------
C     
C     INCLUDE COMMON.
      INCLUDE "OPTIONS.comm"
      INCLUDE "LLGRDS.comm"
      INCLUDE "BITMAP.comm"
      INCLUDE "IOUNIT.comm"
C
C     SET TOLERANCE LIMITS.
C     
      DATA MXPASS,SPVC,SMALL /2,1.E20,1.E-4/
C     
C
      GDOUT(1:IMOT,1:JMOT)=SPVC
C
!$omp  parallel do
!$omp& private(m,n)
      doout120: DO J = 1,JMOT
      doin120: DO  I = 1,IMOT
        IF (IWGT(I,J).EQ.1) THEN
          M = IEGRD(I,J)
          N = JEGRD(I,J) 
          GDOUT(I,J) = EGFUL(M,N) 
        ENDIF
       END DO doin120
       END DO doout120
!$omp end parallel do
C
C
      RETURN
      END

      SUBROUTINE CLMAX
     I (DETA,PDSL,HTM,Q2,ZINT,SM,HGT,LMH,IM,JM,LM,LP1
     O, EL0
     W, SQZ,SQ,RQ2L,RQ2H)
CFPP$ NOCONCUR R
C
C     CALCULATES THE FREE-ATMOSPHERE ASYMPTOTE OF THE TURBULENCE LENGTH
C     SCALE (L-INF IN THE BLACKADAR's FORMULA) FROM THE DISTRIBUTION
C     OF THE TURBULENT ENERGY (see MY82)
C
C     EXTRACTED FROM EXISTING CODE BY L. LOBOCKI, JULY 28, 1992
C
C     INPUT:
C     ------
C
C     DETA (LM)        - VECTOR OF THE ETA COORDINATE STEPS
C     PDSL (IM,JM)     - VECTORIZED ARRAY OF SURFACE PRESSURE
C     HTM  (IM,JM,LM)  - HEIGHT TOPOGRAPHY MASK ARRAY
C     Q2   (IM,JM,LM)  - TWICE THE TURBULENT ENERGY FIELD
C     ZINT (IM,JM,LP1) - ETA INTERFACES HEIGHT FIELD
C     SM   (IM,JM)     - SEA MASK
C     HGT  (IM,JM)     - SURFACE ELEVATION ARRAY
C     LMH  (IM,JM)     - TOPOGRAPHY INDEXES ARRAY
C     IM,JM            - ARRAY DIMENSIONS FOR HORIZONTAL GRIDS
C                        IN A VECTORIZED FORM
C     KHL00            - INDEX POINTING TO THE BEGIN OF INTERNAL H-POINTS
C                        IN HORIZONTAL GRIDS
C     KHH00            - INDEX POINTING TO THE END OF INTERNAL H-POINTS
C                        IN HORIZONTAL GRIDS
C     LM               - ARRAY DIMENSION FOR VERTICAL GRIDS
C     LP1              = LM+1
C
C
C     OUTPUT:
C     -------
C
C     EL0 (IM,JM)      - ARRAY OF RESULTING ASYMPTOTIC MIXING LENGTHS
C
C
C     SCRATCH AREAS:
C     --------------
C
C     SQZ(IM,JM),SQ(IM,JM),RQ2L(IM,JM),RQ2H(IM,JM)
C
C
C     RELEVANT CONSTANTS:
C     -------------------
C
C     PROPORTIONALITY CONSTANT BETWEEN ASYMPTOTIC MIXING LENGTH AND THE
C     S.D. OF Q DISTRIBUTION, FOR LAND AND SEA AREAS, CORRESPONDINGLY:
      PARAMETER (ALPHAL=0.2, ALPHAS=0.2)
C
C     ASYMPTOTIC MIXING LENGTH LIMITATIONS:
      PARAMETER (EL0M=300.0, ELMIN=11.0)
C
C     MINIMAL VALUE OF TURBULENT ENERGY:
      PARAMETER (EPSQ2=0.2)
C
C     ------------------------------------------------------------------
C
                         D I M E N S I O N
     & DETA(LM),PDSL(IM,JM),HTM(IM,JM,LM),Q2(IM,JM,LM)
     &,ZINT(IM,JM,LP1),SM(IM,JM),HGT(IM,JM),EL0(IM,JM),LMH(IM,JM)
     &,SQZ(IM,JM),SQ(IM,JM),RQ2L(IM,JM),RQ2H(IM,JM)
C     ------------------------------------------------------------------
C
      INCLUDE "CTLBLK.comm"
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        SQZ(I,J)=0.0
        SQ(I,J)=0.0
        RQ2H(I,J)=0.0
      ENDDO
      ENDDO
C
      DO 220 L=1,LM
!$omp  parallel do
!$omp& private(dp,rq2m)
      DO J=JSTA,JEND
      DO I=1,IM
        IF(Q2(I,J,L).LE.EPSQ2) THEN
          RQ2L(I,J)=0.0
        ELSE
          RQ2L(I,J)=SQRT(Q2(I,J,L))
        ENDIF
C
C         -----------------------------------------------------------------
C         THIS PART OF THE CODE IS LEFT FOR TESTING OTHER PARAMETERIZATION
C         SCHEMES 
C
C         IF (L.GE.LMH(I,J)) GOTO 215
c         RQ2L(I,J)=SQRT(Q2(I,J,L))
c         IF(Q2(I,J,L).LT.0.0)THEN
c           write(3,*)'NEGATIVE Q2 AT (I,J,L)=(',I,',',J,',',L,'): ',
c                     Q2(I,J,L)
c           STOP
c         ENDIF
C         -----------------------------------------------------------------
C
          DP=DETA(L)*PDSL(I,J)*HTM(I,J,L)
C***
C***      SUM OF Q2 AT BOTH LOWER & UPPER SURFACES:
C***
          RQ2M=(RQ2H(I,J)+RQ2L(I,J))
C***
C***      INTEGRAL OF Q*Z OVER DP
C***
          SQZ(I,J)=((ZINT(I,J,L)+ZINT(I,J,L+1))*0.5-HGT(I,J))*RQ2M*DP
     1              +SQZ(I,J)
C***
C***      INTEGRAL OF Q OVER DP:
C***
          SQ(I,J)=RQ2M*DP+SQ(I,J)
          RQ2H(I,J)=RQ2L(I,J)
      ENDDO
      ENDDO
c215  CONTINUE
 220  CONTINUE
C***
C***    CLIPPING & APPLYING DIFFERENT VALUES OF THE PROPORTIONALITY 
C***    CONSTANT ALPHA FOR THE LAND AND SEA AREA:
C***
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        EL0(I,J)= AMAX1(AMIN1(
     1    ((SM(I,J)*ALPHAS+(1.0-SM(I,J))*ALPHAL)*SQZ(I,J)
     2     /(SQ(I,J)+EPSQ2)),
     3    EL0M),ELMIN)
      ENDDO
      ENDDO
C
      RETURN
      END

      subroutine stat ( a, im, jm )
      real(8) sum
      real(8) count
      real a ( im, jm )
       imax = 1
       imin = 1
       jmax = 1
       jmin = 1
       aamax = a(1,1)
       aamin = a(1,1)
       sum = 0.
       count = im * jm
       do j = 1, jm
          do i = 1, im
             sum = sum + a(i,j)
             if ( a(i,j) .gt. aamax ) then
                aamax = a(i,j)
                imax = i
                jmax = j
             end if
             if ( a(i,j) .lt. aamin ) then
                aamin = a(i,j)
                imin = i
                jmin = j
             end if
          end do
       end do
       print *, ' amax(',imax,',',jmax,')= ',aamax,
     &          ' amin(',imin,',',jmin,')= ',aamin,' avg = ',sum/count
      end

      SUBROUTINE SIG2PSPLINE(IMOUT,JMOUT)
C     ******************************************************************
C     *                                                                *
C     *  THIS IS THE PROGRAM FOR CONVERSION FROM SIGMA TO P SYSTEM     *
C     *  USING SPLINE FITTING                                          *
C     *  02-1981 TO 03- 1998 Z. JANJIC, D. JOVIC, S. NICKOVIC          *
C     *  09-2000  H CHUANG MODIFIED THE PROGRAM TO BE INCLUDED IN      *
C     *              OPERATIONAL POST                                  *
C     *  NOTE: CURRENT POST ONLY PROCESS UP TO 1000 MB PRESSURE LEVEL  *
C     *        2 ADDITIONAL LEVELS (1025 1050) ARE ADDED DURING SPLINE *
C     *        FITTING COMPUTATION BUT THE FIELDS ON THESE TWO LEVELS  *
C     *        ARE NOT OUTPUT TO GRID FILES                            *   
C     ******************************************************************
!-----------------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"    
!-----------------------------------------------------------------------
Cmptest      parameter(nsmud=100,lp2=lm+2,LSMP2=LSM+2)
      parameter(nsmud=25,lp2=lm+2,LSMP2=LSM+2)
      parameter(zero=1.e-5)
      parameter(iii=2,jjj=2)
c-----------------------------------------------------------------------
      LOGICAL IOOMG,IOALL
                             d i m e n s i o n
     &ihw(jm),ihe(jm),ivw(jm),ive(jm)
c
     &,ztt   (lm+1)
     &,tcol  (lm+1),ocol  (lm+1),qcol  (lm+1),cwcl  (lm+1)
     &,zth   (lm+2)
     &,hcol  (lm+2),q2cl  (lm+2)
     &,ztu   (lm+1),ztv   (lm+1)
     &,ucol  (lm+1),vcol  (lm+1)
c
     &,y2    (lm+2),phld  (lm+2),qhld  (lm+2)
c
     &,ztsl  (lsmp2),ovrlx (lsmp2)
     &,tcolsl(lsmp2),ocolsl(lsmp2),qcolsl(lsmp2),cwclsl(lsmp2)
     &,hcolsl(lsmp2),q2clsl(lsmp2)
     &,ucolsl(lsmp2),vcolsl(lsmp2)
C
     &,hcol3(3),pcol3(3),y23(3)
c     
     &,tmask (im,jm),hs    (im,jm)
c
     &,tsll  (im,jm),osll  (im,jm),qsll  (im,jm),qcll  (im,jm)
     &,fsll  (im,jm),q2ll  (im,jm)
c
     &,zet   (im,jm,lm+1)
c
     &,tprs(im,jm,lsmp2) ,oprs(im,jm,lsmp2),qprs(im,jm,lsmp2)
     &,fprs(im,jm,lsmp2) ,qcprs(im,jm,lsmp2),q2prs(im,jm,lsmp2)
     &,uprs(im,jm,lsmp2) ,vprs(im,jm,lsmp2)
c
      real iw(im,jm,lm),IWU,IWL,icecl(lm+1),icelsl(lsmp2),icell(im,jm)
     &,iceprs(im,jm,lsmp2) 
      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT)
cc      REAL,ALLOCATABLE,DIMENSION(:,:,:)::tprs,oprs,qprs,fprs
cc     +,qcprs,q2prs,uprs,vprs 
!-----------------------------------------------------------------------
c      equivalence
c     & (t(1),tsl(1))
c     &,(q(1),qsl(1))
c     &,(cwm(1),qcsl(1))
c     &,(q2(1),q2sl(1))
c     &,(omgalf(1),osl(1))
c     &,(div(1),dsl(1))
c     &,(u(1),usl(1))
c     &,(v(1),vsl(1))
c     &,(dwdt(1),dwsl(1))
c     &,(w(1),wsl(1))
!-----------------------------------------------------------------------
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "E2PFLG.comm"
      INCLUDE "DYNAMD.comm"
!-----------------------------------------------------------------------
                              d a t a
     & y2/lp2*0./
!-----------------------------------------------------------------------
                              d a t a
     & ovrlx/lsmp2*0.175/
!-----------------------------------------------------------------------
C     VERTICAL INTERPOLATION.  EXECUTE ONLY
C     IF THERE'S SOMETHING WE WANT.
C
      IF((IGET(012).GT.0).OR.(IGET(013).GT.0).OR.
     X   (IGET(014).GT.0).OR.(IGET(015).GT.0).OR.
     X   (IGET(016).GT.0).OR.(IGET(017).GT.0).OR.
     X   (IGET(018).GT.0).OR.(IGET(019).GT.0).OR.
     X   (IGET(020).GT.0).OR.(IGET(030).GT.0).OR.
     X   (IGET(021).GT.0).OR.(IGET(022).GT.0).OR.
     X   (IGET(153).GT.0).OR.(IGET(166).GT.0).OR.
     X   (IGET(23).GT.0)) THEN
C
C  SET UP UTIM FOR THIS TIME STEP
C
       UTIM=1.
       CLIMIT=1.E-20
c
       DO 75 L=1,LM
        IF(L.EQ.1)THEN
         DO J=JSTA,JEND
          DO I=1,IM
           IW(I,J,L)=0.
          ENDDO
         ENDDO
         GO TO 75
        ENDIF
        doout70: DO J=JSTA,JEND
         doin70: DO I=1,IM
          LML=LM-LMH(I,J)
          HH=HTM(I,J,L)*HBM2(I,J)
          TKL=T(I,J,L)
          QKL=Q(I,J,L)
          CWMKL=CWM(I,J,L)
          TMT0=(TKL-273.16)*HH
          TMT15=AMIN1(TMT0,-15.)*HH    
          PP=PDSL(I,J)*AETA(L)+PT
          QW=HH*PQ0/PP*EXP(HH*A2*(TKL-A3)/(TKL-A4))
          QI=QW*(1.+0.01*AMIN1(TMT0,0.))     
          U00KL=U00(I,J)+UL(L+LML)*(0.95-U00(I,J))*UTIM
C
          IF(TMT0.LT.-15.0)THEN
           FIQ=QKL-U00KL*QI
           IF(FIQ.GT.0..OR.CWMKL.GT.CLIMIT) THEN
            IW(I,J,L)=1.
           ELSE
            IW(I,J,L)=0.
           ENDIF
          ENDIF
C
          IF(TMT0.GE.0.0)IW(I,J,L)=0.
          IF(TMT0.LT.0.0.AND.TMT0.GE.-15.0)THEN
           IW(I,J,L)=0.
           IF(IW(I,J,L-1).EQ.1..AND.CWMKL.GT.1.E-20)IW(I,J,L)=1.
          ENDIF
C
        END DO doin70
        END DO doout70
   75  CONTINUE
c       	  
       do 100 l=1,lsm
        ztsl(l)=alog(spl(l))**2
 100   continue
       ztsl(lsm+1)=alog(102500.)**2  
       ztsl(lsmp2)=alog(105000.)**2	
c
       ztbot=ztsl(lsmp2)
c
       do 110 j=jsta,jend
        ihw(j)=  -mod(j,2)
        ihe(j)= 1-mod(j,2)
        ivw(j)=-1+mod(j,2)
        ive(j)=   mod(j,2)
 110   continue
c
cc       allocate(tprs(im,jm,lsmp2)) 
cc       allocate(oprs(im,jm,lsmp2))
cc       allocate(qprs(im,jm,lsmp2))
cc       allocate(fprs(im,jm,lsmp2))
cc       allocate(qcprs(im,jm,lsmp2))
cc       allocate(q2prs(im,jm,lsmp2))
cc       allocate(uprs(im,jm,lsmp2))
cc       allocate(vprs(im,jm,lsmp2))
c--------------mass point variables at pressure levels------------------
       do 200 j=jsta,jend
        ihl=1
        ihh=im-1+mod(j,2)
        do 201 i=ihl,ihh
	 if(abs(pdsl(i,j)-pd(i,j)).gt. 1)print*,'inconsistent pd',i,j
     +,  pd(i,j),pdsl(i,j) 	 
         pdp=pdsl(i,j)
c
         hsp=fis(i,j)/g
         hcol(lm+1)=hsp
         hs(i,j)=hsp
c
c         alp1l=alog(pint(i,j,lm+1))   ! for nonhydrostatic version
         alp1l=alog(pt+pdp)
         alp2l=(alog(pdp+pt))**2
         zth(lm+1)=alp2l
c
c         pcol(1)=pt
         q2cl(1)=0.
c--------------loading values at mid-layers and interfaces--------------
         do 220 ivi=1,lm
          l=lm+1-ivi
c
c          alp1u=alog(pint(i,j,l))   ! for nonhydrostatic version
          alp1u=alog(eta(l)*pdp+pt)
          alp2u=(alog(eta(l)*pdp+pt))**2
c
          dpd=(eta(l+1)-eta(l))*pdp
c
c         dh=(q(i,j,l)*0.608+1.)*(alp1l-alp1u)*t(i,j,l)*RD/g
c     2   *dpd/(pint(i,j,l+1)-pint(i,j,l))
          dh=(q(i,j,l)*0.608+1.)*(alp1l-alp1u)*t(i,j,l)*RD/g
c
          alpcp=dh*g/(dpd*cp)
c
          zth(l)=alp2u
czj!!      ztt(l)=(alp2l+alp2u)*0.5
          ztt(l)=alog((eta(l)+eta(l+1))*0.5*pdp+pt)**2
c	  if(i.eq.120.and.j.eq.279)print*,'l,eta(l),eta(l+1),ztt='
c     +,   l,eta(l),eta(l+1),ztt(l),pdp,pt	  
c
          tcol(l)=t(i,j,l)
          ocol(l)=omga(i,j,l)/alpcp
          qcol(l)=q(i,j,l)
          cwcl(l)=cwm(i,j,l)*(1-iw(i,j,l))
	  icecl(l)=cwm(i,j,l)*iw(i,j,l)
c
c          pcol(l+1)=pint(i,j,l+1)
          q2cl(l+1)=q2(i,j,l+1)     
          hcol(l  )=hcol(l+1)+dh
c
          alp1l=alp1u
          alp2l=alp2u
 220     continue
c-------------extrapolation underground for mid-layer variables---------
         if((ztt(lm)-ztbot) .ge. 0.0)then
          lmd=lm
         else
          lmd=lm+1
c
          ztt(lm+1)=ztbot
c
          dum=(tcol(lm)-tcol(lm-4))/(ztt(lm)-ztt(lm-4))
          x=ztbot-ztt(lm)
c
          tcol(lm+1)=dum*x+tcol(lm)
          ocol(lm+1)=0.
          qcol(lm+1)=0.
          cwcl(lm+1)=0.
	  icecl(lm+1)=0.
         endif
         if(i.eq.iii.and.j.eq.jjj)then
	  print*,'on sigma at ',iii,jjj
	  print*,'terrain= ',fis(i,j)/g
	  do l=1,lmd
	   print*,'l,P,T= ',l,exp(ztt(l)**0.5),tcol(l) 	
          end do
	 end if
c         if(i.eq.120.and.j.eq.279)then
c	  print*,'lmd, ztbot= ',lmd,ztbot
c	  print*,'ztt=',ztt
c	 end if 
c-------------interpolation of mid-layer variables to pressure levels---
         y2(lmd)=0.
c	
         call splinef(lmd,ztt,tcol,y2,lsmp2,ztsl,tcolsl,phld,qhld)
         call splinef(lmd,ztt,ocol,y2,lsmp2,ztsl,ocolsl,phld,qhld)
         call splinef(lmd,ztt,qcol,y2,lsmp2,ztsl,qcolsl,phld,qhld)
         call splinef(lmd,ztt,cwcl,y2,lsmp2,ztsl,cwclsl,phld,qhld)
	 call splinef(lmd,ztt,icecl,y2,lsmp2,ztsl,icelsl,phld,qhld)
c
         do 230 l=1,lsmp2
          tprs (i,j,l)=tcolsl(l)
	  oprs (i,j,l)=ocolsl(l)
          qprs (i,j,l)=qcolsl(l)
          qcprs(i,j,l)=cwclsl(l)
	  iceprs(i,j,l)=icelsl(l)
 230     continue
c-------------extrapolation underground for interface variables---------
         if(zth(lm+1).ge.ztbot)    then
          lmd=lm+1      
         else
          lmd=lm+2
c
          zth(lm+2)=ztbot
          x=ztbot-zth(lm+1)
c          if(abs(x/ztbot).lt.zero)x=0.
c
          dum=(hcol(lm+1)-hcol(lm-5))/(zth(lm+1)-zth(lm-5))
          d2=0.
c
c          if(x.lt.0.0000001)print*,'i,j,zth(lm+1),ztbot,x= ',i,j
c     +	  ,zth(lm+1),ztbot,x
          hcol(lm+2)=d2*x*x+dum*x+hcol(lm+1)
c          pcol(lm+2)=spl(lsmp2)
          q2cl(lm+2)=0.
         endif
c-------------interpolation of interface variables to pressure levels---
         if(i.eq.iii.and.j.eq.jjj)then
	  print*,'on sigma at ',iii,jjj
	  do l=1,lmd
	   print*,'l,H,P= ',l,hcol(l),exp(zth(l)**0.5) 	
          end do
	 end if
c
         y2(lmd)=0.
c
         call splinef(lmd,zth,hcol,y2,lsmp2,ztsl,hcolsl,phld,qhld)
c         call splinef(lmd,zth,pcol,y2,lsmp2,ztsl,pcolsl,phld,qhld)
         call splinef(lmd,zth,q2cl,y2,lsmp2,ztsl,q2clsl,phld,qhld)
c
         if(i.eq.iii.and.j.eq.jjj)then
	  print*,'on pressure before relaxation at ',iii,jjj
	  do l=1,lsmp2
	   print*,'l,H,P,T= ',l,hcolsl(l),exp(ztsl(l)**0.5)
     +	   ,tcolsl(l) 	
          end do
	 end if
c	 
         do 240 l=1,lsmp2
          fprs (i,j,l)=hcolsl(l)
c          psl (i,j,l)=pcolsl(l)
          q2prs(i,j,l)=max(q2clsl(l),0.)
 240     continue
c
         do 250 l=1,lm+1
          zet(i,j,l)=zth(l)
 250     continue
 201    continue  
 200   continue
c--------------filling boundaries--------------------------------------
       do 260 l=1,lm+1
        do 261 j=jsta,jend
         zet(im,j,l)=zet(im-1,j,l)
 261    continue
 260   continue
c--------------end of mass point interpolations------------------------
c
c
       print*,'in sig2pspline before relaxation of mass points'
       do 300 l=1,lsmp2
c--------------filling remaining undefined mass point boundaries-------
        if(mod(jsta,2) .lt. 1)then   !even jsta
         do 351 j=jsta,jend,2
          tprs(im,j,l)=tprs(im-1,j,l)
          oprs(im,j,l)=oprs(im-1,j,l)
          qprs(im,j,l)=qprs(im-1,j,l)
          qcprs(im,j,l)=qcprs(im-1,j,l)
	  iceprs(im,j,l)=iceprs(im-1,j,l)
          fprs(im,j,l)=fprs(im-1,j,l)
          q2prs(im,j,l)=q2prs(im-1,j,l)
 351     continue
        else
	 do 352 j=jsta+1,jend,2
          tprs(im,j,l)=tprs(im-1,j,l)
          oprs(im,j,l)=oprs(im-1,j,l)
          qprs(im,j,l)=qprs(im-1,j,l)
          qcprs(im,j,l)=qcprs(im-1,j,l)
	  iceprs(im,j,l)=iceprs(im-1,j,l)
          fprs(im,j,l)=fprs(im-1,j,l)
          q2prs(im,j,l)=q2prs(im-1,j,l)
 352     continue
        end if    
c	if(l.eq.lsm)then
c	 print*,'1000 mb enormal height'
c         do i=1,im
c	  do j=jsta,jend
c	   if(fprs(i,j,l).gt.200.)print*,i,j,fprs(i,j,l)
c          end do
c         end do
c	end if 
c--------------smoothing pressure levels ruptured by topography--------
        rlx=ovrlx(l)
        yes=0.
c
        avt=0.
        avh=0.
        kt=0
        kh=0 
        do 310 j=jsta,jend
         ihl=1
         ihh=im-1+mod(j,2)
         do 311 i=ihl,ihh
          href=hs(i,j)
          if(href.gt.300.) then
           href=href+1500.
          endif
          if(href.ge.fprs(i,j,l))then
           yes=1.
           tmask(i,j)=rlx
          else
           tmask(i,j)=0.
c
c      avt=tprs(i,j,l)+avt
c      avh=fprs(i,j,l)+avh
c      kt=kt+1
c      kh=kh+1
c
          endif
c          if(href.ge.fprs(i,j,l).and.l.lt.lsm)then
c	   tprs(i,j,l)=(((fprs(i,j,l-1)-fprs(i,j,l)))
c     &           /((alog(spl(l))-alog(spl(l-1))))
c     &           +((fprs(i,j,l)-fprs(i,j,l+1)))
c     &           /((alog(spl(l+1))-alog(spl(l)))))*0.5*g/rd
c          end if
          if(href.ge.fprs(i,j,l))then
           if(l.lt.lsmp2)then
            tprs(i,j,l)=(((fprs(i,j,l-1)-fprs(i,j,l)))
     &	         /(ztsl(l)**0.5-ztsl(l-1)**0.5)
     &           +((fprs(i,j,l)-fprs(i,j,l+1)))
     &           /(ztsl(l+1)**0.5-ztsl(l)**0.5))*0.5*g/rd
           else
            tprs(i,j,l)=tprs(i,j,l-1)+(tprs(i,j,l-1)-tprs(i,j,l-2))
     &       *(ztsl(l)-ztsl(l-1))/(ztsl(l-1)-ztsl(l-2))  
           end if
          end if 
 311     continue
 310    continue
c
c??        if(yes.gt.0.)then
c
c              if(kt*kh.ne.0)    then
c          avt=avt/kt
c          avh=avh/kh
c              endif
c
         do 312 j=jsta,jend
          ihl=1
          ihh=im-1+mod(j,2)
          do 313 i=ihl,ihh
           if(hs(i,j).ge.fprs(i,j,l))then
            oprs(i,j,l)=0.
            qprs(i,j,l)=0.
            qcprs(i,j,l)=0.
	    iceprs(i,j,l)=0.
            q2prs(i,j,l)=0.
           endif
 313      continue
 312     continue 
         do 320 n=1,nsmud
	  call exch(tprs(1,1,l))
	  call exch(oprs(1,1,l))
	  call exch(qprs(1,1,l))
	  call exch(qcprs(1,1,l))
	  call exch(iceprs(1,1,l))
	  call exch(fprs(1,1,l))
	  call exch(q2prs(1,1,l))
          do 330 j=jsta_m,jend_m
           ihl=1+mod(j,2)
           ihh=im-1
           do 331 i=ihl,ihh
            if(tmask(i,j).gt.0.05) then
             tsll(i,j)=tprs(i+ihw(j),j-1,l)+tprs(i+ihe(j),j-1,l)
     2         +tprs(i+ihw(j),j+1,l)+tprs(i+ihe(j),j+1,l)-tprs(i,j,l)*4.
             osll(i,j)=oprs(i+ihw(j),j-1,l)+oprs(i+ihe(j),j-1,l)
     2         +oprs(i+ihw(j),j+1,l)+oprs(i+ihe(j),j+1,l)-oprs(i,j,l)*4.
             qsll(i,j)=qprs(i+ihw(j),j-1,l)+qprs(i+ihe(j),j-1,l)
     2         +qprs(i+ihw(j),j+1,l)+qprs(i+ihe(j),j+1,l)-qprs(i,j,l)*4.
             qcll(i,j)=qcprs(i+ihw(j),j-1,l)+qcprs(i+ihe(j),j-1,l)
     2       +qcprs(i+ihw(j),j+1,l)+qcprs(i+ihe(j),j+1,l)-qcprs(i,j,l)*4.
             icell(i,j)=iceprs(i+ihw(j),j-1,l)+iceprs(i+ihe(j),j-1,l)
     2       +iceprs(i+ihw(j),j+1,l)+iceprs(i+ihe(j),j+1,l)
     3       -iceprs(i,j,l)*4.
             fsll(i,j)=fprs(i+ihw(j),j-1,l)+fprs(i+ihe(j),j-1,l)
     2         +fprs(i+ihw(j),j+1,l)+fprs(i+ihe(j),j+1,l)-fprs(i,j,l)*4.
             q2ll(i,j)=q2prs(i+ihw(j),j-1,l)+q2prs(i+ihe(j),j-1,l)
     2       +q2prs(i+ihw(j),j+1,l)+q2prs(i+ihe(j),j+1,l)-q2prs(i,j,l)*4.
            endif
 331       continue
 330      continue
          do 340 j=jsta_m,jend_m
           ihl=1+mod(j,2)
           ihh=im-1
           do 341 i=ihl,ihh
            if(tmask(i,j).gt.0.05) then
             tprs (i,j,l)=tsll(i,j)*tmask(i,j)+tprs (i,j,l)
             oprs (i,j,l)=osll(i,j)*tmask(i,j)+oprs (i,j,l)
             qprs (i,j,l)=qsll(i,j)*tmask(i,j)+qprs (i,j,l)
             qcprs(i,j,l)=qcll(i,j)*tmask(i,j)+qcprs(i,j,l)
	     iceprs(i,j,l)=icell(i,j)*tmask(i,j)+iceprs(i,j,l)
             fprs (i,j,l)=fsll(i,j)*tmask(i,j)+fprs (i,j,l)
             q2prs(i,j,l)=max(q2ll(i,j)*tmask(i,j)+q2prs(i,j,l),0.)
            endif
 341       continue
 340      continue
 320     continue
c??        endif
 300   continue
       print*,'in sig2pspline after relaxation of mass points'
ccc Recalculate QC so that RHs underground are the same as that at lowest
ccc level above ground
       doout346: do j=jsta,jend
        ihl=1
        ihh=im-1+mod(j,2)
        doin346: do i=ihl,ihh 
         do347: do l=1,lsmp2
	  gar1=(eta(lm)+eta(lm+1))*0.5*pdsl(i,j)+pt
	  gar2=exp(ztsl(l)**0.5)
	  if(gar2.gt.gar1)then
	   qw=PQ0/exp(ztsl(l-1)**0.5)*EXP(A2*(tprs(i,j,l-1)-A3)
     +	   /(tprs(i,j,l-1)-A4))
	   rhl=qprs(i,j,l-1)/qw  
	   if(rhl.gt.1)then
cc	    print*,'enormal rh',i,j,rhl
	    rhl=1.
	   end if 
	   if(i.eq.iii.and.j.eq.jjj)print*,'sample rh',rhl
	   do ll=l,lsmp2
	    qw=PQ0/exp(ztsl(ll-1)**0.5)*EXP(A2*(tprs(i,j,ll-1)-A3)
     +  	    /(tprs(i,j,ll-1)-A4))
	    qprs(i,j,ll)=rhl*qw
	   end do
	   exit do347  
          end if
         end do do347
         end do doin346
         end do doout346
c
c--------------velocity point variables at pressure levels--------------
       do l=1,lm+1
        call exch(zet(1,1,l))
       end do
       print*,'in sig2pspline after relaxation of zet'
       do 400 j=jsta_m,jend_m
        ivl=2-mod(j,2)
        ivh=im-1
        do 401 i=ivl,ivh
         zup=(zet(i,j-1,1)+zet(i+ivw(j),j,1)
     2    +zet(i+ive(j),j,1)+zet(i,j+1,1))
         zupu=(zet(i+ivw(j),j,1)+zet(i+ive(j),j,1)+zup)/12.
         zupv=(zet(i,j-1,1)+zet(i,j+1,1)+zup)/12.
c--------------loading variables into vertical columns------------------
         do 410 l=1,lm
          zlo=(zet(i,j-1,l+1)+zet(i+ivw(j),j,l+1)
     2    +zet(i+ive(j),j,l+1)+zet(i,j+1,l+1))
          zlou=(zet(i+ivw(j),j,l+1)+zet(i+ive(j),j,l+1)+zup)/12.
          zlov=(zet(i,j-1,l+1)+zet(i,j+1,l+1)+zup)/12.
c
          ztu(l)=zlou+zupu
          ztv(l)=zlov+zupv
c
          ucol(l)=u(i,j,l)
          vcol(l)=v(i,j,l)
cc	  if(ucol(l).gt.100.)print*,'large I u ',i,j,l,ucol(l)
cc	  if(vcol(l).gt.100.)print*,'large I v ',i,j,l,vcol(l)
c
          zup=zlo
          zupu=zlou
          zupv=zlov
 410     continue 
c
cc         if(amin1(ztu(lm),ztv(lm)).ge.ztbot)then
cc          lmd=lm
cc         else
cc          lmd=lm+1
cc          ztu(lm+1)=ztbot
cc          ztv(lm+1)=ztbot
cc          ucol(lm+1)=ucol(lm)
cc          vcol(lm+1)=vcol(lm)
cc         endif
c
         if(ztu(lm).ge.ztbot)then
          lmd=lm
         else
          lmd=lm+1
          ztu(lm+1)=ztbot
          ucol(lm+1)=ucol(lm)
         endif
c	 
         y2(lmd)=0.
c	 
         if(i.eq.iii.and.j.eq.jjj)then
	  print*,'large input wind input at',i,j
	  do l=1,lmd
	   print*,l,ztu(l),ztv(l),ucol(l),vcol(l)
	  end do
	 end if
c	 
         call splinef(lmd,ztu,ucol,y2,lsmp2,ztsl,ucolsl,phld,qhld)
c	 
         if(ztv(lm).ge.ztbot)then
          lmd=lm
         else
          lmd=lm+1
          ztv(lm+1)=ztbot
          vcol(lm+1)=vcol(lm)
         endif
	 y2(lmd)=0.
         call splinef(lmd,ztv,vcol,y2,lsmp2,ztsl,vcolsl,phld,qhld) 
c
         do 420 l=1,lsmp2
cc	  if(ucolsl(l).gt.100.)print*,'large O u ',i,j,l,ucolSL(l)
cc	  if(vcolSL(l).gt.100.)print*,'large O v ',i,j,l,vcolSL(l)
          uprs(i,j,l)=ucolsl(l)
          vprs(i,j,l)=vcolsl(l)
 420     continue
         if(i.eq.iii.and.j.eq.jjj)then
	  print*,'output wind before geostrophic adjus',i,j
	  do l=1,lsmp2
	   print*,l,ztsl(l),uprs(i,j,l),vprs(i,j,l)
	  end do
	 end if 
cc         if(hs(i,j).gt.300.) then
cc          href=hs(i,j)+1500.
cc         endif
	 do l=1,lsmp2
          if(ztsl(l).ge.amin1(ztu(lm),ztv(lm)))then
	   do ll=l,lsmp2
            uprs(i,j,ll)=uprs(i,j,l-1)
	    vprs(i,j,ll)=vprs(i,j,l-1) 
cc	    ihve=i+mod(j,2)
cc	    ihvw=ihve-1
cc	    TPHI=(J-JMT)*DPHD*DTR
cc	    favg=0.25*(F(I+IHVE,J)+F(I+IHVW,J)
cc     1           +F(I,J+1)+F(I,J-1))*2./dt
cc     2           +uprs(i,j,l-1)*tan(tphi)/erad 
cc            if(i.eq.iii.and.j.eq.jjj)print*,'sample F',favg
cc	    uprs(i,j,ll)=-g/favg*(fprs(i,j+1,ll)-fprs(i,j-1,ll))
cc     1          	    /dy/2.
cc	    vprs(i,j,ll)=g/favg*(fprs(i+ihve,j,ll)-fprs(i+ihvw,j,ll))
cc     1          	    /dx(i,j)/2.
	   end do
	   go to 403
	  end if  
	 end do 
 403     continue
c 
         do l=1,lsmp2 
         if(uprs(i,j,l).gt.100.)print*,'large O u ',i,j,l,uprs(i,j,l)
	 if(vprs(i,j,l).gt.100.)print*,'large O v ',i,j,l,vprs(i,j,l) 
         end do 
         if(i.eq.iii.and.j.eq.jjj)then
	  print*,'output wind after geostrophic adjus',i,j
	  do l=1,lsmp2
	   print*,l,ztsl(l),uprs(i,j,l),vprs(i,j,l)
	  end do
	 end if  
 401    continue
 400   continue
c--------------end of wind point interpolations------------------------
       do l=1,lsmp2
c--------------filling remaining undefined wind point boundaries-------
        do j=jsta_m,jend_m
         uprs(1,j,l)=uprs(2,j,l)
         uprs(im,j,l)=uprs(im-1,j,l)
         vprs(1,j,l)=vprs(2,j,l)
         vprs(im,j,l)=vprs(im-1,j,l)
        enddo
	if(me.eq.0)then
	 do i=1,im	 
          uprs(i,1,l)=uprs(i,3,l)
          vprs(i,1,l)=vprs(i,3,l)
         enddo
	end if
	if(me.eq.(NUM_PROCS-1))then
         do i=1,im	 
          uprs(i,jm,l)=uprs(i,jm-2,l)
          vprs(i,jm,l)=vprs(i,jm-2,l)
         enddo
	end if
c-----------------------------------------------------------------------
       enddo
c--------------sea level pressure---------------------------------------
CCC COMMENT OUT SEA LEVEL PRESSURE REDUCTION BECAUSE IT'S DONE IN QUILT NOW
cc       do 600 j=jsta,jend
cc        ihl=1
cc        ihh=im-1+mod(j,2)
cc        do 601 i=ihl,ihh
cc         if(fis(i,j).gt.-1..and.fis(i,j).lt.1.) then
c          pslp(i,j)=pint(i,j,lm+1)
cc          pslp(i,j)=pt+pd(i,j) 
cc         else
cc	  if(fprs(i,j,lsmp2).gt.0)then
cc	   gar=exp(ztsl(lsmp2)**0.5)+5000.
cc	   hcol3(1)=fprs(i,j,lsmp2)+(fprs(i,j,lsmp2)-fprs(i,j,lsmp2-5))
cc     +     *(alog(gar)**2.-ztsl(lsmp2))/(ztsl(lsmp2)-ztsl(lsmp2-5))
cc           hcol3(2)=fprs(i,j,lsmp2)
cc	   hcol3(3)=fprs(i,j,lsmp2-1) 
cc	   pcol3(1)=gar      
cc           pcol3(2)=exp(ztsl(lsmp2)**0.5)  
cc           pcol3(3)=exp(ztsl(lsmp2-1)**0.5)	 
cc	  else   
cc	   do l=lsmp2,2,-1 
cc	    if(fprs(i,j,l).le.0. .and. fprs(i,j,l-1).gt.0.)then 
cc	     lll=l
cc	     go to 603
cc	    end if 
cc	   end do  
cc 603       hcol3(1)=fprs(i,j,lll)      
cc           hcol3(2)=fprs(i,j,lll-1)    
cc           hcol3(3)=fprs(i,j,lll-2)    
cc           pcol3(1)=exp(ztsl(lll)**0.5)    
cc           pcol3(2)=exp(ztsl(lll-1)**0.5)     
cc           pcol3(3)=exp(ztsl(lll-2)**0.5)     
cc          end if
cc          do l=1,3
cc           y23(l)=0.0
cc          end do
cc          call splinef(3,hcol3,pcol3,y23,1,0.0,slp1,phld,qhld)
cc          pslp(i,j)=slp1
cc         endif
cc         if(pslp(i,j).lt.65000.OR.PSLP(I,J).GT.105000.) print*,
cc     +    'alert, pslp lt 650 or gt 1050 at ',i,j,pslp(i,j)
c     +,  hcol3(2),hcol3(3),pcol3(1),pcol3(2),pcol3(3) 
cc         if(i.eq.iii.and.j.eq.jjj)then
cc	  print*,'on P after relaxation at ',iii,jjj
cc	  do l=1,lsmp2
cc	   print*,'l,H,P,T,U,V= ',l,fprs(i,j,l),exp(ztsl(l)**0.5)
cc     +,    tprs(i,j,l),uprs(i,j,l),vprs(i,j,l) 	
cc          end do
cc	  print*,'pslp = ',pslp(i,j)
cc	 end if    
cc 601    continue
cc 600   continue
C
C*********  END OF VERTICAL INTERPOLATION       
C      
C        INTERPOLATE HORIZONTALLY/OUTPUT SELECTED FIELDS.
C
C---------------------------------------------------------------------
C     
C***  SPECIFIC HUMIDITY.
C
       DO 650 LP=1,LSM
c        print*,'horizontal interp at L=',lp       
        IF(IGET(016).GT.0)THEN
          IF(LVLS(LP,IGET(016)).GT.0)THEN
            CALL E2OUT(016,000,QPRS(1,1,LP),EGRID2,GRID1,GRID2
     +	            ,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            print*,'calling output humidity from sig2pspline'
            CALL OUTPUT(IOUTYP,IGET(016),LP,GRID1,IMOUT,JMOUT)
            if(lp.eq.1)print*,'sample SH IOUTYP',IOUTYP,IGET(016)
          ENDIF
        ENDIF
C     
C***  OMEGA
C
        IF(IGET(020).GT.0)THEN
          IF(LVLS(LP,IGET(020)).GT.0)THEN
            CALL E2OUT(020,000,OPRS(1,1,LP),EGRID2,GRID1,GRID2
     +        	    ,IMOUT,JMOUT)
            ID(1:25)=0
            print*,'calling output omeg from sig2pspline'
            CALL OUTPUT(IOUTYP,IGET(020),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  MOISTURE CONVERGENCE
C
        IF(IGET(085).GT.0)THEN
          IF(LVLS(LP,IGET(085)).GT.0)THEN
            CALL CALMCVG(QPRS(1,1,LP),UPRS(1,1,LP),VPRS(1,1,LP)
     1   	    ,-1,EGRID1)
            CALL E2OUT(085,000,EGRID1,EGRID2,
     1                 GRID1,GRID2,IMOUT,JMOUT)
C
C     CONVERT TO DIVERGENCE FOR GRIB UNITS
C
            CALL SCLFLD(GRID1,-1.0,IMOUT,JMOUT)
            ID(1:25)=0
            print*,'calling output moisture from sig2p'
            CALL OUTPUT(IOUTYP,IGET(085),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  U AND/OR V WIND
C
        IF(IGET(018).GT.0.OR.IGET(019).GT.0)THEN
          IF(LVLS(LP,IGET(018)).GT.0.OR.LVLS(LP,IGET(019)).GT.0)THEN
            CALL E2OUT(018,019,UPRS(1,1,LP),VPRS(1,1,LP),GRID1,GRID2
     1	            ,IMOUT,JMOUT)
            ID(1:25)=0
            IF(IGET(018).GT.0)THEN
              CALL OUTPUT(IOUTYP,IGET(018),LP,GRID1,IMOUT,JMOUT)
            ENDIF
            ID(1:25)=0
            IF(IGET(019).GT.0) 
     1       CALL OUTPUT(IOUTYP,IGET(019),LP,GRID2,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  ABSOLUTE VORTICITY
C
         IF (IGET(021).GT.0) THEN
          IF (LVLS(LP,IGET(021)).GT.0) THEN
            CALL CALVOR(UPRS(1,1,LP),VPRS(1,1,LP),EGRID1)
            CALL E2OUT(021,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(021),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        GEOSTROPHIC STREAMFUNCTION.
         IF (IGET(086).GT.0) THEN
          IF (LVLS(LP,IGET(086)).GT.0) THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=FPRS(I,J,LP)*GI
            ENDDO
            ENDDO
            CALL CALSTRM(EGRID2,EGRID1)
            CALL E2OUT(086,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(086),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C***  TURBULENT KINETIC ENERGY
C
         IF (IGET(022).GT.0) THEN
          IF (LVLS(LP,IGET(022)).GT.0) THEN
            CALL E2OUT(022,000,Q2PRS(1,1,LP),EGRID2,GRID1,GRID2
     +  	    ,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(022),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C***  TOTAL CLOUD WATER
C
         IF (IGET(153).GT.0) THEN
          IF (LVLS(LP,IGET(153)).GT.0) THEN
            CALL E2OUT(153,000,QCPRS(1,1,LP),EGRID2,GRID1,GRID2
     +  	    ,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(153),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C
C***  TOTAL CLOUD ICE 
C
         IF (IGET(166).GT.0) THEN
          IF (LVLS(LP,IGET(166)).GT.0) THEN
            CALL E2OUT(166,000,ICEPRS(1,1,LP),EGRID2,GRID1,GRID2
     +  	    ,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(166),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C
 650   continue
C***  OUTPUT SEA LEVEL PRESSURE IF REQUESTED.
cc        IF(IGET(023).GT.0)THEN
cc          CALL E2OUT(023,000,PSLP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
cc          ID(1:25)=0
cc          CALL OUTPUT(IOUTYP,IGET(023),LVLS(1,IGET(023)),
cc     1                GRID1,IMOUT,JMOUT)
cc        ENDIF
C
C***  SECOND, STANDARD NGM SEA LEVEL PRESSURE.
C
        IF(IGET(105).GT.0)THEN
          CALL NGMSLP2
          CALL E2OUT(105,000,SLP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
          ID(1:25)=0
          CALL OUTPUT(IOUTYP,IGET(105),LVLS(1,IGET(105)),
     1        GRID1,IMOUT,JMOUT)
        ENDIF
C
C---------------------------------------------------------------------
C***  OUTPUT THE TEMPERATURES AND QUANTITIES DERIVED FROM IT
C---------------------------------------------------------------------
C
C     
       DO 680 LP=1,LSM
C***  TEMPERATURE
C
        IF(IGET(013).GT.0) THEN
          IF(LVLS(LP,IGET(013)).GT.0)THEN
             CALL E2OUT(013,000,TPRS(1,1,LP),EGRID2,GRID1,GRID2
     1,                 IMOUT,JMOUT)
             ID(1:25)=0
             CALL OUTPUT(IOUTYP,IGET(013),LP,GRID1,IMOUT,JMOUT)
             if(lp.eq.1)print*,'sample T IOUTYP',IOUTYP,IGET(013)
          ENDIF
        ENDIF
C     
C***  POTENTIAL TEMPERATURE.
C
        IF(IGET(014).GT.0)THEN
          IF(LVLS(LP,IGET(014)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(LP)
            ENDDO
            ENDDO
C
            CALL CALPOT2(EGRID2,TPRS(1,1,LP),EGRID1,IM,JM)
            CALL E2OUT(014,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(014),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  RELATIVE HUMIDITY.
C
        IF(IGET(017).GT.0)THEN
          IF(LVLS(LP,IGET(017)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(LP)
            ENDDO
            ENDDO
C
            CALL CALRH2(EGRID2,TPRS(1,1,LP),QPRS(1,1,LP),ICE,EGRID1
     1,                 IM,JM)
            CALL E2OUT(017,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(017),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  DEWPOINT TEMPERATURE.
C
        IF(IGET(015).GT.0)THEN
          IF(LVLS(LP,IGET(015)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(LP)
            ENDDO
            ENDDO
C
            CALL CALDWP2(EGRID2,QPRS(1,1,LP),EGRID1,TPRS(1,1,LP))
            CALL E2OUT(015,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(015),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C---------------------------------------------------------------------
C***  CALCULATE 1000MB GEOPOTENTIALS CONSISTENT WITH SLP OBTAINED 
C***  FROM THE MESINGER OR NWS SHUELL SLP REDUCTION.
C---------------------------------------------------------------------
C     
C***  FROM MESINGER SLP
C
cc        IF(IGET(023).GT.0.AND.ABS(SPL(LP)-1.E5).LE.0.1)THEN
cc          ALPTH=ALOG(1.E5)
cc!$omp  parallel do private(i,j)
cc          DO J=JSTA,JEND
cc         DO I=1,IM
cc            PSLPIJ=PSLP(I,J)
cc            ALPSL=ALOG(PSLPIJ)
cc            PSFC=PD(I,J)+PT
cc            IEND=IM-MOD(J+1,2)
cc            IF(ABS(PSLPIJ-PSFC).LT.5.E2.OR.
cc     1        ((I.EQ.1.OR.I.LE.IEND.OR.J.LE.2.OR.J.GE.JM-1)
cc     2         .AND.SM(I,J).GT.0.5))THEN
cc              FPRS(I,J,LP)=R*TPRS(I,J,LSL)*(ALPSL-ALPTH)
cc            ELSE
cc              FPRS(I,J,LP)=FIS(I,J)/(ALPSL-ALOG(PD(I,J)+PT))*
cc     1                              (ALPSL-ALPTH)
cc            ENDIF
cc            Z1000(I,J)=FPRS(I,J,LP)*GI
cc          ENDDO
cc          ENDDO
C     
C***  FROM NWS SHUELL SLP. NGMSLP2 COMPUTES 1000MB GEOPOTENTIAL.
C
cc        ELSEIF(IGET(023).LE.0.AND.ABS(SPL(LP)-1.E5).LE.0.1)THEN
cc!$omp  parallel do private(i,j)
cc          DO J=JSTA,JEND
cc          DO I=1,IM
cc            FPRS(I,J,LP)=Z1000(I,J)*G
cc          ENDDO
cc          ENDDO
cc        ENDIF
C
C***  OUTPUT GEOPOTENTIAL (SCALE BY GI)
C
        IF(IGET(012).GT.0)THEN
          IF(LVLS(LP,IGET(012)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J)=FPRS(I,J,LP)
            ENDDO
            ENDDO
C
            if(me.eq.0)print*,'H at (3,3,lp)= ',lp,fprs(3,3,lp)
            CALL E2OUT(012,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(012),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C
  680  CONTINUE
C
        IOALL=.TRUE.
C
C***  ENDIF FOR IF TEST SEEING IF WE WANT ANY OTHER VARIABLES
C
      ENDIF
C     
C     END OF ROUTINE.
C
cc      deallocate(tprs) 
cc      deallocate(oprs)
cc      deallocate(qprs)
cc      deallocate(fprs)
cc      deallocate(qcprs)
cc      deallocate(q2prs)
cc      deallocate(uprs)
cc      deallocate(vprs)
      RETURN
      END
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE SPLINEF(NOLD,XOLD,YOLD,Y2,NNEW,XNEW,YNEW,P,Q)           
C                                                                       
C     ******************************************************************
C     *                                                                *
C     *  THIS IS A ONE-DIMENSIONAL CUBIC SPLINE FITTING ROUTINE        *
C     *  PROGRAMED FOR A SMALL SCALAR MACHINE.                         *
C     *                                                                *
C     *  PROGRAMER[ Z. JANJIC, YUGOSLAV FED. HYDROMET. INST., BEOGRAD  *
C     *                                                                *
C     *                                                                *
C     *                                                                *
C     *  NOLD - NUMBER OF GIVEN VALUES OF THE FUNCTION.  MUST BE GE 3. *
C     *  XOLD - LOCATIONS OF THE POINTS AT WHICH THE VALUES OF THE     *
C     *         FUNCTION ARE GIVEN.  MUST BE IN ASCENDING ORDER.       *
C     *  YOLD - THE GIVEN VALUES OF THE FUNCTION AT THE POINTS XOLD.   *
C     *  Y2   - THE SECOND DERIVATIVES AT THE POINTS XOLD.  IF NATURAL *
C     *         SPLINE IS FITTED Y2(1)=0. AND Y2(NOLD)=0. MUST BE      *
C     *         SPECIFIED.                                             *
C     *  NNEW - NUMBER OF VALUES OF THE FUNCTION TO BE CALCULATED.     *
C     *  XNEW - LOCATIONS OF THE POINTS AT WHICH THE VALUES OF THE     *
C     *         FUNCTION ARE CALCULATED.  XNEW(K) MUST BE GE XOLD(1)   *
C     *         AND LE XOLD(NOLD).                                     *
C     *  YNEW - THE VALUES OF THE FUNCTION TO BE CALCULATED.           *
C     *  P, Q - AUXILIARY VECTORS OF THE LENGTH NOLD-2.                *
C     *                                                                *
C     ******************************************************************
C                                                                       
                             D I M E N S I O N                          
     2 XOLD(NOLD),YOLD(NOLD),Y2(NOLD),P(NOLD),Q(NOLD)
     3,XNEW(NNEW),YNEW(NNEW)
C-----------------------------------------------------------------------
      NOLDM1=NOLD-1                                                     
C                                                                       
      DXL=XOLD(2)-XOLD(1)                                               
      DXR=XOLD(3)-XOLD(2)                                               
      DYDXL=(YOLD(2)-YOLD(1))/DXL                                       
      DYDXR=(YOLD(3)-YOLD(2))/DXR                                       
      RTDXC=.5/(DXL+DXR)                                                
C                                                                       
      P(1)= RTDXC*(6.*(DYDXR-DYDXL)-DXL*Y2(1))                          
      Q(1)=-RTDXC*DXR                                                   
C                                                                       
      IF(NOLD.EQ.3) GO TO 700                                           
C-----------------------------------------------------------------------
      K=3                                                               
C                                                                       
 100  DXL=DXR                                                           
      DYDXL=DYDXR                                                       
      DXR=XOLD(K+1)-XOLD(K)  
c      if(i.eq.120.and.j.eq.279)then
c       print*,'in spline',k,XOLD(K),XOLD(K+1),dxr 
c      end if                                           
      DYDXR=(YOLD(K+1)-YOLD(K))/DXR                                     
      DXC=DXL+DXR                                                       
      DEN=1./(DXL*Q(K-2)+DXC+DXC)                                       
C                                                                       
      P(K-1)= DEN*(6.*(DYDXR-DYDXL)-DXL*P(K-2))                         
      Q(K-1)=-DEN*DXR                                                   
C                                                                       
      K=K+1                                                             
      IF(K.LT.NOLD) GO TO 100                                           
C-----------------------------------------------------------------------
 700  K=NOLDM1                                                          
C                                                                       
 200  Y2(K)=P(K-1)+Q(K-1)*Y2(K+1)                                       
C                                                                       
      K=K-1                                                             
      IF(K.GT.1) GO TO 200                                              
C-----------------------------------------------------------------------
      K1=1                                                              
C                                                                       
 300  XK=XNEW(K1)                                                       
C                                                                       
      DO 400 K2=2,NOLD                                                  
      IF(XOLD(K2).LE.XK) GO TO 400                                      
      KOLD=K2-1                                                         
      GO TO 450                                                         
 400  CONTINUE                                                          
      YNEW(K1)=YOLD(NOLD)                                               
      GO TO 600                                                         
C                                                                       
 450  IF(K1.EQ.1)   GO TO 500                                           
      IF(K.EQ.KOLD) GO TO 550                                           
C                                                                       
 500  K=KOLD                                                            
C                                                                       
      Y2K=Y2(K)                                                         
      Y2KP1=Y2(K+1)                                                     
      DX=XOLD(K+1)-XOLD(K)                                              
      RDX=1./DX                                                         
C                                                                       
      AK=.1666667*RDX*(Y2KP1-Y2K)                                       
      BK=.5*Y2K                                                         
      CK=RDX*(YOLD(K+1)-YOLD(K))-.1666667*DX*(Y2KP1+Y2K+Y2K)            
C                                                                       
 550  X=XK-XOLD(K)                                                      
      XSQ=X*X                                                           
C                                                                       
      YNEW(K1)=AK*XSQ*X+BK*XSQ+CK*X+YOLD(K)                             
C                                                                       
 600  K1=K1+1                                                           
      IF(K1.LE.NNEW) GO TO 300       
C-----------------------------------------------------------------------
      RETURN                                                            
      END

      SUBROUTINE CALMCVG(Q1D,U1D,V1D,IH,QCNVG)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALMCVG     COMPUTES MOISTURE CONVERGENCE
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-01-22       
C     
C ABSTRACT:
C     GIVEN SPECIFIC HUMIDITY, Q, AND THE U-V WIND COMPONENTS
C     THIS ROUTINE EVALUATES THE VECTOR OPERATION, 
C                      DEL DOT (Q*VEC)
C     WHERE,
C        DEL IS THE VECTOR GRADIENT OPERATOR,
C        DOT IS THE STANDARD DOT PRODUCT OPERATOR, AND
C        VEC IS THE VECTOR WIND.
C     MINUS ONE TIMES THE RESULTING SCALAR FIELD IS THE 
C     MOISTURE CONVERGENCE WHICH IS RETURNED BY THIS ROUTINE.
C     
C     THE ROUTINE USES THE SAME FINITE DIFFERENCING SCHEME
C     USED IN CALCULATING ABSOLUTE VORTICITY (SUBROUTINE 
C     CALVOR).  THIS REQUIRES WINDS BE AT VELOCITY POINTS.
C     IF THE U-V WIND COMPONENTS ARE AT MASS POINTS, SET 
C     IH TO A POSITIVE INTEGER GREATER THAN ZERO.  REGARDLESS,
C     SPECIFIC HUMIDITY IS INTERPOLATED TO VELOCITY POINTS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-01-22  RUSS TREADON
C   98-06-08  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION              
C     
C USAGE:    CALL CALMCVG(Q1D,U1D,V1D,IH,QCNVG)
C   INPUT ARGUMENT LIST:
C     Q1D      - SPECIFIC HUMIDITY AT MASS POINTS (KG/KG)
C     U1D      - U WIND COMPONENT (M/S)
C     V1D      - V WIND COMPONENT (M/S)
C     IH       - FLAG FOR MASS POINT WINDS.
C                IH.GT.0 MEANS WINDS AT MASS POINTS.
C
C   OUTPUT ARGUMENT LIST: 
C     QCNVG    - MOISTURE CONVERGENCE (1/S)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MASKS
C                  DYNAM
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     PARAMETER IPASS WAS THE NUMBER OF SMOOTHING PASSES TO APPLY
C     TO THE FIELDS.  THIS IS NO LONGER DONE.
C     
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
      PARAMETER (IPASS=6)
C
C     DECLARE VARIABLES.
C     
      REAL QDIV, R2DY, R2DX
      REAL Q1D(IM,JM), U1D(IM,JM), V1D(IM,JM), QV(IM,JM)
      REAL QCNVG(IM,JM), UWND(IM,JM), VWND(IM,JM)
C     
C     DECLARE COMMONS.
      INCLUDE "DYNAM.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C***************************************************************************
C     START CALMCVG HERE.
C     
C     INITIALIZE MOISTURE CONVERGENCE ARRAY.  LOAD TEMPORARY WIND ARRAYS.
C     
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        QV(I,J) = D00
        QCNVG(I,J) = D00
        UWND(I,J)  = U1D(I,J)
        VWND(I,J)  = V1D(I,J)
        IF (UWND(I,J).EQ.SPVAL) UWND(I,J) = D00
        IF (VWND(I,J).EQ.SPVAL) VWND(I,J) = D00
      ENDDO
      ENDDO
C     
C     FIND Q (AND U-V IF NECESSARY) AT V POINTS.
C
      CALL EXCH(Q1D)
      CALL EXCH(U1D)
      CALL EXCH(V1D)
C
!$omp  parallel do
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
         QV(I,J) = D25*(Q1D(I,J-1)+Q1D(I+IVW(J),J)
     1                 +Q1D(I+IVE(J),J)+Q1D(I,J+1))
         IF (IH.GT.0) THEN
            UWND(I,J) = D25*(U1D(I,J-1)+U1D(I+IVW(J),J)
     1                      +U1D(I+IVE(J),J)+U1D(I,J+1))
     2                      *VBM2(I,J)
            VWND(I,J) = D25*(V1D(I,J-1)+V1D(I+IVW(J),J)
     1                      +V1D(I+IVE(J),J)+V1D(I,J+1))
     2                      *VBM2(I,J)
         ENDIF
      ENDDO
      ENDDO
C     
C     LOOP TO COMPUTE MOISTURE CONVERGENCE.
C
      CALL EXCH(QV)
      CALL EXCH(VWND)
C
!$omp  parallel do
!$omp& private(iend,qdiv,qudx,qvdy,r2dx,r2dy)
      DO J=JSTA_M2,JEND_M2
      IEND=IM-1-MOD(J,2)
        DO I=2,IEND
          R2DX   = 1./(2.*DX(I,J))
          R2DY   = 1./(2.*DY)   
          QUDX   = (QV(I+IHE(J),J)*UWND(I+IHE(J),J)
     1             -QV(I+IHW(J),J)*UWND(I+IHW(J),J))*R2DX
          QVDY   = (QV(I,J+1)*VWND(I,J+1)-QV(I,J-1)*VWND(I,J-1))*R2DY
          QDIV   = QUDX + QVDY
          QCNVG(I,J) = -1.*QDIV*HBM2(I,J)
        ENDDO
      ENDDO
C
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE TRNSEG
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    TRNSEG      
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-20       
C     
C ABSTRACT:
C     THIS ROUTINE LOADS COMMON BLOCK EGRID WITH ETA
C     GRID SPECIFICATIONS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE TRNSEG IN ETAPACKC
C   92-12-20  RUSS TREADON - MODIFIED ETAPACKC TRNSEG FOR
C                            USE IN ETA POST PROCESSOR.
C     
C USAGE:    CALL TRNSEG
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     STDOUT     - RUN-TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MAPOT
C                  EGRID
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE ETA E-GRID DIMENSIONS.
      INCLUDE "parmeta"
      PARAMETER(LP1=LM+1)
C     
C     DECLARE VARIABLES.
C
      LOGICAL NORTH
      REAL ALONVT, DLAM, DPHI, LAM0, PHI0, POLEI, POLEJ
      REAL SINPH0, TANPH0, WLONC, XMESHL, YLATC
C     
C     INCLUDE NECESSARY COMMON BLOCKS.
      INCLUDE "MAPOT.comm"
      INCLUDE "EGRID.comm"
      INCLUDE "IOUNIT.comm"
C
      EQUIVALENCE (YLATC,ALONVT), (DPHI, POLEI)
      EQUIVALENCE (WLONC, POLEJ), (DLAM,XMESHL)
C
      DATA CONV2R/0.017453293/,CONV2D/57.2958/
      DATA EARTHR/6371.2/
C     
C     SET COMMON BLOCK VARIABLES.
C     
      IF (TPH0D.GT.0) THEN
         NORTH = .TRUE.
      ELSE
         NORTH = .FALSE.
      ENDIF
      YLATC  = TPH0D
      DPHI   = DPHD
      WLONC  = ABS(TLM0D)
      DLAM   = DLMD
      IDIM   = 2*IM-1
      JDIM   = JM

      PHI0   = YLATC * CONV2R
      LAM0   = WLONC * CONV2R
      COSPH0 = COS(PHI0)
      SINPH0 = SIN(PHI0)
      TANPH0 = TAN(PHI0)
C     
      WRITE(STDOUT,*)'TRNSEG:  COMMON BLOCK EGRID BELOW'
      WRITE(STDOUT,*)'  NORTH        :  ',NORTH
      WRITE(STDOUT,*)'  ALONVT,XMESHL:  ',ALONVT,XMESHL
      WRITE(STDOUT,*)'  POLEI,POLEJ  :  ',POLEI,POLEJ
      WRITE(STDOUT,*)'  IDIM,JDIM    :  ',IDIM,JDIM
      WRITE(STDOUT,*)'  PHI0,LAM0    :  ',PHI0,LAM0
      WRITE(STDOUT,*)'  COS,SIN,TAN0 :  ',COSPH0,SINPH0,TANPH0
C     
      RETURN
      END

      SUBROUTINE CALQUV(QUint,QVint)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    CALQUV     COMPUTES vert integrtd MOISTURE TRANSPORT COMPONENTS
C SUBPROGRAM:               BASED ON CALMCVG
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-01-22       d
C
C ABSTRACT:
C     GIVEN SPECIFIC HUMIDITY, Q, and Cloud water/ice AND THE U-V WIND COMPONENTS
C     THIS ROUTINE CALCULATES  integral (qu) dp/g ;ntegral (qv) dp/g
C     WHERE,
C
C     THIS REQUIRES WINDS BE AT VELOCITY POINTS.
C     SPECIFIC HUMIDITY IS INTERPOLATED TO VELOCITY POINTS.
C
C USAGE:    CALL CALQUV(QUint, QVint)
C   INPUT ARGUMENT LIST:
C
C   OUTPUT ARGUMENT LIST:
C     QUint     -  INTEGRAL OF MOISTURE TRANSPORT IN ZONAL DIRECTION
C     QVint     -  INTEGRAL OF MOISTURE TRANSPORT IN MERIDIONAL DIRECTION
C
C   OUTPUT FILES:
C     NONE
C
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MASKS
C                  DYNAM
C                  OPTIONS
C                  INDX
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$
C
C
C
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C
C     DECLARE VARIABLES.
C
      REAL QUint(IM,JM), QVint(IM,JM)
      REAL U1D(IM,JM), V1D(IM,JM)
C
C     DECLARE COMMONS.
      INCLUDE "DYNAM.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
C
C
C***************************************************************************
C     START CALQUV  HERE.
C
C     INITIALIZE MOISTURE TRANSPORT ARRAY.  LOAD TEMPORARY WIND ARRAYS.
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        QUINT(I,J) = D00
        QVINT(I,J) = D00
      ENDDO
      ENDDO

      DO L=1,LM

      DO J=JSTA,JEND
      DO I=1,IM
        U1D(I,J)  = U(I,J,L)
        V1D(I,J)  = V(I,J,L)
      ENDDO
      ENDDO
C
      CALL EXCH(U1D)
      CALL EXCH(V1D)
C
!$omp  parallel do
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
      DMEAN  =  (VTM(I,J-1,L) +VTM(I+IHW(J),J,L)+VTM(I+IHE(J),J,L)
     1          +VTM(I,J+1,L))
      IF (DMEAN .LT. 1) THEN   ! inside topography
         DMEAN  =  0
      ELSE
         DMEAN  =  1./(VTM(I,J-1,L) +VTM(I+IHW(J),J,L)+VTM(I+IHE(J),J,L)
     1                +VTM(I,J+1,L))
      ENDIF
Chou DP is the DPi at the wind point, averaged from the mass points
      DP     = -(PINT(I,J,L) -PINT(I,J,L+1))
C
C     CALC  U and V at MASS POINTS times DP/G
C
      UMDP     = (U1D(I,J-1)     *VTM(I,J-1,L)      +
     1            U1D(I+IHW(J),J)*VTM(I+IHW(J),J,L) +
     2            U1D(I+IHE(J),J)*VTM(I+IHE(J),J,L) +
     1            U1D(I,J+1)     *VTM(I,J+1,L)     )* DMEAN*DP*GI

      VMDP     = (V1D(I,J-1)     *VTM(I,J-1,L)      +
     1            V1D(I+IHW(J),J)*VTM(I+IHW(J),J,L) +
     2            V1D(I+IHE(J),J)*VTM(I+IHE(J),J,L) +
     1            V1D(I,J+1)     *VTM(I,J+1,L)     )* DMEAN* DP*GI
C
C     VERTICAL INTEGRAL  (U* q , V* q) * DP/G
C
      QUINT(I,J)= QUINT(I,J)+ UMDP*(Q(I,J,L)+CWM(I,J,L))*HTM(I,J,L)
      QVINT(I,J)= QVINT(I,J)+ VMDP*(Q(I,J,L)+CWM(I,J,L))*HTM(I,J,L)

CHOU checking       WRITE(1099,*)"alquv:", i,j,l, quint(i,j), qvint(i,j), u1D(i,j),
CHOU checking     2                 v1d(i,j),q(i,j,l), cwm(i,j,l),vtm(i,j,l)
      ENDDO
      ENDDO
C
      ENDDO    ! L LOOP
C
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE EXTEND(GRID,IDIM,JDIM,AVG,SPVC)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    EXTEND      FILL MISSING BOUNDARY VALUES.
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-02-03       
C     
C ABSTRACT:
C     THIS SUBROUTINE EXTENDS KNOW BOUNDARY VALUES TO FILL
C     MISSING VALUES TAGGED BY THE VALUE SPVC.  MULTIPLE
C     FILLING PASSES MAY BE MADE.  WE OPTED TO MAKE ONE
C     PASS AND REPLACE ANY REMAINING SPVC VALUES BY THE
C     FIELD MEAN.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SOURCE IN ETAPACKC 
C   93-02-26  RUSS TREADON  - GENERALIZED ETAPACKC SOURCE
C                             AND ADDED COMMENTS.
C   93-06-23  RUSS TREADON  - COMPLETE REWRITE.
C     
C USAGE:    CALL EXTEND(GRID,IDIM,JDIM,AVG,SPVC)
C   INPUT ARGUMENT LIST:
C     GRID     - GRID TO BE FILLED.
C     IDIM     - FIRST DIMENSION OF GRID.
C     JDIM     - SECOND DIENSION OF GRID.
C     AVG      - VALUE TO REPLACE SPVC VALUES WITH AFTER
C                MXPASS FILLING PASSES OVER THE GRID.
C     SPVC     - THE MISSING DATA FLAG.
C
C   OUTPUT ARGUMENT LIST: 
C     GRID     - GRID WITH SPVC VALUES REPLACED BY EXTENDED
C                BORDER VALUES OR PASSED VALUE OF AVG.
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     
C     SET PARAMETERS
      PARAMETER (MXPASS=1)
C     
C     DECLARE VARIABLES.
      REAL GRID(IDIM,JDIM)
C     
C     INCLUDE COMMON BLOCK
      INCLUDE "IOUNIT.comm"
C     
C**************************************************************************
C     START EXTEND HERE.
C     
      print *,'EXTENDD ',idim,jdim
      IJDIM = IDIM*JDIM
C     
C     FILL MISSING VALUES WITH BOUNDARY VALUES.  WE ALLOW
C     UP TO MXPASS EXTENSION PASSES TO ACCOMPLISH THIS.  THE
C     COMMENTS BELOW ASSUME GRID(1,1) IS IN THE SOUTHWEST OR
C     LOWER LEFT CORNER AND GRID(IDIM,JDIM) IS IN THE NORTHEAST
C     OR UPPER RIGHT CORNER.
C     

      IPASS = 0
 10   CONTINUE
      IPASS = IPASS + 1
C     
C     EXTEND SOUTHERN AND NORTHERN BOUNDARIES.
      DO 70 I = 1,IDIM
C     
C        EXTEND SOUTHERN BOUNDARY.
         DO 30 J = 1,JDIM
            IF (GRID(I,J).NE.SPVC) THEN
               DO 20 JJ = J,1,-1
                  GRID(I,JJ) = GRID(I,J)
 20            CONTINUE
               GOTO 40
            ENDIF
 30      CONTINUE
C     
C        EXTEND NORTHERN BOUNDARY
 40      CONTINUE
         DO 60 J = JDIM,1,-1
            IF (GRID(I,J).NE.SPVC) THEN
               DO 50 JJ = J,JDIM
                  GRID(I,JJ) = GRID(I,J)
 50            CONTINUE
               GOTO 70
            ENDIF
 60      CONTINUE
C
C     REPEAT FOR NEXT COLUMN.
 70   CONTINUE
C     
C     EXTEND WESTERN AND EASTERN BOUNDARIES
      DO 170 J = 1,JDIM
C     
C        EXTEND WESTERN BOUNDARY
         DO 130 I = 1,IDIM
            IF (GRID(I,J).NE.SPVC) THEN
               DO 120 II = I,1,-1
                  GRID(II,J) = GRID(I,J)
 120           CONTINUE
               GOTO 140
            ENDIF
 130     CONTINUE
C     
C        EXTEND EASTERN BOUNDARY
 140     CONTINUE
         DO 160 I = IDIM,1,-1
            IF (GRID(I,J).NE.SPVC) THEN
               DO 150 II = I,IDIM
                  GRID(II,J) = GRID(I,J)
 150           CONTINUE
               GOTO 170
            ENDIF
 160     CONTINUE
C     
C     REPEAT FOR NEXT ROW
 170  CONTINUE
C     
C     SEE IF WE NEED TO MAKE ANOTHER PASS.
C
      CALL MINMAX(GRID,IDIM,JDIM,FMIN,FMAX)
      IF (FMAX.GE.SPVC) THEN
CX         WRITE(STDOUT,*)'EXTEND:  BOUNDARY FILL:  ',IPASS,FMIN,FMAX
         IF (IPASS.LT.MXPASS) GOTO 10
      ENDIF
C     
C     IF WE STILL CAN'T FILL THE GRID AFTER MXPASS PASSES, 
C     FILL MISSING VALUES WITH FIELD MEAN.
C
      IF ((FMAX.GE.SPVC).AND.(IPASS.GE.MXPASS)) THEN
CX         WRITE(STDOUT,*)'EXTEND:  FILLING WITH AVG=',AVG
         WHERE(GRID >= SPVC) GRID = AVG
      ENDIF
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE NETAL(FLD3D,ITYPE,L,LMHLMV,EGRID)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    NETAL       EXTRACT ETA LAYER DATA.
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-04-02       
C     
C ABSTRACT:
C     THIS ROUTINE EXTRACTS FROM THE 3D ARRAY FLD3D ON EITHER
C     ETA LAYER L OR ATMOSPHERIC ETA LAYER L.  BY "ETA LAYER L"
C     WE MEAN EXTRACTING DATA ON THE CONSTANT ETA LAYER L,
C     REGARDLESS OF THE MODEL TERRAIN.  THIS IS SIMPLY A 
C     HORIZONTAL SLICE THROUGH THE VOLUME FLD3D AT VERTICAL 
C     LEVEL L.  BY "ATMOSPHERIC ETA LAYER L WE MEAN THE TERRAIN
C     FOLLOWING LAYER CONSISTING OF ALL ETA LAYERS L LAYERS 
C     ABOVE THE LOCAL MODEL SURFACE.
C     
C     INTEGER FLAG ITYPE CONTROLS WHICH TYPE OF ETA LAYER DATA
C     TO EXTRACT.  FOR ITYPE=1 EXTRACT DATA ON CONSTANT ETA
C     LAYER L.  FOR ITYPE GREATER THAN ONE EXTRACT DATA ON
C     ATMOSPHERIC ETA LAYER L.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-04-02  RUSS TREADON
C   98-06-08  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL NETAL(FLD3D,ITYPE,L,LMHLMV,EGRID)
C   INPUT ARGUMENT LIST:
C     FLD3D    - 3D VOLUME OF DATA ON ETA SURFACES.
C     ITYPE    - FLAG CONTROLLING TYPE OF DATA EXTRACTION.
C     L        - LEVEL TO EXTRACT.
C     LMHLMV   - HORIZONTAL ARRAY CONTAINING VERTICAL INDEX
C                OF FIRST ATMOSPHERIC ETA LAYER.
C
C   OUTPUT ARGUMENT LIST: 
C     EGRID    - HORIZONTAL ARRAY CONTAINING ETA LAYER DATA.
C     
C   OUTPUT FILES:
C     
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     
C     
C     INCLUDE PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "CTLBLK.comm"
C     
C     DECLARE VARIABLES.
      INTEGER LMHLMV(IM,JM)
      REAL EGRID(IM,JM), FLD3D(IM,JM,LM)
C     
C     
C***************************************************************
C     START NETAL HERE.
C     
C     
C     CASE WHEN ITYPE=1.
C     LOAD ETA LEVEL L INTO EGRID.
C     
      IF (ITYPE.EQ.1) THEN
         LGET = L
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID(I,J) = FLD3D(I,J,LGET)
         ENDDO
         ENDDO
C     
C     CASE WHEN ITYPE.GT.1.
C     LOAD ATMOSPHERIC ETA LAYER L INTO EGRID.
C     
      ELSEIF (ITYPE.GT.1) THEN
         LOFF = L-1
         DO J=JSTA,JEND
         DO I=1,IM
            LGET = LMHLMV(I,J) - LOFF
            IF (LGET.LT.01) LGET = 01
            IF (LGET.GT.LM) LGET = LM
            EGRID(I,J) = FLD3D(I,J,LGET)
         ENDDO
         ENDDO
      ENDIF
CX    
CX      DEBUG PRINTS BELOW.
CX
CX      IF (ITYPE.GT.1) THEN
CX         WRITE(81,*)' '
CX         WRITE(81,*)'LISTING FOR NEW FIELD.'
CX         CALL MINMAX(EGRID,IM,JM,FMIN,FMAX) 
CX         WRITE(81,*)' FMIN,FMAX:  ',FMIN,FMAX
CX         DO J=JSTA,JEND
CX         DO I=1,IM
CX            LOFF = L-1
CX            LGET = LMHLMV(I,J) - LOFF
CX            DIFF = FLD3D(I,J,LGET)-EGRID(I,J)
CX            IF (DIFF.NE.0.) WRITE(81,*)'WARNING:  DIFF.NE.0.'
CX            WRITE(81,1234) I,J,L,LOFF,LMHLMV(I,J),
CX     X           FLD3D(I,J,LGET),EGRID(I,J),DIFF
CX 1234       FORMAT(I3,1X,I3,,1X,3(I2,1X),3(G12.6,1X))
CX         END DO
CX      END IF
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE SURFCE2(IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    SURFCE2     POST SURFACE BASED FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-21       
C     
C ABSTRACT:
C     THIS ROUTINE POSTS SURFACE BASED FIELDS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-21  RUSS TREADON
C   94-08-04  MICHAEL BALDWIN - ADDED OUTPUT OF SFC FLUXES OF
C                               SENS AND LATENT HEAT AND THETA AT Z0
C   94-11-04  MICHAEL BALDWIN - ADDED INSTANTANEOUS PRECIP TYPE
C   96-03-19  MICHAEL BALDWIN - CHANGE SOIL PARAMETERS
C   96-09-25  MICHAEL BALDWIN - ADDED SNOW RATIO FROM EXPLICIT SCHEME
C   96-10-17  MICHAEL BALDWIN - CHANGED SFCEVP,POTEVP TO ACCUM.  TOOK
C                               OUT -PTRACE FOR ACSNOW,SSROFF,BGROFF.
C   97-04-23  MICHAEL BALDWIN - TOOK OUT -PTRACE FOR ALL PRECIP FIELDS
C   98-06-12  T BLACK         - CONVERSION FROM 1-D TO 2-D
C   98-07-17  MIKE BALDWIN - REMOVED LABL84
C   98-08-18  MIKE BALDWIN - COMPUTE RH OVER ICE
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL SURFCE2(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       E2OUT    - INTERPOLATION/SMOOTHING ROUTINE.
C       OUTPUT   - DRIVER FOR OUTPUT ROUTINES.
C       BOUND    - ENFORCE LOWER AND UPPER LIMITS ON ARRAY ELEMENTS.
C       SCLFLD   - SCALE ARRAY ELEMENTS BY CONSTANT.
C       SHELTR2  - COMPUTE 2M TEMPERATURE AND SPECIFIC HUMIDITY.
C       ANEMLV6  - COMPUTE 10M U AND V WINDS.
C       DEWPOINT - COMPUTE DEWPOINT TEMPERATURE.
C       CALDRG   - COMPUTE SURFACE LAYER DRAG COEFFICENT
C       CALTAU   - COMPUTE SURFACE LAYER U AND V WIND STRESSES.
C
C     LIBRARY:
C       COMMON   - CTLBLK
C                  RQSTFLD
C                  EXTRA
C                  VRBLS
C                  MAPOT
C                  MASKS
C                  PVRBLS
C                  CLDWTR
C                  LOOPS
C                  PHYS2
C                  SRFDSP
C                  CNVCLD
C                  LLGRDS
C                  SOIL
C                  ACMSFC
C                  ACMPRE
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
      INCLUDE "parm.tbl"
      INCLUDE "parmsoil"
C     
C     IN NGM SUBROUTINE OUTPUT WE FIND THE FOLLOWING COMMENT.
C     "IF THE FOLLOWING THRESHOLD VALUES ARE CHANGED, CONTACT
C     TDL/SYNOPTIC-SCALE TECHNIQUES BRANCH (PAUL DALLAVALLE
C     AND JOHN JENSENIUS).  THEY MAY BE USING IT IN ONE OF 
C     THEIR PACKING CODES."  THE THRESHOLD VALUE IS 0.01 INCH
C     OR 2.54E-4 METER.  PRECIPITATION VALUES LESS THAN THIS
C     THRESHOLD ARE SET TO MINUS ONE TIMES THIS THRESHOLD.
      PARAMETER (PTRACE = 0.000254E0)
C     
C     SET CELCIUS TO KELVIN AND SECOND TO HOUR CONVERSION.
      PARAMETER (C2K    = 273.15)
      PARAMETER (SEC2HR = 1./3600.)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STDRD
      INTEGER IWX1(IM,JM)
      REAL PSFC(IM,JM),TSFC(IM,JM),QSFC(IM,JM),RHSFC(IM,JM)
      REAL ZSFC(IM,JM),THSFC(IM,JM),DWPSFC(IM,JM),EVP(IM,JM)
      REAL ANCPRC(IM,JM),P1D(IM,JM),T1D(IM,JM),Q1D(IM,JM)
      REAL EGRID1(IM,JM),EGRID2(IM,JM),UA(IM,JM),VA(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT),IW(IM,JM),IWM1
      REAL SLEET(IM,JM),RAIN(IM,JM),FREEZR(IM,JM),SNOW(IM,JM)
      REAL VGTYP(IM,JM),SLTYP(IM,JM)
CGSM v100m
      REAL P100(IM,JM),T100(IM,JM)
      REAL XFIL(IM*2-1,JM)
CGSM v100m 
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "PHYS2.comm"
      INCLUDE "SRFDSP.comm"
      INCLUDE "CNVCLD.comm"
      INCLUDE "LLGRDS.comm"
      INCLUDE "SOIL.comm"
      INCLUDE "ACMSFC.comm"
      INCLUDE "ACMPRE.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "OUTFIL.comm"
C     
C****************************************************************************
C
C     START SURFCE.
C
C     COMPUTE IW AT SFC FOR SFC AND 2M RH
C
      IF ( (IGET(076).GT.0).OR.(IGET(114).GT.0) ) THEN
        CLIMIT =1.0E-20
        IW=0.
C
        DO L=2,LM 
        DO J=JSTA,JEND
        DO I=1,IM
         IF (L.LE.LMH(I,J)) THEN
           IWM1=IW(I,J)
           IF(CWM(I,J,L).GT.CLIMIT) THEN
             IF(T(I,J,L).LT.258.15)THEN
               IW(I,J)=1.
             ELSEIF(T(I,J,L).GE.273.15)THEN
               IW(I,J)=0.
             ELSE
               IF(IWM1.EQ.1.0)IW(I,J)=1.
             ENDIF
           ELSE
             IW(I,J)=0.
           ENDIF
         ENDIF
        ENDDO
        ENDDO
        ENDDO
C
      ENDIF
C     
C***  BLOCK 1.  SURFACE BASED FIELDS.
C
C     IF ANY OF THE FOLLOWING "SURFACE" FIELDS ARE REQUESTED,
C     WE NEED TO COMPUTE THE FIELDS FIRST.
C     
      IF ( (IGET(024).GT.0).OR.(IGET(025).GT.0).OR.
     X     (IGET(026).GT.0).OR.(IGET(027).GT.0).OR.
     X     (IGET(028).GT.0).OR.(IGET(029).GT.0).OR.
     X     (IGET(154).GT.0).OR.
     X     (IGET(181).GT.0).OR.(IGET(182).GT.0).OR.
     X     (IGET(034).GT.0).OR.(IGET(076).GT.0) ) THEN
C     
         doout40: DO J=JSTA,JEND
         doin40:  DO I=1,IM

CGSM v100m
C           PRESSURE AND TEMPERATURE AT 50 M and 100M.
            LMHK=LMH(I,J)
            P100(I,J)=(PD(I,J)+PT)*EXP(-100.0*G/(287.04*T(I,J,LMHK)))
            T100(I,J)=TH100(I,J)*(P100(I,J)/P1000)**CAPA
CGSM v100m

C
C           SCALE ARRAY FIS BY GI TO GET SURFACE HEIGHT.
            ZSFC(I,J)=FIS(I,J)*GI
C
C           SURFACE PRESSURE.
            PSFC(I,J)=PD(I,J)+PT
CJLG            if(psfc(i,j).lt.60000.)print*,'enormal posted psfc',
CJLG     +      i,j,psfc(i,j)
C     
C           SURFACE (SKIN) POTENTIAL TEMPERATURE AND TEMPERATURE.
            THSFC(I,J)=THS(I,J)
            TSFC(I,J) =THSFC(I,J)*(PSFC(I,J)/P1000)**CAPA 
C     
C           SURFACE SPECIFIC HUMIDITY, RELATIVE HUMIDITY,
C           AND DEWPOINT.  ADJUST SPECIFIC HUMIDITY IF
C           RELATIVE HUMIDITY EXCEEDS 0.1 OR 1.0.
C
            QSFC(I,J)=QS(I,J)
            QSFC(I,J)=AMAX1(H1M12,QSFC(I,J))
            TSFCK    =TSFC(I,J)
C     
            TMT0=TSFCK-273.16
            TMT15=AMIN1(TMT0,-15.)
            AI=0.008855
            BI=1.
            IF(TMT0.LT.-20.)THEN
              AI=0.007225
              BI=0.9674
            ENDIF
            QW=PQ0/PSFC(I,J)
     1          *EXP(A2*(TSFCK-A3)/(TSFCK-A4))
            QI=QW*(BI+AI*AMIN1(TMT0,0.))
            QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
            IF(TMT0.LT.-15.)THEN
                QSAT=QI
            ELSEIF(TMT0.GE.0.)THEN
                QSAT=QINT
            ELSE
              IF(IW(I,J).GT.0.0) THEN
                QSAT=QI
              ELSE
                QSAT=QINT
              ENDIF
            ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
            QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C
            RHSFC(I,J)=QSFC(I,J)/QSAT

            IF (RHSFC(I,J).GT.H1 ) RHSFC(I,J) = H1
            IF (RHSFC(I,J).LT.D00) RHSFC(I,J) = D01
            QSFC(I,J)  = RHSFC(I,J)*QSAT
            EVP(I,J)   = PSFC(I,J)*QSFC(I,J)/(EPS+ONEPS*QSFC(I,J))
            EVP(I,J)   = EVP(I,J)*D001
C     
C           ACCUMULATED NON-CONVECTIVE PRECIP.
            IF(IGET(034).GT.0)THEN
              IF(LVLS(1,IGET(034)).GT.0)THEN
                 ANCPRC(I,J)=ACPREC(I,J)-CUPREC(I,J)
              ENDIF
            ENDIF

         END DO doin40
         END DO doout40
C     
C        INTERPOLATE/OUTPUT REQUESTED SURFACE FIELDS.
C     
C        SURFACE PRESSURE.
         IF (IGET(024).GT.0) THEN
            CALL E2OUT(024,000,PSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            do j=jsta,jend
C             do i=1,im
C              if(grid1(i,j).lt.30000.)print*,'enormal output psfc',i,j
C     +,        grid1(i,j)
C             end do
C            end do
            CALL OUTPUT(IOUTYP,IGET(024),LVLS(1,IGET(024)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE HEIGHT.
         IF (IGET(025).GT.0) THEN
            CALL E2OUT(025,000,ZSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(025),LVLS(1,IGET(025)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE (SKIN) TEMPERATURE.
         IF (IGET(026).GT.0) THEN
            CALL E2OUT(026,000,TSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(026),LVLS(1,IGET(026)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE (SKIN) POTENTIAL TEMPERATURE.
         IF (IGET(027).GT.0) THEN
            CALL E2OUT(027,000,THSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(027),LVLS(1,IGET(027)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     
C        SOIL TYPE
         IF (IGET(181).GT.0) THEN
         SLTYP=REAL(ISLTYP)
            CALL E2OUT(181,000,SLTYP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(181),LVLS(1,IGET(181)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        VEG TYPE
         IF (IGET(182).GT.0) THEN
         VGTYP=REAL(IVGTYP)
            CALL E2OUT(182,000,VGTYP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(182),LVLS(1,IGET(182)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE SPECIFIC HUMIDITY.
C        SURFACE SPECIFIC HUMIDITY.
         IF (IGET(028).GT.0) THEN
            CALL E2OUT(028,000,QSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(028),LVLS(1,IGET(028)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE DEWPOINT TEMPERATURE.
         IF (IGET(029).GT.0) THEN
            CALL DEWPOINT(EVP,DWPSFC,IM,JM)
            CALL E2OUT(029,000,DWPSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(029),LVLS(1,IGET(029)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE RELATIVE HUMIDITY.
         IF (IGET(076).GT.0) THEN
            CALL E2OUT(076,000,RHSFC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(076),LVLS(1,IGET(076)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
      ENDIF
C
C     ADDITIONAL SURFACE-SOIL LEVEL FIELDS.
C

      DO L=1,NSOIL
C     SOIL TEMPERATURE.
        IF (IGET(116).GT.0) THEN
          IF (LVLS(L,IGET(116)).GT.0) THEN
            DO J=JSTA,JEND
              DO I=1,IM
                EGRID1(I,J)=STC(I,J,L)
              ENDDO
            ENDDO
            CALL E2OUT(116,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            DTOP=0.
            DO LS=1,L-1
              DTOP=DTOP+SLDPTH(LS)
            ENDDO
            DBOT=DTOP+SLDPTH(L)
            ID(10) = NINT(DTOP*100.)
            ID(11) = NINT(DBOT*100.)
            CALL OUTPUT(IOUTYP,IGET(116),L,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C
C     SOIL MOISTURE.
        IF (IGET(117).GT.0) THEN
          IF (LVLS(L,IGET(117)).GT.0) THEN
            DO J=JSTA,JEND
              DO I=1,IM
                EGRID1(I,J)=SMC(I,J,L)
                EGRID2(I,J)=SM(I,J)
              ENDDO
            ENDDO
            CALL E2OUT(117,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            DTOP=0.
            DO LS=1,L-1
              DTOP=DTOP+SLDPTH(LS)
            ENDDO
            DBOT=DTOP+SLDPTH(L)
            ID(10) = NINT(DTOP*100.)
            ID(11) = NINT(DBOT*100.)
CHOU 202212
CHOU 202212  SMC undef in water
CJLG GRID2 is SM in OUT grid 
            DO I=1,IMOUT
              DO J=1,JMOUT
                IF (GRID2(I,J).gt. 0.5) GRID1(I,J)=H99999
              ENDDO
            ENDDO
CHOU 202212
            CALL OUTPUT(IOUTYP,IGET(117),L,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
      ENDDO
C
C     BOTTOM SOIL TEMPERATURE.
      IF (IGET(115).GT.0) THEN
         CALL E2OUT(115,000,SOILTB,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         ISVALUE     = 300
         ID(11) = ISVALUE
         CALL OUTPUT(IOUTYP,IGET(115),LVLS(1,IGET(115)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     SOIL MOISTURE AVAILABILITY
      IF (IGET(171).GT.0) THEN
         CALL E2OUT(171,000,SMSTAV,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         ID(10) = 0
         ID(11) = 100
         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(171),LVLS(1,IGET(171)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     TOTAL SOIL MOISTURE
      IF (IGET(036).GT.0) THEN
         CALL E2OUT(036,000,SMSTOT,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         ID(10) = 0
         ID(11) = 200
         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(036),LVLS(1,IGET(036)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     PLANT CANOPY SURFACE WATER.
      IF ( IGET(118).GT.0 ) THEN
         CALL E2OUT(118,000,CMC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(118),LVLS(1,IGET(118)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     SNOW WATER EQUIVALENT.
      IF ( IGET(119).GT.0 ) THEN
         CALL E2OUT(119,000,SNO,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
CHOU 20221229    no scaling to mm, kept in meters
CHOU         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(119),LVLS(1,IGET(119)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     PERCENT SNOW COVER.
      IF ( IGET(120).GT.0 ) THEN
         CALL E2OUT(120,000,PCTSNO,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
CHOU 20221230 PCTSNO calculated from albedo, need to convert to percentage
CHOU         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
CHOU 20221230        CALL BOUND(GRID1,D00,H1,IMOUT,JMOUT)
CHOU 29221230
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(120),LVLS(1,IGET(120)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
CHOU 20221225 Include SNOWDEPTH
C
C     SNOW DEPTH (m) 
      IF ( IGET(099).GT.0 ) THEN
         CALL E2OUT(099,000,SI,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(099),LVLS(1,IGET(099)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
CHOU 20221225
C     
C
C***  BLOCK 2.  SHELTER (2M) LEVEL FIELDS.
C     
C     COMPUTE/POST SHELTER LEVEL FIELDS.
C     
      IF ( (IGET(106).GT.0).OR.(IGET(112).GT.0).OR.
     X     (IGET(113).GT.0).OR.(IGET(114).GT.0).OR.
     X     (IGET(138).GT.0) ) THEN
C
C        CALL SHELTR2(PSHLTR,QSHLTR,TSHLTR)
C
C        SHELTER LEVEL TEMPERATURE
         IF (IGET(106).GT.0) THEN
            CALL E2OUT(106,000,TSHLTR,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            ISVALUE = 2
            ID(10) = MOD(ISVALUE/256,256)
            ID(11) = MOD(ISVALUE,256)
            CALL OUTPUT(IOUTYP,IGET(106),LVLS(1,IGET(106)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C        SHELTER LEVEL SPECIFIC HUMIDITY.
         IF (IGET(112).GT.0) THEN       
            CALL E2OUT(112,000,QSHLTR,EGRID1,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND (GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25) = 0
            ISVALUE = 2
            ID(10) = MOD(ISVALUE/256,256)
            ID(11) = MOD(ISVALUE,256)
            CALL OUTPUT(IOUTYP,IGET(112),LVLS(1,IGET(112)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SHELTER LEVEL DEWPOINT.
         IF (IGET(113).GT.0) THEN
            DO J=JSTA,JEND
            DO I=1,IM
              EVP(I,J)=PSHLTR(I,J)*QSHLTR(I,J)/(EPS+ONEPS*QSHLTR(I,J))
	      EVP(I,J)=EVP(I,J)*D001
            ENDDO
            ENDDO
            CALL DEWPOINT(EVP,EGRID1,IM,JM)
            CALL E2OUT(113,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            ISVALUE = 2
            ID(10) = MOD(ISVALUE/256,256)
            ID(11) = MOD(ISVALUE,256)
            CALL OUTPUT(IOUTYP,IGET(113),LVLS(1,IGET(113)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SHELTER LEVEL RELATIVE HUMIDITY.
         IF (IGET(114).GT.0) THEN
            CALL CALRH2(PSHLTR,TSHLTR,QSHLTR,IW,EGRID1,IM,JM)
            CALL E2OUT(114,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
            ID(1:25) = 0
            ISVALUE = 2
            ID(10) = MOD(ISVALUE/256,256)
            ID(11) = MOD(ISVALUE,256)
            CALL OUTPUT(IOUTYP,IGET(114),LVLS(1,IGET(114)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SHELTER LEVEL PRESSURE.
         IF (IGET(138).GT.0) THEN
            CALL E2OUT(138,000,PSHLTR,EGRID1,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            ISVALUE = 2
            ID(10) = MOD(ISVALUE/256,256)
            ID(11) = MOD(ISVALUE,256)
            CALL OUTPUT(IOUTYP,IGET(138),LVLS(1,IGET(138)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
      ENDIF
C
C
C     BLOCK 3.  ANEMOMETER LEVEL (10M) WINDS, THETA, AND Q.
C
      IF ( (IGET(064).GT.0).OR.(IGET(065).GT.0) ) THEN
C        CALL ANEMLV6(UA,VA)
         ID(1:25) = 0
         ISVALUE = 10
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
C
C        ANEMOMETER LEVEL U WIND AND/OR V WIND.
         IF ((IGET(064).GT.0).OR.(IGET(065).GT.0)) THEN
            CALL E2OUT(064,065,U10,V10,GRID1,GRID2,IMOUT,JMOUT)
            IF (IGET(064).GT.0) CALL OUTPUT(IOUTYP,IGET(064),
     X           LVLS(1,IGET(064)),GRID1,IMOUT,JMOUT)
            IF (IGET(065).GT.0) CALL OUTPUT(IOUTYP,IGET(065),
     X           LVLS(1,IGET(065)),GRID2,IMOUT,JMOUT)
         ENDIF
      ENDIF
C
C        ANEMOMETER LEVEL (10 M) POTENTIAL TEMPERATURE.
C
      IF (IGET(158).GT.0) THEN
         ID(1:25) = 0
         ISVALUE = 10
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
         CALL E2OUT(158,000,TH10,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(158),
     X        LVLS(1,IGET(158)),GRID1,IMOUT,JMOUT)
       ENDIF
C
C        ANEMOMETER LEVEL (10 M) SPECIFIC HUMIDITY.
C
      IF (IGET(159).GT.0) THEN
         ID(1:25) = 0
         ISVALUE = 10
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
         CALL E2OUT(159,000,Q10,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(159),
     X        LVLS(1,IGET(159)),GRID1,IMOUT,JMOUT)
       ENDIF

CGSM v100m
C
C     BLOCK 3.1 100M WINDS.
C
      IF ( (IGET(95).GT.0).OR.(IGET(96).GT.0) ) THEN
         ID(1:25) = 0
         ISVALUE = 100
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
C
C        100-m LEVEL U WIND AND/OR V WIND.
            CALL E2OUT(95,96,U100,V100,GRID1,GRID2,IMOUT,JMOUT)
            IF (IGET(95).GT.0) CALL OUTPUT(IOUTYP,IGET(95),
     X           LVLS(1,IGET(95)),GRID1,IMOUT,JMOUT)
            IF (IGET(96).GT.0) CALL OUTPUT(IOUTYP,IGET(96),
     X           LVLS(1,IGET(96)),GRID2,IMOUT,JMOUT)
      ENDIF
C
C        100 M POTENTIAL TEMPERATURE.
C
      IF (IGET(92).GT.0) THEN
         ID(1:25) = 0
         ISVALUE = 100
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
         CALL E2OUT(92,000,TH100,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(92),
     X        LVLS(1,IGET(92)),GRID1,IMOUT,JMOUT)
CJLG         print*,' in post, surfce2.f th100:',th100
       ENDIF
C
C        100 M TEMPERATURE.
C
      IF (IGET(94).GT.0) THEN
         ID(1:25) = 0
         ISVALUE = 100
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
         CALL E2OUT(94,000,T100,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(94),
     X        LVLS(1,IGET(94)),GRID1,IMOUT,JMOUT)
       ENDIF
C
C        100 M PRESSURE.
C
      IF (IGET(91).GT.0) THEN
         ID(1:25) = 0
         ISVALUE = 100
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
         CALL E2OUT(91,000,P100,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(91),
     X        LVLS(1,IGET(91)),GRID1,IMOUT,JMOUT)
       ENDIF
C
C       100 M SPECIFIC HUMIDITY.
C
      IF (IGET(93).GT.0) THEN
         ID(1:25) = 0
         ISVALUE = 100
         ID(10) = MOD(ISVALUE/256,256)
         ID(11) = MOD(ISVALUE,256)
         CALL E2OUT(93,000,Q100,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(93),
     X        LVLS(1,IGET(93)),GRID1,IMOUT,JMOUT)
       ENDIF      
    
C         IF (MYPE.EQ.0) THEN
C	 print*,"Entrou no IF"
C         call fillh(u100,xfil,im*2-1,jm)             ! orig in V point
C         write(74)xfil                           !write u100m
C	 call fillh(v100,xfil,im*2-1,jm)             ! orig in V point
C         write(74)xfil                           !write v100m  
C	 ENDIF
             
CGSM v100m

C
C
C
C***  BLOCK 4.  PRECIPITATION RELATED FIELDS.
C     
C     SNOW FRACTION FROM EXPLICIT CLOUD SCHEME.  LABELLED AS
C      'PROB OF FROZEN PRECIP' IN GRIB, 
C      DIDN'T KNOW WHAT ELSE TO CALL IT
      IF (IGET(172).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J)=SR(I,J)*100.
         ENDDO
         ENDDO
         CALL E2OUT(172,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(172),LVLS(1,IGET(172)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     INSTANTANEOUS PRECIPITATION RATE.
      IF (IGET(167).GT.0) THEN
         RDTPHS=1./DTQ2
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J)=PREC(I,J)*RDTPHS
         ENDDO
         ENDDO
         CALL E2OUT(167,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(167),LVLS(1,IGET(167)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     ACCUMULATED TOTAL PRECIPITATION.
      IF (IGET(087).GT.0) THEN
         CALL E2OUT(087,000,ACPREC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
C         IFHR       = NTSD/TSPH + 0.5
         IFHR       = ITAG
         ITPREC     = INT(TPREC)
         IFINCR     = MOD(IFHR,ITPREC)
         ID(19)     = IFHR
         ID(20)     = 4
         IF (IFINCR.EQ.0) THEN
            ID(18) = IFHR-ITPREC
         ELSE
            ID(18) = IFHR-IFINCR
         ENDIF
         IF (ID(18).LT.0) ID(18) = 0
 
         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(087),LVLS(1,IGET(087)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     ACCUMULATED CONVECTIVE PRECIPITATION.
      IF (IGET(033).GT.0) THEN
         CALL E2OUT(033,000,CUPREC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
C         IFHR       = NTSD/TSPH + 0.5
         IFHR       = ITAG
         ITPREC     = INT(TPREC)
         IFINCR     = MOD(IFHR,ITPREC)
         ID(19)     = IFHR
         ID(20)     = 4
         IF (IFINCR.EQ.0) THEN
            ID(18) = IFHR-ITPREC
         ELSE
            ID(18) = IFHR-IFINCR
         ENDIF
         IF (ID(18).LT.0) ID(18) = 0
         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(033),LVLS(1,IGET(033)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     ACCUMULATED GRID-SCALE PRECIPITATION.
      IF (IGET(034).GT.0) THEN
         CALL E2OUT(034,000,ANCPRC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
C         IFHR       = NTSD/TSPH + 0.5
         IFHR       = ITAG
	 ITPREC     = INT(TPREC)
         IFINCR     = MOD(IFHR,ITPREC)
         ID(19)     = IFHR
         ID(20)     = 4
         IF (IFINCR.EQ.0) THEN
            ID(18) = IFHR-ITPREC
         ELSE
            ID(18) = IFHR-IFINCR
         ENDIF
         IF (ID(18).LT.0) ID(18) = 0
         CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(034),LVLS(1,IGET(034)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     ACCUMULATED SNOWFALL.
         IF (IGET(035).GT.0) THEN
            CALL E2OUT(035,000,ACSNOW,EGRID2,
     x           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
	    ITPREC     = INT(TPREC)
            IFINCR     = MOD(IFHR,ITPREC)
            ID(19)     = IFHR
            ID(20)     = 4
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITPREC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(035),LVLS(1,IGET(035)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     ACCUMULATED SNOW MELT.
         IF (IGET(121).GT.0) THEN
            CALL E2OUT(121,000,ACSNOM,EGRID2,
     x           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
	    ITPREC     = INT(TPREC)
            IFINCR     = MOD(IFHR,ITPREC)
            ID(19)     = IFHR
            ID(20)     = 4
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITPREC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(121),LVLS(1,IGET(121)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     ACCUMULATED STORM SURFACE RUNOFF.
         IF (IGET(122).GT.0) THEN
            CALL E2OUT(122,000,SSROFF,EGRID2,
     x           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITPREC     = INT(TPREC)
            IFINCR     = MOD(IFHR,ITPREC)
            ID(19)     = IFHR
            ID(20)     = 4
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITPREC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(122),LVLS(1,IGET(122)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     ACCUMULATED BASEFLOW-GROUNDWATER RUNOFF.
         IF (IGET(123).GT.0) THEN
            CALL E2OUT(123,000,BGROFF,EGRID2,
     x           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITPREC     = INT(TPREC)
            IFINCR     = MOD(IFHR,ITPREC)
            ID(19)     = IFHR
            ID(20)     = 4
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITPREC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(123),LVLS(1,IGET(123)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     INSTANTANEOUS PRECIPITATION TYPE.
         IF (IGET(160).GT.0) THEN
            CALL CALWXT(T,Q,RES,PD,HTM,LMH,PREC,PT,AETA,ETA,IWX1)
            ID(1:25) = 0
C     
C     DECOMPOSE IWX1 ARRAY
C
            DO J=JSTA,JEND
            DO I=1,IM
              IWX=IWX1(I,J)
              ISNO=MOD(IWX,2)
              IIP=MOD(IWX,4)/2
              IZR=MOD(IWX,8)/4
              IRAIN=IWX/8
              SNOW(I,J)   = ISNO*1.0
              SLEET(I,J)  = IIP*1.0
              FREEZR(I,J) = IZR*1.0
              RAIN(I,J)   = IRAIN*1.0
            ENDDO
            ENDDO
C     
C     INTERPOLATE/OUTPUT REQUESTED SURFACE FIELDS.
C     
C     SNOW.
            ID(8) = 143
            CALL E2OUT(160,000,SNOW,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(160),LVLS(1,IGET(160)),
     X           GRID1,IMOUT,JMOUT)
C     ICE PELLETS.
            ID(8) = 142
            CALL E2OUT(160,000,SLEET,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(160),LVLS(1,IGET(160)),
     X           GRID1,IMOUT,JMOUT)
C     FREEZING RAIN.
            ID(8) = 141
            CALL E2OUT(160,000,FREEZR,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(160),LVLS(1,IGET(160)),
     X           GRID1,IMOUT,JMOUT)
C     RAIN.
            ID(8) = 140
            CALL E2OUT(160,000,RAIN,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(160),LVLS(1,IGET(160)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C
C
C***  BLOCK 5.  SURFACE EXCHANGE FIELDS.
C     
C     TIME AVERAGED SURFACE LATENT HEAT FLUX.
         IF (IGET(042).GT.0) THEN
            IF(ASRFC.GT.0.)THEN
              RRNUM=1./ASRFC
            ELSE
              RRNUM=0.
            ENDIF
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = SFCLHX(I,J)*RRNUM
            ENDDO
            ENDDO
            CALL E2OUT(042,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITSRFC     = INT(TSRFC)
            IFINCR     = MOD(IFHR,ITSRFC)
            ID(19)     = IFHR
            ID(20)     = 3
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITSRFC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(042),LVLS(1,IGET(042)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED SURFACE SENSIBLE HEAT FLUX.
         IF (IGET(043).GT.0) THEN
            IF(ASRFC.GT.0.)THEN
              RRNUM=1./ASRFC
            ELSE
              RRNUM=0.
            ENDIF
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = SFCSHX(I,J)*RRNUM
            ENDDO
            ENDDO
            CALL E2OUT(043,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITSRFC     = INT(TSRFC)
            IFINCR     = MOD(IFHR,ITSRFC)
            ID(19)     = IFHR
            ID(20)     = 3
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITSRFC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(043),LVLS(1,IGET(043)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     TIME AVERAGED SUB-SURFACE SENSIBLE HEAT FLUX.
         IF (IGET(135).GT.0) THEN
            IF(ASRFC.GT.0.)THEN
              RRNUM=1./ASRFC
            ELSE
              RRNUM=0.
            ENDIF
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = SUBSHX(I,J)*RRNUM
            ENDDO
            ENDDO
            CALL E2OUT(135,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITSRFC     = INT(TSRFC)
            IFINCR     = MOD(IFHR,ITSRFC)
            ID(19)     = IFHR
            ID(20)     = 3
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITSRFC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(135),LVLS(1,IGET(135)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     TIME AVERAGED SNOW PHASE CHANGE HEAT FLUX.
         IF (IGET(136).GT.0) THEN
            IF(ASRFC.GT.0.)THEN
              RRNUM=1./ASRFC
            ELSE
              RRNUM=0.
            ENDIF
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = SNOPCX(I,J)*RRNUM
            ENDDO
            ENDDO
            CALL E2OUT(136,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITSRFC     = INT(TSRFC)
            IFINCR     = MOD(IFHR,ITSRFC)
            ID(19)     = IFHR
            ID(20)     = 3
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITSRFC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(136),LVLS(1,IGET(136)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     TIME AVERAGED SURFACE MOMENTUM FLUX.
         IF (IGET(046).GT.0) THEN
            IF(ASRFC.GT.0.)THEN
              RRNUM=1./ASRFC
            ELSE
              RRNUM=0.
            ENDIF
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = SFCUVX(I,J)*RRNUM
            ENDDO
            ENDDO
            CALL E2OUT(046,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITSRFC     = INT(TSRFC)
            IFINCR     = MOD(IFHR,ITSRFC)
            ID(19)     = IFHR
            ID(20)     = 3
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITSRFC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(046),LVLS(1,IGET(046)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     ACCUMULATED SURFACE EVAPORATION
         IF (IGET(047).GT.0) THEN
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = SFCEVP(I,J)
            ENDDO
            ENDDO
            CALL E2OUT(047,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITPREC     = INT(TPREC)
            IFINCR     = MOD(IFHR,ITPREC)
            ID(19)     = IFHR
            ID(20)     = 4
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITPREC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(047),LVLS(1,IGET(047)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     ACCUMULATED POTENTIAL EVAPORATION
         IF (IGET(137).GT.0) THEN
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = POTEVP(I,J)
            ENDDO
            ENDDO
            CALL E2OUT(137,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
C            IFHR       = NTSD/TSPH + 0.5
            IFHR       = ITAG
            ITPREC     = INT(TPREC)
            IFINCR     = MOD(IFHR,ITPREC)
            ID(19)     = IFHR
            ID(20)     = 4
            IF (IFINCR.EQ.0) THEN
               ID(18) = IFHR-ITPREC
            ELSE
               ID(18) = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,1000.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(137),LVLS(1,IGET(137)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     ROUGHNESS LENGTH.
      IF (IGET(044).GT.0) THEN
         CALL E2OUT(044,000,Z0,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(044),LVLS(1,IGET(044)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     FRICTION VELOCITY.
      IF (IGET(045).GT.0) THEN
         CALL E2OUT(045,000,USTAR,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(045),LVLS(1,IGET(045)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SURFACE DRAG COEFFICIENT.
      IF (IGET(132).GT.0) THEN
         CALL CALDRG(EGRID1)
         CALL E2OUT(132,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(132),LVLS(1,IGET(132)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SURFACE U AND/OR V COMPONENT WIND STRESS
      IF ( (IGET(133).GT.0) .OR. (IGET(134).GT.0) ) THEN
CLYRA GSM Wind stress         CALL CALTAU(EGRID1,EGRID2)
CLYRA GSM Wind stress
      EGRID1=XMOMFLUX
      EGRID2=YMOMFLUX
CLYRA GSM Wind stress
C     
C        SURFACE U COMPONENT WIND STRESS.
         IF (IGET(133).GT.0) THEN
            CALL E2OUT(133,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(133),LVLS(1,IGET(133)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        SURFACE V COMPONENT WIND STRESS
         IF (IGET(134).GT.0) THEN
            CALL E2OUT(134,000,EGRID2,EGRID1,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(134),LVLS(1,IGET(134)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
      ENDIF
C     
C     INSTANTANEOUS SENSIBLE HEAT FLUX
      IF (IGET(154).GT.0) THEN
         CALL E2OUT(154,000,TWBS,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(154),LVLS(1,IGET(154)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     INSTANTANEOUS LATENT HEAT FLUX
      IF (IGET(155).GT.0) THEN
         CALL E2OUT(155,000,QWBS,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(155),LVLS(1,IGET(155)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     SURFACE EXCHANGE COEFF
      IF (IGET(169).GT.0) THEN
         CALL E2OUT(169,000,SFCEXC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(169),LVLS(1,IGET(169)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     GREEN VEG FRACTION
      IF (IGET(170).GT.0) THEN
         CALL E2OUT(170,000,VEGFRC,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(170),LVLS(1,IGET(170)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     INSTANTANEOUS GROUND HEAT FLUX
      IF (IGET(172).GT.0) THEN
         CALL E2OUT(172,000,GRNFLX,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25) = 0
         CALL OUTPUT(IOUTYP,IGET(172),LVLS(1,IGET(172)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     END OF ROUTINE
C     
      RETURN
      END

      SUBROUTINE OTLFT2(PBND,TBND,QBND,SLINDX)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    OTLFT2      COMPUTES LIFTED INDEX
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-03-10       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES LIFTS A PARCEL SPECIFIED BY THE
C     PASSED PRESSURE, TEMPERATURE, AND SPECIFIC HUMIDITY TO
C     500MB AND THEN COMPUTES A LIFTED INDEX.  THIS LIFTED 
C     LIFTED INDEX IS THE DIFFERENCE BETWEEN THE LIFTED 
C     PARCEL'S TEMPERATURE AT 500MB AND THE AMBIENT 500MB
C     TEMPERATURE.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-03-10  RUSS TREADON - MODIFIED OTLIFT2 TO LIFT PARCELS
C                            SPECIFIED BY PASSED P, T, AND Q.
C   98-06-15  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL OTLFT2(PBND,TBND,QBND,SLINDX)
C   INPUT ARGUMENT LIST:
C     PBND     - PARCEL PRESSURE.
C     TBND     - PARCEL TEMPERATURE.
C     QBND     - PARCEL SPECIFIC HUMIDITY.
C
C   OUTPUT ARGUMENT LIST: 
C     SLINDX   - LIFTED INDEX.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - CTLBLK
C                  LOOPS
C                  MASKS
C                  PHYS
C                  VRBLS
C                  EXTRA
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     SET LOCAL PARAMETERS.
      PARAMETER
     & (D00=0.E0,H10E5=100000.E0,H5E4=5.E4,CAPA=0.28589641
     &, D8202=.820231E0)
      PARAMETER
     & (ELIVW=2.72E6,CP=1004.6E0,ELOCP=ELIVW/CP)
C     
C     INCLUDE GLOBAL PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "parm.tbl"
C     
C     SET DEPENDENT PARAMETERS.
      PARAMETER
     & (JAM=6+2*(JM-10),LP1=LM+1)
C     
C     DECLARE VARIABLES.
C
                            L O G I C A L
     & RUN,FIRST,RESTRT,SIGMA
C
                            D I M E N S I O N
     & ITTB  (IM,JM),IQTB  (IM,JM),IPTB  (IM,JM),ITHTB (IM,JM)
     &,TBT   (IM,JM),QBT   (IM,JM)
     &,APEBT (IM,JM),TTHBT (IM,JM),TTH   (IM,JM),PP    (IM,JM)
     &,BQS00 (IM,JM),SQS00 (IM,JM),BQS10 (IM,JM),SQS10 (IM,JM)
     &,BQ    (IM,JM),SQ    (IM,JM),TQ    (IM,JM),QQ    (IM,JM)
     &,P00   (IM,JM),P10   (IM,JM),P01   (IM,JM),P11   (IM,JM)
     &,TPSP  (IM,JM),APESP (IM,JM),TTHES (IM,JM)
     &,PSP   (IM,JM),THBT  (IM,JM),THESP (IM,JM)
     &,P     (IM,JM),TP    (IM,JM),BTH   (IM,JM),STH   (IM,JM)
     &,BTHE00(IM,JM),STHE00(IM,JM),BTHE10(IM,JM),STHE10(IM,JM)
     &,T00   (IM,JM),T10   (IM,JM),T01   (IM,JM),T11   (IM,JM)
     &,PARTMP(IM,JM)
     &,SLINDX(IM,JM)
     &,PBND  (IM,JM),TBND  (IM,JM),QBND  (IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
C     
C     DECLARE EQUIVALENCES.
       EQUIVALENCE
     & (ITTB  (1,1),IPTB  (1,1)                           )
     &,(IQTB  (1,1),ITHTB (1,1)                           )
     &,(QQ    (1,1),APESP (1,1),TTHES (1,1)               )
     &,(TTH   (1,1),TQ    (1,1),TP    (1,1)               )
       EQUIVALENCE
     & (BQS00 (1,1),P00   (1,1),BTHE00(1,1),T00   (1,1)   )
     &,(SQS00 (1,1),P10   (1,1),STHE00(1,1),T10   (1,1)   )
     &,(BQS10 (1,1),P01   (1,1),BTHE10(1,1),T01   (1,1)   )
     &,(SQS10 (1,1),P11   (1,1),STHE10(1,1),T11   (1,1)   )
     &,(BQ    (1,1)          ,BTH   (1,1)                 )
     &,(SQ    (1,1)          ,STH   (1,1)                 )

C
C     
C********************************************************************
C     START OTLFT2 HERE.
C     
C     ZERO LIFTED INDEX ARRAY.
C
      DO J=JSTA,JEND
      DO I=1,IM
        SLINDX(I,J)=D00
      ENDDO
      ENDDO
C
C--------------FIND EXNER IN BOUNDARY LAYER-----------------------------
C
      doout130: DO J=JSTA_M2,JEND_M2
      doin130: DO I=2,IM-1
       TBT(I,J)   = TBND(I,J)
       QBT(I,J)   = QBND(I,J)
       APEBT(I,J) = PBND(I,J)
       APEBT(I,J) = (H10E5/APEBT(I,J))**CAPA
      END DO doin130
      END DO doout130
C
C--------------SCALING POTENTIAL TEMPERATURE & TABLE INDEX--------------
C
      doout140: DO J=JSTA_M2,JEND_M2
      doin140: DO I=2,IM-1
       TTHBT(I,J)=TBT(I,J)*APEBT(I,J)
       TTH(I,J)=(TTHBT(I,J)-THL)*RDTH
       QQ(I,J)=TTH(I,J)-AINT(TTH(I,J))
       ITTB(I,J)=INT(TTH(I,J))+1
      END DO doin140
      END DO doout140
C
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
C
      doout145: DO J=JSTA_M2,JEND_M2
      doin145: DO I=2,IM-1
      IF(ITTB(I,J).LT.1)THEN
        ITTB(I,J)=1
        QQ(I,J)=D00
      ENDIF
      IF(ITTB(I,J).GE.JTB)THEN
        ITTB(I,J)=JTB-1
        QQ(I,J)=D00
      ENDIF
      END DO doin145
      END DO doout145
C
C--------------BASE AND SCALING FACTOR FOR SPEC. HUMIDITY---------------
C
      doout150: DO J=JSTA_M2,JEND_M2
      doin150: DO I=2,IM-1
      ITTBK=ITTB(I,J)
      BQS00(I,J)=QS0(ITTBK)
      SQS00(I,J)=SQS(ITTBK)
      BQS10(I,J)=QS0(ITTBK+1)
      SQS10(I,J)=SQS(ITTBK+1)
      END DO doin150
      END DO doout150
C
C--------------SCALING SPEC. HUMIDITY & TABLE INDEX---------------------
C
      doout160: DO J=JSTA_M2,JEND_M2
      doin160: DO I=2,IM-1
      BQ(I,J)=(BQS10(I,J)-BQS00(I,J))*QQ(I,J)+BQS00(I,J)
      SQ(I,J)=(SQS10(I,J)-SQS00(I,J))*QQ(I,J)+SQS00(I,J)
      TQ(I,J)=(QBT(I,J)-BQ(I,J))/SQ(I,J)*RDQ
      PP(I,J)=TQ(I,J)-AINT(TQ(I,J))
      IQTB(I,J)=INT(TQ(I,J))+1
      END DO doin160
      END DO doout160
C
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
C
      doout165: DO J=JSTA_M2,JEND_M2
      doin165: DO I=2,IM-1
        IF(IQTB(I,J).LT.1)THEN
        IQTB(I,J)=1
        PP(I,J)=D00
      ENDIF
      IF(IQTB(I,J).GE.ITB)THEN
        IQTB(I,J)=ITB-1
        PP(I,J)=D00
      ENDIF
      END DO doin165
      END DO doout165
C
C--------------SATURATION PRESSURE AT FOUR SURROUNDING TABLE PTS.-------
C
      doout170: DO J=JSTA_M2,JEND_M2
      doin170: DO I=2,IM-1
      IQ=IQTB(I,J)
      IT=ITTB(I,J)
      P00(I,J)=PTBL(IQ,IT)
      P10(I,J)=PTBL(IQ+1,IT)
      P01(I,J)=PTBL(IQ,IT+1)
      P11(I,J)=PTBL(IQ+1,IT+1)
      END DO doin170
      END DO doout170
C
C--------------SATURATION POINT VARIABLES AT THE BOTTOM-----------------
C
      doout180: DO J=JSTA_M2,JEND_M2
      doin180: DO I=2,IM-1
      TPSP(I,J)=P00(I,J)+(P10(I,J)-P00(I,J))*PP(I,J)
     1                  +(P01(I,J)-P00(I,J))*QQ(I,J)
     2      +(P00(I,J)-P10(I,J)-P01(I,J)+P11(I,J))*PP(I,J)*QQ(I,J)
      IF(TPSP(I,J).LE.D00)TPSP(I,J)=H10E5
      APESP(I,J)=(H10E5/TPSP(I,J))**CAPA
      TTHES(I,J)=TTHBT(I,J)*EXP(ELOCP*QBT(I,J)*APESP(I,J)/TTHBT(I,J))
      END DO doin180
      END DO doout180
C
C-----------------------------------------------------------------------
C
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        PSP(I,J)=TPSP(I,J)
        THBT(I,J)=TTHBT(I,J)
        THESP(I,J)=TTHES(I,J)
      ENDDO
      ENDDO
C
C-----------------------------------------------------------------------
C
 190  CONTINUE
C
C--------------SCALING PRESSURE & TT TABLE INDEX------------------------
C
      doout210: DO J=JSTA_M2,JEND_M2
      doin210: DO I=2,IM-1
      P (I,J)=H5E4
      TP(I,J)=(P(I,J)-PL)*RDP
      QQ(I,J)=TP(I,J)-AINT(TP(I,J))
      IPTB(I,J)=INT(TP(I,J))+1
      END DO doin210
      END DO doout210
C
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
C
      doout215: DO J=JSTA_M2,JEND_M2
      doin215: DO I=2,IM-1
      IF(IPTB(I,J).LT.1)THEN
        IPTB(I,J)=1
        QQ(I,J)=D00
      ENDIF
      IF(IPTB(I,J).GE.ITB)THEN
        IPTB(I,J)=ITB-1
        QQ(I,J)=D00
      ENDIF
      END DO doin215
      END DO doout215
C
C--------------BASE AND SCALING FACTOR FOR THE--------------------------
C
      doout220: DO J=JSTA_M2,JEND_M2
      doin220: DO I=2,IM-1
      IPTBK=IPTB(I,J)
      BTHE00(I,J)=THE0(IPTBK)
      STHE00(I,J)=STHE(IPTBK)
      BTHE10(I,J)=THE0(IPTBK+1)
      STHE10(I,J)=STHE(IPTBK+1)
      END DO doin220
      END DO doout220
C
C--------------SCALING THE & TT TABLE INDEX-----------------------------
C
      doout230: DO J=JSTA_M2,JEND_M2
      doin230: DO I=2,IM-1
      BTH(I,J)=(BTHE10(I,J)-BTHE00(I,J))*QQ(I,J)+BTHE00(I,J)
      STH(I,J)=(STHE10(I,J)-STHE00(I,J))*QQ(I,J)+STHE00(I,J)
      TTH(I,J)=(THESP(I,J)-BTH(I,J))/STH(I,J)*RDTHE
      PP(I,J)=TTH(I,J)-AINT(TTH(I,J))
      ITHTB(I,J)=INT(TTH(I,J))+1
      END DO doin230
      END DO doout230
C
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
C
      doout235: DO J=JSTA_M2,JEND_M2
      doin235: DO I=2,IM-1
      IF(ITHTB(I,J).LT.1)THEN
        ITHTB(I,J)=1
        PP(I,J)=D00
      ENDIF
      IF(ITHTB(I,J).GE.JTB)THEN
        ITHTB(I,J)=JTB-1
        PP(I,J)=D00
      ENDIF
      END DO doin235
      END DO doout235
C
C--------------TEMPERATURE AT FOUR SURROUNDING TT TABLE PTS.------------
C
      doout240: DO J=JSTA_M2,JEND_M2
      doin240: DO I=2,IM-1
      ITH=ITHTB(I,J)
      IP=IPTB(I,J)
      T00(I,J)=TTBL(ITH,IP)
      T10(I,J)=TTBL(ITH+1,IP)
      T01(I,J)=TTBL(ITH,IP+1)
      T11(I,J)=TTBL(ITH+1,IP+1)
      END DO doin240
      END DO doout240
C
C--------------PARCEL TEMPERATURE AT 500MB----------------------------
C
      doout300: DO J=JSTA_M2,JEND_M2
      doin300: DO I=2,IM-1
      IF(TPSP(I,J).GE.H5E4)THEN
        PARTMP(I,J)=(T00(I,J)+(T10(I,J)-T00(I,J))*PP(I,J)
     1                       +(T01(I,J)-T00(I,J))*QQ(I,J)
     2         +(T00(I,J)-T10(I,J)-T01(I,J)+T11(I,J))*PP(I,J)*QQ(I,J))
      ELSE
        PARTMP(I,J)=TBT(I,J)*APEBT(I,J)*D8202
      ENDIF
C
C--------------LIFTED INDEX---------------------------------------------
C
      SLINDX(I,J)=T500(I,J)-PARTMP(I,J)
      END DO doin300
      END DO doout300
C     
C     END OF ROUTINE.
      RETURN
      END

      SUBROUTINE CALPW(PW)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALPW       COMPUTES 
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-24       
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES PRECIPITABLE WATER IN A COLUMN
C     EXTENDING FROM THE FIRST ATMOSPHERIC ETA LAYER TO THE
C     MODEL TOP.  THE DEFINITION USED IS
C                                 TOP
C            PRECIPITABLE WATER = SUM (Q+CLDW) DP*HTM/G
C                                 BOT
C     WHERE,
C        BOT IS THE FIRST ETA LAYER,
C        TOP IS THE MODEL TOP,
C        Q IS THE SPECIFIC HUMIDITY (KG/KG) IN THE LAYER
C        CLDW IS THE CLOUD WATER (KG/KG) IN THE LAYER
C        DP (Pa) IS THE LAYER THICKNESS.
C        HTM IS THE HEIGHT MASK AT THAT LAYER (=0 IF BELOW GROUND)
C        G IS THE GRAVITATIONAL CONSTANT
C     
C PROGRAM HISTORY LOG:
C   92-12-24  RUSS TREADON
C   96-03-04  MIKE BALDWIN - ADD CLOUD WATER AND SPEED UP CODE
C   98-06-15  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION                 
C     
C USAGE:    CALL CALPW(PW)
C   INPUT ARGUMENT LIST:
C     PW       - ARRAY OF PRECIPITABLE WATER.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE     
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LOOPS
C                  EXTRA
C                  VRBLS
C                  MASKS
C                  CLDWTR
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE/SET PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
C     
C     SET DENSITY OF WATER AT 1 ATMOSPHERE PRESSURE, 0C.
C     UNITS ARE KG/M**3.
      PARAMETER (RHOWAT=1.E3)
C     
C     DECLARE VARIABLES.
C     
      INTEGER LLMH
      REAL ALPM,DZ,PM,PWSUM,RHOAIR
      REAL PW(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "CTLBLK.comm"
C
C***************************************************************
C     START CALPW HERE.
C
C     INITIALIZE PW TO 0.    
C     
      PW = 0.
C     
C     OUTER LOOP OVER VERTICAL DIMENSION.
C     INNER LOOP OVER HORIZONTAL GRID.
C     
!$omp  parallel do
!$omp& private(dp)
      DO L = 1,LM
        DO J=JSTA,JEND
        DO I=1,IM
          DP   =PINT(I,J,L+1)-PINT(I,J,L)
          PW(I,J)=PW(I,J)+(Q(I,J,L)+CWM(I,J,L))*DP*GI*HTM(I,J,L)
        ENDDO
        ENDDO
      ENDDO
C     
C        AT ONE TIME THE SUM WAS DIVIDED BY THE DENSITY OF
C        WATER.  (TO GET PW IN M) THIS IS NO LONGER DONE.
C        PW(I,J) = PWSUM/RHOWAT
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE CALLCL(P1D,T1D,Q1D,PLCL,ZLCL)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALLCL      COMPUTES LCL HEIGHTS AND PRESSURE
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-03-15
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES THE LIFTING CONDENSATION LEVEL 
C     PRESSURE AND HEIGHT IN EACH COLUMN AT MASS POINTS.
C     THE HEIGHT IS ABOVE GROUND LEVEL.  THE EQUATION USED
C     TO FIND THE LCL PRESSURE IS FROM BOLTAN (1980,MWR) 
C     AND IS THE SAME AS THAT USED IN SUBROUTINE CALCAPE.
C     
C     THIS ROUTINE IS A TEST VERSION.  STILL TO BE RESOLVED
C     IS THE "BEST" PARCEL TO LIFT.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-03-15  RUSS TREADON
C   98-06-16  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION            
C     
C USAGE:    CALL CALLCL(P1D,T1D,Q1D,PLCL,ZLCL)
C   INPUT ARGUMENT LIST:
C     P1D      - ARRAY OF PARCEL PRESSURES (PA)
C     T1D      - ARRAY OF PARCEL TEMPERATURES (K)
C     Q1D      - ARRAY OF PARCEL SPECIFIC HUMIDITIES (KG/KG)
C
C   OUTPUT ARGUMENT LIST: 
C     PLCL     - PARCEL PRESSURE AT LCL (PA)
C     ZLCL     - PARCEL AGL HEIGHT AT LCL (M)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LOOPS
C                  VRBLS
C                  EXTRA
C                  OPTIONS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     
C     INCLUDE/SET PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
C
      PARAMETER (D35=3.5,D4805=4.805,H2840=2840.,H55=55.)
      PARAMETER (D2845=0.2845,D28=0.28)
C
C     DECLARE VARIABLES.
C     
      LOGICAL OLDRD,STDRD
      REAL P1D(IM,JM),T1D(IM,JM),Q1D(IM,JM)
      REAL PLCL(IM,JM),TLCL(IM,JM),ZLCL(IM,JM)
CX      REAL PFAL(IM,JM),TFAL(IM,JM),QFAL(IM,JM)
CX      REAL PSAL(IM,JM),TSAL(IM,JM),QSAL(IM,JM)
CX      REAL PBAR(IM,JM),TBAR(IM,JM),QBAR(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C**********************************************************************
C     START CALLCL HERE.
C     
C     LOAD OUTPUT ARRAYS WITH SPECIAL VALUE.
C     
      DO J=JSTA,JEND
      DO I=1,IM
        PLCL(I,J)=SPVAL
        TLCL(I,J)=SPVAL
        ZLCL(I,J)=SPVAL
      ENDDO
      ENDDO

CX      DO J=JSTA,JEND
CX      DO I=1,IM
CX         LLMH    = LMH(I,J)
CX         ALPFAL  = D50*(ALPINT(I,J,LLMH)+ALPINT(I,J,LLMH+1))
CX         ALPSAL  = D50*(ALPINT(I,J,LLMH-1)+ALPINT(I,J,LLMH))
CX         PFAL(I,J) = EXP(ALPFAL)
CX         PSAL(I,J) = EXP(ALPSAL)
CX         TFAL(I,J) = T(I,J,LLMH)
CX         TSAL(I,J) = T(I,J,LLMH-1)
CX         QFAL(I,J) = Q(I,J,LLMH)
CX         QSAL(I,J) = Q(I,J,LLMH-1)
CX         PBAR(I,J) = D50*(PFAL(I,J)+PSAL(I,J))
CX         TBAR(I,J) = D50*(TFAL(I,J)+TSAL(I,J))
CX         QBAR(I,J) = D50*(QFAL(I,J)+QSAL(I,J))
CX      ENDDO
CX      ENDDO

C     
C     COMPUTE PRESSURE, TEMPERATURE AND AGL HEIGHT AT LCL.
C
      doout30: DO J=JSTA_M,JEND_M
      doin30: DO I=2,IM-1
      EVP      =P1D(I,J)*Q1D(I,J)/(EPS+ONEPS*Q1D(I,J))
      RMX      =EPS*EVP/(P1D(I,J)-EVP)
      CKAPA    =D2845*(1.-D28*RMX)
      RKAPA    =1./CKAPA
      ARG      =EVP*D01
      ARG      =AMAX1(H1M12,ARG)
      DENOM    =D35*ALOG(T1D(I,J))-ALOG(ARG)-D4805
      TLCL(I,J)=H2840/DENOM+H55
      PLCL(I,J)=P1D(I,J)*(TLCL(I,J)/T1D(I,J))**RKAPA
      ALPLCL   =ALOG(PLCL(I,J))
      LLMH     =LMH(I,J)
C
      do20: DO L=LLMH,1,-1
      IF(ALPINT(I,J,L).LT.ALPLCL)THEN
        DLPLCL   =ALPLCL-ALPINT(I,J,L+1)
        DALP     =ALPINT(I,J,L)-ALPINT(I,J,L+1)
        DZ       =ZINT(I,J,L)-ZINT(I,J,L+1)
        ZLCL(I,J)=ZINT(I,J,L+1)+DZ*DLPLCL/DALP
        ZSFC     =FIS(I,J)*GI
        ZLCL(I,J)=ZLCL(I,J)-ZSFC
        ZLCL(I,J)=AMAX1(D00,ZLCL(I,J))
CX               PSFC=PD(I,J)+50.E2
CX               WRITE(81,1234)I,J,LLMH,L,PSFC*D01,T1D(I,J),ZSFC
CX               WRITE(81,1234)I,J,LLMH,L,PLCL(I,J)*D01,TLCL(I,J),ZLCL(I,J)
CX               WRITE(81,*)' '
CX 1234          FORMAT(I3,1X,I3,1X,2(I2,1X),4(G12.6,1X))
               
        CYCLE  doin30
      ENDIF
      END DO do20
      END DO doin30
      END DO doout30
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE DEWPOINT( VP, TD, IM,JM )
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    DEWPOINT    COMPUTES DEWPOINTS FROM VAPOR PRESSURE
C   PRGMMR: J TUCCILLO       ORG: W/NP2       DATE: 90-05-19
C
C ABSTRACT: COMPUTES THE DEWPOINTS FOR THE N VALUES
C           OF VAPOR PRESSURE IN ARRAY VP.
C   .
C   .       THE FORMULA
C   .
C   .            VP = 0.611 * (X**A) * EXP( (A+B)*(1-X) )
C   .
C   IS USED TO GET DEWPOINT TEMPERATURE T, WHERE
C   .
C   X = T3/T,                   T3=TRIPLE PT TEMPERATURE,
C   VP=VAPOR PRESSURE IN CBS,   0.611=VP AT T3,
C   A=(SPEC. HT. OF WATER-CSUBP OF VAPOR)/GAS CONST OF VAPOR
C   .                        AND
C   B=LATENT HEAT AT T3/(GAS CONST OF VAPOR TIMES T3).
C   .
C   ON THE FIRST CALL, A TABLE  TDP  IS CONSTRUCTED GIVING
C   DEWPOINT AS A FUNCTION OF VAPOR PRESSURE.
C   .
C   VALUES OF VP LESS THAN THE FIRST TABLE ENTRY
C   (RVP1 IN THE CODE) WILL BE GIVEN DEWPOINTS FOR
C   THAT BEGINNING VALUE.  SIMILARLY , VP VALUES THAT
C   EXCEED THE MAXIMUM TABLE VALUE (RVP2 IN THE CODE)
C   WILL BE ASSIGNED DEWPOINTS FOR THAT MAXIMUM VALUE.
C   .
C   THE VALUES 0.02 AND 8.0 FOR RVP1 AND RVP2 YIELD
C   DEWPOINTS OF 233.6K AND 314.7K,RESPECTIVELY.
C   .
C
C PROGRAM HISTORY LOG:
C   90-05-19  J TUCCILLO
C   93-05-12  R TREADON - EXPANDED TABLE SIZE AND RESET
C                         RANGE OF PRESSURES COVERED BY
C                         TABLE.
C   98-06-12  T BLACK   - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C
C USAGE:  CALL DEWPOINT( VP, TD, N )
C   INPUT ARGUMENT LIST:
C     VP       - ARRAY OF N VAPOR PRESSURES(CENTIBARS)
C     IM,JM    - DIMENSIONS OF THE INPUT ARRAY VP.
C
C   OUTPUT ARGUMENT LIST:
C     TD       - DEWPOINT IN DEGREES ABSOLUTE
C
C   SUBPROGRAMS CALLED:
C     LIBRARY:
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN
C   MACHINE:  CRAY C-90
C
C$$$
       INCLUDE "CTLBLK.comm"
C
C          NT IS THE TABLE SIZE
      PARAMETER (NT=2000)
C...TRANSLATED BY FPP 3.00Z36 11/09/90  14:48:53  
C...SWITCHES: OPTON=I47,OPTOFF=VAE0
      DIMENSION TDP(NT),VP(IM,JM),TD(IM,JM)
CX      LOGICAL LFRST
CX      DATA LFRST / .TRUE. /
C
C
CX      IF ( LFRST ) THEN
C
CX      LFRST = .FALSE.
C          PREPARE THE TABLE (TDP=DEWPT AS FCN OF VAPOR PRESS).
C          RANGE IN CENTIBARS IS FROM RVP1 THRU RVP2
coff      RVP1=0.02E0
coff      RVP2=8.E0
      rvp1=0.0001E0
      rvp2=10.E0
C          THE TRIPLE POINT
      RT3=273.16E0
C          VAPOR PRESS AT THE TRIPLE POINT
      RVP3=0.611E0
      RLOG3=LOG(RVP3)
C          (SPEC HT OF WATER -CSUBP OF VAPOR)/GAS CONST OF VAPOR.
      RA=5.0065E0
C          LATENT HEAT AT T3/(GAS CONST OF VAPOR * TRIPLE PT TEMP).
      RB=19.83923E0
      RAPB=RA+RB
C          CRITERION FOR CONVERGENCE OF NEWTON ITERATION
      RTEST=1.E-6
CMEB  RTEST=1.E-8  !  PROBABLY WON'T CONVERGE WITH 32-BIT AT THIS CRITERION
C
      RNT=FLOAT(NT)
C          TABLE INCREMENT IN VAPOR PRESS
      RDVP=(RVP2-RVP1)/(RNT-1.E0)
C          RGS WILL BE THE GUESSED VALUE OF (T3  /  DEWPOINT)
      RGS=1.E0
      RVP=RVP1-RDVP
C
      DO 20 NN=1,NT
      RVP=RVP+RDVP
      RLVP=LOG(RVP)-RLOG3-RAPB
C     ***** ENTER NEWTON ITERATION LOOP
   10 RN=RA*LOG(RGS)-RAPB*RGS-RLVP
C          THAT WAS VALUE OF FUNCTION
C          NOW GET ITS DERIVATIVE
      RD=(RA/RGS)-RAPB
C          THE DESIRED CHANGE IN THE GUESS
      RCH=RN/RD
      IF( ABS(RCH) .LT. RTEST ) GO TO 15
C          NEED MORE ITERATIONS
      RGS=RGS-RCH
      GO TO 10
C          *****
C          HAVE ACCURATE ENUF VALUE OF RGS=T3/DEWPOINT.
   15 RT=RT3/RGS
      TDP(NN)=RT
C
   20 CONTINUE
C      PRINT 25,RVP1,RVP2,TDP(1),TDP(NT)
C  25  FORMAT(/'0', 'IN SUBROUTINE DEWPOINT, THE DEWPT TABLE ',
C    1             'HAS RVP1=', 1PE13.6, ', RVP2=', 1PE13.6,
C    2             ', TDP(1)=', 1PE13.6, ', AND TDP(NT)=',
C    3             1PE13.6, '.'/)
C           CONSTANTS FOR USING THE TABLE
      A=1./RDVP
      B=1.-A*RVP1
      DNTM1=FLOAT(NT) -.01
C
CX      END IF
C
C          *********** ENTER TO USE THE TABLE.  ************
C
      DO J=JSTA,JEND
      DO I=1,IM
        W1=AMIN1(AMAX1((A*VP(I,J)+B),1.0),DNTM1)
        W2=AINT(W1)
        JNT=INT(W2)
        TD(I,J) = TDP(JNT)+(W1-W2)*(TDP(JNT+1)-TDP(JNT))
      ENDDO
      ENDDO
C
C
      RETURN
      END

      SUBROUTINE OUTPUT(IOUTYP,IFLD,ILVL,GRID,IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    OUTPUT      DRIVER FOR PACKING/POSTING ROUTINES.
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-24       
C     
C ABSTRACT:
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-02-26  RUSS TREADON
C   93-06-13  RUSS TREADON - ADDED COMBINED ON84 AND GRIB PACKING OPTION.
C   98-07-17  MIKE BALDWIN - REMOVED PACK84
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL OUTPUT(IOUTYP,IFLD,ILVL,GRID,IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IOUTYP   - INTEGER FLAG FOR TYPE OF OUTPUT.
C     IFLD     - LOCATION OF FIELD INFORMATION IN ARRAYS.
C     ILVL     - INDEX OF LEVEL (P,ETA,SFC) OF GRID.
C     GRID     - OUTPUT GRID.
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NOPACK   - WRITE DATA AS UNFORMATTED BINARY CRAY WORDS.
C       GRIBIT   - PACK/WRITE DATA IN GRIB FORMAT.
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
CJLG  
      INCLUDE "parmout" 
      INCLUDE "RQSTFLD1.comm"      
CJLG       
      INCLUDE "CTLBLK.comm"
C     
C     DECLARE VARIABLES.
      DIMENSION GRID(IMOUT,JMOUT)
C
      common/jjt/time_output, time_e2out
      real(8) ist, rtc, time_output, time_e2out
C***********************************************************
C     START OUPUT HERE.
C     
C     BRANCH TO APPROPRIATE OUTPUT ROUTINE.
C    
C      ist = rtc()
      IF ( ME .EQ. 0 ) THEN
c     call stat(grid,imout,jmout)
CJLG      CALL MINMAX(GRID,IMOUT,JMOUT,FMIN,FMAX)
CJLG      SFC = 0.
CJLG      WRITE(6,1040) IFLD,FIELD(IFLD),FMIN,FMAX
CJLG 1040 FORMAT('NOPACK:',I3,1X,A20,1X,2(G12.6,1X))

      IF (IOUTYP.EQ.1) CALL NOPACK(IFLD,ILVL,GRID,IMOUT,JMOUT)
      IF (IOUTYP.EQ.3) CALL GRIBIT(IFLD,ILVL,GRID,IMOUT,JMOUT)
      IF (IOUTYP.EQ.5) CALL GRIBIT(IFLD,ILVL,GRID,IMOUT,JMOUT)
      END IF
C      time_output = time_output + rtc() - ist
C
C     END OF ROUTINE.
C
      RETURN
      END

	SUBROUTINE GETGDEF

C*	SUBROUTINE WRITTEN AS FIRST STEP IN A "FLEXIBLE" POST
C*	
C*	USED IN ASSOCIATION WITH THE WORKSTATION ETA, IT READS
C*	THE NECESSARY GRID INFORMATION FROM THE NAMELIST FILE 
C*	ETAIN, AND CALCULATES THE NECESSARY INFORMATION ABOUT THE
C*	OUTPUT GRID.  
C*
C*	98-12-21 Pyle--Initial version which only handles the native
C*	e-grid.  Based largely on the e-grid boundary finding code
C*	of E. Rogers.
C*
C*	99-04-06 PYLE--Changed to reflect new model_grids namelist
C*
C*	99-04-06 PYLE--Changed so copygb input fields would be generated
C*	here instead of in another script as was done previously
C*
C*	00-03-03 PYLE--Changed so will interpolate properly across the DL
C*	A bit of a fudge for lmbc grids since copygb seems troubled by
C*	the DL.  Also made some fixes for the southern hemisphere
C*

	INCLUDE "GDS.com"
	include 'ecommons.h'
        INCLUDE "mpif.h"

      namelist/model_grids/tlm0d,tph0d,im,jm,lm,ptinp,dlmd,dphd
     .                    ,dt,w,idtad,imonth,idate,iyear,istrtim
     .                    ,nsoil
     .                    ,ninit,init_in,rean_sfc,rean,
     .			   init_gdsdir,init_out
     .                    ,tboco,nhour
     .                    ,fcst_out
c
C
                             P A R A M E T E R
     & (IMAX=2500,JMAX=4500,IMJMMAX=IMAX*JMAX-JMAX/2)
                          D I M E N S I O N
     & KHL0  (JMAX),KHH0  (JMAX), GLAT(IMJMMAX),GLON(IMJMMAX)
                             D A T A
     & PI/3.141592654/

	character*4 tag
	character*3 proj

C-----------------------------------------------------------------------
c *** Read ETA namelist.
c
      open(1,file='ETAIN',form='formatted',status='old',err=900)
      read(1,model_grids,end=901)
      
      IF ( ME .EQ. 0 ) write(6,*) 'past read of ETAIN'
      close(1)
	WBD=-(IM-1.)*DLMD
	SBD=(-(JM-1.)/2.)*DPHD
	IF ( ME .EQ. 0 )write(6,*) 'IM= ', IM
 	IF ( ME .EQ. 0 )write(6,*) 'JM= ', JM	
	IMJM=IM*JM-JM/2
C
      IF ( ME .EQ. 0 ) 
     & write(6,*) 'grid centered at ',TPH0D, TLM0D

      DTR=PI/180.
      TPH0=TPH0D*DTR
      WB=WBD*DTR
      SB=SBD*DTR
      DLM=DLMD*DTR
      DPH=DPHD*DTR
      TDLM=DLM+DLM
      TDPH=DPH+DPH
C
      STPH0=SIN(TPH0)
      CTPH0=COS(TPH0)
C
      DO 100 J=1,JM
      KHL0(J)=IM*(J-1)-(J-1)/2+1
      KHH0(J)=IM*J-J/2
  100 CONTINUE

C--------------GEOGRAPHIC LAT AND LONG OF TLL GRID POINTS---------------
              TPH=SB-DPH
              doout200: DO J=1,JM
              KHL=KHL0(J)
              KHH=KHH0(J)
C
              TLM=WB-TDLM+MOD(J+1,2)*DLM
              TPH=TPH+DPH
              STPH=SIN(TPH)
              CTPH=COS(TPH)
C
          doin200: DO K=KHL,KHH
      TLM=TLM+TDLM
      SPH=CTPH0*STPH+STPH0*CTPH*COS(TLM)
      GLAT(K)=ASIN(SPH)
      CLM=CTPH*COS(TLM)/(COS(GLAT(K))*CTPH0)-TAN(GLAT(K))*TAN(TPH0)
C      print*,CTPH,COS(TLM),COS(GLAT(K)),CTPH0,TAN(GLAT(K)),TAN(TPH0)
          IF(CLM.GT.1.)      CLM=1.
      FACT=1.
          IF(TLM.GT.0.)      FACT=-1.
      GLON(K)=(-TLM0D*DTR+FACT*ACOS(CLM))/DTR

Cmp	at this point GLON is in DEGREES WEST
	if (GLON(K) .lt. 0) GLON(K)=GLON(K)+360.
	if (GLON(K) .gt. 360.) GLON(K)=GLON(K)-360.
	if (GLON(K) .lt. 180) GLON(K)=-GLON(K)         ! make WH negative
	if (GLON(K) .gt. 180) GLON(K)=360.-GLON(K)     ! make EH 

	GLAT(K)=GLAT(K)/DTR

       END DO doin200
       END DO doout200
C
	write(6,*) ' '
	ilat=(glat(1)*1000.)
	ilon=(glon(1)*1000.)
	iclat=(TPH0D*1000.)
	iclon=(TLM0D*1000.)
	idelx=(DLMD*1000.)
	idely=(DPHD*1000.)
Cmp	write(6,*) ilat,ilon,iclat,iclon,idelx,idely
 1020 format('LOWER LEFT  POINT= ',f12.5,x,f12.5)
 1021 FORMAT('UPPER RIGHT POINT= ',F12.5,X,F12.5)
C
Cmp	define the grid in w3fi71 format
	IGDS(1)=0
	IGDS(2)=255
	IGDS(3)=203
	IGDS(4)=IM
	IGDS(5)=JM
	IGDS(6)=ilat
	IGDS(7)=ilon
	IGDS(8)=136
	IGDS(9)=iclat
	IGDS(10)=iclon
	IGDS(11)=idelx
	IGDS(12)=idely
	IGDS(13)=64
	IGDS(14)=0

	IF ( ME .EQ. 0 )write(6,*) 'IGDS= ',(IGDS(I),I=1,18)

	tag='ETWS'
	proj='CED'
	ilat2=0
	IMT=IM*2-1
	JMT=JM
	frac=0.5
	open(unit=63,file='grdnav.tbl',form='formatted')
	write(63,207) tag,IGDS(2),proj,int(TPH0D),int(TLM0D),ilat2,
     +	glat(1),glon(1),glat(imjm),glon(imjm),IMT,JMT,frac,ilat2
  207	format(A4,x,I3,x,A3,x,I3,x,I4,x,I3,x,f7.3,x,f8.3,x,f7.3,x,f8.3,x,
     +	I3,x,I3,x,f4.2,x,I1)


Cmp	get the lat-lon info for copygb

Cmp	set dlat a bit coarser than the filled e-grid
Cmp	dlat=DPHD*1.25
	dlattmp=(1./(DPHD*1.25))
	dlat=1./dlattmp
	if (TPH0D .ge. 0) wlon=(glon(1))+1
	if (TPH0D .lt. 0) wlon=(glon(imjm-im+1))+1
        slat=(TPH0D+SBD)+1
Cmp
	if (wlon .gt. 0 .and. TLM0D .lt. 0) then
	wloncalc=wlon-360.
	else
	wloncalc=wlon
	endif

        delta=abs(TLM0D-wloncalc)
        elon=(TLM0D+delta)-1
        nlat=(GLAT(IMJM))-1

Cmp     search the lat values corresponding to wlon

C	if (tph0d .ge. 0) then
	
	IF ( ME .EQ. 0 ) 
     &  write(6,*) 'target longitude is ' , wlon

        do K=1,imjm
        dif=abs(wlon-glon(k))
        if (dif .lt. 1 .and. dif .gt. 0.) then
C        IF ( ME .EQ. 0 )
C    &  write(6,*) 'changing tnlat to ', tnlat
        tnlat=glat(k)
        endif
        enddo

C	elseif (tph0d .lt. 0) then

C	do K=imjm,1,-1
C	dif=abs(wlon-glon(k))
C        if (dif .lt. 1 .and. dif .gt. 0.) then
C        tnlat=glat(k)
C        endif
C        enddo

C	endif

Cmp	dateline add
       IF ( ME .EQ. 0 )
     & write(6,*) 'going into check ', wlon, elon
C	extend from West into East
	if (TLM0D .lt. 0 .and. wlon .gt. 0) then
	wloncalc=wlon-360.
	eloncalc=elon
C	extend from East into West
	elseif (TLM0D .gt. 0 .and. elon .lt. 0) then
	wloncalc=wlon
	eloncalc=elon+360.
	else
C	normal
	eloncalc=elon
	wloncalc=wlon
	endif
       IF ( ME .EQ. 0 )
     & write(6,*) 'found eloncalc,wloncalc ', eloncalc,wloncalc
C	STOP

Cmp end dateline add
        nlat=(tnlat)-1
        jdim=((nlat-slat)/dlat)+1
Cmp        idim=((elon-wlon)/dlat)+1
        idim=((eloncalc-wloncalc)/dlat)+1
        islat=slat*1000
        iwlon=wlon*1000
        nlat=nlat*1000
Cmp
Cmp	if (elon .gt. 180) elon=elon-360.
        ielon=elon*1000
        idlat=(dlat*1000)
        open (unit=23,file='outjob_input_lat',form='formatted',
     +  access='sequential',status='unknown')
        write(23,299) IDIM,JDIM,islat,iwlon,nlat,ielon,idlat,idlat
  299   format('255 0 ',2(I4,x),I6,x,I7,x,'128 ',I6,x,I7,x,2(I3,x),'64')
	close(23)

Cmp     now compute the values needed for a lambert conic conformal
Cmp     projection.  Use dimensions of filled e-grid

        IDIM=IM*2-1
        JDIM=JM

        idx=INT(DPHD*111*1000)
        idy=idx

Cmp        LATONE=INT(GLAT(1)*1000)
Cmp        LONONE=INT(GLON(1)*1000)
        LATONE=INT(GLAT(2)*1000)
        LONONE=INT(GLON(2)*1000)

Cmp
	IF ( ME .EQ. 0 )write(6,*) 'LONONE= ', LONONE
	if (LONONE .gt. 0 .and. TLM0D .lt. 0) then
	tlmuse=179.
C	tlmuse=TLM0D
	else
	tlmuse=TLM0D
	endif
	
        open (unit=24,file='outjob_input_lmbc',form='formatted',
     +  access='sequential',status='unknown')
        write(24,301) IDIM,JDIM,latone,lonone,int(tlmuse*1000),idx,idy,
     +  int(TPH0D*1000),INT(TPH0D*1000)

  301   format('255 3 ',2(I3,x),I6,x,I7,x,'8 ',I7,x,2(I6,x),'0 64',
     +  2(x,I6))

  900	IF ( ME .EQ. 0 )print*, 'end of namelist file'
  901	IF ( ME .EQ. 0 )print*, 'model list trouble'
	RETURN
      END

C***************************************************************************

	BLOCK DATA GDSVAR
	include "GDS.com"
	
	DATA IGDS/18*0/
	end

C***********************************************************************

      SUBROUTINE GRIBIT(IFLD,ILVL,GRID,IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GRIBIT      POST FIELDS IN GRIB1
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-06-18       
C     
C ABSTRACT:
C     THIS ROUTINE POSTS THE DATA IN THE PASSED ARRAY GRID
C     TO THE OUTPUT FILE IN GRIB1 FORMAT.
C     
C PROGRAM HISTORY LOG:
C   93-06-18  RUSS TREADON
C   93-11-23  RUSS TREADON - REMOVED CODE GENERATING GRIB INDEX FILE.
C   98-07-17  MIKE BALDWIN - REMOVED LABL84, NOW USING ID
C     
C USAGE:    CALL GRIBIT(IFLD,ILVL,GRID,IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IFLD     - FIELD ID TAG.
C     ILVL     - INTEGER TAG FOR LEVEL OF FIELD.
C     GRID     - FIELD TO BE POSTED IN GRIB.
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     
C   OUTPUT FILES:
C     STDOUT    - RUN TIME STANDARD OUT.
C     LUNOUT+1  - UNIT TO RECEIVE GRIB1 DATA.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C     GETENV   - CRAY SUBROUTINE TO GET VALUE OF ENVIRONMENT VARIABLE.
C     MINMAX   - DETERMINES MIN/MAX VALUES IN AN ARRAY.
C     WRYTE    - WRITE DATA OUT BY BYTES.
C     GET_BITS   - COMPUTE NUMBER OF BITS 
C     VARIOUS W3LIB ROUTINES
C     LIBRARY:
C       COMMON   - CTLBLK
C                  MAPOT
C                  RQSTFLD
C                  IOUNIT
C                  OUTGRD
C                  GRBDAT
C                  AVBLFLDS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C
C     INCLUDE GRID DIMENSIONS.  SET/DERIVE PARAMETERS.
C
      INCLUDE "parmeta"
      INCLUDE "parmout"
      PARAMETER (LP1=LM+1,D01=0.01,D50=0.5E0)
      PARAMETER (IMT=2*IM-1,JMT=JM,IMJMT=IMT*JMT)
C     
C     GRIB1 PARAMETERS.
C        MNBIT  = MINIMUM NUMBER OF BITS TO USE IN PACKING.
C        MXBIT  = MAXIMUM NUMBER OF BITS TO USE IN PACKING.
C        LENPDS = LENGTH OF GRIB1 PDS.
C        LENGDS = LENGTH OF GRIB1 GDS.
C     
      PARAMETER (MNBIT=0,MXBIT=16,LENPDS=28,LENGDS=32)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESRT,SIGMA,OLDRD,STRD
      LOGICAL NORTH
      CHARACTER*1  KBUF(30+LENPDS+LENGDS+IMOUT*JMOUT*(MXBIT+2)/8)
      CHARACTER*1  IFLAG
      CHARACTER*4  RESTHR,BLANK
      CHARACTER*6  CRUN,PROJ
      CHARACTER*7  DESCR2
      CHARACTER*28 PDS
Cmp      CHARACTER*50 ENVAR
      CHARACTER*90 ENVAR
      CHARACTER*110 FNAME,OPATH
      CHARACTER*90 CMD
      INTEGER IBDSFL(9)
Cmp      INTEGER IGRD(IMOUT,JMOUT),IGDS(18),IBMASK(IMOUT,JMOUT)
      INTEGER IGRD(IMOUT,JMOUT),IBMASK(IMOUT,JMOUT)
Cmp
      REAL GRID(IMOUT,JMOUT),GRIDOT(IMOUT,JMOUT)
C     
C     THE BELOW VARIABLE ARE ONLY NEEDED FOR THE CALL TO W3FI63.
      REAL DATAFLD(IMOUT,JMOUT)
      INTEGER KGDS(20),KPTR(16)
      LOGICAL KBMS(IMOUT,JMOUT)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "OUTGRD.comm"
      INCLUDE "BITMAP.comm"
      INCLUDE "GRBDAT.comm"
      INCLUDE "OUTFIL.comm"
Cmp
        INCLUDE "GDS.com"
Cmp
C     
C     SET DEFAULT GRIB1 PARAMETERS.  
C     PARAMETERS MNBIT, MXBIT, IBX, AND NBIT ARE USED 
C     IN THE CALL TO GET_BITS.
C        IBX    = DESIRED BINARY PRECISION.
C        NBIT   = NUMBER OF BITS TO USE IN PACKING DATA.
C     
      DATA IBX,NBIT / 0, 12 /
      DATA BLANK /'    '/
      SAVE OPATH
C
C*****************************************************************************
C     START GRIBIT HERE.
C
C     SET NUMBER OF OUTPUT GRID POINTS.
      IJOUT = IMOUT*JMOUT
C     
C     PREPARE GRIB PDS
C     
C     SET ARRAY ID VALUES TO GENERATE GRIB1 PDS.  
C        ID(1)  = NUMBER OF BYTES IN PRODUCT DEFINITION SECTION (PDS)
C        ID(2)  = PARAMETER TABLE VERSION NUMBER
C        ID(3)  = IDENTIFICATION OF ORIGINATING CENTER
C        ID(4)  = MODEL IDENTIFICATION (ALLOCATED BY ORIGINATING CENTER)
C        ID(5)  = GRID IDENTIFICATION
C        ID(6)  = 0 IF NO GDS SECTION, 1 IF GDS SECTION IS INCLUDED
C        ID(7)  = 0 IF NO BMS SECTION, 1 IF BMS SECTION IS INCLUDED
C        ID(8)  = INDICATOR OF PARAMETER AND UNITS (TABLE 2)
C        ID(9)  = INDICATOR OF TYPE OF LEVEL       (TABLE 3)
C        ID(10) = VALUE 1 OF LEVEL (=0 FOR 1-100,102,103,105,107,
C          109,111,113,115,117,119,125,160,200,201 LEVEL IS IN ID WORD 11)
C        ID(11) = VALUE 2 OF LEVEL
C        ID(12) = YEAR OF CENTURY
C        ID(13) = MONTH OF YEAR
C        ID(14) = DAY OF MONTH
C        ID(15) = HOUR OF DAY
C        ID(16) = MINUTE OF HOUR   (IN MOST CASES SET TO 0)
C        ID(17) = FCST TIME UNIT
C        ID(18) = P1 PERIOD OF TIME
C        ID(19) = P2 PERIOD OF TIME
C        ID(20) = TIME RANGE INDICATOR
C        ID(21) = NUMBER INCLUDED IN AVERAGE
C        ID(22) = NUMBER MISSING FROM AVERAGES
C        ID(23) = CENTURY  (20, CHANGE TO 21 ON JAN. 1, 2001)
C        ID(24) = RESERVED - SET TO 0
C        ID(25) = SCALING POWER OF 10
C
      IF (IOUTYP.EQ.3.OR.IOUTYP.EQ.5) THEN
C     
C        PREPARE DATE PART OF GRIB PDS RECORD.
C         IFHR       = NTSD/TSPH+D50
         IFHR       = ITAG
	 ICENT      = (IDAT(3)-1)/100 + 1
         IYY        = IDAT(3) - (ICENT-1)*100
         IMM        = IDAT(1)
         IDD        = IDAT(2)
         AYEAR0     = IYY
         AMNTH0     = IMM
         ADAY0      = IDD
         AGMT0      = IHRST
         ID(01)     = 28
         ID(02)     = 2
         ID(03)     = 7
         ID(12)     = IYY
         ID(13)     = IMM
         ID(14)     = IDD
         ID(15)     = IHRST
         ID(16)     = 0

C	ID(17)=1 (hourly time increment.  limits to 256 hours)
C	ID(17)=10 (3 hour increment.  limits to 768 hours)
C	
C	below options are listed, but currently would have problems
C	beyond 999 hours due to filename constraints.  
C
C	ID(17)=11 (6 hour increment.  limits to 1536 hours)
C	ID(17)=12 (12 hour increment.  allows 3072 hours)
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
         ID(17)     = 1
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

	IF (ID(17) .eq. 1) IFACT=1
	IF (ID(17) .eq. 10) IFACT=3
	IF (ID(17) .eq. 11) IFACT=6
	IF (ID(17) .eq. 12) IFACT=12
C
C    ASSUMING ID(18-20), (P1, P2, TIME RANGE INDICATOR) 
C    ARE PASSED IN CORRECTLY IF NOT AN INSTANTANEOUS FIELD
C   
         IF (ID(20).EQ.0) THEN
          ID(18)     = IFHR/IFACT
          ID(19)     = 0
         ENDIF

!tst
	IF (ID(20).EQ.3 .OR. ID(20).EQ.4) THEN
	  ID(18)     = ID(18)/IFACT
          ID(19)     = ID(19)/IFACT
	ENDIF
!endtst

         ID(21)     = 0
         ID(22)     = 0
         ID(23)     = ICENT
         ID(24)     = 0
C
C     
C        SET OUTPUT GRID TYPE.  WE ASSUME KGYTPE HOLDS THE GRIB
C        ID FOR THE OUTPUT GRID.  
C
         KGTYP = KGTYPE
C     
C        SET GRID TYPE ID(5)
C        GENERATING PROGRAM ID(4)
C
         IJOUT      = IMOUT*JMOUT
         ID(4) = IMDLTY
         ID(5) = KGTYP
C
C        ID(6) =0 IF NO GDS SECTION, =1 IF GDS INCLUDED, 
C                 ALWAYS INCLUDE GDS
C
         ID(6) = 1
C     
C        SET DATA TYPE ID(8) AND SURFACE ID(9).
C
C     DON'T SET PARAMETER IF PRECIP TYPE, SINCE THERE ARE
C     4 PARAMETER NUMBERS FOR THE SAME IFLD
C
         IF (ID(8).LT.140.OR.ID(8).GT.143) ID(8) = IQ(IDENT(IFLD))
         IF (ID(9).EQ.0) ID(9) = IS(IDENT(IFLD))
C     
C        SET VALUE OF LEVEL IF ON PRESSURE OR ETA SURFACE.
C        OTHERWISE, WE ASSUME ID(10) AND (11) ARE SET 
C        APPROPRIATELY PRIOR TO ENTERING GRIBIT.
C     
         IF (ID(9).EQ.100)  THEN
            ISVALUE = NINT(SPL(ILVL)*D01)
            ID(10) = 0
            ID(11) = ISVALUE
         ELSEIF (ID(9).EQ.119) THEN
            ISVALUE = NINT(AETA(ILVL)*10000.)
C
C   TKE IS ON THE ETA INTERFACE AT THE BOTTOM OF THE LAYER ILVL
C
            IF (ID(8).EQ.158) ISVALUE = NINT(ETA(ILVL+1)*10000.)
            ID(10) = 0
            ID(11) = ISVALUE
         ELSEIF (ID(9) .EQ. 109) THEN
            ISVALUE = ILVL
            ID(10) = 0
            ID(11) = ISVALUE
         ENDIF
C     
C     END OF GRIB PDS LABEL PREPARATION.
C
      ENDIF

C     
C     SET DECIMAL SCALING (IDECI) FROM LIST IN INCLUDE FILE 
C     RQSTFLD.  A CALL TO GET_BITS WILL COMPUTE THE NUMBER OF
C     BITS NECESSARY TO PACK THE DATA BASED ON THE RANGE OF 
C     THE FIELD.  THE FIELD IS SCALED TO THIS PRECISION AND
C     RETURNED FOR PACKING BY THE GRIB PACKER.
C     
      DO JJ = 1,JMOUT
       DO II = 1,IMOUT
        IBMASK(II,JJ)=IBMAP(II,JJ)
       ENDDO
      ENDDO
      IBM = 0
      IBITM = 0
      SGDG  = DEC(IFLD)
!$omp  parallel do
      DO J=1,JMOUT
      DO I=1,IMOUT
        GRIDOT(I,J)=GRID(I,J)
      ENDDO
      ENDDO
C
      DO J=1,JMOUT
      DO I=1,IMOUT
        IBITM=IBITM+IBMASK(I,J)
      ENDDO
      ENDDO
C
C        ID(7) =0 IF NO BMS SECTION, =1 IF BMS INCLUDED
C
      IF (IBITM.EQ.IJOUT) THEN
        ID(7) = 0
        IBM = 0
      ELSE
        ID(7) = 1
        IBM = 1
      ENDIF
      CALL GET_BITS(IBM,SGDG,IJOUT,IBMASK,GRID,
     &                IDECI,GRIDOT,GMIN,GMAX,NBIT)
C
C        ID(25) = SCALING POWER OF 10
C
      ID(25) = IDECI
C     
C     GENERATE COMPLETE GRIB1 MESSAGE USING W3FI72.
C        ITYPE  = 0 SPECIFIES REAL DATA TO BE PACKED.
C        IGRD   = DUMMY ARRAY FOR INTEGER DATA.
C        IBITL  = NBIT TELLS W3FI72 TO PACK DATA USING NBIT BITS.
C        IPFLAG = 0 IS PDS INFORMATION IN USER ARRAY ID.
C                 1 IS PDS (GENERATED ABOVE BY W3FP12).
C        ID     = (DUMMY) ARRAY FOR USER DEFINED PDS.
C        IGFLAG = 0 TELLS W3FI72 TO MAKE GDS USING IGRID.
C                 1 IS GDS GENERATED BY USER IN ARRAY IGDS
C        IGRID  = GRIB1 GRID TYPE (TABLE B OF ON388).
C        IGDS   = ARRAY FOR USER DEFINED GDS.
C        ICOMP  = 0 FOR EARTH ORIENTED WINDS,
C                 1 FOR GRID ORIENTED WINDS.
C        IBFLAG = 0 TELLS W3FI72 TO MAKE BIT MAP FROM USER
C                 SUPPLIED DATA.
C        IBMASK = ARRAY CONTAINING USER DEFINED BIT MAP.
C        IBLEN  = LENGTH OF ARRAY IBMASK.
C        IBDSFL = ARRAY CONTAINING TABLE 11 (ON388) FLAG INFORMATION.
C        NPTS   = LENGTH OF ARRAY GRID OR IGRD.  MUST AGREE WITH IBLEN.
C     
C     INTIALIZE VARIABLES.
      ITYPE  = 0
!$omp  parallel do
      DO J=1,JMOUT
      DO I=1,IMOUT
        IGRD(I,J)=0
      ENDDO
      ENDDO
C
      IBITL  = MIN(NBIT,MXBIT)
C
      IPFLAG = 0
C
      IGFLAG = 0
Cwrkst      IGRID  = ID(5)
      IF (IGRID.EQ.26) IGRID=6
Cwrkst      DO 20 K = 1,18
Cwrkst        IGDS(K) = 0
Cwrkst 20   CONTINUE
      ICOMP  = 1
      IF (INDEX(PROJ,'LOLA').NE.0) ICOMP = 0
      IBFLAG = 0
      IBLEN  = IJOUT
      DO 30 K = 1,9
         IBDSFL(K) = 0
 30   CONTINUE

Cmp     this is where things need to be defined
Cmp
Cmp     want IGRID=255 (user defined type)
Cmp     IGDS needs to have the w3fi71 style GDS (18 elements)
Cmp     also NEED IGFLAG=1
Cmp
Cmp     what to do with bitmap IBFLAG/IBLEN?
        IGFLAG=1
        IGRID=255
Cmp

C
!	write(6,*) 'ID= ', ID
      CALL W3FI72(ITYPE,GRIDOT,IGRD,IBITL,
     X            IPFLAG,ID,PDS,
     X            IGFLAG,IGRID,IGDS,ICOMP,
     X            IBFLAG,IBMASK,IBLEN,
     X            IBDSFL,
     X            NPTS,KBUF,ITOT,IER)
C     
C     EXPLICITLY SET BYTE 12 OF KBUF (BYTE 4 OF THE PDS)
C     TO 2.  THIS WILL REFER ALL QUANTITIES TO PARAMETER
C     TABLE VERSION 2 OF WHICH TABLE VERSION 1 IS A SUBSET.
C     THIS IS NEEDED BECAUSE THE W3 ROUTINES HARDWIRE THIS
C     VALUE TO 1 YET SOME OF THE OUTPUT VARIABLES ARE ONLY 
C     DEFINED IN VERSION 2 OF THE PARAMETER TABLE.
C
      KBUF(12)=CHAR(2)
C
      IF (IER.NE.0) THEN
         WRITE(STDOUT,1040) IER,FIELD(IFLD)
 1040    FORMAT('GRIBIT:  ***W3FI72 ERROR IER=',I1,
     X        ' FOR ',A20)
         WRITE(STDOUT,*)'GRIBIT:  DID NOT POST THIS FIELD'
         RETURN
      ENDIF
C     
C     ON FIRST ENTRY MAKE OUTPUT DIRECTORY.  SET SWITCH (RITEHD)
C     TO FALSE FOR SUBSEQUENT ENTRIES.
      IF ( ((IOUTYP.EQ.3).AND.RITEHD) .OR.
     X     ((IOUTYP.EQ.5).AND.RITEHD) .OR.
     X     ((IOUTYP.EQ.4).AND.RITE2 ) ) THEN
C
C        PUT FORECAST HOUR INTO DIR PREFIX FOR GRIB FILE.
C         IHR = NTSD/TSPH + 0.5
          IHR = ITAG
C     
C        GET FULL PATH FOR OUTPUT FILE FROM ENVIRONMENT VARIABLE
C        COMSP WHICH IS SET IN THE SCRIPT RUNNING THE MODEL.
C     
C        CONSTRUCT FULL PATH-FILENAME FOR OUTPUT FILE
         ENVAR = ' '
         RESTHR = ' '
         CALL GETENV('COMSP',ENVAR)
         CALL GETENV('tmmark',RESTHR)
         KDAT = INDEX(DATSET,' ') -1
         IF (KDAT.LE.0) KDAT = LEN(DATSET)
         KENV = INDEX(ENVAR,' ') -1
         IF (KENV.LE.0) KENV = LEN(ENVAR)
         KTHR = INDEX(RESTHR,' ') -1
         IF (KTHR.LE.0) KTHR = LEN(RESTHR)
       IF (IOUTYP.EQ.5) THEN
         WRITE(DESCR2,1010) IHR
 1010    FORMAT('f',I2.2)
         IF (ENVAR(1:4).EQ.BLANK.AND.RESTHR(1:4).EQ.BLANK) THEN
          OPATH = DATSET(1:KDAT) // '/' // DESCR2(1:3) // '/'
         ELSEIF (ENVAR(1:4).NE.BLANK.AND.RESTHR(1:4).EQ.BLANK) THEN
          OPATH = ENVAR(1:KENV) // DATSET(1:KDAT) // '/' 
     &              // DESCR2(1:3) // '/'
         ELSEIF (ENVAR(1:4).EQ.BLANK.AND.RESTHR(1:4).NE.BLANK) THEN
          OPATH = DATSET(1:KDAT) // '/' // DESCR2(1:3) // '.' //
     &              RESTHR(1:KTHR) // '/'
         ELSE
          OPATH = ENVAR(1:KENV) // DATSET(1:KDAT) // '/' 
     &              // DESCR2(1:3) // '.' // RESTHR(1:KTHR) // '/'
         ENDIF
C
         WRITE(STDOUT,*)'GRIBIT:  DIRECTORY ',OPATH,
     X        ' CREATED FOR GRIB DATA '
       ELSE
C     
C        CONSTRUCT FULL PATH-FILENAME FOR OUTPUT FILE
         IF (ENVAR(1:4).EQ.BLANK.AND.RESTHR(1:4).EQ.BLANK) THEN
          WRITE(DESCR2,1011) IHR
 1011     FORMAT('.GrbF',I7.7)
          FNAME = DATSET(1:KDAT) // DESCR2
         ELSEIF(ENVAR(1:4).EQ.BLANK.AND.RESTHR(1:4).NE.BLANK) THEN
          WRITE(DESCR2,1012) IHR
          FNAME = DATSET(1:KDAT) // DESCR2(1:2)  //'.'// RESTHR
         ELSE
          WRITE(DESCR2,1012) IHR
Cmp 1012     FORMAT(I2.2)
 1012     FORMAT(I7.7)
          FNAME = ENVAR(1:KENV) // DATSET(1:KDAT) // DESCR2(1:6)
     &              //'.'// RESTHR
         ENDIF
C
C        ASSIGN AND OPEN UNIT FOR GRIB DATA FILE.
         CLOSE(LUNOUT+1)
C        CALL ASNUNIT(LUNOUT+1,'-s unblocked',IER)
         CALL BAOPEN(LUNOUT+1,FNAME,IER)
         IF (IER.NE.0) WRITE(STDOUT,*)
     X        'GRIBIT:  BAOPEN ERROR FOR GRIB DATA ',
     X        'FILE.  IER=',IER
         WRITE(STDOUT,*)'GRIBIT:  OPENED ',LUNOUT+1,
     X        ' FOR GRIB DATA ',FNAME
       ENDIF
C     
C        SET OPEN-UNIT FLAGS TO FALSE.
         RITEHD = .FALSE.
         RITE2  = .FALSE.
      ENDIF
C     
C     WRITE GRIB1 MESSAGE TO OUTPUT FILE.
      CALL WRYTE(LUNOUT+1,ITOT,KBUF)
C     
C     WRITE DIAGNOSTIC MESSAGE.
C        ID(8)  = INDICATOR OF PARAMETER AND UNITS (TABLE 2)
C        ID(9)  = INDICATOR OF TYPE OF LEVEL       (TABLE 3)
C        ID(10) = VALUE 1 OF LEVEL  (0 FOR 1-100,102,103,105,107
C              111,160   LEVEL IS IN ID WORD 11)
C        ID(11) = VALUE 2 OF LEVEL
      WRITE(STDOUT,1050) ID(8),FIELD(IFLD),ID(9),ID(10),ID(11)
 1050 FORMAT('GRIBIT:  ',I3,1X,A20,1X,I3,1X,I5,1X,I5)
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE CALHEL(UST,VST,HELI)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALHEL       COMPUTES STORM RELATIVE HELICITY
C   PRGRMMR: BALDWIN         ORG: W/NP2      DATE: 94-08-22       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES ESTIMATED STORM MOTION AND
C     STORM-RELATIVE ENVIRONMENTAL HELICITY.  
C     (DAVIES-JONES ET AL 1990) THE ALGORITHM PROCEEDS AS 
C     FOLLOWS.
C     
C     AT EACH WIND POINT MOVE UP VERTICALLY FROM THE LMV(K)-TH
C     ETA LAYER.  USE ALL LAYER WINDS WHOSE PRESSURES ARE 
C     FOUND BETWEEN 150 MB ABOVE THE SURFACE AND 300 MB LEVEL
C     TO COMPUTE A MASS WEIGHTED MEAN WIND.  THIS IS USED 
C     TO ESTIMATE THE STORM MOTION.  STORM MOTION IS SPECIFIED
C     AS 30 DEG TO THE RIGHT OF THE MEAN WIND AND 75% OF
C     THE MEAN WIND SPEED IF THE MEAN WIND IS LESS THAN 15 M/S.
C     IF THE MEAN WIND IS MORE THAN 15 M/S, THE STORM MOTION
C     IS 20 DEG TO THE RIGHT OF THE MEAN WIND AND 80% OF
C     ITS SPEED.  THIS STORM MOTION IS USED TO COMPUTE THE
C     STORM-RELATIVE HELICITY.  MOVING UP VERTICALLY FROM
C     THE LMV(K)-TH LAYER TO THE HIGHEST LAYER BELOW 3 KM
C     ABOVE GROUND, SUM UP THE FOLLOWING:
C        HELI = (V-VMEAN) * DU/DZ - (U-UMEAN) * DV/DZ
C     
C     
C PROGRAM HISTORY LOG:
C   94-08-22  MICHAEL BALDWIN
C   97-03-27  MICHAEL BALDWIN - SPEED UP CODE
C   98-06-15  T BLACK         - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO    - MPI VERSION               
C     
C USAGE:    CALHEL(UST,VST,HELI)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     UST      - ESTIMATED U COMPONENT (M/S) OF STORM MOTION.
C     VST      - ESTIMATED V COMPONENT (M/S) OF STORM MOTION.
C     HELI     - STORM-RELATIVE HELICITY (M**2/S**2)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C
C     LIBRARY:
C       COMMON   - VRBLS
C                  LOOPS
C                  PHYS 
C                  EXTRA
C                  MASKS
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE PARAMETERS.
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
      INCLUDE "parm.tbl"
      PARAMETER (PI=3.141592654)
      PARAMETER (P150=15000.0,P300=30000.0,S15=15.0)
      PARAMETER (D3000=3000.0,PI6=0.5235987756,PI9=0.34906585)
C     
C     DECLARE VARIABLES
C     
      REAL UST(IM,JM),VST(IM,JM),HELI(IM,JM),ETOT(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "OPTIONS.comm"
C      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C****************************************************************
C     START CALHEL HERE
C     
C     INITIALIZE ARRAYS.
C     
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
         UST(I,J)    = 0.0
         VST(I,J)    = 0.0
         HELI(I,J)   = 0.0
         ETOT(I,J)   = 0.0
      ENDDO
      ENDDO
C     
C     LOOP OVER HORIZONTAL GRID.
C 
      CALL EXCH(RES)
      CALL EXCH(PD)
      DO L = 1,LP1
        CALL EXCH(ZINT(1,1,L))
      END DO
C
!$omp  parallel do
!$omp& private(htsfc,ie,iw,pdslvk,pkl,psfck)
      DO L = 1,LM
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IE=I+IVE(J)
          IW=I+IVW(J)
          PDSLVK=(PD(IW,J)*RES(IW,J)+PD(IE,J)*RES(IE,J)+
     1           PD(I,J+1)*RES(I,J+1)+PD(I,J-1)*RES(I,J-1))*0.25
          PSFCK=AETA(LMV(I,J))*PDSLVK+PT
c         HTSFC=0.25*(ZINT(IW,J,LMV(I,J)+1)+ZINT(IE,J,LMV(I,J)+1)+
c    1                ZINT(I,J+1,LMV(I,J)+1)+ZINT(I,J-1,LMV(I,J)+1))
C     
C     COMPUTE MASS WEIGHTED MEAN WIND FROM 150 MB ABOVE
C      SURFACE TO 300 MB LAYER
C
         PKL = AETA(L)*PDSLVK+PT
         IF (PKL.LT.PSFCK-P150.AND.PKL.GT.P300) THEN
               UST(I,J) = UST(I,J) + U(I,J,L) * DETA(L)
               VST(I,J) = VST(I,J) + V(I,J,L) * DETA(L)
               ETOT(I,J) = ETOT(I,J) + DETA(L)
         ENDIF
        ENDDO
        ENDDO
      ENDDO


!$omp  parallel do
!$omp& private(rot,stspd,umean,unew,vmean,vnew)
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
         IF (ETOT(I,J).GT.0.0) THEN
           UMEAN = UST(I,J) / ETOT(I,J)
           VMEAN = VST(I,J) / ETOT(I,J)
           STSPD = SQRT(UMEAN*UMEAN+VMEAN*VMEAN)
C
C      COMPUTE STORM MOTION VECTOR
C
           IF (STSPD.LE.S15) THEN
            ROT=PI6
            UNEW=UMEAN*COS(ROT)+VMEAN*SIN(ROT)
            VNEW=VMEAN*COS(ROT)-UMEAN*SIN(ROT)
            UMEAN=0.75*UNEW
            VMEAN=0.75*VNEW
           ELSE
            ROT=PI9
            UNEW=UMEAN*COS(ROT)+VMEAN*SIN(ROT)
            VNEW=VMEAN*COS(ROT)-UMEAN*SIN(ROT)
            UMEAN=0.80*UNEW
            VMEAN=0.80*VNEW
           ENDIF
            UST(I,J)=UMEAN
            VST(I,J)=VMEAN
         ELSE
            UST(I,J)=0.0
            VST(I,J)=0.0
         ENDIF
      ENDDO
      ENDDO
C
C
C       COMPUTE STORM-RELATIVE HELICITY
C
!$omp  parallel do
!$omp& private(du1,du2,dv1,dv2,dz,dz1,dz2,dzabv,ie,iw,z1,z2,z3)
      DO L = 2,LM-1
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IW=I+IVW(J)
          IE=I+IVE(J)
          Z2=0.125*(ZINT(IW,J,L)+ZINT(IW,J,L+1)+
     &              ZINT(IE,J,L)+ZINT(IE,J,L+1)+
     &              ZINT(I,J+1,L)+ZINT(I,J+1,L+1)+
     &              ZINT(I,J-1,L)+ZINT(I,J-1,L+1))
          HTSFC=0.25*(ZINT(IW,J,LMV(I,J)+1)+ZINT(IE,J,LMV(I,J)+1)+
     1                ZINT(I,J+1,LMV(I,J)+1)+ZINT(I,J-1,LMV(I,J)+1))

          DZABV=Z2-HTSFC
C
          IF(DZABV.LT.D3000.AND.L.LE.LMV(I,J))THEN
            Z1=0.125*(ZINT(IW,J,L+1)+ZINT(IW,J,L+2)+
     &                ZINT(IE,J,L+1)+ZINT(IE,J,L+2)+
     &                ZINT(I,J+1,L+1)+ZINT(I,J+1,L+2)+
     &                ZINT(I,J-1,L+1)+ZINT(I,J-1,L+2))
            Z3=0.125*(ZINT(IW,J,L-1)+ZINT(IW,J,L)+
     &                ZINT(IE,J,L-1)+ZINT(IE,J,L)+
     &                ZINT(I,J+1,L-1)+ZINT(I,J+1,L)+
     &                ZINT(I,J-1,L-1)+ZINT(I,J-1,L))
            DZ=0.25*((ZINT(IW,J,L)+ZINT(IE,J,L)+
     &                ZINT(I,J-1,L)+ZINT(I,J+1,L))-
     &               (ZINT(IW,J,L+1)+ZINT(IE,J,L+1)+
     &                ZINT(I,J-1,L+1)+ZINT(I,J+1,L+1)))
            DZ1=Z1-Z2
            DZ2=Z2-Z3
            DU1=U(I,J,L+1)-U(I,J,L)
            DU2=U(I,J,L)-U(I,J,L-1)
            DV1=V(I,J,L+1)-V(I,J,L)
            DV2=V(I,J,L)-V(I,J,L-1)
            HELI(I,J)=((V(I,J,L)-VST(I,J))*
     1                (DZ2*(DU1/DZ1)+DZ1*(DU2/DZ2))
     2                -(U(I,J,L)-UST(I,J))*
     3                (DZ2*(DV1/DZ1)+DZ1*(DV2/DZ2)))
     4                *DZ/(DZ1+DZ2)+HELI(I,J) 
           ENDIF
        ENDDO
        ENDDO
      ENDDO
C
C
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE SIG2P(IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    SIG2P       VERT INTRP OF SIGMA TO PRESSURE
C   PRGRMMR: BLACK           ORG: W/NP22     DATE: 99-09-23       
C     
C ABSTRACT:
C     FOR MOST APPLICATIONS THIS ROUTINE IS THE WORKHORSE
C     OF THE POST PROCESSOR.  IN A NUTSHELL IT INTERPOLATES
C     DATA FROM SIGMA TO PRESSURE SURFACES.  IT ORIGINATED
C     FROM THE VERTICAL INTERPOLATION CODE IN THE OLD ETA
C     POST PROCESSOR SUBROUTINE OUTMAP AND IS A REVISION
C     OF SUBROUTINE ETA2P.
C   .     
C     
C PROGRAM HISTORY LOG:
C   99-09-23  T BLACK       - REWRITTEN FROM ETA2P
C     
C USAGE:    CALL SIG2P(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID
C
C   OUTPUT ARGUMENT LIST: 
C     NONE       
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       SLPSIG   - COMPUTE MESINGER SEA LEVEL PRESSURE
C       SCLFLD   - SCALE ARRAY ELEMENTS BY CONSTANT.
C       E2OUT    - E-GRID TO OUTPUT GRID INTERPOLATION/SMOOTHING.
C       OUTPUT   - POST ARRAY TO OUTPUT FILE.
C       CALPOT2  - COMPUTE POTENTIAL TEMPERATURE.
C       CALRH2   - COMPUTE RELATIVE HUMIDITY.
C       CALDWP2  - COMPUTE DEWPOINT TEMPERATURE.
C       BOUND    - BOUND ARRAY ELEMENTS BETWEEN LOWER AND UPPER LIMITS.
C       CALMCVG  - COMPUTE MOISTURE CONVERGENCE.
C       CALVOR   - COMPUTE ABSOLUTE VORTICITY.
C       CALSTRM  - COMPUTE GEOSTROPHIC STREAMFUNCTION.
C
C     LIBRARY:
C       COMMON   - OMGAOT
C                  LOOPS
C                  MASKS
C                  MAPOT
C                  VRBLS
C                  PVRBLS
C                  RQSTFLD
C                  EXTRA
C                  CLDWTR
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : IBM SP
C$$$  
C
C
C     
C     INCLUDE ETA MODEL DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     GAMMA AND RGAMOG ARE USED IN THE EXTRAPOLATION OF VIRTUAL
C     TEMPERATURES BEYOND THE UPPER OF LOWER LIMITS OF ETA DATA.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
C
      PARAMETER (IM_JM=IM*JM,LMP1=LM+1)
      PARAMETER (GAMMA=6.5E-3,RGAMOG=RD*GAMMA/G)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STDRD
      LOGICAL IOOMG,IOALL
      REAL OSL(IM,JM),USL(IM,JM),VSL(IM,JM)
      REAL PRSI(IM,JM),QCSL(IM,JM),Q2SL(IM,JM)
      REAL ICE(IM,JM),IW(IM,JM,LM),IWU,IWL

      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT)
C
      REAL TPRS(IM,JM,LSL),QPRS(IM,JM,LSL),FPRS(IM,JM,LSL)
C
      INTEGER IHOLD(IM_JM),JHOLD(IM_JM)
C
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "E2PFLG.comm"
C
      COMMON/JIMA/NL1X(IM,JM),ALPETUX(IM,JM),ALPET2X(IM,JM)
C
C      DATA SIGFLG/.FALSE./
C     
C******************************************************************************
C
C     START SIG2P. 
C     
C     SET TOTAL NUMBER OF POINTS ON OUTPUT GRID.
C
C---------------------------------------------------------------
C
C     *** PART I ***
C
C     VERTICAL INTERPOLATION OF EVERYTHING ELSE.  EXECUTE ONLY
C     IF THERE'S SOMETHING WE WANT.
C
      IF((IGET(012).GT.0).OR.(IGET(013).GT.0).OR.
     X   (IGET(014).GT.0).OR.(IGET(015).GT.0).OR.
     X   (IGET(016).GT.0).OR.(IGET(017).GT.0).OR.
     X   (IGET(018).GT.0).OR.(IGET(019).GT.0).OR.
     X   (IGET(020).GT.0).OR.(IGET(030).GT.0).OR.
     X   (IGET(021).GT.0).OR.(IGET(022).GT.0).OR.
     X   (IGET(153).GT.0).OR.(IGET(166).GT.0))THEN
C
C  SET UP UTIM FOR THIS TIME STEP
C
        UTIM=1.
        CLIMIT=1.E-20
C
        do75: DO L=1,LM
        IF(L.EQ.1)THEN
!$omp  parallel do
          DO J=JSTA,JEND
          DO I=1,IM
            IW(I,J,L)=0.
          ENDDO
          ENDDO
          CYCLE  do75
        ENDIF
C
!$omp  parallel do
!$omp& private(cwmkl,fiq,hh,lml,pp,qi,qkl,qw,tkl,tmt0,tmt15,u00kl)
        doout70: DO J=JSTA,JEND
        doin70: DO I=1,IM
        LML=LM-LMH(I,J)
        HH=HTM(I,J,L)*HBM2(I,J)
        TKL=T(I,J,L)
        QKL=Q(I,J,L)
        CWMKL=CWM(I,J,L)
        TMT0=(TKL-273.16)*HH
        TMT15=AMIN1(TMT0,-15.)*HH    
        PP=PDSL(I,J)*AETA(L)+PT
        QW=HH*PQ0/PP*EXP(HH*A2*(TKL-A3)/(TKL-A4))
        QI=QW*(1.+0.01*AMIN1(TMT0,0.))     
        U00KL=U00(I,J)+UL(L+LML)*(0.95-U00(I,J))*UTIM
C
        IF(TMT0.LT.-15.0)THEN
          FIQ=QKL-U00KL*QI
          IF(FIQ.GT.0..OR.CWMKL.GT.CLIMIT) THEN
            IW(I,J,L)=1.
          ELSE
            IW(I,J,L)=0.
          ENDIF
        ENDIF
C
        IF(TMT0.GE.0.0)IW(I,J,L)=0.
        IF(TMT0.LT.0.0.AND.TMT0.GE.-15.0)THEN
          IW(I,J,L)=0.
          IF(IW(I,J,L-1).EQ.1..AND.CWMKL.GT.CLIMIT)IW(I,J,L)=1.
        ENDIF
C
        END DO doin70
        END DO doout70
        END DO do75
C
C---------------------------------------------------------------------
C***
C***  BECAUSE SIGMA LAYERS DO NOT GO UNDERGROUND, SUBROUTINE BLOSFC2
C***  COULD DO NO WORK TO FILL IN VALUES BELOW THE GROUND SURFACE.
C***  VALUES OF T ON THE OUTPUT PRESSURE LEVELS ABOVE GROUND MUST BE
C***  KNOWN BEFORE THEY CAN BE FILLED IN BELOW GROUND IN THE ROUTINE 
C***  WHICH COMPUTES THE MESINGER SEA LEVEL PRESSURE.  THEREFORE DO ALL
C***  INTERPOLATION ABOVE GROUND NOW.
C***
C
        do310: DO LP=1,LSL
        NHOLD=0
C
        doout125: DO J=JSTA,JEND
        doin125: DO I=1,IM
C
        TSL(I,J)=-1.E6
        QSL(I,J)=-1.E6
        FSL(I,J)=-1.E6
C
C***  LOCATE VERTICAL INDEX OF MODEL INTERFACE JUST BELOW
C***  THE PRESSURE LEVEL TO WHICH WE ARE INTERPOLATING.
C
        do115: DO L=2,LMP1
c       IF((ALPINT(I,J,L)).LT.ALSL(LP))GO TO 115
        IF(ALPINT(I,J,L).GE.ALSL(LP))THEN
          NL1X(I,J)=L
          NHOLD=NHOLD+1
          IHOLD(NHOLD)=I
          JHOLD(NHOLD)=J
          CYCLE doin125
        ELSEIF(ALPINT(I,J,LMP1).LT.ALSL(LP))THEN
          NL1X(I,J)=LMP1
          NHOLD=NHOLD+1
          IHOLD(NHOLD)=I
          JHOLD(NHOLD)=J
          CYCLE doin125
        ENDIF
        END DO do115
C
        END DO doin125
        END DO doout125
        IF(NHOLD.EQ.0)CYCLE do310
C
        TRF=2.*ALSL(LP)
C***
C***  NL1X WAS SET BASED ON INTERFACE PRESSURE VALUES.  HOWEVER, WE 
C***  ARE READY TO INTERPOLATE VALUES FROM MIDLAYER LOCATIONS SO 
C***  ADJUST NL1X UP ONE LAYER IF NEEDED SO THAT THE INDEX OF THE
C***  MIDLAYER LOCATION IS IMMEDIATELY BELOW THE PRESSURE LEVEL
C***  TO WHICH INTERPOLATION IS BEING DONE.
C***
!$omp  parallel do
!$omp& private(ahf,ahfo,ahfq,ahfq2,ahfqc,ahfqi,ai,b,bi,bom,
!$omp&         bq,bq2,bqc,bqc_2,bqi_2,bqi,fac,gmiw,gmiw_2,iwl,iwu,
!$omp&         lmp1,pl,pnl1,pu,q2a,q2b,qabv,qi,qint,ql,
!$omp&         qsat,qu,qw,rhu,tabv,tblo,tl,tmt0,tmt15,tu,
!$omp&         tvrabv,tvrblo,tvrl,tvru,zl,zu)
        do220: DO NN=1,NHOLD
        I=IHOLD(NN)
        J=JHOLD(NN)
        DIFU=ALSL(LP)-ALPINT(I,J,NL1X(I,J)-1)
        DIFL=ALPINT(I,J,NL1X(I,J))-ALSL(LP)
        IF(DIFU.LT.DIFL)NL1X(I,J)=NL1X(I,J)-1
        PNL1=PINT(I,J,NL1X(I,J))
C---------------------------------------------------------------------
C***  VERTICAL INTERPOLATION OF GEOPOTENTIAL, TEMPERATURE, SPECIFIC
C***  HUMIDITY, CLOUD WATER/ICE, AND TKE.
C---------------------------------------------------------------------
C
C---------------------------------------------------------------------
C***  EXTRAPOLATE ABOVE THE TOPMOST MIDLAYER OF THE MODEL
C---------------------------------------------------------------------
C
        IF(NL1X(I,J).EQ.1)THEN
          PU=PINT(I,J,2)
          ZU=ZINT(I,J,2)
          TU=0.5*(T(I,J,1)+T(I,J,2))
          QU=0.5*(Q(I,J,1)+Q(I,J,2))
C
          IWU=0.5*(IW(I,J,1)+IW(I,J,2))
          TMT0=TU-273.16
          TMT15=AMIN1(TMT0,-15.)
          AI=0.008855
          BI=1.
          IF(TMT0.LT.-20.)THEN
            AI=0.007225
            BI=0.9674
          ENDIF
          QW=PQ0/PU
     1      *EXP(A2*(TU-A3)/(TU-A4))
          QI=QW*(BI+AI*AMIN1(TMT0,0.))
          QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
          IF(TMT0.LT.-15.)THEN
            QSAT=QI
          ELSEIF(TMT0.GE.0.)THEN
            QSAT=QINT
          ELSE
            IF(IWU.GT.0.)THEN
              QSAT=QI
            ELSE
              QSAT=QINT
            ENDIF
          ENDIF
C
C***  USE RH FOR LIQUID WATER NO MATTER WHAT.
C***  DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
          QSAT=QW
C
          RHU=QU/QSAT
C
          IF(RHU.GT.1.)THEN
            RHU=1.
            QU =RHU*QSAT
          ENDIF
C
          IF(RHU.LT.0.01)THEN
            RHU=0.01
            QU =RHU*QSAT
          ENDIF
C
          TVRU=TU*(1.+0.608*QU)
          TVRABV=TVRU*(SPL(LP)/PU)**RGAMOG
          TABV=TVRABV/(1.+0.608*QU)
C     
          TMT0=TABV-273.16
          TMT15=AMIN1(TMT0,-15.)
          AI=0.008855
          BI=1.
          IF(TMT0.LT.-20.)THEN
            AI=0.007225
            BI=0.9674
          ENDIF
          QW=PQ0/SPL(LP)
     1      *EXP(A2*(TABV-A3)/(TABV-A4))
          QI=QW*(BI+AI*AMIN1(TMT0,0.))
          QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
          IF(TMT0.LT.-15.)THEN
            QSAT=QI
          ELSEIF(TMT0.GE.0.)THEN
            QSAT=QINT
          ELSE
            IF(IWU.GT.0.)THEN
              QSAT=QI
            ELSE
              QSAT=QINT
            ENDIF
          ENDIF
C
C***  USE RH FOR LIQUID WATER NO MATTER WHAT.
C***  DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
          QSAT=QW
C
          QABV =RHU*QSAT
          QABV =AMAX1(1.E-12,QABV)
          B    =TABV
          BQ   =QABV
          BOM  =OMGA(I,J,1)
          GMIW =IW(I,J,1) 
          BQC  =(1.-GMIW)*CWM(I,J,1)
          BQI  =GMIW*CWM(I,J,1)
          Q2A  =0.5*(Q2(I,J,1)+Q2(I,J,2))
          BQ2  =Q2A
          AHF  =0.
          AHFQ =0.
          AHFO =0.
          AHFQC=0.
          AHFQI=0.
          AHFQ2=0.
          FAC  =0.
C
        ELSEIF(NL1X(I,J).EQ.LMP1)THEN 
C---------------------------------------------------------------------
C***  EXTRAPOLATE BELOW LOWEST MODEL MIDLAYER (BUT STILL ABOVE GROUND)
C---------------------------------------------------------------------
C
          PL=PINT(I,J,LM-1)
          ZL=ZINT(I,J,LM-1)
          TL=0.5*(T(I,J,LM-2)+T(I,J,LM-1))
          QL=0.5*(Q(I,J,LM-2)+Q(I,J,LM-1))
C     
          IWL=0.5*(IW(I,J,LM-2)+IW(I,J,LM-1))

          TMT0=TL-273.16
          TMT15=AMIN1(TMT0,-15.)
          AI=0.008855
          BI=1.
          IF(TMT0.LT.-20.)THEN
            AI=0.007225
            BI=0.9674
          ENDIF
          QW=PQ0/PL
     1      *EXP(A2*(TL-A3)/(TL-A4))
          QI=QW*(BI+AI*AMIN1(TMT0,0.))
          QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
          IF(TMT0.LT.-15.)THEN
            QSAT=QI
          ELSEIF(TMT0.GE.0.)THEN
            QSAT=QINT
          ELSE
            IF(IWL.GT.0.)THEN
              QSAT=QI
            ELSE
              QSAT=QINT
            ENDIF
          ENDIF
C
C***  USE RH FOR LIQUID WATER NO MATTER WHAT.
C***  DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
          QSAT=QW
C
          RHL=QL/QSAT
C
          IF(RHL.GT.1.)THEN
            RHL=1.
            QL =RHL*QSAT
          ENDIF
C
          IF(RHL.LT.0.01)THEN
            RHL=0.01
            QL =RHL*QSAT
          ENDIF
C
          TVRL  =TL*(1.+0.608*QL)
          TVRBLO=TVRL*(SPL(LP)/PL)**RGAMOG
          TBLO  =TVRBLO/(1.+0.608*QL)
C     
          TMT0=TBLO-273.16
          TMT15=AMIN1(TMT0,-15.)
          AI=0.008855
          BI=1.
          IF(TMT0.LT.-20.)THEN
            AI=0.007225
            BI=0.9674
          ENDIF
          QW=PQ0/SPL(LP)
     1      *EXP(A2*(TBLO-A3)/(TBLO-A4))
          QI=QW*(BI+AI*AMIN1(TMT0,0.))
          QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
          IF(TMT0.LT.-15.)THEN
            QSAT=QI
          ELSEIF(TMT0.GE.0.)THEN
            QSAT=QINT
          ELSE
            IF(IWL.GT.0.) THEN
              QSAT=QI
            ELSE
              QSAT=QINT
            ENDIF
          ENDIF
C
C***  USE RH FOR LIQUID WATER NO MATTER WHAT.
C***  DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
          QSAT=QW
C
          QBLO =RHL*QSAT
          QBLO =AMAX1(1.E-12,QBLO)
          B    =TBLO
          BQ   =QBLO
          BOM  =OMGA(I,J,LM)
          GMIW =IW(I,J,LMH(I,J))
          BQC  =(1.-GMIW)*CWM(I,J,LMH(I,J))
          BQI  =GMIW*CWM(I,J,LMH(I,J)) 
          Q2A  =0.5*(Q2(I,J,LMH(I,J)-1)+Q2(I,J,LMH(I,J)))
          BQ2  =Q2A
          AHF  =0.
          AHFQ =0.
          AHFO =0.
          AHFQC=0.
          AHFQI=0.
          AHFQ2=0.
          FAC  =0.
C
        ELSE
C---------------------------------------------------------------------
C***  INTERPOLATION BETWEEN NORMAL LOWER AND UPPER BOUNDS
C---------------------------------------------------------------------
C
          B     =T(I,J,NL1X(I,J))
          BQ    =Q(I,J,NL1X(I,J))
          BOM   =OMGA(I,J,NL1X(I,J))
          GMIW  =IW(I,J,NL1X(I,J))
          BQC   =(1.-GMIW)*CWM(I,J,NL1X(I,J))
          BQI   =GMIW*CWM(I,J,NL1X(I,J)) 
          GMIW_2=IW(I,J,NL1X(I,J)-1)
          BQC_2 =(1.-GMIW)*CWM(I,J,NL1X(I,J)-1)
          BQI_2 =GMIW*CWM(I,J,NL1X(I,J)-1)
          Q2B   =0.5*(Q2(I,J,NL1X(I,J)-1)+Q2(I,J,NL1X(I,J)))
C
          IF(NL1X(I,J).GT.2)THEN
            Q2A=0.5*(Q2(I,J,NL1X(I,J)-2)+Q2(I,J,NL1X(I,J)-1))
          ELSE
            Q2A=Q2B
          ENDIF
C
          BQ2=Q2B*HTM(I,J,NL1X(I,J))
          FAC  =2.*ALOG(PT+PDSL(I,J)*AETA(NL1X(I,J)))
          AHF  =(B-T(I,J,NL1X(I,J)-1))/
     1          (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
          AHFQ =(BQ-Q(I,J,NL1X(I,J)-1))/
     1          (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
          AHFO =(BOM-OMGA(I,J,NL1X(I,J)-1))/
     1          (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
          AHFQC=(BQC-BQC_2)/
     1          (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
          AHFQI=(BQI-BQI_2)/
     1          (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
          AHFQ2=(BQ2-Q2A*HTM(I,J,NL1X(I,J)-1))/
     1          (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
        ENDIF
C
        TSL(I,J)=B+AHF*(TRF-FAC)
        QSL(I,J)=BQ+AHFQ*(TRF-FAC)
        QSL(I,J)=AMAX1(QSL(I,J),H1M12)
        OSL(I,J)=BOM+AHFO*(TRF-FAC)
        QCSL(I,J)=BQC+AHFQC*(TRF-FAC)
        QCSL(I,J)=AMAX1(QCSL(I,J),H1M12)
        ICE(I,J)=BQI+AHFQI*(TRF-FAC)
        ICE(I,J)=AMAX1(ICE(I,J),1.E-12)
        Q2SL(I,J)=BQ2+AHFQ2*(TRF-FAC)
        Q2SL(I,J)=AMAX1(Q2SL(I,J),0.)
        FSL(I,J)=(PNL1-SPL(LP))/(SPL(LP)+PNL1)
     1       *((ALSL(LP)+ALPINT(I,J,NL1X(I,J))-FAC)*AHF+B)*R*2.
     2       +ZINT(I,J,NL1X(I,J))*G
        END DO do220
C
c 225   CONTINUE
C---------------------------------------------------------------------
C        LOAD GEOPOTENTIAL AND TEMPERATURE INTO STANDARD LEVEL 
C        ARRAYS FOR THE NEXT PASS.
C---------------------------------------------------------------------
C     
C***     SAVE 500MB TEMPERATURE FOR LIFTED INDEX.
C     
        IF((NINT(SPL(LP)).EQ.50000).AND.
     1    ((IGET(030).GT.0).OR.(IGET(031).GT.0).OR.
     2                         (IGET(075).GT.0)))THEN
!$omp  parallel do private(i,j)
          DO NN=1,NHOLD
            I=IHOLD(NN)
            J=JHOLD(NN)
            T500(I,J)=TSL(I,J)
          ENDDO
        ENDIF
C     
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C***  INTERPOLATE WIND COMPONENTS FROM ETA TO PRESSURE
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C     
        IF((IGET(018).GT.0).OR.(IGET(019).GT.0).OR.
     1     (IGET(021).GT.0).OR.(IGET(085).GT.0))THEN
C
!$omp  parallel do private(i,j)
          DO J=JSTA,JEND
          DO I=1,IM
            USL(I,J)=0.
            VSL(I,J)=0.
          ENDDO
          ENDDO
C
!!$omp  parallel do
!!$omp& private(alpet2,alpetl,alpetu,lmb,petal,petau)
!!$omp& shared (alpet2x,alpetux,nl1x)
          doout280: DO J=JSTA,JEND
          doin1280: DO  I=1,IM
CNOTE 
CNOTE         29 JANUARY 1993, RUSS TREADON.
CNOTE          - AS FOR THE OTHER FIELDS WE INTERPOLATE ONLY
CNOTE            BETWEEN THE FAL AND THE MODEL TOP.  BELOW 
CNOTE            SURFACE VALUES ARE FAL VALUES.
C
          LMVIJ=LMV(I,J)
C
cccccccc  DO 280 LV=2,LMVIJ
          doin2280: DO LV=2,LMVIJ+1
          PETAL=PT+PDVP1(I,J)*ETA(LV)
          PETAU=PT+PDVP1(I,J)*ETA(LV-1)
          ALPETL=ALOG(PETAL)
          ALPETU=ALOG(PETAU)
          ALPET2=SQRT(0.5*(ALPETL*ALPETL+ALPETU*ALPETU))
C     
C***  SEARCH FOR HIGHEST MID-LAYER MODEL SURFACE
C***  THAT IS BELOW THE GIVEN STANDARD PRESSURE LEVEL.
C
          IF(ALSL(LP).LT.ALPET2)THEN
            NL1X(I,J)=LV-1
            ALPETUX(I,J)=ALPETU
            ALPET2X(I,J)=ALPET2
            GO TO 281
          ENDIF
          END DO doin2280
          END DO doin1280
          END DO doout280
C
          NL1X(I,J)=LMVIJ+1
          ALPETUX(I,J)=ALPETU
          ALPET2X(I,J)=ALPET2
  281     CONTINUE
C     
C---------------------------------------------------------------------
C***      BELOW GROUND USE WIND IN LOWEST LAYER
C---------------------------------------------------------------------
C
!$omp  parallel do
!$omp& private(alpet1,alpetl,alpetu,fact,lmvij,petau)
          doout290: DO J=JSTA,JEND
          doin290: DO I=1,IM
          LMVIJ=LMV(I,J)
          IF(NL1X(I,J).GT.LMVIJ)THEN
            USL(I,J)=U(I,J,LMVIJ)
            VSL(I,J)=V(I,J,LMVIJ)
C     
C---------------------------------------------------------------------
C***  IF REQUESTED PRESSURE LEVEL IS NOT BELOW THE LOCAL GROUND
C***  THEN WE HAVE TWO POSSIBILITIES.  IF THE REQUESTED PRESSURE
C***  LEVEL IS BETWEEN THE LOCAL SURFACE PRESSURE AND TOP OF
C***  MODEL PRESSURE, VERTICALLY INTERPOLATE BETWEEN NEAREST
C***  BOUNDING ETA LEVELS TO GET THE WIND COMPONENTS.  IF THE   
C***  REQUESTED PRESSURE LEVEL IS ABOVE THE MODEL TOP, USE
C***  CONSTANT EXTRAPOLATION OF TOP ETA LAYER (L=1) WINDS.
C---------------------------------------------------------------------
C 
          ELSE
            IF(NL1X(I,J).GT.1)THEN
              ALPETL=ALPETUX(I,J)
              PETAU=PT+PDVP1(I,J)*ETA(NL1X(I,J)-1)
              ALPETU=ALOG(PETAU)
              ALPET1=SQRT(0.5*(ALPETL*ALPETL+ALPETU*ALPETU))
              FACT=(ALPET2X(I,J)-ALSL(LP))/(ALPET2X(I,J)-ALPET1)
              USL(I,J)=U(I,J,NL1X(I,J))
     1               +(U(I,J,NL1X(I,J)-1)-U(I,J,NL1X(I,J)))*FACT
              VSL(I,J)=V(I,J,NL1X(I,J))+(V(I,J,NL1X(I,J)-1)
     1                -V(I,J,NL1X(I,J)))*FACT
            ELSE
              USL(I,J)=U(I,J,NL1X(I,J))
              VSL(I,J)=V(I,J,NL1X(I,J))
            ENDIF
C     
C---------------------------------------------------------------------
C***  ALPET2 IS MID-LAYER ETA SURFACE JUST BELOW STANDARD PRESSURE
C***  LEVEL AND ALPET1 IS MID-LAYER ETA SURFACE JUST ABOVE.
C***  NOTE THAT IF THE STANDARD PRESSURE SURFACE IS SUBMERGED, THEN
C***  ALPET2 AND ALPET1 ARE THE LOWEST AND 2ND LOWEST MID-LAYER
C***  ETA SURFACES ABOVE THE TOPOGRAPHY (WITH OLDRD=.TRUE., ZJ).
C---------------------------------------------------------------------
C
          ENDIF
          END DO doin290
          END DO doout290
C
        ENDIF
C
C---------------------------------------------------------------------
C
C***  FILL THE 3-D-IN-PRESSURE ARRAYS FOR THE SLP REDUCTION
C
        DO J=JSTA,JEND
        DO I=1,IM
          TPRS(I,J,LP)=TSL(I,J)
          QPRS(I,J,LP)=QSL(I,J)
          FPRS(I,J,LP)=FSL(I,J)
        ENDDO
        ENDDO
C
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C        *** PART II ***
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C
C        INTERPOLATE/OUTPUT SELECTED FIELDS.
C
C---------------------------------------------------------------------
C     
C***  SPECIFIC HUMIDITY.
C
        IF(IGET(016).GT.0)THEN
          IF(LVLS(LP,IGET(016)).GT.0)THEN
            CALL E2OUT(016,000,QSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            print*,'calling output humidity from sig2p'
            CALL OUTPUT(IOUTYP,IGET(016),LP,GRID1,IMOUT,JMOUT)
            if(lp.eq.1)print*,'sample SH IOUTYP',IOUTYP,IGET(016)
          ENDIF
        ENDIF
C     
C***  OMEGA
C
        IF(IGET(020).GT.0)THEN
          IF(LVLS(LP,IGET(020)).GT.0)THEN
            CALL E2OUT(020,000,OSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            print*,'calling output omeg from sig2p'
            CALL OUTPUT(IOUTYP,IGET(020),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  MOISTURE CONVERGENCE
C
        IF(IGET(085).GT.0)THEN
          IF(LVLS(LP,IGET(085)).GT.0)THEN
            CALL CALMCVG(QSL,USL,VSL,-1,EGRID1)
            CALL E2OUT(085,000,EGRID1,EGRID2,
     1                 GRID1,GRID2,IMOUT,JMOUT)
C
C     CONVERT TO DIVERGENCE FOR GRIB UNITS
C
            CALL SCLFLD(GRID1,-1.0,IMOUT,JMOUT)
            ID(1:25)=0
            print*,'calling output moisture from sig2p'
            CALL OUTPUT(IOUTYP,IGET(085),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  U AND/OR V WIND
C
        IF(IGET(018).GT.0.OR.IGET(019).GT.0)THEN
          IF(LVLS(LP,IGET(018)).GT.0.OR.LVLS(LP,IGET(019)).GT.0)THEN
            CALL E2OUT(018,019,USL,VSL,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            IF(IGET(018).GT.0)THEN
              CALL OUTPUT(IOUTYP,IGET(018),LP,GRID1,IMOUT,JMOUT)
            ENDIF
            ID(1:25)=0
            IF(IGET(019).GT.0) 
     1       CALL OUTPUT(IOUTYP,IGET(019),LP,GRID2,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  ABSOLUTE VORTICITY
C
         IF (IGET(021).GT.0) THEN
          IF (LVLS(LP,IGET(021)).GT.0) THEN
            CALL CALVOR(USL,VSL,EGRID1)
            CALL E2OUT(021,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(021),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        GEOSTROPHIC STREAMFUNCTION.
         IF (IGET(086).GT.0) THEN
          IF (LVLS(LP,IGET(086)).GT.0) THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=FSL(I,J)*GI
            ENDDO
            ENDDO
            CALL CALSTRM(EGRID2,EGRID1)
            CALL E2OUT(086,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(086),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C***  TURBULENT KINETIC ENERGY
C
         IF (IGET(022).GT.0) THEN
          IF (LVLS(LP,IGET(022)).GT.0) THEN
            CALL E2OUT(022,000,Q2SL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(022),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C***  TOTAL CLOUD WATER
C
         IF (IGET(153).GT.0) THEN
          IF (LVLS(LP,IGET(153)).GT.0) THEN
            CALL E2OUT(153,000,QCSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(153),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C
C***  TOTAL CLOUD ICE 
C
         IF (IGET(166).GT.0) THEN
          IF (LVLS(LP,IGET(166)).GT.0) THEN
            CALL E2OUT(166,000,ICE,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(166),LP,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF

C     
C***  END OF MAIN VERTICAL LOOP
C     
        END DO do310
C---------------------------------------------------------------------
C***
C***  NOW CALL THE SEA LEVEL PRESSURE ROUTINE WHICH WILL ALSO
C***  GENERATE THE UNDERGROUND TEMPERATURES.  IF IT HAS ALREADY
C***  BEEN CALLED IN A PREVIOUS PASS THROUGH SIG2P, THEN WE
C***  DO NOT NEED TO CALL IT AGAIN.
C***
C
C        IF(.NOT.SIGFLG)THEN
C          CALL SLPSIG(PD,FIS,SM,TPRS,QPRS,FPRS,IM,JM,SPL,LSL
C     1,               DETA,PT,PSLP)
C          SIGFLG=.TRUE.
C        ENDIF
C
C***  OUTPUT SEA LEVEL PRESSURE IF REQUESTED.
C***  FIRST, MESINGER'S SEA LEVEL PRESSURE.
C
cc        IF(IGET(023).GT.0)THEN
cc          CALL E2OUT(023,000,PSLP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
cc          ID(1:25)=0
cc          CALL OUTPUT(IOUTYP,IGET(023),LVLS(1,IGET(023)),
cc     1                GRID1,IMOUT,JMOUT)
cc          print*,'sample PSLP IOUTYP',IOUTYP,IGET(023)
cc     1    ,LVLS(1,IGET(023)) 
cc        ENDIF
C
C***  SECOND, STANDARD NGM SEA LEVEL PRESSURE.
C
        IF(IGET(105).GT.0)THEN
          CALL NGMSLP2
          CALL E2OUT(105,000,SLP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
          ID(1:25)=0
          CALL OUTPUT(IOUTYP,IGET(105),LVLS(1,IGET(105)),
     1        GRID1,IMOUT,JMOUT)
        ENDIF
C
C---------------------------------------------------------------------
C***  OUTPUT THE TEMPERATURES AND QUANTITIES DERIVED FROM IT
C---------------------------------------------------------------------
C
        do400: DO LP=1,LSL
C     
C***  TEMPERATURE
C
        IF(IGET(013).GT.0) THEN
          IF(LVLS(LP,IGET(013)).GT.0)THEN
             CALL E2OUT(013,000,TPRS(1,1,LP),EGRID2,GRID1,GRID2
     1,                 IMOUT,JMOUT)
             ID(1:25)=0
             CALL OUTPUT(IOUTYP,IGET(013),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  POTENTIAL TEMPERATURE.
C
        IF(IGET(014).GT.0)THEN
          IF(LVLS(LP,IGET(014)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(LP)
            ENDDO
            ENDDO
C
            CALL CALPOT2(EGRID2,TPRS(1,1,LP),EGRID1,IM,JM)
            CALL E2OUT(014,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(014),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  RELATIVE HUMIDITY.
C
        IF(IGET(017).GT.0)THEN
          IF(LVLS(LP,IGET(017)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(LP)
            ENDDO
            ENDDO
C
            CALL CALRH2(EGRID2,TPRS(1,1,LP),QPRS(1,1,LP),ICE,EGRID1
     1,                 IM,JM)
            CALL E2OUT(017,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(017),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C***  DEWPOINT TEMPERATURE.
C
        IF(IGET(015).GT.0)THEN
          IF(LVLS(LP,IGET(015)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(LP)
            ENDDO
            ENDDO
C
            CALL CALDWP2(EGRID2,QPRS(1,1,LP),EGRID1,TPRS(1,1,LP))
            CALL E2OUT(015,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(015),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C     
C---------------------------------------------------------------------
C***  CALCULATE 1000MB GEOPOTENTIALS CONSISTENT WITH SLP OBTAINED 
C***  FROM THE MESINGER OR NWS SHUELL SLP REDUCTION.
C---------------------------------------------------------------------
C     
C***  FROM MESINGER SLP
C
        IF(IGET(023).GT.0.AND.LP.EQ.LSM)THEN
          ALPTH=ALOG(1.E5)
!$omp  parallel do private(i,j)
          DO J=JSTA,JEND
          DO I=1,IM
            PSLPIJ=PSLP(I,J)
            ALPSL=ALOG(PSLPIJ)
            PSFC=PD(I,J)+PT
            IEND=IM-MOD(J+1,2)
            IF(ABS(PSLPIJ-PSFC).LT.5.E2.OR.
     1        ((I.EQ.1.OR.I.LE.IEND.OR.J.LE.2.OR.J.GE.JM-1)
     2         .AND.SM(I,J).GT.0.5))THEN
              FPRS(I,J,LP)=R*TPRS(I,J,LSL)*(ALPSL-ALPTH)
            ELSE
              FPRS(I,J,LP)=FIS(I,J)/(ALPSL-ALOG(PD(I,J)+PT))*
     1                              (ALPSL-ALPTH)
            ENDIF
            Z1000(I,J)=FPRS(I,J,LP)*GI
          ENDDO
          ENDDO
C     
C***  FROM NWS SHUELL SLP. NGMSLP2 COMPUTES 1000MB GEOPOTENTIAL.
C
        ELSEIF(IGET(023).LE.0.AND.LP.EQ.LSM)THEN
!$omp  parallel do private(i,j)
          DO J=JSTA,JEND
          DO I=1,IM
            FPRS(I,J,LP)=Z1000(I,J)*G
          ENDDO
          ENDDO
        ENDIF
C
C***  OUTPUT GEOPOTENTIAL (SCALE BY GI)
C
        IF(IGET(012).GT.0)THEN
          IF(LVLS(LP,IGET(012)).GT.0)THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J)=FPRS(I,J,LP)*GI
            ENDDO
            ENDDO
C
            CALL E2OUT(012,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(012),LP,GRID1,IMOUT,JMOUT)
          ENDIF
        ENDIF
C
        END DO do400
C
        IOALL=.TRUE.
C
C***  ENDIF FOR IF TEST SEEING IF WE WANT ANY OTHER VARIABLES
C
      ENDIF
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE MIXLEN
     I (ZINT,T,PDSL,AETA,PT,Q2,HGT,HTM,EL0
     I, LM,LM1,LP1,IM,JM
     O, EL)
C
C     CALCULATES LAYER-AVERAGED BLACKADAR'S MIXING LENGTH, AND PBL TOP
C     AS CPBLT*(ASYMPTOTIC EL); AND THEN EL, ACCOUNT TAKEN OF STABILITY,
C     PBL TOP AND VERTICAL GRID DISTANCE RESTRICTIONS (SEE BELOW)
C
C     SET FROM EXISTING CODES BY L. LOBOCKI, JUNE 5, 1992
C       MODIFIED BY FEDOR MESINGER, OCTOBER 13, NOVEMBER 19
C       MODIFIED BY JIM TUCCILLO FOR MPI IMPLEMENTATION
C
C     INPUT:
C     ------
C
C     ZINT (IM,JM,LP1) - ETA INTERFACES HEIGHT FIELD
C     T    (IM,JM,LM)  - TEMPERATURE
C     APE  (IM,JM,02)  - (P/P0)**-KAPPA IN LAYERS
C     Q2   (IM,JM,LM)  - TURBULENCE KINETIC ENERGY * 2
C     HGT  (IM,JM)     - SURFACE ELEVATION ARRAY
C     HTM  (IM,JM,LM)  - HEIGHT TOPOGRAPHY MASK ARRAY
C     EL0  (IM,JM)     - ARRAY OF ASYMPTOTIC VALUES FOR MIXING LENGTH
C     LM               - ARRAY DIMENSION FOR VERTICAL GRIDS
C     LM1              - ARRAY DIMENSION FOR VERTICAL GRIDS, MINUS ONE
C     LP1              - ARRAY DIMENSION FOR VERTICAL GRIDS, PLUS ONE
C
C     IM,JM            - ARRAY DIMENSIONS FOR HORIZONTAL GRIDS
C
C
C     OUTPUT:
C     -------
C
C     EL   (IM,JM,LM) - FIELD OF RESULTING MASTER LENGTH SCALES
C
C
C     SCRATCH AREAS:
C     --------------
C
C     VKRMZ(IM,JM)
C
C     RELEVANT CONSTANTS:
C     -------------------
C
C     VON KARMAN CONSTANT:
      PARAMETER (VKRM=0.4)
C     CONSTANTS NEEDED FOR THE EL(BL,ST,ZI) SCHEME:
      PARAMETER (FRG=4.*9.8,DRDRFF=0.54,CPBLT=10.,CSH=0.23*0.5
     &, EPSN2=1.E-7,EPSQ2=0.2,CAPA=0.28589641)
C
C     ------------------------------------------------------------------
C
      DIMENSION ZINT(IM,JM,LP1),EL(IM,JM,LM),EL0(IM,JM),PDSL(IM,JM)
     &,         HTM(IM,JM,LM),HGT(IM,JM),Q2(IM,JM,LM)
     &,           T(IM,JM,LM),APE(IM,JM,2),AETA(LM)

       INCLUDE "CTLBLK.comm"
C***********************************************************************
C
!$omp  parallel do
      DO L=1,LM
        DO J=JSTA,JEND
        DO I=1,IM
          EL(I,J,L)=0.
        ENDDO
        ENDDO
      ENDDO
C
C---THE AVERAGE EL SCHEME---------------------------(FM, AUGUST 19 MEMO)
C   FIRST GET EL IN THE LAYERS
C
!$omp  parallel do
!$omp& private(vkrmz,zl)
      DO 260 L=1,LM
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        ZL=0.5*(ZINT(I,J,L)+ZINT(I,J,L+1))
        VKRMZ=(ZL-HGT(I,J))*VKRM
        EL(I,J,L)=EL0(I,J)*VKRMZ/(EL0(I,J)+VKRMZ)
      ENDDO
      ENDDO
  260 CONTINUE
C***
C***  GET NOW THE INTERFACE EL BY TWO-POINT AVERAGING OF LAYER VALUES
C***
      DO 280 L=1,LM1
!$omp  parallel do
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        EL(I,J,L)=0.5*(EL(I,J,L)+EL(I,J,L+1))*HTM(I,J,L+1)
      ENDDO
      ENDDO
 280  CONTINUE
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        EL(I,J,LM)=0.0
      ENDDO
      ENDDO
C---STABILITY, PBL TOP, AND VERTICAL GRID DISTANCE RESTRICTIONS:--------
C   COMPUTE EL STABLE AND
C   * USE THE SMALLER OF EL BLACKADAR, EL STABLE IF WITHIN PBL;
C   * USE THE SMALLEST OF EL STABLE, ELVGD, AND VKRMZ IF ABOVE PBL
C       (ASSUME PBL TOP IS AT CPBLT*EL0(K));
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        APE(I,J,1)=(1.E5/(PDSL(I,J)*AETA(1)+PT))**CAPA
      ENDDO
      ENDDO
C
      DO 380 L=1,LM1
!$omp  parallel do
!$omp& private(elst,elvgd,ensq,q2kl,ziag)
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        APE(I,J,2)=(1.E5/(PDSL(I,J)*AETA(L+1)+PT))**CAPA
        ENSQ=HTM(I,J,L+1)*
     1       FRG*(T(I,J,L)*APE(I,J,1)-T(I,J,L+1)*APE(I,J,2))/
     2       ((T(I,J,L)*APE(I,J,1)+T(I,J,L+1)*APE(I,J,2))*
     3        (ZINT(I,J,L)-ZINT(I,J,L+2))+EPSN2)
        ENSQ=AMAX1(ENSQ,EPSN2)
        Q2KL=AMAX1(EPSQ2,Q2(I,J,L))
        ELST=DRDRFF*SQRT(Q2KL/ENSQ)
CWAS    ELST=DRDRFF*SQRT(Q2(I,J,L)/ENSQ)
        ZIAG=ZINT(I,J,L+1)-HGT(I,J)
C
        IF(ZIAG.LT.CPBLT*EL0(I,J))THEN
          EL(I,J,L)=AMIN1(EL(I,J,L),ELST)
        ELSE
          ELVGD=CSH*(ZINT(I,J,L)-ZINT(I,J,L+2))
          EL(I,J,L)=AMIN1(ELST,ELVGD,VKRM*ZIAG)
        ENDIF
        APE(I,J,1)=APE(I,J,2)
      ENDDO
      ENDDO
  380 CONTINUE
C
      RETURN
      END

      SUBROUTINE EXTRACT(DUM,A)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    EXTRACT    EXTRACT THE DATA WE WILL "OWN"
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     EXTRACT THE DATA WE WILL "OWN". SETUP ONE HALO ROW.
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C
C USAGE:    CALL EXTRACT(DUM,A)
C   INPUT ARGUMENT LIST:
C      DUM - ARRAY TO EXTRACT FROM
C
C   OUTPUT ARGUMENT LIST:
C      A - ARRAY WITH EXTRACTED DATA
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - CTLBLK.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
      include 'parmeta'
      include "CTLBLK.comm"
      include "mpif.h"
      real dum ( im, jm ), a ( im, jm )

      CALL MPI_BCAST(dum,IM*JM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
      do j = jsta_2l, jend_2u
         do i = 1, im
            a ( i, j ) = dum ( i, j )
         end do
      end do
c
      end

C
C  	function written early Dec. 1999 by M. Pyle to support workstation
C	Eta for users with etime but not timef functionality (like certain
Cmp	HPs)  Designed to duplicate timef (elapsed time in milliseconds)
C	
	function timef()
	real et(2)
	real*8 timef
	timef=etime(et)
	timef=timef*1.e3
	end

      FUNCTION TIMEF()
C>--------------------------------------------------------------------------------------------------
C> FUNCTION TIMEF
C>
C> FUNCTION: TIMEF - DESIGNED TO DUPLICATE TIMEF
C> PROGRAMMER: ?????   
C> ORG: ?????
C> DATE: ??-??-??
C> 
C> ABSTRACT:
C> DESIGNED TO DUPLICATE TIMEF
C>
C> PROGRAM HISTORY LOG:
C> 99-12-??  M. PYLE     - ORIGINATOR
C> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
C>                         * F77 TO F90/F95
C>                         * INDENTATION & UNIFORMIZATION CODE
C>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
C>                         * DOCUMENTATION WITH DOXYGEN
C>                         * OPENMP FUNCTIONALITY
C>
C> INPUT ARGUMENT LIST:
C> NONE
C>
C> OUTPUT ARGUMENT LIST:
C> NONE
C>
C> INPUT/OUTPUT ARGUMENT LIST:
C> NONE
C>
C> USE MODULES: 
C>
C> DRIVER     : CHKOUT
C>              EBU
C>              INIT
C>              INITS
C>              PDTEDT
C>              QUILT
C>              TURBL
C>-------------------------------------------------------------------------------------------------- 
C
      REAL   (KIND=4), DIMENSION(2)                                  ::
     & ET
C
      REAL   (KIND=8)                                                ::
     & TIMEF
C
      TIMEF = ETIME(ET)
      TIMEF = TIMEF * 1.E3
C
      END FUNCTION TIMEF

      SUBROUTINE EFILL(EGRID,IM,JM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    EFILL       FILLS MISSING VALUES ON E-GRID
C   PRGRMMR: TREADON         ORG: W/NP2 
C     
C ABSTRACT:  
C     THIS ROUTINE REPLACES ARRAY ELEMENTS ON A E-GRID MARKED
C     BY A MISSING DATA FLAG WITH THE FIELD MEAN.  THE FIELD
C     MEAN IS COMPUTED FROM ALL NON-MISSING ARRAY VALUES.
C     THE MISSING DATA FLAG, SPVAL,  IS SET IN INCLUDE FILE
C     (AND COMMON BLOCK) OPTIONS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-02-03  RUSS TREADON
C   98-06-01  BLACK - CONVERSION FROM 1-D TO 2-D
C     
C USAGE:    CALL EFILL(EGRID,IM,JM)
C   INPUT ARGUMENT LIST:
C     EGRID    - DATA ON STAGGERED E-GRID
C     IM,JM    - DIMENSIONS OF E-GRID
C
C   OUTPUT ARGUMENT LIST: 
C     EGRID    - SAME A INPUT EXCEPT MISSING VALUES
C                ARE REPLACED BY THE FIELD MEAN
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - OPTIONS
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     SET PARAMETER
      PARAMETER (SMALL=1.E-12)
C
C     DECLARE VARIABLES
      REAL EGRID(IM,JM)
      DOUBLE PRECISION SUM
C     
C     INCLUDE COMMON BLOCK WITH SPVAL
      INCLUDE "OPTIONS.comm"
      INCLUDE "IOUNIT.comm"
C     
C**********************************************************************
C     START EFILL HERE
C     
C     SEE IF THERE ARE ANY MISSING VALUES IN THE ARRAY.  IF NOT,
C     RETURN TO CALLING PROGRAM.
C
      CALL MINMAX(EGRID,IM,JM,FMIN,FMAX)
      IF (ABS(FMAX-SPVAL).GT.SMALL) RETURN
C     
C     COMPUTE FIELD MEAN, EXCLUDING MISSING POINTS.
C
      NPTS=0
      SUM =0.
C
      DO J=1,JM
      DO I=1,IM
        IF(ABS(EGRID(I,J)-SPVAL).GE.SMALL)THEN
          NPTS=NPTS+1
          SUM =SUM+EGRID(I,J)
        ENDIF
      ENDDO
      ENDDO
      IF(NPTS.EQ.0)THEN
        WRITE(STDOUT,*)'EFILL:  ALL DATA ON EGRID EQUAL SPVAL'
        RETURN
      ENDIF
      AVG=SUM/NPTS
C     
C     REPLACE MISSING VALUES WITH FIELD MEAN.
C
!$omp  parallel do
      DO J=1,JM
      DO I=1,IM
        IF(ABS(EGRID(I,J)-SPVAL).LT.SMALL)EGRID(I,J)=AVG
      ENDDO
      ENDDO
CX      CALL MINMAX(EGRID,IM,JM,FMIN,FMAX)
CX      WRITE(STDOUT,*)'EFILL:  EGRID MIN,MAX,AVG:  ',FMIN,FMAX,AVG
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE BNDLYR2(PBND,TBND,QBND,RHBND,UBND,VBND,
     X     OMGBND,PWTBND,LVLBND)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    BNDLYR2     COMPUTES CONSTANT MASS MEAN FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-01-29
C     
C ABSTRACT:  THIS ROUTINE COMPUTES CONSTANT MASS (BOUNDARY LAYER)
C   FIELDS.  THE FIELDS ARE A MEAN OVER LAYERS PARAMETER DPBND
C   (PASCALS) THICK.  THERE ARE NBND CONSTANT MASS LAYERS, EACH
C   DPBND THICK STARTING FROM THE SURFACE UP.  COMPUTED BOUNDARY 
C   LAYER FIELDS ARE PRESSURE, TEMPERATURE, SPECIFIC HUMIDITY,
C   RELATIVE HUMIDITY, U AND V WINDS, VERTICAL VELOCITY,
C   AND PRECIPITABLE WATER.  GIVEN THESE FUNDAMENTAL VARIABLES
C   OTHER FIELDS MAY BE COMPUTED.
C
C   ***WARNING*** IF YOU CHANGE PARAMETER NBND IN THIS ROUTINE 
C                 DON'T FOREGET TO CHANGE IT ALSO IN THE CALLING
C                 SUBPROGRAM, MISCLN.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-01-29  RUSS TREADON
C   93-05-07  RUSS TREADON - ADDED DOC BLOCK AND MORE COMMENTS.
C   93-06-19  RUSS TREADON - ADDED LVLBND TO PARAMETER LIST.
C   96-03-07  MIKE BALDWIN - CHANGE PWTR CALC TO INCLUDE CLD WTR
C                            SPEED UP CODE
C   98-06-16  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-18  MIKE BALDWIN - CHANGE QSBND TO RHBND IN CALL,
C                            COMPUTE RH OVER ICE
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   00-01-04  JIM TUCCILLO - MPI VERSION 
C     
C     USAGE:    CALL BNDLYR2(PBND,TBND,QBND,RHBND,UBND,VBND,
C                            OMGBND,PWTBND,LVLBND)
C           
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     PBND     - LAYER MEAN PRESSURE IN NBND BOUNDARY LAYERS (NBL).
C     TBND     - LAYER MEAN TEMPERATURE IN NBL.
C     QBND     - LAYER MEAN SPECIFIC HUMIDITY IN NBL.
C     RHBND    - LAYER MEAN RELATIVE HUM. (QBND/QSBND) IN  NBL.
C     UBND     - LAYER MEAN U WIND COMPONENT IN NBL.
C     VBND     - LAYER MEAN V WIND COMPONENT IN NBL.
C     OMGBND   - LAYER MEAN VERTICAL VELOCITY IN NBL.
C     PWTBND   - LAYER PRECIPITABLE WATER IN NBL.
C     LVLBND   - ETA LAYER AT MIDPOINT OF NBL.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       H2V
C
C     LIBRARY:
C       COMMON   - LOOPS
C                  VRBLS
C                  MAPOT
C                  EXTRA
C                  MASKS
C                  PVRBLS
C                  OMGAOT
C                  OPTIONS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     INCLUDE GLOBAL PARAMETERS.  SET LOCAL PARAMETERS.
C        DPBND:  DEPTH OF BOUNDARY LAYER (IN PASCALS).
C     
      USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C
C
C
      PARAMETER (DPBND=30.E2,RHOWAT=1.E3,rrhowt=1./rhowat)
      PARAMETER (NBND=6)
C     
C     DECLARE VARIABLES.
C     
      INTEGER LVLBND(IM,JM,NBND)
      REAL PBND(IM,JM,NBND),TBND(IM,JM,NBND),QBND(IM,JM,NBND)
      REAL UBND(IM,JM,NBND),VBND(IM,JM,NBND),OMGBND(IM,JM,NBND)
      REAL PWTBND(IM,JM,NBND),PBINT(IM,JM,NBND+1)
      REAL QSBND(IM,JM,NBND),RHBND(IM,JM,NBND),IWL(IM,JM),IWM1
      REAL PSUM(IM,JM,NBND),PVSUM(IM,JM,NBND),NSUM(IM,JM,NBND)
C     
C     INCLUDE COMMONS.
      INCLUDE "LOOPS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "OPTIONS.comm"
C      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C
C*****************************************************************************
C     START BNDLYR HERE
        CLIMIT =1.0E-20
C
C     LOOP OVER HORIZONTAL GRID.  AT EACH MASS POINT COMPUTE
C     PRESSURE AT THE INTERFACE OF EACH BOUNDARY LAYER.
C     
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        PBINT(I,J,1)=PD(I,J)+PT
      ENDDO
      ENDDO
C
      DO LBND=2,NBND+1
!$omp  parallel do
        DO J=JSTA,JEND
        DO I=1,IM
          PBINT(I,J,LBND)=PBINT(I,J,LBND-1)-DPBND
        ENDDO
        ENDDO
      ENDDO
C     
C     LOOP OVER HORIZONTAL.  AT EACH MASS POINT COMPUTE 
C     MASS WEIGHTED LAYER MEAN P, T, Q, U, V, OMEGA, 
C     WAND PRECIPITABLE WATER IN EACH BOUNDARY LAYER FROM THE SURFACE UP.
C     
!$omp  parallel do
!$omp& private(ai,bi,dp,iwl,iwm1,pm,qi,qint,qsat,qw,tmt0,tmt15)
      DO LBND=1,NBND
        DO J=JSTA,JEND
        DO I=1,IM
          PBND(I,J,LBND)   = D00
          TBND(I,J,LBND)   = D00
          QBND(I,J,LBND)   = D00
          QSBND(I,J,LBND)  = D00
          RHBND(I,J,LBND)  = D00
          UBND(I,J,LBND)   = D00
          VBND(I,J,LBND)   = D00
          OMGBND(I,J,LBND) = D00
          LVLBND(I,J,LBND) = 0
          NSUM(I,J,LBND)   = 0
          PSUM(I,J,LBND)   = D00
          PVSUM(I,J,LBND)  = D00
          PWTBND(I,J,LBND) = D00
        ENDDO
        ENDDO
C
        IWL=0.
        DO L=1,LM
          DO J=JSTA,JEND
          DO I=1,IM
C
C   COMPUTE IW
C
           IF (L.LE.LMH(I,J)) THEN
            IWM1=IWL(I,J)
            IF(CWM(I,J,L).GT.CLIMIT) THEN
             IF(T(I,J,L).LT.258.15)THEN
               IWL(I,J)=1.
             ELSEIF(T(I,J,L).GE.273.15)THEN
               IWL(I,J)=0.
             ELSE
               IF(IWM1.EQ.1.0)IWL(I,J)=1.
             ENDIF
            ELSE
             IWL(I,J)=0.
            ENDIF
           ENDIF
C
            PM=D50*(PINT(I,J,L)+PINT(I,J,L+1))
            IF((PBINT(I,J,LBND).GE.PM).AND.
     1         (PBINT(I,J,LBND+1).LE.PM)) THEN
              DP     = PINT(I,J,L+1)-PINT(I,J,L)
              PSUM(I,J,LBND)  =PSUM(I,J,LBND)+DP
              NSUM(I,J,LBND)  =NSUM(I,J,LBND)+1
              LVLBND(I,J,LBND)=LVLBND(I,J,LBND)+L
              TBND(I,J,LBND)  =TBND(I,J,LBND)+T(I,J,L)*DP
              QBND(I,J,LBND)  =QBND(I,J,LBND)+Q(I,J,L)*DP
              OMGBND(I,J,LBND)=OMGBND(I,J,LBND)+OMGA(I,J,L)*DP
              PWTBND(I,J,LBND)=PWTBND(I,J,LBND)
     1                        +(Q(I,J,L)+CWM(I,J,L))*DP*GI
C
              TMT0=T(I,J,L)-273.16
              TMT15=AMIN1(TMT0,-15.)
              AI=0.008855
              BI=1.
              IF(TMT0.LT.-20.)THEN
                AI=0.007225
                BI=0.9674
              ENDIF
              QW=PQ0/PM
     1          *EXP(A2*(T(I,J,L)-A3)/(T(I,J,L)-A4))
              QI=QW*(BI+AI*AMIN1(TMT0,0.))
              QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
              IF(TMT0.LT.-15.)THEN
                  QSAT=QI
              ELSEIF(TMT0.GE.0.)THEN
                  QSAT=QINT
              ELSE
                IF(IWL(I,J).GT.0.0) THEN
                  QSAT=QI
                ELSE
                  QSAT=QINT
                ENDIF
              ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
              QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
              QSBND(I,J,LBND)=QSBND(I,J,LBND)+QSAT*DP
            ENDIF
          ENDDO
          ENDDO
        ENDDO
C
C         NEED TO MAKE SURE THAT PINT HALOS EXIST
C
        DO L = 1, LP1
           CALL EXCH(PINT(1,1,L))
        end do
C
        DO L=1,LM
C
          DO J=JSTA_M,JEND_M
          DO I=2,IM-1
            IE=I+IVE(J)
            IW=I+IVW(J)
            PV1=0.25*(PINT(IW,J,L)+PINT(IE,J,L)
     1               +PINT(I,J+1,L)+PINT(I,J-1,L))
            PV2=0.25*(PINT(IW,J,L+1)+PINT(IE,J,L+1)
     1               +PINT(I,J+1,L+1)+PINT(I,J-1,L+1))
            DP=PV2-PV1
            PMV=0.5*(PV1+PV2)
            IF((PBINT(IW,J,LBND).GE.PMV).AND.
     X         (PBINT(IW,J,LBND+1).LE.PMV)) THEN
              PVSUM(I,J,LBND)=PVSUM(I,J,LBND)+DP
              UBND(I,J,LBND)=UBND(I,J,LBND)+U(I,J,L)*DP
              VBND(I,J,LBND)=VBND(I,J,LBND)+V(I,J,L)*DP
            ENDIF
C
          ENDDO
          ENDDO
        ENDDO
      ENDDO
C
!$omp  parallel do
!$omp& private(rpsum)
      DO LBND=1,NBND
        DO J=JSTA,JEND
        DO I=1,IM
          IF(PSUM(I,J,LBND).NE.0.)THEN
            RPSUM           = 1./PSUM(I,J,LBND)
            LVLBND(I,J,LBND)= LVLBND(I,J,LBND)/NSUM(I,J,LBND)
            PBND(I,J,LBND)  = (PBINT(I,J,LBND)+PBINT(I,J,LBND+1))*0.5
            TBND(I,J,LBND)  = TBND(I,J,LBND)*RPSUM
            QBND(I,J,LBND)  = QBND(I,J,LBND)*RPSUM
            QSBND(I,J,LBND) = QSBND(I,J,LBND)*RPSUM
            OMGBND(I,J,LBND)= OMGBND(I,J,LBND)*RPSUM
          ENDIF
        ENDDO
        ENDDO
C
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IF(PVSUM(I,J,LBND).NE.0.)THEN
            RPVSUM      =1./PVSUM(I,J,LBND)
            UBND(I,J,LBND)=UBND(I,J,LBND)*RPVSUM
            VBND(I,J,LBND)=VBND(I,J,LBND)*RPVSUM
          ENDIF
        ENDDO
        ENDDO
      ENDDO
C
C  IF NO ETA MID LAYER PRESSURES FELL WITHIN A BND LYR,
C   FIND THE CLOSEST LAYER TO THE BND LYR AND ASSIGN THE VALUES THERE
C
!$omp  parallel do
!$omp& private(ai,bi,delp,delpv,dp,ie,iw,l,lv,pm,pmin,pminv,pmv,
!$omp&         qi,qint,qsat,qw,tmt0,tmt15)
      DO LBND=1,NBND
        DO J=JSTA,JEND
        DO I=1,IM
          IF(PSUM(I,J,LBND).EQ.0.)THEN
            L=LM
            PMIN=9999999.
            PBND(I,J,LBND)=(PBINT(I,J,LBND)+PBINT(I,J,LBND+1))*0.5
C
            DO LL=1,LM
              PM=D50*(PINT(I,J,LL)+PINT(I,J,LL+1))
              DELP=ABS(PM-PBND(I,J,LBND))
              IF(DELP.LT.PMIN)THEN
                PMIN=DELP
                L=LL
              ENDIF
            ENDDO
C
            DP=PINT(I,J,L+1)-PINT(I,J,L)
            PM=D50*(PINT(I,J,L)+PINT(I,J,L+1))
            LVLBND(I,J,LBND)=L
            TBND(I,J,LBND)=T(I,J,L)
            QBND(I,J,LBND)=Q(I,J,L)
C
            TMT0=T(I,J,L)-273.16
            TMT15=AMIN1(TMT0,-15.)
            AI=0.008855
            BI=1.
            IF(TMT0.LT.-20.)THEN
              AI=0.007225
              BI=0.9674
            ENDIF
            QW=PQ0/PM
     1          *EXP(A2*(T(I,J,L)-A3)/(T(I,J,L)-A4))
            QI=QW*(BI+AI*AMIN1(TMT0,0.))
            QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
            IF(TMT0.LT.-15.)THEN
                QSAT=QI
            ELSEIF(TMT0.GE.0.)THEN
                QSAT=QINT
            ELSE
              IF(IWL(I,J).GT.0.0) THEN
                QSAT=QI
              ELSE
                QSAT=QINT
              ENDIF
            ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
              QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
            QSBND(I,J,LBND)=QSAT
            OMGBND(I,J,LBND)=OMGA(I,J,L)
            PWTBND(I,J,LBND)=(Q(I,J,L)+CWM(I,J,L))*DP*GI
          ENDIF
C
C   RH, BOUNDS CHECK
C
          RHBND(I,J,LBND)=QBND(I,J,LBND)/QSBND(I,J,LBND)
          IF (RHBND(I,J,LBND).GT.1.0) THEN
            RHBND(I,J,LBND)=1.0
            QBND(I,J,LBND)=RHBND(I,J,LBND)*QSBND(I,J,LBND)
          ENDIF
          IF (RHBND(I,J,LBND).LT.0.01) THEN
            RHBND(I,J,LBND)=0.01
            QBND(I,J,LBND)=RHBND(I,J,LBND)*QSBND(I,J,LBND)
          ENDIF
        ENDDO
        ENDDO
C
        DO J=JSTA_M,JEND_M
        DO I=2,IM-1
          IF(PVSUM(I,J,LBND).EQ.0.)THEN
            LV=LM
            PMINV=9999999.
            IE=I+IVE(J)
            IW=I+IVW(J)
C
C           PINT HALOS UPDATED ALREADY
C
            DO LL=1,LM
              PMV=0.125*(PINT(IW,J,LL)+PINT(IE,J,LL)+
     1              PINT(I,J+1,LL)+PINT(I,J-1,LL)+
     2              PINT(IW,J,LL+1)+PINT(IE,J,LL+1)+
     3              PINT(I,J+1,LL+1)+PINT(I,J-1,LL+1))
              DELPV=ABS(PMV-PBND(I,J,LBND))
              IF(DELPV.LT.PMINV)THEN
                PMINV=DELPV
                LV=LL
              ENDIF
            ENDDO
C
            UBND(I,J,LBND)=U(I,J,LV)
            VBND(I,J,LBND)=V(I,J,LV)
          ENDIF
        ENDDO
        ENDDO
      ENDDO
C
C     END OF ROUTINE
C     
      RETURN
      END
C

      SUBROUTINE OTLIFT2(T500,SLINDX)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    OTLIFT2     COMPUTES SFC TO 500MB LIFTED INDEX
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-03-10       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES A SURFACE TO 500MB LIFTED INDEX.
C     THE LIFTED PARCEL IS FROM THE FIRST ATMOSPHERIC ETA 
C     LAYER (IE, THE ETA LAYER CLOSEST TO THE MODEL GROUND).
C     THE LIFTED INDEX IS THE DIFFERENCE BETWEEN THIS PARCEL'S
C     TEMPERATURE AT 500MB AND THE AMBIENT 500MB TEMPERATURE.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  ??? - SUBROUTINE OTLIFT IN ETA MODEL.
C   93-03-10  RUSS TREADON - ADAPTED OTLIFT FOR USE WITH NEW POST. 
C   98-06-18  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL OTLIFT2(T500,SLINDX)
C   INPUT ARGUMENT LIST:
C     T500     - 500MB AMBIENT TEMPERATURE.
C
C   OUTPUT ARGUMENT LIST: 
C     SLINDX   - LIFTED INDEX.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - CTLBLK
C                  LOOPS
C                  MASKS
C                  PHYS
C                  VRBLS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     SET LOCAL PARAMETERS.
      PARAMETER
     & (D00=0.E0,H10E5=100000.E0,H5E4=5.E4,CAPA=0.28589641
     &, D8202=.820231E0)
      PARAMETER
     & (ELIVW=2.72E6,CP=1004.6E0,ELOCP=ELIVW/CP)
C     
C     INCLUDE GLOBAL PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "parm.tbl"
C     
C     SET DEPENDENT PARAMETERS.
      PARAMETER
     & (JAM=6+2*(JM-10),LP1=LM+1)
C     
C     DECLARE VARIABLES.
      LOGICAL RUN,FIRST,RESTRT,SIGMA
      DIMENSION
     & ITTB  (IM,JM),IQTB  (IM,JM),IPTB  (IM,JM),ITHTB (IM,JM)
     &,PDSL  (IM,JM),TBT   (IM,JM),QBT   (IM,JM)
     &,APEBT (IM,JM),TTHBT (IM,JM),TTH   (IM,JM),PP    (IM,JM)
     &,BQS00 (IM,JM),SQS00 (IM,JM),BQS10 (IM,JM),SQS10 (IM,JM)
     &,BQ    (IM,JM),SQ    (IM,JM),TQ    (IM,JM),QQ    (IM,JM)
     &,P00   (IM,JM),P10   (IM,JM),P01   (IM,JM),P11   (IM,JM)
     &,TPSP  (IM,JM),APESP (IM,JM),TTHES (IM,JM)
     &,PSP   (IM,JM),THBT  (IM,JM),THESP (IM,JM)
     &,P     (IM,JM),TP    (IM,JM),BTH   (IM,JM),STH   (IM,JM)
     &,BTHE00(IM,JM),STHE00(IM,JM),BTHE10(IM,JM),STHE10(IM,JM)
     &,T00   (IM,JM),T10   (IM,JM),T01   (IM,JM),T11   (IM,JM)
     &,PARTMP(IM,JM),T500  (IM,JM),SLINDX(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "VRBLS.comm"
C
       EQUIVALENCE
     & (ITTB  (1,1),IPTB  (1,1)                           )
     &,(IQTB  (1,1),ITHTB (1,1)                           )
     &,(QQ    (1,1),APESP (1,1),TTHES (1,1)               )
     &,(TTH   (1,1),TQ    (1,1),TP    (1,1)               )
       EQUIVALENCE
     & (BQS00 (1,1),P00   (1,1),BTHE00(1,1),T00   (1,1)   )
     &,(SQS00 (1,1),P10   (1,1),STHE00(1,1),T10   (1,1)   )
     &,(BQS10 (1,1),P01   (1,1),BTHE10(1,1),T01   (1,1)   )
     &,(SQS10 (1,1),P11   (1,1),STHE10(1,1),T11   (1,1)   )
     &,(BQ    (1,1)          ,BTH   (1,1)                 )
     &,(SQ    (1,1)          ,STH   (1,1)                 )
C     
C     
C***********************************************************************
C     START OTLIFT2 HERE
C     
C     INTIALIZE LIFTED INDEX ARRAY TO ZERO.
      DO J=JSTA,JEND
      DO I=1,IM
        SLINDX(I,J)=D00
      ENDDO
      ENDDO
C--------------FIND EXNER AT LOWEST LEVEL-------------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        LBTM=LMH(I,J)
        TBT(I,J)=T(I,J,LBTM)
        QBT(I,J)=Q(I,J,LBTM)
        PDSL(I,J)=PD(I,J)*RES(I,J)
        APEBT(I,J)=PDSL(I,J)*AETA(LBTM)+PT
        APEBT(I,J)=(H10E5/APEBT(I,J))**CAPA
      ENDDO
      ENDDO
C--------------SCALING POTENTIAL TEMPERATURE & TABLE INDEX--------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        TTHBT(I,J)=TBT(I,J)*APEBT(I,J)
        TTH(I,J)=(TTHBT(I,J)-THL)*RDTH
        QQ(I,J)=TTH(I,J)-AINT(TTH(I,J))
        ITTB(I,J)=INT(TTH(I,J))+1
      ENDDO
      ENDDO
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IF(ITTB(I,J).LT.1)THEN
          ITTB(I,J)=1
          QQ(I,J)=D00
        ENDIF
          IF(ITTB(I,J).GE.JTB)THEN
          ITTB(I,J)=JTB-1
          QQ(I,J)=D00
        ENDIF
      ENDDO
      ENDDO
C--------------BASE AND SCALING FACTOR FOR SPEC. HUMIDITY---------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        ITTBK=ITTB(I,J)
        BQS00(I,J)=QS0(ITTBK)
        SQS00(I,J)=SQS(ITTBK)
        BQS10(I,J)=QS0(ITTBK+1)
        SQS10(I,J)=SQS(ITTBK+1)
      ENDDO
      ENDDO
C--------------SCALING SPEC. HUMIDITY & TABLE INDEX---------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        BQ(I,J)=(BQS10(I,J)-BQS00(I,J))*QQ(I,J)+BQS00(I,J)
        SQ(I,J)=(SQS10(I,J)-SQS00(I,J))*QQ(I,J)+SQS00(I,J)
        TQ(I,J)=(QBT(I,J)-BQ(I,J))/SQ(I,J)*RDQ
        PP(I,J)=TQ(I,J)-AINT(TQ(I,J))
        IQTB(I,J)=INT(TQ(I,J))+1
      ENDDO
      ENDDO
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IF(IQTB(I,J).LT.1)THEN
          IQTB(I,J)=1
          PP(I,J)=D00
        ENDIF
        IF(IQTB(I,J).GE.ITB)THEN
          IQTB(I,J)=ITB-1
          PP(I,J)=D00
        ENDIF
      ENDDO
      ENDDO
C--------------SATURATION PRESSURE AT FOUR SURROUNDING TABLE PTS.-------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IQ=IQTB(I,J)
        IT=ITTB(I,J)
        P00(I,J)=PTBL(IQ,IT)
        P10(I,J)=PTBL(IQ+1,IT)
        P01(I,J)=PTBL(IQ,IT+1)
        P11(I,J)=PTBL(IQ+1,IT+1)
      ENDDO
      ENDDO
C--------------SATURATION POINT VARIABLES AT THE BOTTOM-----------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        TPSP(I,J)=P00(I,J)+(P10(I,J)-P00(I,J))*PP(I,J)
     1                    +(P01(I,J)-P00(I,J))*QQ(I,J)
     2        +(P00(I,J)-P10(I,J)-P01(I,J)+P11(I,J))*PP(I,J)*QQ(I,J)
        IF(TPSP(I,J).LE.D00)TPSP(I,J)=H10E5
        APESP(I,J)=(H10E5/TPSP(I,J))**CAPA
        TTHES(I,J)=TTHBT(I,J)*EXP(ELOCP*QBT(I,J)*APESP(I,J)/TTHBT(I,J))
      ENDDO
      ENDDO
C-----------------------------------------------------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        PSP(I,J)=TPSP(I,J)
        THBT(I,J)=TTHBT(I,J)
        THESP(I,J)=TTHES(I,J)
      ENDDO
      ENDDO
C-----------------------------------------------------------------------
 190  CONTINUE
C--------------SCALING PRESSURE & TT TABLE INDEX------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        P (I,J)=H5E4
        TP(I,J)=(P(I,J)-PL)*RDP
        QQ(I,J)=TP(I,J)-AINT(TP(I,J))
        IPTB(I,J)=INT(TP(I,J))+1
      ENDDO
      ENDDO
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IF(IPTB(I,J).LT.1)THEN
          IPTB(I,J)=1
          QQ(I,J)=D00
        ENDIF
        IF(IPTB(I,J).GE.ITB)THEN
          IPTB(I,J)=ITB-1
          QQ(I,J)=D00
        ENDIF
      ENDDO
      ENDDO
C--------------BASE AND SCALING FACTOR FOR THE--------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IPTBK=IPTB(I,J)
        BTHE00(I,J)=THE0(IPTBK)
        STHE00(I,J)=STHE(IPTBK)
        BTHE10(I,J)=THE0(IPTBK+1)
        STHE10(I,J)=STHE(IPTBK+1)
      ENDDO
      ENDDO
C--------------SCALING THE & TT TABLE INDEX-----------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        BTH(I,J)=(BTHE10(I,J)-BTHE00(I,J))*QQ(I,J)+BTHE00(I,J)
        STH(I,J)=(STHE10(I,J)-STHE00(I,J))*QQ(I,J)+STHE00(I,J)
        TTH(I,J)=(THESP(I,J)-BTH(I,J))/STH(I,J)*RDTHE
        PP(I,J)=TTH(I,J)-AINT(TTH(I,J))
        ITHTB(I,J)=INT(TTH(I,J))+1
      ENDDO
      ENDDO
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IF(ITHTB(I,J).LT.1)THEN
          ITHTB(I,J)=1
          PP(I,j)=D00
        ENDIF
        IF(ITHTB(I,J).GE.JTB)THEN
          ITHTB(I,J)=JTB-1
          PP(I,J)=D00
        ENDIF
      ENDDO
      ENDDO
C--------------TEMPERATURE AT FOUR SURROUNDING TT TABLE PTS.------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        ITH=ITHTB(I,J)
        IP=IPTB(I,J)
        T00(I,J)=TTBL(ITH,IP)
        T10(I,J)=TTBL(ITH+1,IP)
        T01(I,J)=TTBL(ITH,IP+1)
        T11(I,J)=TTBL(ITH+1,IP+1)
      ENDDO
      ENDDO
C--------------PARCEL TEMPERATURE AT 500MB----------------------------
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        IF(TPSP(I,J).GE.H5E4)THEN
          PARTMP(I,J)=(T00(I,J)+(T10(I,J)-T00(I,J))*PP(I,J)
     1                         +(T01(I,J)-T00(I,J))*QQ(I,J)
     2        +(T00(I,J)-T10(I,J)-T01(I,J)+T11(I,J))*PP(I,J)*QQ(I,J))
        ELSE
          PARTMP(I,J)=TBT(I,J)*APEBT(I,J)*D8202
        ENDIF
C--------------LIFTED INDEX---------------------------------------------
        SLINDX(I,J)=T500(I,J)-PARTMP(I,J)
      ENDDO
      ENDDO
C
      RETURN
      END

      SUBROUTINE CLDRAD(IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CLDRAD       POST SNDING/CLOUD/RADTN FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-08-30       
C     
C ABSTRACT:  THIS ROUTINE COMPUTES/POSTS SOUNDING, CLOUD 
C   RELATED, AND RADIATION FIELDS.  UNDER THE HEADING OF 
C   SOUNDING FIELDS FALL THE THREE ETA MODEL LIFTED INDICES,
C   CAPE, CIN, AND TOTAL COLUMN PRECIPITABLE WATER.
C
C   THE THREE ETA MODEL LIFTED INDICES DIFFER ONLY IN THE
C   DEFINITION OF THE PARCEL TO LIFT.  ONE LIFTS PARCELS FROM
C   THE LOWEST ABOVE GROUND ETA LAYER.  ANOTHER LIFTS MEAN 
C   PARCELS FROM ANY OF NBND BOUNDARY LAYERS (SEE SUBROUTINE
C   BNDLYR2).  THE FINAL TYPE OF LIFTED INDEX IS A BEST LIFTED
C   INDEX BASED ON THE NBND BOUNDARY LAYER LIFTED INDICES.
C
C   TWO TYPES OF CAPE/CIN ARE AVAILABLE.  ONE IS BASED ON PARCELS
C   IN THE LOWEST ETA LAYER ABOVE GROUND.  THE OTHER IS BASED 
C   ON A LAYER MEAN PARCEL IN THE N-TH BOUNDARY LAYER ABOVE 
C   THE GROUND.  SEE SUBROUTINE CALCAPE FOR DETAILS.
C
C   THE CLOUD FRACTION AND LIQUID CLOUD WATER FIELDS ARE DIRECTLY
C   FROM THE MODEL WITH MINIMAL POST PROCESSING.  THE LIQUID 
C   CLOUD WATER, 3-D CLOUD FRACTION, AND TEMPERATURE TENDENCIES
C   DUE TO PRECIPITATION ARE NOT POSTED IN THIS ROUTINE.  SEE
C   SUBROUTINE ETAFLD2 FOR THESE FIELDS.  LIFTING CONDENSATION
C   LEVEL HEIGHT AND PRESSURE ARE COMPUTED AND POSTED IN
C   SUBROUTINE MISCLN.  
C
C   THE RADIATION FIELDS POSTED BY THIS ROUTINE ARE THOSE COMPUTED
C   DIRECTLY IN THE MODEL.
C     
C PROGRAM HISTORY LOG:
C   93-08-30  RUSS TREADON
C   94-08-04  MICHAEL BALDWIN - ADDED OUTPUT OF INSTANTANEOUS SFC
C                               FLUXES OF NET SW AND LW DOWN RADIATION
C   97-04-25  MICHAEL BALDWIN - FIX PDS FOR PRECIPITABLE WATER
C   97-04-29  GEOFF MANIKIN - MOVED CLOUD TOP TEMPS CALCULATION
C                               TO THIS SUBROUTINE.  CHANGED METHOD
C                               OF DETERMINING WHERE CLOUD BASE AND
C                               TOP ARE FOUND AND ADDED HEIGHT OPTION
C                               FOR TOP AND BASE.
C   98-04-29  GEOFF MANIKIN - CHANGED VALUE FOR CLOUD BASE/TOP PRESSURES
C                               AND HEIGHTS FROM SPVAL TO -500
C   98-06-15  T BLACK       - CONVERSION FROM 1-D TO 2-D
C   98-07-17  MIKE BALDWIN  - REMOVED LABL84
C   00-01-04  JIM TUCCILLO  - MPI VERSION
C
C
C     
C USAGE:    CALL CLDRAD(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - RQSTFLD
C                  EXTRA
C                  MAPOT
C                  PHYS
C                  LOOPS
C                  MASKS
C                  VRBLS
C                  CNVCLD
C                  CTLBLK
C                  ACMCLD
C                  ACMRDS
C                  ACMRDL
C                  OPTIONS
C                  CLDWTR
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C
C     INCLUDE GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
      INCLUDE "parm.tbl"
      INCLUDE "mpif.h"
C     
C     SET CELSIUS TO KELVIN CONVERSION.
      PARAMETER (C2K=273.15)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STDRD
      LOGICAL NEED(IM,JM)
      INTEGER L1D(IM,JM)
      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT),CLDTP(IM,JM),
     &        CLDTZ(IM,JM),CLDBP(IM,JM),CLDBZ(IM,JM),CLDTT(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "RQSTFLD.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PHYS1.comm"
      INCLUDE "CNVCLD.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "ACMCLD.comm"
      INCLUDE "ACMRDS.comm"
      INCLUDE "ACMRDL.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "OUTFIL.comm"
C
C
C*************************************************************************
C     START CLDRAD HERE.
C     
C***  BLOCK 1.  SOUNDING DERIVED FIELDS.
C     
C     ETA SURFACE TO 500MB LIFTED INDEX.  TO BE CONSISTENT WITH THE

C     LFM AND NGM POSTING WE ADD 273.15 TO THE LIFTED INDEX
C     NOTE:  25 JUNE 1993, RUSS TREADON.
C               ON THE LFM FORECAST GRID (026) WE POST
C               THE FIRST BOUNDARY LAYER LIFTED INDEX.
C               SEE SUBROUTINE MISCLN.
C
C     THE BEST (SIX LAYER) AND BOUNDARY LAYER LIFTED INDICES ARE
C     COMPUTED AND POSTED IN SUBROUTINE MISCLN.
C
      IF ( (IGET(030).GT.0).AND.(KGTYPE.NE.026) ) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J) = SPVAL
         ENDDO
         ENDDO
C
         CALL OTLIFT2(T500,EGRID1)
C
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J) = EGRID1(I,J) + C2K
         ENDDO
         ENDDO
C
         CALL E2OUT(030,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         ID(10)  =50
         ID(11)  =100
         CALL OUTPUT(IOUTYP,IGET(030),LVLS(1,IGET(030)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     SOUNDING DERIVED AREA INTEGRATED ENERGIES - CAPE AND CIN.
      IF ((IGET(032).GT.0).OR.(IGET(107).GT.0)) THEN
         IF ( (LVLS(1,IGET(032)).GT.0) .OR. 
     X        (LVLS(1,IGET(107)).GT.0) ) THEN
            ITYPE = 1
            CALL CALCAPE(ITYPE,P1D,T1D,Q1D,L1D,EGRID1,EGRID2)
C
C           CONVECTIVE AVAILABLE POTENTIAL ENERGY.
            IF (IGET(032).GT.0) THEN
               CALL E2OUT(032,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
CJLG 20230612               CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
               ID(1:25)=0
               CALL OUTPUT(IOUTYP,IGET(032),LVLS(1,IGET(032)),
     X              GRID1,IMOUT,JMOUT)
            ENDIF
C
C           CONVECTIVE INHIBITION.
            IF (IGET(107).GT.0) THEN
               CALL E2OUT(107,000,EGRID2,EGRID1,GRID1,GRID2,IMOUT,JMOUT)
               if ( me .eq. 0 ) then
               DO J=1,JMOUT
               DO I=1,IMOUT
                 GRID1(I,J) = -1.*GRID1(I,J)
               ENDDO
               ENDDO
               end if
CJLG 20230612               CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
               if ( me .eq. 0 ) then
               DO J=1,JMOUT
               DO I=1,IMOUT
                 GRID1(I,J) = -1.*GRID1(I,J)
               ENDDO
               ENDDO
               end if
               ID(1:25)=0
               CALL OUTPUT(IOUTYP,IGET(107),LVLS(1,IGET(107)),
     X              GRID1,IMOUT,JMOUT)
            ENDIF
         ENDIF
      ENDIF
C
C     TOTAL COLUMN PRECIPITABLE WATER.
      IF (IGET(080).GT.0) THEN
         CALL CALPW(EGRID1)
         CALL E2OUT(080,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
CJLG 20230612        CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT) 
         CALL OUTPUT(IOUTYP,IGET(080),LVLS(1,IGET(080)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C   
C
C
C***  BLOCK 2.  2-D CLOUD FIELDS.
C
C     LOW CLOUD FRACTION.
      IF (IGET(037).GT.0) THEN
         CALL E2OUT(037,000,CFRACL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(037),LVLS(1,IGET(037)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     MIDDLE CLOUD FRACTION.
      IF (IGET(038).GT.0) THEN
         CALL E2OUT(038,000,CFRACM,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(038),LVLS(1,IGET(038)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     HIGH CLOUD FRACTION.
      IF (IGET(039).GT.0) THEN
         CALL E2OUT(039,000,CFRACH,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(039),LVLS(1,IGET(039)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     TOTAL CLOUD FRACTION (INSTANTANEOUS).
      IF (IGET(161).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           EGRID1(I,J)=AMAX1(CFRACL(I,J),
     1                 AMAX1(CFRACM(I,J),CFRACH(I,J)))
         ENDDO
         ENDDO
         CALL E2OUT(161,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
         CALL OUTPUT(IOUTYP,IGET(161),LVLS(1,IGET(161)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     TIME AVERAGED TOTAL CLOUD FRACTION.
         IF (IGET(144).GT.0) THEN
            doout40: DO J=JSTA,JEND
            doin40: DO I=1,IM
               ISUM = NCFRST(I,J)+NCFRCV(I,J)
               IF (ISUM.GT.0) THEN
                  EGRID1(I,J)=(ACFRST(I,J)+ACFRCV(I,J))/ISUM
               ELSE
                  EGRID1(I,J) = D00
               ENDIF
            END DO doin40
            END DO doout40
C
            CALL E2OUT(144,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)= 0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
	    ITCLOD     = INT(TCLOD)
            IFINCR     = MOD(IFHR,ITCLOD)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITCLOD
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(144),LVLS(1,IGET(144)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED STRATIFORM CLOUD FRACTION.
         IF (IGET(139).GT.0) THEN
            doout50: DO J=JSTA,JEND
            doin50: DO I=1,IM
               IF (NCFRST(I,J).GT.0) THEN
                  EGRID1(I,J) = ACFRST(I,J)/NCFRST(I,J)
               ELSE
                  EGRID1(I,J) = D00
               ENDIF
            END DO doin50
            END DO doout50
C
            CALL E2OUT(139,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
            ITCLOD     = INT(TCLOD)
            IFINCR     = MOD(IFHR,ITCLOD)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITCLOD
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(139),LVLS(1,IGET(139)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C    
C     TIME AVERAGED CONVECTIVE CLOUD FRACTION.
         IF (IGET(143).GT.0) THEN
            doout60: DO J=JSTA,JEND
            doin60: DO I=1,IM
               IF (NCFRCV(I,J).GT.0) THEN
                  EGRID1(I,J) = ACFRCV(I,J)/NCFRCV(I,J)
               ELSE
                  EGRID1(I,J) = D00
               ENDIF
            END DO doin60
            END DO doout60
C
            CALL E2OUT(143,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
            ITCLOD     = INT(TCLOD)
            IFINCR     = MOD(IFHR,ITCLOD)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITCLOD
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL SCLFLD(GRID1,100.,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(143),LVLS(1,IGET(143)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C    
C     CLOUD BASE FIELDS 
      IF ((IGET(148).GT.0) .OR. (IGET(178).GT.0)) THEN
          CLIMIT =1.0E-06
          DO J=JSTA,JEND
          DO I=1,IM
            NEED(I,J)=.TRUE.
            CLDBP(I,J) = SPVAL
            CLDBZ(I,J) = SPVAL
          ENDDO
          ENDDO

!$omp  parallel do
!$omp& private(cbot,lev,llmh)
          doout70: DO J=JSTA,JEND
          doin70: DO I=1,IM
            LLMH=LMH(I,J)
            CBOT = 500
            DO L=LLMH,1,-1
C GSM
C START AT THE FIRST LAYER ABOVE GROUND, AND FIND THE
C   FIRST LAYER WITH A VALUE OF CLOUD WATER GREATER THAN
C   THE SIGNIFICANT LIMIT (VALUE DESIGNATED BY Q. ZHAO).
C   THIS LAYER WILL BE THE CLOUD BOTTOM UNLESS THE BOTTOM
C   OF THE CONVECTIVE CLOUD (HBOT) IS FOUND BELOW IN WHICH
C   CASE HBOT BECOMES THE CLOUD BASE LAYER.
              IF (CWM(I,J,L).GT.CLIMIT.AND.NEED(I,J)) THEN
                CBOT=L
                IF (HBOT(I,J).GT.CBOT) THEN
                   CBOT = HBOT(I,J)
                ENDIF
                NEED(I,J)=.FALSE.
               ENDIF
            ENDDO
C
              IF (CBOT.EQ.500.) THEN
                 CLDBP(I,J) = SPVAL
                 CLDBZ(I,J) = SPVAL
              ELSE IF (CBOT.EQ.LM) THEN
                 CLDBP(I,J) = AETA1(INT(CBOT))*PDSL(I,J)+PT1
                 CLDBZ(I,J) = ZINT(I,J,LM) 
              ELSE
                 LEV = CBOT
                 CLDBP(I,J) = AETA1(INT(LEV))*PDSL(I,J)+PT1
                 CLDBZ(I,J) = HTM(I,J,LEV+1)*T(I,J,LEV+1)
     1                       *(Q(I,J,LEV+1)*D608+H1)*ROG*
     2                        (LOG(PINT(I,J,LEV+1))-LOG(CLDBP(I,J)))
     3                       +ZINT(I,J,LEV+1)
              ENDIF
         END DO doin70
         END DO doout70
C   CLOUD BOTTOM PRESSURE
         IF (IGET(148).GT.0) THEN
          CALL E2OUT(148,000,CLDBP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
          ID(1:25)=0
          CALL OUTPUT(IOUTYP,IGET(148),LVLS(1,IGET(148)),
     X        GRID1,IMOUT,JMOUT)
         ENDIF

C    CLOUD BOTTOM HEIGHT    
         IF (IGET(178).GT.0) THEN
          CALL E2OUT(148,000,CLDBZ,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
          ID(1:25)=0
          CALL OUTPUT(IOUTYP,IGET(178),LVLS(1,IGET(178)),
     X        GRID1,IMOUT,JMOUT)
         ENDIF
      ENDIF
C
C     CLOUD TOP FIELDS 
      IF ((IGET(149).GT.0) .OR. (IGET(179).GT.0) .OR.
     X    (IGET(168).GT.0)) THEN
          CLIMIT =1.0E-06
          DO J=JSTA,JEND
          DO I=1,IM
            NEED(I,J)=.TRUE.
          ENDDO
          ENDDO
C GSM
C   START AT THE TOP OF THE ATMOSPHERE.  FIND THE
C   FIRST LAYER WITH A VALUE OF CLOUD WATER GREATER THAN
C   THE SIGNIFICANT LIMIT (VALUE DESIGNATED BY Q. ZHAO).
C   THIS LAYER WILL BE THE CLOUD TOP UNLESS THE TOP 
C   OF THE CONVECTIVE CLOUD (HTOP) IS FOUND ABOVE IN WHICH
C   CASE HTOP BECOMES THE CLOUD TOP LAYER.

!$omp  parallel do
!$omp& private(ctop,lev,lmhk)
          doout80: DO J=JSTA,JEND
          doin80: DO I=1,IM
            CTOP = 0.
            LMHK=LMH(I,J)
            DO L=1,LMHK
              IF (CWM(I,J,L).GT.CLIMIT.AND.NEED(I,J)) THEN
                CTOP=L
                IF (HTOP(I,J).LT.CTOP) THEN
                   CTOP = HTOP(I,J)
                ENDIF
                NEED(I,J)=.FALSE.
              ENDIF
            ENDDO
C
            IF (CTOP.EQ.0.)THEN
              CLDTP(I,J) = SPVAL
              CLDTZ(I,J) = SPVAL
              LMHK=LMH(I,J)
              CLDTT(I,J) = T(I,J,LMHK)
            ELSE IF (CTOP.EQ.LM) THEN
              CLDTP(I,J) = AETA1(INT(LM))*PDSL(I,J)+PT1
              CLDTZ(I,J) = ZINT(I,J,LM)
              CLDTT(I,J) = T(I,J,LM)
            ELSE
              LEV = CTOP
              CLDTP(I,J) = AETA1(INT(LEV))*PDSL(I,J)+PT1
              CLDTZ(I,J) = HTM(I,J,LEV+1)*T(I,J,LEV+1)
     1                    *(Q(I,J,LEV+1)*D608+H1)*ROG*
     2                     (LOG(PINT(I,J,LEV+1))-LOG(CLDTP(I,J)))
     3                    +ZINT(I,J,LEV+1) 
              CLDTT(I,J) = T(I,J,LEV)
            ENDIF
         END DO doin80
         END DO doout80
C   CLOUD TOP PRESSURE
         IF (IGET(149).GT.0) THEN
           CALL E2OUT(149,000,CLDTP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
           ID(1:25)=0
           CALL OUTPUT(IOUTYP,IGET(149),LVLS(1,IGET(149)),
     X        GRID1,IMOUT,JMOUT)
          ENDIF
 
C   CLOUD TOP HEIGHT 
          IF (IGET(179).GT.0) THEN
           CALL E2OUT(179,000,CLDTZ,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
           ID(1:25)=0
           CALL OUTPUT(IOUTYP,IGET(179),LVLS(1,IGET(179)),
     X        GRID1,IMOUT,JMOUT)
          ENDIF

C   CLOUD TOP TEMPS
          IF (IGET(168).GT.0) THEN
           CALL E2OUT(168,000,CLDTT,EGRID2,
     X         GRID1,GRID2,IMOUT,JMOUT)
           ID(1:25)=0
           CALL OUTPUT(IOUTYP,IGET(168),LVLS(1,IGET(168)),
     X         GRID1,IMOUT,JMOUT)
          ENDIF
      ENDIF

C***  BLOCK 3.  RADIATION FIELDS.
C     
C
C     TIME AVERAGED SURFACE SHORT WAVE INCOMING RADIATION.
         IF (IGET(126).GT.0) THEN
           IF(ARDSW.GT.0.)THEN
             RRNUM=1./ARDSW
           ELSE
             RRNUM=0.
           ENDIF
           DO J=JSTA,JEND
           DO I=1,IM
              EGRID1(I,J) = ASWIN(I,J)*RRNUM
           ENDDO
           ENDDO
            CALL E2OUT(126,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
	    ITRDSW     = INT(TRDSW)
            IFINCR     = MOD(IFHR,ITRDSW)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITRDSW
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(126),LVLS(1,IGET(126)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED SURFACE LONG WAVE INCOMING RADIATION.
         IF (IGET(127).GT.0) THEN
           IF(ARDLW.GT.0.)THEN
             RRNUM=1./ARDLW
           ELSE
             RRNUM=0.
           ENDIF
           DO J=JSTA,JEND
           DO I=1,IM
             EGRID1(I,J) = ALWIN(I,J)*RRNUM
           ENDDO
           ENDDO
            CALL E2OUT(127,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
            ITRDLW     = INT(TRDLW)
            IFINCR     = MOD(IFHR,ITRDLW)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITRDLW
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(127),LVLS(1,IGET(127)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED SURFACE SHORT WAVE OUTGOING RADIATION.
         IF (IGET(128).GT.0) THEN
           IF(ARDSW.GT.0.)THEN
             RRNUM=1./ARDSW
           ELSE
             RRNUM=0.
           ENDIF
           DO J=JSTA,JEND
           DO I=1,IM
             EGRID1(I,J) = -1.0*ASWOUT(I,J)*RRNUM
           ENDDO
           ENDDO
            CALL E2OUT(128,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
	    ITRDSW     = INT(TRDSW)
            IFINCR     = MOD(IFHR,ITRDSW)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITRDSW
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(128),LVLS(1,IGET(128)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED SURFACE LONG WAVE OUTGOING RADIATION.
         IF (IGET(129).GT.0) THEN
           IF(ARDLW.GT.0.)THEN
             RRNUM=1./ARDLW
           ELSE
             RRNUM=0.
           ENDIF
           DO J=JSTA,JEND
           DO I=1,IM
             EGRID1(I,J) = -1.0*ALWOUT(I,J)*RRNUM
           ENDDO
           ENDDO
            CALL E2OUT(129,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
	    ITRDLW     = INT(TRDLW)
            IFINCR     = MOD(IFHR,ITRDLW)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITRDLW
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(129),LVLS(1,IGET(129)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED TOP OF THE ATMOSPHERE SHORT WAVE RADIATION.
         IF (IGET(130).GT.0) THEN
           IF(ARDSW.GT.0.)THEN
             RRNUM=1./ARDSW
           ELSE
             RRNUM=0.
           ENDIF
           DO J=JSTA,JEND
           DO I=1,IM
             EGRID1(I,J) = ASWTOA(I,J)*RRNUM
           ENDDO
           ENDDO
            CALL E2OUT(130,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
	    ITRDSW     = INT(TRDSW)
            IFINCR     = MOD(IFHR,ITRDSW)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITRDSW
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(130),LVLS(1,IGET(130)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C     TIME AVERAGED TOP OF THE ATMOSPHERE LONG WAVE RADIATION.
         IF (IGET(131).GT.0) THEN
           IF(ARDLW.GT.0.)THEN
             RRNUM=1./ARDLW
           ELSE
             RRNUM=0.
           ENDIF
           DO J=JSTA,JEND
           DO I=1,IM
             EGRID1(I,J) = ALWTOA(I,J)*RRNUM
           ENDDO
           ENDDO
            CALL E2OUT(131,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
C            IFHR       = NTSD/TSPH+0.5
            IFHR       = ITAG
	    ITRDLW     = INT(TRDLW)
            IFINCR     = MOD(IFHR,ITRDLW)
            ID(19)  = IFHR
            ID(20)  = 3
            IF (IFINCR.EQ.0) THEN
               ID(18)  = IFHR-ITRDLW
            ELSE
               ID(18)  = IFHR-IFINCR
            ENDIF
            IF (ID(18).LT.0) ID(18) = 0
            CALL OUTPUT(IOUTYP,IGET(131),LVLS(1,IGET(131)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C     CURRENT INCOMING SW RADIATION AT THE SURFACE.
      IF (IGET(156).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           IF(CZMEAN(I,J).GT.1.E-6) THEN
             FACTRS=CZEN(I,J)/CZMEAN(I,J)
           ELSE
             FACTRS=0.0
           ENDIF
           EGRID1(I,J)=HBM2(I,J)*RSWIN(I,J)*FACTRS
         ENDDO
         ENDDO
C
         CALL E2OUT(156,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL OUTPUT(IOUTYP,IGET(156),LVLS(1,IGET(156)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     CURRENT INCOMING LW RADIATION AT THE SURFACE.
      IF (IGET(157).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           IF(SIGT4(I,J).GT.0.0) THEN
             LLMH=LMH(I,J)
             TLMH=T(I,J,LLMH)
             FACTRL=5.67E-8*TLMH*TLMH*TLMH*TLMH/SIGT4(I,J)
           ELSE
             FACTRL=0.0
           ENDIF
           EGRID1(I,J)=HBM2(I,J)*RLWIN(I,J)*FACTRL
         ENDDO
         ENDDO
C
         CALL E2OUT(157,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL OUTPUT(IOUTYP,IGET(157),LVLS(1,IGET(157)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     CURRENT OUTGOING SW RADIATION AT THE SURFACE.
      IF (IGET(141).GT.0) THEN
         DO J=JSTA,JEND
         DO I=1,IM
           IF(CZMEAN(I,J).GT.1.E-6) THEN
             FACTRS=CZEN(I,J)/CZMEAN(I,J)
           ELSE
             FACTRS=0.0
           ENDIF
           EGRID1(I,J)=HBM2(I,J)*RSWOUT(I,J)*FACTRS
         ENDDO
         ENDDO
C
         CALL E2OUT(141,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL OUTPUT(IOUTYP,IGET(141),LVLS(1,IGET(141)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C     
C     CURRENT OUTGOING LW RADIATION AT THE SURFACE.
      IF (IGET(142).GT.0) THEN
         CALL E2OUT(142,000,RADOT,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
         ID(1:25)=0
         CALL OUTPUT(IOUTYP,IGET(142),LVLS(1,IGET(142)),
     X        GRID1,IMOUT,JMOUT)
      ENDIF
C
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE FRZLVL2(ZFRZ,RHFRZ)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    FRZLVL      COMPUTES FRZING LVL Z AND RH
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES THE FREEZING LEVEL HEIGHT AND RELATIVE
C     HUMIDITY AT THIS LEVEL FOR EACH MASS POINT ON THE ETA GRID.
C     THE COMPUTED FREEZING LEVEL HEIGHT IS THE MEAN SEA LEVEL
C     HEIGHT.  AT EACH MASS POINT WE MOVE UP FROM THE SURFACE TO 
C     FIND THE LAST ETA LAYER WHERE THE TEMPERATURE IS LESS THAN
C     273.16K AND THE TEMP IN THE LAYER BELOW IS ABOVE 273.16K.
C     VERTICAL INTERPOLATION IN TEMPERATURE TO THE FREEZING
C     TEMPERATURE GIVES THE FREEZING LEVEL HEIGHT.  PRESSURE AND 
C     SPECIFIC HUMIDITY ARE INTERPOLATED TO THIS LEVEL AND ALONG WITH
C     THE TEMPERATURE PROVIDE THE FREEZING LEVEL RELATIVE HUMIDITY.
C     IF THE ENTIRE ATMOSPHERE IS BELOW FREEZING, THE ROUTINE
C     USES SURFACE BASED FIELDS TO COMPUTE THE RELATIVE HUMIDITY.
C     
C     NOTE THAT IN POSTING FREEZING LEVEL DATA THE LFM LOOK-ALIKE FILE
C     (IE, GRID 26), WE PACK 273.15K AS THE FREEZING TEMPERATURE.  ALL
C     OTHER OUTPUT GRIDS USE 273.16K
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   93-06-10  RUSS TREADON - CORRECTED FREEZING LEVEL HEIGHTS TO BE
C                            WITH REPSECT TO MEAN SEA LEVEL, NOT  
C                            ABOVE GROUND LEVEL.
C   95-03-10  MIKE BALDWIN - GET HIGHEST FREEZING LEVEL.
C   98-06-15  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-17  MIKE BALDWIN - COMPUTE RH OVER ICE IF NECESSARY
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   00-01-04  JIM TUCCILLO - MPI VERSION
C
C USAGE:    CALL FRZLVL(ZFRZ,RHFRZ)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     ZFRZ     - ABOVE GROUND LEVEL FREEZING HEIGHT.
C     RHFRZ    - RELATIVE HUMIDITY AT FREEZING LEVEL.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - VRBLS
C                  LOOPS
C                  EXTRA
C                  PVRBLS
C                  MASKS
C                  MAPOT
C                  POSTVAR
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE/SET PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
C
C     DECLARE VARIABLES.
C
      REAL RHFRZ(IM,JM),ZFRZ(IM,JM),IWSFC(IM,JM),IWM1(IM,JM)
C
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "CTLBLK.comm"
C     
C*********************************************************************
C     START FRZLVL.
C
C
C     COMPUTE IW AT SURFACE IN CASE WE NEED TO COMPUTE RH OVER ICE
C

        CLIMIT =1.0E-20
        IWSFC=0.
C
        DO L=2,LM 
        DO J=JSTA,JEND
        DO I=1,IM
          IF (L.LE.LMH(I,J)) THEN
           IWM1(I,J)=IWSFC(I,J)
           IF(CWM(I,J,L).GT.CLIMIT) THEN
             IF(T(I,J,L).LT.258.15)THEN
               IWSFC(I,J)=1.
             ELSEIF(T(I,J,L).GE.273.15)THEN
               IWSFC(I,J)=0.
             ELSE
               IF(IWM1(I,J).EQ.1.0)IWSFC(I,J)=1.
             ENDIF
           ELSE
             IWSFC(I,J)=0.
           ENDIF
          ENDIF
        ENDDO
        ENDDO
        ENDDO
C     LOOP OVER HORIZONTAL GRID.
C     
CX      ZMIN = +999999.
CX      ZMAX = -999999.

      doout20: DO J=JSTA,JEND
      doin20: DO I=1,IM
         HTSFC    = FIS(I,J)*GI
         LLMH     = LMH(I,J)
         RHFRZ(I,J) = D00
         ZFRZ(I,J)  = HTSFC
C     
C        FIND THE HIGHEST LAYER WHERE THE TEMPERATURE
C        CHANGES FROM ABOVE TO BELOW FREEZING.
C     
         TSFC = SM(I,J)*THZ0(I,J)+(1.-SM(I,J))*THS(I,J)
         LICE=LLMH
         DO L = LLMH-1,1,-1
            IF (T(I,J,L).LE.TFRZ.AND.T(I,J,L+1).GT.TFRZ) LICE=L
         ENDDO
C     
C        CHECK IF FREEZING LEVEL IS AT THE GROUND.
C     
         IF (LICE.EQ.LLMH.AND.TSFC.LE.TFRZ) THEN
            ZFRZ(I,J) = HTSFC
            PSFC    = PD(I,J)+PT
            QSFC    = SM(I,J)*QZ0(I,J)+(1.-SM(I,J))*QS(I,J)
C
            TMT0=TSFC-273.16
            TMT15=AMIN1(TMT0,-15.)
            AI=0.008855
            BI=1.
            IF(TMT0.LT.-20.)THEN
              AI=0.007225
              BI=0.9674
            ENDIF
            QW=PQ0/PSFC
     1          *EXP(A2*(TSFC-A3)/(TSFC-A4))
            QI=QW*(BI+AI*AMIN1(TMT0,0.))
            QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
            IF(TMT0.LT.-15.)THEN
                QSAT=QI
            ELSEIF(TMT0.GE.0.)THEN
                QSAT=QINT
            ELSE
              IF(IWSFC(I,J).GT.0.0) THEN
                QSAT=QI
              ELSE
                QSAT=QINT
              ENDIF
            ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
            QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C
            RHSFC   = QSFC/QSAT
            RHSFC   = AMAX1(0.01,RHSFC)
            RHSFC   = AMIN1(RHSFC,1.0)
            RHFRZ(I,J)= RHSFC
C     
C        OTHERWISE, LOCATE THE FREEZING LEVEL ALOFT.
C
         ELSE IF (LICE.LT.LLMH) THEN
                  L=LICE
                  DELZ = D50*(ZINT(I,J,L)-ZINT(I,J,L+2))
                  ZL   = D50*(ZINT(I,J,L+1)+ZINT(I,J,L+2))
                  DELT = T(I,J,L)-T(I,J,L+1)
                  ZFRZ(I,J) = ZL+(TFRZ-T(I,J,L+1))/DELT*DELZ
C     
                  DZABV = ZFRZ(I,J)-ZL
                  DELQ  = Q(I,J,L)-Q(I,J,L+1)
                  QFRZ  = Q(I,J,L+1) + DELQ/DELZ*DZABV
                  QFRZ  = AMAX1(0.0,QFRZ)
C     
                  ALPL   = ALPINT(I,J,L+2)
                  ALPH   = ALPINT(I,J,L)
                  DELALP = ALPH - ALPL
                  DELZP  = ZINT(I,J,L)-ZINT(I,J,L+2)
                  DZFR   = ZFRZ(I,J) - ZINT(I,J,L+2)
                  ALPFRZ = ALPL + DELALP/DELZP*DZFR
                  PFRZ   = EXP(ALPFRZ)
                  QSFRZ  = PQ0/PFRZ
C     
                  RHZ      = QFRZ/QSFRZ
                  RHZ      = AMAX1(0.01,RHZ)
                  RHZ      = AMIN1(RHZ,1.0)
                  RHFRZ(I,J) = RHZ
C     
         ELSE
                  L=LICE
                  ZU      = D50*(ZINT(I,J,L)+ZINT(I,J,L+1))
                  ZL      = HTSFC
                  DELZ    = ZU-ZL
                  TSFC    = SM(I,J)*THZ0(I,J)+(1.-SM(I,J))*THS(I,J)
                  DELT    = T(I,J,L)-TSFC
                  ZFRZ(I,J) = ZL + (TFRZ-TSFC)/DELT*DELZ
C     
                  DZABV   = ZFRZ(I,J)-ZL
                  QSFC    = SM(I,J)*QZ0(I,J)+(1.-SM(I,J))*QS(I,J)
                  DELQ    = Q(I,J,L)-QSFC
                  QFRZ    = QSFC + DELQ/DELZ*DZABV
                  QFRZ    = AMAX1(0.0,QFRZ)
C     
                  ALPH    = ALPINT(I,J,L)
                  PSFC    = PD(I,J)+PT
                  ALPL    = ALOG(PSFC)
                  DELALP  = ALPH-ALPL
                  ALPFRZ  = ALPL + DELALP/DELZ*DZABV
                  PFRZ    = EXP(ALPFRZ)
                  QSFRZ   = PQ0/PFRZ
C
                  RHZ     = QFRZ/QSFRZ
                  RHZ     = AMAX1(0.01,RHZ)
                  RHZ     = AMIN1(RHZ,1.0)
                  RHFRZ(I,J)= RHZ
         ENDIF
C     
C              BOUND FREEZING LEVEL RH.  FREEZING LEVEL HEIGHT IS
C              MEASURED WITH RESPECT TO MEAN SEA LEVEL.
C
               RHFRZ(I,J) = AMAX1(0.01,RHFRZ(I,J))
               RHFRZ(I,J) = AMIN1(RHFRZ(I,J),1.00)
               ZFRZ(I,J)  = AMAX1(0.0,ZFRZ(I,J))
      END DO doin20
      END DO doout20
C     
C     END OF ROUTINE.
C     
      RETURN
      END

c**********************************************************************c
      SUBROUTINE CALVIS(QV,QC,QR,QI,QS,TT,PP,VIS)
c
c   This routine computes horizontal visibility at the
c   surface or lowest model layer, from qc, qr, qi, and qs.  
c   qv--water vapor mixing ratio (kg/kg)
c   qc--cloud water mixing ratio (kg/kg)
c   qr--rain water mixing ratio  (kg/kg)
c   qi--cloud ice mixing ratio   (kg/kg)
c   qs--snow mixing ratio        (kg/kg)
c   tt--temperature              (k)
c   pp--pressure                 (Pa)
c
c   If iice=0:
c      qprc=qr     qrain=qr and qclw=qc if T>0C
c      qcld=qc          =0          =0  if T<0C
c                  qsnow=qs and qclice=qc  if T<0C
c                       =0            =0   if T>0C
c   If iice=1:
c      qprc=qr+qs   qrain=qr and qclw=qc
c      qcld=qc+qi   qsnow=qs and qclice=qc
c
c   Independent of the above definitions, the scheme can use different
c   assumptions of the state of hydrometeors:
c        meth='d': qprc is all frozen if T<0, liquid if T>0
c        meth='b': Bocchieri scheme used to determine whether qprc
c           is rain or snow. A temperature assumption is used to
c           determine whether qcld is liquid or frozen.
c        meth='r': Uses the four mixing ratios qrain, qsnow, qclw,
c           and qclice
c
c   The routine uses the following
c   expressions for extinction coefficient, beta (in km**-1),
c   with C being the mass concentration (in g/m**3):
c
c      cloud water:  beta = 144.7 * C ** (0.8800)
c      rain water:   beta =  2.24 * C ** (0.7500)
c      cloud ice:    beta = 327.8 * C ** (1.0000)
c      snow:         beta = 10.36 * C ** (0.7776)
c
c   These expressions were obtained from the following sources:
c
c      for cloud water: from Kunkel (1984)
c      for rainwater: from M-P dist'n, with No=8e6 m**-4 and
c         rho_w=1000 kg/m**3
c      for cloud ice: assume randomly oriented plates which follow
c         mass-diameter relationship from Rutledge and Hobbs (1983)
c      for snow: from Stallabrass (1985), assuming beta = -ln(.02)/vis
c
c   The extinction coefficient for each water species present is
c   calculated, and then all applicable betas are summed to yield
c   a single beta. Then the following relationship is used to
c   determine visibility (in km), where epsilon is the threshhold
c   of contrast, usually taken to be .02:
c
c      vis = -ln(epsilon)/beta      [found in Kunkel (1984)]
c
C------------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "params"
      INCLUDE "CTLBLK.comm"
C
      REAL QV(IM,JM),QC(IM,JM),QI(IM,JM),QR(IM,JM),QS(IM,JM)
     1,    TT(IM,JM),PP(IM,JM),VIS(IM,JM)
      CHARACTER METH*1
C------------------------------------------------------------------
C------------------------------------------------------------------
      CELKEL=273.15
      TICE=CELKEL-10.
      COEFLC=144.7
      COEFLP=2.24
      COEFFC=327.8
      COEFFP=10.36
      EXPONLC=0.8800
      EXPONLP=0.7500
      EXPONFC=1.0000
      EXPONFP=0.7776
      CONST1=-LOG(.02)
      RHOICE=917.
      RHOWAT=1000.
C
      DO J=JSTA,JEND
      DO I=1,IM
c       IF(IICE.EQ.0)THEN
c         QPRC=QR
c         QCLD=QC
c         IF(TT.LT.CELKEL)THEN
c           QRAIN=0.
c           QSNOW=QPRC
c           QCLW=0.
c           QCLICE=QCLD
c         ELSE
c           QRAIN=QPRC
c           QSNOW=0.
c           QCLW=QCLD
c           QCLICE=0.
c         ENDIF
c       ELSE
          QPRC=QR(I,J)+QS(I,J)
          QCLD=QC(I,J)+QI(I,J)
          QRAIN=QR(I,J)
          QSNOW=QS(I,J)
          QCLW=QC(I,J)
          QCLICE=QI(I,J)
c       ENDIF
c       TV=VIRTUAL(TT,QV)
        TV=TT(I,J)*(H1+D608*QV(I,J))
        RHOAIR=PP(I,J)/(RD*TV)
c       IF(METH.EQ.'D')THEN
c         IF(TT.LT.CELKEL)THEN
c           VOVERMD=(1.+QV)/RHOAIR+(QPRC+QCLD)/RHOICE
c           CONCLC = 0.
c           CONCLP = 0.
c           CONCFC = QCLD/VOVERMD*1000.
c           CONCFP = QPRC/VOVERMD*1000.
c         ELSE
c           VOVERMD=(1.+QV)/RHOAIR+(QPRC+QCLD)/RHOWAT
c           CONCLC = QCLD/VOVERMD*1000.
c           CONCLP = QPRC/VOVERMD*1000.
c           CONCFC = 0.
c           CONCFP = 0.
c         ENDIF
c       ELSEIF(METH.EQ.'B')THEN
c         IF(TT.LT.TICE)THEN
c           VOVERMD=(1.+QV)/RHOAIR+(QPRC+QCLD)/RHOICE
c           CONCLC = 0.
c           CONCLP = 0.
c           CONCFC = QCLD/VOVERMD*1000.
c           CONCFP = QPRC/VOVERMD*1000.
c         ELSEIF(PRSNOW.GE.50.)THEN
c           VOVERMD=(1.+QV)/RHOAIR+QPRC/RHOICE+QCLD/RHOWAT
c           CONCLC = QCLD/VOVERMD*1000.
c           CONCLP = 0.
c           CONCFC = 0.
c           CONCFP = QPRC/VOVERMD*1000.
c         ELSE
c           VOVERMD=(1.+QV)/RHOAIR+(QPRC+QCLD)/RHOWAT
c           CONCLC = QCLD/VOVERMD*1000.
c           CONCLP = QPRC/VOVERMD*1000.
c           CONCFC = 0.
c           CONCFP = 0.
c         ENDIF
c       ELSEIF(METH.EQ.'R')THEN
          VOVERMD=(1.+QV(I,J))/RHOAIR+(QCLW+QRAIN)/RHOWAT+
     1            (QCLICE+QSNOW)/RHOICE
          CONCLC=QCLW/VOVERMD*1000.
          CONCLP=QRAIN/VOVERMD*1000.
          CONCFC=QCLICE/VOVERMD*1000.
          CONCFP=QSNOW/VOVERMD*1000.
c       ENDIF
        BETAV=COEFFC*CONCFC**EXPONFC+COEFFP*CONCFP**EXPONFP
     1       +COEFLC*CONCLC**EXPONLC+COEFLP*CONCLP**EXPONLP
     2       +1.E-10
        VIS(I,J)=1.E3*MIN(80.,CONST1/BETAV)   ! max of 80km
      ENDDO
      ENDDO
C
      RETURN
      END

      SUBROUTINE INTERP3(EGFUL,GDOUT,IMOT,JMOT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    INTERP3     BILINEAR INTERPOLATION
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23
C     
C ABSTRACT: 
C     THIS ROUTINE BILINEARLY INTERPOLATES DATA FROM A 
C     REGULAR INPUT GRID (FILLED E-GRID) TO A SPECIFIED
C     REGULAR OUTPUT GRID.  THE ROUTINE ASSUMES THE 
C     INTERPOLATION COEFFICIENTS HAVE BEEN PRECOMPUTED
C     EITHER EARLIER IN THE POST RUN BY SUBROUTINE GENBIL
C     OR READ IN WHILE IN SUBROUTINE READCNTRL2.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE INTERP
C   92-12-23  RUSS TREADON - BROKE INTERP INTO SEVERAL PIECES
C                            ONE OF WHICH BECAME THIS
C                            INTERPOLATION ROUTINE.
C   95-05-03  MIKE BALDWIN - ADDED BIT MAP ARRAY
C     
C USAGE:    CALL INTERP3(EGFUL,GDOUT,IMOT,JMOT)
C   INPUT ARGUMENT LIST:
C     EGFUL    - DATA ON FILLED E-GRID.
C     IMOT     - FIRST DIMENSION OF OUTPUT GRID.
C     JMOT     - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     GDOUT    - DATA INTERPOLATED TO OUTPUT GRID.
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       EXTEND   - FILLS MISSING VALUES ON OUTPUT GRID WITH 
C                  EITHER AN EXTENSION OF BORDER VALUES OR
C                  THE FIELD MEAN.
C     LIBRARY:
C       COMMON   - OPTIONS
C                  LLGRDS
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY Y-MP
C$$$  
C     
C     
C     INCLUDE DECLARED GRID DIMENSIONS.
C-----------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "parmout"
C-----------------------------------------------------------------
      PARAMETER (IMT=2*IM-1,JMT=JM)
C     
C     DECLARE VARIABLES.
C-----------------------------------------------------------------
      INTEGER IMOT,JMOT
      REAL EGFUL(IMT,JMT),GDOUT(IMOT,JMOT)
      DOUBLE PRECISION SUM
C-----------------------------------------------------------------
C     
C     INCLUDE COMMON.
      INCLUDE "OPTIONS.comm"
      INCLUDE "LLGRDS.comm"
      INCLUDE "BITMAP.comm"
      INCLUDE "IOUNIT.comm"
C
C     SET TOLERANCE LIMITS.
C     
      DATA MXPASS,SPVC,SMALL /2,1.E20,1.E-4/
C     
C******************************************************************
C     START INTERP3 HERE.
C     
C     BILINEAR INTERPOLATION OF FILLED E-GRID TO OUTPUT GRID.
C     THE WEIGHT ARRAYS W*(I,J) ARE PASSED THROUGH COMMON 
C     BLOCK LLGRDS.  WHILE INTERPOLATING, COMPUTE FIELD 
C     AVERAGE ON OUTPUT GRID.
C 
      SUM = 0.0
      NPTS=0
C
      GDOUT(1:IMOT,1:JMOT)=SPVC
C
!$omp  parallel do
!$omp& private(m,n)
      doout120: DO J = 1,JMOT
      doin120: DO  I = 1,IMOT
c       GDOUT(I,J) = SPVC
        IBMAP(I,J) = IWGT(I,J)
        IF (IWGT(I,J).EQ.1) THEN
          M = IEGRD(I,J)
          N = JEGRD(I,J) 
          GDOUT(I,J) = 
     X        WIJ(I,J)  *EGFUL(M,N)   +
     X        WIPJ(I,J) *EGFUL(M+1,N) +
     X        WIJP(I,J) *EGFUL(M,N+1) +
     X        WIPJP(I,J)*EGFUL(M+1,N+1) 
        ENDIF
       END DO doin120
       END DO doout120
!$omp end parallel do
C
      DO J=1,JMOT
      DO I=1,IMOT
        IF(IWGT(I,J).EQ.1)THEN
          SUM=SUM+GDOUT(I,J)
          NPTS=NPTS+1
        ENDIF
      ENDDO
      ENDDO
C
      IF(NPTS.EQ.0)THEN
        WRITE(STDOUT,*)'INTERP3:  OUTPUT GRID NPTS IS ZERO'
        RETURN
      ENDIF
      AVG=SUM/NPTS
C     
C     DONE WITH INTERPOLATION.  FILL MISSING VALUES WITH BOUNDARY VALUES.
C     
CHOU 20221230      CALL EXTEND(GDOUT,IMOT,JMOT,AVG,SPVC)
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE E2OUT(ITAG1,ITAG2,EGRID1,EGRID2,
     1     GRID1,GRID2,IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    E2OUT       INTRP E-GRID TO OUTPUT GRID
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-21       
C     
C ABSTRACT:  
C     THIS SUBROUTINE PERFORMS ALL ETA POST PROCESSOR 
C     INTERPOLATION/CONVERSION OF DATA ON THE E-GRID TO
C     THE OUTPUT GRID.  ADDITIONALLY, THE ROUTINE WILL
C     SMOOTH OR FILTER THE FIELD(S) AT ANY OF THREE 
C     STEPS IN THE ROUTINE.  DATA MAY BE SMOOTHED ON 
C     THE INPUT E-GRID, FILTERED ON A FILLED E-GRID, OR
C     FILTERED ON THE OUTPUT GRID.  VORTICITY FIELDS ARE
C     GIVEN AN ADDITIONAL HEAVY HANDED SMOOTHING TO PRODUCE
C     A PLEASING PRODUCT.  CONTROL OF SMOOTHING/FILTERING
C     IS VIA SWITCHES SET IN THE CONTROL FILE.  
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-21  RUSS TREADON
C   93-06-13  RUSS TREADON - ADDED INTERPOLATION TO LAT-LON GRID.
C   98-06-01  BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-05  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL E2OUT(ITAG1,ITAG2,EGRID1,EGRID2,
C                      GRID1,GRID2,IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     ITAG1    - INTEGER ID FOR DATA IN EGRID1
C     ITAG2    - INTEGER ID FOR DATA IN EGRID2
C     EGRID1   - FIRST FIELD ON E-GRID
C     EGRID2   - SECOND FIELD ON E-GRID
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID
C
C   OUTPUT ARGUMENT LIST: 
C     GRID1    - FIRST FIELD ON OUTPUT GRID
C     GRID2    - SECOND FIELD ON OUTPUT GRID
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       LOAD     - LOAD FILLED E-GRID INTO 2-D OUTPUT GRID
C       EFILL    - REPLACES MISSING VALUES ON E-GRID WITH FIELD MEAN
C       FILLH    - FILL MASS POINTS FOR VELOCITY POINT E-GRID
C       FILLV    - FILL VELOCITY POINTS FOR MASS POINT E-GRID
C       CETLIH4  - INTERPOLATE E-GRID TO OUPUT GRID CONSERVING
C                  THE AREA INTEGRAL OF THE INPUT FIELD OVER
C                  SPECIFIED SUB-GRIDS.
C       EUVGUV   - ROTATE ETA (U,V) TO OUTPUT GRID (U,V)
C       INTERP3  - BILINEAR INTERPOLATION TO OUTPUT GRID
C       P2FILTF  - SMOOTH MASS POINT DATA ON E-GRID
C       P2FLTVF  - SMOOTH VELOCITY POINT DATA ON E-GRID
C       EFILT    - HEAVY-HANDED MASS POINT SMOOTHER.  CURRENTLY
C                  HARDWIRED FOR USE ON VORITCITY FIELDS.
C       FILTER   - 25 POINT BLECK FILTER ON A REGULAR GRID.
C     LIBRARY:
C       COMMON   - OPTIONS
C                  LLGRDS
C                  RQSTFLD
C                  MASKS
C                  IOUNIT
C                  OUTGRD
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE ETA MODEL DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      PARAMETER (IMJM=IM*JM-JM/2,IMT=2*IM-1,JMT=JM,LP1=LM+1)
      PARAMETER (D00=0.0)
C     
C     DECLARE VARIABLES.
      CHARACTER*6  PROJ
      LOGICAL NORTH
      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT)
      REAL HFUL(IMT,JMT),UFUL(IMT,JMT),VFUL(IMT,JMT)
C     
C     INCLUDE COMMONS.
      INCLUDE "OPTIONS.comm"
      INCLUDE "LLGRDS.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "BITMAP.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "OUTGRD.comm"
      INCLUDE "CTLBLK.comm"
C
      common/jjt/time_output, time_e2out
      real(8) ist, rtc, time_output, time_e2out
C*****************************************************************************
C     START SUBROUTINE E2OUT.
C     
C
C     GATHER EGRID1 AND EGRID2
C
C      ist = rtc()
      CALL COLLECT(EGRID1)
c      print*,'writing egrid1 in E2OUT after calling COLLECT'
c      do i=1,im
c      do j=jsta,jend
c      print*,i,j,egrid1(i,j)
c      end do
c      end do
      CALL COLLECT(EGRID2)
C 
      IF ( ME .EQ. 0 ) THEN
C
C     ZERO OUTPUT GRIDS.
C
      GRID1(1:IMOUT,1:JMOUT)=D00
      GRID2(1:IMOUT,1:JMOUT)=D00
C     
C     GRID TYPE KGTYPE=90,92,94,96 IS OUTPUT ON THE STAGGERED MODEL
C     GRIDS. SIMPLY LOAD DATA INTO OUTPUT GRID ARRAYS.  IF WANTED,
C     SMOOTH DATA ON OUTPUT GRID.  (YOU NEVER KNOW!)
C    
   
      IF (KGTYPE.EQ.90.OR.KGTYPE.EQ.92.OR.
     X      KGTYPE.EQ.94.OR.KGTYPE.EQ.96.OR.
     X      KGTYPE.EQ.99.OR.KGTYPE.EQ.190.OR.KGTYPE.EQ.192
Cmp
     X      .OR.KGTYPE.EQ.194.OR.KGTYPE.EQ.196.or.KGTYPE.eq.255) THEN
cmp
c          call ps7
         CALL EFILL(EGRID1,IM,JM)
c         print*,'writing egrid1 in E2OUT after calling EFILL'
c         do i=1,im
c         do j=jsta,jend
c         print*,i,j,egrid1(i,j)
c         end do
c         end do
c           call ps8
         DO J=1,JM
         DO I=1,IM
           GRID1(I,J)=EGRID1(I,J)
           IBMAP(I,J)=1
         ENDDO
         ENDDO
cc          call ps9
         IF (ITAG2.GT.0) THEN
c              call psa
            CALL EFILL(EGRID2,IM,JM)
c
            DO J=1,JM
            DO I=1,IM
              GRID2(I,J)=EGRID2(I,J)
            ENDDO
            ENDDO
c              call psb
         ENDIF
         GOTO 400
      ENDIF
      
C     
C     IF SELECTED, SMOOTH DATA ON STAGGERED E-GRID.
C     
      ISMTH = ISMSTG(IGET(ITAG1))
      IF (IFILV(ITAG1).GT.0) THEN
         IF (ISMTH.GT.0) THEN
              CALL P2FILTF(ISMTH,HBM2,EGRID1)
         END IF
         IF ((ISMTH.GT.0).AND.((ITAG1.EQ.10).OR.(ITAG1.EQ.21))) THEN
              CALL EFILT(EGRID1)
         END IF
         IF(ITAG2.GT.0)THEN
           ISMTH = ISMSTG(IGET(ITAG2))
           IF(ISMTH.GT.0) THEN 
              CALL P2FILTF(ISMTH,HBM2,EGRID2)
           END IF
         ENDIF
      ELSE
         IF (ISMTH.GT.0) THEN
              CALL P2FLTVF(ISMTH,VBM2,EGRID1)
         END IF
         IF(ITAG2.GT.0)THEN
           ISMTH = ISMSTG(IGET(ITAG2))
           IF(ISMTH.GT.0) THEN
              CALL P2FLTVF(ISMTH,VBM2,EGRID2)
           END IF
         ENDIF
      ENDIF
C     
C     INTERPOLATE H-POINT FIELDS FROM STAGGERED E-GRID TO OUTPUT GRID.
C     
      IF ( IFILV(ITAG1).GT.0) THEN
C     
C        FILL H-POINT FIELD AT V POINTS.
c         call psd
         CALL FILLV(EGRID1,HFUL,IFLAG,IMT,JMT)
c          call pse
C     
C        IF REQUESTED, SMOOTH DATA ON FILLED E-GRID.
         ISMTH = ISMFUL(IGET(ITAG1))
         IF (ISMTH.GT.0) CALL FILTER(IMT,JMT,HFUL,ISMTH)
C     
C        INTERPOLATE TO OUTPUT GRID.
         IF ((KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1        .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
Cmp
     1 .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196.and.kgtype.ne.255))THEN
C     
C           INTERPOLATION FOR GENERIC FIELDS.
c       call ps1
          if (itag1.eq.050) then
            CALL OUT_MASKS(HFUL,GRID1,IMOUT,JMOUT)
C             CALL INTERP3(HFUL,GRID1,IMOUT,JMOUT)
C               where(GRID1> 0.5)
C                 GRID1=1.      
C               else where
C                 GRID1=0 
C               end where
          else
            CALL INTERP3(HFUL,GRID1,IMOUT,JMOUT)
          endif
C
C           U-V FIELDS ORGINALLY AT H POINTS NEED TO BE ROTATED.
            IF ( (ITAG1.EQ.056).OR.(ITAG1.EQ.057).OR.
     X           (ITAG1.EQ.060).OR.(ITAG1.EQ.061).OR.
     X           (ITAG1.EQ.064).OR.(ITAG1.EQ.065).OR.
     X           (ITAG1.EQ.073).OR.(ITAG1.EQ.074).OR.
     X           (ITAG1.EQ.095).OR.(ITAG1.EQ.096) ) THEN
               CALL FILLV(EGRID2,VFUL,IFLAG,IMT,JMT)
               IF(ITAG2.GT.0)THEN
                 ISMTH = ISMFUL(IGET(ITAG2))
                 IF(ISMTH.GT.0)CALL FILTER(IMT,JMT,VFUL,ISMTH)
               ENDIF
               CALL EUVGUV(HFUL,VFUL,FVTLON,IMT,JMT,EVLAT,
     X              EVLON,ALATVT,ALONVT,NORTH,PROJ)
c               call ps3
               CALL INTERP3(HFUL,GRID1,IMOUT,JMOUT)
               CALL INTERP3(VFUL,GRID2,IMOUT,JMOUT)
            ENDIF

C     
C           PRECIPITATION FIELDS USE AREA CONSERVING INTERPOLATION.
c            call ps4
            IF ( (ITAG1.EQ.033).OR.(ITAG1.EQ.034).OR.
     X           (ITAG1.EQ.087) )
     X           CALL CETLIH4(EGRID1,GRID1,IMOUT,JMOUT,KSB,IOFFS)
C     
C        OUTPUT ON FILLED E-GRID REQUIRES NO INTERPOLATION.
         ELSE
            DO J=1,JMT
            DO I=1,IMT
              GRID1(I,J)=HFUL(I,J)
              IBMAP(I,J)=1
            ENDDO
            ENDDO
C
            IF ( (ITAG1.EQ.056).OR.(ITAG1.EQ.057).OR.
     X           (ITAG1.EQ.060).OR.(ITAG1.EQ.061).OR.
     X           (ITAG1.EQ.064).OR.(ITAG1.EQ.065).OR.
     X           (ITAG1.EQ.073).OR.(ITAG1.EQ.074).OR.
     X           (ITAG1.EQ.095).OR.(ITAG1.EQ.096) ) THEN
               CALL FILLV(EGRID2,VFUL,IFLAG,IMT,JMT)
               IF(ITAG2.GT.0)THEN
                 ISMTH = ISMFUL(IGET(ITAG2))
                 IF(ISMTH.GT.0)CALL FILTER(IMT,JMT,VFUL,ISMTH)
               ENDIF
C
               DO J=1,JMT
               DO I=1,IMT
                 GRID2(I,J)=VFUL(I,J)
               ENDDO
               ENDDO
C
            ENDIF
         ENDIF
C     
C     NOW HANDLE FIELDS AT V-POINTS.
C
      ELSE
         IF (ITAG1.NE.053.AND.ITAG1.NE.162) THEN 
            CALL FILLH(EGRID1,UFUL,IMT,JMT)
            CALL FILLH(EGRID2,VFUL,IMT,JMT)
            ISMTH = ISMFUL(IGET(ITAG1))
            IF (ISMTH.GT.0) CALL FILTER(IMT,JMT,UFUL,ISMTH)
            IF(ITAG2.GT.0)THEN
              ISMTH = ISMFUL(IGET(ITAG2))
              IF(ISMTH.GT.0)
     X           CALL FILTER(IMT,JMT,VFUL,ISMTH)
            ENDIF
C
            IF ((KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1          .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
Cmp
     1    .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196.and.KGTYPE.NE.255))THEN
               CALL EUVGUV(UFUL,VFUL,FVTLON,IMT,JMT,
     X              EVLAT,EVLON,ALATVT,ALONVT,NORTH,PROJ)
               CALL INTERP3(UFUL,GRID1,IMOUT,JMOUT)
               CALL INTERP3(VFUL,GRID2,IMOUT,JMOUT)
            ELSE
C
               DO J=1,JMT
               DO I=1,IMT
                 GRID1(I,J)=UFUL(I,J)
                 IBMAP(I,J)=1
               ENDDO
               ENDDO
C
               DO J=1,JMT
               DO I=1,IMT
                 GRID2(I,J)=VFUL(I,J)
               ENDDO
               ENDDO
C
            ENDIF
         ELSE
            CALL FILLH(EGRID1,HFUL,IMT,JMT)
            ISMTH = ISMFUL(ITAG1)
            IF (ISMTH.GT.0) CALL FILTER(IMT,JMT,HFUL,ISMTH)
            IF ((KGTYPE.LT.90).OR.(KGTYPE.GT.97
     1          .AND.KGTYPE.NE.99.AND.KGTYPE.NE.190.AND.KGTYPE.NE.192
Cmp
     1   .AND.KGTYPE.NE.194.AND.KGTYPE.NE.196.and.KGTYPE.ne.255))THEN
c        call ps6
               CALL INTERP3(HFUL,GRID1,IMOUT,JMOUT)
            ELSE
               DO J=1,JMT
               DO I=1,IMT
                 GRID1(I,J)=HFUL(I,J)
                 IBMAP(I,J)=1
               ENDDO
               ENDDO
            ENDIF
         ENDIF
      ENDIF
C     
C     ZERO FILLED EGRID ARRAYS.
C
      HFUL(1:IMT,1:JMT) = 0.0
      UFUL(1:IMT,1:JMT) = 0.0
      VFUL(1:IMT,1:JMT) = 0.0
C     
C     IF SELECTED, APPLY SMOOTHER TO OUTPUT GRID(S).
C     
 400  CONTINUE
C
      IF(ITAG1.GT.0)THEN
        IF(IGET(ITAG1).GT.0)THEN
          ISMTH=ISMOUT(IGET(ITAG1))
          IF(ISMTH.GT.0)CALL FILTER(IMOUT,JMOUT,GRID1,ISMTH)
        ENDIF
      ENDIF
C
      IF(ITAG2.GT.0)THEN
        IF(IGET(ITAG2).GT.0)THEN
          ISMTH=ISMOUT(IGET(ITAG2))
          IF(ISMTH.GT.0)CALL FILTER(IMOUT,JMOUT,GRID2,ISMTH)
        ENDIF
      ENDIF
C     
      END IF
C
C     SCATTER EGRID1 AND EGRID2
C
c      if(itag1.eq.23)then
c      print*,'printing grid1 before calling DIST'
c      do i=1,im
c      do j=jsta,jend
c       print*,i,j,grid1(i,j)
c      end do
c      end do 
c      end if
c      CALL DIST(GRID1)
c      CALL DIST(GRID2)
c      if(itag1.eq.23)then
c      print*,'printing grid1 after calling DIST'
c      do i=1,im
c      do j=jsta,jend
c       print*,i,j,grid1(i,j)
c      end do
c      end do
c      end if
      CALL DIST(EGRID1)
      CALL DIST(EGRID2)
C
C      time_e2out = time_e2out + rtc() - ist
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE TTBLEX(TREF,TTBL,ITB,JTB,KARR,PDSL,AETAL,HTML
     1,                 PT,PL,QQ,PP,RDP,THE0,STHE,RDTHE,THESP
     2,                 IPTB,ITHTB)
CFPP$ NOCONCUR R
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    TTBLEX      COMPUTES T ALONG A MOIST ADIABAT
C   PRGRMMR: BLACK           ORG: W/NP2      DATE: ??-??-??
C
C ABSTRACT:
C     THIS ROUTINE COMPUTES THE TEMPERATURE ALONG A MOIST
C     ADIABAT GIVEN THE SATURATION POTENTIAL TEMPERATURE
C     AND THE PRESSURE
C   .
C
C PROGRAM HISTORY LOG:
C   ??-??-??  T BLACK - ORIGINATOR
C   98-06-12  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C
C   OUTPUT FILES:
C     NONE
C
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C----------------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "CTLBLK.comm"
C----------------------------------------------------------------------
                             D I M E N S I O N
     1 TREF(IM,JM),TTBL(JTB,ITB),KARR(IM,JM),PDSL(IM,JM),HTML(IM,JM)
     2,QQ(IM,JM),PP(IM,JM),THE0(ITB),STHE(ITB),THESP(IM,JM)
     3,IPTB(IM,JM),ITHTB(IM,JM)
C-----------------------------------------------------------------------
!$omp  parallel do
!$omp& private(bthe00k,bthe10k,bthk,ip,iptbk,ith,pk,sthe00k,sthe10k,
!$omp&         sthk,t00k,t01k,t10k,t11k,tpk,tthk)
      doout500: DO J=JSTA_M,JEND_M
      doin500: DO I=2,IM-1
      IF(KARR(I,J).GT.0)THEN
C--------------SCALING PRESSURE & TT TABLE INDEX------------------------
        PK=PDSL(I,J)*AETAL+PT
        TPK=(PK-PL)*RDP
        QQ(I,J)=TPK-AINT(TPK)
        IPTB(I,J)=INT(TPK)+1
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
        IF(IPTB(I,J).LT.1)THEN
          IPTB(I,J)=1
          QQ(I,J)=0.
        ENDIF
C
        IF(IPTB(I,J).GE.ITB)THEN
          IPTB(I,J)=ITB-1
          QQ(I,J)=0.
        ENDIF
C--------------BASE AND SCALING FACTOR FOR THE--------------------------
        IPTBK=IPTB(I,J)
        BTHE00K=THE0(IPTBK)
        STHE00K=STHE(IPTBK)
        BTHE10K=THE0(IPTBK+1)
        STHE10K=STHE(IPTBK+1)
C--------------SCALING THE & TT TABLE INDEX-----------------------------
        BTHK=(BTHE10K-BTHE00K)*QQ(I,J)+BTHE00K
        STHK=(STHE10K-STHE00K)*QQ(I,J)+STHE00K
        TTHK=(THESP(I,J)-BTHK)/STHK*RDTHE
        PP(I,J)=TTHK-AINT(TTHK)
        ITHTB(I,J)=INT(TTHK)+1
C--------------KEEPING INDICES WITHIN THE TABLE-------------------------
        IF(ITHTB(I,J).LT.1)THEN
          ITHTB(I,J)=1
          PP(I,J)=0.
        ENDIF
C
        IF(ITHTB(I,J).GE.JTB)THEN
          ITHTB(I,J)=JTB-1
          PP(I,J)=0.
        ENDIF
C--------------TEMPERATURE AT FOUR SURROUNDING TT TABLE PTS.------------
        ITH=ITHTB(I,J)
        IP=IPTB(I,J)
        T00K=TTBL(ITH  ,IP  )
        T10K=TTBL(ITH+1,IP  )
        T01K=TTBL(ITH  ,IP+1)
        T11K=TTBL(ITH+1,IP+1)
C--------------PARCEL TEMPERATURE-------------------------------------
        TREF(I,J)=(T00K+(T10K-T00K)*PP(I,J)+(T01K-T00K)*QQ(I,J)
     1           +(T00K-T10K-T01K+T11K)*PP(I,J)*QQ(I,J))*HTML(I,J)
      ENDIF
      END DO doin500
      END DO doout500
C
      RETURN
      END
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

      SUBROUTINE CALSTRM(Z1D,STRM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALSTRM     COMPUTES GEO STREAMFUNCTION
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES THE GEOSTROPHIC STREAMFUNCTION,
C     PSI, FROM THE PASSED GEOPOTENTIAL HEIGHT FIELD, Z.  
C     THE FORMULA USED IS PSI = G*Z/F0, WHERE G IS THE
C     GRAVITATIONAL ACCELERATION CONSTANT AND F0 IS A 
C     CONSTANT CORIOLIS PARAMETER.  F0 IS SET TO BE THE
C     VALUE OF THE CORIOLIS PARAMETER ALONG THE CENTRAL
C     (GEODETIC) LATITUDE (IE, TPH0D) OF THE MODEL GRID.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   98-06-08  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-05  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL CALSTRM(Z1D,STRM)
C   INPUT ARGUMENT LIST:
C     Z1D      - GEOPOTENTIAL HEIGHT (M)
C
C   OUTPUT ARGUMENT LIST: 
C     STRM     - GEOSTROPHIC STREAMFUNCTION
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MAPOT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     
C     
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     
      INCLUDE "parmeta"
      INCLUDE "params"
      PARAMETER (OMEGA=7.292E-5,TWOMG=2*OMEGA)
C
C     DECLARE VARIABLES.
C     
      LOGICAL FIRST,OLDRD,RESTRT,RUN,SIGMA,STRD
      REAL Z1D(IM,JM),STRM(IM,JM)
C     
C     DECLARE COMMONS.
      INCLUDE "MAPOT.comm"
      INCLUDE "CTLBLK.comm"
C     
C***************************************************************************
C     START CALSTRM HERE.
C     
C     COMPUTE CORIOLIS PARAMETER ALONG CENTRAL GEODETIC 
C     OF STAGGERED E-GRID LATITUDE.
      F0   = TWOMG*SIN(TPH0D*DTR)
      GOF0 = G/F0
C     
C     COMPUTE GEOSTROPHIC STREAMFUNCTION.
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        STRM(I,J)=GOF0*Z1D(I,J)
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
      RETURN
      END

      SUBROUTINE FILTER (IMX,JMX,ZI,IPASS)                            
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK                                    
C                .      .    .                                       .  
C SUBPROGRAM:    FILTER      FILTERS THE ARRAY ZI                       
C   PRGMMR: DIMEGO           ORG: W/NP22     DATE: 86-07-18             
C                                                                       
C ABSTRACT: FILTERS AN ARRAY USING A 25PT BLECK FILTER IN THE           
C   INTERIOR OF THE DOMAIN                                              
C                                                                       
C PROGRAM HISTORY LOG:                                                  
C   86-07-18  G DIMEGO                                                  
C   88-09-23  B SCHMIDT ADDED THE DOCBLOCK                              
C   90-11-27  G DIMEGO LEFT Z AS INTERNAL WORK ARRAY ON CRAY
C   93-06-21  R TREADON STREAMLINED CODE
C                                                                       
C USAGE:    CALL FILTER (IMX, JMX, ZI, IPASS)                        
C   INPUT ARGUMENT LIST:                                                
C     ZI       - ARRAY CONTAINING THE ARRAY TO BE FILTERED              
C     IMX      - I DIMENSION OF ARRAYS ZI AND Z                  
C     JMX      - J DIMENSION OF ARRAYS ZI AND Z                  
C     IPASS    - NUMBER OF PASSES THROUGH THE FILTER                    
C                                                                       
C   OUTPUT ARGUMENT LIST:                                               
C     ZI       - ARRAY CONTAINING THE FILTERED FIELD                    
C                                                                       
C ATTRIBUTES:                                                           
C   LANGUAGE: STANDARD FORTRAN                                          
C   MACHINE:                                                            
C                                                                       
C$$$                                                                    
      DIMENSION ZI(IMX,JMX),Z(IMX,JMX)                                
      LOGICAL BND,FST,SMTH                                              
C
      LI=IMX                                                            
      LJ=JMX                                                            
      I1 = 1                                                            
      J1 = 1                                                            
      I2 = I1 + 1                                                       
      J2 = J1 + 1                                                       
      I3 = I2 + 1                                                       
      LI1 = LI - 1                                                      
      LJ1 = LJ - 1                                                      
      LI2 = LI - 2                                                      
      LJ3 = LJ - 3                                                      
      LI4 = LI - 4                                                      
      LJ4 = LJ - 4                                                      
      LI5 = LI - 5                                                      
      IPC = IPASS                                                       
C
      DO 105 IP = 1,IPC                                                 
C **  FILTER REST OF INTERIOR POINTS   25-PT BLECK FILTER               
!$omp  parallel do
!$omp& private(i,ii,im1,im2,ip1,ip2,j,jm1,jm2,jp1,jp2)
         DO 102 JJ = J1,LJ4                                             
            JM2=JJ                                                      
            JM1=JJ+1                                                    
            J  =JJ+2                                                    
            JP1=JJ+3                                                    
            JP2=JJ+4                                                    
            DO 101 II = I1,LI4                                          
               IM2=II                                                   
               IM1=II+1                                                 
               I  =II+2                                                 
               IP1=II+3                                                 
               IP2=II+4                                                 
               Z(I,J) = 0.279372 * ZI(I,J)                              
     +   +0.171943*((ZI(IM1,J  )+ZI(I  ,JM1))+(ZI(IP1,J  )+ZI(I  ,JP1)))
     +   -0.006918*((ZI(IM2,J  )+ZI(I  ,JM2))+(ZI(IP2,J  )+ZI(I  ,JP2)))
     +   +0.077458*((ZI(IM1,JM1)+ZI(IP1,JP1))+(ZI(IP1,JM1)+ZI(IM1,JP1)))
     +   -0.024693*((ZI(IM1,JM2)+ZI(IP1,JM2))+(ZI(IM2,JM1)+ZI(IP2,JM1)) 
     +             +(ZI(IM2,JP1)+ZI(IP2,JP1))+(ZI(IM1,JP2)+ZI(IP1,JP2)))
     +   -0.01294 *((ZI(IM2,JM2)+ZI(IP2,JM2))+(ZI(IM2,JP2)+ZI(IP2,JP2)))
  101       CONTINUE                                                    
  102    CONTINUE                                                       
C
!$omp  parallel do
!$omp& private(i,j)
         DO 104 JJ= J1,LJ4                                              
            J = JJ + 2                                                  
            DO 103 II= I1,LI4                                           
               I = II + 2                                               
               ZI(I,J) = Z(I,J)                                         
 103        CONTINUE                                                    
 104     CONTINUE                                                       
C
 105  CONTINUE                                                          
      RETURN                                                            
      END                                                               

      SUBROUTINE GD2TLL(GDLAT,GDLON,GDTLAT,GDTLON,IMOUT,JMOUT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GD2TLL      COMPUTE TRANSFORMED (LAT,LON)
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES THE TRANSFORMED LATITUDE OF (LAT,
C     LON) OF OUTPUT GRID POINTS.  THE TRANSFORMED (LAT,LON)
C     ARE WITH RESPECT TO THE INPUT E-GRID.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE CGTLL IN ETAPACKC
C   92-12-23  RUSS TREADON - GENERALIZED TO HANDLE VARIABLE
C                               OUTPUT GRIDS.
C     
C USAGE:    CALL GD2TLL(GDLAT,GDLON,GDTLAT,GDTLON,IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     GDLAT    - GEODETIC LATITUDE OF OUTPUT GRID POINTS.
C     GDLON    - GEODETIC LONGTUDE OF OUTPUT GRID POINTS.
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     GDTLAT   - TRANSFORMED LATITUDE OF OUTPUT GRID POINTS.
C     GDTLON   - TRANSFORMED LONGITUDE OF OUTPUT GRID POINTS.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EGRID
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE ETA GRID DIMENSIONS
      INCLUDE "parmeta"
      INCLUDE "parmout"
      PARAMETER (LP1=LM+1)
C
C     SET CONVERSION CONSTANTS.
      PARAMETER (R2D=57.29578,D2R=1./R2D)
C
C     DECLARE VARIABLES AND COMMONS.

      LOGICAL  NORTH
      REAL GDLAT(IMX,JMX), GDLON(IMX,JMX)
      REAL GDTLAT(IMX,JMX), GDTLON(IMX,JMX)
C     
C     INCLUDE ETA GRID SPECIFICATIONS IN COMMON MAPOT.
      INCLUDE "EGRID.comm"
C     
C     DECLARE EQUIVALENCES.
      EQUIVALENCE (YLATC,ALONVT), (DPHI, POLEI)
      EQUIVALENCE (WLONC, POLEJ), (DLAM,XMESHL)
C     
C*******************************************************************
C     START GD2TLL HERE.
C     
C     SET CONSTANTS.
C     
      ELAM0=WLONC+360.
      EPHI0=YLATC
      SPHI0=SINPH0
      CPHI0=COSPH0
C     
C     LOOP TO COMPUTE TRANSFORMED (LAT,LON).
C
      DO 20 J = 1,JMOUT
         DO 10 I = 1,IMOUT
            WLON  = GDLON(I,J)
            YLAT  = GDLAT(I,J)
            RELM  = (WLON-ELAM0)*D2R
            SRLM  = SIN(RELM)
            CRLM  = COS(RELM)
            APH   = YLAT*D2R
            SPH   = SIN(APH)
            CPH   = COS(APH)
            CC    = CPH*CRLM
            ANUM  = -CPH*SRLM
            DENOM = CPHI0*CC+SPHI0*SPH
            TLM   = ATAN2(ANUM,DENOM)/D2R
            TPH   = ASIN(CPHI0*SPH-SPHI0*CC)/D2R
            GDTLAT(I,J) = TPH
            GDTLON(I,J) = TLM
 10      CONTINUE
 20   CONTINUE
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE RDRST2D(ARR,IM,JM,LUNIT,NREC0,NREC1,NF,PRE)
C
C------------------------------------------------------------
      PARAMETER (KM=7)
C
      INCLUDE "CTLBLK.comm"
C
      REAL ARR(IM,JM),RDDUM(IM,JM)
C
      INTEGER IDATx(3)
      LOGICAL RUN,PRE
      CHARACTER LABEL*32
C------------------------------------------------------------
C*** 
C***  ARR: ARRAY NEEDED FROM RESTRT FILE
C***
C***  RDDUM: DUMMY ARRAY USED TO READ THE RESTRT FILE
C***
C***  IM,JM: HORIZONTAL DIMENSIONS OF ARR AND RDDUM
C***
C***  KM: VERTICAL DIMENSION OF RDDUM; THIS IS THE MAXIMUM
C***      NUMBER OF 2-D ARRAYS THAT OCCUR ON ANY SINGLE
C***      RECORD OF THE FILE
C***
C***  LUNIT: UNIT NUMBER OF THE RESTRT FILE BEING READ
C***
C***  NREC0: THE RECORD AFTER WHICH THE POINTER IS SET
C***         WHEN THIS ROUTINE IS ENTERED
C***
C***  NREC1: THE NUMBER OF THE RECORD FROM WHICH 
C***         WE WANT TO EXTRACT
C***
C***  NF: SINCE THERE MAY BE MORE THAN ONE 2-D ARRAY IN EACH
C***      RECORD, THIS IS THE NUMBER OF THE FIELD WE ACTUALLY
C***      WANT IN THE GIVEN RECORD; NF CANNOT EXCEED KM
C***
C***  PRE: A LOGICAL FLAG INDICATING WHETHER OR NOT TO READ
C***       THE EXTRA WORDS WHICH OCCUR ON SOME OF THE RECORDS
C***       PRECEDING THE 2-D ARRAYS
C*** 
C------------------------------------------------------------

      print *, ' *** IN RDRST2D ***'
      NDIF=NREC1-NREC0
C***
C***  GO TO START OF THE DESIRED RECORD
C***
      IF(NDIF.GT.0)THEN
        DO KOUNT=1,NDIF
          READ(LUNIT)
        ENDDO
      ELSEIF(NDIF.LT.0)THEN
        NDIF=-NDIF
        DO KOUNT=1,NDIF
          BACKSPACE LUNIT
        ENDDO
      ENDIF
C***
C***  READ THE ARRAY FROM THIS RECORD
C***
      IF(PRE)THEN
        READ(LUNIT)RUN,IDATx,IHRST,NTSD,LABEL,
     1              (((RDDUM(I,J),I=1,IM),J=1,JM),K=1,NF)
      ELSE
        READ(LUNIT)(((RDDUM(I,J),I=1,IM),J=1,JM),K=1,NF)
      ENDIF
C
      CALL EXTRACT(RDDUM, ARR )
c     DO J=JSTA,JEND
c     DO I=1,IM
c       ARR(I,J)=RDDUM(I,J)
c     ENDDO
c     ENDDO
c
      RETURN
      END

      SUBROUTINE COEFI(ARRX,IDIM,JDIM,I,J,C1,C2,C3,C4)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    COEFI       INTRP WGTS FOR FILLED E-GRID ROWS
C   PRGRMMR: TREADON         ORG: W/NP2 
C     
C ABSTRACT:  
C     THIS ROUTINE RETURNS WEIGHTED E-GRID VALUES FOR CUBIC
C     INTERPOLATION OF ROWS ON FILLED E-GRID.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-05-12  RUSS TREADON
C     
C USAGE:    CALL COEFI(ARRX,IDIM,JDIM,I,J,C1,C2,C3,C4)
C   INPUT ARGUMENT LIST:
C     ARRX     - ARRAY TO CONTAIN FILLED E-GRID.
C     IDIM     - 2*IM-1, FIRST DIMENSION OF ARRX
C     JDIM     - JM, SECOND DIMENSION OF ARRX
C     I        - TARGET POINT I INDEX
C     J        - TARGET POINT J INDEX
C
C   OUTPUT ARGUMENT LIST: 
C     C1,C2,C3,C4 - WEIGHTED FILLED E-GRID VALUES.
C
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
      PARAMETER (C11=.166667,C12=-.5,C13=.5,C14=-.166667)
      PARAMETER (C21=-1.,C22=3.5,C23=-4.,C24=1.5)
      PARAMETER (C31=1.833333,C32=-7.,C33=9.5,C34=-4.333333)
      PARAMETER (C41=-1.,C42=4.,C43=-6.,C44=4.)
      DIMENSION ARRX(IDIM,JDIM)
      C1=C11*ARRX(I+6,J)+C12*ARRX(I+4,J)+C13*ARRX(I+2,J)+C14*ARRX(I,J)
      C2=C21*ARRX(I+6,J)+C22*ARRX(I+4,J)+C23*ARRX(I+2,J)+C24*ARRX(I,J)
      C3=C31*ARRX(I+6,J)+C32*ARRX(I+4,J)+C33*ARRX(I+2,J)+C34*ARRX(I,J)
      C4=C41*ARRX(I+6,J)+C42*ARRX(I+4,J)+C43*ARRX(I+2,J)+C44*ARRX(I,J)
      RETURN
      END

      SUBROUTINE EXCH2(A)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    EXCH2       EXCHANGE TWO HALO ROWS
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     EXCHANGE TWO HALO ROWS
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C
C USAGE:    CALL EXCH2(A)
C   INPUT ARGUMENT LIST:
C      A - ARRAY TO HAVE HALOS EXCHANGED
C
C   OUTPUT ARGUMENT LIST:
C      A - ARRAY WITH HALOS EXCHANGED
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_SENDRECV
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - CTLBLK.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
      include "parmeta"
      include "CTLBLK.comm"
      include 'mpif.h'
      real a ( im, jm )
      integer status(MPI_STATUS_SIZE)
c
      if ( num_procs .eq. 1 ) return
C
      call mpi_sendrecv(a(1,jend-1),2*im,MPI_REAL,iup,1,
     &                  a(1,jsta-2),2*im,MPI_REAL,idn,1,
     &                  MPI_COMM_WORLD,status,ierr)
      if ( ierr .ne. 0 ) then
         print *, ' problem with first sendrecv in exch2, ierr = ',ierr
         call exit(2)
      end if
      call mpi_sendrecv(a(1,jsta  ),2*im,MPI_REAL,idn,1,
     &                  a(1,jend+1),2*im,MPI_REAL,iup,1,
     &                  MPI_COMM_WORLD,status,ierr)
      if ( ierr .ne. 0 ) then
         print *, ' problem with second sendrecv in exch2, ierr = ',ierr
         call exit(2)
      end if
c
      end

      SUBROUTINE GENLL(GDLAT,GDLON)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GENLL       COMPUTE (LAT,LON) FOR OUTPUT GRID
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     GIVEN THE STANDARD NMC GRID SPECIFICATIONS THIS ROUTINE
C     COMPUTES THE GEODETIC (LAT,LON) OF THE GRID POINTS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE CGTLL IN ETAPACKC
C   93-02-26  RUSS TREADON  - EXTRACTED THIS CODE FROM CGTLL
C                             AND GENERALIZED TO HANDLE
C                             VARIOUS OUTPUT GRIDS.
C   93-06-13  RUSS TREADON  - ADDED LOLA PROJECTION.
C     
C USAGE:    CALL GENLL(GDLAT,GDLON)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     GDLAT    - GEODETIC LATITUDE OF OUTPUT GRID POINTS.
C     GDLON    - GEODETIC LONGITUDE OF OUTPUT GRID POINTS.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - OUTGRD
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE/SET PARAMETERS.
C
      INCLUDE "parmout"
C     
C     DECLARE VARIABLES.
C
      LOGICAL NORTH
      CHARACTER*6 PROJ
      REAL LAMBDA
      REAL GDLAT(IMX,JMX), GDLON(IMX,JMX)
C     
C     INCLUDE OUTPUT GRID COMMON BLOCK.
      INCLUDE "OUTGRD.comm"
C
C     SET EARTH RADIUS.
      DATA EARTHR /6371.2/
C     
C*********************************************************************
C     START GENLL HERE.
C
C     SET CONSTANTS.
      PI     = ACOS(-1.)
      HALFPI = PI/2.
      TWOPI  = 2.*PI
      D2R    = PI/180.
      R2D    = 1./D2R
C     
C     CASE 1:  POLAR STEROGRAPHIC PROJECTION.
C     
      IF (INDEX(PROJ,'POLA').NE.0) THEN
C
C        COMPUTE GEODETIC (LAT,LON) FOR OUTPUT GRID.
         DO 20 J = 1,JGOUT
            DO 10 I = 1,IGOUT
               XI   = REAL(I)
               YJ   = REAL(J)
               DELX = XI-POLEI
               DELY = YJ-POLEJ
               R2   = DELX*DELX+DELY*DELY
C
C              VARIABLES YLAT AND WLON ARE THE GEODETIC 
C              LATITUDE (POSITIVE NORTH) AND LONGITUDE 
C              (POSITIVE WEST) OF THE OUTPUT GRID POINTS.
C
               IF (R2.NE.0.) THEN
                  TLON = R2D*ATAN2(DELY,DELX)
                  IF (NORTH) THEN
                     WLON = ALONVT-90.-TLON
                     YLAT = ASIN((GI2-R2)/(GI2+R2))*R2D
                  ELSE
                     WLON = ALONVT+90.+TLON
                     YLAT = -ASIN((GI2-R2)/(GI2+R2))*R2D
                  ENDIF
                  IF (WLON.GT.360.) WLON = WLON-360.
                  IF (WLON.LT.0.)   WLON = WLON+360.
               ELSE
                  YLAT = 90.
                  IF (.NOT.NORTH) YLAT = -90.
                  WLON = ALONVT
               ENDIF
               GDLAT(I,J) = YLAT
               GDLON(I,J) = WLON
 10         CONTINUE
 20      CONTINUE
C     
C     CASE II:  LATITUDE-LONGITUDE PROJECTION.
C     
      ELSEIF (INDEX(PROJ,'LOLA').NE.0) THEN
         SWLAT = ALONVT
         SWLON = POLEJ
         DO 40 J = 1,JGOUT
            DLAT = (J-1)*POLEI
            DO 30 I = 1,IGOUT
               DLON = (I-1)*XMESHL
               GDLAT(I,J) = SWLAT + DLAT
CGSM               GDLON(I,J) = SWLON - DLON
               GDLON(I,J) = 9.412958 - DLON
 30         CONTINUE
 40      CONTINUE
C
C     CASE III:  LAMBERT CONFORMAL (TANGENT) PROJECTION).
C
      ELSEIF (INDEX(PROJ,'LMBC').NE.0) THEN
C
C        CONVERT WEST LONGITUDE TO EAST.
         POLEJE  = -1.*POLEJ
         ALONVTE = -1.*ALONVT
C
C        COMPUTE TANGENT CONE CONSTANT AND FACTOR A.
         PSIT = HALFPI - ABS(ALATVT*D2R)
         CONE = COS(PSIT)
         A    = EARTHR/CONE
C
C        COMPUTE LINEAR COORDINATES CORRESPONDING TO
C        GRIDPOINT (1,1)=(POLEI,POLEJE).
         PHI    = POLEI*D2R
         LAMBDA = POLEJE*D2R
         IF (NORTH) THEN
            PSI = HALFPI - PHI
         ELSE
            PSI = HALFPI + PHI
         ENDIF
         TERMA  = PSI/2.
         TERMB  = CONE*(LAMBDA-ALONVTE*D2R)
         X1     = A * TAN(TERMA)**CONE * SIN(TERMB)
         Y1     = A * TAN(TERMA)**CONE * COS(TERMB)
         IF (NORTH) Y1 = -1. * Y1
C
C        LOOP TO COMPUTE GEODETIC (LAT,LON).
         ALPHA = (TAN(PSIT/2.)**CONE) / SIN(PSIT)
         DO 60 J = 1,JGOUT
            DO 50 I = 1,IGOUT
               X = X1 + (I-1)*ALPHA*XMESHL
               Y = Y1 + (J-1)*ALPHA*XMESHL
C
               TERM = (SQRT(X*X+Y*Y)/A)**(1./CONE)
               GPHI = HALFPI - 2.*ATAN(TERM)
C
               IF (.NOT.NORTH) GPHI = -1.*GPHI
               IF (NORTH) THEN
                  GTHETA = ATAN2(X,-1.*Y)
               ELSE
                  GTHETA = ATAN2(X,Y)
               ENDIF
C
               GLAM = ALONVTE*D2R + GTHETA/CONE
               IF (GLAM.GT.PI)     GLAM = GLAM - TWOPI
               IF (GLAM.LT.-PI) GLAM = GLAM + TWOPI
C
               GDLAT(I,J) = GPHI*R2D
               GDLON(I,J) = ABS(GLAM*R2D)
C
 50         CONTINUE
 60      CONTINUE
C     
C     CASE IV:  ETA PROJECTION (TRANSFORMED LAT-LON).
C        (DO NOTHING HERE, SINCE THE MODEL PROVIDES GDLAT,GDLON.)
C     
      ENDIF
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE GENEUV(EVLAT,EVLON)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GENEUV      COMPUTE ROTATION (LAT,LON)
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23
C     
C ABSTRACT:
C     THIS ROUTINE LOADS V POINT LATITUDE AND LONGITUDE
C     ARRAYS USED BY SUBROUTINE EUVGUV WHICH ROTATES 
C     U-V WINDS ON A FILLED E-GRID TO THE OUTPUT GRID
C     ORIENTATION.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-23  RUSS TREADON
C     
C USAGE:    CALL GENEUV(EVLAT,EVLON)
C   INPUT ARGUMENT LIST:
C     NONE
C
C   OUTPUT ARGUMENT LIST: 
C     EVLAT    - V POINT LATITUDES ON A FILLED E-GRID.
C     EVLON    - V POINT LONGITUDES ON A FILED E-GRID.
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EGRID
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE ETA MODEL DIMENSIONS.
      INCLUDE "parmeta"
      PARAMETER (IMT=2*IM-1,JMT=JM)
C     
C     DECLARE VARIABLES.
      LOGICAL NORTH
      REAL ALONVT, DLAM, DPHI, LAM0, PHI0, POLEI
      REAL POLEJ, COSPH0, SINPH0, TANPH0, WLONC, XMESHL
      REAL YLATC
      REAL EVLAT(IMT,JMT),EVLON(IMT,JMT)
C     
C     INCLUDE COMMONS.
      INCLUDE "EGRID.comm"
      INCLUDE "IOUNIT.comm"
C     
      EQUIVALENCE (YLATC,ALONVT), (DPHI, POLEI)
      EQUIVALENCE (WLONC, POLEJ), (DLAM,XMESHL)
C
      DATA CONV2R/0.017453293/,CONV2D/57.2958/
C     
C**************************************************************
C     START GENEUV HERE.
C     
      WRITE(STDOUT,*)'GENEUV:  LOAD EVLAT,EVLON'
C
C     COMPUTE GEODETIC LAT-LON OF E-GRID WIND POINTS.
C
      doout20: DO J = 1,JMT
      doin20: DO I = 1,IMT
         XI = I
         YJ = J
         BIGPHI = (YJ-(JDIM+1)/2.0)*DPHI*CONV2R
         BIGLAM = (XI-(IDIM+1)/2.0)*DLAM*CONV2R
         COSPHI = COS(BIGPHI)
         SINPHI = SIN(BIGPHI)
         COSLAM = COS(BIGLAM)
         PHI    = ASIN(SINPHI*COSPH0+COSPHI*SINPH0*COSLAM)
         X      = (COSPHI*COSLAM)/(COS(PHI)*COSPH0)
         Y1     = AMIN1(1.0,(X-TAN(PHI)*TANPH0))
         Y      = ACOS(Y1)*CONV2D
         YLAT   = PHI*CONV2D
         IF (BIGLAM.LT.0.0) WLON = WLONC+Y
         IF (BIGLAM.GE.0.0) WLON = WLONC-Y
         EVLAT(I,J) = YLAT
         EVLON(I,J) = WLON
       END DO doin20
       END DO doout20
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE EFILT(EGRID)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    EFILT       HEAVY HANDED E-GRID SMOOTHER
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-03-24       
C     
C ABSTRACT:  
C     THIS ROUTINE IS A HEAVY HANDED SMOOTHER THAT WORKS ON 
C     E-GRID MASS POINTS.  IT IS BASED ON CODE IN THE OLD
C     ETA POST PROCESSOR SUBROUTINE, OUTMAP.  CURRENTLY,
C     THIS SMOOTHER IS HARDCODED TO BE USED ONLY ON VORTICITY
C     FIELDS IF THE USER ACTIVATES E-GRID SMOOTHING OF 
C     VORTICITY. IT DOES A VERY NICE JOB OF SMOOTHING THE
C     VORTICITY FIELD.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-03-24  RUSS TREADON
C   98-06-04  BLACK - CONVERSION TO 2-D
C     
C USAGE:    CALL EFILT(EGRID)
C   INPUT ARGUMENT LIST:
C     EGRID    - ARRAY OF DATA ON E-GRID
C
C   OUTPUT ARGUMENT LIST: 
C     EGRID    - ARRAY OF SMOOTHED DATA ON E-GRID
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MASKS
C                  DYNAMD
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY Y-MP
C$$$  
C     
C     
C     INCLUDE PARAMETERS.
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C     
C     DECLARE VARIABLES.
      REAL EGRID(IM,JM),WORK1(IM,JM),WORK2(IM,JM),WORK3(IM,JM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "MASKS.comm"
      INCLUDE "DYNAMD.comm"
c      INCLUDE "INDX.comm"
C     
C*******************************************************************
C     START EFILT HERE.
C     
C     LOAD PASSED E-GRID FIELD INTO WORK ARRAY.

!$omp  parallel do
      DO J=1,JM
      DO I=1,IM
        WORK1(I,J)=EGRID(I,J)
      ENDDO
      ENDDO
C     
C     LOAD WEIGHT ARRAY.
!$omp  parallel do
      DO J=3,JM-2
      DO I=2,IM-1
         WORK3(I,J)=1./(4.* HBM2(I,J)+
     1        2.*(HBM2(I+IHE(J),J+1)+HBM2(I+IHW(J),J+1)+
     2        HBM2(I+IHE(J),J-1)+HBM2(I+IHW(J),J-1))+
     3        HBM2(I+1,J)+HBM2(I-1,J)+
     4        HBM2(I,J+2)+HBM2(I,J-2))
      ENDDO
      ENDDO
C     
C     SMOOTHING LOOP.  SMTHA AND SMTHB ARE PARAMETERS SET IN
C     INCLUDE FILE PARAMS.
      MXFILT = NINT(SMTHA*DY+SMTHB)
C
      DO 50 NFILT = 1,MXFILT
!$omp  parallel do
         DO J=3,JM-2
         DO I=2,IM-1
            WORK2(I,J) = 4.*WORK1(I,J)+
     1           2.*(WORK1(I+IHE(J),J+1)+WORK1(I+IHW(J),J+1)+
     2           WORK1(I+IHE(J),J-1)+WORK1(I+IHW(J),J-1))+
     3           WORK1(I+1,J)+WORK1(I-1,J)+
     4           WORK1(I,J+2)+WORK1(I,J-2)
         ENDDO
         ENDDO
C
!$omp  parallel do
         DO J=3,JM-2
         DO I=2,IM-1
           WORK1(I,J)=WORK3(I,J)*WORK2(I,J)*HBM2(I,J)
         ENDDO
         ENDDO
   50 CONTINUE
C     
C     LOAD SMOOTHED EGRID INTO OUTPUT ARRAY.
!$omp  parallel do
      DO J=1,JM
      DO I=1,IM
        EGRID(I,J)=WORK1(I,J)*HBM2(I,J)
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
      RETURN
      END

      SUBROUTINE GET_BITS(IBM,SGDS,LEN,MG,G,ISCALE,GROUND,
     &                    GMIN,GMAX,NBIT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GET_BITS      COMPUTE NUMBER OF BITS AND ROUND FIELD.
C   PRGMMR: IREDELL          ORG: W/NP23     DATE: 92-10-31
C
C ABSTRACT: THE NUMBER OF BITS REQUIRED TO PACK A GIVEN FIELD
C   AT A PARTICULAR DECIMAL SCALING IS COMPUTED USING THE FIELD RANGE.
C   THE FIELD IS ROUNDED OFF TO THE DECIMAL SCALING FOR PACKING.
C   THE MINIMUM AND MAXIMUM ROUNDED FIELD VALUES ARE ALSO RETURNED.
C   GRIB BITMAP MASKING FOR VALID DATA IS OPTIONALLY USED.
C
C PROGRAM HISTORY LOG:
C   92-10-31  IREDELL
C   95-04-14  BALDWIN - MODIFY FOLLOWING KEITH BRILL'S CODE
C                       TO USE SIG DIGITS TO COMPUTE DEC SCALE
C
C USAGE:   CALL GET_BITS(IBM,ISGDS,LEN,MG,G,ISCALE,GROUND,GMIN,GMAX,NBIT)
C   INPUT ARGUMENT LIST:
C     IBM      - INTEGER BITMAP FLAG (=0 FOR NO BITMAP)
C     SGDS     - MAXIMUM SIGNIFICANT DIGITS TO KEEP
C                (E.G. SGDS=3.0 KEEPS 3 SIGNIFICANT DIGITS)
C                OR BINARY PRECISION IF <0
C                (E.G. SGDS=-2.0 KEEPS FIELD TO NEAREST 1/4
C                           -3.0 "                    " 1/8
C                         2**SGDS PRECISION)
C     LEN      - INTEGER LENGTH OF THE FIELD AND BITMAP
C     MG       - INTEGER (LEN) BITMAP IF IBM=1 (0 TO SKIP, 1 TO KEEP)
C     G        - REAL (LEN) FIELD
C
C   OUTPUT ARGUMENT LIST:
C     ISCALE   - INTEGER DECIMAL SCALING
C     GROUND   - REAL (LEN) FIELD ROUNDED TO DECIMAL SCALING
C     GMIN     - REAL MINIMUM VALID ROUNDED FIELD VALUE
C     GMAX     - REAL MAXIMUM VALID ROUNDED FIELD VALUE
C     NBIT     - INTEGER NUMBER OF BITS TO PACK
C
C SUBPROGRAMS CALLED:
C   ISRCHNE  - FIND FIRST VALUE IN AN ARRAY NOT EQUAL TO TARGET VALUE
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN
C
C$$$
      DIMENSION MG(LEN),G(LEN),GROUND(LEN)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  DETERMINE EXTREMES WHERE BITMAP IS ON
C
      IF(IBM.EQ.0) THEN
        GMAX=G(1)
        GMIN=G(1)
        DO I=2,LEN
          GMAX=MAX(GMAX,G(I))
          GMIN=MIN(GMIN,G(I))
        ENDDO
      ELSE
        I1=0
        DO I=1,LEN
          IF(MG(I).NE.0.AND.I1.EQ.0) I1=I
        ENDDO
        IF(I1.GT.0.AND.I1.LE.LEN) THEN
          GMAX=G(I1)
          GMIN=G(I1)
          DO I=I1+1,LEN
            IF(MG(I).NE.0) THEN
              GMAX=MAX(GMAX,G(I))
              GMIN=MIN(GMIN,G(I))
            ENDIF
          ENDDO
        ELSE
          GMAX=0.
          GMIN=0.
        ENDIF
      ENDIF
C
C
C
      CALL FNDBIT  ( GMIN, GMAX, SGDS, NBIT, ISCALE, IRETT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      RETURN
      END
	SUBROUTINE FNDBIT  ( rmin, rmax, rdb, nmbts, iscale, iret )
C************************************************************************
C* FNDBIT								*
C*									*
C* This subroutine computes the number of packing bits given the	*
C* maximum number of significant digits to preserve or the binary	*
C* precision to store the data.  The binary precision is given as a	*
C* negative integer, ISCALE will always be zero in this case.		*
C*									*
C* The binary precision translates as follows:				*
C*     -1  =>  store data to nearest 1/2				*
C*     -2  =>  store data to nearest 1/4				*
C*     -3  =>  store data to nearest 1/8				*
C*									*
C* Note that a fractional number of significant digits is allowed.	*
C*									*
C* FNDBIT ( AMIN, AMAX, RDB, NBITS, ISCALE, IRET )			*
C*									*
C* Input parameters:							*
C*	AMIN 		REAL		Minimum value			*
C*	AMAX		REAL		Maximum value			*
C*	RDB		REAL		Maximum # of significant digits	*
C*					  OR binary precision if < 0	*
C*									*
C* Output parameters:							*
C*	NBITS		INTEGER		Number of bits for packing	*
C*	ISCALE		INTEGER		Power of 10 scaling to use	*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C**									*
C* Log:									*
C* K. Brill/NMC		06/92						*
C* K. Brill/EMC		12/95	Added binary precision			*
C* M. Baldwin           10/96   Added fix for negative nmbts
C************************************************************************
C*
	DATA		rln2/0.69314718/
C-----------------------------------------------------------------------
	iret = 0
	icnt = 0
	iscale = 0
	range = rmax - rmin
	IF ( range .le. 0.00 ) THEN
	    nmbts = 8
	    RETURN
	END IF
C*
	IF ( rdb .eq. 0.0 ) THEN
	    nmbts = 8
	    RETURN
	ELSE IF ( rdb .gt. 0.0 ) THEN
	    ipo = INT (ALOG10 ( range ))
	    IF ( range .lt. 1.00 ) ipo = ipo - 1
	    po = float(ipo) - rdb + 1.
	    iscale = - INT ( po )
	    rr = range * 10. ** ( -po )
	    nmbts = INT ( ALOG ( rr ) / rln2 ) + 1
	ELSE
	    ibin = NINT ( -rdb )
	    rng2 = range * 2. ** ibin
	    nmbts = INT ( ALOG ( rng2 ) / rln2 ) + 1
	END IF
C*
        IF(NMBTS.LE.0) THEN
          NMBTS=0
          IF(ABS(RMIN).GE.1.) THEN
            ISCALE=-INT(ALOG10(ABS(RMIN)))
          ELSE IF (ABS(RMIN).LT.1.0.AND.ABS(RMIN).GT.0.0) THEN
            ISCALE=-INT(ALOG10(ABS(RMIN)))+1
          ELSE
            ISCALE=0
          ENDIF
        ENDIF
	RETURN
	END

      SUBROUTINE CALEKM2(U1D,V1D)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALEKM2     COMPUTES EKMAN ROT. GEOS. WINDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-03-25       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES EKMAN SPRIAL ROTATED GEOSTROPHIC
C     WINDS FROM THE SEA LEVEL PRESSURE.  THE EKMAN SPIRAL 
C     ROTATION IS BASED ON THE MATERIAL PRESENTED IN SECTION
C     8.5.2 (PP274-277) OF "NUMERICAL WEATHER PREDICTION AND
C     DYNAMIC METEOROLOGY" BY HALTINER AND WILLIAMS 
C     (WILEY,1980).
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-03-23  RUSS TREADON
C   98-06-16  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION           
C     
C USAGE:    CALL CALEKM2(U1D,V1D)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     U1D      - EKMAN SPIRAL GEOSTROPHIC U WIND
C     V1D      - EKMAN SPIRAL GEOSTROPHIC V WIND
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EXTRA
C                  VRBLS
C                  DYNAMD
C                  MAPOT
C                  CTLBLK
C                  MASKS
C                  LOOPS
C                  INDX
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C
C
C     INCLUDE PARAMETERS
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
C
      PARAMETER (EDDYK=5.,TWOK=2.*EDDYK)
      PARAMETER (Z=250.,H=50.,ZMH=Z-H)
      PARAMETER (ARGLIM=500.,ISMTHP=2)
      PARAMETER (FACTOR=1.0,RHO=1.)
C
C     DECLARE VARIABLES
      REAL U1D(IM,JM),V1D(IM,JM),SLPH(IM,JM),SLPV(IM,JM)
C
C     INCLUDE COMMON BLOCKS.
      INCLUDE "EXTRA.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "DYNAMD.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "LOOPS.comm"
c      INCLUDE "INDX.comm"
C
C******************************************************************
C     START CALEKM2 HERE.
C
C     SET CONSTANTS.
      D75PI =3.*ACOS(-1.)/4.
      DEG2RD=ACOS(-1.)/180.
      SQRT2 =SQRT(2.)
C
C     INITIALIZE WIND COMPONENTS TO ZERO.
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        U1D(I,J) =D00
        V1D(I,J) =D00
        SLPH(I,J)=SLP(I,J)
        SLPV(I,J)=D00
      ENDDO
      ENDDO
C     
C     COMPUTE 1000MB HEIGHTS AT V POINTS.
C
      CALL P2FILT(ISMTHP,HBM2,SLPH)
C
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        SLPV(I,J)=D25*(SLPH(I+IVE(J),J)+SLPH(I+IVW(J),J)
     1                +SLPH(I,J+1)+SLPH(I,J-1))
      ENDDO
      ENDDO
C
      CALL P2FLTV(ISMTHP,VBM2,SLPV)
C
C     LOOP OVER HORIZONTAL GRID.
C
      doout30: DO J=JSTA_M2,JEND_M2
      doin30: DO I=2,IM-1
C     
C        OBTAIN FAL WIND COMPONENTS
C
      LLMH=LMH(I,J)
      UFAL=U(I,J,LLMH)
      VFAL=V(I,J,LLMH)

CX         WRITE(81,*)' '
CX 1234    FORMAT(I5,1X,I2,1X,5(G12.6,1X))

C
C        COMPUTE GEOSTROPHIC WIND BASED ON SEA LEVEL PRESSURE.
C
      FTRUE=(2.*F(I,J))/DT
      RRHOF=1./(RHO*FTRUE)
      DPDX =(SLPV(I+IHE(J),J)-SLPV(I+IHW(J),J))/(2.*DX(I,J))
      DPDY =(SLPV(I,J+1)-SLPV(I,J-1))/(2.*DY)
      UG   =-1.*RRHOF*DPDY*HBM2(I,J)
      VG   =RRHOF*DPDX*HBM2(I,J)
      SPDG =SQRT(UG**2+VG**2)

CX         WRITE(81,1235) G,FTRUE,DX(K),DY
CX         WRITE(81,1235) SLPV(K),SLPV(K-1),SLPV(K+IM-1),SLPV(K-IM)
CX         WRITE(81,1235) GRF,DZDX,DZDY,UG,VG,SPDG
CX 1235    FORMAT(5(G12.6,1X))

C
C        COMPUTE EKMAN SPIRAL COEFFICIENTS.
C     
      WDIRT=WDIR(UFAL,VFAL)
      WDIRG=WDIR(UG,VG)
      B    =SQRT(FTRUE/TWOK)
      BZMH =B*ZMH
      IF (BZMH.GT. ARGLIM) BZMH= ARGLIM
      IF (BZMH.LT.-ARGLIM) BZMH=-ARGLIM
      EXBZMH = EXP(-1.*BZMH)
C     
C        COMPUTE EKMAN SPIRAL U WIND COMPONENT.
C
      ALPHAS=+45.
      ALPHAS=ALPHAS*DEG2RD*FACTOR
      SINALF=SIN(ALPHAS)
      ARG   =D75PI + ALPHAS - BZMH
      COSARG=COS(ARG)
      IF(((WDIRG.GE.000.).AND.(WDIRG.LE.090.)).OR.
     X     ((WDIRG.GE.270.).AND.(WDIRG.LE.360.)) )
     X    COSARG = -1.*COSARG
      U1D(I,J)=UG+SQRT2*SPDG*SINALF*EXBZMH*COSARG

CX         WRITE(81,1235) WDIRG,WDIRT,ALPHAS,SINALF
CX         WRITE(81,1235) B,ZMH,BZMH,EXBZMH
CX         WRITE(81,1235) ARG,COSARG,SINARG
C     
C        COMPUTE EKMAN SPIRAL V WIND COMPONENT.
C
      ALPHAS=+45.
      ALPHAS=ALPHAS*DEG2RD*FACTOR
      SINALF=SIN(ALPHAS)
      ARG   =D75PI + ALPHAS - BZMH
      SINARG=SIN(ARG)
      IF((WDIRG.GE.000.).AND.(WDIRG.LE.180.))
     X    SINARG=-1.*SINARG
      V1D(I,J)=VG+SQRT2*SPDG*SINALF*EXBZMH*SINARG

CX         WRITE(81,1235) WDIRG,WDIRT,ALPHAS,SINALF
CX         WRITE(81,1235) B,ZMH,BZMH,EXBZMH
CX         WRITE(81,1235) ARG,COSARG,SINARG

C
C     SCALE EKMAN SPIRAL WIND COMPONENTS TO AN ACCEPTABLE
C     LEVEL THIS IS ENTIRELY AD HOC.  IT WAS DONE TO PRODUCE
C     A PLEASING WIND FIELD.
C
      U1D(I,J)=D50*U1D(I,J)
      V1D(I,J)=D50*V1D(I,J)

CX         WRITE(81,1234) K,LLMH,WDIRG,WDIRT,UG,VG
CX         WRITE(81,1234) K,LLMH,SQRT2,SPDG,ALPHAS/DEG2RD,SINALF
CX         WRITE(81,1234) K,LLMH,EXBZMH,COSARG,SINARG
CX         WRITE(81,1234) K,LLMH,UFAL,VFAL,U1D(K),V1D(K)

      END DO doin30
      END DO doout30
C
C     END OF ROUTINE.
      RETURN
      END

      SUBROUTINE CALCWI(CLW,CLI)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    CALCWI     COMPUTES vert integr  CLOUD WATER & CLOUD ICE
C SUBPROGRAM:               BASED ON CALQUV and CALCAPE
C
C ABSTRACT:
C     GIVEN SPECIFIC HUMIDITY, Q, and Cloud water/ice AND THE U-V WIND COMPONENTS
C     THIS ROUTINE CALCULATES  integral (qu) dp/g ;ntegral (qv) dp/g
C     WHERE,
C
C     THIS REQUIRES WINDS BE AT VELOCITY POINTS.
C     SPECIFIC HUMIDITY IS INTERPOLATED TO VELOCITY POINTS.
C
C USAGE:    CALL CALCWI(CLW,CLI)
C   INPUT ARGUMENT LIST:
C
C   OUTPUT ARGUMENT LIST:
C     CLW     -  INTEGRAL OF CLOUD WATER
C     CLI     -  INTEGRAL OF CLOUD ICE
C
C   OUTPUT FILES:
C     NONE
C
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MASKS
C                  DYNAM
C                  OPTIONS
C                  INDX
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$
C
C
C
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
             USE INDX_MOD
C
      INCLUDE "parmeta"
      INCLUDE "params"
C
C     DECLARE VARIABLES.
C
      REAL CLW(IM,JM), CLI(IM,JM), QI(IM,JM)
      REAL IW(IM,JM,LM)
C
C     DECLARE COMMONS.
      INCLUDE "DYNAM.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
c      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
C
C
C***************************************************************************
C     START CALCWI  HERE.
C
C     DEFINE IW switch between water and ice
C
        CLIMIT =1.0E-20

        DO J=JSTA,JEND
        DO I=1,IM
          IW(I,J,1)=0.
        ENDDO
        ENDDO
C
      DO 125 L=2,LM
      DO J=JSTA,JEND
      DO I=1,IM
        LML=LM-LMH(I,J)
        HH=HTM(I,J,L)*HBM2(I,J)
        TKL=T(I,J,L)
        QKL=Q(I,J,L)
        CWMKL=CWM(I,J,L)
        TMT0=(TKL-273.15)*HH
        TMT15=AMIN1(TMT0,-15.)*HH
        PP=PDSL(I,J)*AETA(L)+PT
        QW=HH*PQ0/PP*EXP(HH*A2*(TKL-A3)/(TKL-A4))
        QI(I,J)=QW*(1.+0.01*AMIN1(TMT0,0.))
C
        U00KL=U00(I,J)+UL(L+LML)*(0.95-U00(I,J))*UTIM
        IF(TMT0.LT.-15.0)THEN
          FIQ=QKL-U00KL*QI(I,J)
          IF(FIQ.GT.D00.OR.CWMKL.GT.CLIMIT) THEN
            IW(I,J,L)=1.
          ELSE
            IW(I,J,L)=0.
          ENDIF
        ENDIF
        IF(TMT0.GE.0.0)IW(I,J,L)=0.
        IF(TMT0.LT.0.0.AND.TMT0.GE.-15.0)THEN
          IW(I,J,L)=0.
          IF(IW(I,J,L-1).EQ.1.0.AND.CWMKL.GT.CLIMIT)IW(I,J,L)=1.
        ENDIF
      ENDDO
      ENDDO
  125 CONTINUE

!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        CLW(I,J) = D00
        CLI(I,J) = D00
      ENDDO
      ENDDO

      DO L=1,LM

!$omp  parallel do
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
      DP     = -(PINT(I,J,L) -PINT(I,J,L+1))
      CLW(I,J)= CLW(I,J)+ (CWM(I,J,L)*(1-IW(I,J,L))*HTM(I,J,L))*DP*GI
      CLI(I,J)= CLI(I,J)+ (CWM(I,J,L)*(IW(I,J,L))  *HTM(I,J,L))*DP*GI

CHOU checking       WRITE(1098,*)"CalCWI:", i,j,l, CLW(i,j), CLI(i,j),
CHOU checking     1                                cwm(i,j,l),IW(i,j,l), htm(i,j,l)
      ENDDO
      ENDDO
C
      ENDDO    ! L LOOP
C
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE PARA_RANGE (N1,N2,NPROCS,IRANK,ISTA,IEND)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    PARA_RANGE  SET UP DECOMPOSITION VALUES
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     SETS UP DECOMOSITION VALUES
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C
C USAGE:    CALL COLLECT(A)
C   INPUT ARGUMENT LIST:
C     N1 - FIRST INTERATE VALUE
C     N2 - LAST INTERATE VALUE
C     NPROCS - NUMBER OF MPI TASKS
C     IRANK - MY TAKS ID
C
C   OUTPUT ARGUMENT LIST:
C     ISTA - FIRST LOOP VALUE
C     IEND - LAST LOOP VALUE
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
      implicit none
      integer n1,n2,nprocs,irank,ista,iend
      integer iwork1, iwork2
      iwork1 = ( n2 - n1 + 1 ) / nprocs
      iwork2 = mod ( n2 - n1 + 1, nprocs )
      ista = irank * iwork1 + n1 + min ( irank, iwork2 )
      iend = ista + iwork1 - 1
      if ( iwork2 .gt. irank ) iend = iend + 1
      end

      SUBROUTINE CHR2INT(CHR,ILEN,IVAL)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CHR2INT     CONVERTS CHR STRING TO INTEGER
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-31
C     
C ABSTRACT:  
C     GIVEN A CHARACTER STRING, CHR, OF LENGTH LEN CONTAINING
C     INTEGERS OR BLANKS, THIS ROUTINE RETURNS THE INTEGER
C     VALUE IN IVAL.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-31  RUSS TREADON
C     
C USAGE:    CALL CHR2INT(CHR,ILEN,IVAL)
C   INPUT ARGUMENT LIST:
C     CHR      - CHARACTER STRING CONTAINING INTEGERS OR BLANKS.
C     LEN      - LENGTH OF CHR.
C
C   OUTPUT ARGUMENT LIST: 
C     IVAL     - INTEGER EQUIVALENT TO CHR.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     SET PARAMETER IOFF.  IOFF IS THE ASCII CODE FOR
C     THE ZERO CHARACTER.  CHARACTERS 48 THROUGH 57
C     ARE INTEGER 0 THROUGH 9, RESPECTIVELY.
C
      PARAMETER (IOFF=48)
C
C     DECLARE VARIABLES.
C     
      CHARACTER*10 CHR
C
C     
C***********************************************************************
C     START CHR2INT HERE.
C     
C     LOOP OVER LENGTH OF CHARACTER STRING. CONSTRUCT
C     THE INTEGER EQUIVALENT TO THE INTEGER IN THE 
C     CHARACTER STRING.
C     
      ISUM = 0
      DO 10 IPOS = ILEN,1,-1
         ICVAL = ICHAR(CHR(IPOS:IPOS))
         IPOWER = ILEN-IPOS
         IF ((ICVAL.GE.48).AND.(ICVAL.LE.57)) THEN
            INTVAL = ICVAL-IOFF
            ISUM = ISUM + INTVAL*10**IPOWER
         ENDIF
 10   CONTINUE
C     
C     SET INTEGER VALUE.
C
      IVAL = ISUM
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE SCLFLD(FLD,SCALE,IMO,JMO)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    SCLFLD      SCALE ARRAY ELEMENT BY CONSTANT
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-09-13       
C     
C ABSTRACT:  
C     THIS ROUTINE MULTIPLES (SCALES) THE FIRST IMO*JMO
C     ELEMENTS OF ARRAY FLD BY THE REAL SCALAR SCALE.
C     ARRAY ELEMENTS WHICH EQUAL A SPECIAL VALUE WILL
C     NOT BE SCALED BY SCALE.  THEY WILL BE LEFT AS IS.
C     THE SPECIAL VALUE, SPVAL, IS PASSED THROUGH COMMON
C     BLOCK OPTIONS.  IT IS SET IN INCLUDE FILE OPTIONS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-09-13  RUSS TREADON
C   00-01-04  JIM TUCCILLO
C     
C USAGE:    CALL SCLFLD(FLD,SCALE,IMO,JMO)
C   INPUT ARGUMENT LIST:
C     FLD      - ARRAY WHOSE ELEMENTS ARE TO BE SCALED.
C     SCALE    - CONSTANT BY WHICH TO SCALE ELEMENTS OF FLD.
C     IMO,JMO  - DIMENSION OF ARRAY FLD.
C
C   OUTPUT ARGUMENT LIST: 
C     FLD      - ARRAY WHOSE ELEMENTS HAVE BEEN SCALED BY SCALE.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - OPTIONS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     
C     DECLARE PARAMETER.
      PARAMETER (SMALL=1.E-6)
C
C     DECLARE VARIABLES.
C     
      REAL SCALE, FLD(IMO,JMO)
C     
C     INCLUDE COMMON BLOCK WITH SPVAL.
      INCLUDE "OPTIONS.comm"
      INCLUDE "CTLBLK.comm"
C     
C     
C***********************************************************************
C     START SCLFLD HERE
C     
C     MULTIPLY EACH ELEMENT OF FLD BY SCALE.
C     
      IF ( ME .EQ. 0 ) THEN
!$omp  parallel do
      DO J=1,JMO
      DO I=1,IMO
        IF(ABS(FLD(I,J)-SPVAL).GT.SMALL) 
     1        FLD(I,J)=SCALE*FLD(I,J)
      ENDDO
      ENDDO
!$omp end  parallel do
      END IF
C     
C     END OF ROUTINE.
C     
      RETURN
      END

       SUBROUTINE INITPOST
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    INITPOST    INITIALIZE POST FOR RUN
C   PRGRMMR: RUSS TREADON    ORG: W/NP2      DATE: 93-11-10
C     
C ABSTRACT:  THIS ROUTINE INITIALIZES CONSTANTS AND
C   VARIABLES AT THE START OF AN ETA MODEL OR POST 
C   PROCESSOR RUN.
C
C   THIS ROUTINE ASSUMES THAT INTEGERS AND REALS ARE THE SAME SIZE
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-11-10  RUSS TREADON - ADDED DOCBLOC
C   98-05-29  BLACK - CONVERSION OF POST CODE FROM 1-D TO 2-D
C   99-01 20  TUCCILLO - MPI VERSION
C     
C USAGE:    CALL INIT
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - CTLBLK
C                  OUTFIL
C                  LOOPS
C                  MASKS
C                  DYNAMD
C                  PHYS2
C                  MAPOT1
C                  VRBLS
C                  PVRBLS
C                  BOCO
C                  GRIDS
C                  ACMCLD
C                  ACMCLH
C                  ACMPRE
C                  ACMRDL
C                  ACMRDS
C                  ACMSFC
C                  INDX
C
C    
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C
C     INCLUDE/SET PARAMETERS.
C     
               USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "params"
      INCLUDE "parm.tbl"
      INCLUDE "parmsoil"
      include "mpif.h"
C
C     DECLARE VARIABLES.
C     
      REAL DUMMY ( IM, JM )
      REAL DUMMY_MF ( IM, JM, 15 )
C 
C     NOTE: SOME INTEGER VARIABLES ARE READ INTO DUMMY ( A REAL ). THIS IS OK
C     AS LONG AS REALS AND INTEGERS ARE THE SAME SIZE.
C
C     ALSO, EXTRACT IS CALLED WITH DUMMY ( A REAL ) EVEN WHEN THE NUMBERS ARE
C     INTEGERS - THIS IS OK AS LONG AS INTEGERS AND REALS ARE THE SAME SIZE.
      LOGICAL RUN,RUNB,FIRST,RESTRT,SINGLRST
     1,       SIGMA,SUBPOST,NEST,HYDRO
      LOGICAL IOOMG,IOALL
      CHARACTER*32 LABEL
      CHARACTER*40 CONTRL,FILALL,FILMST,FILTMP,FILTKE,FILUNV
     &, FILCLD,FILRAD,FILSFC
      CHARACTER*4 RESTHR
C     JLG increased lenght of FNAME
      CHARACTER FNAME*256,ENVAR*50,BLANK*4
      INTEGER IDATB(3)
      REAL ETA(LP1),DETA(LM),AETA(LM)
C     
C     INCLUDE COMMON BLOCKS.
C
      INCLUDE "IOUNIT.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "CTLBLK.comm"
      INCLUDE "OUTFIL.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "DYNAMD.comm"
      INCLUDE "PHYS2.comm"
      INCLUDE "MAPOT1.comm"
      INCLUDE "SRFDSP.comm"
      INCLUDE "CNVCLD.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "BOCO.comm"
      INCLUDE "ACMCLD.comm"
      INCLUDE "ACMCLH.comm"
      INCLUDE "ACMPRE.comm"
      INCLUDE "ACMRDL.comm"
      INCLUDE "ACMRDS.comm"
      INCLUDE "ACMSFC.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "SOIL.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "E2PFLG.comm"
c      INCLUDE "INDX.comm"
      
C     
C     DELCARE NAMELIST.
C
      NAMELIST /FCSTDATA/
     & TSTART,TEND,TCP,RESTRT,SINGLRST
     &,SUBPOST,NMAP,TSHDE,SPL
     &,NPHS,NCNVC,NRADSH,NRADLH,NTDDMP
     &,TPREC,THEAT,TCLOD,TRDSW,TRDLW,TSRFC
     &,NEST,HYDRO,SPLINE
C
      DATA BLANK/'    '/
C
C***********************************************************************
C     START INIT HERE.
C
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)'INITPOST:  ENTER INITPOST'
      WRITE(STDOUT,*)'INITPOST:  SPLINE=', SPLINE
      ENDIF
C
C     ***STEP 1.  READ "NHB" NFILE.
C
C     READ DATA FROM UNIT CONNECTED TO NHIBU.  THIS DATA CONSISTS
C     OF "CONSTANTS" FOR A GIVEN ETA MODEL RUN.
C
      LSL   = LSM

Cmp
      IF ( ME .EQ. 0 ) THEN
      LUNHB = 12
      REWIND LUNHB
        open (unit=LUNHB,file='CNST.file',form='unformatted',
     +          access='sequential')
      ENDIF
Cmp
C
C
      IF ( ME .EQ. 0 ) READ(LUNHB) NFCST,NBC,LIST,DT,IDTAD,SIGMA,
     X     KHLA,KHHA,KVLA,KVHA,KHL2,KHH2,KVL2,KVH2
      CALL MPI_BCAST(NFCST, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(NBC  , 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(LIST , 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DT   , 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(IDTAD, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(SIGMA, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
cwas  READ(LUNHB) LMH
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,LMH)
      IF ( ME .EQ. 0 ) print*,"EXTRACT LMH"

C
cwas  READ(LUNHB) LMV
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,LMV)
      IF ( ME .EQ. 0 ) print*,"EXTRACT LMV"
C
C     NEED ALL OF HBM2 FOR MPI TASK 0
      IF ( ME .EQ. 0 ) READ(LUNHB) HBM2
      CALL MPI_BCAST(HBM2,IM*JM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
C     NEED ALL OF VBM2 FOR MPI TASK 0
      IF ( ME .EQ. 0 ) READ(LUNHB) VBM2
      CALL MPI_BCAST(VBM2,IM*JM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
cwas  READ(LUNHB) VBM3
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,VBM3)
      IF ( ME .EQ. 0 ) print*,"EXTRACT VBM3"
C
cwas  READ(LUNHB) 
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,SM)
C
cwas  READ(LUNHB) SICE
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,SICE)
c
      DO L=1,LM
C
cwas     READ(LUNHB)((HTM(I,J,L),I=1,IM),J=1,JM)
        IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
        CALL EXTRACT(DUMMY,HTM(1,1,L))
      END DO
C
      DO L=1,LM
cwas     READ(LUNHB)((VTM(I,J,L),I=1,IM),J=1,JM)
        IF ( ME .EQ. 0 ) READ(LUNHB)DUMMY
        CALL EXTRACT(DUMMY,VTM(1,1,L))
      END DO
C
      IF ( ME .EQ. 0 ) READ(LUNHB) DY,CPGFV,EN,ENT,R,PT,TDDAMP,F4D,F4Q,
     X     EF4T,DETAD,RDETA,AETAD,F4Q2,ETAD,DFL,EM,EMT
      CALL MPI_BCAST(DY      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(CPGFV   , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(EN      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(ENT     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(R       , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(PT      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(TDDAMP  , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(F4D     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(F4Q     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(EF4T    , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DETAD(1), LM , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDETA(1), LM , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(AETAD(1), LM , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(F4Q2(1), LM , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(ETAD(1), LP1, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DFL(1), LP1, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(EM(1), JAM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(EMT(1), JAM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
cwas  READ(LUNHB) DX
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,DX)
C
cwas  READ(LUNHB) WPDAR
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,WPDAR)
C
cwas  READ(LUNHB) CPGFU
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,CPGFU)
C
cwas  READ(LUNHB) CURV
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,CURV)
C
cwas  READ(LUNHB) FCP
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,FCP)
C
cwas  READ(LUNHB) FDIV
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,FDIV)
C
cwas  READ(LUNHB) FAD
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,FAD)
C
cwas  READ(LUNHB) F
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,F)
C
cwas  READ(LUNHB) DDMPU
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,DDMPU)
C
cwas  READ(LUNHB) DDMPV
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,DDMPV)
C
      IF ( ME .EQ. 0 ) READ(LUNHB) PT2,GLAT
      CALL MPI_BCAST(GLAT,IM*JM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(PT2,1, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)    
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN) 
C
      IF ( ME .EQ. 0 ) READ(LUNHB) GLON
      CALL MPI_BCAST(GLON,IM*JM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN) 
C
      IF ( ME .EQ. 0 ) READ(LUNHB) PLQ,RDPQ,RDTHEQ,STHEQ,THE0Q
      CALL MPI_BCAST(PLQ     , 1   , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDPQ    , 1   , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDTHEQ  , 1   , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(STHEQ(1), ITBQ, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(THE0Q(1), ITBQ, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
      IF ( ME .EQ. 0 ) READ(LUNHB) ROS,CS,DS,ROI,CI,DI,PL,THL,RDQ,
     X     RDTH,RDP,RDTHE,DETA2,AETA2,DFRLG,QS0,SQS,STHE,THE0
      CALL MPI_BCAST(ROS     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(CS      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DS      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(ROI     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(CI      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DI      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(PL      , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(THL     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDQ     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDTH    , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDP     , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(RDTHE   , 1  , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DETA2(1), LM , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(AETA2(1), LM , MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DFRLG(1), LP1, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(  QS0(1), JTB, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(  SQS(1), JTB, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST( STHE(1), ITB, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST( THE0(1), ITB, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)

C
cwas  READ(LUNHB) WFK
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,WFK)
C
cwas  READ(LUNHB) EPSR
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,EPSR)
C
cwas  READ(LUNHB) TG
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,TG)
C
cwas  READ(LUNHB) GFFC
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,GFFC)
C
cwas  READ(LUNHB) SST
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,SST)
C
cwas  READ(LUNHB) ALB
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,ALB)
C
cwas  READ(LUNHB) HDAC
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,HDAC)
C
cwas  READ(LUNHB) HDACV
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,HDACV)
C
      IF ( ME .EQ. 0 ) READ(LUNHB) TTBLQ
      CALL MPI_BCAST(TTBLQ(1,1),JTBQ*ITBQ,MPI_REAL,0,MPI_COMM_WORLD,
     X               IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
      IF ( ME .EQ. 0 ) READ(LUNHB) PTBL,TTBL,R1,PT1,TSPH,WBD,SBD,
     X    TLM0D,TPH0D,DLMD,DPHD,CMLD,DP30,X1P,Y1P,IXM,IYM,DETA1,AETA1,
     X     ETA1
      CALL MPI_BCAST(PTBL(1,1),ITB*JTB,MPI_REAL, 0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(TTBL(1,1),JTB*ITB,MPI_REAL, 0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(R1,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(PT1, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(TSPH, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(WBD, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(SBD, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(TLM0D, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(TPH0D, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DLMD, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DPHD, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(CMLD, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DP30, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(X1P, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(Y1P, 1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(IXM, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(IYM, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(DETA1(1), LM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(AETA1(1), LM, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(ETA1(1), LP1, MPI_REAL, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
cwas  READ(LUNHB) IVGTYP
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,IVGTYP)
C
cwas  READ(LUNHB) ISLTYP
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,ISLTYP)
C
cwas  READ(LUNHB) ISLOPE
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,ISLOPE)
C
cwas  READ(LUNHB) VEGFRC
      IF ( ME .EQ. 0 ) READ(LUNHB) DUMMY
      CALL EXTRACT(DUMMY,VEGFRC)
C
      IF ( ME .EQ. 0 ) READ(LUNHB) SLDPTH
      CALL MPI_BCAST(SLDPTH(1),NSOIL,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
      IF ( ME .EQ. 0 ) READ(LUNHB) RTDPTH
      CALL MPI_BCAST(RTDPTH(1),NSOIL,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)'INITPOST:  READ CONSTANTS FILE NHB'
      ENDIF
C     
C     COMPUTE DERIVED CONSTANTS FROM NHB INPUT.
C
      PTDYN = PT
      RDYN  = R
      DO L = 1,LM
         DETA(L) = DETAD(L)
         AETA(L) = AETAD(L)
         ETA(L)  = ETAD(L)
      END DO
      ETA(LP1) = ETAD(LP1)
C     
C     
C     ***STEP 2.  READ NAMELIST FCSTDATA.
C
C     READ NAMELIST FCSTDATA WHICH CONTROLS TIMESTEPS, 
C     ACCUMULATION PERIODS, AND STANDARD OUTPUT
C
      RESTRT = .FALSE.
      LFCSTD = 11
C      IF ( ME .EQ. 0 ) THEN
       open(LFCSTD,file='FCSTDATA.meso',status='old')
       REWIND LFCSTD
       READ(LFCSTD,FCSTDATA)
C      ENDIF

C      CALL MPI_BCAST(RESTRT,1, MPI_LOGICAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(NPHS,1, MPI_INTEGER   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(TPREC,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(THEAT,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(TCLOD,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(TRDSW,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(TRDLW,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(TSRFC,1, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(SPLINE,1, MPI_LOGICAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(TSHDE,9999999, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
C      CALL MPI_BCAST(SPL,LSM, MPI_REAL   , 0, MPI_COMM_WORLD, IRTN)
C      CALL MPI_BARRIER(MPI_COMM_WORLD, IRTN)
Cmp
      IF ( ME .EQ. 0 ) THEN
	write(6,*) 'what is spline???? ', SPLINE
Cmp
C     

      WRITE(STDOUT,*)'INITPOST:  READ NAMELIST ',
     X     'FCSTDATA - CONTENTS BELOW'
      WRITE(STDOUT,*)'  TSTART,TEND  :  ',TSTART,TEND
      WRITE(STDOUT,*)'  TCP          :  ',TCP
      WRITE(STDOUT,*)'  RESTRT       :  ',RESTRT
      WRITE(STDOUT,*)'  SUBPOST      :  ',SUBPOST
      WRITE(STDOUT,*)'  NMAP,NPHS    :  ',NMAP,NPHS
      WRITE(STDOUT,*)'  NRADSH,NRADLH:  ',NRADSH,NRADLH
      WRITE(STDOUT,*)'  TPREC,THEAT  :  ',TPREC,THEAT
      WRITE(STDOUT,*)'  TCLOD,TRDSW  :  ',TCLOD,TRDSW
      WRITE(STDOUT,*)'  TRDLW,TSRFC  :  ',TRDLW,TSRFC
      WRITE(STDOUT,*)'  TSHDE (POSTED FORECAST HOURS) BELOW:  '
      WRITE(STDOUT,50) (TSHDE(K),K=1,99)
      WRITE(STDOUT,*)'  SPL (POSTED PRESSURE LEVELS) BELOW: '
      WRITE(STDOUT,51) (SPL(L),L=1,LSM)
   50 FORMAT(14(F4.1,1X))
   51 FORMAT(8(F8.1,1X))
      ENDIF
C     
C     COMPUTE DERIVED TIME STEPPING CONSTANTS.
C
      FIRST  = .TRUE.
      NSTART = INT(TSTART*TSPH+D50)
      NTSTM  = INT(TEND  *TSPH+D50)+1
      NCP    = INT(TCP   *TSPH+D50)
      NDDAMP = INT(TDDAMP*TSPH+D50)
      NPREC  = INT(TPREC *TSPH+D50)
      NHEAT  = INT(THEAT *TSPH+D50)
      NCLOD  = INT(TCLOD *TSPH+D50)
      NRDSW  = INT(TRDSW *TSPH+D50)
      NRDLW  = INT(TRDLW *TSPH+D50)
      NSRFC  = INT(TSRFC *TSPH+D50)
      NRADS = NINT(TSPH)*NRADSH
      NRADL = NINT(TSPH)*NRADLH
      DTQ2  = NPHS * DT
      TDTQ2 = DTQ2 + DTQ2
      DTD   = D50  * DTQ2
      TDTD  = DTD  + DTD
      KTM   = INT(DTQ2/DTD+D50)
C     
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)' '
      WRITE(STDOUT,*)'DERIVED TIME STEPPING CONSTANTS'
      WRITE(STDOUT,*)' FIRST             :  ',FIRST
      WRITE(STDOUT,*)' NSTART,NSTSM,NCP  :  ',NSTART,NTSTM,NCP
      WRITE(STDOUT,*)' NDDAMP,NPREC,NHEAT:  ',NDDAMP,NPREC,NHEAT
      WRITE(STDOUT,*)' NCLOD,NRDSW,NRDLW :  ',NCLOD,NRDSW,NRDLW
      WRITE(STDOUT,*)' NSRFC             :  ',NSRFC
      WRITE(STDOUT,*)' NRADS,NRADL       :  ',NRADS,NRADL
      WRITE(STDOUT,*)' DTQ2,TDTQ2        :  ',DTQ2,TDTQ2
      WRITE(STDOUT,*)' DTD,TDTD,KTM      :  ',DTD,TDTD,KTM
      ENDIF
C
C     COMPUTE DERIVED MAP OUTPUT CONSTANTS.
      DO L = 1,LSL
         ALSL(L) = LOG(SPL(L))
      END DO
      DO I=1,NMAP
         ISHDE(I)=INT(TSHDE(I)*TSPH+D50)+1
      END DO
C     
C     
C     
C     STEP 3.  READ MODEL RESTART FILE
C
      IF ( ME .EQ. 0 )WRITE(STDOUT,*)'INITPOST:  READ RESTRT FILE'
C
      ENVAR=' '
      CALL GETENV("RSTFNL",ENVAR)
      CALL GETENV("tmmark",RESTHR)
      KPATH = INDEX(ENVAR,' ') -1
      IF(KPATH.LE.0) KPATH = LEN(ENVAR)
      IF ( ME .EQ. 0 ) THEN
      print*,'kpath= ',kpath
C
	write(6,*) 'itag= ', itag
	write(6,*) 'rstfil= ', rstfil
	write(6,*) 'resthr= ', resthr
      ENDIF
      IF(RESTHR.EQ.'    ')THEN
        WRITE(RSTFIL,75)ITAG
   75   FORMAT('RESTRT',I7.7)
      ELSE
	IF ( ME .EQ. 0 )write(6,*) 'using format 80 statement'
        WRITE(RSTFIL,80)ITAG,RESTHR
	IF ( ME .EQ. 0 )write(6,*) 'past format 80 write'
   80   FORMAT('RESTRT',I7.7,'.',a4)
      ENDIF
C
      KRST = INDEX(RSTFIL,' ') -1
      IF(KRST.LE.0) KRST = LEN(RSTFIL)
      IF ( ME .EQ. 0 ) print *,'krst= ',krst
C***
      LRSTRT = 17
      CLOSE(LRSTRT)
C     CALL ASNUNIT(LRSTRT,'-F cos -C ascii -N ibm',IER)
C     IF(IER.NE.0)
C    1     WRITE(LIST,*)'INITPOST:  ASNUNIT ERROR IER=',IER
      IF(ENVAR(1:4).EQ.BLANK) THEN
        OPEN(LRSTRT,FILE=RSTFIL,FORM='UNFORMATTED')
      ELSE
        FNAME = ENVAR(1:KPATH) // RSTFIL(1:KRST)
        OPEN(UNIT=LRSTRT,FILE=FNAME,FORM='UNFORMATTED',IOSTAT=IER)
      ENDIF
C***
      IF ( ME .EQ. 0 ) READ(LRSTRT) RUN,IDAT,IHRST,NTSD,LABEL,itag
      CALL MPI_BCAST(RUN,1,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(IDAT,3,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(IHRST,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(NTSD,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(itag,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)

C***
      IF ( ME .EQ. 0 ) READ(LRSTRT) PDOMG,RESOMG

C***
      DO L = 1,LM
cwas    READ(LRSTRT) ((OMGA(I,J,L),I=1,IM),J=1,JM)
      IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
      CALL EXTRACT(DUMMY,OMGA(1,1,L))
      END DO
C***
      IF ( ME .EQ. 0 )WRITE(STDOUT,*)'  READ ',LABEL
C
      IF ( ME .EQ. 0 ) READ(LRSTRT) RUN,IDAT,IHRST,NTSD,LABEL,itag,
     &     FIRST,IOUT,NSHDE
      CALL MPI_BCAST(FIRST,1,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(IOUT,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(NSHDE,1,MPI_INTEGER,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
C***
CWAS  READ(LRSTRT) PD,RES,FIS
      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,3) 
      CALL EXTRACT(DUMMY_MF(1,1,1),PD)
      CALL EXTRACT(DUMMY_MF(1,1,2),RES)
      CALL EXTRACT(DUMMY_MF(1,1,3),FIS)
C
      IF ( ME .EQ. 0 ) READ(LRSTRT) PDB,TB,QB,UB,VB
      CALL MPI_BCAST(PDB,LB*2,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(TB,LB*LM*2,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(QB,LB*LM*2,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(UB,LB*LM*2,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
      CALL MPI_BCAST(VB,LB*LM*2,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
C***
      DO L = 1,LM
        IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
        CALL EXTRACT(DUMMY,T(1,1,L))
        IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
        CALL EXTRACT(DUMMY,Q(1,1,L))
        IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
        CALL EXTRACT(DUMMY,U(1,1,L))
        IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
        CALL EXTRACT(DUMMY,V(1,1,L))
        IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
        CALL EXTRACT(DUMMY,Q2(1,1,L))
        IF ( ME .EQ. 0 ) READ(LRSTRT)
        IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
        CALL EXTRACT(DUMMY,CWM(1,1,L))
        IF ( ME .EQ. 0 ) READ(LRSTRT)
        IF ( ME .EQ. 0 ) READ(LRSTRT)
      ENDDO
C***
      IF ( ME .EQ. 0 ) WRITE(STDOUT,*)'  READ ',LABEL
C
cwas  READ(LRSTRT) RUN,IDAT,IHRST,NTSD,LABEL
cwas &,            RSWIN,RSWOUT,TG,Z0,AKMS,CZEN
      IF ( ME .EQ. 0 ) READ(LRSTRT) RUN,IDAT,IHRST,NTSD,LABEL,itag 
     1,    (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,6) 
      CALL EXTRACT(DUMMY_MF(1,1,1),RSWIN)
      CALL EXTRACT(DUMMY_MF(1,1,2),RSWOUT)
      CALL EXTRACT(DUMMY_MF(1,1,3),TG)
      CALL EXTRACT(DUMMY_MF(1,1,4),Z0)
      CALL EXTRACT(DUMMY_MF(1,1,5),AKMS)
      CALL EXTRACT(DUMMY_MF(1,1,6),CZEN)
C***
cwas  READ(LRSTRT) AKHS,THS,QS,TWBS,QWBS,HBOT,CFRACL
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,7) 
      CALL EXTRACT(DUMMY_MF(1,1,1),AKHS)
      CALL EXTRACT(DUMMY_MF(1,1,2),THS)
      CALL EXTRACT(DUMMY_MF(1,1,3),QS)
      CALL EXTRACT(DUMMY_MF(1,1,4),TWBS)
      CALL EXTRACT(DUMMY_MF(1,1,5),QWBS)
      CALL EXTRACT(DUMMY_MF(1,1,6),HBOT)
      CALL EXTRACT(DUMMY_MF(1,1,7),CFRACL)
C***
cwas  READ(LRSTRT) THZ0,QZ0,UZ0,VZ0,USTAR,HTOP,CFRACM
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,7) 
      CALL EXTRACT(DUMMY_MF(1,1,1),THZ0)
      CALL EXTRACT(DUMMY_MF(1,1,2),QZ0)
      CALL EXTRACT(DUMMY_MF(1,1,3),UZ0)
      CALL EXTRACT(DUMMY_MF(1,1,4),VZ0)
      CALL EXTRACT(DUMMY_MF(1,1,5),USTAR)
      CALL EXTRACT(DUMMY_MF(1,1,6),HTOP)
      CALL EXTRACT(DUMMY_MF(1,1,7),CFRACM)
C***
CWAS  READ(LRSTRT) SNO,WET,CLDEFI,RF,PSLP,CUPPT,CFRACH
CCHOUWAS  READ(LRSTRT) SNO, SI,CLDEFI,RF,PSLP,CUPPT,CFRACH
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,7) 
      CALL EXTRACT(DUMMY_MF(1,1,1),SNO)
      CALL EXTRACT(DUMMY_MF(1,1,2),SI)     !Chou 20221225 EXTRACT(DUMMY,WET) SI is the name in etafcst
      CALL EXTRACT(DUMMY_MF(1,1,3),CLDEFI)
      CALL EXTRACT(DUMMY_MF(1,1,4),RF)
      CALL EXTRACT(DUMMY_MF(1,1,5),PSLP)
      CALL EXTRACT(DUMMY_MF(1,1,6),CUPPT)
      CALL EXTRACT(DUMMY_MF(1,1,7),CFRACH)
C     
C***
cwas  READ(LRSTRT) SOILTB,SFCEXC,SMSTAV,SMSTOT,GRNFLX,PCTSNO
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,6) 
      CALL EXTRACT(DUMMY_MF(1,1,1),SOILTB)
      CALL EXTRACT(DUMMY_MF(1,1,2),SFCEXC)
      CALL EXTRACT(DUMMY_MF(1,1,3),SMSTAV)
      CALL EXTRACT(DUMMY_MF(1,1,4),SMSTOT)
      CALL EXTRACT(DUMMY_MF(1,1,5),GRNFLX)
      CALL EXTRACT(DUMMY_MF(1,1,6),PCTSNO)
C***
CWAS  READ(LRSTRT) RLWIN,RADOT,CZMEAN,SIGT4
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,4) 
      CALL EXTRACT(DUMMY_MF(1,1,1),RLWIN)
      CALL EXTRACT(DUMMY_MF(1,1,2),RADOT)
      CALL EXTRACT(DUMMY_MF(1,1,3),CZMEAN)
      CALL EXTRACT(DUMMY_MF(1,1,4),SIGT4)
C***
CWAS  READ(LRSTRT) U00,UL,LC,SR
      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,3) 
      CALL EXTRACT(DUMMY_MF(1,1,1),U00)
      CALL EXTRACT(DUMMY_MF(1,1,2),LC)
      CALL EXTRACT(DUMMY_MF(1,1,3),SR)
C***
      IF ( ME .EQ. 0 ) WRITE(STDOUT,*)'  READ ',LABEL
C
CWAS  READ(LRSTRT) RUN,IDAT,IHRST,NTSD,LABEL,
CWAS &             PREC,ACPREC,ACCLIQ,CUPREC
      IF ( ME .EQ. 0 ) READ(LRSTRT) RUN,IDAT,IHRST,NTSD,LABEL,itag
     1,    (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,4) 
      CALL EXTRACT(DUMMY_MF(1,1,1),PREC)
      CALL EXTRACT(DUMMY_MF(1,1,2),ACPREC)
      CALL EXTRACT(DUMMY_MF(1,1,3),ACCLIQ)
      CALL EXTRACT(DUMMY_MF(1,1,4),CUPREC)
C***
cwas  READ(LRSTRT) ACFRCV,NCFRCV,ACFRST,NCFRST
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,4) 
      CALL EXTRACT(DUMMY_MF(1,1,1),ACFRCV)
      CALL EXTRACT(DUMMY_MF(1,1,2),NCFRCV)
      CALL EXTRACT(DUMMY_MF(1,1,3),ACFRST)
      CALL EXTRACT(DUMMY_MF(1,1,4),NCFRST)
C**
cwas  READ(LRSTRT) ACSNOW,ACSNOM,SSROFF,BGROFF
      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,4) 
      CALL EXTRACT(DUMMY_MF(1,1,1),ACSNOW)
      CALL EXTRACT(DUMMY_MF(1,1,2),ACSNOM)
      CALL EXTRACT(DUMMY_MF(1,1,3),SSROFF)
      CALL EXTRACT(DUMMY_MF(1,1,4),BGROFF)
C***
cwas  READ(LRSTRT) SFCSHX,SFCLHX,SUBSHX,SNOPCX
cwas 1,            SFCUVX,SFCEVP,POTEVP
      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,7) 
      CALL EXTRACT(DUMMY_MF(1,1,1),SFCSHX)
      CALL EXTRACT(DUMMY_MF(1,1,2),SFCLHX)
      CALL EXTRACT(DUMMY_MF(1,1,3),SUBSHX)
      CALL EXTRACT(DUMMY_MF(1,1,4),SNOPCX)
      CALL EXTRACT(DUMMY_MF(1,1,5),SFCUVX)
      CALL EXTRACT(DUMMY_MF(1,1,6),SFCEVP)
      CALL EXTRACT(DUMMY_MF(1,1,7),POTEVP)
C***
cwas  READ(LRSTRT) ASWIN,ASWOUT,ASWTOA,ALWIN,ALWOUT,ALWTOA
      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,6) 
      CALL EXTRACT(DUMMY_MF(1,1,1),ASWIN)
      CALL EXTRACT(DUMMY_MF(1,1,2),ASWOUT)
      CALL EXTRACT(DUMMY_MF(1,1,3),ASWTOA)
      CALL EXTRACT(DUMMY_MF(1,1,4),ALWIN)
      CALL EXTRACT(DUMMY_MF(1,1,5),ALWOUT)
      CALL EXTRACT(DUMMY_MF(1,1,6),ALWTOA)
C***
      IF ( ME .EQ. 0 ) READ(LRSTRT) ARDSW,ARDLW,ASRFC,AVRAIN,AVCNVC
      CALL MPI_BCAST(ARDSW, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(ARDLW, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(ASRFC, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(AVRAIN,1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
      CALL MPI_BCAST(AVCNVC,1, MPI_INTEGER, 0, MPI_COMM_WORLD, IRTN)
C***
cwas  READ(LRSTRT) TH10,Q10,U10,V10,TSHLTR,QSHLTR,PSHLTR
      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,13) 
      CALL EXTRACT(DUMMY_MF(1,1,1),TH10)
      CALL EXTRACT(DUMMY_MF(1,1,2),Q10)
      CALL EXTRACT(DUMMY_MF(1,1,3),U10)
      CALL EXTRACT(DUMMY_MF(1,1,4),V10)
      CALL EXTRACT(DUMMY_MF(1,1,5),TSHLTR)
      CALL EXTRACT(DUMMY_MF(1,1,6),QSHLTR)
      CALL EXTRACT(DUMMY_MF(1,1,7),PSHLTR)
CGSM v100m
      CALL EXTRACT(DUMMY_MF(1,1,8),TH100)
      CALL EXTRACT(DUMMY_MF(1,1,9),Q100)
      CALL EXTRACT(DUMMY_MF(1,1,10),U100)
      CALL EXTRACT(DUMMY_MF(1,1,11),V100)
CGSM v100m      
CLYRA GSM Wind stress
      CALL EXTRACT(DUMMY_MF(1,1,12),XMOMFLUX)
      CALL EXTRACT(DUMMY_MF(1,1,13),YMOMFLUX)   
CLYRA GSM Wind stress

C***
cwas  READ(LRSTRT) (((SMC(I,J,N),I=1,IM),J=1,JM),N=1,NSOIL)
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,NSOIL) 
      DO II=1, NSOIL
        CALL EXTRACT(DUMMY_MF(1,1,II),SMC(:,:,II))
      ENDDO
C      IF ( ME .EQ. 0 ) READ(LRSTRT)
C***
cwas  READ(LRSTRT) CMC
      IF ( ME .EQ. 0 ) READ(LRSTRT) DUMMY
      CALL EXTRACT(DUMMY,CMC)
C***
cwas  READ(LRSTRT) (((STC(I,J,N),I=1,IM),J=1,JM),N=1,NSOIL)
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,NSOIL) 
      DO II=1, NSOIL
        CALL EXTRACT(DUMMY_MF(1,1,II),STC(:,:,II))
      ENDDO
C      IF ( ME .EQ. 0 ) READ(LRSTRT)

Chou 13/06/2009  more fields available in restrt file
      IF ( ME .EQ. 0 ) READ(LRSTRT)
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,NSOIL) 
      DO II=1, NSOIL
CJLG        CALL EXTRACT(DUMMY_MF(:,:,II),SH2O(:,:,II))
      ENDDO

      IF ( ME .EQ. 0 ) READ(LRSTRT)

      IF ( ME .EQ. 0 ) READ(LRSTRT) 
     1     (((DUMMY_MF(I,J,N),I=1,IM),J=1,JM),N=1,5) 
cANDRE(RESTRT)      READ(LRSTRT) DUMMY
cANDRE(RESTRT)      READ(LRSTRT) DUMMY
      CALL EXTRACT(DUMMY_MF(1,1,2),TLMIN)
      CALL EXTRACT(DUMMY_MF(1,1,3),TLMAX)
Chou  to reach TLMAX and TLMIN
c Lyra GSM Max wind
      CALL EXTRACT(DUMMY_MF(1,1,4),MAXWU)      
      CALL EXTRACT(DUMMY_MF(1,1,5),MAXWV)      
c Lyra GSM Max wind

C***
      IF ( ME .EQ. 0 ) WRITE(STDOUT,*)'END OF RESTART FILE READ'
C     
C     END OF RESTART FILE READ.
C     
C     CLOSE THE RESTART FILE.
      CLOSE(LRSTRT)
C     
C     SET UP THESE FLAGS FOR ETA2P     
C     
      IOOMG=.FALSE.
      IOALL=.FALSE.
C***
C***  BOUND SR BY 0 AND 1
C***
      DO J=JSTA,JEND
      DO I=1,IM
        SR(I,J)=MAX(SR(I,J),0.)
        SR(I,J)=MIN(SR(I,J),1.)
      ENDDO
      ENDDO
C***
C***  FILL IN THE EXTRA-LEVEL ARRAYS WITH VALUES AT L=LM
C***  WHEREVER THERE ARE NO STEPS.
C***
      DO J=JSTA,JEND
      DO I=1,IM
        LMHK=LMH(I,J)
        IF(LMHK.EQ.LM)THEN
          PDSL(I,J)=RES(I,J)*PD(I,J)
          TH10(I,J)=T(I,J,LM)*(1.0E5/(AETA(LM)*PDSL(I,J)+PT))**CAPA
          Q10(I,J)=Q(I,J,LM)
        ENDIF
      ENDDO
      ENDDO
C
CHOU 20221229      DO J=JSTA,JEND
CHOU 20221229      DO I=1,IM
CHOU 20221229        LMVK=LMV(I,J)
CHOU 20221229        IF(LMVK.EQ.LM)THEN 
CHOU 20221229          U10(I,J)=U(I,J,LM)
CHOU 20221229          V10(I,J)=V(I,J,LM)
CHOU 20221229       ENDIF
CHOU 20221229     ENDDO
CHOU 20221229     ENDDO
C
C     CLIP NEGATIVE SPECIFIC HUMIDITY.
C
      DO 100 L=1,LM
      CALL BOUNDL(Q(1,1,L),H1M12,H99999,IM,JM)
  100 CONTINUE 
      IF ( ME .EQ. 0 )
     X WRITE(STDOUT,*)'INITPOST:  CLIP NEGATIVE SPECIFIC HUMIDITY'
C     
C     COMPUTE PRESSURE AND LN(P) AT INTERFACES.
C     SET SURFACE VALUES.
C     
!$omp  parallel do
!$omp& private(pbi)
      DO J=JSTA,JEND
      DO I=1,IM
        PDSL(I,J)      =RES(I,J)*PD(I,J)
        PBI            =PD(I,J)+PT
        PINT(I,J,LP1)  =PBI
        ALPINT(I,J,LP1)=ALOG(PBI)
      ENDDO
      ENDDO
C     
C     COMPUTE OMEGA ON ETA LEVELS.
C
!$omp  parallel do
!$omp& private(rtopkl)
      DO 125 L=1,LM
      DO J=JSTA,JEND
      DO I=1,IM
        RTOPKL=RDYN*T(I,J,L)*(H1+D608*Q(I,J,L))/
     1         (PDSL(I,J)*AETA(L)+PT)
        IF(ABS(RTOPKL).GT.H1M12) 
     1       OMGA(I,J,L)=OMGA(I,J,L)*CP/(RTOPKL*DT)
      ENDDO
      ENDDO
  125 CONTINUE
C
C     CALCULATE AVERAGE PRESSURE DIFFERENCE BETWEEN ETA=1 AND ETA=0
C     AT VELOCITY POINTS (PDVP1) USING THE VALUES ALREADY KNOWN AT
C     HEIGHT POINTS (PDSL).
C
      CALL EXCH(PDSL)
!$omp  parallel do
      DO J=2,JM-1,2
      DO I=2,IM-1
        PDVP1(I,J)=0.25*(PDSL(I-1,J)+PDSL(I,J)
     1                  +PDSL(I,J+1)+PDSL(I,J-1))
      ENDDO
      ENDDO
!$omp  parallel do
      DO J=3,JM-1,2
      DO I=1,IM-1
        PDVP1(I,J)=0.25*(PDSL(I+1,J)+PDSL(I,J)
     1                  +PDSL(I,J+1)+PDSL(I,J-1))
      ENDDO
      ENDDO
C
!$omp  parallel do
      DO I=1,IM-1
        PDVP1(I,1)=0.5*(PDSL(I,1)+PDSL(I+1,1))
        PDVP1(I,JM)=0.5*(PDSL(I,JM)+PDSL(I+1,JM))
      ENDDO
C
!$omp  parallel do
      DO J=2,JM-1,2
        PDVP1(1,J)=0.5*(PDSL(1,J-1)+PDSL(1,J+1))
        PDVP1(IM,J)=0.5*(PDSL(IM,J-1)+PDSL(IM,J+1))
      ENDDO
C
      PDVP1(IM,JM)=PDVP1(IM-1,JM)
C     
C     FIND THE HIGHEST ETA LAYER CONTAINING MOUNTAINS.
C     
      DO 150 L=LM,1,-1
C
      DO J=JSTA,JEND
      DO I=1,IM
        IF (HTM(I,J,L).EQ.D00)GO TO 150
      ENDDO
      ENDDO
C
      LHMNT=L+1
      GO TO 155
  150 CONTINUE
  155 IF(LHMNT.EQ.LP1)THEN
CHOU 20230201        IF(.NOT.SIGMA)THEN
          GO TO 175
CHOU 20230201        ELSE
CHOU 20230201          LHMNT = LM
CHOU 20230201        ENDIF
      ENDIF
C***
C***  NOW GATHER THE ADDRESSES OF ALL THE UNDERGROUND POINTS.
C***
      do170: DO L=LHMNT,LM
      KMN=0
      KMNTM(L)=0
C
      K=0
      doout160: DO J=1,JM
      IEND=IM
      IF(MOD(J,2).EQ.0)IEND=IM-1
      doin160: DO  I=1,IEND
      K=K+1
      IF ( J .GE. JSTA .AND. J .LE. JEND ) THEN
         KMNT(K,L)=0
         IF(HTM(I,J,L).EQ.H1)CYCLE doin160
         KMN=KMN+1
         KMNT(KMN,L)=K
      END IF
      END DO doin160
      END DO doout160
      KMNTM(L)=KMN
      END DO do170
  175 CONTINUE
 
C     
C     COMPUTE PRESSURE VALUES ABOVE THE SURFACE.
C
!$omp  parallel do
!$omp& private(pbi)
      DO L=LM,1,-1
        DO J=JSTA,JEND
        DO I=1,IM
          PBI          =PDSL(I,J)*ETA(L)+PT
          PINT(I,J,L)  =PBI     
          ALPINT(I,J,L)=ALOG(PBI)
        ENDDO
        ENDDO
      ENDDO
C
C     COMPUTE PRESSURE VALUES BELOW THE SURFACE.
C
      KMM=KMNTM(LM)
      DO KM=1,KMM
        K=KMNT(KM,LM)
        NDROW=K/IMT
        LFTOV1=MOD(K,IMT)
        IF(LFTOV1-IM.GT.0)THEN
          I=K-NDROW*IMT-IM
          IADD=2
        ELSEIF(LFTOV1.GT.0)THEN
          I=K-NDROW*IMT
          IADD=1
        ELSEIF(LFTOV1.EQ.0)THEN
          I=IM-1
          IADD=0
        ENDIF
        J=2*NDROW+IADD
C
C       COMPUTE ALPINT AND PINT ONLY FOR THOSE POINTS THAT WE OWN
C
C       IF ( J .GE. JSTA .AND. J .LE. JEND ) THEN
C
        LMAP1=LMH(I,J)+1
        DO L=LMAP1,LM
          ALPINT(I,J,L+1)=(DFL(L)-DFL(L+1))/(R*T(I,J,L))
     1                   +ALPINT(I,J,L)
          PINT(I,J,L+1)=EXP(ALPINT(I,J,L+1))
        ENDDO
C       END IF
      ENDDO
C
C     CALCULATE THE I-INDEX EAST-WEST INCREMENTS
C
      DO J=1,JM
        IHE(J)=MOD(J+1,2)
        IHW(J)=IHE(J)-1
        IVE(J)=MOD(J,2)
        IVW(J)=IVE(J)-1
      ENDDO
C
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)'INITPOST:  COMPLETE ONE TIME CALCULATIONS'
      ENDIF
C     
C     END OF ROUTINE.
C     
      IF ( ME .EQ. 0 ) THEN
      WRITE(STDOUT,*)'INITPOST:  ALL INPUT DATA READ/PREPARED.'
      WRITE(STDOUT,*)' '
      ENDIF
      CALL MPI_BARRIER(MPI_COMM_WORLD,IRTN)
      RETURN
      END

      SUBROUTINE P2FLTV(MKOUNT,VBM2,FIELD)
CFPP$ NOCONCUR R
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    P2FLTV      4-TH ORDER SMOOTHER for vel pts
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-03-02
C     
C ABSTRACT:
C     THIS ROUTINE WILL APPLY A FOURTH OTHER FILTER (SMOOTHER)
C     OF A CONTINOUS FIELD AT VELOCITY POINTS ON THE STAGGERED
C     E-GRID.  MULTIPLE APPLICATIONS OF THIS FILTER MAY BE
C     MADE.  
C     IN THIS VERSION, EACH TASK WORKS ON THE DATA IT OWNS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-03-02  RUSS TREADON - MODIFIED SUBROUTINE P2FILT.
C   98-06-04  BLACK - CONVERSION TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL P2FLTV(MKOUNT,VBM2,FIELD)
C   INPUT ARGUMENT LIST:
C     MKOUNT   - NUMBER OF APPLICATIONS OF THE SMOOTHER.
C     HBM2     - VELOCITY POINT BOUNDARY MASK.
C     FIELD    - VELOCITY POINT FIELD TO BE SMOOTHED.
C
C   OUTPUT ARGUMENT LIST: 
C     FIELD    - SMOOTHED VELOCITY POINT FIELD.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY Y-MP
C$$$  
C     
C     
C     INCLUDE GLOBAL PARAMETERS.  SET DEPENDENT VARIABLES.
C
C----------------------------------------------------------------------
      INCLUDE "parmeta"
C
      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C----------------------------------------------------------------------
                            D I M E N S I O N
     & VBM2(IM,JM),FIELD(IM,JM),WFIELD(IM,JM),FNE(IM,JM),FSE(IM,JM)
C     
C***********************************************************************
C     START P2FLTV HERE.
C     
C     IF NUMBER OF PASSES IS LESS THAN 1, EXIT ROUTINE.
C
      IF(MKOUNT.LT.1)        RETURN
C     
C     OTHERWISE, APPLY SMOOTHER MKOUND TIMES.
C
C-----------------------------------------------------------------------
      DO 400 KOUNT=1,MKOUNT
C-----------------------------------------------------------------------
C
C        FILTERING STARTS
C
C-----------------------------------------------------------------------
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        FNE   (I,J)=0.0
        FSE   (I,J)=0.0
        WFIELD(I,J)=0.0
      ENDDO
      ENDDO
C
C
      CALL EXCH(FIELD)
C
C        2-ND ORDER DIAGONAL CONTRIBUTIONS
C
!$omp  parallel do
      DO J=JSTA,JEND_M
      DO I=1,IM-1
        FNE(I,J)=FIELD(I+IVE(J),J+1)-FIELD(I,J)
      ENDDO
      ENDDO
C
!$omp  parallel do
      DO J=JSTA_M,JEND
      DO I=1,IM-1
        FSE(I,J)=FIELD(I+IVE(J),J-1)-FIELD(I,J)
      ENDDO
      ENDDO
C
      CALL EXCH(FNE)
      CALL EXCH(FSE)
C
!$omp  parallel do
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        WFIELD(I,J)=(FNE(I,J)-FNE(I+IVW(J),J-1)
     1              +FSE(I,J)-FSE(I+IVW(J),J+1))
     2              *VBM2(I,J)*0.125
      ENDDO
      ENDDO
C
C        4-TH ORDER DIAGONAL CONTRIBUTIONS
C
       CALL EXCH(WFIELD)
C
!$omp  parallel do
      DO J=JSTA,JEND_M
      DO I=1,IM-1
        FNE(I,J)=WFIELD(I+IHE(J),J+1)-WFIELD(I,J)
      ENDDO
      ENDDO
C
!$omp  parallel do
      DO J=JSTA_M,JEND
      DO I=1,IM-1
        FSE(I,J)=WFIELD(I+IVE(J),J-1)-WFIELD(I,J)
      ENDDO
      ENDDO
C
      CALL EXCH(FNE)
      CALL EXCH(FSE)
C
!$omp  parallel do
      DO J=JSTA_M2,JEND_M2
      DO I=2,IM-1
        FIELD(I,J)=FIELD(I,J)-(FNE(I,J)-FNE(I+IVW(J),J-1)
     1                        +FSE(I,J)-FSE(I+IVW(J),J+1))
     2                        *VBM2(I,J)*0.125
      ENDDO
      ENDDO
C
 400  CONTINUE
C     
      CALL EXCH(FIELD)
C
C     END OF ROUTINE
      RETURN
      END

      SUBROUTINE PROCESS
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    PROCESS     DRIVER FOR MAJOR POST ROUTINES.
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-21       
C     
C ABSTRACT:
C     THIS ROUTINE CALLS THE MAJOR POST PROCESSOR ROUTINES.
C     THESE ROUTINES ARE
C        ETAFLD2 - CALCULATE NMC SLP, SET BELOW SURFACE FIELDS,
C                  AND POSTS DATA ON ETA SURFACES.
C        ETA2P   - POSTS DATA ON ISOBARIC SURFACES.
C        SURFCE2 - POSTS SOUNDING DATA, SURFACE BASED FIELDS, 
C                  AND STATIC OR FIXED FIELDS.
C        CLDRAD  - POST SOUNDING/CLOUD/RADIATION FIELDS.
C        MISCLN  - POST MISCELLANEOUS (SPECIAL) FIELDS.
C        FIXED   - POST FIXED FIELDS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-21  RUSS TREADON
C   98-06-01  T BLACK - CONVERSION OF POST FROM 1-D TO 2-D
C   00-01-05  JIM TUCCILLO - MPI VERSION
C   00-07-01  H CHUANG - ADDED CALLS TO SIG2P
C   00-09-22  H CHUANG - ADDED OPTIONS TO INTERPOLATE FIELDS FROM SIGMA
C             TO PRESSURE LEVELS USING SPINE (ADOPTED from Janjic)  
C     
C USAGE:    CALL PROCESS
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       ETAFLD2  - POST DATA ETA SURFACES.
C       ETA2P    - POST DATA ON PRESSURE SURFACES.
C       SURFCE2  - POST SURFACE BASED FIELDS.
C       CLDRAD   - POST SOUNDING/CLOUD/RADIATION FIELDS.
C       MISCLN   - POST MISCELLANEOUS FIELDS.
C       FIXED    - POST FIXED FIELDS.
C     LIBRARY:
C       COMMON   - OUTGRD
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE PARAMETERS.
      INCLUDE "parmout"
C
C     DECLARE VARIABLES.
C     
      CHARACTER*6  DATSET,PROJ
      LOGICAL NORTH,SIGMA
C     
C     INCLUDE I/O COMMON BLOCK.
      INCLUDE "OUTGRD.comm"
      INCLUDE "CTLBLK.comm"
c
      common/tim_info/ETAFLD2_tim,ETA2P_tim,SURFCE2_tim, CLDRAD_tim,
     *                MISCLN_tim,FIXED_tim
C
C****************************************************************************
C     START SUBROUTINE PROCESS.
C
C     
C     COMPUTE/POST FIELDS ON ETA SURFACES.
C
      btim = timef()
      CALL ETAFLD2(IGOUT,JGOUT)
      ETAFLD2_tim = ETAFLD2_tim +(timef() - btim)
C
C     COMPUTE/POST FIELDS ON PRESSURE SURFACES.
      btim = timef()
cc      SPLINE=.TRUE.
CHOU 20230201      IF(SIGMA)THEN
CHOU 20230201       IF(SPLINE)THEN
CHOU 20230201        print*,'calling sig2pspline'
CHOU 20230201        CALL SIG2PSPLINE(IGOUT,JGOUT) 
CHOU 20230201       ELSE 
CHOU 20230201        print*,'calling sig2p'
CHOU 20230201        CALL SIG2P(IGOUT,JGOUT)
CHOU 20230201       END IF
CHOU 20230201      ELSE
       CALL ETA2P(IGOUT,JGOUT)
CHOU 20230201      END IF
      ETA2P_tim = ETA2P_tim +(timef() - btim)
C
C     COMPUTE/POST SURFACE RELATED FIELDS.
      btim = timef()
      CALL SURFCE2(IGOUT,JGOUT)
      SURFCE2_tim = SURFCE2_tim +(timef() - btim)
C
C     COMPUTE/POST SOUNDING AND CLOUD RELATED FIELDS.
      btim = timef()
      CALL CLDRAD(IGOUT,JGOUT)
      CLDRAD_tim = CLDRAD_tim +(timef() - btim)
C
C     COMPUTE/POST TROPOPAUSE DATA, FD LEVEL FIELDS,
C     FREEZING LEVEL HEIGHT AND RH, BOUNDARY LAYER FIELDS,
C     AND LFM-NGM LOOK-ALIKE FIELDS.
      btim = timef()
      CALL MISCLN(IGOUT,JGOUT)
      MISCLN_tim = MISCLN_tim +(timef() - btim)
C
C     POST FIXED FIELDS.
      btim = timef()
      CALL FIXED(IGOUT,JGOUT)
      FIXED_tim =  FIXED_tim +(timef() - btim)
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE E2TLL(HTLAT,HTLON,VTLAT,VTLON)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    E2TLL       COMPUTE ETA TRNSFM (LAT,LON)
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES THE TRANSFORMED LATITUDE AND 
C     LONGITUDE OF MASS (H) AND VELOCITY (V) POINTS FOR
C     GIVEN ETA E-GRID SPECIFICATIONS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - ROUTINE ETATLL IN ETAPACKC
C   92-12-23  RUSS TREADON  - GENERALIZED FOR ETAPOST USE.
C   98-06-04  BLACK - CONVERSION TO 2-D
C     
C USAGE:    CALL E2TLL(HTLAT,HTLON,VTLAT,VTLON)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     HTLAT    - TRANSFORMED LATITUDE OF H POINTS
C     HTLON    - TRANSFORMED LONGITUDE OF H POINTS
C     VTLAT    - TRANSFORMED LATITUDE OF V POINTS
C     VTLON    - TRANSFORMED LONGITUDE OF V POINTS
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - EGRID
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     INCLUDE ETA GRID SPECIFICATIONS.  DERIVE OTHER PARAMETERS.
C------------------------------------------------------------------     
      INCLUDE "parmeta"
C------------------------------------------------------------------     
      PARAMETER (ICEN=2*IM/2,JCEN=(JM+1)/2)
C------------------------------------------------------------------     
C     
C     DECLARE VARIABLES.
C     
      LOGICAL NORTH
      REAL ALONVT, DLAM, DPHI, LAM0, PHI0, POLEI, POLEJ
      REAL SINPH0, TANPH0, WLONC, XMESHL, YLATC
      REAL HTLAT(IM,JM),HTLON(IM,JM)
      REAL VTLAT(IM,JM),VTLON(IM,JM)
C------------------------------------------------------------------     
      EQUIVALENCE (YLATC,ALONVT), (DPHI, POLEI)
      EQUIVALENCE (WLONC, POLEJ), (DLAM,XMESHL)
C------------------------------------------------------------------     
      INCLUDE "EGRID.comm"
C************************************************************************
C***
C***  TRANFORMED LONGITUDE OF WESTERN BOUNDARY AND
C***  TRANSFORMED LATITUDE OF SOUTHERN BOUNDARY
C***
      WBD=-1*((IM-1)*DLAM)
      SBD=-1*((JM-1)/2*DPHI)
C     
C     COMPUTE TRANSFORMED (LAT,LON) OF THE HEIGHTS POINTS
C     ON THE ETA GRID.
C
      DO J=1,JM
      ELON=WBD+MOD(J+1,2)*DLAM-2.*DLAM
      ELAT=SBD+(J-1)*DPHI
      DO I=1,IM
        ELON=ELON+2.*DLAM
        HTLON(I,J)=ELON
        HTLAT(I,J)=ELAT
      ENDDO
      ENDDO
C     
C     COMPUTE TRANSFORMED (LAT,LON) OF THE VELOCITY POINTS 
C     ON THE ETA GRID.
C
      DO J=1,JM
      ELON=WBD+MOD(J,2)*DLAM-2.*DLAM
      ELAT=SBD+(J-1)*DPHI
      DO I=1,IM
        ELON=ELON+2.*DLAM
        VTLON(I,J)=ELON
        VTLAT(I,J)=ELAT
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE CALDWP2(P1D,Q1D,TDWP,T1D)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALDWP2     COMPUTES 
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22
C     
C ABSTRACT:  COMPUTES ANEMOMETER LEVEL WINDS.  AT EACH WIND
C   POINT IN THE GRID FIT A LOGRITHMIC, THEN LINEAR PROFILE 
C   BETWEEN THE WIND COMPONENTS AT Z0 AND THOSE IN THE FIRST
C   ATMOSPHERIC ETA LAYER.  WE MATCH THE TWO PROFILES AT A
C   CRITICAL HEIGHT, ZC, MAINTAINING ZEROTH AND FIRST ORDER 
C   CONTINUITY.   IF THE DISTANCE BETWEEN THE SURFACE AND 
C   THE FIRST ATMOSPHERIC ETA LAYER EXCEEDS A SWITCH HEIGHT,
C   ZSWITCH, WE ASSUME AN INVERSE EXPONENTIAL PROFILE BETWEEN
C   THE WIND COMPONENTS AT Z0 AND THOSE IN THE FIRST ATMOSPHERIC
C   ETA LAYER.  THIS INVERSE EXPONENTIAL PROFILE WAS A TEMPORARY
C   FIX TO AVOID UNREASONABLY SMALL ANEMOMETER LEVEL WINDS.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   93-10-04  RUSS TREADON - ADDED CHECK TO BOUND DEWPOINT
C                            TEMPERATURE TO NOT EXCEED THE
C                            AMBIENT TEMPERATURE.
C   98-06-08  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION                
C     
C USAGE:    CALL CALDWP2(P1D,Q1D,TDWP,T1D)
C   INPUT ARGUMENT LIST:
C     P1D      - PRESSURE (PA)
C     Q1D      - SPECIFIC HUMIDITY (KG/KG)
C     T1D      - TEMPERATURE (K)
C
C   OUTPUT ARGUMENT LIST: 
C     TDWP     - DEWPOINT TEMPERATURE (K)

C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       DEWPOINT - COMPUTES DEWPOINT GIVEN VAPOR PRESSURE.
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C
C
C     SET PARAMETERS.
      INCLUDE "parmeta" 
      INCLUDE "params"
      INCLUDE "CTLBLK.comm"
C     
C     DECLARE VARIABLES.
C     
      REAL EVP(IM,JM),P1D(IM,JM),Q1D(IM,JM),TDWP(IM,JM),T1D(IM,JM)
C     
C     
C****************************************************************************
C     START CALDWP2 HERE.
C     
C     COMPUTE VAPOR PRESSURE.  CONVERT TO CENITBARS.
C     
      DO J=JSTA,JEND
      DO I=1,IM
        EVP(I,J) = P1D(I,J)*Q1D(I,J)/(EPS+ONEPS*Q1D(I,J))
        EVP(I,J) = EVP(I,J)*D001
        EVP(I,J) = AMAX1(H1M12,EVP(I,J))
      ENDDO
      ENDDO
C     
C     COMPUTE DEWPOINT TEMPERATURE.
C     
      CALL DEWPOINT(EVP,TDWP,IM,JM)
C     
C     ENSURE DEWPOINT TEMPERATURE DOES NOT EXCEED AMBIENT TEMPERATURE.
C     
      DO J=JSTA,JEND
      DO I=1,IM
        IF (TDWP(I,J).GT.T1D(I,J)) TDWP(I,J) = T1D(I,J)
      ENDDO
      ENDDO
C
C     END OF ROUTINE.
C     
      RETURN
      END

      FUNCTION WDIR(X,Y)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    WDIR        CMPTE VEC DIR FROM U-V
C   PRGRMMR: TREADON         ORG: W/NMC2     DATE: 93-05-12       
C     
C ABSTRACT:  
C     GIVEN U AND V WIND COMPONENTS, THIS FUNCTION CALCULATES
C     THE VECTOR WIND DIRECTION (IN DEGREES)
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  CHRIS PETERS ??
C   93-05-12  RUSS TREADON - ADDED DOCBLOC
C     
C USAGE:   WIND = WDIR(X,Y)
C   INPUT ARGUMENT LIST:
C     X        - U WIND COMPONENT
C     Y        - V WIND COMPONENT
C
C   OUTPUT ARGUMENT LIST: 
C     WDIR     - VECTOR WIND DIRECTION IN DEGREES
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       DIR    - CONPUTE VECTOR WIND DIRECTION FROM U-V WIND.
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY Y-MP
C$$$  
C     
C**********************************************************************
C     START WDIR HERE.
C
      RDIR = 270.-DIR(X,Y)
      IF (RDIR.LT.0.) RDIR = RDIR+360.
      IF (RDIR.GE.360.) RDIR = RDIR-360.
      WDIR = RDIR
      RETURN
      END

      SUBROUTINE MPI_LAST
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    MPI_LAST    SHUTS DOWN MPI
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     SHUTS DOWN MPI
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C
C USAGE:    CALL COLLECT(A)
C   INPUT ARGUMENT LIST:
C
C   OUTPUT ARGUMENT LIST:
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_FINALIZE
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$

      call MPI_FINALIZE(ierr)
      end

      SUBROUTINE GENBIL(EGFUL,IMOT,JMOT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    GENBIL      COMPUTE BILINEAR INTRP WEIGHTS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23       
C     
C ABSTRACT:
C     THIS ROUTINE IS BASED ON CODE SUBROUTINE INTERP FOUND
C     IN DAVID PLUMMER'S ETAPACKC.  GIVEN THE E-GRID AND
C     OUTPUT GRID BILINEAR INTERPOLATION WEIGHTS ARE COMPUTED
C     AND SAVED COMMON BLOCK LLGRDS ARRAYS.  THE PASSED FILLED
C     E-GRID ARRAY, EGFUL CAN CONTAIN ANY FIELD.  IT IS USED
C     TO DETERMINE THE EXTENT KNOW DATA VALUES IN THE E-GRID.
C     THOSE GRID POINTS ON THE E-GRID WHICH EQUAL OR EXCEED
C     THE SPECIAL VALUE, SPVC, ARE TREATED DIFFERENTLY IN THE
C     INTERPOLATION.  FOR MOST APPLICATIONS THIS CHECK IS NOT
C     NECESSARY.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DAVID PLUMMER - SUBROUTINE INTERP IN ETAPACKC
C   92-12-23  RUSS TREADON - EXTRACTED CODE FROM INTERP AND 
C                               GENERALIZED TO HANDLE VARIOUS  
C                               INPUT AND OUTPUT GRIDS
C     
C USAGE:    CALL GENBIL(EGFUL,IMOT,JMOT)
C   INPUT ARGUMENT LIST:
C     EGFUL    - FILLED E-GRID DEFINING EXTENT OF E-GRID.  
C     IMOT     - FIRST DIMENSION OF OUTPUT GRID.
C     JMOT     - SECOND DIMENSION OF OUTPUT GRID.
C   OUTPUT ARGUMENT LIST: 
C     
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LLGRDS
C                  IOUNIT
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C
C     INCLUDE DECLARED GRID DIMENSIONS.
      INCLUDE "parmeta"
      INCLUDE "parmout"
      PARAMETER (IMJM=IM*JM-JM/2,IMT=2*IM-1,JMT=JM)
C     
C     DECLARE VARIABLES.
      LOGICAL LM0N0,LM1N0,LM0N1,LM1N1
      INTEGER IMOT,JMOT
      REAL EGFUL(IMT,JMT)
C     
C     INCLUDE COMMON.
      INCLUDE "LLGRDS.comm"
      INCLUDE "IOUNIT.comm"
C
C     SET TOLERANCE LIMITS.
C     
      DATA SPVC,SMALL /1.E20,1.E-4/
C     
C******************************************************************
C     START GENBIL HERE.
C     
C     COMPUTE INTERPOLATION WEIGHTS.
C     
      WRITE(STDOUT,*)'GENBIL:  GENERATE BILIN WEIGHTS'
      MAXI = IMT
      MAXJ = JMT
      doout90: DO J = 1,JMOT
         doin90: DO I = 1,IMOT
            XX = EGRDI(I,J)
            YY = EGRDJ(I,J)
            M = XX                                                           
            N = YY 
            IEGRD(I,J) = M
            JEGRD(I,J) = N
C
            IF ( ( M.LE.0   ).OR.( N.LE.0   ) ) THEN
               WIJ(I,J)   = 0.
               WIPJ(I,J)  = 0.
               WIJP(I,J)  = 0.
               WIPJP(I,J) = 0.
               IWGT(I,J)  = 0
               GOTO 75
            ENDIF
C
            IF ( (XX.GT.MAXI).OR.(YY.GT.MAXJ) ) THEN
               WIJ(I,J)   = 0.
               WIPJ(I,J)  = 0.
               WIJP(I,J)  = 0.
               WIPJP(I,J) = 0.
               IWGT(I,J)  = 0
               GOTO 75
            ENDIF
C
            DX  = (XX - M)                                                    
            DY  = (YY - N)                                                    
            DX1 = 1.0 - DX                                                   
            DY1 = 1.0 - DY                                                   
            IF ( (ABS(DX ).LT.SMALL).AND.(ABS(DY ).LT.SMALL) ) THEN
               W00 = 1.
               W10 = 0.
               W01 = 0.
               W11 = 0.
               WIJ(I,J)   = W00
               WIPJ(I,J)  = W10
               WIJP(I,J)  = W01
               WIPJP(I,J) = W11
               IWGT(I,J)  = 1
               GOTO 75
CX               DAT = EGFUL(M,N)
            ELSEIF ( (ABS(DX ).LT.SMALL).AND.
     X              (ABS(DY1).LT.SMALL) ) THEN
               W00 = 0.
               W10 = 0.
               W01 = 1.
               W11 = 0.
               WIJ(I,J)   = W00
               WIPJ(I,J)  = W10
               WIJP(I,J)  = W01
               WIPJP(I,J) = W11
               IWGT(I,J)  = 1
               GOTO 75
CX               DAT = EGFUL(M,N+1)
            ELSEIF ( (ABS(DX1).LT.SMALL).AND.
     X              (ABS(DY ).LT.SMALL) )  THEN
               W00 = 0.
               W10 = 1.
               W01 = 0.
               W11 = 0.
               WIJ(I,J)   = W00
               WIPJ(I,J)  = W10
               WIJP(I,J)  = W01
               WIPJP(I,J) = W11
               IWGT(I,J)  = 1
               GOTO 75
CX               DAT = EGFUL(M+1,N)
            ELSEIF ( (ABS(DX1).LT.SMALL).AND.
     X              (ABS(DY1).LT.SMALL) )  THEN
               W00 = 0.
               W10 = 0.
               W01 = 0.
               W11 = 1.
               WIJ(I,J)   = W00
               WIPJ(I,J)  = W10
               WIJP(I,J)  = W01
               WIPJP(I,J) = W11
               IWGT(I,J)  = 1
               GOTO 75
CX               DAT = EGFUL(M+1,N+1)
            END IF                                                           
C
C	    DONE WITH SPECIAL CASES.  NOW FOR GENERAL CASES.
C
            LM0N0 = (EGFUL(M  ,N  ).GE.SPVC)                                  
            LM1N0 = (EGFUL(M+1,N  ).GE.SPVC)                                  
            LM0N1 = (EGFUL(M  ,N+1).GE.SPVC)                                  
            LM1N1 = (EGFUL(M+1,N+1).GE.SPVC)                                  
            IF ( (.NOT.LM0N0).AND.(.NOT.LM1N0).AND.
     X           (.NOT.LM0N1).AND.(.NOT.LM1N1) ) THEN
               W00 = (1.-DY)*(1.-DX)
               W10 = (1.-DY)*DX
               W01 = DY*(1.-DX)
               W11 = DY*DX
               WIJ(I,J)   = W00
               WIPJ(I,J)  = W10
               WIJP(I,J)  = W01
               WIPJP(I,J) = W11
               IWGT(I,J)  = 1
CX               DAT = (1.0-DY)*((1.0-DX)*EGFUL(M,N) +
CX                     DX*EGFUL(M+1,N)) +  
CX                     DY*((1.0-DX)*EGFUL(M,N+1) +
CX                     DX*EGFUL(M+1,N+1))    
               GOTO 75
            ELSEIF (LM0N0.AND.LM1N0.AND.LM0N1.AND.LM1N1) THEN              
               WIJ(I,J)   = 0.
               WIPJ(I,J)  = 0.
               WIJP(I,J)  = 0.
               WIPJP(I,J) = 0.
               IWGT(I,J)  = 0
               GOTO 75
CX               DAT = SPVAL                                                   
            ELSE                                                             
               IM0N0 = 1                                                     
               IF (LM0N0)  IM0N0 = 0                                         
               IM1N0 = 1                                                     
               IF (LM1N0)  IM1N0 = 0                                         
               IM0N1 = 1                                                     
               IF (LM0N1)  IM0N1 = 0                                         
               IM1N1 = 1                                                     
               IF (LM1N1)  IM1N1 = 0                                         
               RXX = ((SQRT(2.0)/4.0)*(IM0N0+IM1N0+IM0N1+IM1N1))**2      
               R00 = (     DX *     DX)  + (     DY *     DY)                
               R10 = ((1.0-DX)*(1.0-DX)) + (     DY *     DY)                
               R01 = (     DX *     DX)  + ((1.0-DY)*(1.0-DY))               
               R11 = ((1.0-DX)*(1.0-DX)) + ((1.0-DY)*(1.0-DY))               
               W00 = IM0N0 * MAX(0.0,(RXX - R00)) / (RXX + R00)              
               W10 = IM1N0 * MAX(0.0,(RXX - R10)) / (RXX + R10)              
               W01 = IM0N1 * MAX(0.0,(RXX - R01)) / (RXX + R01)              
               W11 = IM1N1 * MAX(0.0,(RXX - R11)) / (RXX + R11)              
               WSUM = W00 + W01 + W10 + W11                                  
               IF (WSUM .NE. 0.0)  THEN                                      
                  WIJ(I,J)   = W00/WSUM
                  WIPJ(I,J)  = W10/WSUM
                  WIJP(I,J)  = W01/WSUM
                  WIPJP(I,J) = W11/WSUM
                  IWGT(I,J)  = 1
                  GOTO 75
CX                DAT = (W00*EGFUL(M,N)+W10*EGFUL(M+1,N) +
CX                  W01*EGFUL(M,N+1)+W11*EGFUL(M+1,N+1)) / WSUM 
               ELSE                                                          
                  WIJ(I,J)   = 0.
                  WIPJ(I,J)  = 0.
                  WIJP(I,J)  = 0.
                  WIPJP(I,J) = 0.
                  IWGT(I,J)  = 0
                  GOTO 75
CX                  DAT = SPVAL                                                
               END IF
            END IF       
            WRITE(STDOUT,*)'GENWGT:  SHOULD NOT REACH THIS LINE'
 75         CONTINUE
      END DO doin90
      END DO doout90
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE MISCLN(IMOUT,JMOUT)
C
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    MISCLN      POSTS MISCELLANEOUS FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-20
C     
C ABSTRACT:
C     THIS ROUTINE HAS BECOME THE CATCH-ALL FOR MISCELLANEOUS
C     OUTPUT FIELDS POSTED BY THE ETA POST PROCESSOR.  
C     CURRENTLY THIS ROUTINE POSTS THE FOLLOWING FIELDS:
C        (1) TROPOPAUSE LEVEL Z,P, T, U, V, AND VERTICAL WIND SHEAR,
C        (2) MAX WIND LEVEL Z, P, U, AND V,
C        (3) FD LEVEL T, U, AND V,
C        (4) FREEZING LEVEL Z AND RH,
C        (5) CONSTANT MASS (BOUNDARY) FIELDS,
C        (6) LFM LOOK-ALIKE FIELDS, AND
C        (7) NGM LOOK-ALIKE FIELDS.
C
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-20  RUSS TREADON
C   93-06-19  RUSS TREADON - ADDED TYPE 2 CAPE POSTING.
C   94-11-07  MIKE BALDWIN - ADDED HELICITY POSTING.
C   96-03-26  MIKE BALDWIN - CHANGE ETA BOUNDARY LAYER LABELS FOR GRIB
C   96-11-19  MIKE BALDWIN - BACK OUT PREVIOUS CHANGE 
C   97-04-25  MIKE BALDWIN - CHANGE ETA BOUNDARY LAYER LABELS FOR GRIB
C   97-04-29  GEOFF MANIKIN - ADDED TROPOPAUSE HEIGHT AND
C                             MAX WIND LEVEL FIELDS
C   98-06-15  T BLACK       - CONVERSION FROM 1-D TO 2-D
C   98-07-17  MIKE BALDWIN - REMOVED LABL84
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL MISCLN(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID.
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID.
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     STDOUT   - RUN-TIME MESSAGES (FOR DEBUGGING, NOW TURNED OFF)
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       TRPAUS  - COMPUTE TROPOPAUSE LEVEL FIELDS.
C       CALMXW  - COMPUTE MAX WIND LEVEL FIELDS.
C       E2OUT   - INTERPOLATE STAGGERED E-GRID TO OUTPUT GRID.
C       SCLFLD  - SCALE ARRAY ELEMENTS BY CONSTANT.
C       OUTPUT  - DRIVER FOR TYPE OF FILE OUTPUT.
C       CALPOT2 - CALCULATE POTENTIAL TEMPERATURE.
C       FDLVL   - COMPUTE FD LEVEL DATA (AGL OR MSL).
C       FRZLVL  - COMPUTE FREEZING LEVEL DATA.
C       BOUND   - BOUND ARRAY ELEMENTS BETWEEN MINIMUM AND MAXIMUM VALUES.
C       BNDLYR2 - COMPUTE BOUNDARY LAYER FIELDS.
C       CALDWP2 - CALCULATE DEWPOINT TEMPERATURE.
C       CALMCVG - CALCULATE MOISTURE CONVERGENCE.
C       OTLFT2  - COMPUTE LIFTED INDEX AT 500MB.
C       CALLCL  - COMPUTE LCL DATA.
C       LFMFLD  - COMPUTE LFM LOOK-ALIKE FIELDS.
C       NGMFLD2 - COMPUTE NGM LOOK-ALIKE FIELDS.
C       CALTHTE - COMPUTE THETA-E.
C       CALHEL  - COMPUTE HELICITY AND STORM MOTION.
C
C     LIBRARY:
C       COMMON - RQSTFLD
C                MASKS
C                IOUNIT
C                OPTIONS
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     INCLUDE GRID DIMENSIONS.  DERIVE DEPENDENT PARAMETERS.
C
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
C     
C     SET LOCAL PARAMETERS.  MAKE SURE NFD AND NBND AGREE
C     WITH THE VALUES SET IN SUBROUTINES FDLVL AND BNDLYR2,
C     RESPECTIVELY.
      PARAMETER (NFD=6,NBND=6,SMALL=1.E-12)
      PARAMETER (C2K=273.15)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL NORTH
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STDRD
      LOGICAL FIELD1,FIELD2
      INTEGER LVLBND(IM,JM,NBND),LB2(IM,JM)
      REAL P1D(IM,JM),T1D(IM,JM),Q1D(IM,JM),U1D(IM,JM),V1D(IM,JM)
      REAL SHR1D(IM,JM),Z1D(IM,JM),RH1D(IM,JM)
      REAL OMGBND(IM,JM,NBND),PWTBND(IM,JM,NBND)
      REAL PBND(IM,JM,NBND),TBND(IM,JM,NBND),QBND(IM,JM,NBND)
      REAL UBND(IM,JM,NBND),VBND(IM,JM,NBND),RHBND(IM,JM,NBND)
      REAL T78483(IM,JM),T89671(IM,JM),P78483(IM,JM),P89671(IM,JM)
      REAL QM8510(IM,JM),RH4710(IM,JM),RH8498(IM,JM)
      REAL RH4796(IM,JM),RH1847(IM,JM),UST(IM,JM),VST(IM,JM)
      REAL RH3310(IM,JM),RH6610(IM,JM),RH3366(IM,JM),PW3310(IM,JM)
      REAL HTFD(NFD),T6D(IM,JM,NFD),U6D(IM,JM,NFD),V6D(IM,JM,NFD)
      REAL PETABND(NBND),SIGBND(NBND),HELI(IM,JM)
      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT)
CGSM      REAL MAXWP(IM,JM),MAXWZ(IM,JM),MAXWU(IM,JM), MAXWV(IM,JM)
C Lyra GSM Max wind
      REAL MAXWUold(IM,JM),MAXWVold(IM,JM)
      REAL MAXWP(IM,JM),MAXWZ(IM,JM)
C Lyra GSM Max wind
CHOU   integrated qU & qV
      REAL QUINT(IM,JM), QVINT(IM,JM)
      REAL CLW(IM,JM), CLI(IM,JM)
      REAL HPBL(IM,JM)      !consistent w/ etafcst, not using NBND layers
      
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "RQSTFLD.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "IOUNIT.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "DYNAM.comm"
      INCLUDE "CTLBLK.comm"
C     
C
C     EQUIVALENCES FOR SUBROUTINE MISCLN.
      EQUIVALENCE (TBND(1,1,1),T6D(1,1,1))
      EQUIVALENCE (TBND(1,1,2),T6D(1,1,2))
      EQUIVALENCE (TBND(1,1,3),T6D(1,1,3))
      EQUIVALENCE (TBND(1,1,4),T6D(1,1,4))
      EQUIVALENCE (TBND(1,1,5),T6D(1,1,5))
      EQUIVALENCE (TBND(1,1,6),T6D(1,1,6))
      EQUIVALENCE (UBND(1,1,1),U6D(1,1,1))
      EQUIVALENCE (UBND(1,1,2),U6D(1,1,2))
      EQUIVALENCE (UBND(1,1,3),U6D(1,1,3))
      EQUIVALENCE (UBND(1,1,4),U6D(1,1,4))
      EQUIVALENCE (UBND(1,1,5),U6D(1,1,5))
      EQUIVALENCE (UBND(1,1,6),U6D(1,1,6))
      EQUIVALENCE (VBND(1,1,1),V6D(1,1,1))
      EQUIVALENCE (VBND(1,1,2),V6D(1,1,2))
      EQUIVALENCE (VBND(1,1,3),V6D(1,1,3))
      EQUIVALENCE (VBND(1,1,4),V6D(1,1,4))
      EQUIVALENCE (VBND(1,1,5),V6D(1,1,5))
      EQUIVALENCE (VBND(1,1,6),V6D(1,1,6))
C     
C     SET FD LEVEL HEIGHTS IN GEOPOTENTAL METERS.
      DATA HTFD  / 914.E0,1524.E0,1829.E0,
     X     2134.E0,2743.E0,3658.E0/
C     
C     SET MIDPOINT "SIGMA" VALUES FOR ETA BOUNDARY LAYERS.
      DATA SIGBND / 0.985,0.955,0.925,0.895,0.865,0.835 /
      DATA PETABND / 15.,45.,75.,105.,135.,165. /
C     
C****************************************************************************
C     START MISCLN HERE.
C     
C        HELICITY AND STORM MOTION.
       IF (IGET(162).GT.0.OR.IGET(163).GT.0.OR.IGET(164).GT.0) THEN
         CALL CALHEL(UST,VST,HELI)
         IF (IGET(162).GT.0) THEN
            CALL E2OUT(162,000,HELI,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            ID(10)   = 30
            ID(11)   = 0
            CALL OUTPUT(IOUTYP,IGET(162),LVLS(1,IGET(162)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
         IF ((IGET(163).GT.0).OR.(IGET(164).GT.0)) THEN
            CALL E2OUT(163,164,UST,VST,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            ID(10)   = 30
            ID(11)   = 85
            IF (IGET(163).GT.0) CALL OUTPUT(IOUTYP,IGET(163),
     X           LVLS(1,IGET(163)),GRID1,IMOUT,JMOUT)
            ID(1:25) = 0
            ID(10)   = 30
            ID(11)   = 85
            IF (IGET(164).GT.0) CALL OUTPUT(IOUTYP,IGET(164),
     X           LVLS(1,IGET(164)),GRID2,IMOUT,JMOUT)
         ENDIF
       ENDIF
C     
C
C
C     ***BLOCK 1:  TROPOPAUSE P, Z, T, U, V, AND WIND SHEAR.
C    
      IF ( (IGET(054).GT.0).OR.(IGET(055).GT.0).OR.
     X     (IGET(056).GT.0).OR.(IGET(057).GT.0).OR.
     X     (IGET(177).GT.0).OR.
     X     (IGET(058).GT.0).OR.(IGET(108).GT.0) ) THEN
         CALL TRPAUS(P1D,T1D,Z1D,U1D,V1D,SHR1D) 
C
C        TROPOPAUSE PRESSURE.
         IF (IGET(054).GT.0) THEN
            CALL E2OUT(054,000,P1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(054),LVLS(1,IGET(054)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF

C        TROPOPAUSE HEIGHT.
         IF (IGET(177).GT.0) THEN
            CALL E2OUT(177,000,Z1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(177),LVLS(1,IGET(177)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C        TROPOPAUSE TEMPERATURE.
         IF (IGET(055).GT.0) THEN
            CALL E2OUT(055,000,T1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(055),LVLS(1,IGET(055)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C        TROPOPAUSE POTENTIAL TEMPERATURE.
         IF (IGET(108).GT.0) THEN
            CALL CALPOT2(P1D,T1D,EGRID1,IM,JM)
            CALL E2OUT(108,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(108),LVLS(1,IGET(108)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        TROPOPAUSE U WIND AND/OR V WIND.
         IF ((IGET(056).GT.0).OR.(IGET(057).GT.0)) THEN
            CALL E2OUT(056,057,U1D,V1D,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            IF (IGET(056).GT.0) CALL OUTPUT(IOUTYP,IGET(056),
     X           LVLS(1,IGET(056)),GRID1,IMOUT,JMOUT)
            ID(1:25) = 0
            IF (IGET(057).GT.0) CALL OUTPUT(IOUTYP,IGET(057),
     X           LVLS(1,IGET(057)),GRID2,IMOUT,JMOUT)
         ENDIF
C
C        TROPOPAUSE WIND SHEAR.
         IF (IGET(058).GT.0) THEN
            CALL E2OUT(058,000,SHR1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(058),LVLS(1,IGET(058)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
      ENDIF
C
C
C
C     ***BLOCK 2:  MAX WIND LEVEL  P, Z, U, AND V
C
C        MAX WIND LEVEL CALCULATIONS
         IF ((IGET(173).GT.0) .OR. (IGET(174).GT.0) .OR.
     X      (IGET(175).GT.0) .OR. (IGET(176).GT.0)) THEN
CLyra GSM Max wind
            CALL CALMXW(MAXWP,MAXWZ,MAXWUold,MAXWVold)
CLyra GSM Max wind
         ENDIF
C        PRESSURE OF MAX WIND LEVEL
         IF (IGET(173).GT.0) THEN
            CALL E2OUT(173,000,MAXWP,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(173),LVLS(1,IGET(173)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF
C        HEIGHT OF MAX WIND LEVEL
         IF (IGET(174).GT.0) THEN
            CALL E2OUT(174,000,MAXWZ,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(174),LVLS(1,IGET(174)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF

C        MAX WIND LEVEL U WIND AND/OR V WIND.
         IF ((IGET(175).GT.0).OR.(IGET(176).GT.0)) THEN
            CALL E2OUT(175,176,MAXWU,MAXWV,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            IF (IGET(175).GT.0) CALL OUTPUT(IOUTYP,IGET(175),
     X           LVLS(1,IGET(175)),GRID1,IMOUT,JMOUT)
            ID(1:25) = 0
            IF (IGET(176).GT.0) CALL OUTPUT(IOUTYP,IGET(176),
     X           LVLS(1,IGET(176)),GRID2,IMOUT,JMOUT)
         ENDIF
C
C
C
C     ***BLOCK 3:  FD LEVEL T, U, AND V.
C     
      IF ( (IGET(059).GT.0).OR.(IGET(060).GT.0).OR.
     X     (IGET(061).GT.0) ) THEN
C
C     DETERMINE WHETHER TO DO MSL OR AGL FD LEVELS
C
         ITYPE=1
         DO IFD = 1,NFD
           IF (IGET(059).GT.0) THEN
            IF (LVLS(IFD,IGET(059)).GT.1) ITYPE=2
           ENDIF
           IF (IGET(060).GT.0) THEN
            IF (LVLS(IFD,IGET(060)).GT.1) ITYPE=2
           ENDIF
           IF (IGET(061).GT.0) THEN
            IF (LVLS(IFD,IGET(061)).GT.1) ITYPE=2
           ENDIF
         ENDDO
         CALL FDLVL(ITYPE,T6D,U6D,V6D)
C     
         DO 10 IFD = 1,NFD
            ID(1:25) = 0
            ISVALUE = NINT(HTFD(IFD))
            ID(11) = ISVALUE
C
C           FD LEVEL TEMPERATURE.
            IF (IGET(059).GT.0) THEN
              IF (LVLS(IFD,IGET(059)).GT.0) THEN
               CALL E2OUT(059,000,T6D(1,1,IFD),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(059),
     X              LVLS(IFD,IGET(059)),GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C
C           FD LEVEL U WIND AND/OR V WIND.
            IF ((IGET(060).GT.0).OR.(IGET(061).GT.0)) THEN
               CALL E2OUT(060,061,U6D(1,1,IFD),V6D(1,1,IFD),
     X              GRID1,GRID2,IMOUT,JMOUT)
               IF (IGET(060).GT.0) THEN
                 IF (LVLS(IFD,IGET(060)).GT.0) CALL OUTPUT(IOUTYP,
     X              IGET(060),LVLS(IFD,IGET(060)),GRID1,IMOUT,JMOUT)
               ENDIF
               IF (IGET(061).GT.0) THEN
                 IF (LVLS(IFD,IGET(061)).GT.0) CALL OUTPUT(IOUTYP,
     X              IGET(061),LVLS(IFD,IGET(061)),GRID2,IMOUT,JMOUT)
               ENDIF
            ENDIF
 10      CONTINUE
      ENDIF
C     
C
C
C     ***BLOCK 4:  FREEZING LEVEL Z AND RH.
C     
      IF ( (IGET(062).GT.0).OR.(IGET(063).GT.0) ) THEN
         CALL FRZLVL(Z1D,RH1D)
C
C        FREEZING LEVEL HEIGHT.
         IF (IGET(062).GT.0) THEN
            CALL E2OUT(062,000,Z1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL BOUND (GRID1,D00,H99999,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(062),LVLS(1,IGET(062)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C
C        FREEZING LEVEL RELATIVE HUMIDITY.
         IF (IGET(063).GT.0) THEN
            CALL E2OUT(063,000,RH1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(063),LVLS(1,IGET(063)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
      ENDIF
      IF (IGET(165).GT.0) THEN
         CALL FRZLVL2(Z1D,RH1D)
C
C        HIGHEST FREEZING LEVEL HEIGHT.
            CALL E2OUT(165,000,Z1D,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL BOUND (GRID1,D00,H99999,IMOUT,JMOUT)
            CALL OUTPUT(IOUTYP,IGET(165),LVLS(1,IGET(165)),
     X           GRID1,IMOUT,JMOUT)
      ENDIF
C     
C
C
C     ***BLOCK 5:  BOUNDARY LAYER FIELDS.
C     
      IF ( (IGET(067).GT.0).OR.(IGET(068).GT.0).OR.
     X     (IGET(069).GT.0).OR.(IGET(070).GT.0).OR.
     X     (IGET(071).GT.0).OR.(IGET(072).GT.0).OR.
     X     (IGET(073).GT.0).OR.(IGET(074).GT.0).OR.
     X     (IGET(088).GT.0).OR.(IGET(089).GT.0).OR.
     X     (IGET(090).GT.0).OR.(IGET(075).GT.0).OR.
     X     (IGET(109).GT.0).OR.(IGET(110).GT.0).OR.
     X     (IGET(031).GT.0).OR.(IGET(032).GT.0).OR.
     X     (IGET(107).GT.0)) THEN 
Chou     X     (IGET(107).GT.0).OR.(IGET(091).GT.0).OR.
Chou     X     (IGET(092).GT.0).OR.(IGET(093).GT.0).OR.
Chou     X     (IGET(094).GT.0).OR.(IGET(095).GT.0).OR.
Chou     X     (IGET(096).GT.0).OR.(IGET(097).GT.0).OR.
Chou     X     (IGET(098).GT.0) ) THEN
C
C        COMPUTE ETA BOUNDARY LAYER FIELDS.
         CALL BNDLYR2(PBND,TBND,QBND,RHBND,UBND,VBND,
     X        OMGBND,PWTBND,LVLBND)
C     
C        LOOP OVER NBND BOUNDARY LAYERS.
         DO 20 LBND = 1,NBND
            ID(1:25) = 0
            ID(10)   = NINT(PETABND(LBND)+15.)
            ID(11)   = NINT(PETABND(LBND)-15.)
C     
C           BOUNDARY LAYER PRESSURE.
            IF (IGET(067).GT.0) THEN
              IF (LVLS(LBND,IGET(067)).GT.0) THEN
               CALL E2OUT(067,000,PBND(1,1,LBND),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(067),
     X              LVLS(LBND,IGET(067)),GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER TEMPERATURE.
            IF (IGET(068).GT.0) THEN
              IF (LVLS(LBND,IGET(068)).GT.0) THEN
               CALL E2OUT(068,000,TBND(1,1,LBND),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(068),LVLS(LBND,IGET(068)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER POTENTIAL TEMPERATURE.
            IF (IGET(069).GT.0) THEN
              IF (LVLS(LBND,IGET(069)).GT.0) THEN
               CALL CALPOT2(PBND(1,1,LBND),TBND(1,1,LBND),EGRID1,IM,JM)
               CALL E2OUT(069,000,EGRID1,EGRID2,GRID1,GRID2,
     X              IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(069),LVLS(LBND,IGET(069)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER RELATIVE HUMIDITY.
            IF (IGET(072).GT.0) THEN
              IF (LVLS(LBND,IGET(072)).GT.0) THEN
               CALL E2OUT(072,000,RHBND(1,1,LBND),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(072),LVLS(LBND,IGET(072)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER DEWPOINT TEMPERATURE.
            IF (IGET(070).GT.0) THEN
              IF (LVLS(LBND,IGET(070)).GT.0) THEN
               CALL CALDWP2(PBND(1,1,LBND),QBND(1,1,LBND),EGRID1,
     X              TBND(1,1,LBND))
               CALL E2OUT(070,000,EGRID1,EGRID2,GRID1,GRID2,
     X              IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(070),LVLS(LBND,IGET(070)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER SPECIFIC HUMIDITY.
            IF (IGET(071).GT.0) THEN
              IF (LVLS(LBND,IGET(071)).GT.0) THEN
               CALL E2OUT(071,000,QBND(1,1,LBND),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(071),LVLS(LBND,IGET(071)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER MOISTURE CONVERGENCE.
            IF (IGET(088).GT.0) THEN
              IF (LVLS(LBND,IGET(088)).GT.0) THEN
               CALL CALMCVG(QBND(1,1,LBND),UBND(1,1,LBND),
     X              VBND(1,1,LBND),-1,EGRID1)
C          CONVERT TO DIVERGENCE FOR GRIB
               DO J=JSTA,JEND
               DO I=1,IM
                 EGRID1(I,J)=-1.0*EGRID1(I,J)
               ENDDO
               ENDDO
               CALL E2OUT(088,000,EGRID1,EGRID2,GRID1,GRID2,
     X              IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(088),LVLS(LBND,IGET(088)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER U WIND AND/OR V WIND.
C
            FIELD1=.FALSE.
            FIELD2=.FALSE.
C
            IF(IGET(073).GT.0)THEN
              IF(LVLS(LBND,IGET(073)).GT.0)FIELD1=.TRUE.
            ENDIF
            IF(IGET(074).GT.0)THEN
              IF(LVLS(LBND,IGET(074)).GT.0)FIELD2=.TRUE.
            ENDIF
C
            IF(FIELD1.OR.FIELD2)THEN
              CALL E2OUT(073,074,UBND(1,1,LBND),VBND(1,1,LBND),
     X                   GRID1,GRID2,IMOUT,JMOUT)
C
C              TWO ROUTINES WERE WRITTEN DURING POST PROCESSOR
C              DEVELOPMENT TO MIMIC LFM BOUNDARY LAYER WINDS.
C              BOTH APPLY AN EKMAN SPIRAL ROTATION TO AN ARTIFICIALLY
C              REDUCED GEOSTROPHIC WIND FIELD.  SUBROUTINE CALEKM
C              BASES THE GEOSTROPHIC WIND ON 1000MB HEIGHTS WHILE
C              CALEKM2 USES THE SEA LEVEL PRESSURE FIELD.  IF
C              LBND EQUALS ONE AND LVLS IS 8 POST THE CALEKM WINDS
C              AS BOUNDARY LAYER ONE WINDS.  IF LBND EQUALS ONE AND
C              LVLS IS 9 POST CALEKM2 WINDS AS BOUNDARY LAYER ONE
C              WINDS.  OTHERWISE, POST THE "TRUE" BOUNDARY LAYER 
C              ONE WINDS.
C                              - 19 OCTOBER 1993, RUSS TREADON
C                     
               IF (IGET(073).GT.0) THEN
               IF ((LBND.EQ.1).AND.(LVLS(LBND,IGET(073)).EQ.8)) THEN
                  WRITE(STDOUT,*)'MISCLN:  BNDLYR ',LBND,
     X                 ' UV USING EKMAN-GEO Z1000 UV'
                  CALL CALEKM(U1D,V1D)
                  CALL E2OUT(073,074,U1D,V1D,GRID1,GRID2,IMOUT,JMOUT)
               ENDIF
               ENDIF
C
               IF (IGET(073).GT.0) THEN
               IF ((LBND.EQ.1).AND.(LVLS(LBND,IGET(073)).EQ.9)) THEN
                  WRITE(STDOUT,*)'MISCLN:  BNDLYR ',LBND,
     X                 ' UV USING EKMAN-GEO PMSL UV'
                  CALL CALEKM2(U1D,V1D)
                  CALL E2OUT(073,074,U1D,V1D,GRID1,GRID2,IMOUT,JMOUT)
               ENDIF
               ENDIF
C
               IF (IGET(073).GT.0) THEN
                 IF (LVLS(LBND,IGET(073)).GT.0)
     X              CALL OUTPUT(IOUTYP,IGET(073),
     X              LVLS(LBND,IGET(073)),GRID1,IMOUT,JMOUT)
               ENDIF
               IF (IGET(074).GT.0) THEN
                 IF (LVLS(LBND,IGET(074)).GT.0) 
     X              CALL OUTPUT(IOUTYP,IGET(074),
     X              LVLS(LBND,IGET(074)),GRID2,IMOUT,JMOUT)
               ENDIF
            ENDIF
C     
C           BOUNDARY LAYER OMEGA.
            IF (IGET(090).GT.0) THEN
              IF (LVLS(LBND,IGET(090)).GT.0) THEN
               CALL E2OUT(090,000,OMGBND(1,1,LBND),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(090),LVLS(LBND,IGET(090)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER PRECIPITBLE WATER.
            IF (IGET(089).GT.0) THEN
              IF (LVLS(LBND,IGET(089)).GT.0) THEN
               CALL E2OUT(089,000,PWTBND(1,1,LBND),EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
               CALL OUTPUT(IOUTYP,IGET(089),LVLS(LBND,IGET(089)),
     X              GRID1,IMOUT,JMOUT)
              ENDIF
            ENDIF
C     
C           BOUNDARY LAYER LIFTED INDEX.
            IF (IGET(075).GT.0) THEN
              IF (LVLS(LBND,IGET(075)).GT.0) THEN
               CALL OTLFT2(PBND(1,1,LBND),TBND(1,1,LBND),
     X              QBND(1,1,LBND),EGRID1)
               CALL E2OUT(075,000,EGRID1,EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
C     
C           23 SEPTEMBER 1993, RUSS TREADON.
C             ON LFM FORECAST GRID 026 WE POST THE FIRST ETA 
C             BOUNDARY LAYER LI AS THE SURFACE TO 500MB LI.
C             THE CALL TO E2OUT INTERPOLATES THE LI FROM
C             THE E-GRID TO THE OUTPUT GRID.  IF WE ARE POSTING
C             DATA THE THE LFM GRID WE NEED TO SAVE THIS 
C             INTERPOLATED FIELD FOR USE BELOW.  WHY?  WHEN
C             PACKING THE DATA IN GRIB1 THE VALUES IN GRID1
C             ARE MULTIPLIED BY 10.  IF WE SEND GRID1 TO THE
C             GRIB PACKER A SECOND TIME THE LI'S ARE 10 TIMES 
C             TOO BIG.
C
               CALL E2OUT(075,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
               IF (KGTYPE.EQ.026) THEN
                if ( me .eq. 0 ) then
                  DO J=1,JMOUT
                  DO I=1,IMOUT
                     GRID2(I,J) = GRID1(I,J)
                  ENDDO
                  ENDDO
                end if
               ENDIF
               
               
               CALL OUTPUT(IOUTYP,IGET(075),LVLS(LBND,IGET(075)),
     X              GRID1,IMOUT,JMOUT)
C
C              25 JUNE 1993, RUSS TREADON.
C                 ON THE LFM FORECAST GRID (026) WE POST THE FIRST
C                 BOUNDARY LAYER LIFTED INDEX AS THE SURFACE LI.
C     
               IF (KGTYPE.EQ.026) THEN
                 if ( me .eq. 0 ) then
                  DO J=1,JMOUT
                  DO I=1,IMOUT
                    GRID2(I,J) = GRID2(I,J) + C2K
                  ENDDO
                  ENDDO
                 end if
C
                  ID(1:25) = 0
                  ID(9) = 101
                  ID(10) = 50
                  ID(11) = 0
                  CALL OUTPUT(IOUTYP,IGET(030),LVLS(1,IGET(030)),
     X                 GRID2,IMOUT,JMOUT)
               ENDIF
              ENDIF
            ENDIF
C
C        END OF ETA BOUNDARY LAYER LOOP.
 20      CONTINUE
C     
C        BEST LIFTED INDEX FROM BOUNDARY LAYER FIELDS.
C     
         IF (IGET(031).GT.0) THEN
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID1(I,J) = H99999
              EGRID2(I,J) = H99999
            ENDDO
            ENDDO
C
            DO 50 LBND = 1,NBND
               CALL OTLFT2(PBND(1,1,LBND),TBND(1,1,LBND),
     X              QBND(1,1,LBND),EGRID2)
               DO J=JSTA,JEND
               DO I=1,IM
                 EGRID1(I,J)=AMIN1(EGRID1(I,J),EGRID2(I,J))
               ENDDO
               ENDDO
 50         CONTINUE
            CALL E2OUT(031,000,EGRID1,EGRID2,
     X           GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            ID(10)   = PETABND(NBND)+15.
            ID(11)   = PETABND(1)-15.
            CALL OUTPUT(IOUTYP,IGET(031),LVLS(1,IGET(031)),
     X           GRID1,IMOUT,JMOUT)
         ENDIF
C     
C        BEST BOUNDARY LAYER CAPE AND CINS.
C     
         FIELD1=.FALSE.
         FIELD2=.FALSE.
C
         IF(IGET(032).GT.0)THEN
           IF(LVLS(2,IGET(032)).GT.0)FIELD1=.TRUE.
         ENDIF
         IF(IGET(107).GT.0)THEN
           IF(LVLS(2,IGET(107)).GT.0)FIELD2=.TRUE.
         ENDIF
C
         IF(FIELD1.OR.FIELD2)THEN
           ITYPE = 2
C
           DO J=JSTA,JEND
           DO I=1,IM
             EGRID1(I,J) = -H99999
             EGRID2(I,J) = -H99999
           ENDDO
           ENDDO
C
           DO 80 LBND = 1,NBND
           CALL CALTHTE(PBND(1,1,LBND),TBND(1,1,LBND),
     X                  QBND(1,1,LBND),EGRID1)
           DO J=JSTA,JEND
           DO I=1,IM
             IF (EGRID1(I,J).GT.EGRID2(I,J)) THEN
               EGRID2(I,J) = EGRID1(I,J)
               LB2(I,J)  = LVLBND(I,J,LBND)
               P1D(I,J)  = PBND(I,J,LBND)
               T1D(I,J)  = TBND(I,J,LBND)
               Q1D(I,J)  = QBND(I,J,LBND)
             ENDIF
           ENDDO
           ENDDO
 80        CONTINUE
C
           CALL CALCAPE(ITYPE,P1D,T1D,Q1D,LB2,EGRID1,EGRID2)
C
           IF (IGET(032).GT.0) THEN
             CALL E2OUT(032,000,EGRID1,EGRID2,
     X                  GRID1,GRID2,IMOUT,JMOUT)
             CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
             ID(1:25) = 0
             ID(09)   = 116
             ID(10)   = PETABND(NBND)+15.
             ID(11)   = PETABND(1)-15.
             CALL OUTPUT(IOUTYP,IGET(032),LVLS(1,IGET(032)),
     X                   GRID1,IMOUT,JMOUT)
           ENDIF
C
           IF (IGET(107).GT.0) THEN
             CALL E2OUT(107,000,EGRID2,EGRID1,
     X                  GRID1,GRID2,IMOUT,JMOUT)
            if ( me .eq. 0 ) then
             DO J=1,JMOUT
             DO I=1,IMOUT
               GRID1(I,J) = -1.*GRID1(I,J)
             ENDDO
             ENDDO
           end if
C
             CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
C
            if ( me .eq. 0 ) then
             DO J=1,JMOUT
             DO I=1,IMOUT
               GRID1(I,J) = -1.*GRID1(I,J)
             ENDDO
             ENDDO
            end if
C
             ID(1:25) = 0
             ID(09)   = 116
             ID(10)   = PETABND(NBND)+15.
             ID(11)   = PETABND(1)-15.
             CALL OUTPUT(IOUTYP,IGET(107),LVLS(1,IGET(107)),
     X                   GRID1,IMOUT,JMOUT)
           ENDIF
         ENDIF
C
C        BOUNDARY LAYER LIFTING CONDENSATION PRESSURE AND HEIGHT.
C        EGRID1 IS LCL PRESSURE.  EGRID2 IS LCL HEIGHT.
C
         IF ( (IGET(109).GT.0).OR.(IGET(110).GT.0) ) THEN
            CALL CALLCL(PBND(1,1,1),TBND(1,1,1),
     X           QBND(1,1,1),EGRID1,EGRID2)
            IF (IGET(109).GT.0) THEN
               CALL E2OUT(109,000,EGRID2,EGRID1,
     X              GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               CALL OUTPUT(IOUTYP,IGET(109),ILVL,
     X              GRID1,IMOUT,JMOUT)
            ENDIF
            IF (IGET(110).GT.0) THEN
               CALL E2OUT(110,000,EGRID1,EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
               ID(1:25) = 0
               CALL OUTPUT(IOUTYP,IGET(110),ILVL,
     X              GRID1,IMOUT,JMOUT)
            ENDIF
         ENDIF
C         
CGSM        NGM BOUNDARY LAYER FIELDS.
C     
C         IF ( (IGET(091).GT.0).OR.(IGET(092).GT.0).OR.
C     X        (IGET(093).GT.0).OR.(IGET(094).GT.0).OR.
C     X        (IGET(095).GT.0).OR.(IGET(095).GT.0).OR.
C     X        (IGET(096).GT.0).OR.(IGET(097).GT.0).OR.
C     X        (IGET(098).GT.0) ) THEN
C
C  COMPUTE SIGMA 0.89671 AND 0.78483 TEMPERATURES
C    INTERPOLATE LINEAR IN LOG P
C            IF (IGET(097).GT.0.OR.IGET(098).GT.0) THEN
C               DO J=JSTA,JEND
C              DO I=1,IM
C                 P78483(I,J)=ALOG((PD(I,J)+PT)*0.78483)
C                 P89671(I,J)=ALOG((PD(I,J)+PT)*0.89671)
C               ENDDO
C               ENDDO
!!$omp  parallel do
!!$omp& private(fac1,fac2,pkl1,pku1,t78483,t89671)
C               DO L=2,LM
C                DO J=JSTA,JEND
C                DO I=1,IM
C                  PKL1=0.5*(ALPINT(I,J,L)+ALPINT(I,J,L+1))
C                  PKU1=0.5*(ALPINT(I,J,L)+ALPINT(I,J,L-1))
C                  IF(P78483(I,J).LE.PKL1.AND.P78483(I,J).GT.PKU1)THEN
C                    FAC1=(PKL1-P78483(I,J))/(PKL1-PKU1)
C                    FAC2=(P78483(I,J)-PKU1)/(PKL1-PKU1)
C                    T78483(I,J)=T(I,J,L)*FAC2+T(I,J,L-1)*FAC1
C                  ENDIF
C                  IF(P89671(I,J).LE.PKL1.AND.P89671(I,J).GT.PKU1)THEN
C                    FAC1=(PKL1-P89671(I,J))/(PKL1-PKU1)
C                    FAC2=(P89671(I,J)-PKU1)/(PKL1-PKU1)
C                    T89671(I,J)=T(I,J,L)*FAC2+T(I,J,L-1)*FAC1
C                  ENDIF
C                ENDDO
C                ENDDO
C               ENDDO
C     
C           SIGMA 0.89671 TEMPERATURE
C             IF (IGET(097).GT.0) THEN
C               ID(1:25) = 0
C               ISVALUE = 8967
C               ID(11) = ISVALUE
C               CALL E2OUT(097,000,T89671,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(097),LVLS(1,IGET(097)),
C     X              GRID1,IMOUT,JMOUT)
C             ENDIF     
C           SIGMA 0.78483 TEMPERATURE
C             IF (IGET(098).GT.0) THEN
C               ID(1:25) = 0
C               ISVALUE = 7848
C               ID(11) = ISVALUE
C               CALL E2OUT(098,000,T78483,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(098),LVLS(1,IGET(098)),
C     X              GRID1,IMOUT,JMOUT)
C             ENDIF
C            ENDIF
C     
C           NGM SIGMA LAYER 0.98230 FIELDS.  THESE FIELDS ARE 
C           THE FIRST ETA LAYER BOUNDARY LAYER FIELDS.  AN
C           EXCEPTION IS MADE FOR RELATIVE HUMIDITY ON THE LFM
C           FORECAST GRID (026).  ON THIS OUTPUT GRID THE SIGMA
C           0.98230 RELATIVE HUMIDITY IS THE MEAN RELATIVE HUMIDITY
C           COMPUTED BY AVERAGING ETA BOUNDARY LAYER 1, 2, AND 3
C           RELATIVE HUMIDITIES.  THIS AD HOC APPROACH WAS TAKEN 
C           TO PRODUCE A MORE "LFM-LIKE" BOUNDARY LAYER RELATIVE
C           HUMIDITY FIELD FOR THE AVIATION BRANCH OF MOD.
C
C           THIS IS NOT A SATISFACTORY SOLUTION.  THE SIGMA 
C           0.98230 RELATIVE HUMIDITY SHOULD BE CONSISTENT
C           WITH THE OTHER SIGMA 0.98230 FIELDS.  
C     
C     
C            IF ( (IGET(091).GT.0).OR.(IGET(092).GT.0).OR.
C     X           (IGET(093).GT.0).OR.(IGET(094).GT.0).OR.
C     X           (IGET(095).GT.0).OR.(IGET(095).GT.0).OR.
C     X           (IGET(096).GT.0) ) THEN
C     
C               ID(1:25) = 0
C               ISVALUE = 9823
C               ID(11) = ISVALUE
C     
C              PRESSURE.
C               IF (IGET(091).GT.0) THEN
C                  CALL E2OUT(091,000,PBND(1,1,1),EGRID2,
C     X                 GRID1,GRID2,IMOUT,JMOUT)
C                  CALL OUTPUT(IOUTYP,IGET(091),LVLS(1,IGET(091)),
C     X                 GRID1,IMOUT,JMOUT)
C               ENDIF
C     
C              TEMPERATURE.
C               IF (IGET(092).GT.0) THEN
C                  CALL E2OUT(092,000,TBND(1,1,1),EGRID2,
C     X                 GRID1,GRID2,IMOUT,JMOUT)
C                  CALL OUTPUT(IOUTYP,IGET(092),LVLS(1,IGET(092)),
C     X                 GRID1,IMOUT,JMOUT)
C               ENDIF
C     
C              SPECIFIC HUMIDITY.
C               IF (IGET(093).GT.0) THEN
C                  CALL E2OUT(093,000,QBND(1,1,1),EGRID2,
C     X                 GRID1,GRID2,IMOUT,JMOUT)
C                  CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
C                  CALL OUTPUT(IOUTYP,IGET(093),LVLS(1,IGET(093)),
C     X                 GRID1,IMOUT,JMOUT)
C               ENDIF     
C              RELATIVE HUMIDITY.
C               IF (IGET(094).GT.0) THEN
C                  IF (KGTYPE.EQ.026) THEN
C                     DO J=JSTA,JEND
C                     DO I=1,IM
C                       RH1D(I,J)=(RHBND(I,J,1)+RHBND(I,J,2)+
C     &                            RHBND(I,J,3))*0.33333333
c                     ENDDO                    
C                     ENDDO
C                  ELSE
C                     DO J=JSTA,JEND
C                     DO I=1,IM
C                       RH1D(I,J)=RHBND(I,J,1)
C                     ENDDO
C                     ENDDO
C                  ENDIF
C                  CALL E2OUT(094,000,RH1D,EGRID2,GRID1,GRID2,
C     X                 IMOUT,JMOUT)
C                  CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C                  CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C                  CALL OUTPUT(IOUTYP,IGET(094),LVLS(1,IGET(094)),
C     X                 GRID1,IMOUT,JMOUT)
C               ENDIF
C 
C        CHOU 13/06/2009: NEW EXTRA FIELDS, using NGM slot
C     
               IF  (IGET(091).GT.0) THEN
                CALL E2OUT(091,000,TLMAX,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
                         ID(1:25) = 0
                     CALL OUTPUT(IOUTYP,IGET(091),LVLS(1,IGET(091)),
     X                       GRID1,IMOUT,JMOUT)
               ENDIF

               IF  (IGET(092).GT.0) THEN
                CALL E2OUT(092,000,TLMIN,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
                          ID(1:25) = 0
                     CALL OUTPUT(IOUTYP,IGET(092),LVLS(1,IGET(092)),
     X                      GRID1,IMOUT,JMOUT)
               ENDIF

CHOU  INCLUDE vertically integrated moisture transport U & V components
C  integral((q+cwm) x U) dp/g  and integral((q+cwm) x V) dp/G)
C
         IF ((IGET(093).GT.0).OR.(IGET(094).GT.0)) THEN
          CALL CALQUV(QUINT,QVINT)
C
C        qu component
          IF (IGET(093).GT.0) THEN
            CALL E2OUT(093,000,QUINT,EGRID2, GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(093),LVLS(1,IGET(093)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF
C
C        qv component
          IF (IGET(094).GT.0) THEN
            CALL E2OUT(094,000,QVINT,EGRID2, GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(094),LVLS(1,IGET(094)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C
Chou   Vert Integrated Cloud Water
         IF ((IGET(097).GT.0).OR.(IGET(098).GT.0))  THEN
            CALL CALCWI(CLW,CLI)

          IF (IGET(097).GT.0) THEN
            CALL E2OUT(097,000,CLW,EGRID2, GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(097),LVLS(1,IGET(097)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF
C
Chou   Vert Integrated Cloud ICE
          IF (IGET(098).GT.0) THEN
            CALL E2OUT(098,000,CLI,EGRID2, GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(098),LVLS(1,IGET(098)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF

Chou 20221226 HPBL
         IF (IGET(066).GT.0) THEN
            CALL CALHPBL(HPBL)
            CALL E2OUT(066,000,HPBL,EGRID2, GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25) = 0
            CALL OUTPUT(IOUTYP,IGET(066),LVLS(1,IGET(066)),
     X           GRID1,IMOUT,JMOUT)
          ENDIF


Chou
Chou               IF ((IGET(093).GT.0).OR.(IGET(094).GT.0)) THEN
Chou                  CALL CALQUV(QUINT,QVINT)
Chou                  CALL E2OUT(093,094,QUINT,QVINT,
Chou     X                       GRID1,GRID2,IMOUT,JMOUT)
Chou                  ID(1:25) = 0
Chou                  IF (IGET(093).GT.0) CALL OUTPUT(IOUTYP,IGET(093),
Chou     X                 LVLS(1,IGET(093)),GRID1,IMOUT,JMOUT)
Chou                  ID(1:25) = 0
Chou                  IF (IGET(094).GT.0) CALL OUTPUT(IOUTYP,IGET(094),
Chou     X                 LVLS(1,IGET(094)),GRID2,IMOUT,JMOUT)
Chou               ENDIF

C              U AND/OR V WIND.
               IF ((IGET(095).GT.0).OR.(IGET(096).GT.0)) THEN
                  CALL E2OUT(095,096,UBND(1,1,1),VBND(1,1,1),
     X                 GRID1,GRID2,IMOUT,JMOUT)
                  IF (IGET(095).GT.0) CALL OUTPUT(IOUTYP,IGET(095),
     X                 LVLS(1,IGET(095)),GRID1,IMOUT,JMOUT)
                  IF (IGET(096).GT.0) CALL OUTPUT(IOUTYP,IGET(096),
     X                 LVLS(1,IGET(096)),GRID2,IMOUT,JMOUT)
               ENDIF
            ENDIF
CGSM         ENDIF
C     
C     ENDIF FOR BOUNDARY LAYER BLOCK.
C
CGSM      ENDIF
C     
C
C
C     ***BLOCK 6:  MISCELLANEOUS LAYER MEAN LFM AND NGM FIELDS.
C     
CHOU 2022/10/30 COMMENTED OUT LFM and NGM outputs, IGET(IQ)  can be used for new
Cvariables
C
C      IF ( (IGET(066).GT.0).OR.(IGET(081).GT.0).OR.
C     X     (IGET(082).GT.0).OR.(IGET(104).GT.0).OR.
C     X     (IGET(099).GT.0).OR.(IGET(100).GT.0).OR.
C     X     (IGET(101).GT.0).OR.(IGET(102).GT.0).OR.
C     X     (IGET(103).GT.0) ) THEN
CC     
CC        LFM "MEAN" RELATIVE HUMIDITIES AND PRECIPITABLE WATER.
CC     
C         IF ( (IGET(066).GT.0).OR.(IGET(081).GT.0).OR.
C     X        (IGET(082).GT.0).OR.(IGET(104).GT.0) ) THEN
c            CALL LFMFLD(RH3310,RH6610,RH3366,PW3310)
C            ID(1:25) = 0
CC     
CC           SIGMA 0.33-1.00 MEAN RELATIVE HUMIIDITY.
C            IF (IGET(066).GT.0) THEN
C               CALL E2OUT(066,000,RH3310,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10) = 33
C               ID(11) = 100
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(066),LVLS(1,IGET(066)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.66-1.00 MEAN RELATIVE HUMIIDITY.
C            IF (IGET(081).GT.0) THEN
C               CALL E2OUT(081,000,RH6610,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10) = 67
C               ID(11) = 100
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(081),LVLS(1,IGET(081)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.33-0.66 MEAN RELATIVE HUMIIDITY.
C            IF (IGET(082).GT.0) THEN
C               CALL E2OUT(082,000,RH3366,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10) = 33
C               ID(11) = 67
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(082),LVLS(1,IGET(082)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.33-1.00 PRECIPITABLE WATER.
C            IF (IGET(104).GT.0) THEN
C               CALL E2OUT(104,000,PW3310,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10) = 33
C               ID(11) = 100
C               CALL BOUND(GRID1,D00,H99999,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(104),LVLS(1,IGET(104)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
C         ENDIF
CC     
CC        VARIOUS LAYER MEAN NGM SIGMA FIELDS.
CC     
C         IF ( (IGET(099).GT.0).OR.(IGET(100).GT.0).OR.
C     X        (IGET(101).GT.0).OR.(IGET(102).GT.0).OR.
C     X        (IGET(103).GT.0) ) THEN
C            CALL NGMFLD2(RH4710,RH4796,RH1847,RH8498,QM8510)
CC     
CC           SIGMA 0.47191-1.00000 RELATIVE HUMIDITY.
C            IF (IGET(099).GT.0) THEN
C               CALL E2OUT(099,000,RH4710,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10)   = 47
C               ID(11)   = 100
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(099),LVLS(1,IGET(099)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.47191-0.96470 RELATIVE HUMIDITY.
C            IF (IGET(100).GT.0) THEN
C               CALL E2OUT(100,000,RH4796,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10)   = 47
C               ID(11)   = 96
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(100),LVLS(1,IGET(100)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.18019-0.47191 RELATIVE HUMIDITY.
C            IF (IGET(101).GT.0) THEN
C               CALL E2OUT(101,000,RH1847,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10)   = 18
C               ID(11)   = 47
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(101),LVLS(1,IGET(101)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.84368-0.98230 RELATIVE HUMIDITY.
C            IF (IGET(102).GT.0) THEN
C               CALL E2OUT(102,000,RH8498,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
C               ID(1:25) = 0
C               ID(10)   = 84
C               ID(11)   = 98
C               CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
C               CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
C               CALL OUTPUT(IOUTYP,IGET(102),LVLS(1,IGET(102)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
CC     
CC           SIGMA 0.85000-1.00000 MOISTURE CONVERGENCE.
C            IF (IGET(103).GT.0) THEN
C               CALL E2OUT(103,000,QM8510,EGRID2,GRID1,GRID2,
C     X              IMOUT,JMOUT)
CC           CONVERT TO DIVERGENCE FOR GRIB
C              if ( me .eq. 0 ) then
C               DO J = 1,JMOUT
C               DO I = 1,IMOUT
C                GRID1(I,J) = -1.0 * GRID1(I,J)
C               ENDDO
C               ENDDO
C              end if
C               ID(1:25) = 0
C               ID(10)   = 85
C               ID(11)   = 100
C               CALL OUTPUT(IOUTYP,IGET(103),LVLS(1,IGET(103)),
C     X              GRID1,IMOUT,JMOUT)
C            ENDIF
C         ENDIF
C      ENDIF
C     
CHOU  2022/10/30  end of commented out block 6
C
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE NGMSLP2
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    NGMSLP2     NMC SEA LEVEL PRESSURE REDUCTION
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-02-02       
C     
C ABSTRACT:
C     
C     THIS ROUTINE COMPUTES SEA LEVEL PRESSURE USING THE
C     HYDROSTATIC EQUATION WITH THE SHUELL CORRECTION.  THE
C     FOLLOWING IS BASED ON DOCUMENTATION IN SUBROUTINE 
C     OUTHYDRO OF THE NGM:
C     
C     THE FUNDAMENTAL HYDROSTATIC EQUATION IS
C        D(HEIGHT)
C        ---------  =  TAU = VIRTUAL TEMPERATURE * (RGAS/GRAVITY)
C        D (Z)
C      WHERE
C        Z = MINUS LOG OF PRESSURE (-LN(P)).
C
C     SEA-LEVEL PRESSURE IS COMPUTED FROM THE FORMULA
C        PRESS(MSL) = PRESS(GROUND) * EXP( F)
C     WHERE
C        F        = HEIGHT OF GROUND / MEAN TAU
C        MEAN TAU = ( TAU(GRND) + TAU(SL) ) / 2
C     
C     IN THE NGM TAU(GRND) AND TAU(SL) ARE FIRST SET USING A 
C     6.5DEG/KM LAPSE RATE FROM SIGMA LEVEL K=1.  THIS IS MODIFIED
C     BY A CORRECTION BASED ON THE CRITICAL TAU OF THE SHUELL
C     CORRECTION:
C                  TAUCR=(RGASD/GRAVITY) * 290.66
C   
C     1) WHERE ONLY TAU(SL) EXCEEDS TAUCR, CHANGE TAU(SL) TO TAUCR.
C
C     2) WHERE BOTH TAU(SL) AND TAU(GRND) EXCEED TAUCR,
C        CHANGE TAU(SL) TO TAUCR-CONST*(TAU(GRND)-TAUCR  )**2
C        WHERE CONST = .005 (GRAVITY/RGASD)
C   
C     THE AVERAGE OF TAU(SL) AND TAU(GRND) IS THEN USED TOGETHER
C     WITH THE GROUND HEIGHT AND PRESSURE TO DERIVE THE PRESSURE
C     AT SEA LEVEL. 
C     
C     EXTRAPOLATING FROM TEMPERATURES IN THE FIRST ATMOSPHERIC ETA
C     LAYER LEAD TO EXCESSIVELY NOISY UNDERGROUND TEMPERATURE FIELDS.
C     AFTER EXPERIMENTATION WE OPTED TO USE A MEAN TEMPERATURE FROM
C     THE LOWEST DP=30MB ABOVE THE GROUND.  FROM THIS MEAN TEMPERATURE
C     WE EXTRAPOLATE TO GET THE GROUND AND SEA LEVEL TEMPERATURES.
C     USING A TRUE MASS WEIGHTED LAYER MEAN INSTEAD OF THE SIMPLE
C     ARITHMETIC MEAN CODED SHOWED LITTLE QUALITATIVE DIFFERENCE.
C     
C     HEIGHT OF THE 1000MB SURFACE IS COMPUTED FROM THE MSL PRESSURE
C     FIELD USING THE FORMULA:
C     
C       P(MSL) - P(1000MB) = MEAN DENSITY * GRAVITY * HGT(1000MBS)
C     
C     WHERE P(MSL) IS THE SEA LEVEL PRESSURE FIELD WE HAVE JUST
C     COMPUTED.
C     
C     BELOW GROUND VIRTUAL TEMPERATURES ARE COMPUTED ASSUMING A CONSTANT
C     6.5DEG/KM LAPSE RATE.  TO CONVERT VIRTUAL TEMPERATURE TO A DRY
C     TEMPERATURE WE USE THE DP=30MB MEAN SPECIFIC HUMIDITY.
C     
C     LINE COMMENTED OUT WITH 'CX' ARE LEFT OVER FROM EARLIER
C     EXPERIMENTATION.  THEY REMAIN TO REMIND READERS WHAT 
C     WAS TRIED.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-02-02  RUSS TREADON
C   98-06-08  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL NGMSLP2
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     NONE
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - VRBLS
C                  EXTRA
C                  MAPOT
C                  LOOPS
C                  DYNAMD
C                  MASKS
C                  PVRBLS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE PARAMETERS.  SET LOCAL PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
      PARAMETER (GAMMA=6.5/1000.,ZSL=0.0)
      PARAMETER (TAUCR=RD*GI*290.66,CONST=0.005*G/RD)
      PARAMETER (GORD=G/RD,DP=60.E2)
      PARAMETER (ISMTHT=4,ISMTHQ=2)
C     
C     DECLARE VARIABLES
      REAL TBAR(IM,JM),QBAR(IM,JM),ALPBAR(IM,JM)
      REAL TSFC(IM,JM),QSFC(IM,JM),EGRID(IM,JM)
C     
C     INCLUDE COMMON BLOCKS
      INCLUDE "VRBLS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "DYNAMD.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C**********************************************************************
C     START NGMSLP HERE.
C     
C     LOOP OVER HORIZONTAL GRID.
C
!$omp  parallel do
!$omp& private(alpm,alps,l,llmh,nlev,pm,psfc,ptop,qsum,thsfc,tsum)
      doout30: DO J=JSTA,JEND
      doin30: DO I=1,IM
         LLMH = LMH(I,J)
C     
C        LOCATE TOP OF LAYER OVER WHICH TO COMPUTE MEAN FIELDS.
         PSFC    = PD(I,J)+PT
         PTOP    = PSFC-DP
         QSFC(I,J) = (1.-SM(I,J))*QS(I,J)+SM(I,J)*QZ0(I,J)
         QSFC(I,J) = AMAX1(H1M12,QSFC(I,J))
         THSFC   = (1.-SM(I,J))*THS(I,J)+SM(I,J)*THZ0(I,J)
         TSFC(I,J) = THSFC*(P1000/PSFC)**(-CAPA)
C
C        COMPUTE MEAN FIELDS.
         NLEV = 1
         ALPS = D50*(ALPINT(I,J,LLMH)+ALPINT(I,J,LLMH+1))
         TSUM = T(I,J,LLMH)
         QSUM = Q(I,J,LLMH)
         TBAR(I,J)   = TSUM
         QBAR(I,J)   = QSUM
         ALPBAR(I,J) = ALPS
         IF (LLMH.EQ.LM) CYCLE doin30
         do10: DO L = LLMH-1,1,-1
            ALPM = D50*(ALPINT(I,J,L)+ALPINT(I,J,L+1))
            PM   = EXP(ALPM)
            IF (PM.LT.PTOP) EXIT do10 
            NLEV = NLEV + 1
            ALPS = ALPS + ALPM
            TSUM = TSUM + T(I,J,L)
            QSUM = QSUM + Q(I,J,L)
         END DO do10
         RNLEV     = 1./NLEV
         ALPBAR(I,J) = ALPS*RNLEV
         TBAR(I,J)   = TSUM*RNLEV
         QBAR(I,J)   = QSUM*RNLEV
         END DO doin30
         END DO doout30
C     
C     SMOOTH LAYER MEAN TEMPERATURE AND SPECIFIC HUMIDITY.
C     BOUND SPECIFIC HUMIDITY SO THAT IT IS NON-NEGATIVE.
C     
      CALL P2FILT(ISMTHT,HBM2,TBAR)
      CALL P2FILT(ISMTHT,HBM2,TSFC)
      CALL P2FILT(ISMTHQ,HBM2,QBAR)
      CALL P2FILT(ISMTHQ,HBM2,QSFC)
      CALL BOUNDL(QBAR,H1M12,H99999,IM,JM)
      CALL BOUNDL(QSFC,H1M12,H99999,IM,JM)
C     
C     LOOP OVER HORIZONTAL GRID.
C     
!$omp  parallel do
!$omp& private(alpavg,alpsfc,llmh,pavg,psfc,ptop,qavg,rhoavg,rrhog,
!$omp&         tau,tauavg,tausfc,tausl,tavg,tvrbar,tvrsfc,tvrsl,
!$omp&         tvrt,tvrtal,zbar,zl,zsfc)
       doout50: DO J=JSTA,JEND
       doin50: DO I=1,IM
         LLMH = LMH(I,J)
         ZSFC = FIS(I,J)*GI
         PSFC = PD(I,J)+PT
         ALPSFC = ALOG(PSFC)
         PTOP   = PSFC-DP
         SLP(I,J) = PSFC
CX         IF (LLMH.EQ.LM) GOTO 50
C
C        COMPUTE LAYER MEAN TAU (VIRTUAL TEMP*RD/G).
         TVRT = TBAR(I,J)*(H1+D608*QBAR(I,J))
         TAU  = TVRT*RD*GI
C
C        COMPUTE HEIGHT OF MEAN ATMOSPHERIC LAYER.
CX         QSFC   = (1.-SM(I,J))*QS(I,J)+SM(I,J)*QZ0(I,J)
CX         QSFC   = AMAX1(H1M12,QSFC)
         QAVG   = D50*(QSFC(I,J)+QBAR(I,J))
CX         THSFC  = (1.-SM(I,J))*THS(I,J)+SM(I,J)*THZ0(I,J)
CX         TSFC   = THSFC*(P1000/PSFC)**(-CAPA)
         TAVG   = D50*(TSFC(I,J)+TBAR(I,J))
         TVRBAR = TAVG*(H1+D608*QAVG)
         ZBAR   = RD*GI*TVRBAR*(ALPSFC-ALPBAR(I,J)) + ZSFC
C     
C        COMPUTE TAU AT THE GROUND (Z=ZSFC) AND SEA LEVEL (Z=0)
C        ASSUMING A CONSTANT LAPSE RATE OF GAMMA=6.5DEG/KM.
         TVRSFC = TVRT + (ZBAR-ZSFC)*GAMMA
         TAUSFC = TVRSFC*RD*GI
         TVRSL  = TVRT + (ZBAR- ZSL)*GAMMA
         TAUSL  = TVRSL*RD*GI
C     
C        IF NEED BE APPLY SHEULL CORRECTION.
         IF ((TAUSL.GT.TAUCR).AND.(TAUSFC.LE.TAUCR)) THEN
            TAUSL=TAUCR
         ELSEIF ((TAUSL.GT.TAUCR).AND.(TAUSFC.GT.TAUCR)) THEN
            TAUSL = TAUCR-CONST*(TAUSFC-TAUCR)**2
         ENDIF
C     
C        COMPUTE MEAN TAU.
         TAUAVG = D50*(TAUSL+TAUSFC)
C     
C        COMPUTE SEA LEVEL PRESSURE.
         IF (LLMH.LT.LM) SLP(I,J) = PSFC*EXP(ZSFC/TAUAVG)
C     
C        COMPUTE 1000MB HEIGHTS.
         ALPAVG   = D50*(ALOG(PSFC)+ALOG(SLP(I,J)))
         PAVG     = EXP(ALPAVG)
         RHOAVG   = PAVG*GI/TAUAVG
         RRHOG    = H1/(RHOAVG*G)
         Z1000(I,J) = (SLP(I,J)-P1000)*RRHOG
C     
C        COMPUTE TEMPERATURES ON ETA LEVELS BELOW GROUND.
         IF ((ZSFC-ZSL).EQ.0.) CYCLE doin50
CX       TLAPSE = GORD*(TAUSFC-TAUSL)/(ZSFC-ZSL)
         IF (LLMH.EQ.LM) CYCLE doin50
         do40: DO L = LLMH+1,LM
            ZL     = GI*DFL(L)
            TVRTL  = TVRT + (ZBAR-ZL)*GAMMA
            T(I,J,L) = TVRTL/(H1+D608*QBAR(I,J))
         END DO do40
C     
C     MOVE TO NEXT HORIZONTAL GRIDPOINT.
      END DO doin50
      END DO doout50
C     
C     WE NOW HAVE THE SHEULL SEA LEVEL PRESSURE FIELD
C     IN ARRAY SLP.  APPLY A FIVE POINT SMOOTHER.
C     
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        EGRID(I,J)=SLP(I,J)
      ENDDO
      ENDDO
C
      CALL EXCH(SLP) 
      do90: DO KS=1,KSLPD
         do80: DO J=JSTA_M2,JEND_M2
         IEND=IM-1-MOD(J+1,2)
         DO I=2,IEND
           IF (FIS(I,J).GT.H1000)         GO TO 70
           IF (FIS(I+IHW(J),J-1).GT.H1000)GO TO 70
           IF (FIS(I+IHE(J),J-1).GT.H1000)GO TO 70
           IF (FIS(I+IHW(J),J+1).GT.H1000)GO TO 70
           IF (FIS(I+IHE(J),J+1).GT.H1000)GO TO 70
           IF (KS.GT.1) CYCLE do80
 70        EGRID(I,J)=D125*
     1          (SLP(I+IHW(J),J-1)+SLP(I+IHE(J),J-1)
     1          +SLP(I+IHW(J),J+1)+SLP(I+IHE(J),J+1)
     2          +H4*SLP(I,J))
         ENDDO
         END DO do80
         DO J=JSTA,JEND
         DO I=1,IM
           SLP(I,J) = EGRID(I,J)
         ENDDO
         ENDDO
      END DO do90
C     
C     END OF ROUTINE.
C     

      RETURN
      END

      SUBROUTINE CETLIH4(HE,HX,IMOT,JMOT,KSB,IOFFS)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CETLIH4     INTERPOLATES
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-23
C     
C ABSTRACT:
C     THIS ROUTINE INTERPOLATES DATA IN ARRAY HE FROM HEIGHT
C     POINTS ON AN ETA GRID TO HEIGHT POINTS ON ANOTHER GRID
C     IN ARRAY HX.  THE INTERPOLATION CONSERVES THE AREA 
C     INTEGRAL OF HE.
C     
C     ***WARNING*** 
C     COMPUTATION OF THE INTERPOLATION 'WEIGHTS' CONSUMES 
C     AN ENORMOUS AMOUNT OF CPU TIME, MUCH MORE THAN 
C     THE ACTUAL TIME IT TAKES TO DO THE INTERPOLATION.
C     IT IS MUCH BETTER TO PRECOMPUTE THE REQUIRED
C     WEIGHTS.  SUBROUINE GD2EGK COMPUTES THESE 'WEIGHTS'.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  ???
C   92-12-23  RUSS TREADON - GENERALIZED CODE BY REMOVING 
C                            HARDCODED (IM,JM).
C   93-06-09  RUSS TREADON - EXPANDED COMMENTS.
C   98-06-17  T BLACK      - CONVERSION FROM 1-D TO 2-D
C     
C USAGE:    CETLIH4(HE,HX,IMOT,JMOT,KSB)
C   INPUT ARGUMENT LIST:
C     HE       - DATA ON E-GRID.
C     IMOT     - FIRST DIMENSION OF OUTPUT GRID.
C     JMOT     - SECOND DIMENSION OF OUTPUT GRID.
C     KSB      - NUMBER OF SUB BOXES
C     IOFFS    - WIDTH (IN GRID POINTS) OF SEARCH WINDOW
C                AROUND E-GRID POINT FROM WHICH INTERPOLATING.
C
C   OUTPUT ARGUMENT LIST: 
C     HX       - DATA INTERPOLATED TO THE OUTPUT GRID
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - LLGRDS
C       COMMON   - INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE ETA GRID DIMENSIONS.  COMPUTE DEPENDENT PARAMETERS.
C     
              USE INDX_MOD
      INCLUDE "parmeta"
      INCLUDE "parmout"
C
      PARAMETER (IMT=2*IM-1,JMT=JM)
C
C     DECLARE VARIABLES.
      INTEGER NZ(IMX,JMX)
      REAL HE(IM,JM),HX(IMOT,JMOT)
C     
C     INCLUDE COMMON BLOCK.
      INCLUDE "LLGRDS.comm"
c      INCLUDE "INDX.comm"
C
      REAL SBLAT(IM,JM),SBLON(IM,JM),DSQMN(IM,JM)
      INTEGER IISB(IM,JM),JJSB(IM,JM)
C     
C     
C**********************************************************************
C     START CETLIH4.
C     
C     ZERO OUTPUT ARRAY AND NORMALIZATION ARRAY.
         HX(1:IMOT,1:JMOT)=0.
         NZ(1:IMOT,1:JMOT)=0
C     
C     SET CONSTANTS.
      JMOT2 = JMOT-2
      IMOT2 = IMOT-2
      SBS=1./KSB
C     
C     LOOP OVER E-GRID.  MOVE SOUTH TO NORTH THROUGH JM2 ROWS. 
C     ON EACH ROW MOVE WEST TO EAST THROUGH THE E-GRID K INDEX.
C     AT EACH K INTERPOLATE DATA IN E-GRID ARRAY HE TO OUTPUT
C     GRID ARRAY HX.
C
!$omp  parallel do
!$omp& private(clat,clon,dsq,ie,iend,ip,is,iw,jp,js,p,pq,q)
      do185: DO J=3,JM-2
C     
      IEND=IM-1-MOD(J+1,2)
C
C        DISTRIBUTE THE E-GRID VALUES (IN ARRAY HE) TO THE SURROUNDING
C        KSB*KSB OUTPUT GRID POINTS.
C     
         doout160: DO JB=1,KSB
         doin160: DO IB=1,KSB
           do175: DO I=2,IEND
C     
C        SET TRANSFORMED (LAT,LON) OF THE K-TH E-GRID MASS POINT.
C        THIS BECOMES THE CENTER OF THE BOX OVER WHICH THE AREA
C        CONSERVING INTERPOLATION IS DONE.
C
         DSQMN(I,J)=  1.
         IISB(I,J) = -1 
         JJSB(I,J) = -1
         JP  = JEGRDK(I,J)
         IF (JP.LT.1) CYCLE  do175
         CLON=HTLON(I,J)
         CLAT=HTLAT(I,j)
C     
C        LOAD THE OUTPUT GRID (I,J) NEAREST TO K-TH E-GRID MASS POINT.
C        IF INTERPOLATION FROM THE K-TH E-GRID MASS POINT TO THE 
C        OUTPUT GRID IS NOT POSSIBLE (AT INDICATED BY ZERO OR NEGATIVE
C        OUTPUT GRID (I,J), DO NOT ATTEMPT INTERPOLATION CENTERED ON 
C        THIS E-GRID MASS POINT.
C
C     
C           FOR THE (IB,JB)-TH SUB-BOX COMPUTE THE TRANSFORMED E-GRID
C           LATITUDE AND LONGITUDE AT THE CENTER OF THIS SUB-BOX.
C
            P=(IB-(KSB+1.)/2.)*SBS
            Q=(JB-(KSB+1.)/2.)*SBS
            PQ=P*Q
            IE=I+IHE(J)
            IW=I+IHW(J)
            SBLON(I,J)=CLON+P*(HTLON(IE,J+1)-CLON)
     1                     +Q*(HTLON(IW,J+1)-CLON)
     2           +PQ*(CLON-HTLON(IE,J+1)-HTLON(IW,J+1)+HTLON(I,J+2))
            SBLAT(I,J)=CLAT+P*(HTLAT(IE,J+1)-CLAT)
     1                     +Q*(HTLAT(IW,J+1)-CLAT)
     2           +PQ*(CLAT-HTLAT(IE,J+1)-HTLAT(IW,J+1)+HTLAT(I,J+2))
           END DO do175
C
         doout150: DO JJ=0,IOFFS
         doin150: DO II=0,IOFFS
C
            do180: DO I=2,IEND
         JP  = JEGRDK(I,J)
         IF (JP.LT.1) CYCLE do180
         IP  = IEGRDK(I,J)

C        SET OUTPUT GRID (I,J) SURROUNDING THE E-GRID MASS POINT.
C 
         IS=IP-(IOFFS-1)
         JS=JP-(IOFFS-1)
C           SEARCH FOR THE OUTPUT GRID POINT NEAREST TO THE CENTER 
C           OF THE (IB,JB)-TH SUB-BOX.  ASSIGN THE (I,J) INDEX OF 
C           THIS POINT TO (IISB,JJSB)
C
             DSQ=(GDTLON((IS+II),(JS+JJ))-SBLON(I,J))**2
     *          +(GDTLAT((IS+II),(JS+JJ))-SBLAT(I,J))**2
               IF(DSQ.LT.DSQMN(I,J)) THEN
                  DSQMN(I,J)=DSQ
                  IISB(I,J)=IS+II
                  JJSB(I,J)=JS+JJ
               ENDIF
            END DO do180
            END DO doin150
            END DO doout150
C     
C           IF INTERPOLATION WAS NOT POSSIBLE TO THE CURRENT
C           OUTPUT GRID SUB-BOX, THEN SKIP THIS SUB-BOX AND 
C           TRY THE NEXT ONE.
C
            do155: DO I=2,IEND
              IF(IISB(I,J).GT.0)THEN
C     
C            ADD E-GRID AMOUNT IN ARRAY HE ON INPUT E-GRID TO THE 
C            NEAREST NEIGHBOR OUTPUT GRID SUB-BOX IDENTIFIED ABOVE.
C
             HX(IISB(I,J),JJSB(I,J))=HX(IISB(I,J),JJSB(I,J))+HE(I,J)
             NZ(IISB(I,J),JJSB(I,J))=NZ(IISB(I,J),JJSB(I,J))+1
            ENDIF
            END DO do155
C     
C        REPEAT FOR NEXT SUB-BOX.
C
         END DO doin160
         END DO doout160
C     
C     REPEAT INTERPOLATION FOR NEXT E-GRID MASS POINT.
C
      END DO do185
C     
C     NORMALIZE OUTPUT GRID AMOUNT IN ARRAY HX BY THE NUMBER OF
C     E-GRID AMOUNTS SUMMED TO OBTAIN THE OUTPUT GRID AMOUNT.
C
!$omp  parallel do
      doout200: DO JJ=1,JMOT
         doin200: DO II=1,IMOT
C     
C           AVOID DIVISION BY ZERO.  NZ=0 INDICATES NO
C           INTERPOLATION WAS POSSIBLE AND SO THE OUTPUT
C           GRID VALUE IN ARRAY HX SHOULD REMAIN THE ZERO
C           IT WAS INITIALIZED TO.
c            IF (NZ(II,JJ).EQ.0) NZ(II,JJ) = 1
C
            IF (NZ(II,JJ).NE.0) THEN
             HX (II,JJ)=HX(II,JJ) / NZ(II,JJ)
CHOU 2022
            ELSE
             HX (II,JJ)= 1.E20
CHOU
            ENDIF
         END DO doin200
      END DO doout200
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE CALRH2(P1,T1,Q1,ICE1,RH,IM,JM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALRH2      COMPUTES RELATIVE HUMIDITY
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22       
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES RELATIVE HUMIDITY GIVEN PRESSURE, 
C     TEMPERATURE, SPECIFIC HUMIDITY, CLOUD WATER, AND CLOUD 
C     ICE/WATER FLAG.  THE CODE IS BASED ON SUBROUTINE GSCOND
C     IN THE ETA MODEL.  AN UPPER AND LOWER BOUND
C     OF 100 AND 1 PERCENT RELATIVE HUMIDITY IS ENFORCED.  WHEN
C     THESE BOUNDS ARE APPLIED THE PASSED SPECIFIC HUMIDITY 
C     ARRAY IS ADJUSTED AS NECESSARY TO PRODUCE THE SET RELATIVE
C     HUMIDITY.
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  DENNIS DEAVEN
C   92-12-22  RUSS TREADON - MODIFIED AS DESCRIBED ABOVE.
C   98-06-08  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-18  MIKE BALDWIN - MODIFY TO COMPUTE RH OVER ICE AS IN MODEL
C   98-12-16  GEOFF MANIKIN - UNDO RH COMPUTATION OVER ICE
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL CALRH2(P1,T1,Q1,ICE1,RH,IM,JM)
C   INPUT ARGUMENT LIST:
C     P1     - PRESSURE (PA)
C     T1     - TEMPERATURE (K)
C     Q1     - SPECIFIC HUMIDITY (KG/KG)
C     ICE1   - CLOUD ICE (KG/KG)
C     IM,JM  - ARRAY DIMENSIONS
C
C   OUTPUT ARGUMENT LIST: 
C     RH     - RELATIVE HUMIDITY  (DECIMAL FORM)
C     Q1     - ADJUSTED SPECIFIC HUMIDITY (KG/KG)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
      INCLUDE "CTLBLK.comm"
C     
C     SET PARAMETER.
C
      PARAMETER (A2=17.2693882,A3=273.16,A4=35.86,
     &  PQ0=379.90516)
C
C     DECLARE VARIABLES.
C     
C      REAL QI,QINT,QC,P1(IM,JM),T1(IM,JM),Q1(IM,JM),RH(IM,JM)
      REAL QC,P1(IM,JM),T1(IM,JM),Q1(IM,JM),RH(IM,JM) 
C      REAL ICE1(IM,JM)
C***************************************************************
C**  THE CODE WRITTEN TO ADD IN THE ICE COMPUTATION HAS BEEN
C**     COMMENTED OUT.   SIMPLY UNCOMMENT THE SECTIONS BELOW AND
C**     COMMENT OUT THE 8 LINES USED 17 LINES BELOW THIS ONE
C**     IF YOU WISH TO ADD THE ICE COMPUTATION BACK.
C
C     START CALRH2.
C
C      DO J=JSTA,JEND
C        DO I=1,IM
C        IF (ABS(P1(I,J)).GT.1) THEN
C           TMT0=T1(I,J)-273.16
C           TMT15=AMIN1(TMT0,-15.)
C           AI=0.008855
C           BI=1.
C           IF(TMT0.LT.-20.)THEN
C             AI=0.007225
C             BI=0.9674
C           ENDIF
C           QW=PQ0/P1(I,J)
C     1          *EXP(A2*(T1(I,J)-A3)/(T1(I,J)-A4))
C           QI=QW*(BI+AI*AMIN1(TMT0,0.))
C           QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
C
      DO J=JSTA,JEND
        DO I=1,IM
        IF (ABS(P1(I,J)).GT.1) THEN
           QC=PQ0/P1(I,J)
     1          *EXP(A2*(T1(I,J)-A3)/(T1(I,J)-A4))
C
C
           if(qc.lt.1.0e-20)print*,'0 qc',i,j,pq0,P1(I,J),A2
     1,    T1(I,J),A3,A4,qc
           RH(I,J)=Q1(I,J)/QC

C   IF TEMP IS BELOW -15 C OR IF THERE IS ANY CLOUD ICE
C   AND TEMP IS BETWEEN -15 AND 0 C, THEN DO RH OVER ICE
C
C           IF(TMT0.LT.-15.)THEN
C               QC=QI
C           ELSEIF(TMT0.GE.0.)THEN
C               QC=QINT
C           ELSE
C             IF(ICE1(I,J).GT.0.0) THEN
C               QC=QI
C             ELSE
C               QC=QINT
C             ENDIF
C           ENDIF
C
C           RH(I,J)=Q1(I,J)/QC
C
C   BOUNDS CHECK
C
           IF (RH(I,J).GT.1.0) THEN
            RH(I,J)=1.0
            Q1(I,J)=RH(I,J)*QC
           ENDIF
           IF (RH(I,J).LT.0.01) THEN
            RH(I,J)=0.01
            Q1(I,J)=RH(I,J)*QC
           ENDIF
C
        ENDIF
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE CALHPBL(HPBL)
C
C     CALCULATES THE  Planetary boundary layer height consistent w/ etafcst code
C
C
C     INPUT:
C     ------
C
C     Q2   (IM,JM,LM)  - TWICE THE TURBULENT ENERGY FIELD
C     ZINT (IM,JM,LP1) - ETA INTERFACES HEIGHT FIELD
C     LMH  (IM,JM)     - TOPOGRAPHY INDEXES ARRAY
C     IM,JM            - ARRAY DIMENSIONS FOR HORIZONTAL GRIDS
C                        IN A VECTORIZED FORM
C     LM               - ARRAY DIMENSION FOR VERTICAL GRIDS
C     LP1              = LM+1
C
C
C     OUTPUT:
C     -------
C
C     HPBL(IM,JM)      - PBL Height    !Chou added
C
C
C     RELEVANT CONSTANTS:
C     -------------------
C
      INCLUDE "parmeta"
      INCLUDE "params"

C     MINIMAL VALUE OF TURBULENT ENERGY:
      PARAMETER (EPSQ2F = 0.12 * 1.01)    !in etafcst/MIXLEN.f90,EPSQ2=0.12, FH=1.01

      INCLUDE "CTLBLK.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "PVRBLS.comm"
C
      REAL HPBL(IM,JM)
C
      DO  J=1,JM
      DO  I=1,IM
     
       LMHK = LMH(I,J) 
       LPBL = LMHK
!
!teste JOrge - 28-01-21 - T4-NEW
       NEPSQ2=0
       DO 100 L=LMHK, LMHK/2, -1   !Daniela 
          IF ((Q2(I,J,L) < EPSQ2F).and.(NEPSQ2<2)) THEN
             NEPSQ2=NEPSQ2+1
             CYCLE             ! raise L either ecreasing or increasing tke with height
          END IF
          IF (Q2(I,J,L) >= EPSQ2F) THEN
             LPBL=L
             NEPSQ2=0
             CYCLE
          ELSEIF (NEPSQ2>=2) THEN
             EXIT   ! raise L either in decreasing or in increasing tke with height
             END IF
 100   END DO
       IF (ZINT(I,J,LMHK+1). lt. 2500.) LPBL = LPBL - 1  !raise pbl thickness 
!
!----------------------
! THE HEIGHT OF THE PBL
!----------------------
       HPBL(I,J) = ZINT(I,J,LPBL) - ZINT(I,J,LMHK+1)
       HPBL(I,J) = AMAX1(300., HPBL(I,J))
      END DO
      END DO

      RETURN
      END

      FUNCTION DIR(X,Y)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    DIR         CMPTE VEC DIR FROM U-V
C   PRGRMMR: TREADON         ORG: W/NMC2     DATE: 93-05-12       
C     
C ABSTRACT:  
C     GIVEN U AND V WIND COMPONENTS, THIS FUNCTION CALCULATES
C     THE VECTOR WIND DIRECTION (IN DEGREES)
C   .     
C     
C PROGRAM HISTORY LOG:
C   ??-??-??  CHRIS PETERS ??
C   93-05-12  RUSS TREADON - ADDED DOCBLOC
C     
C USAGE:   WDIR = DIR(X,Y)
C   INPUT ARGUMENT LIST:
C     X        - U WIND COMPONENT
C     Y        - V WIND COMPONENT
C
C   OUTPUT ARGUMENT LIST: 
C     DIR      - VECTOR WIND DIRECTION IN DEGREES
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY Y-MP
C$$$  
C
C***************************************************************************
C     START FUNCTION DIR HERE.
C
       IF(X.EQ.0.0)THEN
         IF(Y.GT.0.0)THEN
           DIR=90.
         ELSEIF(X.EQ.0.0)THEN
           DIR=360.
         ELSE
           DIR=270.
         ENDIF
       ELSE
         DIR=ATAN(Y/X)*180./3.14159
         IF(X.LT.0.0)THEN
           DIR=DIR+180.
         ENDIF
         IF(DIR.LT.0.0)THEN
           DIR=DIR+360.
         ENDIF
       ENDIF
       RETURN
       END

      SUBROUTINE CALPOT2(P1D,T1D,THETA,IM,JM)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALPOT2     COMPUTES POTENTIAL TEMPERATURE
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-24
C     
C ABSTRACT: 
C     GIVEN PRESSURE AND TEMPERATURE THIS ROUTINE RETURNS
C     THE POTENTIAL TEMPERATURE.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-24  RUSS TREADON
C   98-06-15  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION            
C     
C USAGE:    CALL CALPOT2(P1D,T1D,THETA,IM,JM)
C   INPUT ARGUMENT LIST:
C     P1D      - PRESSURE (PA)
C     T1D      - TEMPERATURE (K)
C     IM,JM    - DIMENSIONS OF ARRAYS.
C
C   OUTPUT ARGUMENT LIST: 
C     THETA    - POTENTIAL TEMPERATURE (K)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C       NONE      
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     SET REQUIRED CONSTANTS.
      PARAMETER (CAPA=0.28589641,P1000=1000.E2)
C
      INCLUDE "CTLBLK.comm"
C
C     DECLARE VARIABLES.
C     
      REAL FAC,P1D(IM,JM),T1D(IM,JM),THETA(IM,JM)
C     
C**********************************************************************
C     START CALPOT2 HERE.
C     
C     COMPUTE THETA
C     
      DO J=JSTA,JEND
      DO I=1,IM
        IF(ABS(P1D(I,J)).GT.1)THEN
          FAC=(P1000/P1D(I,J))**CAPA
          THETA(I,J)=FAC*T1D(I,J)
        ELSE
          THETA(I,J)=0.0
        ENDIF
      ENDDO
      ENDDO
c     do j = 180, 185
c        print *, ' me, j, p1d,t1d,theta = ',
c    *   me, j, p1d(10,j),t1d(10,j),theta (10,j)
c     end do
c       stop
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE LFMFLD(RH3310,RH6610,RH3366,PW3310)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    LFMFLD      COMPUTES LAYER MEAN LFM FIELDS
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22
C     
C ABSTRACT:
C     THIS ROUTINE COMPUTES THREE LAYER MEAN RELATIVE HUMIDITIES
C     AND A PRECIPITABLE WATER FIELD FROM ETA LEVEL DATA.  THE
C     COMPUTED FIELDS ARE INTENDED TO MIMIC SIMILAR FIELDS COM-
C     PUTED BY THE LFM.  THE ALGORITHM USED HERE IS FAIRLY PRI-
C     MATIVE.  IN EACH COLUMN ABOVE A MASS POINT ON THE ETA GRID
C     WE SET THE FOLLOWING TARGET PRESSURES:
C         SIGMA LAYER 1.00 PRESSURE:  SURFACE PRESSURE
C         SIGMA LAYER 0.66 PRESSURE:  0.50 * SURFACE PRESSURE
C         SIGMA LAYER 0.33 PRESSURE:  0.4356 * SURFACE PRESSURE
C     GIVEN THESE PRESSURES A SURFACE UP SUMMATION IS MADE OF 
C     RELATIVE HUMIDITY AND/OR PRECIPITABLE WATER BETWEEN THESE
C     TARGET PRESSURES.  EACH TERM IN THE SUMMATION IS WEIGHTED
C     BY THE THICKNESS OF THE ETA LAYER.  THE FINAL LAYER MEAN
C     IS THIS SUM NORMALIZED BY THE TOTAL DEPTH OF THE LAYER.  
C     THERE IS, OBVIOUSLY, NO NORMALIZATION FOR PRECIPITABLE WATER.
C
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   93-07-27  RUSS TREADON - MODIFIED SUMMATION LIMITS FROM
C                            0.66*PSFC TO 0.75*PSFC AND 0.33*PSFC 
C                            TO 0.50*PSFC, WHERE PSFC IS THE
C                            SURFACES PRESSURE.  THE REASON FOR
C                            THIS CHANGE WAS RECOGNITION THAT IN 
C                            THE LFM 0.33 AND 0.66 WERE MEASURED
C                            FROM THE SURFACE TO THE TROPOPAUSE,
C                            NOT THE TOP OF THE MODEL.
C   93-09-13  RUSS TREADON - RH CALCULATIONS WERE MADE INTERNAL
C                            TO THE ROUTINE.
C   96-03-04  MIKE BALDWIN - CHANGE PW CALC TO INCLUDE CLD WTR 
C   98-06-16  T BLACK      - CONVERSION FROM 1-D TO 2-D
C   98-08-17  MIKE BALDWIN - COMPUTE RH OVER ICE
C   98-12-22  MIKE BALDWIN - BACK OUT RH OVER ICE
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C     
C USAGE:    CALL LFMFLD(RH3310,RH6610,RH3366,PW3310)
C   INPUT ARGUMENT LIST:
C     NONE
C
C   OUTPUT ARGUMENT LIST: 
C     RH3310   - SIGMA LAYER 0.33-1.00 MEAN RELATIVE HUMIDITY.
C     RH6610   - SIGMA LAYER 0.66-1.00 MEAN RELATIVE HUMIDITY.
C     RH3366   - SIGMA LAYER 0.33-0.66 MEAN RELATIVE HUMIDITY.
C     PW3310   - SIGMA LAYER 0.33-1.00 PRECIPITABLE WATER.
C     
C   OUTPUT FILES:
C     NONE
C     
C   LIBRARY:
C     COMMON   - VRBLS
C                MAPOT
C                EXTRA
C                LOOPS
C                OPTIONS
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C
C     
C     INCLUDE PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
C
      PARAMETER (RHOWAT=1.E3)
C     
C     DECLARE VARIABLES.
C     
      REAL ALPM, DZ, ES, PM, PWSUM, QM, QS, TM
      REAL RH3310(IM,JM), RH6610(IM,JM), RH3366(IM,JM)
      REAL PW3310(IM,JM), IW(IM,JM,LM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "CTLBLK.comm"
C
C***********************************************************************
C     START LFMFLD HERE
C     
C
C    COMPUTE IW
C
        CLIMIT =1.0E-20
        IW=0.
C
        DO L=2,LM 
        DO J=JSTA,JEND
        DO I=1,IM
           IF(CWM(I,J,L).GT.CLIMIT) THEN
             IF(T(I,J,L).LT.258.15)THEN
               IW(I,J,L)=1.
             ELSEIF(T(I,J,L).GE.273.15)THEN
               IW(I,J,L)=0.
             ELSE
               IF(IW(I,J,L-1).EQ.1.0)IW(I,J,L)=1.
             ENDIF
           ELSE
             IW(I,J,L)=0.
           ENDIF
        ENDDO
        ENDDO
        ENDDO
C
C     LOOP OVER HORIZONTAL GRID.
C     
      doout30: DO J=JSTA,JEND
      doin30: DO I=1,IM
C     
C        ZERO VARIABLES.
         RH3310(I,J) = D00
         PW3310(I,J) = D00
         RH6610(I,J) = D00
         RH3366(I,J) = D00
         Z3310     = D00
         Z6610     = D00
         Z3366     = D00
C     
C        SET BOUNDS FOR PRESSURES AND SURFACE L.
         P10  = PD(I,J) + PT
         P66  = 0.75*P10
         P33  = 0.50*P10
         LLMH = LMH(I,J)
C     
C        ACCULMULATE RELATIVE HUMIDITIES AND PRECIPITABLE WATER.
C
         do10: DO L = LLMH,1,-1
C     
C           GET P, Z, T, AND Q AT MIDPOINT OF ETA LAYER.
            ALPM = D50*(ALPINT(I,J,L)+ALPINT(I,J,L+1))
            DZ   = ZINT(I,J,L)-ZINT(I,J,L+1)
            DP   = PINT(I,J,L+1)-PINT(I,J,L)
            PM   = EXP(ALPM)
            TM   = T(I,J,L)
            QM   = Q(I,J,L)
            QM   = AMAX1(QM,D00)
C
            TMT0=TM-273.16
            TMT15=AMIN1(TMT0,-15.)
            AI=0.008855
            BI=1.
            IF(TMT0.LT.-20.)THEN
              AI=0.007225
              BI=0.9674
            ENDIF
            QW=PQ0/PM*EXP(A2*(TM-A3)/(TM-A4))
            QI=QW*(BI+AI*AMIN1(TMT0,0.))
            QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
            IF(TMT0.LT.-15.)THEN
               QS=QI
            ELSEIF(TMT0.GE.0.)THEN
               QS=QINT
            ELSE
               IF(IW(I,J,L).GT.0.0) THEN
                 QS=QI
               ELSE
                 QS=QINT
               ENDIF
            ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
            QS=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT

C
            RH   = QM/QS
            IF (RH.GT.H1) THEN
               RH = H1
               QM = RH*QS
            ENDIF
            IF (RH.LT.D01) THEN
               RH = D01
               QM = RH*QS
            ENDIF
C
C           JUMP OUT OF THIS LOOP IF WE ARE ABOVE THE HIGHEST TARGET PRESSURE.
            IF (PM.LE.P33) EXIT do10 
C     
C           0.66-1.00 RELATIVE HUMIDITY.
            IF ((PM.LE.P10).AND.(PM.GE.P66)) THEN
               Z6610     = Z6610 + DZ
               RH6610(I,J) = RH6610(I,J) + RH*DZ
            ENDIF
C     
C           0.33-1.00 RELATIVE HUMIDITY AND PRECIPITABLE WATER.
            IF ((PM.LE.P10).AND.(PM.GE.P33)) THEN
               Z3310      = Z3310 + DZ
               RH3310(I,J)= RH3310(I,J)+RH*DZ
               PW3310(I,J)= PW3310(I,J)+(Q(I,J,L)+CWM(I,J,L))*DP*GI
            ENDIF
C     
C           0.33-0.66 RELATIVE HUMIDITY.
            IF ((PM.LE.P66).AND.(PM.GE.P33)) THEN
               Z3366     = Z3366 + DZ
               RH3366(I,J) = RH3366(I,J) + RH*DZ
            ENDIF
C
         END DO do10
C     
C        NORMALIZE TO GET MEAN RELATIVE HUMIDITIES.  AT
C        ONE TIME WE DIVIDED PRECIPITABLE WATER BY DENSITY
C        TO GET THE EQUIVALENT WATER DEPTH IN METERS.  NO MORE.
         IF (Z6610.GT.D00) THEN
            RH6610(I,J) = RH6610(I,J)/Z6610
         ELSE
            RH6610(I,J) = SPVAL
         ENDIF
C     
         IF (Z3310.GT.D00) THEN
            RH3310(I,J) = RH3310(I,J)/Z3310
         ELSE
            RH3310(I,J) = SPVAL
         ENDIF
C     
         IF (Z3366.GT.D00) THEN
            RH3366(I,J) = RH3366(I,J)/Z3366
         ELSE
            RH3366(I,J) = SPVAL
         ENDIF
C
CWAS     PW3310(I,J) = PW3310(I,J)/RHOWAT
C     
      END DO doin30
      END DO doout30
C     
C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE TRPAUS(PTROP,TTROP,ZTROP,UTROP,VTROP,SHTROP)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    TRPAUS      COMPUTE TROPOPAUSE DATA.
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-22       
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES TROPOPAUSE DATA.  AT EACH MASS
C     POINT A SURFACE UP SEARCH IS MADE FOR THE FIRST 
C     OCCURRENCE OF A THREE LAYER MEAN LAPSE RATE LESS THAN
C     OR EQUAL TO A CRITICAL LAPSE RATE.  THIS CRITCAL LAPSE
C     RATE IS 2DEG/KM.  THIS IS IN ACCORD WITH THE WMO
C     DEFINITION OF A TROPOPAUSE.  A MAXIMUM TROPOPAUSE
C     PRESSURE OF 500MB IS ENFORCED.  ONC THE TROPOPAUSE
C     IS LOCATED IN A COLUMN, PRESSURE, TEMPERATURE, U
C     AND V WINDS, AND VERTICAL WIND SHEAR ARE COMPUTED.
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-22  RUSS TREADON
C   97-03-06  GEOFF MANIKIN - CHANGED CRITERIA FOR DETERMINING
C                            THE TROPOPAUSE AND ADDED HEIGHT
C   98-06-15  T BLACK       - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO  - MPI VERSION
C     
C USAGE:    CALL TRPAUS(PTROP,TTROP,ZTROP,UTROP,VTROP,SHTROP)
C   INPUT ARGUMENT LIST:
C     NONE     
C
C   OUTPUT ARGUMENT LIST: 
C     PTROP    - TROPOPAUSE PRESSURE.
C     TTROP    - TROPOPAUSE TEMPERATURE.
C     ZTROP    - TROPOPAUSE HEIGHT
C     UTROP    - TROPOPAUSE U WIND COMPONENT.
C     VTROP    - TROPOPAUSE V WIND COMPONENT.
C     SHTROP   - VERTICAL WIND SHEAR AT TROPOPAUSE.
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       H2V     
C
C     LIBRARY:
C       COMMON   - VRBLS
C                  LOOPS
C                  EXTRA
C                  OPTIONS
C                  MASKS
C                  INDX
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C     
C     
C     INCLUDE ETA GRID DIMENSIONS.  SET/DERIVE PARAMETERS.
C
      INCLUDE "parmeta"
      INCLUDE "params"
C
C     
C     PARAMTER CRTLAP SPECIFIES THE CRITICAL LAPSE RATE
C     (IN K/M) IDENTIFYING THE TROPOPAUSE.  WE START 
C     LOOKING FOR THE TROPOPAUSE ABOVE PRESSURE LEVEL
C     PSTART (IN PASALS).
      PARAMETER (CRTLAP=0.002E0, PSTART=5.0E4)
C     
C     DECLARE VARIABLES.
C     
      REAL PTROP(IM,JM),TTROP(IM,JM),ZTROP(IM,JM),UTROP(IM,JM)
      REAL VTROP(IM,JM),SHTROP(IM,JM),EGRIDU(IM,JM),EGRIDV(IM,JM)
      REAL TLAPSE(LM),DZ2(LM),DELT2(LM),TLAPSE2(LM)
C     
C     INCLUDE COMMON BLOCKS.
      INCLUDE "VRBLS.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "OPTIONS.comm"
      INCLUDE "INDX.comm"
      INCLUDE "CTLBLK.comm"
C     
C*****************************************************************************
C     START TRPAUS HERE.
C     
C     LOOP OVER THE HORIZONTAL GRID.
C    
      DO J=JSTA,JEND
      DO I=1,IM
         PTROP(I,J)  = SPVAL
         TTROP(I,J)  = SPVAL
         ZTROP(I,J)  = SPVAL
         UTROP(I,J)  = SPVAL
         VTROP(I,J)  = SPVAL
         SHTROP(I,J) = SPVAL
         EGRIDU(I,J) = D00
         EGRIDV(I,J) = D00
      ENDDO
      ENDDO
C
!$omp  parallel do
!$omp& private(delt,delt2,dz,dz2,ie,iw,l,llmh,pm,rsqdif,
!$omp&         tlapse,tlapse2,u0,u0l,uh,uh0,ul,
!$omp&         v0,v0l,vh,vh0)
      doout20: DO J=JSTA_M,JEND_M
      doin20: DO I=2,IM-1
C     
C        COMPUTE THE TEMPERATURE LAPSE RATE (-DT/DZ) BETWEEN ETA 
C        LAYERS MOVING UP FROM THE GROUND.  THE FIRST ETA LAYER
C        ABOVE PRESSURE "PSTART" IN WHICH THE LAPSE RATE IS LESS
C        THAN THE CRITCAL LAPSE RATE IS LABELED THE TROPOPAUSE.
C
        LLMH=LMH(I,J)
C
        do10: DO L=LLMH-1,2,-1
        PM     = PINT(I,J,L)
        DELT   = T(I,J,L-1)-T(I,J,L)
        DZ     = D50*(ZINT(I,J,L-1)-ZINT(I,J,L+1))
        TLAPSE(L) = -DELT/DZ
C
        IF ((TLAPSE(L).LT.CRTLAP).AND.(PM.LT.PSTART)) THEN 
          IF (L .EQ. 2 .AND. TLAPSE(L) .LT. CRTLAP) GOTO15
          DZ2(L+1) = 0.
C
          do17: DO LL=L,3,-1
            DZ2(LL) = 0.
            DELT2(LL) = 0.
            TLAPSE2(LL) = 0.
            DZ2(LL) = (2./3.)*(ZINT(I,J,LL-2)-ZINT(I,J,L+1))
            IF ((DZ2(LL) .GT. 2000.) .AND.
     1        (DZ2(LL+1) .GT. 2000.)) GO TO 15
            DELT2(LL) = T(I,J,LL-2)-T(I,J,L)
            TLAPSE2(LL) = -DELT2(LL)/DZ2(LL)
            IF (TLAPSE2(LL) .GT. CRTLAP) CYCLE do10
          END DO do17
        ELSE
          CYCLE do10 
        ENDIF 
C
   15   PTROP(I,J)  = D50*(PINT(I,J,L)+PINT(I,J,L+1))
        TTROP(I,J)  = T(I,J,L)
        ZTROP(I,J)= HTM(I,J,L+1)*T(I,J,L+1)*
     X               (Q(I,J,L+1)*D608+H1)*ROG*
     X               (LOG(PINT(I,J,L+1))-LOG(PTROP(I,J)))
     X               +ZINT(I,J,L+1)
C
        IE=I+IHE(J)
        IW=I+IHW(J)
        UH        = D25*(U(I,J-1,L-1)+U(IW,J,L-1)+
     X                   U(IE,J,L-1) +U(I,J+1,L-1))
        U0        = D25*(U(I,J-1,L  )+U(IW,J,L  )+
     X                   U(IE,J,L  )+U(I,J+1,L  ))
        UL        = D25*(U(I,J-1,L+1)+U(IW,J,L+1)+
     X                   U(IE,J,L+1)+U(I,J+1,L+1))
        UH0       = D50*(UH+U0)
        U0L       = D50*(U0+UL)
        VH        = D25*(V(I,J-1,L-1)+V(IW,J,L-1)+
     X                   V(IE,J,L-1)+V(I,J+1,L-1))
        V0        = D25*(V(I,J-1,L  )+V(IW,J,L  )+
     X                   V(IE,J,L  )+V(I,J+1 ,L  ))
        VL        = D25*(V(I,J-1,L+1)+V(IW,J,L+1)+
     X                   V(IE,J,L+1)+V(I,J+1,L+1))
        VH0       = D50*(VH+V0)
        V0L       = D50*(V0+VL)
        EGRIDU(I,J) = U0
        EGRIDV(I,J) = V0
        DZ        = ZINT(I,J,L)-ZINT(I,J,L+1)
        RSQDIF    = SQRT((UH0-U0L)**2+(VH0-V0L)**2)
        SHTROP(I,J) = RSQDIF/DZ
        CYCLE  doin20
        END DO do10

CX         WRITE(88,*)'REACHED TOP FOR K,P,TLAPSE:  ',K,PM,TLAPSE

        DZ       = D50*(ZINT(I,J,1)-ZINT(I,J,3))
        PTROP(I,J) = D50*(PINT(I,J,2)+PINT(I,J,3))
        TTROP(I,J) = T(I,J,2)
        ZTROP(I,J)= HTM(I,J,3)*T(I,J,3)*(Q(I,J,3)*D608+H1)*ROG*
     X          (LOG(PINT(I,J,3))-LOG(PTROP(I,J)))+ZINT(I,J,3)
        UH        = D25*(U(I,J-1,2)+U(IW,J,2)+
     X                   U(IE,J,2)+U(I,J+1,2))
        VH        = D25*(V(I,J-1,2)+V(IW,J,2)+
     X                   V(IE,J,2)+V(I,J+1,2))
        UL        = D25*(U(I,J-1,3  )+U(IW,J,3  )+
     X                   U(IE,J,3  )+U(I,J+1,3  ))
        VL        = D25*(V(I,J-1,3  )+V(IW,J,3  )+
     X                   V(IE,J,3  )+V(I,J+1,3  ))
        EGRIDU(I,J) = UH
        EGRIDV(I,J) = VH
        RSQDIF      = SQRT((UH-UL)**2+(VH-VL)**2)
        SHTROP(I,J) = RSQDIF/DZ

CX        WRITE(82,1010)I,J,L,PTROP(I,J)*D01,TTROP(I,J),
CX     X       EGRIDU(I,J),EGRIDV(I,J),SHTROP(I,J)
C     
      END DO doin20
      END DO doout20

C     CALCULATE U-V AT V POINTS.
      CALL H2V(EGRIDU,EGRIDV,UTROP,VTROP)

C     
C     END OF ROUTINE.
C     
      RETURN
      END

      SUBROUTINE ETA2P(IMOUT,JMOUT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    ETA2P       VERT INTRP OF ETA TO PRESSURE
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 92-12-21       
C     
C ABSTRACT:
C     FOR MOST APPLICATIONS THIS ROUTINE IS THE WORKHORSE
C     OF THE POST PROCESSOR.  IN A NUTSHELL IT INTERPOLATES
C     DATA FROM ETA TO PRESSURE SURFACES.  IT ORIGINATED
C     FROM THE VERTICAL INTERPOLATION CODE IN THE OLD ETA
C     POST PROCESSOR SUBROUTINE OUTMAP.  
C   .     
C     
C PROGRAM HISTORY LOG:
C   92-12-21  RUSS TREADON
C   96-03-21  GEOFF MANIKIN - ADDED CLOUD ICE ON P
C   98-06-16  T BLACK       - CONVERSION FROM 1-D TO 2-D
C   98-07-17  MIKE BALDWIN  - REMOVED LABL84
C   98-08-18  T BLACK       - REMOVED MOST 3-D ARRAYS FROM
C                             COMMON BLOCK JIMA
C   98-12-22  MIKE BALDWIN  - BACK OUT RH OVER ICE
C   00-01-04  JIM TUCCILLO  - MPI VERSION
C     
C USAGE:    CALL ETA2P(IMOUT,JMOUT)
C   INPUT ARGUMENT LIST:
C     IMOUT    - FIRST DIMENSION OF OUTPUT GRID
C     JMOUT    - SECOND DIMENSION OF OUTPUT GRID
C
C   OUTPUT ARGUMENT LIST: 
C     NONE       
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       SCLFLD   - SCALE ARRAY ELEMENTS BY CONSTANT.
C       E2OUT    - E-GRID TO OUTPUT GRID INTERPOLATION/SMOOTHING.
C       OUTPUT   - POST ARRAY TO OUTPUT FILE.
C       CALPOT2  - COMPUTE POTENTIAL TEMPERATURE.
C       CALRH2   - COMPUTE RELATIVE HUMIDITY.
C       CALDWP2  - COMPUTE DEWPOINT TEMPERATURE.
C       BOUND    - BOUND ARRAY ELEMENTS BETWEEN LOWER AND UPPER LIMITS.
C       CALMCVG  - COMPUTE MOISTURE CONVERGENCE.
C       CALVOR   - COMPUTE ABSOLUTE VORTICITY.
C       CALSTRM  - COMPUTE GEOSTROPHIC STREAMFUNCTION.
C
C     LIBRARY:
C       COMMON   - OMGAOT
C                  LOOPS
C                  MASKS
C                  MAPOT
C                  VRBLS
C                  PVRBLS
C                  RQSTFLD
C                  EXTRA
C                  CLDWTR
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : IBM SP
C$$$  
C
C
C     
C     INCLUDE ETA MODEL DIMENSIONS.  SET/DERIVE OTHER PARAMETERS.
C     GAMMA AND RGAMOG ARE USED IN THE EXTRAPOLATION OF VIRTUAL
C     TEMPERATURES BEYOND THE UPPER OF LOWER LIMITS OF ETA DATA.
C     
      INCLUDE "parmeta"
      INCLUDE "parmout"
      INCLUDE "params"
C
      PARAMETER (GAMMA=6.5E-3,RGAMOG=RD*GAMMA/G)
C     
C     DECLARE VARIABLES.
C     
      LOGICAL RUN,FIRST,RESTRT,SIGMA,OLDRD,STDRD
      LOGICAL IOOMG,IOALL
      REAL OSL(IM,JM),USL(IM,JM),VSL(IM,JM)
      REAL PRSI(IM,JM),QCSL(IM,JM),Q2SL(IM,JM)
      REAL ICE(IM,JM),IW(IM,JM,LM),IWU,IWL

      REAL EGRID1(IM,JM),EGRID2(IM,JM)
      REAL GRID1(IMOUT,JMOUT),GRID2(IMOUT,JMOUT)
C
C     INCLUDE COMMON BLOCKS.
      INCLUDE "CTLBLK.comm"
      INCLUDE "OMGAOT.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "MAPOT.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "RQSTFLD.comm"
      INCLUDE "EXTRA.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "E2PFLG.comm"
C
      COMMON/JIMA/NL1X(IM,JM),ALPETUX(IM,JM),ALPET2X(IM,JM)

C     
C******************************************************************************
C
C     START ETA2P. 
C     
C     SET TOTAL NUMBER OF POINTS ON OUTPUT GRID.
C
C---------------------------------------------------------------
C
C     *** PART I ***
C
C     VERTICAL INTERPOLATION OF EVERYTHING ELSE.  EXECUTE ONLY
C     IF THERE'S SOMETHING WE WANT.
C
      IF((IGET(012).GT.0).OR.(IGET(013).GT.0).OR.
     X   (IGET(014).GT.0).OR.(IGET(015).GT.0).OR.
     X   (IGET(016).GT.0).OR.(IGET(017).GT.0).OR.
     X   (IGET(018).GT.0).OR.(IGET(019).GT.0).OR.
     X   (IGET(020).GT.0).OR.(IGET(030).GT.0).OR.
     X   (IGET(021).GT.0).OR.(IGET(022).GT.0).OR.
     X   (IGET(153).GT.0).OR.(IGET(166).GT.0))THEN
C
C  SET UP UTIM FOR THIS TIME STEP
C
          UTIM=1.
          CLIMIT =1.0E-20
C        
          IW(1:IMI,JSTA:JEND,1)=0.
          do975: DO L=2,LM
C
!$omp  parallel do
!$omp& private(cwmkl,fiq,hh,lml,pp,qi,qkl,qw,tkl,tmt0,tmt15,u00kl)
            doout970: DO J=JSTA,JEND
            doin970: DO I=1,IM
              LML=LM-LMH(I,J)
              HH=HTM(I,J,L)*HBM2(I,J)
              TKL=T(I,J,L)
              QKL=Q(I,J,L)
              CWMKL=CWM(I,J,L)
              TMT0=(TKL-273.16)*HH
              TMT15=AMIN1(TMT0,-15.)*HH    
              PP=PDSL(I,J)*AETA(L)+PT
              QW=HH*PQ0/PP*EXP(HH*A2*(TKL-A3)/(TKL-A4))
              QI=QW*(1.+0.01*AMIN1(TMT0,0.))     
              U00KL=U00(I,J)+UL(L+LML)*(0.95-U00(I,J))*UTIM
C
              IF(TMT0.LT.-15.0)THEN
                FIQ=QKL-U00KL*QI
                IF(FIQ.GT.D00.OR.CWMKL.GT.CLIMIT) THEN
                  IW(I,J,L)=1.
                ELSE
                  IW(I,J,L)=0.
                ENDIF
              ENDIF
C
              IF(TMT0.GE.0.0)IW(I,J,L)=0.
              IF(TMT0.LT.0.0.AND.TMT0.GE.-15.0)THEN
                IW(I,J,L)=0.
                IF(IW(I,J,L-1).EQ.1.0.AND.CWMKL.GT.CLIMIT)IW(I,J,L)=1.
              ENDIF
            END DO doin970
            END DO doout970
!$omp end parallel do
            END DO do975
C
C
C     VERTICAL INTERPOLATION OF GEOPOTENTIAL, SPECIFIC HUMIDITY,
C     AND TEMPERATURE.  START AT THE UPPERMOST TARGET PRESSURE LEVEL.
C
        ALPTH = ALOG(1.E5)
        do310: DO L=1,LSL
C
C
c         IF(IOALL)GO TO 225
C
          TRF=H2*ALSL(L)
C     
C       LOOP OVER HORIZONTAL GRID.
C
!$omp  parallel do
!$omp& private(lma,lmap1,ppdsl)
          doout180: DO J=JSTA,JEND
          doin180: DO I=1,IM
            LMA=LM
CX          IF(OLDRD)LMA=LMH(I,J)
            LMAP1=LMA+1
C
C           SET PRESSURE DEPTH IN THIS COLUMN.
C
            PPDSL=PDSL(I,J)
C     
C           LOCATE VERTICAL INDEX OF ETA INTERFACE PRESSURES BOUNDING
C           THE STANDARD PRESSURE LEVEL TO WHICH WE'RE INTERPOLATING.
C
           do170: DO IL=2,LMAP1
               IF((ALSL(L)-ALPINT(I,J,IL)).GT.D00)CYCLE do170
              NL1X(I,J)=IL
               CYCLE doin180
            END DO do170
            NL1X(I,J)=LMAP1
          END DO doin180
          END DO doout180
!$omp end parallel do
!$omp  parallel do
!$omp& private(ahf,ahfo,ahfq,ahfq2,ahfqc,ahfqi,ai,b,bi,bom,
!$omp&         bq,bq2,bqc,bqc_2,bqi_2,bqi,fac,gmiw,gmiw_2,iwl,iwu,
!$omp&         lma,lmap1,pl,pnl1,pu,q2a,q2b,qabv,qi,qint,ql,
!$omp&         qsat,qu,qw,rhu,tabv,tblo,tl,tmt0,tmt15,tu,
!$omp&         tvrabv,tvrblo,tvrl,tvru,zl,zu)
          doout220: DO J=JSTA,JEND
          doin220: DO I=1,IM
            LMA  =LM
            LMAP1=LMA+1
            IF((TRF-ALPINT(I,J,NL1X(I,J))
     1             -ALPINT(I,J,NL1X(I,J)-1)).LE.D00) 
     2          NL1X(I,J)=NL1X(I,J)-1
            PNL1=PINT(I,J,NL1X(I,J))
C     
C           BRANCH TO APPROPRIATE BLOCK TO COMPUTE COEFFICIENTS.
C
            IF(NL1X(I,J).EQ.1)THEN
              PU=PINT(I,J,2)
              ZU=ZINT(I,J,2)
              TU=D50*(T(I,J,1)+T(I,J,2))
              QU=D50*(Q(I,J,1)+Q(I,J,2))
C
              IWU=D50*(IW(I,J,1)+IW(I,J,2))
              TMT0=TU-273.16
              TMT15=AMIN1(TMT0,-15.)
              AI=0.008855
              BI=1.
              IF(TMT0.LT.-20.)THEN
                AI=0.007225
                BI=0.9674
              ENDIF
              QW=PQ0/PU
     1          *EXP(A2*(TU-A3)/(TU-A4))
              QI=QW*(BI+AI*AMIN1(TMT0,0.))
              QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
              IF(TMT0.LT.-15.)THEN
                  QSAT=QI
              ELSEIF(TMT0.GE.0.)THEN
                  QSAT=QINT
              ELSE
                IF(IWU.GT.0.0) THEN
                  QSAT=QI
                ELSE
                  QSAT=QINT
                ENDIF
              ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
              QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
              RHU =QU/QSAT
C
              IF(RHU.GT.H1)THEN
                RHU=H1
                QU =RHU*QSAT
              ENDIF
C
              IF(RHU.LT.D01)THEN
                RHU=D01
                QU =RHU*QSAT
              ENDIF
C
              TVRU=TU*(H1+D608*QU)
              TVRABV=TVRU*(SPL(L)/PU)**RGAMOG
              TABV=TVRABV/(H1+D608*QU)
C     
C
              TMT0=TABV-273.16
              TMT15=AMIN1(TMT0,-15.)
              AI=0.008855
              BI=1.
              IF(TMT0.LT.-20.)THEN
                AI=0.007225
                BI=0.9674
              ENDIF
              QW=PQ0/SPL(L)
     1          *EXP(A2*(TABV-A3)/(TABV-A4))
              QI=QW*(BI+AI*AMIN1(TMT0,0.))
              QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
              IF(TMT0.LT.-15.)THEN
                  QSAT=QI
              ELSEIF(TMT0.GE.0.)THEN
                  QSAT=QINT
              ELSE
                IF(IWU.GT.0.0) THEN
                  QSAT=QI
                ELSE
                  QSAT=QINT
                ENDIF
              ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
              QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
              QABV =RHU*QSAT
              QABV =AMAX1(H1M12,QABV)
              B    =TABV
              BQ   =QABV
              BOM  =OMGA(I,J,1)
              GMIW =IW(I,J,1) 
              BQC  =(1.-GMIW)*CWM(I,J,1)
              BQI  =GMIW*CWM(I,J,1)
              Q2A  =D50*(Q2(I,J,1)+Q2(I,J,2))
              BQ2  =Q2A
              AHF  =D00
              AHFQ =D00
              AHFO =D00
              AHFQC=D00
              AHFQI=D00
              AHFQ2=D00
              FAC  =D00
C
            ELSEIF(NL1X(I,J).EQ.LMAP1)THEN 
C     
C           EXTRAPOLATION AT LOWER BOUND.  THE LOWER BOUND IS
C           LM IF OLDRD=.FALSE.  IF OLDRD=.TRUE. THE LOWER 
C           BOUND IS THE FIRST ATMOSPHERIC ETA LAYER.
C
              PL=PINT(I,J,LMA-1)
              ZL=ZINT(I,J,LMA-1)
              TL=D50*(T(I,J,LMA-2)+T(I,J,LMA-1))
              QL=D50*(Q(I,J,LMA-2)+Q(I,J,LMA-1))
C     
              IWL=D50*(IW(I,J,LMA-2)+IW(I,J,LMA-1))

              TMT0=TL-273.16
              TMT15=AMIN1(TMT0,-15.)
              AI=0.008855
              BI=1.
              IF(TMT0.LT.-20.)THEN
                AI=0.007225
                BI=0.9674
              ENDIF
              QW=PQ0/PL
     1          *EXP(A2*(TL-A3)/(TL-A4))
              QI=QW*(BI+AI*AMIN1(TMT0,0.))
              QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
              IF(TMT0.LT.-15.)THEN
                  QSAT=QI
              ELSEIF(TMT0.GE.0.)THEN
                  QSAT=QINT
              ELSE
                IF(IWL.GT.0.0) THEN
                  QSAT=QI
                ELSE
                  QSAT=QINT
                ENDIF
              ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
              QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
              RHL=QL/QSAT
C
              IF(RHL.GT.H1)THEN
               RHL=H1
               QL =RHL*QSAT
              ENDIF
C
              IF(RHL.LT.D01)THEN
                RHL=D01
                QL =RHL*QSAT
              ENDIF
C
              TVRL  =TL*(H1+D608*QL)
              TVRBLO=TVRL*(SPL(L)/PL)**RGAMOG
              TBLO  =TVRBLO/(H1+D608*QL)
C     
              TMT0=TBLO-273.16
              TMT15=AMIN1(TMT0,-15.)
              AI=0.008855
              BI=1.
              IF(TMT0.LT.-20.)THEN
                AI=0.007225
                BI=0.9674
              ENDIF
              QW=PQ0/SPL(L)
     1          *EXP(A2*(TBLO-A3)/(TBLO-A4))
              QI=QW*(BI+AI*AMIN1(TMT0,0.))
              QINT=QW*(1.-0.00032*TMT15*(TMT15+15.))
              IF(TMT0.LT.-15.)THEN
                  QSAT=QI
              ELSEIF(TMT0.GE.0.)THEN
                  QSAT=QINT
              ELSE
                IF(IWL.GT.0.0) THEN
                  QSAT=QI
                ELSE
                  QSAT=QINT
                ENDIF
              ENDIF
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
C             DELETE THIS LINE TO SWITCH BACK TO RH VS ICE
              QSAT=QW
CMEB 12/22/98 SWITCH TO RH VS WATER NO MATTER WHAT
              QBLO =RHL*QSAT
              QBLO =AMAX1(H1M12,QBLO)
              B    =TBLO
              BQ   =QBLO
              BOM  =OMGA(I,J,LMA)
              GMIW =IW(I,J,LMH(I,J))
              BQC  =(1.-GMIW)*CWM(I,J,LMH(I,J))
              BQI  =GMIW*CWM(I,J,LMH(I,J)) 
              Q2A  =D50*(Q2(I,J,LMH(I,J)-1)+Q2(I,J,LMH(I,J)))
              BQ2  =Q2A
              AHF  =D00
              AHFQ =D00
              AHFO =D00
              AHFQC=D00
              AHFQI=D00
              AHFQ2=D00
              FAC  =D00
C
            ELSE
C     
C           INTERPOLATION BETWEEN LOWER AND UPPER BOUNDS.
C
              B     =T(I,J,NL1X(I,J))
              BQ    =Q(I,J,NL1X(I,J))
              BOM   =OMGA(I,J,NL1X(I,J))
              GMIW  =IW(I,J,NL1X(I,J))
              BQC   =(1.-GMIW)*CWM(I,J,NL1X(I,J))
              BQI   =GMIW*CWM(I,J,NL1X(I,J)) 
              GMIW_2=IW(I,J,NL1X(I,J)-1)
              BQC_2 =(1.-GMIW)*CWM(I,J,NL1X(I,J)-1)
              BQI_2 =GMIW*CWM(I,J,NL1X(I,J)-1)
              Q2B   =D50*(Q2(I,J,NL1X(I,J)-1)+Q2(I,J,NL1X(I,J)))
C
              IF(NL1X(I,J).GT.2)THEN
                Q2A=D50*(Q2(I,J,NL1X(I,J)-2)+Q2(I,J,NL1X(I,J)-1))
              ELSE
                Q2A=Q2B
              ENDIF
C
              BQ2=Q2B*HTM(I,J,NL1X(I,J))
              FAC  =H2*ALOG(PT+PDSL(I,J)*AETA(NL1X(I,J)))
              AHF  =(B-T(I,J,NL1X(I,J)-1))/
     1              (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
              AHFQ =(BQ-Q(I,J,NL1X(I,J)-1))/
     1              (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
              AHFO =(BOM-OMGA(I,J,NL1X(I,J)-1))/
     1              (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
              AHFQC=(BQC-BQC_2)/
     1              (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
              AHFQI=(BQI-BQI_2)/
     1              (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
              AHFQ2=(BQ2-Q2A*HTM(I,J,NL1X(I,J)-1))/
     1              (ALPINT(I,J,NL1X(I,J)+1)-ALPINT(I,J,NL1X(I,J)-1))
            ENDIF
C
            TSL(I,J)=B+AHF*(TRF-FAC)
            QSL(I,J)=BQ+AHFQ*(TRF-FAC)
            QSL(I,J)=AMAX1(QSL(I,J),H1M12)
            OSL(I,J)=BOM+AHFO*(TRF-FAC)
            QCSL(I,J)=BQC+AHFQC*(TRF-FAC)
            QCSL(I,J)=AMAX1(QCSL(I,J),H1M12)
            ICE(I,J)=BQI+AHFQI*(TRF-FAC)
            ICE(I,J)=AMAX1(ICE(I,J),H1M12)
            Q2SL(I,J)=BQ2+AHFQ2*(TRF-FAC)
            Q2SL(I,J)=AMAX1(Q2SL(I,J),D00)
            FSL(I,J)=(PNL1-SPL(L))/(SPL(L)+PNL1)
     1           *((ALSL(L)+ALPINT(I,J,NL1X(I,J))-FAC)*AHF+B)*R*H2
     2           +ZINT(I,J,NL1X(I,J))*G
          END DO doin220
          END DO doout220
!$omp end parallel do
C
C        LOAD GEOPOTENTIAL AND TEMPERATURE INTO STANDARD LEVEL 
C        ARRAYS FOR THE NEXT PASS.
C
  225    CONTINUE
C     
C        SAVE 500MB TEMPERATURE FOR LIFTED INDEX.
C     
           IF((NINT(SPL(L)).EQ.50000).AND.
     1        ((IGET(030).GT.0).OR.(IGET(031).GT.0).OR.
     2         (IGET(075).GT.0)))THEN
             T500(1:IM,JSTA:JEND)=TSL(1:IM,JSTA:JEND)
           ENDIF
C     
C        CALCULATE 1000MB GEOPOTENTIALS CONSISTENT WITH SLP OBTAINED 
C        FROM THE MESINGER OR NWS SHUELL SLP REDUCTION.
C     
          IF(NINT(SPL(L)).EQ.100000)THEN
C     
C         MESINGER SLP
C
            IF(IGET(023).GT.0)THEN
!$omp  parallel do
              DO J=JSTA,JEND
              DO I=1,IM
                ALPSL=ALOG(PSLP(I,J))
                IF(FIS(I,J).GT.H1)THEN
	if ((ALPSL-ALOG(PD(I,J)+PT))*(ALPSL-ALPTH) .eq. 0) then
	FSL(I,J)=0.
	else
                  FSL(I,J)=FIS(I,J)/(ALPSL-ALOG(PD(I,J)+PT))*
     1                              (ALPSL-ALPTH)
	endif
                ELSE
                  FSL(I,J)=R*T(I,J,LM)*(ALPSL-ALPTH)
                ENDIF
                Z1000(I,J)=FSL(I,J)*GI
              ENDDO
              ENDDO
!$omp end parallel do
C     
C           NWS SHUELL SLP.  NGMSLP2 COMPUTES 1000MB GEOPOTENTIAL.
C
            ELSE
!$omp  parallel do
              DO J=JSTA,JEND
              DO I=1,IM
                FSL(I,J)=Z1000(I,J)*G
              ENDDO
              ENDDO
!$omp end  parallel do
            ENDIF
          ENDIF
C     
C        INTERPOLATE WIND COMPONENTS FROM ETA TO PRESSURE.
C     
          IF((IGET(018).GT.0).OR.(IGET(019).GT.0).OR.
     1       (IGET(021).GT.0).OR.(IGET(085).GT.0))THEN
C
            USL(1:IMI,JSTA:JEND)=D00
            VSL(1:IMI,JSTA:JEND)=D00
C
!!$omp  parallel do
!!$omp& private(alpet2,alpetl,alpetu,lmb,petal,petau)
!!$omp& shared (alpet2x,alpetux,nl1x)
          doout281: DO J=JSTA,JEND
          doin281: DO I=1,IM
CNOTE 
CNOTE         29 JANUARY 1993, RUSS TREADON.
CNOTE          - AS FOR THE OTHER FIELDS WE INTERPOLATE ONLY
CNOTE            BETWEEN THE FAL AND THE MODEL TOP.  BELOW 
CNOTE            SURFACE VALUES ARE FAL VALUES.
C
            LMB = LMV(I,J)
C
              PETAU=PT+PDVP1(I,J)*ETA(1)
              ALPETU=ALOG(PETAU)
            do280: DO IL=2,LMB
              PETAL=PT+PDVP1(I,J)*ETA(IL)
c             PETAU=PT+PDVP1(I,J)*ETA(IL-1)
              ALPETL=ALOG(PETAL)
c             ALPETU=ALOG(PETAU)
              ALPET2=SQRT(0.5E0*(ALPETL*ALPETL+ALPETU*ALPETU))
C     
C          SEARCH FOR HIGHEST MID-LAYER ETA SURFACE (NOT SUBMERGED)
C          THAT IS BELOW THE GIVEN STANDARD PRESSURE LEVEL.
              IF(ALSL(L).LT.ALPET2)THEN
                NL1X(I,J)=IL-1
                ALPETUX(I,J)=ALPETU
                ALPET2X(I,J)=ALPET2
                CYCLE doin281
              ENDIF
C      If we arent on the last iterate of the 280 loop, reset  PETAU and ALPETU
              if ( il .eq. lmb ) CYCLE do280
              PETAU=PETAL
              ALPETU=ALPETL
            END DO do280
            NL1X(I,J)=LMB+1
            ALPETUX(I,J)=ALPETU
            ALPET2X(I,J)=ALPET2
          END DO doin281
          END DO doout281
C     
C         BELOW GROUND USE FAL WINDS.
C
!$omp  parallel do
!$omp& private(alpet1,alpetl,alpetu,fact,petau)
          doout290: DO J=JSTA,JEND
          doin290: DO I=1,IM
            IF(NL1X(I,J).GT.LMV(I,J))THEN
              USL(I,J)=U(I,J,LMV(I,J))
              VSL(I,J)=V(I,J,LMV(I,J))
C     
C          IF REQUESTED PRESSURE LEVEL IS NOT BELOW THE LOCAL GROUND
C          THEN WE HAVE TWO POSSIBILITIES.  IF THE REQUESTED PRESSURE
C          LEVEL IS BETWEEN THE LOCAL SURFACE PRESSURE AND TOP OF
C          MODEL PRESSURE, VERTICALLY INTERPOLATE BETWEEN NEAREST
C          BOUNDING ETA LEVELS TO GET THE WIND COMPONENTS.  IF THE   
C          REQUESTED PRESSURE LEVEL IS ABOVE THE MODEL TOP, USE
C          CONSTANT EXTRAPOLATION OF TOP ETA LAYER (L=1) WINDS.
C 
            ELSE
              IF(NL1X(I,J).GT.1)THEN
                ALPETL=ALPETUX(I,J)
                PETAU=PT+PDVP1(I,J)*ETA(NL1X(I,J)-1)
                ALPETU=ALOG(PETAU)
                ALPET1=SQRT(0.5*(ALPETL*ALPETL+ALPETU*ALPETU))
                FACT=(ALPET2X(I,J)-ALSL(L))/(ALPET2X(I,J)-ALPET1)
                USL(I,J)=U(I,J,NL1X(I,J))
     1                 +(U(I,J,NL1X(I,J)-1)-U(I,J,NL1X(I,J)))*FACT
                VSL(I,J)=V(I,J,NL1X(I,J))+(V(I,J,NL1X(I,J)-1)
     1                  -V(I,J,NL1X(I,J)))*FACT
              ELSE
                USL(I,J)=U(I,J,NL1X(I,J))
                VSL(I,J)=V(I,J,NL1X(I,J))
              ENDIF
C     
C            ALPET2 IS MID-LAYER ETA SURFACE JUST BELOW STANDARD PRESSURE
C            LEVEL AND ALPET1 IS DASHED ETA SURFACE JUST ABOVE.
C            NOTE THAT IF THE STANDARD PRESSURE SURFACE IS SUBMERGED, THEN
C            ALPET2 AND ALPET1 ARE THE LOWEST AND 2ND LOWEST MID-LAYER
C            ETA SURFACES ABOVE THE TOPOGRAPHY (WITH OLDRD=.TRUE., ZJ).
C
            ENDIF
          END DO doin290
          END DO doout290
!$omp end parallel do
        ENDIF
C
C
C        *** PART II ***
C
C        INTERPOLATE/OUTPUT SELECTED FIELDS.
C
C        GEOPOTENTIAL (SCALE BY GI)
         IF (IGET(012).GT.0) THEN
          IF (LVLS(L,IGET(012)).GT.0) THEN
            EGRID1(1:IM,JSTA:JEND)=FSL(1:IM,JSTA:JEND)*GI
C
            CALL E2OUT(012,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(012),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        TEMPERATURE.
         IF (IGET(013).GT.0) THEN
          IF (LVLS(L,IGET(013)).GT.0) THEN
            CALL E2OUT(013,000,TSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(013),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        POTENTIAL TEMPERATURE.
         IF (IGET(014).GT.0) THEN
          IF (LVLS(L,IGET(014)).GT.0) THEN
!$omp  parallel do
            
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(L)
            ENDDO
            ENDDO
!$omp end  parallel do
            CALL CALPOT2(EGRID2,TSL,EGRID1,IM,JM)
            CALL E2OUT(014,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(014),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        RELATIVE HUMIDITY.
         IF (IGET(017).GT.0) THEN
          IF (LVLS(L,IGET(017)).GT.0) THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(L)
            ENDDO
            ENDDO
!$omp end  parallel do
            CALL CALRH2(EGRID2,TSL,QSL,ICE,EGRID1,IM,JM)
            CALL E2OUT(017,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL SCLFLD(GRID1,H100,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1,H100,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(017),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        DEWPOINT TEMPERATURE.
         IF (IGET(015).GT.0) THEN
          IF (LVLS(L,IGET(015)).GT.0) THEN
!$omp  parallel do
            DO J=JSTA,JEND
            DO I=1,IM
              EGRID2(I,J)=SPL(L)
            ENDDO
            ENDDO
!$omp end parallel do
            CALL CALDWP2(EGRID2,QSL,EGRID1,TSL)
            CALL E2OUT(015,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(015),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        SPECIFIC HUMIDITY.
         IF (IGET(016).GT.0) THEN
          IF (LVLS(L,IGET(016)).GT.0) THEN
            CALL E2OUT(016,000,QSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(016),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        OMEGA
         IF (IGET(020).GT.0) THEN
          IF (LVLS(L,IGET(020)).GT.0) THEN
            CALL E2OUT(020,000,OSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(020),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C           MOISTURE CONVERGENCE.
            IF (IGET(085).GT.0) THEN
             IF (LVLS(L,IGET(085)).GT.0) THEN
               CALL CALMCVG(QSL,USL,VSL,-1,EGRID1)
               CALL E2OUT(085,000,EGRID1,EGRID2,
     X              GRID1,GRID2,IMOUT,JMOUT)
C           CONVERT TO DIVERGENCE FOR GRIB UNITS
               CALL SCLFLD(GRID1,-1.0,IMOUT,JMOUT)
               ID(1:25)=0
               CALL OUTPUT(IOUTYP,IGET(085),L,GRID1,IMOUT,JMOUT)
             ENDIF
            ENDIF
C     
C        U AND/OR V WIND.
         IF (IGET(018).GT.0.OR.IGET(019).GT.0) THEN
          IF (LVLS(L,IGET(018)).GT.0.OR.LVLS(L,IGET(019)).GT.0) THEN
            CALL E2OUT(018,019,USL,VSL,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            IF (IGET(018).GT.0)then
                 CALL OUTPUT(IOUTYP,IGET(018),L,GRID1,IMOUT,JMOUT)
            endif
            ID(1:25)=0
            IF (IGET(019).GT.0) 
     X           CALL OUTPUT(IOUTYP,IGET(019),L,GRID2,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        ABSOLUTE VORTICITY.
         IF (IGET(021).GT.0) THEN
          IF (LVLS(L,IGET(021)).GT.0) THEN
            CALL CALVOR(USL,VSL,EGRID1)
            CALL E2OUT(021,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(021),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        GEOSTROPHIC STREAMFUNCTION.
         IF (IGET(086).GT.0) THEN
          IF (LVLS(L,IGET(086)).GT.0) THEN
            EGRID2(1:IM,JSTA:JEND)=FSL(1:IM,JSTA:JEND)*GI
            CALL CALSTRM(EGRID2,EGRID1)
            CALL E2OUT(086,000,EGRID1,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(086),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        TURBULENT KINETIC ENERGY.
         IF (IGET(022).GT.0) THEN
          IF (LVLS(L,IGET(022)).GT.0) THEN
            CALL E2OUT(022,000,Q2SL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(022),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C     
C        TOTAL CLOUD WATER.
         IF (IGET(153).GT.0) THEN
          IF (LVLS(L,IGET(153)).GT.0) THEN
            CALL E2OUT(153,000,QCSL,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(153),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF
C
C        TOTAL CLOUD ICE 
         IF (IGET(166).GT.0) THEN
          IF (LVLS(L,IGET(166)).GT.0) THEN
            CALL E2OUT(166,000,ICE,EGRID2,GRID1,GRID2,IMOUT,JMOUT)
            CALL BOUND(GRID1,H1M12,H99999,IMOUT,JMOUT)
            ID(1:25)=0
            CALL OUTPUT(IOUTYP,IGET(166),L,GRID1,IMOUT,JMOUT)
          ENDIF
         ENDIF

C     
C     END OF MAIN VERTICAL LOOP.
C     
      END DO do310
      IOALL=.TRUE.
C
C     ENDIF FOR IF TEST SEEING IF WE WANT ANY OTHER VARIABLES
      ENDIF
C     
C     END OF ROUTINE.
C
      RETURN
      END

      SUBROUTINE CALTHTE(P1D,T1D,Q1D,THTE)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    CALTHTE      COMPUTES THETA-E
C   PRGRMMR: TREADON         ORG: W/NP2      DATE: 93-06-18
C     
C ABSTRACT:  
C     THIS ROUTINE COMPUTES THE EQUIVALENT POTENTIAL TEMPERATURE
C     GIVEN PRESSURE, TEMPERATURE, AND SPECIFIC HUMIDITY.  THE
C     EQUATIONS OF BOLTON (MWR,1980) ARE USED.
C   .     
C     
C PROGRAM HISTORY LOG:
C   93-06-18  RUSS TREADON
C   98-06-16  T BLACK - CONVERSION FROM 1-D TO 2-D
C   00-01-04  JIM TUCCILLO - MPI VERSION
C     
C USAGE:    CALL CALTHTE(P1D,T1D,Q1D,THTE)
C   INPUT ARGUMENT LIST:
C     P1D      - PRESSURE (PA)
C     T1D      - TEMPERATURE (K)
C     Q1D      - SPECIFIC HUMIDITY (KG/KG)
C
C   OUTPUT ARGUMENT LIST: 
C     THTE     - THETA-E (K)
C     
C   OUTPUT FILES:
C     NONE
C     
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       VAPOR    - FUNCTION TO CALCULATE VAPOR PRESSURE.
C     LIBRARY:
C       NONE
C     
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : CRAY C-90
C$$$  
C
C     
C     INCLUDE/SET PARAMETERS.
      INCLUDE "parmeta"
      INCLUDE "params"
      INCLUDE "CTLBLK.comm"
C
      PARAMETER (KG2G=1.E3)
      PARAMETER (D35=3.5,D4805=4.805,H2840=2840.,H55=55.)
      PARAMETER (D2845=0.2845,D00028=0.00028,D3376=3.376)
      PARAMETER (D00254=0.00254,D00081=0.00081,D81=0.81)
      PARAMETER (D28=0.28,H2675=2675.)
C
C     DECLARE VARIABLES.
C     
      REAL P1D(IM,JM),T1D(IM,JM),Q1D(IM,JM),THTE(IM,JM)
C     
C***************************************************************
C     START CALTHTE.
C     
C     ZERO THETA-E ARRAY
      DO J=JSTA,JEND
      DO I=1,IM
        THTE(I,J)=D00
      ENDDO
      ENDDO
C     
C     COMPUTE THETA-E.
C
      DO J=JSTA_M,JEND_M
      DO I=2,IM-1
        P        = P1D(I,J)
        T        = T1D(I,J)
        Q        = Q1D(I,J)
        EVP      = P*Q/(EPS+ONEPS*Q)
        RMX      = EPS*EVP/(P-EVP)
        CKAPA    = D2845*(1.-D28*RMX)
        RKAPA    = 1./CKAPA
        ARG      = EVP*D01
        ARG      = AMAX1(H1M12,ARG)
        DENOM    = D35*ALOG(T) - ALOG(EVP*D01) - D4805
        TLCL     = H2840/DENOM + H55
        PLCL     = P*(TLCL/T)**RKAPA
        FAC      = (P1000/P)**CKAPA
        ETERM    = (D3376/TLCL-D00254)*(RMX*KG2G*(H1+D81*RMX))
        THETAE   = T*FAC*EXP(ETERM)
        THTE(I,J)= THETAE
      ENDDO
      ENDDO
C     
C     END OF ROUTINE.
C
      RETURN
      END
